#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <colm/pdarun.h>
#include <colm/debug.h>
#include <colm/bytecode.h>
#include <colm/defs.h>
#include <colm/input.h>
#include <colm/tree.h>
#include <colm/program.h>
#include <colm/colm.h>

extern struct colm_sections colm_object;

#define parser_start 47
#define parser_first_final 47
#define parser_error 0
#define false 0
#define true 1

static long parser_entry_by_region[] = {
	0, 47, 263, 478, 478, 480, 482, 484, 
	484, 485, 487, 489, 489, 490, 492, 494, 
	494, 495, 507, 518, 518, 520, 521, 522, 
	522, 523, 538, 553, 553
};

static struct fsm_tables fsmTables_start =
{
	0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	parser_entry_by_region,

	0,  0,  0,  0,  0,  0,  0,  0,
	28,

	parser_start,
	parser_first_final,
	parser_error,

	0,
	0
};

static void fsm_execute( struct pda_run *pdaRun, struct input_impl *inputStream )
{
	pdaRun->start = pdaRun->p;
/*_resume:*/
	if ( pdaRun->fsm_cs == 0 )
		goto out;
	if ( pdaRun->p == pdaRun->pe )
		goto out_switch;
	--pdaRun->p;

	switch ( pdaRun->fsm_cs )
	{
tr1:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 113;
	goto out;
}
	goto st47;
tr2:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 107;
	goto out;
}
	goto st47;
tr4:
	{	pdaRun->matched_token = 84;
	goto skip_tokpref;
}
	goto st47;
tr5:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 109;
	goto out;
}
	goto st47;
tr71:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 75;
	goto out;
}
	goto st47;
tr72:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 101;
	goto out;
}
	goto st47;
tr73:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 104;
	goto out;
}
	goto st47;
tr75:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 76;
	goto out;
}
	goto st47;
tr76:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 86;
	goto out;
}
	goto st47;
tr77:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 87;
	goto out;
}
	goto st47;
tr78:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 90;
	goto out;
}
	goto st47;
tr79:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 105;
	goto out;
}
	goto st47;
tr80:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 95;
	goto out;
}
	goto st47;
tr83:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 81;
	goto out;
}
	goto st47;
tr89:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 91;
	goto out;
}
	goto st47;
tr90:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 103;
	goto out;
}
	goto st47;
tr92:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 78;
	goto out;
}
	goto st47;
tr93:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 79;
	goto out;
}
	goto st47;
tr94:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 102;
	goto out;
}
	goto st47;
tr114:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 88;
	goto out;
}
	goto st47;
tr116:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 89;
	goto out;
}
	goto st47;
tr117:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 77;
	goto out;
}
	goto st47;
tr118:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 112;
	goto out;
}
	goto st47;
tr119:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 100;
	goto out;
}
	goto st47;
tr120:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 94;
	goto out;
}
	goto st47;
tr121:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 106;
	goto out;
}
	goto st47;
tr122:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 85;
	goto out;
}
	goto st47;
tr123:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 84;
	goto out;
}
	goto st47;
tr125:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 73;
	goto out;
}
	goto st47;
tr126:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 82;
	goto out;
}
	goto st47;
tr127:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 83;
	goto out;
}
	goto st47;
tr128:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 96;
	goto out;
}
	goto st47;
tr129:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 111;
	goto out;
}
	goto st47;
tr130:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 110;
	goto out;
}
	goto st47;
tr131:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 98;
	goto out;
}
	goto st47;
tr132:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 92;
	goto out;
}
	goto st47;
tr133:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 93;
	goto out;
}
	goto st47;
tr134:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 97;
	goto out;
}
	goto st47;
tr135:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 99;
	goto out;
}
	goto st47;
tr136:
	{	switch( pdaRun->act ) {
	case 3:
	pdaRun->matched_token = 5;
	break;
	case 5:
	pdaRun->matched_token = 6;
	break;
	case 7:
	pdaRun->matched_token = 7;
	break;
	case 9:
	pdaRun->matched_token = 8;
	break;
	case 11:
	pdaRun->matched_token = 9;
	break;
	case 13:
	pdaRun->matched_token = 10;
	break;
	case 17:
	pdaRun->matched_token = 12;
	break;
	case 23:
	pdaRun->matched_token = 15;
	break;
	case 25:
	pdaRun->matched_token = 16;
	break;
	case 27:
	pdaRun->matched_token = 17;
	break;
	case 29:
	pdaRun->matched_token = 18;
	break;
	case 31:
	pdaRun->matched_token = 19;
	break;
	case 33:
	pdaRun->matched_token = 20;
	break;
	case 37:
	pdaRun->matched_token = 22;
	break;
	case 39:
	pdaRun->matched_token = 23;
	break;
	case 41:
	pdaRun->matched_token = 24;
	break;
	case 43:
	pdaRun->matched_token = 25;
	break;
	case 45:
	pdaRun->matched_token = 26;
	break;
	case 47:
	pdaRun->matched_token = 27;
	break;
	case 49:
	pdaRun->matched_token = 28;
	break;
	case 51:
	pdaRun->matched_token = 29;
	break;
	case 53:
	pdaRun->matched_token = 30;
	break;
	case 57:
	pdaRun->matched_token = 32;
	break;
	case 61:
	pdaRun->matched_token = 34;
	break;
	case 65:
	pdaRun->matched_token = 36;
	break;
	case 67:
	pdaRun->matched_token = 37;
	break;
	case 69:
	pdaRun->matched_token = 38;
	break;
	case 71:
	pdaRun->matched_token = 39;
	break;
	case 73:
	pdaRun->matched_token = 40;
	break;
	case 75:
	pdaRun->matched_token = 41;
	break;
	case 77:
	pdaRun->matched_token = 42;
	break;
	case 79:
	pdaRun->matched_token = 43;
	break;
	case 81:
	pdaRun->matched_token = 44;
	break;
	case 83:
	pdaRun->matched_token = 45;
	break;
	case 85:
	pdaRun->matched_token = 46;
	break;
	case 87:
	pdaRun->matched_token = 47;
	break;
	case 89:
	pdaRun->matched_token = 48;
	break;
	case 91:
	pdaRun->matched_token = 49;
	break;
	case 93:
	pdaRun->matched_token = 50;
	break;
	case 95:
	pdaRun->matched_token = 51;
	break;
	case 97:
	pdaRun->matched_token = 52;
	break;
	case 99:
	pdaRun->matched_token = 53;
	break;
	case 101:
	pdaRun->matched_token = 54;
	break;
	case 103:
	pdaRun->matched_token = 55;
	break;
	case 105:
	pdaRun->matched_token = 56;
	break;
	case 107:
	pdaRun->matched_token = 57;
	break;
	case 109:
	pdaRun->matched_token = 58;
	break;
	case 111:
	pdaRun->matched_token = 59;
	break;
	case 113:
	pdaRun->matched_token = 60;
	break;
	case 115:
	pdaRun->matched_token = 61;
	break;
	case 117:
	pdaRun->matched_token = 62;
	break;
	case 119:
	pdaRun->matched_token = 63;
	break;
	case 123:
	pdaRun->matched_token = 65;
	break;
	case 125:
	pdaRun->matched_token = 66;
	break;
	case 127:
	pdaRun->matched_token = 67;
	break;
	case 129:
	pdaRun->matched_token = 68;
	break;
	case 131:
	pdaRun->matched_token = 69;
	break;
	case 133:
	pdaRun->matched_token = 70;
	break;
	case 135:
	pdaRun->matched_token = 71;
	break;
	case 137:
	pdaRun->matched_token = 72;
	break;
	}
		goto skip_tokpref;
}
	goto st47;
tr137:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 74;
	goto out;
}
	goto st47;
tr138:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 74;
	goto out;
}
	goto st47;
tr139:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 72;
	goto out;
}
	goto st47;
tr167:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 18;
	goto out;
}
	goto st47;
tr178:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 4;
	goto out;
}
	goto st47;
tr216:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 31;
	goto out;
}
	goto st47;
tr233:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 33;
	goto out;
}
	goto st47;
tr255:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 35;
	goto out;
}
	goto st47;
tr273:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 64;
	goto out;
}
	goto st47;
tr287:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 13;
	goto out;
}
	goto st47;
tr304:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 11;
	goto out;
}
	goto st47;
tr330:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 14;
	goto out;
}
	goto st47;
tr357:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 21;
	goto out;
}
	goto st47;
tr394:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 80;
	goto out;
}
	goto st47;
tr395:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 108;
	goto out;
}
	goto st47;
st47:
case 47:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out47;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st48;
		case 33: goto st49;
		case 34: goto tr71;
		case 35: goto st1;
		case 36: goto tr72;
		case 37: goto tr73;
		case 38: goto st2;
		case 39: goto tr75;
		case 40: goto tr76;
		case 41: goto tr77;
		case 42: goto tr78;
		case 43: goto tr79;
		case 44: goto tr80;
		case 45: goto st50;
		case 46: goto tr82;
		case 47: goto tr83;
		case 58: goto st53;
		case 60: goto st54;
		case 61: goto st55;
		case 62: goto st56;
		case 63: goto tr89;
		case 64: goto tr90;
		case 91: goto tr92;
		case 93: goto tr93;
		case 94: goto tr94;
		case 96: goto st4;
		case 97: goto st59;
		case 98: goto st66;
		case 99: goto st72;
		case 100: goto st88;
		case 101: goto st94;
		case 102: goto st104;
		case 103: goto st109;
		case 105: goto st114;
		case 108: goto st126;
		case 109: goto st138;
		case 110: goto st154;
		case 112: goto st170;
		case 114: goto st190;
		case 115: goto st225;
		case 116: goto st241;
		case 118: goto st251;
		case 119: goto st254;
		case 121: goto st258;
		case 123: goto tr114;
		case 124: goto st262;
		case 125: goto tr116;
		case 126: goto tr117;
	}
	if ( (*pdaRun->p) < 48 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st48;
	} else if ( (*pdaRun->p) > 57 ) {
		if ( (*pdaRun->p) > 90 ) {
			if ( 95 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
				goto tr91;
		} else if ( (*pdaRun->p) >= 65 )
			goto tr91;
	} else
		goto st52;
	goto st0;
st48:
case 48:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out48;
	if ( (*pdaRun->p) == 32 )
		goto st48;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st48;
	goto tr118;
st49:
case 49:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out49;
	if ( (*pdaRun->p) == 61 )
		goto tr120;
	goto tr119;
st1:
case 1:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out1;
	if ( (*pdaRun->p) == 10 )
		goto tr1;
	goto st1;
st2:
case 2:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out2;
	if ( (*pdaRun->p) == 38 )
		goto tr2;
	goto st0;
st0:
	goto out0;
st50:
case 50:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out50;
	if ( (*pdaRun->p) == 62 )
		goto tr122;
	goto tr121;
tr82:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st51;
st51:
case 51:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out51;
	if ( (*pdaRun->p) == 46 )
		goto st3;
	goto tr123;
st3:
case 3:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out3;
	if ( (*pdaRun->p) == 46 )
		goto tr5;
	goto tr4;
st53:
case 53:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out53;
	if ( (*pdaRun->p) == 58 )
		goto tr127;
	goto tr126;
st54:
case 54:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out54;
	switch( (*pdaRun->p) ) {
		case 45: goto tr129;
		case 60: goto tr130;
		case 61: goto tr131;
	}
	goto tr128;
st55:
case 55:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out55;
	if ( (*pdaRun->p) == 61 )
		goto tr133;
	goto tr132;
st56:
case 56:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out56;
	if ( (*pdaRun->p) == 61 )
		goto tr135;
	goto tr134;
st4:
case 4:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out4;
	if ( (*pdaRun->p) == 32 )
		goto st0;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st0;
	goto st58;
st58:
case 58:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out58;
	switch( (*pdaRun->p) ) {
		case 32: goto tr137;
		case 93: goto tr137;
		case 96: goto tr138;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto tr137;
	goto st58;
st59:
case 59:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out59;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st60;
		case 108: goto st63;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
tr91:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 137;}
	goto st57;
tr144:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 57;}
	goto st57;
tr147:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 83;}
	goto st57;
tr151:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 105;}
	goto st57;
tr154:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 77;}
	goto st57;
tr158:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 99;}
	goto st57;
tr159:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 95;}
	goto st57;
tr164:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 85;}
	goto st57;
tr172:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 29;}
	goto st57;
tr175:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 117;}
	goto st57;
tr182:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 101;}
	goto st57;
tr188:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 53;}
	goto st57;
tr190:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 51;}
	goto st57;
tr191:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 7;}
	goto st57;
tr192:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 93;}
	goto st57;
tr196:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 73;}
	goto st57;
tr201:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 127;}
	goto st57;
tr202:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 43;}
	goto st57;
tr207:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 91;}
	goto st57;
tr208:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 45;}
	goto st57;
tr215:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 13;}
	goto st57;
tr218:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 103;}
	goto st57;
tr222:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 135;}
	goto st57;
tr224:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 69;}
	goto st57;
tr228:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 5;}
	goto st57;
tr229:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 129;}
	goto st57;
tr236:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 61;}
	goto st57;
tr240:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 115;}
	goto st57;
tr252:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 109;}
	goto st57;
tr254:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 111;}
	goto st57;
tr258:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 65;}
	goto st57;
tr260:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 31;}
	goto st57;
tr271:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 39;}
	goto st57;
tr272:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 87;}
	goto st57;
tr274:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 123;}
	goto st57;
tr280:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 133;}
	goto st57;
tr293:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 27;}
	goto st57;
tr296:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 25;}
	goto st57;
tr301:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 89;}
	goto st57;
tr305:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 17;}
	goto st57;
tr306:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 67;}
	goto st57;
tr309:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 11;}
	goto st57;
tr312:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 71;}
	goto st57;
tr323:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 23;}
	goto st57;
tr326:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 3;}
	goto st57;
tr335:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 81;}
	goto st57;
tr338:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 41;}
	goto st57;
tr341:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 79;}
	goto st57;
tr345:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 33;}
	goto st57;
tr348:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 75;}
	goto st57;
tr351:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 131;}
	goto st57;
tr362:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 37;}
	goto st57;
tr366:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 119;}
	goto st57;
tr370:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 97;}
	goto st57;
tr376:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 9;}
	goto st57;
tr378:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 125;}
	goto st57;
tr382:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 113;}
	goto st57;
tr385:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 107;}
	goto st57;
tr389:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 49;}
	goto st57;
tr393:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 47;}
	goto st57;
st57:
case 57:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out57;
	if ( (*pdaRun->p) == 95 )
		goto tr91;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr136;
st60:
case 60:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out60;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st61;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st61:
case 61:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out61;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st62;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st62:
case 62:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out62;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 109: goto tr144;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st63:
case 63:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out63;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st64;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st64:
case 64:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out64;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st65;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st65:
case 65:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out65;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto tr147;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st66:
case 66:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out66;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st67;
		case 114: goto st69;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st67:
case 67:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out67;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st68;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st68:
case 68:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out68;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto tr151;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st69:
case 69:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out69;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st70;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st70:
case 70:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out70;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st71;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st71:
case 71:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out71;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 107: goto tr154;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st72:
case 72:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out72;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st73;
		case 111: goto st75;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st73:
case 73:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out73;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st74;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st74:
case 74:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out74;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr158;
		case 116: goto tr159;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st75:
case 75:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out75;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 109: goto st76;
		case 110: goto st79;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st76:
case 76:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out76;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 109: goto st77;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st77:
case 77:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out77;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st78;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st78:
case 78:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out78;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr164;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st79:
case 79:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out79;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st80;
		case 116: goto st85;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st80:
case 80:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out80;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st81;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr167;
st81:
case 81:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out81;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st82;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st82:
case 82:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out82;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st83;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st83:
case 83:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out83;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st84;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st84:
case 84:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out84;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr172;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st85:
case 85:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out85;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st86;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st86:
case 86:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out86;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 120: goto st87;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st87:
case 87:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out87;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr175;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st88:
case 88:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out88;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st89;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st89:
case 89:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out89;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto st90;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st90:
case 90:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out90;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st91;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr178;
st91:
case 91:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out91;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st92;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st92:
case 92:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out92;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st93;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st93:
case 93:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out93;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr182;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st94:
case 94:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out94;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st95;
		case 110: goto st98;
		case 111: goto st99;
		case 120: goto st100;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st95:
case 95:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out95;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st96;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st96:
case 96:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out96;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr188;
		case 105: goto st97;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st97:
case 97:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out97;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto tr190;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st98:
case 98:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out98;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto tr191;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st99:
case 99:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out99;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto tr192;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st100:
case 100:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out100;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 112: goto st101;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st101:
case 101:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out101;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st102;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st102:
case 102:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out102;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st103;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st103:
case 103:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out103;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr196;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st104:
case 104:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out104;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st105;
		case 111: goto st108;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st105:
case 105:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out105;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st106;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st106:
case 106:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out106;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st107;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st107:
case 107:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out107;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr201;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st108:
case 108:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out108;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto tr202;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st109:
case 109:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out109;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st110;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st110:
case 110:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out110;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st111;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st111:
case 111:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out111;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 98: goto st112;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st112:
case 112:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out112;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st113;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st113:
case 113:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out113;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto tr207;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st114:
case 114:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out114;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto tr208;
		case 103: goto st115;
		case 110: goto st119;
		case 116: goto st124;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st115:
case 115:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out115;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto st116;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st116:
case 116:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out116;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st117;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st117:
case 117:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out117;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st118;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st118:
case 118:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out118;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr215;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st119:
case 119:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out119;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st120;
		case 116: goto tr218;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr216;
st120:
case 120:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out120;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st121;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st121:
case 121:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out121;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st122;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st122:
case 122:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out122;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto st123;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st123:
case 123:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out123;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr222;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st124:
case 124:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out124;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st125;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st125:
case 125:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out125;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto tr224;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st126:
case 126:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out126;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st127;
		case 105: goto st129;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st127:
case 127:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out127;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto st128;
		case 120: goto tr228;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st128:
case 128:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out128;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr229;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st129:
case 129:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out129;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st130;
		case 116: goto st134;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st130:
case 130:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out130;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st131;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st131:
case 131:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out131;
	if ( (*pdaRun->p) == 95 )
		goto st132;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr233;
st132:
case 132:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out132;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st133;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st133:
case 133:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out133;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto tr236;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st134:
case 134:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out134;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st135;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st135:
case 135:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out135;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st136;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st136:
case 136:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out136;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st137;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st137:
case 137:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out137;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto tr240;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st138:
case 138:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out138;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st139;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st139:
case 139:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out139;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 107: goto st140;
		case 112: goto st149;
		case 116: goto st152;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st140:
case 140:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out140;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st141;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st141:
case 141:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out141;
	if ( (*pdaRun->p) == 95 )
		goto st142;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st142:
case 142:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out142;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st143;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st143:
case 143:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out143;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st144;
		case 114: goto st147;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st144:
case 144:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out144;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 107: goto st145;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st145:
case 145:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out145;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st146;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st146:
case 146:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out146;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto tr252;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st147:
case 147:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out147;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st148;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st148:
case 148:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out148;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr254;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st149:
case 149:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out149;
	if ( (*pdaRun->p) == 95 )
		goto st150;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr255;
st150:
case 150:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out150;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st151;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st151:
case 151:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out151;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto tr258;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st152:
case 152:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out152;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st153;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st153:
case 153:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out153;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 104: goto tr260;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st154:
case 154:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out154;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st155;
		case 101: goto st162;
		case 105: goto st163;
		case 111: goto st164;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st155:
case 155:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out155;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 109: goto st156;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st156:
case 156:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out156;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st157;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st157:
case 157:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out157;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st158;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st158:
case 158:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out158;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 112: goto st159;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st159:
case 159:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out159;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st160;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st160:
case 160:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out160;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st161;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st161:
case 161:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out161;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr271;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st162:
case 162:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out162;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 119: goto tr272;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st163:
case 163:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out163;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto tr274;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr273;
st164:
case 164:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out164;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto st165;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st165:
case 165:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out165;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st166;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st166:
case 166:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out166;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st167;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st167:
case 167:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out167;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st168;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st168:
case 168:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out168;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st169;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st169:
case 169:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out169;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto tr280;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st170:
case 170:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out170;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st171;
		case 114: goto st182;
		case 116: goto st189;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st171:
case 171:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out171;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st172;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st172:
case 172:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out172;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st173;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st173:
case 173:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out173;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st174;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st174:
case 174:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out174;
	switch( (*pdaRun->p) ) {
		case 95: goto st175;
		case 114: goto tr144;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr287;
st175:
case 175:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out175;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st176;
		case 116: goto st179;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st176:
case 176:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out176;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st177;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st177:
case 177:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out177;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st178;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st178:
case 178:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out178;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 112: goto tr293;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st179:
case 179:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out179;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st180;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st180:
case 180:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out180;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st181;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st181:
case 181:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out181;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr296;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st182:
case 182:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out182;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st183;
		case 105: goto st186;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st183:
case 183:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out183;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st184;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st184:
case 184:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out184;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st185;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st185:
case 185:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out185;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto tr301;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st186:
case 186:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out186;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto st187;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st187:
case 187:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out187;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st188;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st188:
case 188:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out188;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto tr305;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr304;
st189:
case 189:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out189;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto tr306;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st190:
case 190:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out190;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st191;
		case 105: goto st222;
		case 108: goto tr309;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st191:
case 191:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out191;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 97: goto st192;
		case 100: goto st200;
		case 102: goto tr312;
		case 106: goto st212;
		case 113: goto st215;
		case 116: goto st219;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st192:
case 192:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out192;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto st193;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st193:
case 193:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out193;
	if ( (*pdaRun->p) == 95 )
		goto st194;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st194:
case 194:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out194;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st195;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st195:
case 195:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out195;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st196;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st196:
case 196:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out196;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto st197;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st197:
case 197:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out197;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st198;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st198:
case 198:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out198;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st199;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st199:
case 199:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out199;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr323;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st200:
case 200:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out200;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st201;
		case 117: goto st202;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st201:
case 201:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out201;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto tr326;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st202:
case 202:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out202;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st203;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st203:
case 203:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out203;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st204;
		case 116: goto st209;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st204:
case 204:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out204;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 102: goto st205;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr330;
st205:
case 205:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out205;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st206;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st206:
case 206:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out206;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st207;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st207:
case 207:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out207;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 115: goto st208;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st208:
case 208:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out208;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr335;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st209:
case 209:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out209;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st210;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st210:
case 210:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out210;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st211;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st211:
case 211:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out211;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto tr338;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st212:
case 212:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out212;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st213;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st213:
case 213:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out213;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st214;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st214:
case 214:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out214;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr341;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st215:
case 215:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out215;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st216;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st216:
case 216:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out216;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st217;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st217:
case 217:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out217;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st218;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st218:
case 218:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out218;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr345;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st219:
case 219:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out219;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st220;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st220:
case 220:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out220;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st221;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st221:
case 221:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out221;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto tr348;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st222:
case 222:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out222;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 103: goto st223;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st223:
case 223:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out223;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 104: goto st224;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st224:
case 224:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out224;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr351;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st225:
case 225:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out225;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st226;
		case 116: goto st233;
		case 119: goto st237;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st226:
case 226:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out226;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto st227;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st227:
case 227:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out227;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto st228;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st228:
case 228:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out228;
	if ( (*pdaRun->p) == 95 )
		goto st229;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr357;
st229:
case 229:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out229;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st230;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st230:
case 230:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out230;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st231;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st231:
case 231:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out231;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st232;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st232:
case 232:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out232;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr362;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st233:
case 233:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out233;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 114: goto st234;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st234:
case 234:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out234;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st235;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st235:
case 235:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out235;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st236;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st236:
case 236:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out236;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto tr366;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st237:
case 237:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out237;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st238;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st238:
case 238:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out238;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 116: goto st239;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st239:
case 239:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out239;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 99: goto st240;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st240:
case 240:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out240;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 104: goto tr370;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st241:
case 241:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out241;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st242;
		case 114: goto st245;
		case 121: goto st247;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st242:
case 242:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out242;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 107: goto st243;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st243:
case 243:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out243;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st244;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st244:
case 244:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out244;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 110: goto tr376;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st245:
case 245:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out245;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 117: goto st246;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st246:
case 246:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out246;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr378;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st247:
case 247:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out247;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 112: goto st248;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st248:
case 248:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out248;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st249;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st249:
case 249:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out249;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st250;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st250:
case 250:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out250;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto tr382;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st251:
case 251:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out251;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 111: goto st252;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st252:
case 252:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out252;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st253;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st253:
case 253:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out253;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto tr385;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st254:
case 254:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out254;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 104: goto st255;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st255:
case 255:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out255;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st256;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st256:
case 256:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out256;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st257;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st257:
case 257:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out257;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto tr389;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st258:
case 258:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out258;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 105: goto st259;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st259:
case 259:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out259;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 101: goto st260;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st260:
case 260:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out260;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 108: goto st261;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st261:
case 261:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out261;
	switch( (*pdaRun->p) ) {
		case 95: goto tr91;
		case 100: goto tr393;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr91;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr91;
	} else
		goto tr91;
	goto tr139;
st262:
case 262:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out262;
	if ( (*pdaRun->p) == 124 )
		goto tr395;
	goto tr394;
st52:
case 52:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out52;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st52;
	goto tr125;
tr7:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 107;
	goto out;
}
	goto st263;
tr8:
	{	pdaRun->matched_token = 84;
	goto skip_tokpref;
}
	goto st263;
tr9:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 109;
	goto out;
}
	goto st263;
tr397:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 75;
	goto out;
}
	goto st263;
tr398:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 101;
	goto out;
}
	goto st263;
tr399:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 104;
	goto out;
}
	goto st263;
tr401:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 76;
	goto out;
}
	goto st263;
tr402:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 86;
	goto out;
}
	goto st263;
tr403:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 87;
	goto out;
}
	goto st263;
tr404:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 90;
	goto out;
}
	goto st263;
tr405:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 105;
	goto out;
}
	goto st263;
tr406:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 95;
	goto out;
}
	goto st263;
tr409:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 81;
	goto out;
}
	goto st263;
tr415:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 91;
	goto out;
}
	goto st263;
tr416:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 103;
	goto out;
}
	goto st263;
tr418:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 78;
	goto out;
}
	goto st263;
tr419:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 79;
	goto out;
}
	goto st263;
tr420:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 102;
	goto out;
}
	goto st263;
tr440:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 88;
	goto out;
}
	goto st263;
tr442:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 89;
	goto out;
}
	goto st263;
tr443:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 77;
	goto out;
}
	goto st263;
tr444:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 100;
	goto out;
}
	goto st263;
tr445:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 94;
	goto out;
}
	goto st263;
tr446:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 106;
	goto out;
}
	goto st263;
tr447:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 85;
	goto out;
}
	goto st263;
tr448:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 84;
	goto out;
}
	goto st263;
tr450:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 73;
	goto out;
}
	goto st263;
tr451:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 82;
	goto out;
}
	goto st263;
tr452:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 83;
	goto out;
}
	goto st263;
tr453:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 96;
	goto out;
}
	goto st263;
tr454:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 111;
	goto out;
}
	goto st263;
tr455:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 110;
	goto out;
}
	goto st263;
tr456:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 98;
	goto out;
}
	goto st263;
tr457:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 92;
	goto out;
}
	goto st263;
tr458:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 93;
	goto out;
}
	goto st263;
tr459:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 97;
	goto out;
}
	goto st263;
tr460:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 99;
	goto out;
}
	goto st263;
tr461:
	{	switch( pdaRun->act ) {
	case 4:
	pdaRun->matched_token = 5;
	break;
	case 6:
	pdaRun->matched_token = 6;
	break;
	case 8:
	pdaRun->matched_token = 7;
	break;
	case 10:
	pdaRun->matched_token = 8;
	break;
	case 12:
	pdaRun->matched_token = 9;
	break;
	case 14:
	pdaRun->matched_token = 10;
	break;
	case 18:
	pdaRun->matched_token = 12;
	break;
	case 24:
	pdaRun->matched_token = 15;
	break;
	case 26:
	pdaRun->matched_token = 16;
	break;
	case 28:
	pdaRun->matched_token = 17;
	break;
	case 30:
	pdaRun->matched_token = 18;
	break;
	case 32:
	pdaRun->matched_token = 19;
	break;
	case 34:
	pdaRun->matched_token = 20;
	break;
	case 38:
	pdaRun->matched_token = 22;
	break;
	case 40:
	pdaRun->matched_token = 23;
	break;
	case 42:
	pdaRun->matched_token = 24;
	break;
	case 44:
	pdaRun->matched_token = 25;
	break;
	case 46:
	pdaRun->matched_token = 26;
	break;
	case 48:
	pdaRun->matched_token = 27;
	break;
	case 50:
	pdaRun->matched_token = 28;
	break;
	case 52:
	pdaRun->matched_token = 29;
	break;
	case 54:
	pdaRun->matched_token = 30;
	break;
	case 58:
	pdaRun->matched_token = 32;
	break;
	case 62:
	pdaRun->matched_token = 34;
	break;
	case 66:
	pdaRun->matched_token = 36;
	break;
	case 68:
	pdaRun->matched_token = 37;
	break;
	case 70:
	pdaRun->matched_token = 38;
	break;
	case 72:
	pdaRun->matched_token = 39;
	break;
	case 74:
	pdaRun->matched_token = 40;
	break;
	case 76:
	pdaRun->matched_token = 41;
	break;
	case 78:
	pdaRun->matched_token = 42;
	break;
	case 80:
	pdaRun->matched_token = 43;
	break;
	case 82:
	pdaRun->matched_token = 44;
	break;
	case 84:
	pdaRun->matched_token = 45;
	break;
	case 86:
	pdaRun->matched_token = 46;
	break;
	case 88:
	pdaRun->matched_token = 47;
	break;
	case 90:
	pdaRun->matched_token = 48;
	break;
	case 92:
	pdaRun->matched_token = 49;
	break;
	case 94:
	pdaRun->matched_token = 50;
	break;
	case 96:
	pdaRun->matched_token = 51;
	break;
	case 98:
	pdaRun->matched_token = 52;
	break;
	case 100:
	pdaRun->matched_token = 53;
	break;
	case 102:
	pdaRun->matched_token = 54;
	break;
	case 104:
	pdaRun->matched_token = 55;
	break;
	case 106:
	pdaRun->matched_token = 56;
	break;
	case 108:
	pdaRun->matched_token = 57;
	break;
	case 110:
	pdaRun->matched_token = 58;
	break;
	case 112:
	pdaRun->matched_token = 59;
	break;
	case 114:
	pdaRun->matched_token = 60;
	break;
	case 116:
	pdaRun->matched_token = 61;
	break;
	case 118:
	pdaRun->matched_token = 62;
	break;
	case 120:
	pdaRun->matched_token = 63;
	break;
	case 124:
	pdaRun->matched_token = 65;
	break;
	case 126:
	pdaRun->matched_token = 66;
	break;
	case 128:
	pdaRun->matched_token = 67;
	break;
	case 130:
	pdaRun->matched_token = 68;
	break;
	case 132:
	pdaRun->matched_token = 69;
	break;
	case 134:
	pdaRun->matched_token = 70;
	break;
	case 136:
	pdaRun->matched_token = 71;
	break;
	case 138:
	pdaRun->matched_token = 72;
	break;
	}
		goto skip_tokpref;
}
	goto st263;
tr462:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 74;
	goto out;
}
	goto st263;
tr463:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 74;
	goto out;
}
	goto st263;
tr464:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 72;
	goto out;
}
	goto st263;
tr492:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 18;
	goto out;
}
	goto st263;
tr503:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 4;
	goto out;
}
	goto st263;
tr541:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 31;
	goto out;
}
	goto st263;
tr558:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 33;
	goto out;
}
	goto st263;
tr580:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 35;
	goto out;
}
	goto st263;
tr598:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 64;
	goto out;
}
	goto st263;
tr612:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 13;
	goto out;
}
	goto st263;
tr629:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 11;
	goto out;
}
	goto st263;
tr655:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 14;
	goto out;
}
	goto st263;
tr682:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 21;
	goto out;
}
	goto st263;
tr719:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 80;
	goto out;
}
	goto st263;
tr720:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 108;
	goto out;
}
	goto st263;
st263:
case 263:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out263;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 33: goto st264;
		case 34: goto tr397;
		case 36: goto tr398;
		case 37: goto tr399;
		case 38: goto st5;
		case 39: goto tr401;
		case 40: goto tr402;
		case 41: goto tr403;
		case 42: goto tr404;
		case 43: goto tr405;
		case 44: goto tr406;
		case 45: goto st265;
		case 46: goto tr408;
		case 47: goto tr409;
		case 58: goto st268;
		case 60: goto st269;
		case 61: goto st270;
		case 62: goto st271;
		case 63: goto tr415;
		case 64: goto tr416;
		case 91: goto tr418;
		case 93: goto tr419;
		case 94: goto tr420;
		case 96: goto st7;
		case 97: goto st274;
		case 98: goto st281;
		case 99: goto st287;
		case 100: goto st303;
		case 101: goto st309;
		case 102: goto st319;
		case 103: goto st324;
		case 105: goto st329;
		case 108: goto st341;
		case 109: goto st353;
		case 110: goto st369;
		case 112: goto st385;
		case 114: goto st405;
		case 115: goto st440;
		case 116: goto st456;
		case 118: goto st466;
		case 119: goto st469;
		case 121: goto st473;
		case 123: goto tr440;
		case 124: goto st477;
		case 125: goto tr442;
		case 126: goto tr443;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st267;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 95 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto st0;
st264:
case 264:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out264;
	if ( (*pdaRun->p) == 61 )
		goto tr445;
	goto tr444;
st5:
case 5:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out5;
	if ( (*pdaRun->p) == 38 )
		goto tr7;
	goto st0;
st265:
case 265:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out265;
	if ( (*pdaRun->p) == 62 )
		goto tr447;
	goto tr446;
tr408:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st266;
st266:
case 266:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out266;
	if ( (*pdaRun->p) == 46 )
		goto st6;
	goto tr448;
st6:
case 6:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out6;
	if ( (*pdaRun->p) == 46 )
		goto tr9;
	goto tr8;
st268:
case 268:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out268;
	if ( (*pdaRun->p) == 58 )
		goto tr452;
	goto tr451;
st269:
case 269:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out269;
	switch( (*pdaRun->p) ) {
		case 45: goto tr454;
		case 60: goto tr455;
		case 61: goto tr456;
	}
	goto tr453;
st270:
case 270:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out270;
	if ( (*pdaRun->p) == 61 )
		goto tr458;
	goto tr457;
st271:
case 271:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out271;
	if ( (*pdaRun->p) == 61 )
		goto tr460;
	goto tr459;
st7:
case 7:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out7;
	if ( (*pdaRun->p) == 32 )
		goto st0;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st0;
	goto st273;
st273:
case 273:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out273;
	switch( (*pdaRun->p) ) {
		case 32: goto tr462;
		case 93: goto tr462;
		case 96: goto tr463;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto tr462;
	goto st273;
st274:
case 274:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out274;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st275;
		case 108: goto st278;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
tr417:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 138;}
	goto st272;
tr469:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 58;}
	goto st272;
tr472:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 84;}
	goto st272;
tr476:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 106;}
	goto st272;
tr479:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 78;}
	goto st272;
tr483:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 100;}
	goto st272;
tr484:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 96;}
	goto st272;
tr489:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 86;}
	goto st272;
tr497:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 30;}
	goto st272;
tr500:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 118;}
	goto st272;
tr507:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 102;}
	goto st272;
tr513:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 54;}
	goto st272;
tr515:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 52;}
	goto st272;
tr516:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 8;}
	goto st272;
tr517:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 94;}
	goto st272;
tr521:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 74;}
	goto st272;
tr526:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 128;}
	goto st272;
tr527:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 44;}
	goto st272;
tr532:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 92;}
	goto st272;
tr533:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 46;}
	goto st272;
tr540:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 14;}
	goto st272;
tr543:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 104;}
	goto st272;
tr547:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 136;}
	goto st272;
tr549:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 70;}
	goto st272;
tr553:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 6;}
	goto st272;
tr554:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 130;}
	goto st272;
tr561:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 62;}
	goto st272;
tr565:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 116;}
	goto st272;
tr577:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 110;}
	goto st272;
tr579:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 112;}
	goto st272;
tr583:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 66;}
	goto st272;
tr585:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 32;}
	goto st272;
tr596:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 40;}
	goto st272;
tr597:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 88;}
	goto st272;
tr599:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 124;}
	goto st272;
tr605:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 134;}
	goto st272;
tr618:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 28;}
	goto st272;
tr621:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 26;}
	goto st272;
tr626:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 90;}
	goto st272;
tr630:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 18;}
	goto st272;
tr631:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 68;}
	goto st272;
tr634:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 12;}
	goto st272;
tr637:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 72;}
	goto st272;
tr648:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 24;}
	goto st272;
tr651:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 4;}
	goto st272;
tr660:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 82;}
	goto st272;
tr663:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 42;}
	goto st272;
tr666:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 80;}
	goto st272;
tr670:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 34;}
	goto st272;
tr673:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 76;}
	goto st272;
tr676:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 132;}
	goto st272;
tr687:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 38;}
	goto st272;
tr691:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 120;}
	goto st272;
tr695:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 98;}
	goto st272;
tr701:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 10;}
	goto st272;
tr703:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 126;}
	goto st272;
tr707:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 114;}
	goto st272;
tr710:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 108;}
	goto st272;
tr714:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 50;}
	goto st272;
tr718:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 48;}
	goto st272;
st272:
case 272:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out272;
	if ( (*pdaRun->p) == 95 )
		goto tr417;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr461;
st275:
case 275:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out275;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st276;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st276:
case 276:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out276;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st277;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st277:
case 277:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out277;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 109: goto tr469;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st278:
case 278:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out278;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st279;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st279:
case 279:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out279;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st280;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st280:
case 280:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out280;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto tr472;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st281:
case 281:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out281;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st282;
		case 114: goto st284;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st282:
case 282:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out282;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st283;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st283:
case 283:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out283;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto tr476;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st284:
case 284:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out284;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st285;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st285:
case 285:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out285;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st286;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st286:
case 286:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out286;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 107: goto tr479;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st287:
case 287:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out287;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st288;
		case 111: goto st290;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st288:
case 288:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out288;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st289;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st289:
case 289:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out289;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr483;
		case 116: goto tr484;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st290:
case 290:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out290;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 109: goto st291;
		case 110: goto st294;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st291:
case 291:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out291;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 109: goto st292;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st292:
case 292:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out292;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st293;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st293:
case 293:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out293;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr489;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st294:
case 294:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out294;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st295;
		case 116: goto st300;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st295:
case 295:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out295;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st296;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr492;
st296:
case 296:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out296;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st297;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st297:
case 297:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out297;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st298;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st298:
case 298:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out298;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st299;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st299:
case 299:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out299;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr497;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st300:
case 300:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out300;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st301;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st301:
case 301:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out301;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 120: goto st302;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st302:
case 302:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out302;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr500;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st303:
case 303:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out303;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st304;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st304:
case 304:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out304;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto st305;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st305:
case 305:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out305;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st306;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr503;
st306:
case 306:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out306;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st307;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st307:
case 307:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out307;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st308;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st308:
case 308:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out308;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr507;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st309:
case 309:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out309;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st310;
		case 110: goto st313;
		case 111: goto st314;
		case 120: goto st315;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st310:
case 310:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out310;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st311;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st311:
case 311:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out311;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr513;
		case 105: goto st312;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st312:
case 312:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out312;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto tr515;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st313:
case 313:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out313;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto tr516;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st314:
case 314:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out314;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto tr517;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st315:
case 315:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out315;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 112: goto st316;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st316:
case 316:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out316;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st317;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st317:
case 317:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out317;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st318;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st318:
case 318:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out318;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr521;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st319:
case 319:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out319;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st320;
		case 111: goto st323;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st320:
case 320:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out320;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st321;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st321:
case 321:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out321;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st322;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st322:
case 322:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out322;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr526;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st323:
case 323:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out323;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto tr527;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st324:
case 324:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out324;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st325;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st325:
case 325:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out325;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st326;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st326:
case 326:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out326;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 98: goto st327;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st327:
case 327:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out327;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st328;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st328:
case 328:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out328;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto tr532;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st329:
case 329:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out329;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto tr533;
		case 103: goto st330;
		case 110: goto st334;
		case 116: goto st339;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st330:
case 330:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out330;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto st331;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st331:
case 331:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out331;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st332;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st332:
case 332:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out332;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st333;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st333:
case 333:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out333;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr540;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st334:
case 334:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out334;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st335;
		case 116: goto tr543;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr541;
st335:
case 335:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out335;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st336;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st336:
case 336:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out336;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st337;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st337:
case 337:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out337;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto st338;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st338:
case 338:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out338;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr547;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st339:
case 339:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out339;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st340;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st340:
case 340:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out340;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto tr549;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st341:
case 341:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out341;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st342;
		case 105: goto st344;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st342:
case 342:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out342;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto st343;
		case 120: goto tr553;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st343:
case 343:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out343;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr554;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st344:
case 344:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out344;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st345;
		case 116: goto st349;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st345:
case 345:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out345;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st346;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st346:
case 346:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out346;
	if ( (*pdaRun->p) == 95 )
		goto st347;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr558;
st347:
case 347:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out347;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st348;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st348:
case 348:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out348;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto tr561;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st349:
case 349:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out349;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st350;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st350:
case 350:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out350;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st351;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st351:
case 351:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out351;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st352;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st352:
case 352:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out352;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto tr565;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st353:
case 353:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out353;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st354;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st354:
case 354:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out354;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 107: goto st355;
		case 112: goto st364;
		case 116: goto st367;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st355:
case 355:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out355;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st356;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st356:
case 356:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out356;
	if ( (*pdaRun->p) == 95 )
		goto st357;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st357:
case 357:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out357;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st358;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st358:
case 358:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out358;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st359;
		case 114: goto st362;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st359:
case 359:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out359;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 107: goto st360;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st360:
case 360:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out360;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st361;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st361:
case 361:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out361;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto tr577;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st362:
case 362:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out362;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st363;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st363:
case 363:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out363;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr579;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st364:
case 364:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out364;
	if ( (*pdaRun->p) == 95 )
		goto st365;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr580;
st365:
case 365:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out365;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st366;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st366:
case 366:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out366;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto tr583;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st367:
case 367:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out367;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st368;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st368:
case 368:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out368;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 104: goto tr585;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st369:
case 369:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out369;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st370;
		case 101: goto st377;
		case 105: goto st378;
		case 111: goto st379;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st370:
case 370:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out370;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 109: goto st371;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st371:
case 371:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out371;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st372;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st372:
case 372:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out372;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st373;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st373:
case 373:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out373;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 112: goto st374;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st374:
case 374:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out374;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st375;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st375:
case 375:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out375;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st376;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st376:
case 376:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out376;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr596;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st377:
case 377:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out377;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 119: goto tr597;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st378:
case 378:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out378;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto tr599;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr598;
st379:
case 379:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out379;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto st380;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st380:
case 380:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out380;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st381;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st381:
case 381:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out381;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st382;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st382:
case 382:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out382;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st383;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st383:
case 383:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out383;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st384;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st384:
case 384:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out384;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto tr605;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st385:
case 385:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out385;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st386;
		case 114: goto st397;
		case 116: goto st404;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st386:
case 386:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out386;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st387;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st387:
case 387:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out387;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st388;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st388:
case 388:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out388;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st389;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st389:
case 389:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out389;
	switch( (*pdaRun->p) ) {
		case 95: goto st390;
		case 114: goto tr469;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr612;
st390:
case 390:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out390;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st391;
		case 116: goto st394;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st391:
case 391:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out391;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st392;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st392:
case 392:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out392;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st393;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st393:
case 393:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out393;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 112: goto tr618;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st394:
case 394:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out394;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st395;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st395:
case 395:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out395;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st396;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st396:
case 396:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out396;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr621;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st397:
case 397:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out397;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st398;
		case 105: goto st401;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st398:
case 398:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out398;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st399;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st399:
case 399:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out399;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st400;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st400:
case 400:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out400;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto tr626;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st401:
case 401:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out401;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto st402;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st402:
case 402:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out402;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st403;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st403:
case 403:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out403;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto tr630;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr629;
st404:
case 404:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out404;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto tr631;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st405:
case 405:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out405;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st406;
		case 105: goto st437;
		case 108: goto tr634;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st406:
case 406:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out406;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 97: goto st407;
		case 100: goto st415;
		case 102: goto tr637;
		case 106: goto st427;
		case 113: goto st430;
		case 116: goto st434;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 98 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st407:
case 407:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out407;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto st408;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st408:
case 408:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out408;
	if ( (*pdaRun->p) == 95 )
		goto st409;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st409:
case 409:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out409;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st410;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st410:
case 410:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out410;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st411;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st411:
case 411:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out411;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto st412;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st412:
case 412:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out412;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st413;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st413:
case 413:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out413;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st414;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st414:
case 414:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out414;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr648;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st415:
case 415:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out415;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st416;
		case 117: goto st417;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st416:
case 416:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out416;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto tr651;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st417:
case 417:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out417;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st418;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st418:
case 418:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out418;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st419;
		case 116: goto st424;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st419:
case 419:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out419;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 102: goto st420;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr655;
st420:
case 420:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out420;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st421;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st421:
case 421:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out421;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st422;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st422:
case 422:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out422;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 115: goto st423;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st423:
case 423:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out423;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr660;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st424:
case 424:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out424;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st425;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st425:
case 425:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out425;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st426;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st426:
case 426:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out426;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto tr663;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st427:
case 427:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out427;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st428;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st428:
case 428:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out428;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st429;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st429:
case 429:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out429;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr666;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st430:
case 430:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out430;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st431;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st431:
case 431:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out431;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st432;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st432:
case 432:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out432;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st433;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st433:
case 433:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out433;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr670;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st434:
case 434:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out434;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st435;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st435:
case 435:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out435;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st436;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st436:
case 436:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out436;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto tr673;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st437:
case 437:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out437;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 103: goto st438;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st438:
case 438:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out438;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 104: goto st439;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st439:
case 439:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out439;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr676;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st440:
case 440:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out440;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st441;
		case 116: goto st448;
		case 119: goto st452;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st441:
case 441:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out441;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto st442;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st442:
case 442:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out442;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto st443;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st443:
case 443:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out443;
	if ( (*pdaRun->p) == 95 )
		goto st444;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr682;
st444:
case 444:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out444;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st445;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st445:
case 445:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out445;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st446;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st446:
case 446:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out446;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st447;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st447:
case 447:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out447;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr687;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st448:
case 448:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out448;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 114: goto st449;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st449:
case 449:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out449;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st450;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st450:
case 450:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out450;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st451;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st451:
case 451:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out451;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto tr691;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st452:
case 452:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out452;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st453;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st453:
case 453:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out453;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 116: goto st454;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st454:
case 454:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out454;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 99: goto st455;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st455:
case 455:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out455;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 104: goto tr695;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st456:
case 456:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out456;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st457;
		case 114: goto st460;
		case 121: goto st462;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st457:
case 457:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out457;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 107: goto st458;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st458:
case 458:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out458;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st459;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st459:
case 459:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out459;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 110: goto tr701;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st460:
case 460:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out460;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 117: goto st461;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st461:
case 461:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out461;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr703;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st462:
case 462:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out462;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 112: goto st463;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st463:
case 463:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out463;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st464;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st464:
case 464:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out464;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st465;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st465:
case 465:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out465;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto tr707;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st466:
case 466:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out466;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 111: goto st467;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st467:
case 467:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out467;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st468;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st468:
case 468:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out468;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto tr710;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st469:
case 469:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out469;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 104: goto st470;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st470:
case 470:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out470;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st471;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st471:
case 471:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out471;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st472;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st472:
case 472:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out472;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto tr714;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st473:
case 473:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out473;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 105: goto st474;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st474:
case 474:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out474;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 101: goto st475;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st475:
case 475:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out475;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 108: goto st476;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st476:
case 476:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out476;
	switch( (*pdaRun->p) ) {
		case 95: goto tr417;
		case 100: goto tr718;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto tr417;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto tr417;
	} else
		goto tr417;
	goto tr464;
st477:
case 477:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out477;
	if ( (*pdaRun->p) == 124 )
		goto tr720;
	goto tr719;
st267:
case 267:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out267;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st267;
	goto tr450;
tr12:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 113;
	goto out;
}
	goto st478;
tr722:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 112;
	goto out;
}
	goto st478;
st478:
case 478:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out478;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st479;
		case 35: goto st8;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st479;
	goto st0;
st479:
case 479:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out479;
	if ( (*pdaRun->p) == 32 )
		goto st479;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st479;
	goto tr722;
st8:
case 8:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out8;
	if ( (*pdaRun->p) == 10 )
		goto tr12;
	goto st8;
tr14:
	{	switch( pdaRun->act ) {
	case 0: goto st0;
	case 229:
	pdaRun->matched_token = 118;
	break;
	}
		goto skip_tokpref;
}
	goto st480;
tr723:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 115;
	goto out;
}
	goto st480;
tr724:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 114;
	goto out;
}
	goto st480;
tr725:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 116;
	goto out;
}
	goto st480;
tr727:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 117;
	goto out;
}
	goto st480;
tr728:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 118;
	goto out;
}
	goto st480;
st480:
	{pdaRun->act = 0;}
case 480:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out480;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr723;
		case 34: goto tr724;
		case 91: goto tr725;
		case 92: goto st9;
		case 93: goto tr727;
	}
	goto tr13;
st9:
case 9:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out9;
	goto tr13;
tr13:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 229;}
	goto st481;
st481:
case 481:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out481;
	switch( (*pdaRun->p) ) {
		case 10: goto tr728;
		case 34: goto tr728;
		case 92: goto st9;
	}
	if ( 91 <= (*pdaRun->p) && (*pdaRun->p) <= 93 )
		goto tr728;
	goto tr13;
tr16:
	{	switch( pdaRun->act ) {
	case 0: goto st0;
	case 230:
	pdaRun->matched_token = 118;
	break;
	}
		goto skip_tokpref;
}
	goto st482;
tr729:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 115;
	goto out;
}
	goto st482;
tr730:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 114;
	goto out;
}
	goto st482;
tr731:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 116;
	goto out;
}
	goto st482;
tr733:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 117;
	goto out;
}
	goto st482;
tr734:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 118;
	goto out;
}
	goto st482;
st482:
	{pdaRun->act = 0;}
case 482:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out482;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr729;
		case 34: goto tr730;
		case 91: goto tr731;
		case 92: goto st10;
		case 93: goto tr733;
	}
	goto tr15;
st10:
case 10:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out10;
	goto tr15;
tr15:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 230;}
	goto st483;
st483:
case 483:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out483;
	switch( (*pdaRun->p) ) {
		case 10: goto tr734;
		case 34: goto tr734;
		case 92: goto st10;
	}
	if ( 91 <= (*pdaRun->p) && (*pdaRun->p) <= 93 )
		goto tr734;
	goto tr15;
tr735:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 173;
	goto out;
}
	goto st484;
st484:
case 484:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out484;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr735;
tr18:
	{	switch( pdaRun->act ) {
	case 0: goto st0;
	case 235:
	pdaRun->matched_token = 121;
	break;
	}
		goto skip_tokpref;
}
	goto st485;
tr736:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 120;
	goto out;
}
	goto st485;
tr737:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 119;
	goto out;
}
	goto st485;
tr739:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 121;
	goto out;
}
	goto st485;
st485:
	{pdaRun->act = 0;}
case 485:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out485;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr736;
		case 39: goto tr737;
		case 92: goto st11;
	}
	goto tr17;
st11:
case 11:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out11;
	goto tr17;
tr17:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 235;}
	goto st486;
st486:
case 486:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out486;
	switch( (*pdaRun->p) ) {
		case 10: goto tr739;
		case 39: goto tr739;
		case 92: goto st11;
	}
	goto tr17;
tr20:
	{	switch( pdaRun->act ) {
	case 0: goto st0;
	case 236:
	pdaRun->matched_token = 121;
	break;
	}
		goto skip_tokpref;
}
	goto st487;
tr740:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 120;
	goto out;
}
	goto st487;
tr741:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 119;
	goto out;
}
	goto st487;
tr743:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 121;
	goto out;
}
	goto st487;
st487:
	{pdaRun->act = 0;}
case 487:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out487;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 10: goto tr740;
		case 39: goto tr741;
		case 92: goto st12;
	}
	goto tr19;
st12:
case 12:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out12;
	goto tr19;
tr19:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	{pdaRun->act = 236;}
	goto st488;
st488:
case 488:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out488;
	switch( (*pdaRun->p) ) {
		case 10: goto tr743;
		case 39: goto tr743;
		case 92: goto st12;
	}
	goto tr19;
tr744:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 174;
	goto out;
}
	goto st489;
st489:
case 489:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out489;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr744;
tr746:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 122;
	goto out;
}
	goto st490;
tr747:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 123;
	goto out;
}
	goto st490;
st490:
case 490:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out490;
	{pdaRun->tokstart = pdaRun->p;}
	if ( (*pdaRun->p) == 10 )
		goto tr746;
	goto st491;
st491:
case 491:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out491;
	if ( (*pdaRun->p) == 10 )
		goto tr747;
	goto st491;
tr749:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 122;
	goto out;
}
	goto st492;
tr750:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 123;
	goto out;
}
	goto st492;
st492:
case 492:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out492;
	{pdaRun->tokstart = pdaRun->p;}
	if ( (*pdaRun->p) == 10 )
		goto tr749;
	goto st493;
st493:
case 493:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out493;
	if ( (*pdaRun->p) == 10 )
		goto tr750;
	goto st493;
tr751:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 175;
	goto out;
}
	goto st494;
st494:
case 494:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out494;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr751;
tr25:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 148;
	goto out;
}
	goto st495;
tr28:
	{	pdaRun->matched_token = 125;
	goto skip_tokpref;
}
	goto st495;
tr31:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 146;
	goto out;
}
	goto st495;
tr753:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 130;
	goto out;
}
	goto st495;
tr754:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 132;
	goto out;
}
	goto st495;
tr755:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 133;
	goto out;
}
	goto st495;
tr757:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 137;
	goto out;
}
	goto st495;
tr760:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 142;
	goto out;
}
	goto st495;
tr765:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 136;
	goto out;
}
	goto st495;
tr768:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 138;
	goto out;
}
	goto st495;
tr769:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 129;
	goto out;
}
	goto st495;
tr770:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 147;
	goto out;
}
	goto st495;
tr771:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 127;
	goto out;
}
	goto st495;
tr772:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 127;
	goto out;
}
	goto st495;
tr773:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 134;
	goto out;
}
	goto st495;
tr774:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 135;
	goto out;
}
	goto st495;
tr775:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 131;
	goto out;
}
	goto st495;
tr776:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 143;
	goto out;
}
	goto st495;
tr777:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 128;
	goto out;
}
	goto st495;
tr778:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 139;
	goto out;
}
	goto st495;
tr779:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 125;
	goto out;
}
	goto st495;
tr781:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 126;
	goto out;
}
	goto st495;
tr782:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 144;
	goto out;
}
	goto st495;
tr783:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 145;
	goto out;
}
	goto st495;
tr784:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 124;
	goto out;
}
	goto st495;
tr785:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 140;
	goto out;
}
	goto st495;
tr786:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 141;
	goto out;
}
	goto st495;
st495:
case 495:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out495;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st496;
		case 34: goto st13;
		case 35: goto st15;
		case 38: goto tr753;
		case 39: goto st16;
		case 40: goto tr754;
		case 41: goto tr755;
		case 42: goto st498;
		case 43: goto tr757;
		case 45: goto st499;
		case 46: goto st500;
		case 47: goto tr760;
		case 48: goto tr761;
		case 58: goto st19;
		case 60: goto st20;
		case 63: goto tr765;
		case 91: goto st506;
		case 94: goto tr768;
		case 95: goto st505;
		case 124: goto tr769;
	}
	if ( (*pdaRun->p) < 49 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st496;
	} else if ( (*pdaRun->p) > 57 ) {
		if ( (*pdaRun->p) > 90 ) {
			if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
				goto st505;
		} else if ( (*pdaRun->p) >= 65 )
			goto st505;
	} else
		goto st502;
	goto st0;
st496:
case 496:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out496;
	if ( (*pdaRun->p) == 32 )
		goto st496;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st496;
	goto tr770;
st13:
case 13:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out13;
	switch( (*pdaRun->p) ) {
		case 34: goto st497;
		case 92: goto st14;
	}
	goto st13;
st497:
case 497:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out497;
	if ( (*pdaRun->p) == 105 )
		goto tr772;
	goto tr771;
st14:
case 14:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out14;
	goto st13;
st15:
case 15:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out15;
	if ( (*pdaRun->p) == 10 )
		goto tr25;
	goto st15;
st16:
case 16:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out16;
	switch( (*pdaRun->p) ) {
		case 39: goto st497;
		case 92: goto st17;
	}
	goto st16;
st17:
case 17:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out17;
	goto st16;
st498:
case 498:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out498;
	if ( (*pdaRun->p) == 42 )
		goto tr774;
	goto tr773;
st499:
case 499:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out499;
	if ( (*pdaRun->p) == 45 )
		goto tr776;
	goto tr775;
st500:
case 500:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out500;
	if ( (*pdaRun->p) == 46 )
		goto tr778;
	goto tr777;
tr761:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st501;
st501:
case 501:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out501;
	if ( (*pdaRun->p) == 120 )
		goto st18;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st502;
	goto tr779;
st18:
case 18:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out18;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st503;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st503;
	} else
		goto st503;
	goto tr28;
st503:
case 503:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out503;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st503;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st503;
	} else
		goto st503;
	goto tr781;
st502:
case 502:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out502;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st502;
	goto tr779;
st19:
case 19:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out19;
	if ( (*pdaRun->p) == 62 )
		goto st504;
	goto st0;
st504:
case 504:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out504;
	if ( (*pdaRun->p) == 62 )
		goto tr783;
	goto tr782;
st20:
case 20:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out20;
	if ( (*pdaRun->p) == 58 )
		goto tr31;
	goto st0;
st506:
case 506:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out506;
	if ( (*pdaRun->p) == 94 )
		goto tr786;
	goto tr785;
st505:
case 505:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out505;
	if ( (*pdaRun->p) == 95 )
		goto st505;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st505;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st505;
	} else
		goto st505;
	goto tr784;
tr37:
	{	pdaRun->matched_token = 125;
	goto skip_tokpref;
}
	goto st507;
tr40:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 146;
	goto out;
}
	goto st507;
tr787:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 130;
	goto out;
}
	goto st507;
tr788:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 132;
	goto out;
}
	goto st507;
tr789:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 133;
	goto out;
}
	goto st507;
tr791:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 137;
	goto out;
}
	goto st507;
tr794:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 142;
	goto out;
}
	goto st507;
tr799:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 136;
	goto out;
}
	goto st507;
tr802:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 138;
	goto out;
}
	goto st507;
tr803:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 129;
	goto out;
}
	goto st507;
tr804:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 127;
	goto out;
}
	goto st507;
tr805:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 127;
	goto out;
}
	goto st507;
tr806:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 134;
	goto out;
}
	goto st507;
tr807:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 135;
	goto out;
}
	goto st507;
tr808:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 131;
	goto out;
}
	goto st507;
tr809:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 143;
	goto out;
}
	goto st507;
tr810:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 128;
	goto out;
}
	goto st507;
tr811:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 139;
	goto out;
}
	goto st507;
tr812:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 125;
	goto out;
}
	goto st507;
tr814:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 126;
	goto out;
}
	goto st507;
tr815:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 144;
	goto out;
}
	goto st507;
tr816:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 145;
	goto out;
}
	goto st507;
tr817:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 124;
	goto out;
}
	goto st507;
tr818:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 140;
	goto out;
}
	goto st507;
tr819:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 141;
	goto out;
}
	goto st507;
st507:
case 507:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out507;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 34: goto st21;
		case 38: goto tr787;
		case 39: goto st23;
		case 40: goto tr788;
		case 41: goto tr789;
		case 42: goto st509;
		case 43: goto tr791;
		case 45: goto st510;
		case 46: goto st511;
		case 47: goto tr794;
		case 48: goto tr795;
		case 58: goto st26;
		case 60: goto st27;
		case 63: goto tr799;
		case 91: goto st517;
		case 94: goto tr802;
		case 95: goto st516;
		case 124: goto tr803;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st513;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st516;
	} else
		goto st516;
	goto st0;
st21:
case 21:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out21;
	switch( (*pdaRun->p) ) {
		case 34: goto st508;
		case 92: goto st22;
	}
	goto st21;
st508:
case 508:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out508;
	if ( (*pdaRun->p) == 105 )
		goto tr805;
	goto tr804;
st22:
case 22:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out22;
	goto st21;
st23:
case 23:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out23;
	switch( (*pdaRun->p) ) {
		case 39: goto st508;
		case 92: goto st24;
	}
	goto st23;
st24:
case 24:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out24;
	goto st23;
st509:
case 509:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out509;
	if ( (*pdaRun->p) == 42 )
		goto tr807;
	goto tr806;
st510:
case 510:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out510;
	if ( (*pdaRun->p) == 45 )
		goto tr809;
	goto tr808;
st511:
case 511:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out511;
	if ( (*pdaRun->p) == 46 )
		goto tr811;
	goto tr810;
tr795:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st512;
st512:
case 512:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out512;
	if ( (*pdaRun->p) == 120 )
		goto st25;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st513;
	goto tr812;
st25:
case 25:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out25;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st514;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st514;
	} else
		goto st514;
	goto tr37;
st514:
case 514:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out514;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st514;
	} else if ( (*pdaRun->p) > 70 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 102 )
			goto st514;
	} else
		goto st514;
	goto tr814;
st513:
case 513:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out513;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st513;
	goto tr812;
st26:
case 26:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out26;
	if ( (*pdaRun->p) == 62 )
		goto st515;
	goto st0;
st515:
case 515:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out515;
	if ( (*pdaRun->p) == 62 )
		goto tr816;
	goto tr815;
st27:
case 27:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out27;
	if ( (*pdaRun->p) == 58 )
		goto tr40;
	goto st0;
st517:
case 517:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out517;
	if ( (*pdaRun->p) == 94 )
		goto tr819;
	goto tr818;
st516:
case 516:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out516;
	if ( (*pdaRun->p) == 95 )
		goto st516;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st516;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st516;
	} else
		goto st516;
	goto tr817;
tr42:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 148;
	goto out;
}
	goto st518;
tr821:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 147;
	goto out;
}
	goto st518;
st518:
case 518:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out518;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st519;
		case 35: goto st28;
	}
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st519;
	goto st0;
st519:
case 519:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out519;
	if ( (*pdaRun->p) == 32 )
		goto st519;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st519;
	goto tr821;
st28:
case 28:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out28;
	if ( (*pdaRun->p) == 10 )
		goto tr42;
	goto st28;
tr43:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 150;
	goto out;
}
	goto st520;
tr822:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 149;
	goto out;
}
	goto st520;
tr824:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 151;
	goto out;
}
	goto st520;
st520:
case 520:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out520;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 45: goto tr822;
		case 92: goto st29;
		case 93: goto tr824;
	}
	goto tr43;
st29:
case 29:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out29;
	goto tr43;
tr44:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 150;
	goto out;
}
	goto st521;
tr825:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 149;
	goto out;
}
	goto st521;
tr827:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 151;
	goto out;
}
	goto st521;
st521:
case 521:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out521;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 45: goto tr825;
		case 92: goto st30;
		case 93: goto tr827;
	}
	goto tr44;
st30:
case 30:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out30;
	goto tr44;
tr828:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 176;
	goto out;
}
	goto st522;
st522:
case 522:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out522;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr828;
tr48:
	{	pdaRun->matched_token = 165;
	goto skip_tokpref;
}
	goto st523;
tr55:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 155;
	goto out;
}
	goto st523;
tr829:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 165;
	goto out;
}
	goto st523;
tr837:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 152;
	goto out;
}
	goto st523;
tr838:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 153;
	goto out;
}
	goto st523;
tr839:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 156;
	goto out;
}
	goto st523;
tr840:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 165;
	goto out;
}
	goto st523;
tr841:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 157;
	goto out;
}
	goto st523;
tr842:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 157;
	goto out;
}
	goto st523;
tr843:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 158;
	goto out;
}
	goto st523;
tr847:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 164;
	goto out;
}
	goto st523;
tr848:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 161;
	goto out;
}
	goto st523;
tr849:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 162;
	goto out;
}
	goto st523;
tr850:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 159;
	goto out;
}
	goto st523;
tr853:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 163;
	goto out;
}
	goto st523;
tr854:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 160;
	goto out;
}
	goto st523;
tr855:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 154;
	goto out;
}
	goto st523;
st523:
case 523:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out523;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st524;
		case 34: goto tr831;
		case 36: goto tr832;
		case 39: goto tr833;
		case 47: goto tr834;
		case 64: goto st534;
		case 95: goto st537;
		case 123: goto tr837;
		case 125: goto tr838;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st524;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st537;
	} else
		goto st537;
	goto tr829;
st524:
case 524:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out524;
	if ( (*pdaRun->p) == 32 )
		goto st524;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st524;
	goto tr839;
tr831:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st525;
st525:
case 525:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out525;
	switch( (*pdaRun->p) ) {
		case 34: goto st526;
		case 92: goto st32;
	}
	goto st31;
st526:
case 526:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out526;
	if ( (*pdaRun->p) == 105 )
		goto tr842;
	goto tr841;
st32:
case 32:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out32;
	goto st31;
st31:
case 31:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out31;
	switch( (*pdaRun->p) ) {
		case 34: goto st526;
		case 92: goto st32;
	}
	goto st31;
tr832:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st527;
st527:
case 527:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out527;
	switch( (*pdaRun->p) ) {
		case 36: goto tr843;
		case 42: goto st33;
		case 95: goto st531;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st530;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st531;
	} else
		goto st531;
	goto tr840;
st33:
case 33:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out33;
	if ( (*pdaRun->p) == 95 )
		goto st529;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st528;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st529;
	} else
		goto st529;
	goto tr48;
st529:
case 529:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out529;
	if ( (*pdaRun->p) == 95 )
		goto st529;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st529;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st529;
	} else
		goto st529;
	goto tr848;
st528:
case 528:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out528;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st528;
	goto tr847;
st531:
case 531:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out531;
	if ( (*pdaRun->p) == 95 )
		goto st531;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st531;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st531;
	} else
		goto st531;
	goto tr850;
st530:
case 530:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out530;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st530;
	goto tr849;
tr833:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st532;
st532:
case 532:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out532;
	switch( (*pdaRun->p) ) {
		case 39: goto st526;
		case 92: goto st35;
	}
	goto st34;
st35:
case 35:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out35;
	goto st34;
st34:
case 34:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out34;
	switch( (*pdaRun->p) ) {
		case 39: goto st526;
		case 92: goto st35;
	}
	goto st34;
tr834:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st533;
st533:
case 533:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out533;
	switch( (*pdaRun->p) ) {
		case 42: goto st36;
		case 47: goto st38;
	}
	goto tr840;
st36:
case 36:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out36;
	if ( (*pdaRun->p) == 42 )
		goto st37;
	goto st36;
st37:
case 37:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out37;
	if ( (*pdaRun->p) == 47 )
		goto tr55;
	goto tr48;
st38:
case 38:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out38;
	if ( (*pdaRun->p) == 10 )
		goto tr55;
	goto st38;
st534:
case 534:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out534;
	if ( (*pdaRun->p) == 95 )
		goto st536;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st535;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st536;
	} else
		goto st536;
	goto tr840;
st536:
case 536:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out536;
	if ( (*pdaRun->p) == 95 )
		goto st536;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st536;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st536;
	} else
		goto st536;
	goto tr854;
st535:
case 535:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out535;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st535;
	goto tr853;
st537:
case 537:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out537;
	if ( (*pdaRun->p) == 95 )
		goto st537;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st537;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st537;
	} else
		goto st537;
	goto tr855;
tr60:
	{	pdaRun->matched_token = 165;
	goto skip_tokpref;
}
	goto st538;
tr67:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 155;
	goto out;
}
	goto st538;
tr856:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 165;
	goto out;
}
	goto st538;
tr864:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 152;
	goto out;
}
	goto st538;
tr865:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 153;
	goto out;
}
	goto st538;
tr866:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 156;
	goto out;
}
	goto st538;
tr867:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 165;
	goto out;
}
	goto st538;
tr868:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 157;
	goto out;
}
	goto st538;
tr869:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 157;
	goto out;
}
	goto st538;
tr870:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 158;
	goto out;
}
	goto st538;
tr874:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 164;
	goto out;
}
	goto st538;
tr875:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 161;
	goto out;
}
	goto st538;
tr876:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 162;
	goto out;
}
	goto st538;
tr877:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 159;
	goto out;
}
	goto st538;
tr880:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 163;
	goto out;
}
	goto st538;
tr881:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 160;
	goto out;
}
	goto st538;
tr882:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 154;
	goto out;
}
	goto st538;
st538:
case 538:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out538;
	{pdaRun->tokstart = pdaRun->p;}
	switch( (*pdaRun->p) ) {
		case 32: goto st539;
		case 34: goto tr858;
		case 36: goto tr859;
		case 39: goto tr860;
		case 47: goto tr861;
		case 64: goto st549;
		case 95: goto st552;
		case 123: goto tr864;
		case 125: goto tr865;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
			goto st539;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st552;
	} else
		goto st552;
	goto tr856;
st539:
case 539:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out539;
	if ( (*pdaRun->p) == 32 )
		goto st539;
	if ( 9 <= (*pdaRun->p) && (*pdaRun->p) <= 10 )
		goto st539;
	goto tr866;
tr858:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st540;
st540:
case 540:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out540;
	switch( (*pdaRun->p) ) {
		case 34: goto st541;
		case 92: goto st40;
	}
	goto st39;
st541:
case 541:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out541;
	if ( (*pdaRun->p) == 105 )
		goto tr869;
	goto tr868;
st40:
case 40:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out40;
	goto st39;
st39:
case 39:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out39;
	switch( (*pdaRun->p) ) {
		case 34: goto st541;
		case 92: goto st40;
	}
	goto st39;
tr859:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st542;
st542:
case 542:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out542;
	switch( (*pdaRun->p) ) {
		case 36: goto tr870;
		case 42: goto st41;
		case 95: goto st546;
	}
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st545;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st546;
	} else
		goto st546;
	goto tr867;
st41:
case 41:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out41;
	if ( (*pdaRun->p) == 95 )
		goto st544;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st543;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st544;
	} else
		goto st544;
	goto tr60;
st544:
case 544:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out544;
	if ( (*pdaRun->p) == 95 )
		goto st544;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st544;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st544;
	} else
		goto st544;
	goto tr875;
st543:
case 543:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out543;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st543;
	goto tr874;
st546:
case 546:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out546;
	if ( (*pdaRun->p) == 95 )
		goto st546;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st546;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st546;
	} else
		goto st546;
	goto tr877;
st545:
case 545:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out545;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st545;
	goto tr876;
tr860:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st547;
st547:
case 547:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out547;
	switch( (*pdaRun->p) ) {
		case 39: goto st541;
		case 92: goto st43;
	}
	goto st42;
st43:
case 43:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out43;
	goto st42;
st42:
case 42:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out42;
	switch( (*pdaRun->p) ) {
		case 39: goto st541;
		case 92: goto st43;
	}
	goto st42;
tr861:
	{{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ) + 1; }}
	goto st548;
st548:
case 548:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out548;
	switch( (*pdaRun->p) ) {
		case 42: goto st44;
		case 47: goto st46;
	}
	goto tr867;
st44:
case 44:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out44;
	if ( (*pdaRun->p) == 42 )
		goto st45;
	goto st44;
st45:
case 45:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out45;
	if ( (*pdaRun->p) == 47 )
		goto tr67;
	goto tr60;
st46:
case 46:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out46;
	if ( (*pdaRun->p) == 10 )
		goto tr67;
	goto st46;
st549:
case 549:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out549;
	if ( (*pdaRun->p) == 95 )
		goto st551;
	if ( (*pdaRun->p) < 65 ) {
		if ( 49 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st550;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st551;
	} else
		goto st551;
	goto tr867;
st551:
case 551:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out551;
	if ( (*pdaRun->p) == 95 )
		goto st551;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st551;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st551;
	} else
		goto st551;
	goto tr881;
st550:
case 550:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out550;
	if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
		goto st550;
	goto tr880;
st552:
case 552:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out552;
	if ( (*pdaRun->p) == 95 )
		goto st552;
	if ( (*pdaRun->p) < 65 ) {
		if ( 48 <= (*pdaRun->p) && (*pdaRun->p) <= 57 )
			goto st552;
	} else if ( (*pdaRun->p) > 90 ) {
		if ( 97 <= (*pdaRun->p) && (*pdaRun->p) <= 122 )
			goto st552;
	} else
		goto st552;
	goto tr882;
tr883:
	{	pdaRun->p += 1;
{ pdaRun->tokend = pdaRun->tokpref + ( pdaRun->p - pdaRun->start ); }	pdaRun->matched_token = 177;
	goto out;
}
	goto st553;
st553:
case 553:
	if ( ++pdaRun->p == pdaRun->pe )
		goto out553;
	{pdaRun->tokstart = pdaRun->p;}
	goto tr883;
	}
out_switch:
	switch ( pdaRun->fsm_cs )
	{
	case 47: out47: pdaRun->fsm_cs = 47; goto out; 
	case 48: out48: if ( pdaRun->scan_eof ) {goto tr118;
}pdaRun->fsm_cs = 48; goto out; 
	case 49: out49: if ( pdaRun->scan_eof ) {goto tr119;
}pdaRun->fsm_cs = 49; goto out; 
	case 1: out1: pdaRun->fsm_cs = 1; goto out; 
	case 2: out2: pdaRun->fsm_cs = 2; goto out; 
	case 0: out0: pdaRun->fsm_cs = 0; goto out; 
	case 50: out50: if ( pdaRun->scan_eof ) {goto tr121;
}pdaRun->fsm_cs = 50; goto out; 
	case 51: out51: if ( pdaRun->scan_eof ) {goto tr123;
}pdaRun->fsm_cs = 51; goto out; 
	case 3: out3: if ( pdaRun->scan_eof ) {goto tr4;
}pdaRun->fsm_cs = 3; goto out; 
	case 53: out53: if ( pdaRun->scan_eof ) {goto tr126;
}pdaRun->fsm_cs = 53; goto out; 
	case 54: out54: if ( pdaRun->scan_eof ) {goto tr128;
}pdaRun->fsm_cs = 54; goto out; 
	case 55: out55: if ( pdaRun->scan_eof ) {goto tr132;
}pdaRun->fsm_cs = 55; goto out; 
	case 56: out56: if ( pdaRun->scan_eof ) {goto tr134;
}pdaRun->fsm_cs = 56; goto out; 
	case 4: out4: pdaRun->fsm_cs = 4; goto out; 
	case 58: out58: if ( pdaRun->scan_eof ) {goto tr137;
}pdaRun->fsm_cs = 58; goto out; 
	case 59: out59: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 59; goto out; 
	case 57: out57: if ( pdaRun->scan_eof ) {goto tr136;
}pdaRun->fsm_cs = 57; goto out; 
	case 60: out60: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 60; goto out; 
	case 61: out61: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 61; goto out; 
	case 62: out62: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 62; goto out; 
	case 63: out63: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 63; goto out; 
	case 64: out64: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 64; goto out; 
	case 65: out65: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 65; goto out; 
	case 66: out66: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 66; goto out; 
	case 67: out67: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 67; goto out; 
	case 68: out68: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 68; goto out; 
	case 69: out69: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 69; goto out; 
	case 70: out70: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 70; goto out; 
	case 71: out71: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 71; goto out; 
	case 72: out72: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 72; goto out; 
	case 73: out73: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 73; goto out; 
	case 74: out74: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 74; goto out; 
	case 75: out75: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 75; goto out; 
	case 76: out76: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 76; goto out; 
	case 77: out77: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 77; goto out; 
	case 78: out78: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 78; goto out; 
	case 79: out79: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 79; goto out; 
	case 80: out80: if ( pdaRun->scan_eof ) {goto tr167;
}pdaRun->fsm_cs = 80; goto out; 
	case 81: out81: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 81; goto out; 
	case 82: out82: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 82; goto out; 
	case 83: out83: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 83; goto out; 
	case 84: out84: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 84; goto out; 
	case 85: out85: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 85; goto out; 
	case 86: out86: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 86; goto out; 
	case 87: out87: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 87; goto out; 
	case 88: out88: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 88; goto out; 
	case 89: out89: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 89; goto out; 
	case 90: out90: if ( pdaRun->scan_eof ) {goto tr178;
}pdaRun->fsm_cs = 90; goto out; 
	case 91: out91: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 91; goto out; 
	case 92: out92: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 92; goto out; 
	case 93: out93: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 93; goto out; 
	case 94: out94: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 94; goto out; 
	case 95: out95: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 95; goto out; 
	case 96: out96: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 96; goto out; 
	case 97: out97: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 97; goto out; 
	case 98: out98: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 98; goto out; 
	case 99: out99: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 99; goto out; 
	case 100: out100: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 100; goto out; 
	case 101: out101: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 101; goto out; 
	case 102: out102: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 102; goto out; 
	case 103: out103: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 103; goto out; 
	case 104: out104: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 104; goto out; 
	case 105: out105: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 105; goto out; 
	case 106: out106: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 106; goto out; 
	case 107: out107: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 107; goto out; 
	case 108: out108: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 108; goto out; 
	case 109: out109: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 109; goto out; 
	case 110: out110: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 110; goto out; 
	case 111: out111: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 111; goto out; 
	case 112: out112: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 112; goto out; 
	case 113: out113: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 113; goto out; 
	case 114: out114: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 114; goto out; 
	case 115: out115: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 115; goto out; 
	case 116: out116: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 116; goto out; 
	case 117: out117: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 117; goto out; 
	case 118: out118: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 118; goto out; 
	case 119: out119: if ( pdaRun->scan_eof ) {goto tr216;
}pdaRun->fsm_cs = 119; goto out; 
	case 120: out120: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 120; goto out; 
	case 121: out121: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 121; goto out; 
	case 122: out122: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 122; goto out; 
	case 123: out123: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 123; goto out; 
	case 124: out124: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 124; goto out; 
	case 125: out125: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 125; goto out; 
	case 126: out126: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 126; goto out; 
	case 127: out127: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 127; goto out; 
	case 128: out128: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 128; goto out; 
	case 129: out129: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 129; goto out; 
	case 130: out130: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 130; goto out; 
	case 131: out131: if ( pdaRun->scan_eof ) {goto tr233;
}pdaRun->fsm_cs = 131; goto out; 
	case 132: out132: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 132; goto out; 
	case 133: out133: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 133; goto out; 
	case 134: out134: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 134; goto out; 
	case 135: out135: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 135; goto out; 
	case 136: out136: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 136; goto out; 
	case 137: out137: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 137; goto out; 
	case 138: out138: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 138; goto out; 
	case 139: out139: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 139; goto out; 
	case 140: out140: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 140; goto out; 
	case 141: out141: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 141; goto out; 
	case 142: out142: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 142; goto out; 
	case 143: out143: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 143; goto out; 
	case 144: out144: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 144; goto out; 
	case 145: out145: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 145; goto out; 
	case 146: out146: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 146; goto out; 
	case 147: out147: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 147; goto out; 
	case 148: out148: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 148; goto out; 
	case 149: out149: if ( pdaRun->scan_eof ) {goto tr255;
}pdaRun->fsm_cs = 149; goto out; 
	case 150: out150: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 150; goto out; 
	case 151: out151: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 151; goto out; 
	case 152: out152: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 152; goto out; 
	case 153: out153: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 153; goto out; 
	case 154: out154: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 154; goto out; 
	case 155: out155: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 155; goto out; 
	case 156: out156: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 156; goto out; 
	case 157: out157: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 157; goto out; 
	case 158: out158: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 158; goto out; 
	case 159: out159: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 159; goto out; 
	case 160: out160: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 160; goto out; 
	case 161: out161: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 161; goto out; 
	case 162: out162: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 162; goto out; 
	case 163: out163: if ( pdaRun->scan_eof ) {goto tr273;
}pdaRun->fsm_cs = 163; goto out; 
	case 164: out164: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 164; goto out; 
	case 165: out165: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 165; goto out; 
	case 166: out166: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 166; goto out; 
	case 167: out167: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 167; goto out; 
	case 168: out168: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 168; goto out; 
	case 169: out169: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 169; goto out; 
	case 170: out170: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 170; goto out; 
	case 171: out171: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 171; goto out; 
	case 172: out172: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 172; goto out; 
	case 173: out173: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 173; goto out; 
	case 174: out174: if ( pdaRun->scan_eof ) {goto tr287;
}pdaRun->fsm_cs = 174; goto out; 
	case 175: out175: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 175; goto out; 
	case 176: out176: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 176; goto out; 
	case 177: out177: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 177; goto out; 
	case 178: out178: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 178; goto out; 
	case 179: out179: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 179; goto out; 
	case 180: out180: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 180; goto out; 
	case 181: out181: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 181; goto out; 
	case 182: out182: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 182; goto out; 
	case 183: out183: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 183; goto out; 
	case 184: out184: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 184; goto out; 
	case 185: out185: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 185; goto out; 
	case 186: out186: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 186; goto out; 
	case 187: out187: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 187; goto out; 
	case 188: out188: if ( pdaRun->scan_eof ) {goto tr304;
}pdaRun->fsm_cs = 188; goto out; 
	case 189: out189: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 189; goto out; 
	case 190: out190: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 190; goto out; 
	case 191: out191: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 191; goto out; 
	case 192: out192: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 192; goto out; 
	case 193: out193: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 193; goto out; 
	case 194: out194: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 194; goto out; 
	case 195: out195: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 195; goto out; 
	case 196: out196: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 196; goto out; 
	case 197: out197: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 197; goto out; 
	case 198: out198: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 198; goto out; 
	case 199: out199: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 199; goto out; 
	case 200: out200: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 200; goto out; 
	case 201: out201: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 201; goto out; 
	case 202: out202: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 202; goto out; 
	case 203: out203: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 203; goto out; 
	case 204: out204: if ( pdaRun->scan_eof ) {goto tr330;
}pdaRun->fsm_cs = 204; goto out; 
	case 205: out205: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 205; goto out; 
	case 206: out206: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 206; goto out; 
	case 207: out207: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 207; goto out; 
	case 208: out208: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 208; goto out; 
	case 209: out209: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 209; goto out; 
	case 210: out210: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 210; goto out; 
	case 211: out211: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 211; goto out; 
	case 212: out212: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 212; goto out; 
	case 213: out213: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 213; goto out; 
	case 214: out214: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 214; goto out; 
	case 215: out215: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 215; goto out; 
	case 216: out216: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 216; goto out; 
	case 217: out217: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 217; goto out; 
	case 218: out218: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 218; goto out; 
	case 219: out219: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 219; goto out; 
	case 220: out220: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 220; goto out; 
	case 221: out221: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 221; goto out; 
	case 222: out222: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 222; goto out; 
	case 223: out223: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 223; goto out; 
	case 224: out224: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 224; goto out; 
	case 225: out225: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 225; goto out; 
	case 226: out226: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 226; goto out; 
	case 227: out227: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 227; goto out; 
	case 228: out228: if ( pdaRun->scan_eof ) {goto tr357;
}pdaRun->fsm_cs = 228; goto out; 
	case 229: out229: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 229; goto out; 
	case 230: out230: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 230; goto out; 
	case 231: out231: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 231; goto out; 
	case 232: out232: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 232; goto out; 
	case 233: out233: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 233; goto out; 
	case 234: out234: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 234; goto out; 
	case 235: out235: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 235; goto out; 
	case 236: out236: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 236; goto out; 
	case 237: out237: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 237; goto out; 
	case 238: out238: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 238; goto out; 
	case 239: out239: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 239; goto out; 
	case 240: out240: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 240; goto out; 
	case 241: out241: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 241; goto out; 
	case 242: out242: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 242; goto out; 
	case 243: out243: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 243; goto out; 
	case 244: out244: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 244; goto out; 
	case 245: out245: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 245; goto out; 
	case 246: out246: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 246; goto out; 
	case 247: out247: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 247; goto out; 
	case 248: out248: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 248; goto out; 
	case 249: out249: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 249; goto out; 
	case 250: out250: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 250; goto out; 
	case 251: out251: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 251; goto out; 
	case 252: out252: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 252; goto out; 
	case 253: out253: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 253; goto out; 
	case 254: out254: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 254; goto out; 
	case 255: out255: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 255; goto out; 
	case 256: out256: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 256; goto out; 
	case 257: out257: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 257; goto out; 
	case 258: out258: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 258; goto out; 
	case 259: out259: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 259; goto out; 
	case 260: out260: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 260; goto out; 
	case 261: out261: if ( pdaRun->scan_eof ) {goto tr139;
}pdaRun->fsm_cs = 261; goto out; 
	case 262: out262: if ( pdaRun->scan_eof ) {goto tr394;
}pdaRun->fsm_cs = 262; goto out; 
	case 52: out52: if ( pdaRun->scan_eof ) {goto tr125;
}pdaRun->fsm_cs = 52; goto out; 
	case 263: out263: pdaRun->fsm_cs = 263; goto out; 
	case 264: out264: if ( pdaRun->scan_eof ) {goto tr444;
}pdaRun->fsm_cs = 264; goto out; 
	case 5: out5: pdaRun->fsm_cs = 5; goto out; 
	case 265: out265: if ( pdaRun->scan_eof ) {goto tr446;
}pdaRun->fsm_cs = 265; goto out; 
	case 266: out266: if ( pdaRun->scan_eof ) {goto tr448;
}pdaRun->fsm_cs = 266; goto out; 
	case 6: out6: if ( pdaRun->scan_eof ) {goto tr8;
}pdaRun->fsm_cs = 6; goto out; 
	case 268: out268: if ( pdaRun->scan_eof ) {goto tr451;
}pdaRun->fsm_cs = 268; goto out; 
	case 269: out269: if ( pdaRun->scan_eof ) {goto tr453;
}pdaRun->fsm_cs = 269; goto out; 
	case 270: out270: if ( pdaRun->scan_eof ) {goto tr457;
}pdaRun->fsm_cs = 270; goto out; 
	case 271: out271: if ( pdaRun->scan_eof ) {goto tr459;
}pdaRun->fsm_cs = 271; goto out; 
	case 7: out7: pdaRun->fsm_cs = 7; goto out; 
	case 273: out273: if ( pdaRun->scan_eof ) {goto tr462;
}pdaRun->fsm_cs = 273; goto out; 
	case 274: out274: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 274; goto out; 
	case 272: out272: if ( pdaRun->scan_eof ) {goto tr461;
}pdaRun->fsm_cs = 272; goto out; 
	case 275: out275: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 275; goto out; 
	case 276: out276: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 276; goto out; 
	case 277: out277: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 277; goto out; 
	case 278: out278: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 278; goto out; 
	case 279: out279: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 279; goto out; 
	case 280: out280: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 280; goto out; 
	case 281: out281: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 281; goto out; 
	case 282: out282: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 282; goto out; 
	case 283: out283: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 283; goto out; 
	case 284: out284: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 284; goto out; 
	case 285: out285: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 285; goto out; 
	case 286: out286: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 286; goto out; 
	case 287: out287: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 287; goto out; 
	case 288: out288: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 288; goto out; 
	case 289: out289: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 289; goto out; 
	case 290: out290: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 290; goto out; 
	case 291: out291: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 291; goto out; 
	case 292: out292: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 292; goto out; 
	case 293: out293: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 293; goto out; 
	case 294: out294: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 294; goto out; 
	case 295: out295: if ( pdaRun->scan_eof ) {goto tr492;
}pdaRun->fsm_cs = 295; goto out; 
	case 296: out296: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 296; goto out; 
	case 297: out297: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 297; goto out; 
	case 298: out298: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 298; goto out; 
	case 299: out299: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 299; goto out; 
	case 300: out300: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 300; goto out; 
	case 301: out301: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 301; goto out; 
	case 302: out302: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 302; goto out; 
	case 303: out303: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 303; goto out; 
	case 304: out304: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 304; goto out; 
	case 305: out305: if ( pdaRun->scan_eof ) {goto tr503;
}pdaRun->fsm_cs = 305; goto out; 
	case 306: out306: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 306; goto out; 
	case 307: out307: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 307; goto out; 
	case 308: out308: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 308; goto out; 
	case 309: out309: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 309; goto out; 
	case 310: out310: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 310; goto out; 
	case 311: out311: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 311; goto out; 
	case 312: out312: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 312; goto out; 
	case 313: out313: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 313; goto out; 
	case 314: out314: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 314; goto out; 
	case 315: out315: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 315; goto out; 
	case 316: out316: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 316; goto out; 
	case 317: out317: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 317; goto out; 
	case 318: out318: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 318; goto out; 
	case 319: out319: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 319; goto out; 
	case 320: out320: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 320; goto out; 
	case 321: out321: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 321; goto out; 
	case 322: out322: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 322; goto out; 
	case 323: out323: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 323; goto out; 
	case 324: out324: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 324; goto out; 
	case 325: out325: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 325; goto out; 
	case 326: out326: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 326; goto out; 
	case 327: out327: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 327; goto out; 
	case 328: out328: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 328; goto out; 
	case 329: out329: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 329; goto out; 
	case 330: out330: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 330; goto out; 
	case 331: out331: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 331; goto out; 
	case 332: out332: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 332; goto out; 
	case 333: out333: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 333; goto out; 
	case 334: out334: if ( pdaRun->scan_eof ) {goto tr541;
}pdaRun->fsm_cs = 334; goto out; 
	case 335: out335: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 335; goto out; 
	case 336: out336: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 336; goto out; 
	case 337: out337: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 337; goto out; 
	case 338: out338: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 338; goto out; 
	case 339: out339: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 339; goto out; 
	case 340: out340: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 340; goto out; 
	case 341: out341: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 341; goto out; 
	case 342: out342: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 342; goto out; 
	case 343: out343: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 343; goto out; 
	case 344: out344: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 344; goto out; 
	case 345: out345: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 345; goto out; 
	case 346: out346: if ( pdaRun->scan_eof ) {goto tr558;
}pdaRun->fsm_cs = 346; goto out; 
	case 347: out347: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 347; goto out; 
	case 348: out348: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 348; goto out; 
	case 349: out349: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 349; goto out; 
	case 350: out350: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 350; goto out; 
	case 351: out351: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 351; goto out; 
	case 352: out352: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 352; goto out; 
	case 353: out353: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 353; goto out; 
	case 354: out354: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 354; goto out; 
	case 355: out355: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 355; goto out; 
	case 356: out356: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 356; goto out; 
	case 357: out357: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 357; goto out; 
	case 358: out358: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 358; goto out; 
	case 359: out359: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 359; goto out; 
	case 360: out360: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 360; goto out; 
	case 361: out361: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 361; goto out; 
	case 362: out362: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 362; goto out; 
	case 363: out363: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 363; goto out; 
	case 364: out364: if ( pdaRun->scan_eof ) {goto tr580;
}pdaRun->fsm_cs = 364; goto out; 
	case 365: out365: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 365; goto out; 
	case 366: out366: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 366; goto out; 
	case 367: out367: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 367; goto out; 
	case 368: out368: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 368; goto out; 
	case 369: out369: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 369; goto out; 
	case 370: out370: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 370; goto out; 
	case 371: out371: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 371; goto out; 
	case 372: out372: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 372; goto out; 
	case 373: out373: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 373; goto out; 
	case 374: out374: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 374; goto out; 
	case 375: out375: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 375; goto out; 
	case 376: out376: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 376; goto out; 
	case 377: out377: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 377; goto out; 
	case 378: out378: if ( pdaRun->scan_eof ) {goto tr598;
}pdaRun->fsm_cs = 378; goto out; 
	case 379: out379: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 379; goto out; 
	case 380: out380: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 380; goto out; 
	case 381: out381: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 381; goto out; 
	case 382: out382: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 382; goto out; 
	case 383: out383: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 383; goto out; 
	case 384: out384: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 384; goto out; 
	case 385: out385: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 385; goto out; 
	case 386: out386: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 386; goto out; 
	case 387: out387: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 387; goto out; 
	case 388: out388: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 388; goto out; 
	case 389: out389: if ( pdaRun->scan_eof ) {goto tr612;
}pdaRun->fsm_cs = 389; goto out; 
	case 390: out390: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 390; goto out; 
	case 391: out391: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 391; goto out; 
	case 392: out392: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 392; goto out; 
	case 393: out393: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 393; goto out; 
	case 394: out394: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 394; goto out; 
	case 395: out395: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 395; goto out; 
	case 396: out396: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 396; goto out; 
	case 397: out397: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 397; goto out; 
	case 398: out398: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 398; goto out; 
	case 399: out399: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 399; goto out; 
	case 400: out400: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 400; goto out; 
	case 401: out401: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 401; goto out; 
	case 402: out402: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 402; goto out; 
	case 403: out403: if ( pdaRun->scan_eof ) {goto tr629;
}pdaRun->fsm_cs = 403; goto out; 
	case 404: out404: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 404; goto out; 
	case 405: out405: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 405; goto out; 
	case 406: out406: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 406; goto out; 
	case 407: out407: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 407; goto out; 
	case 408: out408: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 408; goto out; 
	case 409: out409: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 409; goto out; 
	case 410: out410: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 410; goto out; 
	case 411: out411: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 411; goto out; 
	case 412: out412: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 412; goto out; 
	case 413: out413: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 413; goto out; 
	case 414: out414: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 414; goto out; 
	case 415: out415: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 415; goto out; 
	case 416: out416: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 416; goto out; 
	case 417: out417: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 417; goto out; 
	case 418: out418: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 418; goto out; 
	case 419: out419: if ( pdaRun->scan_eof ) {goto tr655;
}pdaRun->fsm_cs = 419; goto out; 
	case 420: out420: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 420; goto out; 
	case 421: out421: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 421; goto out; 
	case 422: out422: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 422; goto out; 
	case 423: out423: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 423; goto out; 
	case 424: out424: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 424; goto out; 
	case 425: out425: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 425; goto out; 
	case 426: out426: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 426; goto out; 
	case 427: out427: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 427; goto out; 
	case 428: out428: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 428; goto out; 
	case 429: out429: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 429; goto out; 
	case 430: out430: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 430; goto out; 
	case 431: out431: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 431; goto out; 
	case 432: out432: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 432; goto out; 
	case 433: out433: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 433; goto out; 
	case 434: out434: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 434; goto out; 
	case 435: out435: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 435; goto out; 
	case 436: out436: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 436; goto out; 
	case 437: out437: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 437; goto out; 
	case 438: out438: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 438; goto out; 
	case 439: out439: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 439; goto out; 
	case 440: out440: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 440; goto out; 
	case 441: out441: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 441; goto out; 
	case 442: out442: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 442; goto out; 
	case 443: out443: if ( pdaRun->scan_eof ) {goto tr682;
}pdaRun->fsm_cs = 443; goto out; 
	case 444: out444: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 444; goto out; 
	case 445: out445: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 445; goto out; 
	case 446: out446: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 446; goto out; 
	case 447: out447: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 447; goto out; 
	case 448: out448: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 448; goto out; 
	case 449: out449: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 449; goto out; 
	case 450: out450: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 450; goto out; 
	case 451: out451: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 451; goto out; 
	case 452: out452: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 452; goto out; 
	case 453: out453: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 453; goto out; 
	case 454: out454: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 454; goto out; 
	case 455: out455: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 455; goto out; 
	case 456: out456: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 456; goto out; 
	case 457: out457: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 457; goto out; 
	case 458: out458: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 458; goto out; 
	case 459: out459: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 459; goto out; 
	case 460: out460: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 460; goto out; 
	case 461: out461: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 461; goto out; 
	case 462: out462: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 462; goto out; 
	case 463: out463: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 463; goto out; 
	case 464: out464: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 464; goto out; 
	case 465: out465: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 465; goto out; 
	case 466: out466: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 466; goto out; 
	case 467: out467: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 467; goto out; 
	case 468: out468: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 468; goto out; 
	case 469: out469: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 469; goto out; 
	case 470: out470: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 470; goto out; 
	case 471: out471: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 471; goto out; 
	case 472: out472: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 472; goto out; 
	case 473: out473: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 473; goto out; 
	case 474: out474: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 474; goto out; 
	case 475: out475: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 475; goto out; 
	case 476: out476: if ( pdaRun->scan_eof ) {goto tr464;
}pdaRun->fsm_cs = 476; goto out; 
	case 477: out477: if ( pdaRun->scan_eof ) {goto tr719;
}pdaRun->fsm_cs = 477; goto out; 
	case 267: out267: if ( pdaRun->scan_eof ) {goto tr450;
}pdaRun->fsm_cs = 267; goto out; 
	case 478: out478: pdaRun->fsm_cs = 478; goto out; 
	case 479: out479: if ( pdaRun->scan_eof ) {goto tr722;
}pdaRun->fsm_cs = 479; goto out; 
	case 8: out8: pdaRun->fsm_cs = 8; goto out; 
	case 480: out480: pdaRun->fsm_cs = 480; goto out; 
	case 9: out9: if ( pdaRun->scan_eof ) {goto tr14;
}pdaRun->fsm_cs = 9; goto out; 
	case 481: out481: if ( pdaRun->scan_eof ) {goto tr728;
}pdaRun->fsm_cs = 481; goto out; 
	case 482: out482: pdaRun->fsm_cs = 482; goto out; 
	case 10: out10: if ( pdaRun->scan_eof ) {goto tr16;
}pdaRun->fsm_cs = 10; goto out; 
	case 483: out483: if ( pdaRun->scan_eof ) {goto tr734;
}pdaRun->fsm_cs = 483; goto out; 
	case 484: out484: pdaRun->fsm_cs = 484; goto out; 
	case 485: out485: pdaRun->fsm_cs = 485; goto out; 
	case 11: out11: if ( pdaRun->scan_eof ) {goto tr18;
}pdaRun->fsm_cs = 11; goto out; 
	case 486: out486: if ( pdaRun->scan_eof ) {goto tr739;
}pdaRun->fsm_cs = 486; goto out; 
	case 487: out487: pdaRun->fsm_cs = 487; goto out; 
	case 12: out12: if ( pdaRun->scan_eof ) {goto tr20;
}pdaRun->fsm_cs = 12; goto out; 
	case 488: out488: if ( pdaRun->scan_eof ) {goto tr743;
}pdaRun->fsm_cs = 488; goto out; 
	case 489: out489: pdaRun->fsm_cs = 489; goto out; 
	case 490: out490: pdaRun->fsm_cs = 490; goto out; 
	case 491: out491: if ( pdaRun->scan_eof ) {goto tr747;
}pdaRun->fsm_cs = 491; goto out; 
	case 492: out492: pdaRun->fsm_cs = 492; goto out; 
	case 493: out493: if ( pdaRun->scan_eof ) {goto tr750;
}pdaRun->fsm_cs = 493; goto out; 
	case 494: out494: pdaRun->fsm_cs = 494; goto out; 
	case 495: out495: pdaRun->fsm_cs = 495; goto out; 
	case 496: out496: if ( pdaRun->scan_eof ) {goto tr770;
}pdaRun->fsm_cs = 496; goto out; 
	case 13: out13: pdaRun->fsm_cs = 13; goto out; 
	case 497: out497: if ( pdaRun->scan_eof ) {goto tr771;
}pdaRun->fsm_cs = 497; goto out; 
	case 14: out14: pdaRun->fsm_cs = 14; goto out; 
	case 15: out15: pdaRun->fsm_cs = 15; goto out; 
	case 16: out16: pdaRun->fsm_cs = 16; goto out; 
	case 17: out17: pdaRun->fsm_cs = 17; goto out; 
	case 498: out498: if ( pdaRun->scan_eof ) {goto tr773;
}pdaRun->fsm_cs = 498; goto out; 
	case 499: out499: if ( pdaRun->scan_eof ) {goto tr775;
}pdaRun->fsm_cs = 499; goto out; 
	case 500: out500: if ( pdaRun->scan_eof ) {goto tr777;
}pdaRun->fsm_cs = 500; goto out; 
	case 501: out501: if ( pdaRun->scan_eof ) {goto tr779;
}pdaRun->fsm_cs = 501; goto out; 
	case 18: out18: if ( pdaRun->scan_eof ) {goto tr28;
}pdaRun->fsm_cs = 18; goto out; 
	case 503: out503: if ( pdaRun->scan_eof ) {goto tr781;
}pdaRun->fsm_cs = 503; goto out; 
	case 502: out502: if ( pdaRun->scan_eof ) {goto tr779;
}pdaRun->fsm_cs = 502; goto out; 
	case 19: out19: pdaRun->fsm_cs = 19; goto out; 
	case 504: out504: if ( pdaRun->scan_eof ) {goto tr782;
}pdaRun->fsm_cs = 504; goto out; 
	case 20: out20: pdaRun->fsm_cs = 20; goto out; 
	case 506: out506: if ( pdaRun->scan_eof ) {goto tr785;
}pdaRun->fsm_cs = 506; goto out; 
	case 505: out505: if ( pdaRun->scan_eof ) {goto tr784;
}pdaRun->fsm_cs = 505; goto out; 
	case 507: out507: pdaRun->fsm_cs = 507; goto out; 
	case 21: out21: pdaRun->fsm_cs = 21; goto out; 
	case 508: out508: if ( pdaRun->scan_eof ) {goto tr804;
}pdaRun->fsm_cs = 508; goto out; 
	case 22: out22: pdaRun->fsm_cs = 22; goto out; 
	case 23: out23: pdaRun->fsm_cs = 23; goto out; 
	case 24: out24: pdaRun->fsm_cs = 24; goto out; 
	case 509: out509: if ( pdaRun->scan_eof ) {goto tr806;
}pdaRun->fsm_cs = 509; goto out; 
	case 510: out510: if ( pdaRun->scan_eof ) {goto tr808;
}pdaRun->fsm_cs = 510; goto out; 
	case 511: out511: if ( pdaRun->scan_eof ) {goto tr810;
}pdaRun->fsm_cs = 511; goto out; 
	case 512: out512: if ( pdaRun->scan_eof ) {goto tr812;
}pdaRun->fsm_cs = 512; goto out; 
	case 25: out25: if ( pdaRun->scan_eof ) {goto tr37;
}pdaRun->fsm_cs = 25; goto out; 
	case 514: out514: if ( pdaRun->scan_eof ) {goto tr814;
}pdaRun->fsm_cs = 514; goto out; 
	case 513: out513: if ( pdaRun->scan_eof ) {goto tr812;
}pdaRun->fsm_cs = 513; goto out; 
	case 26: out26: pdaRun->fsm_cs = 26; goto out; 
	case 515: out515: if ( pdaRun->scan_eof ) {goto tr815;
}pdaRun->fsm_cs = 515; goto out; 
	case 27: out27: pdaRun->fsm_cs = 27; goto out; 
	case 517: out517: if ( pdaRun->scan_eof ) {goto tr818;
}pdaRun->fsm_cs = 517; goto out; 
	case 516: out516: if ( pdaRun->scan_eof ) {goto tr817;
}pdaRun->fsm_cs = 516; goto out; 
	case 518: out518: pdaRun->fsm_cs = 518; goto out; 
	case 519: out519: if ( pdaRun->scan_eof ) {goto tr821;
}pdaRun->fsm_cs = 519; goto out; 
	case 28: out28: pdaRun->fsm_cs = 28; goto out; 
	case 520: out520: pdaRun->fsm_cs = 520; goto out; 
	case 29: out29: pdaRun->fsm_cs = 29; goto out; 
	case 521: out521: pdaRun->fsm_cs = 521; goto out; 
	case 30: out30: pdaRun->fsm_cs = 30; goto out; 
	case 522: out522: pdaRun->fsm_cs = 522; goto out; 
	case 523: out523: pdaRun->fsm_cs = 523; goto out; 
	case 524: out524: if ( pdaRun->scan_eof ) {goto tr839;
}pdaRun->fsm_cs = 524; goto out; 
	case 525: out525: if ( pdaRun->scan_eof ) {goto tr840;
}pdaRun->fsm_cs = 525; goto out; 
	case 526: out526: if ( pdaRun->scan_eof ) {goto tr841;
}pdaRun->fsm_cs = 526; goto out; 
	case 32: out32: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 32; goto out; 
	case 31: out31: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 31; goto out; 
	case 527: out527: if ( pdaRun->scan_eof ) {goto tr840;
}pdaRun->fsm_cs = 527; goto out; 
	case 33: out33: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 33; goto out; 
	case 529: out529: if ( pdaRun->scan_eof ) {goto tr848;
}pdaRun->fsm_cs = 529; goto out; 
	case 528: out528: if ( pdaRun->scan_eof ) {goto tr847;
}pdaRun->fsm_cs = 528; goto out; 
	case 531: out531: if ( pdaRun->scan_eof ) {goto tr850;
}pdaRun->fsm_cs = 531; goto out; 
	case 530: out530: if ( pdaRun->scan_eof ) {goto tr849;
}pdaRun->fsm_cs = 530; goto out; 
	case 532: out532: if ( pdaRun->scan_eof ) {goto tr840;
}pdaRun->fsm_cs = 532; goto out; 
	case 35: out35: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 35; goto out; 
	case 34: out34: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 34; goto out; 
	case 533: out533: if ( pdaRun->scan_eof ) {goto tr840;
}pdaRun->fsm_cs = 533; goto out; 
	case 36: out36: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 36; goto out; 
	case 37: out37: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 37; goto out; 
	case 38: out38: if ( pdaRun->scan_eof ) {goto tr48;
}pdaRun->fsm_cs = 38; goto out; 
	case 534: out534: if ( pdaRun->scan_eof ) {goto tr840;
}pdaRun->fsm_cs = 534; goto out; 
	case 536: out536: if ( pdaRun->scan_eof ) {goto tr854;
}pdaRun->fsm_cs = 536; goto out; 
	case 535: out535: if ( pdaRun->scan_eof ) {goto tr853;
}pdaRun->fsm_cs = 535; goto out; 
	case 537: out537: if ( pdaRun->scan_eof ) {goto tr855;
}pdaRun->fsm_cs = 537; goto out; 
	case 538: out538: pdaRun->fsm_cs = 538; goto out; 
	case 539: out539: if ( pdaRun->scan_eof ) {goto tr866;
}pdaRun->fsm_cs = 539; goto out; 
	case 540: out540: if ( pdaRun->scan_eof ) {goto tr867;
}pdaRun->fsm_cs = 540; goto out; 
	case 541: out541: if ( pdaRun->scan_eof ) {goto tr868;
}pdaRun->fsm_cs = 541; goto out; 
	case 40: out40: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 40; goto out; 
	case 39: out39: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 39; goto out; 
	case 542: out542: if ( pdaRun->scan_eof ) {goto tr867;
}pdaRun->fsm_cs = 542; goto out; 
	case 41: out41: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 41; goto out; 
	case 544: out544: if ( pdaRun->scan_eof ) {goto tr875;
}pdaRun->fsm_cs = 544; goto out; 
	case 543: out543: if ( pdaRun->scan_eof ) {goto tr874;
}pdaRun->fsm_cs = 543; goto out; 
	case 546: out546: if ( pdaRun->scan_eof ) {goto tr877;
}pdaRun->fsm_cs = 546; goto out; 
	case 545: out545: if ( pdaRun->scan_eof ) {goto tr876;
}pdaRun->fsm_cs = 545; goto out; 
	case 547: out547: if ( pdaRun->scan_eof ) {goto tr867;
}pdaRun->fsm_cs = 547; goto out; 
	case 43: out43: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 43; goto out; 
	case 42: out42: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 42; goto out; 
	case 548: out548: if ( pdaRun->scan_eof ) {goto tr867;
}pdaRun->fsm_cs = 548; goto out; 
	case 44: out44: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 44; goto out; 
	case 45: out45: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 45; goto out; 
	case 46: out46: if ( pdaRun->scan_eof ) {goto tr60;
}pdaRun->fsm_cs = 46; goto out; 
	case 549: out549: if ( pdaRun->scan_eof ) {goto tr867;
}pdaRun->fsm_cs = 549; goto out; 
	case 551: out551: if ( pdaRun->scan_eof ) {goto tr881;
}pdaRun->fsm_cs = 551; goto out; 
	case 550: out550: if ( pdaRun->scan_eof ) {goto tr880;
}pdaRun->fsm_cs = 550; goto out; 
	case 552: out552: if ( pdaRun->scan_eof ) {goto tr882;
}pdaRun->fsm_cs = 552; goto out; 
	case 553: out553: pdaRun->fsm_cs = 553; goto out; 
	}
out:
	if ( pdaRun->p != 0 )
		pdaRun->tokpref += pdaRun->p - pdaRun->start;
skip_tokpref:
	{}
}

static void sendNamedLangEl( struct colm_program *prg, tree_t **tree,
		struct pda_run *pda_run, struct input_impl *input ) { }
static void initBindings( struct pda_run *pdaRun ) {}
static void popBinding( struct pda_run *pdaRun, parse_tree_t *tree ) {}


static int pid_0_parser_indices[] = {
	1142, 1142, 1142, 11, 1142, 1142, 1142, 1142, 
	1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 
	3, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 
	1142, 12, 837, 837, 1142, 1142, 1142, 1142, 
	1142, 95, 1142, 96, 1142, 1142, 1142, 1142, 
	837, 1142, 98, 1142, 1142, 1142, 103, 1011, 
	1142, 1011, 837, 1142, 1142, 1142, 1142, 1142, 
	107, 1142, 1142, 1142, 104, 100, 196, 133, 
	1142, 1142, 1142, 1142, 1142, 918, 200, 918, 
	179, 135, 8, 109, 916, 918, 1011, 184, 
	875, 71, 182, 918, 918, 8, 208, 916, 
	916, 918, 189, 918, 207, 911, 134, 865, 
	918, 866, 122, 916, 911, 190, 125, 918, 
	126, 188, 1142, 1142, 187, 915, 869, 915, 
	212, 214, 213, 221, 205, 222, 106, 907, 
	869, 233, 254, 915, 288, 261, 102, 260, 
	255, 11, 868, 256, 258, 257, 259, 295, 
	1042, 226, 1042, 226, 868, 317, 1011, 318, 
	1011, 908, 319, 289, 164, 165, 167, 166, 
	168, 932, 932, 932, 932, 323, 10, 321, 
	9, 290, 328, 329, 373, 1041, 1011, 96, 
	378, 946, 380, 161, 162, 163, 335, 0, 
	1142, 1142, 1142, 1142, 433, 945, 1142, 1142, 
	468, 1142, 1142, 1142, 1011, 379, 469, 480, 
	1142, 1142, 1142, 481, 1142, 1142, 1142, 1142, 
	438, 274, 275, 484, 1142, 114, 116, 118, 
	120, 1142, 197, 198, 199, 1142, 1142, 1142, 
	1142, 508, 1142, 1142, 274, 275, 1142, 513, 
	4, 918, 918, 5, 108, 2, 6, 7, 
	517, 874, 1011, 1142, 1142, 537, 99, 1138, 
	1138, 97, 7, 1011, 538, 918, 918, 101, 
	1142, 1142, 869, 869, 869, 567, 191, 192, 
	1042, 226, 1142, 1142, 918, 185, 11, 511, 
	1142, 916, 1144, 1144, 1144, 76, 868, 868, 
	868, 540, 541, 542, 916, 841, 512, 841, 
	918, 577, 1011, 842, 216, 842, 225, 843, 
	264, 843, 578, 1011, 1011, 1011, 1142, 1142, 
	371, 372, 370, 579, 915, 874, 895, 580, 
	186, 1011, 1, 576, 1142, 1142, 1142, 581, 
	1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 
	1142, 1142, 1142, 1142, 582, 1142, 1142, 1142, 
	1142, 1142, 1142, 1142, 1142, 193, 1011, 583, 
	1142, 1142, 1142, 1142, 1142, 584, 1142, 206, 
	1142, 1142, 1142, 1142, 1010, 1142, 1010, 1142, 
	1142, 1142, 590, 595, 1142, 76, 597, 1142, 
	1142, 1142, 1142, 1142, 856, 1142, 1142, 1142, 
	932, 932, 932, 596, 1142, 1142, 1142, 1142, 
	1142, 575, 194, 195, 114, 116, 118, 120, 
	933, 933, 933, 933, 206, 841, 841, 110, 
	177, 1011, 1154, 842, 842, 520, 1138, 843, 
	843, 1154, 1154, 956, 483, 855, 390, 860, 
	860, 860, 860, 860, 605, 598, 1142, 1142, 
	607, 10, 1144, 509, 113, 112, 201, 1102, 
	1103, 76, 523, 524, 525, 1154, 860, 860, 
	860, 944, 76, 1154, 220, 625, 634, 522, 
	526, 1019, 1019, 1019, 1019, 1019, 644, 74, 
	369, 523, 524, 525, 1019, 1019, 1019, 1019, 
	1019, 895, 224, 895, 131, 1011, 901, 526, 
	1019, 1019, 1019, 624, 841, 132, 1011, 650, 
	1154, 76, 842, 1019, 1019, 1019, 843, 667, 
	954, 124, 193, 76, 1142, 1142, 1142, 1142, 
	672, 1142, 1142, 1142, 124, 1142, 1142, 1142, 
	837, 586, 587, 588, 1142, 1142, 1142, 674, 
	1142, 1142, 1142, 1142, 130, 1011, 677, 676, 
	1142, 681, 687, 837, 678, 1142, 232, 1011, 
	695, 1142, 1142, 1142, 1142, 76, 1142, 1142, 
	698, 696, 1142, 697, 371, 372, 370, 716, 
	1154, 718, 918, 1035, 719, 1035, 722, 1142, 
	1142, 1019, 1019, 1019, 1019, 1019, 114, 116, 
	118, 120, 911, 723, 1142, 1142, 854, 727, 
	461, 1011, 729, 918, 730, 918, 1142, 1142, 
	1019, 1019, 1019, 918, 1142, 1154, 743, 1010, 
	858, 918, 918, 1138, 1138, 745, 1154, 859, 
	858, 124, 747, 1144, 1144, 1144, 1154, 859, 
	1154, 1137, 1137, 113, 112, 111, 750, 933, 
	933, 933, 1142, 1142, 1140, 1140, 1172, 1172, 
	1172, 1154, 1172, 3, 40, 41, 13, 38, 
	36, 39, 69, 70, 78, 81, 82, 79, 
	80, 87, 88, 180, 83, 84, 43, 65, 
	48, 49, 53, 51, 759, 860, 860, 861, 
	861, 861, 861, 861, 731, 45, 219, 60, 
	54, 55, 56, 204, 63, 755, 89, 61, 
	59, 11, 760, 50, 614, 612, 861, 861, 
	861, 86, 85, 764, 66, 68, 67, 1019, 
	1019, 209, 123, 92, 93, 94, 64, 75, 
	732, 765, 1019, 1019, 432, 127, 1019, 1019, 
	1019, 1019, 1019, 1019, 1019, 1019, 1019, 1019, 
	853, 766, 1144, 1144, 1144, 365, 366, 368, 
	853, 367, 371, 372, 370, 1019, 1019, 1019, 
	308, 310, 1019, 1019, 1019, 90, 91, 918, 
	918, 210, 675, 1139, 1139, -1, 124, 917, 
	725, 917, 1035, 124, 726, -1, 917, 917, 
	-1, 521, 1138, 1144, 1035, 917, 917, 918, 
	-1, 918, 8, 303, 916, -1, -1, 918, 
	1137, 215, 918, -1, -1, 918, 918, -1, 
	916, -1, 1172, 1140, -1, 113, 112, 250, 
	1143, 1143, 1143, 371, 372, 370, -1, 1019, 
	1019, -1, 128, 263, -1, -1, -1, 10, 
	-1, 9, 1172, 14, 34, 32, 62, -1, 
	-1, 31, 33, -1, 30, 29, 27, -1, 
	0, -1, -1, 44, 25, 26, -1, 42, 
	23, 37, 16, -1, 10, -1, 516, 35, 
	-1, 262, -1, 613, 24, -1, -1, -1, 
	20, 21, 22, 15, -1, 17, 18, -1, 
	-1, 19, -1, 197, 198, 199, 244, 246, 
	248, 242, 556, 558, 560, 554, 58, 28, 
	-1, 4, 1144, -1, 5, 108, 2, 6, 
	7, 363, 482, 47, 46, -1, -1, 99, 
	-1, -1, 97, 7, -1, 861, 77, -1, 
	101, 308, 310, 57, 364, -1, -1, 191, 
	192, -1, 1139, 917, 917, -1, 185, 1168, 
	1168, 1168, 314, 1168, 614, 615, 76, 304, 
	306, 302, 211, 918, 918, 5, 97, 7, 
	334, 52, 1011, -1, -1, 216, -1, 225, 
	-1, 264, -1, -1, 1019, 1019, 917, 129, 
	1143, 1019, 1019, 566, 183, 1144, 1144, 1144, 
	-1, 186, -1, 1, 71, -1, 918, -1, 
	-1, 916, 896, -1, 1142, 1154, 928, 928, 
	928, 928, 928, 928, 928, 928, 928, 928, 
	928, 928, 928, 928, 928, 928, 193, 928, 
	928, 928, 928, 928, 928, 928, 928, -1, 
	206, 1154, 928, 928, 928, 928, 928, 1154, 
	928, -1, 928, 928, 928, 928, 76, 928, 
	-1, 928, 928, 928, -1, -1, 928, -1, 
	1011, 928, 928, 928, 928, 928, -1, 928, 
	928, 928, -1, 194, 195, -1, 928, 928, 
	928, 928, 928, -1, -1, 206, -1, -1, 
	-1, 177, 928, 1160, 1160, 1160, 520, 1160, 
	-1, 1021, 1021, 1021, 1021, 483, -1, 390, 
	918, -1, 1042, 226, 382, -1, -1, 243, 
	241, 240, 10, 1168, 509, 113, 112, 201, 
	928, 928, 76, 613, 555, 553, 552, -1, 
	304, 306, 477, 76, 1042, 226, 1168, 164, 
	165, 167, 166, 168, -1, -1, 523, 524, 
	525, 369, 611, -1, 332, 1144, -1, -1, 
	-1, 1153, 467, 224, 526, 131, 161, 162, 
	163, 114, 116, 118, 120, 896, 132, 896, 
	223, 857, 76, -1, 838, 1153, -1, 1011, 
	371, 372, 370, 193, 76, 1153, -1, -1, 
	333, 1154, -1, 1153, -1, 389, 928, 928, 
	928, 928, -1, -1, 928, 928, 928, 928, 
	928, 928, 1154, -1, 1154, 130, 928, 928, 
	928, 928, 928, 928, 928, 928, -1, 232, 
	-1, -1, 928, -1, -1, 1154, 76, 928, 
	928, -1, -1, 928, 928, 928, 928, -1, 
	928, 928, -1, -1, 928, 114, 116, 118, 
	120, 164, 165, 167, 166, 168, -1, 1160, 
	-1, 928, 928, 1153, 1160, 200, -1, 76, 
	633, 461, 1042, 226, -1, 71, 928, 928, 
	161, 162, 163, -1, 917, -1, -1, -1, 
	928, 928, -1, 465, 464, 466, 928, -1, 
	-1, 1011, 640, -1, 918, 217, -1, -1, 
	381, -1, 600, 1011, 113, 112, 111, -1, 
	388, -1, 164, 165, 167, 166, 168, -1, 
	-1, -1, -1, -1, 928, 928, -1, 13, 
	1021, 1021, 1021, 1153, 164, 165, 167, 166, 
	168, 161, 162, 163, 180, 1153, -1, -1, 
	680, 475, -1, 875, 244, 246, 248, 242, 
	-1, -1, 1011, 161, 162, 163, 1153, 219, 
	1153, 467, 1021, 1021, 1021, 1021, 164, 165, 
	167, 166, 168, -1, 1011, 382, 1042, 226, 
	857, 1153, -1, 1042, 226, 234, 195, -1, 
	-1, -1, 209, 123, -1, 161, 162, 163, 
	113, 112, 251, -1, -1, 432, 127, -1, 
	365, 366, 431, -1, 430, -1, 1011, -1, 
	3, 40, 41, 345, 38, 36, 39, 69, 
	70, 78, 81, 82, 79, 80, 87, 88, 
	647, 83, 84, 43, 65, 48, 49, 53, 
	51, -1, 210, -1, 861, 861, 861, 861, 
	861, -1, 45, -1, 60, 54, 55, 56, 
	-1, 63, 521, 89, 61, 59, -1, -1, 
	50, 333, -1, 861, 861, 861, 86, 85, 
	-1, 66, 68, 67, 113, 112, 547, -1, 
	92, 93, 94, 64, 75, -1, 113, 112, 
	250, -1, 465, 606, 466, -1, -1, 235, 
	195, -1, -1, 128, 263, 628, 629, 627, 
	-1, -1, -1, -1, 14, 34, 32, 62, 
	-1, -1, 31, 33, 467, 30, 29, 27, 
	-1, -1, 90, 91, 44, 25, 26, 928, 
	42, 23, 37, 16, 662, 10, -1, 516, 
	35, 754, 262, -1, 613, 24, -1, -1, 
	-1, 20, 21, 22, 15, -1, 17, 18, 
	236, 195, 19, -1, -1, 243, 241, 474, 
	-1, 383, -1, -1, 428, 928, -1, 58, 
	28, -1, 237, 195, -1, 1021, 1021, 1021, 
	1021, -1, 363, 482, 47, 46, -1, 928, 
	382, 1021, 1021, 1021, 429, -1, -1, 76, 
	14, 34, 32, 62, 57, 364, 31, 33, 
	-1, 30, 29, 27, 238, 195, -1, -1, 
	44, 25, 26, 314, 42, 23, 37, 16, 
	304, 306, 302, 211, 35, -1, 5, 97, 
	7, 24, 52, -1, -1, 20, 21, 22, 
	15, -1, 17, 18, -1, 668, 19, 466, 
	129, 371, 372, 370, 566, 183, -1, 1144, 
	1144, 1144, -1, 58, 28, -1, -1, -1, 
	-1, 1021, 1021, 1021, 1021, -1, -1, -1, 
	47, 46, -1, -1, 382, -1, 928, -1, 
	-1, -1, 861, 77, 1144, 1144, 1144, -1, 
	57, 626, 360, -1, 1141, 1141, 1141, 1141, 
	1141, 1141, 1141, 1141, 1141, 1141, 1141, 1141, 
	1141, 1141, 1141, 1141, -1, 1141, 1141, 1141, 
	1141, 1141, 1141, 1141, 1141, -1, 52, 1011, 
	1141, 1141, 1141, 1141, 1141, -1, 1141, -1, 
	1141, 1141, 1141, 1141, -1, 1141, -1, 1141, 
	1141, 1141, -1, -1, 1141, -1, -1, 1141, 
	1141, 1141, 1141, 1141, -1, 1141, 1141, 1141, 
	-1, -1, -1, -1, 1141, 1141, 1141, 1141, 
	1141, -1, -1, 1167, 1167, 1167, -1, 1167, 
	243, 241, 240, -1, 387, 1079, 1079, 1079, 
	-1, 1079, -1, -1, 613, 555, 553, 552, 
	-1, 304, 306, 477, -1, -1, -1, 1021, 
	1021, 1021, -1, -1, -1, -1, 1141, 1141, 
	-1, 686, -1, -1, 1011, 332, -1, 1144, 
	-1, 164, 165, 167, 166, 168, 164, 165, 
	167, 166, 168, 164, 165, 167, 166, 168, 
	-1, 223, -1, 164, 165, 167, 166, 168, 
	161, 162, 163, -1, 1144, 161, 162, 163, 
	-1, 333, 161, 162, 163, -1, 389, 632, 
	-1, 1011, 161, 162, 163, -1, 1011, -1, 
	384, -1, -1, 1011, -1, -1, 1021, 1021, 
	1021, 1021, -1, 1011, 1141, 1141, 1141, 1141, 
	-1, 382, 1141, 1141, 639, 1141, 1141, 1141, 
	1021, 1021, 1021, -1, 1141, 1141, 1141, -1, 
	1141, 1141, 1141, 1141, -1, -1, -1, -1, 
	1141, 334, -1, -1, -1, 1141, 1011, -1, 
	1011, 1141, 1141, 1141, 1141, -1, 1141, 1141, 
	76, 633, 1141, 1021, 1021, 1021, 1021, 1167, 
	-1, -1, -1, -1, -1, 71, 382, 1141, 
	1141, 1079, -1, 896, 465, 464, 466, 1144, 
	1144, 1144, 1167, 640, 1141, 1141, 217, -1, 
	8, 381, 916, 600, 1079, -1, 1141, 1141, 
	910, 388, -1, -1, 1141, -1, 916, 910, 
	778, 778, 778, 778, 778, 778, 778, 778, 
	778, 778, 778, 778, 778, 778, 778, 778, 
	-1, 778, 778, 778, 778, 778, 778, 778, 
	778, 680, 1141, 1141, 778, 778, 778, 778, 
	778, -1, 778, 76, 778, 778, 778, 778, 
	-1, 778, -1, 778, 778, 778, -1, -1, 
	778, -1, -1, 778, 778, 778, 778, 778, 
	-1, 778, 778, 778, -1, -1, 234, 195, 
	778, 778, 778, 778, 778, -1, 715, 1011, 
	-1, 113, 112, 251, -1, -1, -1, 239, 
	195, 1144, 1144, 1144, 297, 195, -1, 1148, 
	-1, 298, 195, -1, 345, 385, -1, -1, 
	837, 315, 195, 1018, 1018, 1018, 1018, 1018, 
	-1, 647, 778, 778, -1, 344, -1, -1, 
	1148, 1148, 1148, 1148, 1148, 1021, 1021, 1021, 
	-1, -1, 1018, 1018, 1018, -1, 896, 1144, 
	896, -1, -1, -1, -1, 649, -1, 1148, 
	1148, 1148, 333, 1018, 97, 7, -1, 648, 
	-1, 333, 386, -1, -1, 113, 112, 547, 
	1148, -1, -1, 574, -1, 1036, 571, 572, 
	573, -1, 568, 465, 606, 466, -1, 646, 
	235, 195, 1021, 1021, 1021, -1, -1, 916, 
	778, 778, 778, 778, -1, -1, 778, 778, 
	-1, 778, 778, 778, -1, -1, -1, -1, 
	778, 778, 778, -1, 778, 778, 778, 778, 
	-1, -1, -1, -1, 778, 662, -1, -1, 
	-1, 778, 754, -1, -1, 778, 778, 778, 
	778, -1, 778, 778, -1, 1141, 778, -1, 
	-1, 236, 195, -1, -1, -1, 243, 241, 
	474, 1144, 383, 778, 778, 428, 1168, 1168, 
	1168, -1, 1168, 237, 195, -1, -1, -1, 
	778, 778, -1, -1, -1, 1159, 1159, 1159, 
	-1, 1159, 778, 778, -1, 429, -1, -1, 
	778, 14, 34, 32, 62, -1, -1, 31, 
	33, 661, 30, 29, 27, 238, 195, -1, 
	-1, 44, 25, 26, -1, 42, 23, 37, 
	16, 1148, 1148, -1, 1148, 35, 778, 778, 
	-1, -1, 24, -1, -1, -1, 20, 21, 
	22, 15, -1, 17, 18, -1, 668, 19, 
	466, -1, 1162, -1, 1162, 1162, 1162, 1162, 
	-1, 1162, -1, -1, 58, 28, 1017, -1, 
	1017, 1018, 1018, -1, -1, 1017, 1017, -1, 
	-1, 47, 46, -1, 1017, 1017, 1148, 1148, 
	337, 339, 1036, -1, 76, -1, 340, -1, 
	570, 57, 626, 360, 1036, 569, -1, 338, 
	-1, -1, -1, -1, 1141, -1, -1, 779, 
	779, 779, 779, 779, 779, 779, 779, 779, 
	779, 779, 779, 779, 779, 779, 779, 52, 
	779, 779, 779, 779, 779, 779, 779, 779, 
	-1, 253, 1168, 779, 779, 779, 779, 779, 
	-1, 779, -1, 779, 779, 779, 779, -1, 
	779, 1159, 779, 779, 779, 1168, 1159, 779, 
	-1, -1, 779, 779, 779, 779, 779, -1, 
	779, 779, 779, 371, 372, 370, -1, 779, 
	779, 779, 779, 779, -1, 387, -1, -1, 
	-1, 353, 354, 355, 352, -1, -1, 631, 
	-1, 359, 1171, 1171, 1171, 910, 1171, 350, 
	-1, 357, 358, -1, -1, -1, -1, -1, 
	-1, -1, 686, 164, 165, 167, 166, 168, 
	-1, 779, 779, -1, 371, 372, 370, -1, 
	-1, -1, 1017, 1017, -1, -1, -1, -1, 
	-1, 778, 161, 162, 163, -1, -1, 1092, 
	1092, 1092, -1, 1092, 860, 860, 860, 860, 
	860, 1162, -1, 1011, -1, -1, -1, 1162, 
	632, -1, -1, 1162, 1162, 1017, 341, -1, 
	-1, 384, -1, 860, 860, 860, 1093, 1093, 
	1093, 1011, 1093, 1011, 735, 736, 737, 365, 
	366, 565, -1, 564, 860, 639, -1, 779, 
	779, 779, 779, -1, -1, 779, 779, -1, 
	779, 779, 779, 371, 372, 370, -1, 779, 
	779, 779, 391, 779, 779, 779, 779, -1, 
	1164, 1164, 1164, 779, 1164, 1163, 1163, 1163, 
	779, 1163, -1, 694, 779, 779, 779, 779, 
	-1, 779, 779, -1, -1, 779, -1, -1, 
	-1, 1020, 1020, 1020, 1020, -1, -1, -1, 
	-1, -1, 779, 779, -1, -1, 1171, -1, 
	1049, 1049, 1049, -1, 1049, -1, -1, 779, 
	779, 346, -1, 347, 348, 349, 356, 360, 
	351, 779, 779, -1, 721, -1, 1171, 779, 
	778, -1, -1, 780, 780, 780, 780, 780, 
	780, 780, 780, 780, 780, 780, 780, 780, 
	780, 780, 780, 1092, 780, 780, 780, 780, 
	780, 780, 780, 780, 76, 779, 779, 780, 
	780, 780, 780, 780, -1, 780, -1, 780, 
	780, 780, 780, 1092, 780, -1, 780, 780, 
	780, -1, 1093, 780, -1, -1, 780, 780, 
	780, 780, 780, 562, 780, 780, 780, 715, 
	563, 420, 195, 780, 780, 780, 780, 780, 
	239, 195, 1093, 763, -1, 297, 195, -1, 
	-1, -1, 298, 195, -1, -1, 385, -1, 
	734, -1, 315, 195, 1164, -1, -1, -1, 
	-1, 1163, 860, 860, -1, -1, 344, -1, 
	-1, -1, 1164, -1, -1, 780, 780, 1163, 
	-1, -1, 1156, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 649, -1, 
	1156, 1156, 1156, 1156, 1049, 97, 7, -1, 
	648, 1049, 333, 386, -1, -1, -1, 638, 
	1156, 1156, 1156, -1, -1, -1, 1156, 353, 
	354, 355, 352, 1156, -1, -1, -1, 359, 
	646, 1156, 1156, 1017, 1017, 350, -1, 357, 
	358, -1, -1, 1020, 1020, 1020, -1, 1156, 
	1020, 1020, 1020, 780, 780, 780, 780, -1, 
	-1, 780, 780, -1, 780, 780, 780, -1, 
	1156, -1, -1, 780, 780, 780, -1, 780, 
	780, 780, 780, -1, -1, -1, -1, 780, 
	-1, -1, -1, -1, 780, 1156, 1156, -1, 
	780, 780, 780, 780, -1, 780, 780, -1, 
	779, 780, -1, -1, -1, 1160, 1160, 1160, 
	-1, 1160, -1, 1017, -1, 1017, 780, 780, 
	-1, -1, 1017, 1017, -1, -1, 328, -1, 
	-1, 1017, 1017, 780, 780, 337, 339, -1, 
	1080, 1080, 1080, 340, 1080, 780, 780, -1, 
	-1, -1, 661, 780, 338, -1, -1, 781, 
	781, 781, 781, 781, 781, 781, 781, 781, 
	781, 781, 781, 781, 781, 781, 781, -1, 
	781, 781, 781, 781, 781, 781, 781, 781, 
	-1, 780, 780, 781, 781, 781, 781, 781, 
	-1, 781, -1, 781, 781, 781, 781, -1, 
	781, -1, 781, 781, 781, -1, -1, 781, 
	-1, -1, 781, 781, 781, 781, 781, -1, 
	781, 781, 781, 519, 356, 360, 351, 781, 
	781, 781, 781, 781, -1, -1, 1156, 1156, 
	-1, 570, -1, -1, -1, -1, 569, 1156, 
	1156, 299, -1, 1156, 1156, -1, 164, 165, 
	167, 166, 168, -1, -1, -1, 1156, 779, 
	-1, -1, -1, 1156, 1050, 1050, 1050, -1, 
	1050, 781, 781, -1, -1, 161, 162, 163, 
	-1, 1160, 253, -1, -1, -1, 1160, 1017, 
	1017, 164, 165, 167, 166, 168, 1011, -1, 
	-1, 1156, 1156, 114, 116, 118, 120, -1, 
	-1, -1, -1, -1, 1080, -1, -1, -1, 
	161, 162, 163, -1, 300, 164, 165, 167, 
	166, 168, 1017, 336, -1, -1, -1, 1080, 
	-1, 1011, 645, -1, -1, -1, -1, -1, 
	631, -1, -1, -1, 161, 162, 163, 781, 
	781, 781, 781, -1, -1, 781, 781, -1, 
	781, 781, 781, -1, -1, 1011, -1, 781, 
	781, 781, -1, 781, 781, 781, 781, -1, 
	1066, 1066, 1066, 781, 1066, 1067, 1067, 1067, 
	781, 1067, -1, -1, 781, 781, 781, 781, 
	-1, 781, 781, -1, 780, 781, -1, 114, 
	116, 118, 120, -1, -1, -1, -1, -1, 
	-1, -1, 781, 781, -1, -1, 912, 341, 
	912, -1, -1, -1, -1, 912, 912, 781, 
	781, -1, -1, -1, 912, 912, -1, -1, 
	1050, 781, 781, -1, -1, 1050, -1, 781, 
	-1, -1, -1, 782, 782, 782, 782, 782, 
	782, 782, 782, 782, 782, 782, 782, 782, 
	782, 782, 782, 391, 782, 782, 782, 782, 
	782, 782, 782, 782, -1, 781, 781, 782, 
	782, 782, 782, 782, 694, 782, -1, 782, 
	782, 782, 782, -1, 782, -1, 782, 782, 
	782, -1, -1, 782, 421, 195, 782, 782, 
	782, 782, 782, -1, 782, 782, 782, 1144, 
	1144, 1144, -1, 782, 782, 782, 782, 782, 
	-1, -1, 346, -1, 347, 348, 349, 356, 
	360, 351, 113, 112, 548, 721, -1, 422, 
	195, 365, 366, 431, 1066, 430, -1, -1, 
	-1, 1067, -1, 780, -1, 164, 165, 167, 
	166, 168, 1066, -1, -1, 782, 782, 1067, 
	-1, -1, -1, 423, 195, -1, -1, 164, 
	165, 167, 166, 168, 161, 162, 163, -1, 
	-1, -1, 912, 912, -1, -1, -1, -1, 
	114, 116, 118, 120, -1, 1011, 161, 162, 
	163, -1, -1, -1, 562, -1, -1, -1, 
	-1, 563, 420, 195, -1, -1, -1, 1011, 
	-1, -1, -1, -1, 763, 912, -1, -1, 
	1017, 1017, -1, -1, -1, -1, 113, 112, 
	549, 734, -1, 782, 782, 782, 782, -1, 
	-1, 782, 782, -1, 782, 782, 782, 114, 
	116, 118, 120, 782, 782, 782, -1, 782, 
	782, 782, 782, -1, -1, -1, -1, 782, 
	-1, -1, -1, -1, 782, -1, -1, 1144, 
	782, 782, 782, 782, -1, 782, 782, -1, 
	781, 782, -1, -1, 913, -1, 913, -1, 
	638, -1, -1, 913, 913, -1, 782, 782, 
	-1, -1, 913, 913, -1, 720, 365, 366, 
	685, -1, 684, 782, 782, -1, -1, 753, 
	-1, -1, -1, -1, -1, 782, 782, -1, 
	-1, -1, -1, 782, -1, 429, -1, 783, 
	783, 783, 783, 783, 783, 783, 783, 783, 
	783, 783, 783, 783, 783, 783, 783, -1, 
	783, 783, 783, 783, 783, 783, 783, 783, 
	-1, 782, 782, 783, 783, 783, 783, 783, 
	-1, 783, -1, 783, 783, 783, 783, -1, 
	783, -1, 783, 783, 783, -1, -1, 783, 
	-1, -1, 783, 783, 783, 783, 783, -1, 
	783, 783, 783, 424, 195, -1, -1, 783, 
	783, 783, 783, 783, -1, -1, -1, -1, 
	1172, 1172, 1172, -1, 1172, 425, 195, 113, 
	112, 550, -1, -1, -1, -1, 164, 165, 
	167, 166, 168, -1, -1, -1, -1, 781, 
	-1, 164, 165, 167, 166, 168, -1, -1, 
	-1, 783, 783, -1, -1, 161, 162, 163, 
	913, 913, -1, 164, 165, 167, 166, 168, 
	161, 162, 163, -1, -1, -1, 1011, -1, 
	-1, -1, 682, -1, -1, -1, 113, 112, 
	551, 1011, 161, 162, 163, -1, -1, -1, 
	683, -1, -1, 913, 519, 356, 360, 351, 
	-1, -1, -1, 1011, -1, -1, -1, 1162, 
	-1, 1162, 1162, 1162, 1162, 244, 246, 248, 
	242, -1, 299, 912, 912, -1, -1, 783, 
	783, 783, 783, -1, -1, 783, 783, -1, 
	783, 783, 783, -1, -1, -1, -1, 783, 
	783, 783, -1, 783, 783, 783, 783, -1, 
	-1, -1, -1, 783, 1162, -1, -1, -1, 
	783, -1, -1, -1, 783, 783, 783, 783, 
	-1, 783, 783, -1, 782, 783, -1, 365, 
	366, 565, -1, 564, 1172, -1, -1, 1017, 
	-1, 1017, 783, 783, -1, 300, 1017, 1017, 
	-1, -1, -1, -1, 336, 1017, 1017, 783, 
	783, 337, 339, 645, 1172, -1, -1, 340, 
	-1, 783, 783, -1, -1, -1, -1, 783, 
	338, -1, -1, 784, 784, 784, 784, 784, 
	784, 784, 784, 784, 784, 784, 784, 784, 
	784, 784, 784, 660, 784, 784, 784, 784, 
	784, 784, 784, 784, -1, 783, 783, 784, 
	784, 784, 784, 784, -1, 784, -1, 784, 
	784, 784, 784, -1, 784, -1, 784, 784, 
	784, -1, -1, 784, 426, 195, 784, 784, 
	784, 784, 784, -1, 784, 784, 784, 427, 
	195, -1, -1, 784, 784, 784, 784, 784, 
	-1, -1, -1, -1, -1, 353, 354, 355, 
	352, 656, 195, -1, -1, 359, 1162, -1, 
	-1, -1, -1, 350, 1162, 357, 358, 902, 
	1162, 1162, -1, 782, -1, -1, 243, 241, 
	670, -1, -1, -1, -1, 784, 784, -1, 
	365, 366, 368, 693, 367, -1, -1, -1, 
	563, -1, -1, 1017, 1017, -1, -1, -1, 
	-1, -1, 1161, -1, 1161, 1161, 1161, 1161, 
	-1, 1161, -1, -1, -1, 421, 195, 643, 
	1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 
	1150, 1150, 1150, 1150, 1150, 1150, 1017, 510, 
	-1, 913, 913, 1045, -1, 1045, 1045, 1045, 
	1045, -1, 1045, 113, 112, 548, 361, 1161, 
	422, 195, -1, 784, 784, 784, 784, -1, 
	-1, 784, 784, -1, 784, 784, 784, -1, 
	-1, -1, -1, 784, 784, 784, -1, 784, 
	784, 784, 784, 1150, 423, 195, -1, 784, 
	1045, -1, -1, -1, 784, -1, -1, -1, 
	784, 784, 784, 784, -1, 784, 784, -1, 
	783, 784, -1, -1, 1110, 1110, 1110, 1110, 
	531, 1108, 1108, 1108, 1110, 1108, 784, 784, 
	-1, -1, 1110, -1, 1110, 1110, 1108, 1108, 
	528, 529, 530, 784, 784, 362, -1, 347, 
	348, 349, 356, 360, 351, 784, 784, 113, 
	112, 549, -1, 784, 679, -1, -1, 785, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	785, 785, 785, 785, 785, 785, 785, 364, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	-1, 784, 784, 785, 785, 785, 785, 785, 
	-1, 785, 651, 785, 785, 785, 785, -1, 
	785, -1, 785, 785, 785, -1, -1, 785, 
	-1, 1161, 785, 785, 785, 785, 785, 1161, 
	785, 785, 785, 1161, 1161, -1, 720, 785, 
	785, 785, 785, 785, -1, -1, -1, -1, 
	753, 353, 354, 355, 352, -1, -1, -1, 
	-1, 359, 1045, -1, -1, -1, 429, 350, 
	1045, 357, 358, -1, 1045, 1045, -1, 783, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 785, 785, -1, -1, -1, 1155, 1155, 
	1155, 1155, 1155, 1155, 1155, 1155, 1155, 1155, 
	1155, 1155, -1, -1, 1155, 1155, 1155, 1155, 
	-1, -1, -1, -1, -1, 527, -1, 1110, 
	1110, 1110, 1110, 1110, 1155, 1155, 1155, -1, 
	-1, -1, 1155, -1, 424, 195, -1, 1155, 
	-1, -1, -1, -1, -1, 1155, 1155, -1, 
	-1, -1, -1, -1, 1017, 1017, 425, 195, 
	113, 112, 550, 1155, -1, -1, -1, 785, 
	785, 785, 785, -1, -1, 785, 785, -1, 
	785, 785, 785, -1, 1155, -1, -1, 785, 
	785, 785, -1, 785, 785, 785, 785, -1, 
	-1, -1, -1, 785, -1, -1, -1, -1, 
	785, 1155, 1155, -1, 785, 785, 785, 785, 
	-1, 785, 785, 682, 784, 785, -1, 113, 
	112, 551, -1, -1, -1, 914, -1, 914, 
	-1, 683, 785, 785, 914, 914, -1, -1, 
	-1, -1, -1, 914, 914, -1, -1, 785, 
	785, -1, -1, 616, 348, 349, 356, 360, 
	351, 785, 785, -1, -1, -1, -1, 785, 
	-1, -1, -1, 786, 786, 786, 786, 786, 
	786, 786, 786, 786, 786, 786, 786, 786, 
	786, 786, 786, -1, 786, 786, 786, 786, 
	786, 786, 786, 786, -1, 785, 785, 786, 
	786, 786, 786, 786, -1, 786, -1, 786, 
	786, 786, 786, -1, 786, -1, 786, 786, 
	786, -1, -1, 786, -1, -1, 786, 786, 
	786, 786, 786, -1, 786, 786, 786, -1, 
	-1, -1, -1, 786, 786, 786, 786, 786, 
	-1, -1, 1155, 1155, -1, 353, 354, 355, 
	352, -1, -1, 1155, 1155, 359, -1, 1155, 
	1155, -1, -1, 350, -1, 357, 358, -1, 
	-1, -1, 1155, 784, -1, -1, -1, 1155, 
	-1, -1, -1, -1, 660, 786, 786, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 914, 914, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, 1155, 1155, -1, 
	-1, -1, -1, -1, -1, 426, 195, -1, 
	-1, -1, 161, 162, 163, -1, -1, -1, 
	427, 195, -1, -1, 914, -1, -1, -1, 
	-1, -1, -1, 1011, -1, -1, -1, -1, 
	-1, -1, 656, 195, -1, -1, -1, -1, 
	-1, -1, -1, 786, 786, 786, 786, -1, 
	-1, 786, 786, -1, 786, 786, 786, 243, 
	241, 670, -1, 786, 786, 786, -1, 786, 
	786, 786, 786, -1, 693, -1, -1, 786, 
	-1, 563, -1, -1, 786, -1, -1, -1, 
	786, 786, 786, 786, -1, 786, 786, -1, 
	785, 786, 1109, 1109, 1109, 1109, -1, -1, 
	643, -1, 1109, -1, -1, -1, 786, 786, 
	1109, -1, 1109, 1109, -1, -1, -1, -1, 
	510, -1, -1, 786, 786, 518, -1, 347, 
	348, 349, 356, 360, 351, 786, 786, 361, 
	-1, -1, -1, 786, -1, -1, -1, 787, 
	787, 787, 787, 787, 787, 787, 787, 787, 
	787, 787, 787, 787, 787, 787, 787, -1, 
	787, 787, 787, 787, 787, 787, 787, 787, 
	-1, 786, 786, 787, 787, 787, 787, 787, 
	-1, 787, -1, 787, 787, 787, 787, -1, 
	787, -1, 787, 787, 787, -1, -1, 787, 
	-1, -1, 787, 787, 787, 787, 787, -1, 
	787, 787, 787, -1, -1, -1, -1, 787, 
	787, 787, 787, 787, -1, -1, 362, -1, 
	347, 348, 349, 356, 360, 351, -1, -1, 
	-1, 657, 195, -1, -1, 679, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 785, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	364, 787, 787, -1, -1, -1, 1156, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, -1, 651, 1156, 1156, 1156, 1156, 
	-1, -1, -1, -1, -1, 1109, 1109, 1109, 
	1109, 1109, -1, -1, 1156, 1156, 1156, -1, 
	-1, -1, 1156, -1, -1, -1, -1, 1156, 
	-1, -1, -1, -1, -1, 1156, 1156, -1, 
	-1, -1, 914, 914, -1, -1, -1, -1, 
	-1, -1, -1, 1156, -1, -1, -1, 787, 
	787, 787, 787, -1, -1, 787, 787, -1, 
	787, 787, 787, -1, 1156, -1, -1, 787, 
	787, 787, -1, 787, 787, 787, 787, -1, 
	-1, 1147, -1, 787, -1, -1, -1, -1, 
	787, 1156, 1156, -1, 787, 787, 787, 787, 
	-1, 787, 787, -1, 786, 787, 527, -1, 
	-1, -1, 1147, 1147, 1147, 1147, 1147, -1, 
	-1, -1, 787, 787, -1, -1, 353, 354, 
	355, 352, -1, -1, -1, -1, 359, 787, 
	787, 1147, 1147, 1147, 350, -1, 357, 358, 
	-1, 787, 787, -1, -1, -1, -1, 787, 
	-1, -1, 1147, 788, 788, 788, 788, 788, 
	788, 788, 788, 788, 788, 788, 788, 788, 
	788, 788, 788, -1, 788, 788, 788, 788, 
	788, 788, 788, 788, -1, 787, 787, 788, 
	788, 788, 788, 788, -1, 788, -1, 788, 
	788, 788, 788, -1, 788, -1, 788, 788, 
	788, -1, -1, 788, -1, -1, 788, 788, 
	788, 788, 788, -1, 788, 788, 788, -1, 
	-1, -1, -1, 788, 788, 788, 788, 788, 
	-1, -1, 1156, 1156, 616, 348, 349, 356, 
	360, 351, -1, 1156, 1156, 440, -1, 1156, 
	1156, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1156, 786, -1, -1, -1, 1156, 
	-1, -1, -1, -1, -1, 788, 788, 713, 
	699, 701, 703, 704, 702, 706, 707, 709, 
	708, 710, 712, 711, 705, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1156, 1156, -1, 
	-1, -1, -1, 1147, 1147, -1, 1147, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	300, 623, 349, 356, 360, 351, -1, 1046, 
	-1, 1046, 1046, 1046, 1046, -1, 1046, -1, 
	-1, -1, 700, -1, -1, -1, -1, -1, 
	-1, -1, -1, 788, 788, 788, 788, -1, 
	-1, 788, 788, -1, 788, 788, 788, -1, 
	1147, 1147, -1, 788, 788, 788, -1, 788, 
	788, 788, 788, -1, 1046, 815, -1, 788, 
	-1, -1, -1, -1, 788, -1, -1, -1, 
	788, 788, 788, 788, -1, 788, 788, -1, 
	787, 788, -1, -1, -1, -1, 815, 815, 
	815, 815, 815, -1, -1, -1, 788, 788, 
	-1, -1, 353, 354, 355, 352, -1, -1, 
	-1, -1, 359, 788, 788, 815, 815, 815, 
	350, -1, 357, 358, -1, 788, 788, -1, 
	-1, -1, -1, 788, -1, -1, 815, 789, 
	789, 789, 789, 789, 789, 789, 789, 789, 
	789, 789, 789, 789, 789, 789, 789, -1, 
	789, 789, 789, 789, 789, 789, 789, 789, 
	-1, 788, 788, 789, 789, 789, 789, 789, 
	-1, 789, -1, 789, 789, 789, 789, -1, 
	789, -1, 789, 789, 789, -1, -1, 789, 
	-1, -1, 789, 789, 789, 789, 789, -1, 
	789, 789, 789, -1, -1, -1, -1, 789, 
	789, 789, 789, 789, -1, -1, 518, -1, 
	347, 348, 349, 356, 360, 351, 1046, -1, 
	-1, -1, -1, -1, 1046, -1, -1, -1, 
	1046, 1046, -1, -1, -1, -1, -1, 787, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 789, 789, 1149, 1149, 1149, 1149, 1149, 
	1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 
	1149, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 
	1150, 1150, 1150, 1150, 1150, 1150, 1150, 815, 
	815, -1, 815, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 617, 348, 349, 356, 
	360, 351, -1, -1, -1, 1047, -1, 1047, 
	1047, 1047, 1047, -1, 1047, -1, 1149, -1, 
	-1, -1, 657, 195, -1, -1, -1, 789, 
	789, 789, 789, -1, 1150, 789, 789, -1, 
	789, 789, 789, -1, 815, 815, -1, 789, 
	789, 789, -1, 789, 789, 789, 789, -1, 
	-1, 816, 1047, 789, -1, -1, -1, -1, 
	789, -1, -1, -1, 789, 789, 789, 789, 
	-1, 789, 789, -1, 788, 789, -1, -1, 
	-1, -1, 816, 816, 816, 816, 816, -1, 
	-1, -1, 789, 789, -1, -1, 353, 354, 
	355, 352, -1, -1, -1, -1, 359, 789, 
	789, 816, 816, 816, 350, -1, 357, 358, 
	-1, 789, 789, -1, -1, -1, -1, 789, 
	-1, -1, 816, 790, 790, 790, 790, 790, 
	790, 790, 790, 790, 790, 790, 790, 790, 
	790, 790, 790, 741, 790, 790, 790, 790, 
	790, 790, 790, 790, -1, 789, 789, 790, 
	790, 790, 790, 790, -1, 790, -1, 790, 
	790, 790, 790, -1, 790, -1, 790, 790, 
	790, -1, -1, 790, -1, -1, 790, 790, 
	790, 790, 790, -1, 790, 790, 790, -1, 
	-1, -1, -1, 790, 790, 790, 790, 790, 
	-1, -1, -1, 353, 354, 355, 352, -1, 
	-1, -1, -1, 359, 1047, -1, -1, -1, 
	-1, 350, 1047, 357, 358, -1, 1047, 1047, 
	-1, -1, -1, 788, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 790, 790, 881, 
	881, 881, 881, 881, 881, 881, 881, 881, 
	881, 881, 881, 881, 881, 882, 882, 882, 
	882, 882, 882, 882, 882, 882, 882, 882, 
	882, 882, 882, 816, 816, -1, 816, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	618, 348, 349, 356, 360, 351, -1, -1, 
	-1, 353, 354, 355, 352, -1, -1, -1, 
	-1, 359, 881, -1, -1, -1, 440, 350, 
	-1, 357, 358, 790, 790, 790, 790, -1, 
	882, 790, 790, -1, 790, 790, 790, -1, 
	816, 816, -1, 790, 790, 790, -1, 790, 
	790, 790, 790, -1, 1164, 1164, 1164, 790, 
	1164, -1, -1, -1, 790, -1, -1, -1, 
	790, 790, 790, 790, -1, 790, 790, -1, 
	789, 790, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 790, 790, 
	-1, 300, 623, 349, 356, 360, 351, -1, 
	-1, -1, -1, 790, 790, 619, 348, 349, 
	356, 360, 351, 700, -1, 790, 790, -1, 
	-1, -1, -1, 790, -1, -1, -1, 791, 
	791, 791, 791, 791, 791, 791, 791, 791, 
	791, 791, 791, 791, 791, 791, 791, -1, 
	791, 791, 791, 791, 791, 791, 791, 791, 
	-1, 790, 790, 791, 791, 791, 791, 791, 
	-1, 791, -1, 791, 791, 791, 791, -1, 
	791, -1, 791, 791, 791, -1, -1, 791, 
	-1, -1, 791, 791, 791, 791, 791, -1, 
	791, 791, 791, -1, -1, -1, -1, 791, 
	791, 791, 791, 791, 620, 349, 356, 360, 
	351, 353, 354, 355, 352, -1, -1, -1, 
	-1, 359, -1, -1, -1, -1, -1, 350, 
	1164, 357, 358, 902, -1, -1, -1, 789, 
	-1, -1, -1, -1, -1, -1, 1164, -1, 
	-1, 791, 791, -1, -1, -1, 1156, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, -1, -1, 1156, 1156, 1156, 1156, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 752, 1156, 1156, 1156, -1, 
	-1, -1, 1156, -1, -1, -1, -1, 1156, 
	-1, -1, -1, -1, -1, 1156, 1156, 1048, 
	-1, 1048, 1048, 1048, 1048, -1, 1048, -1, 
	-1, -1, 610, 1156, -1, -1, -1, 791, 
	791, 791, 791, -1, -1, 791, 791, -1, 
	791, 791, 791, -1, 1156, -1, -1, 791, 
	791, 791, -1, 791, 791, 791, 791, -1, 
	-1, -1, -1, 791, 1048, -1, -1, -1, 
	791, 1156, 1156, -1, 791, 791, 791, 791, 
	-1, 791, 791, -1, 790, 791, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 791, 791, -1, 617, 348, 349, 
	356, 360, 351, -1, -1, -1, -1, 791, 
	791, 362, -1, 347, 348, 349, 356, 360, 
	351, 791, 791, -1, -1, -1, -1, 791, 
	-1, -1, -1, 792, 792, 792, 792, 792, 
	792, 792, 792, 792, 792, 792, 792, 792, 
	792, 792, 792, -1, 792, 792, 792, 792, 
	792, 792, 792, 792, -1, 791, 791, 792, 
	792, 792, 792, 792, -1, 792, -1, 792, 
	792, 792, 792, -1, 792, -1, 792, 792, 
	792, -1, -1, 792, -1, -1, 792, 792, 
	792, 792, 792, -1, 792, 792, 792, -1, 
	-1, -1, -1, 792, 792, 792, 792, 792, 
	-1, -1, 1156, 1156, -1, -1, -1, -1, 
	-1, -1, -1, 1156, 1156, 601, 1048, 1156, 
	1156, -1, -1, -1, 1048, -1, -1, -1, 
	1048, 1048, 1156, 790, -1, -1, -1, 1156, 
	-1, -1, -1, -1, 741, 792, 792, 883, 
	883, 883, 883, 883, 883, 883, 883, 883, 
	883, 883, 883, 883, 883, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1156, 1156, 884, 
	884, 884, 884, 884, 884, 884, 884, 884, 
	884, 884, 884, 884, 884, -1, -1, -1, 
	300, 164, 165, 167, 166, 168, -1, -1, 
	666, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 883, -1, -1, -1, -1, -1, 
	161, 162, 163, 792, 792, 792, 792, -1, 
	-1, 792, 792, -1, 792, 792, 792, -1, 
	-1, 1011, 884, 792, 792, 792, -1, 792, 
	792, 792, 792, -1, -1, 879, -1, 792, 
	-1, -1, -1, -1, 792, -1, -1, -1, 
	792, 792, 792, 792, -1, 792, 792, -1, 
	791, 792, -1, -1, -1, -1, 879, 879, 
	879, 879, 879, -1, -1, -1, 792, 792, 
	-1, 618, 348, 349, 356, 360, 351, -1, 
	-1, -1, -1, 792, 792, 879, 879, 879, 
	-1, -1, -1, -1, -1, 792, 792, -1, 
	-1, -1, -1, 792, -1, -1, 879, 793, 
	793, 793, 793, 793, 793, 793, 793, 793, 
	793, 793, 793, 793, 793, 793, 793, -1, 
	793, 793, 793, 793, 793, 793, 793, 793, 
	-1, 792, 792, 793, 793, 793, 793, 793, 
	-1, 793, -1, 793, 793, 793, 793, -1, 
	793, 665, 793, 793, 793, -1, -1, 793, 
	-1, -1, 793, 793, 793, 793, 793, -1, 
	793, 793, 793, -1, -1, -1, -1, 793, 
	793, 793, 793, 793, -1, -1, 619, 348, 
	349, 356, 360, 351, -1, -1, 885, 885, 
	885, 885, 885, 885, 885, 885, 885, 885, 
	885, 885, 885, 885, -1, -1, -1, 791, 
	-1, -1, -1, 164, 165, 167, 166, 168, 
	-1, 793, 793, -1, -1, -1, -1, 664, 
	195, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 161, 162, 163, -1, 574, -1, 
	1036, 571, 572, 573, -1, -1, -1, 879, 
	879, 885, 879, 1011, 886, 886, 886, 886, 
	886, 886, 886, 886, 886, 886, 886, 886, 
	886, 886, -1, -1, -1, 620, 349, 356, 
	360, 351, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 692, -1, -1, -1, 793, 
	793, 793, 793, -1, -1, 793, 793, -1, 
	793, 793, 793, -1, 879, 879, -1, 793, 
	793, 793, -1, 793, 793, 793, 793, 886, 
	-1, -1, -1, 793, -1, -1, -1, -1, 
	793, -1, -1, -1, 793, 793, 793, 793, 
	-1, 793, 793, -1, 792, 793, -1, -1, 
	-1, -1, -1, -1, 752, -1, -1, -1, 
	-1, -1, 793, 793, 353, 354, 355, 352, 
	-1, -1, -1, -1, 359, -1, -1, 793, 
	793, -1, 350, -1, 357, 358, -1, -1, 
	-1, 793, 793, 610, -1, -1, -1, 793, 
	-1, -1, -1, 794, 794, 794, 794, 794, 
	794, 794, 794, 794, 794, 794, 794, 794, 
	794, 794, 794, -1, 794, 794, 794, 794, 
	794, 794, 794, 794, -1, 793, 793, 794, 
	794, 794, 794, 794, -1, 794, -1, 794, 
	794, 794, 794, -1, 794, -1, 794, 794, 
	794, -1, -1, 794, -1, 1036, 794, 794, 
	794, 794, 794, 570, 794, 794, 794, 1036, 
	569, 744, 195, 794, 794, 794, 794, 794, 
	-1, -1, 362, -1, 347, 348, 349, 356, 
	360, 351, 887, 887, 887, 887, 887, 887, 
	887, 887, 887, 887, 887, 887, 887, 887, 
	-1, -1, -1, 792, 365, 366, 685, -1, 
	684, -1, -1, -1, -1, 794, 794, 888, 
	888, 888, 888, 888, 888, 888, 888, 888, 
	888, 888, 888, 888, 888, 889, 889, 889, 
	889, 889, 889, 889, 889, 889, 889, 889, 
	889, 889, 889, -1, -1, 887, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 621, 
	349, 356, 360, 351, 890, 890, 890, 890, 
	890, 890, 890, 890, 890, 890, 890, 890, 
	890, 890, 888, -1, -1, -1, 601, -1, 
	-1, -1, -1, 794, 794, 794, 794, -1, 
	889, 794, 794, -1, 794, 794, 794, -1, 
	-1, -1, -1, 794, 794, 794, -1, 794, 
	794, 794, 794, -1, -1, -1, -1, 794, 
	-1, -1, -1, -1, 794, -1, -1, 890, 
	794, 794, 794, 794, -1, 794, 794, -1, 
	793, 794, 353, 354, 355, 352, -1, -1, 
	-1, -1, 359, -1, -1, -1, 794, 794, 
	350, 300, 357, 358, -1, -1, -1, -1, 
	-1, -1, -1, 794, 794, -1, -1, -1, 
	762, -1, -1, -1, -1, 794, 794, -1, 
	-1, -1, -1, 794, -1, -1, 683, 795, 
	795, 795, 795, 795, 795, 795, 795, 795, 
	795, 795, 795, 795, 795, 795, 795, -1, 
	795, 795, 795, 795, 795, 795, 795, 795, 
	-1, 794, 794, 795, 795, 795, 795, 795, 
	-1, 795, -1, 795, 795, 795, 795, -1, 
	795, -1, 795, 795, 795, -1, -1, 795, 
	-1, -1, 795, 795, 795, 795, 795, -1, 
	795, 795, 795, -1, -1, -1, -1, 795, 
	795, 795, 795, 795, -1, -1, -1, -1, 
	1110, 1110, 1110, 1110, 531, 1104, 1104, 1104, 
	1110, 1104, -1, -1, -1, -1, 1110, -1, 
	1110, 1110, 1104, 1104, 528, 529, 530, 793, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 795, 795, -1, -1, -1, 1156, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, -1, -1, 1156, 1156, 1156, 1156, 
	-1, -1, 665, -1, -1, 622, 349, 356, 
	360, 351, -1, -1, 1156, 1156, 1156, -1, 
	-1, -1, 1156, -1, -1, -1, -1, 1156, 
	-1, -1, -1, -1, -1, 1156, 1156, 1043, 
	-1, 1043, 1043, 1043, 1043, -1, 1043, -1, 
	-1, -1, -1, 1156, -1, -1, -1, 795, 
	795, 795, 795, -1, -1, 795, 795, -1, 
	795, 795, 795, -1, 1156, -1, -1, 795, 
	795, 795, -1, 795, 795, 795, 795, -1, 
	664, 195, -1, 795, 1043, -1, -1, -1, 
	795, 1156, 1156, -1, 795, 795, 795, 795, 
	-1, 795, 795, -1, 794, 795, -1, -1, 
	1110, 1110, 1110, 1110, 531, 1105, 1105, 1105, 
	1110, 1105, 795, 795, -1, -1, 1110, -1, 
	1110, 1110, 1105, 1105, 528, 529, 530, 795, 
	795, 527, -1, 1110, 1110, 1110, 1110, 1110, 
	-1, 795, 795, -1, -1, -1, -1, 795, 
	-1, -1, -1, 796, 796, 796, 796, 796, 
	796, 796, 796, 796, 796, 796, 796, 796, 
	796, 796, 796, -1, 796, 796, 796, 796, 
	796, 796, 796, 796, -1, 795, 795, 796, 
	796, 796, 796, 796, -1, 796, -1, 796, 
	796, 796, 796, -1, 796, -1, 796, 796, 
	796, -1, -1, 796, -1, -1, 796, 796, 
	796, 796, 796, -1, 796, 796, 796, -1, 
	-1, -1, -1, 796, 796, 796, 796, 796, 
	-1, -1, 1156, 1156, -1, -1, -1, -1, 
	-1, -1, -1, 1156, 1156, 673, 1043, 1156, 
	1156, -1, -1, -1, 1043, -1, -1, -1, 
	1043, 1043, 1156, 794, -1, -1, -1, 1156, 
	-1, -1, -1, -1, -1, 796, 796, -1, 
	891, 891, 891, 891, 891, 891, 891, 891, 
	891, 891, 891, 891, 891, 891, -1, -1, 
	-1, -1, -1, -1, -1, 1156, 1156, -1, 
	-1, 527, -1, 1110, 1110, 1110, 1110, 1110, 
	-1, -1, -1, -1, 570, -1, -1, -1, 
	300, 569, 744, 195, -1, -1, -1, 1017, 
	-1, 1017, 1017, 1017, 1017, -1, 1017, -1, 
	-1, -1, 328, 891, -1, -1, -1, -1, 
	-1, 337, 339, 796, 796, 796, 796, 340, 
	-1, 796, 796, -1, 796, 796, 796, -1, 
	338, -1, -1, 796, 796, 796, -1, 796, 
	796, 796, 796, -1, 1017, 415, -1, 796, 
	-1, -1, -1, -1, 796, -1, -1, -1, 
	796, 796, 796, 796, -1, 796, 796, -1, 
	795, 796, -1, -1, -1, -1, 164, 165, 
	167, 166, 168, -1, -1, -1, 796, 796, 
	621, 349, 356, 360, 351, -1, -1, -1, 
	-1, -1, -1, 796, 796, 161, 162, 163, 
	-1, -1, -1, -1, -1, 796, 796, -1, 
	-1, -1, -1, 796, -1, -1, 1011, 797, 
	797, 797, 797, 797, 797, 797, 797, 797, 
	797, 797, 797, 797, 797, 797, 797, -1, 
	797, 797, 797, 797, 797, 797, 797, 797, 
	-1, 796, 796, 797, 797, 797, 797, 797, 
	-1, 797, -1, 797, 797, 797, 797, -1, 
	797, -1, 797, 797, 797, -1, -1, 797, 
	-1, -1, 797, 797, 797, 797, 797, -1, 
	797, 797, 797, -1, -1, -1, -1, 797, 
	797, 797, 797, 797, -1, -1, -1, -1, 
	-1, 762, -1, -1, -1, -1, 1017, 739, 
	-1, -1, -1, -1, 1017, -1, -1, 683, 
	1017, 1017, -1, -1, -1, -1, -1, 795, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 797, 797, 78, 81, 82, 79, 80, 
	87, 88, -1, 83, 84, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 164, 165, 
	167, 166, 168, -1, -1, -1, -1, 417, 
	418, -1, 416, -1, -1, 89, -1, -1, 
	-1, 156, -1, -1, -1, 161, 162, 163, 
	86, 85, 155, -1, -1, -1, -1, 149, 
	150, 151, -1, -1, -1, -1, 1011, 147, 
	-1, 171, 173, 175, 160, -1, -1, 797, 
	797, 797, 797, -1, 152, 797, 797, -1, 
	797, 797, 797, -1, 419, 195, -1, 797, 
	797, 797, -1, 797, 797, 797, 797, -1, 
	-1, -1, -1, 797, -1, -1, -1, -1, 
	797, -1, -1, -1, 797, 797, 797, 797, 
	-1, 797, 797, -1, 796, 797, 622, 349, 
	356, 360, 351, -1, -1, -1, -1, -1, 
	-1, -1, 797, 797, -1, -1, 1044, -1, 
	1044, 1044, 1044, 1044, -1, 1044, -1, 797, 
	797, -1, -1, -1, -1, -1, -1, -1, 
	-1, 797, 797, -1, -1, -1, -1, 797, 
	-1, -1, -1, 798, 798, 798, 798, 798, 
	798, 798, 798, 798, 798, 798, 798, 798, 
	798, 798, 798, 1044, 798, 798, 798, 798, 
	798, 798, 798, 798, -1, 797, 797, 798, 
	798, 798, 798, 798, -1, 798, -1, 798, 
	798, 798, 798, -1, 798, -1, 798, 798, 
	798, -1, -1, 798, -1, -1, 798, 798, 
	798, 798, 798, -1, 798, 798, 798, -1, 
	-1, -1, -1, 798, 798, 798, 798, 798, 
	-1, -1, 527, 892, 892, 892, 892, 892, 
	892, 892, 892, 892, 892, 892, 892, 892, 
	892, -1, -1, 267, 154, 158, -1, -1, 
	-1, -1, 157, 796, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 798, 798, 893, 
	893, 893, 893, 893, 893, 893, 893, 893, 
	893, 893, 893, 893, 893, 169, 159, 153, 
	148, 1011, -1, -1, -1, -1, 892, 713, 
	756, 701, 703, 704, 702, 706, 707, 709, 
	708, 710, 712, 711, 705, -1, -1, 1150, 
	1150, 1150, 1150, 1150, 1150, 1150, 1150, 1150, 
	1150, 1150, 1150, 1150, 1150, 1044, -1, -1, 
	-1, -1, 893, 1044, -1, -1, 673, 1044, 
	1044, -1, -1, 798, 798, 798, 798, -1, 
	-1, 798, 798, -1, 798, 798, 798, -1, 
	-1, -1, 700, 798, 798, 798, -1, 798, 
	798, 798, 798, -1, -1, -1, -1, 798, 
	-1, -1, 1150, -1, 798, -1, -1, -1, 
	798, 798, 798, 798, -1, 798, 798, -1, 
	797, 798, 527, -1, 1110, 1110, 1110, 1110, 
	531, 1106, 1106, 1106, 1110, 1106, 798, 798, 
	-1, 300, 1110, -1, 1110, 1110, 1106, 1106, 
	528, 529, 530, 798, 798, -1, -1, -1, 
	-1, -1, -1, -1, -1, 798, 798, -1, 
	-1, -1, -1, 798, -1, -1, -1, 1142, 
	1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 
	1142, 1142, 1142, 1142, 1142, 1142, 1142, -1, 
	1142, 1142, 1142, 1142, 1142, 1142, 1142, 1142, 
	-1, 798, 798, 1142, 1142, 1142, 1142, 1142, 
	-1, 1142, -1, 1142, 1142, 1142, 1142, -1, 
	1142, 742, 1142, 1142, 1142, -1, -1, 1142, 
	-1, -1, 1142, 1142, 1142, 1142, 1142, -1, 
	1142, 1142, 1142, -1, -1, -1, -1, 1142, 
	1142, 1142, 1142, 1142, -1, -1, -1, 536, 
	1110, 1110, 1110, 1110, 531, 1107, 1107, 1107, 
	1110, 1107, -1, -1, -1, -1, 1110, -1, 
	1110, 1110, 1107, 1107, 528, 529, 530, 797, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1142, 1142, 1115, 1115, 1115, 1115, 1115, 
	1115, 1115, 1115, 1115, 1115, 532, 533, 535, 
	534, 1115, -1, 1115, 1115, 1115, 1115, 1115, 
	1115, 1115, -1, -1, -1, 527, -1, 1110, 
	1110, 1110, 1110, 1110, -1, 713, 757, 701, 
	703, 704, 702, 706, 707, 709, 708, 710, 
	712, 711, 705, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	739, -1, -1, -1, -1, -1, -1, 1142, 
	1142, 1142, 1142, -1, -1, 1142, 1142, -1, 
	1142, 1142, 1142, -1, -1, -1, -1, 1142, 
	1142, 1142, -1, 1142, 1142, 1142, 1142, -1, 
	700, -1, -1, 1142, -1, -1, -1, -1, 
	1142, -1, -1, -1, 1142, 1142, 1142, 1142, 
	-1, 1142, 1142, -1, 798, 1142, -1, -1, 
	417, 418, -1, 416, -1, -1, -1, -1, 
	-1, -1, 1142, 1142, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1142, 
	1142, 527, -1, 1110, 1110, 1110, 1110, 1110, 
	-1, 1142, 1142, -1, -1, -1, -1, 1142, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 419, 195, -1, 
	-1, -1, -1, -1, 1115, -1, 1115, 1115, 
	1115, 1115, 1115, -1, -1, 1142, 1142, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 105, -1, 834, 834, 834, 834, 834, 
	834, 834, 834, 834, 834, 834, 834, 834, 
	834, 834, 834, 834, 834, 834, 834, 834, 
	834, 834, 834, 834, 834, 834, -1, 834, 
	834, 834, 834, 834, -1, 834, -1, 834, 
	834, 834, 834, -1, 834, -1, 834, 834, 
	834, -1, -1, 834, 834, 834, 834, 834, 
	834, 834, 834, 798, 834, 834, 834, -1, 
	-1, -1, -1, 834, 834, 834, 834, 834, 
	-1, -1, -1, 1124, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	834, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 834, 834, 1124, 
	1124, 1124, 1124, 1124, 1124, 1124, 1124, 1124, 
	1124, 1124, 1124, 1124, 1124, 1124, -1, 1124, 
	1124, 1124, 1124, 1124, 1124, 1124, -1, -1, 
	-1, -1, -1, -1, 267, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, -1, 834, 834, 834, 834, -1, 
	-1, 834, 834, -1, 834, 834, 834, -1, 
	-1, -1, -1, 834, 834, 834, -1, 834, 
	834, 834, 834, -1, -1, -1, -1, 834, 
	-1, -1, -1, -1, 834, -1, -1, -1, 
	834, 834, 834, 834, -1, 834, 834, -1, 
	-1, 834, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 834, 834, 834, 834, 834, 
	834, 834, 834, 700, -1, -1, -1, 834, 
	834, -1, -1, 834, 834, -1, -1, -1, 
	-1, -1, -1, -1, -1, 834, 834, -1, 
	-1, -1, -1, 834, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1124, -1, 1124, 1124, 1124, 1124, 1124, -1, 
	-1, 834, 834, -1, -1, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	-1, 958, 958, 958, 958, 958, -1, 958, 
	-1, 958, 958, 958, 958, -1, 958, -1, 
	958, 958, 958, -1, -1, 958, 958, 958, 
	958, 958, 958, 958, 958, -1, 958, 958, 
	958, -1, 742, -1, -1, 958, 958, 958, 
	958, 958, -1, -1, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, -1, -1, 
	-1, -1, 958, -1, -1, 203, -1, 164, 
	165, 167, 166, 168, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 89, 958, 
	958, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, 880, -1, -1, -1, 152, -1, -1, 
	-1, -1, -1, -1, -1, -1, 527, -1, 
	-1, -1, -1, 141, 142, 143, 144, 145, 
	-1, -1, 880, 880, 880, 880, 880, -1, 
	-1, -1, -1, -1, -1, 958, 958, 958, 
	958, -1, -1, 958, 958, -1, 958, 958, 
	958, 880, 880, 880, 834, 958, 958, 958, 
	-1, 958, 958, 958, 958, -1, -1, -1, 
	-1, 958, 880, -1, -1, -1, 958, -1, 
	-1, -1, 958, 958, 958, 958, -1, 958, 
	958, 700, -1, 958, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 958, 958, 958, 
	958, 958, 958, 958, 958, -1, -1, -1, 
	-1, 958, 958, -1, 202, 958, 958, -1, 
	-1, -1, -1, -1, -1, -1, -1, 958, 
	958, -1, -1, -1, -1, 958, -1, -1, 
	-1, -1, 527, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 958, 958, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 136, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, 105, 157, 78, 81, 82, 79, 
	80, 87, 88, 834, 83, 84, -1, -1, 
	-1, -1, -1, 880, 880, -1, 880, 164, 
	165, 167, 166, 168, -1, -1, 169, 159, 
	153, 148, 1011, -1, -1, -1, 89, -1, 
	-1, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	880, 880, -1, -1, -1, 152, -1, -1, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, 141, 142, 143, 144, 145, 
	-1, -1, -1, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 89, -1, -1, -1, 156, -1, 
	-1, -1, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	1126, -1, -1, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, -1, 
	-1, 152, -1, -1, -1, -1, -1, 1131, 
	-1, -1, -1, -1, -1, -1, 958, 141, 
	142, 143, 144, 145, 1126, 1126, 1126, 1126, 
	1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 
	1126, 1126, 1126, -1, 1126, 1126, 1126, 1126, 
	1126, 1126, 1126, 1131, 1131, 1131, 1131, 1131, 
	1131, 1131, 1131, 1131, 1131, 1131, 1131, 1131, 
	1131, 1131, 1127, 1131, 1131, 1131, 1131, 1131, 
	1131, 1131, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 178, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, 1011, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 958, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 181, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1126, -1, 1126, 
	1126, 1126, 1126, 1126, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, 1011, -1, 
	-1, -1, -1, -1, 1131, -1, 1131, 1131, 
	1131, 1131, 1131, -1, -1, -1, -1, -1, 
	-1, -1, 1152, -1, 1152, 1152, 1152, 1152, 
	1152, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1152, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1152, 1152, 
	1152, 1152, 1152, -1, 1152, -1, 1152, -1, 
	-1, -1, -1, 1152, -1, -1, 1152, 1152, 
	-1, -1, -1, -1, -1, 1152, 1152, 1152, 
	-1, -1, -1, 1152, 1152, 1152, -1, -1, 
	-1, -1, 1152, 1152, 1152, 1152, 1152, 835, 
	835, 835, 835, 835, 835, 835, 835, 835, 
	835, 835, 835, 835, 835, 835, 835, 835, 
	835, 835, 835, 835, 835, 835, 835, 835, 
	835, 835, -1, 835, 835, 835, 835, 835, 
	-1, 835, -1, 835, 835, 835, 835, -1, 
	835, -1, 835, 835, 835, -1, -1, 835, 
	835, 835, 835, 835, 835, 835, 835, -1, 
	835, 835, 835, -1, -1, -1, -1, 835, 
	835, 835, 835, 835, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 835, -1, -1, -1, 
	-1, -1, -1, -1, -1, 202, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 835, 835, 1152, 1152, 1152, -1, -1, 
	1152, 1152, -1, -1, 1152, 1152, -1, -1, 
	-1, -1, 1152, 1152, 1152, -1, 1152, 1152, 
	1152, 1152, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1152, 1152, -1, -1, 1152, 
	-1, 1152, 1152, -1, 1152, 1152, -1, -1, 
	1152, -1, -1, -1, -1, -1, -1, 136, 
	137, 138, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, 835, 
	835, 835, 835, -1, -1, 835, 835, -1, 
	835, 835, 835, -1, 1152, 1152, -1, 835, 
	835, 835, -1, 835, 835, 835, 835, 169, 
	159, 153, 148, 835, -1, -1, -1, -1, 
	835, -1, -1, -1, 835, 835, 835, 835, 
	-1, 835, 835, -1, -1, 835, -1, -1, 
	-1, -1, -1, -1, 1132, -1, -1, 835, 
	835, 835, 835, 835, 835, 835, 835, -1, 
	-1, 252, -1, 835, 835, -1, -1, 835, 
	835, -1, -1, -1, -1, -1, -1, -1, 
	-1, 835, 835, 1177, -1, -1, -1, 835, 
	1132, 1132, 1132, 1132, 1132, 1132, 1132, 1132, 
	1132, 1132, 1132, 1132, 1132, 1132, 1132, -1, 
	1132, 1132, 1132, 1132, 1132, 1132, 1132, -1, 
	-1, -1, 1178, -1, -1, 835, 835, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, 1177, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, 1129, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1178, 1178, 
	1178, 1178, 1178, 1178, 1178, 1178, 1178, 1178, 
	1178, 1178, 1178, 1178, 1178, 1130, 1178, 1178, 
	1178, 1178, 1178, 1178, 1178, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 178, 
	137, 138, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, -1, 1017, -1, 1017, 1017, 1017, 
	1017, 1132, 1017, 1132, 1132, 1132, 1132, 1132, 
	-1, -1, -1, -1, -1, 337, 339, 169, 
	159, 153, 148, 340, -1, -1, -1, -1, 
	-1, -1, -1, -1, 338, -1, -1, -1, 
	1177, -1, 1177, 1177, 1177, 1177, 1177, -1, 
	1017, -1, -1, -1, -1, -1, -1, -1, 
	835, -1, -1, 181, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, -1, -1, 1178, 
	157, 1178, 1178, 1178, 1178, 1178, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 169, 159, 153, 148, 836, 
	836, 836, 836, 836, 836, 836, 836, 836, 
	836, 836, 836, 836, 836, 836, 836, 836, 
	836, 836, 836, 836, 836, 836, 836, 836, 
	836, 836, -1, 836, 836, 836, 836, 836, 
	-1, 836, -1, 836, 836, 836, 836, -1, 
	836, -1, 836, 836, 836, -1, -1, 836, 
	836, 836, 836, 836, 836, 836, 836, -1, 
	836, 836, 836, -1, -1, -1, -1, 836, 
	836, 836, 836, 836, -1, -1, -1, 1128, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 836, -1, -1, -1, 
	-1, -1, 1017, 740, -1, -1, -1, 835, 
	1017, -1, -1, -1, 1017, 1017, -1, -1, 
	-1, 836, 836, 1128, 1128, 1128, 1128, 1128, 
	1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 
	1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 
	1128, 1128, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 836, 
	836, 836, 836, -1, -1, 836, 836, -1, 
	836, 836, 836, -1, -1, -1, -1, 836, 
	836, 836, -1, 836, 836, 836, 836, -1, 
	-1, -1, -1, 836, -1, -1, -1, -1, 
	836, -1, -1, -1, 836, 836, 836, 836, 
	-1, 836, 836, -1, -1, 836, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 836, 
	836, 836, 836, 836, 836, 836, 836, -1, 
	-1, -1, -1, 836, 836, -1, -1, 836, 
	836, -1, -1, -1, -1, -1, -1, -1, 
	-1, 836, 836, -1, -1, -1, -1, 836, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1128, -1, 1128, 1128, 
	1128, 1128, 1128, -1, -1, 836, 836, -1, 
	-1, 937, 937, 937, 937, 937, 937, 937, 
	937, 937, 937, 937, 937, 937, 937, 937, 
	937, 937, 937, 937, 937, 937, 937, 937, 
	937, 937, 937, 937, -1, 937, 937, 937, 
	937, 937, 252, 937, -1, 937, 937, 937, 
	937, -1, 937, -1, 937, 937, 937, -1, 
	-1, 937, 937, 937, 937, 937, 937, 937, 
	937, -1, 937, 937, 937, -1, -1, -1, 
	-1, 937, 937, 937, 937, 937, -1, -1, 
	-1, 1125, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 937, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 937, 937, 1125, 1125, 1125, 
	1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 
	1125, 1125, 1125, 1125, -1, 1125, 1125, 1125, 
	1125, 1125, 1125, 1125, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 937, 937, 937, 937, -1, -1, 937, 
	937, -1, 937, 937, 937, -1, -1, -1, 
	836, 937, 937, 937, -1, 937, 937, 937, 
	937, -1, -1, -1, -1, 937, -1, -1, 
	-1, -1, 937, -1, -1, -1, 937, 937, 
	937, 937, -1, 937, 937, -1, -1, 937, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 937, 937, 937, 937, 937, 937, 937, 
	937, -1, -1, -1, -1, 937, 937, -1, 
	-1, 937, 937, -1, -1, -1, -1, -1, 
	-1, -1, -1, 937, 937, -1, -1, -1, 
	-1, 937, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1125, -1, 
	1125, 1125, 1125, 1125, 1125, -1, -1, 937, 
	937, -1, -1, -1, 3, 40, 41, 218, 
	38, 36, 39, 69, 70, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, 43, 
	65, 48, 49, 53, 51, -1, -1, -1, 
	861, 861, 861, 861, 861, -1, 45, 836, 
	60, 54, 55, 56, -1, 63, -1, 89, 
	61, 59, -1, -1, 50, -1, -1, 861, 
	861, 861, 86, 85, -1, 66, 68, 67, 
	-1, -1, -1, -1, 92, 93, 94, 64, 
	75, -1, 78, 81, 82, 79, 80, 87, 
	88, -1, 83, 84, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 164, 165, 167, 
	166, 168, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 89, -1, 90, 91, 
	156, -1, -1, -1, 161, 162, 163, 86, 
	85, 155, -1, -1, 740, -1, 149, 150, 
	151, -1, -1, -1, -1, 1011, 147, -1, 
	171, 173, 175, 160, -1, -1, -1, -1, 
	-1, -1, -1, 152, 947, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 141, 142, 143, 144, 145, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 14, 34, 32, 62, 
	-1, -1, 31, 33, -1, 30, 29, 27, 
	-1, -1, 937, -1, 44, 25, 26, -1, 
	42, 23, 37, 16, -1, -1, -1, -1, 
	35, -1, -1, -1, -1, 24, -1, -1, 
	-1, 20, 21, 22, 15, -1, 17, 18, 
	-1, -1, 19, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 58, 
	28, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 47, 46, -1, -1, 
	-1, -1, -1, -1, -1, -1, 861, 77, 
	-1, -1, -1, -1, 57, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 52, 1011, -1, -1, -1, -1, 
	-1, 229, 228, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 230, 137, 138, 139, 
	140, -1, 146, 154, 158, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, 937, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 169, 159, 153, 148, 
	1011, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, 962, 962, 962, 962, 
	962, 962, 962, 962, -1, 962, 962, 962, 
	962, 962, -1, 962, -1, 962, 962, 962, 
	962, -1, 962, -1, 962, 962, 962, -1, 
	-1, 962, 962, 962, 962, 962, 962, 962, 
	962, -1, 962, 962, 962, -1, -1, -1, 
	-1, 962, 962, 962, 962, 962, -1, -1, 
	1170, 1170, 1170, 1170, 1170, 1170, 1170, -1, 
	1170, 1170, -1, -1, -1, -1, 962, -1, 
	-1, -1, -1, 1170, 1170, 1170, 1170, 1170, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1170, 962, 962, -1, 1170, -1, 
	-1, -1, 1170, 1170, 1170, 1170, 1170, 1170, 
	-1, -1, -1, -1, 1170, 1170, 1170, -1, 
	-1, -1, -1, 1170, 1170, -1, 1170, 1170, 
	1170, 1170, 1170, -1, -1, -1, -1, -1, 
	-1, 1170, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1170, 
	1170, 1170, 1170, 1170, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 962, 962, 962, 962, -1, -1, 962, 
	962, -1, 962, 962, 962, -1, -1, -1, 
	-1, 962, 962, 962, -1, 962, 962, 962, 
	962, -1, -1, -1, -1, 962, -1, -1, 
	-1, -1, 962, -1, -1, -1, 962, 962, 
	962, 962, -1, 962, 962, -1, -1, 962, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 962, 962, 962, 962, 962, 962, 962, 
	962, -1, -1, -1, -1, 962, 962, -1, 
	-1, 962, 962, -1, -1, -1, -1, -1, 
	-1, -1, -1, 962, 962, -1, -1, -1, 
	-1, 962, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 962, 
	962, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1170, 1170, 1170, 1170, 1170, -1, 
	1170, 1170, 1170, 1116, -1, -1, -1, 1170, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1170, 1170, -1, -1, -1, -1, 
	-1, -1, -1, 1170, -1, 1117, -1, -1, 
	-1, -1, 1170, 1170, 1170, 1170, 1170, 1116, 
	1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 
	1116, 1116, 1116, 1116, 1116, 1116, -1, 1116, 
	1116, 1116, 1116, 1116, 1116, 1116, 1118, 227, 
	-1, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 
	1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 
	-1, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1118, 1118, 1118, 1118, 1118, 1118, 
	1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 
	1118, -1, 1118, 1118, 1118, 1118, 1118, 1118, 
	1118, -1, -1, -1, -1, 14, 34, 32, 
	62, -1, -1, 31, 33, -1, 30, 29, 
	27, -1, -1, -1, -1, 44, 25, 26, 
	-1, 42, 23, 37, 16, -1, -1, -1, 
	-1, 35, -1, -1, -1, -1, 24, -1, 
	-1, -1, 20, 21, 22, 15, -1, 17, 
	18, -1, 962, 19, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	58, 28, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 47, 46, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, -1, -1, -1, -1, 57, -1, -1, 
	1116, -1, 1116, 1116, 1116, 1116, 1116, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1117, 52, 1117, 1117, 1117, 1117, 
	1117, -1, 229, 228, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 230, 137, 138, 
	139, 140, -1, 146, 154, 158, -1, -1, 
	-1, -1, 157, 1118, -1, 1118, 1118, 1118, 
	1118, 1118, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, -1, -1, -1, -1, -1, -1, -1, 
	-1, 962, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, -1, 1087, 1087, 
	1087, 1087, 1087, -1, 1087, -1, 1087, 1087, 
	1087, 1087, -1, 1087, -1, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, -1, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, -1, 1087, 
	-1, -1, 1087, -1, 1087, 1087, 1087, 1087, 
	1087, -1, -1, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, 1087, -1, 1087, 1087, -1, -1, 
	-1, -1, -1, 1087, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1087, 1087, 1087, 1087, -1, -1, 
	1087, 1087, 1087, 1087, 1087, 1087, -1, -1, 
	-1, -1, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, -1, -1, -1, -1, 1087, -1, 
	-1, -1, -1, 1087, 1087, -1, -1, 1087, 
	1087, 1087, 1087, -1, 1087, 1087, -1, -1, 
	1087, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1087, 1087, 1087, 1087, 1087, 1087, 
	1087, 1087, -1, -1, -1, 1087, 1087, 1087, 
	-1, -1, 1087, 1087, -1, 1087, 1087, 1087, 
	1087, 1087, 1087, 1087, 1087, 1087, -1, -1, 
	-1, 1087, 1087, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1087, 1087, -1, 
	-1, 1087, -1, -1, -1, -1, 1087, -1, 
	-1, -1, -1, 1087, -1, 1087, 1087, 1087, 
	1087, 1087, -1, -1, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, -1, 
	1086, 1086, 1086, 1086, 1086, -1, 1086, -1, 
	1086, 1086, 1086, 1086, -1, 1086, -1, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	-1, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 115, 117, 119, 121, 1086, 
	227, 1086, -1, -1, 1086, -1, 1086, 1086, 
	1086, 1086, 1086, -1, -1, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, 1086, 1119, 1086, 1086, 
	-1, -1, -1, -1, -1, 1086, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 
	1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 
	-1, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1086, 1086, 1086, 1086, 
	-1, -1, 1086, 1086, 1086, 1086, 1086, 1086, 
	-1, -1, -1, 1087, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, -1, -1, -1, -1, 
	1086, -1, -1, -1, -1, 1086, 1086, -1, 
	-1, 1086, 1086, 1086, 1086, -1, 1086, 1086, 
	-1, -1, 1086, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1086, 1086, 1086, 1086, 
	1086, 1086, 1086, 1086, -1, -1, -1, 1086, 
	1086, 1086, -1, -1, 1086, 1086, -1, 1086, 
	1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 
	-1, -1, -1, 1086, 1086, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1086, 
	1086, -1, -1, 1086, -1, -1, -1, -1, 
	1086, -1, 113, 231, -1, 1086, -1, 1086, 
	1086, 1086, 1086, 1086, 69, 70, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, 48, 49, 53, 51, -1, -1, 
	-1, -1, 1119, -1, 1119, 1119, 1119, 1119, 
	1119, -1, 54, 55, 56, -1, -1, -1, 
	89, -1, 1087, -1, -1, 50, -1, -1, 
	-1, -1, -1, 86, 85, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 73, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 274, 275, -1, 90, 
	91, -1, -1, -1, -1, -1, -1, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, -1, 965, 965, 965, 965, 965, 
	-1, 965, -1, 965, 965, 965, 965, -1, 
	965, -1, 965, 965, 965, -1, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, -1, 965, 965, 965, 965, 
	965, 965, 965, 965, 965, 965, 965, 965, 
	965, 965, 965, -1, -1, -1, -1, -1, 
	-1, 965, 965, 965, 965, 1086, -1, -1, 
	278, 279, 965, 280, 281, 282, 283, 965, 
	965, 965, 965, 965, -1, -1, 965, 965, 
	-1, 965, 965, -1, -1, -1, -1, -1, 
	965, -1, -1, -1, -1, -1, -1, -1, 
	58, 277, -1, -1, -1, -1, -1, -1, 
	273, -1, -1, -1, -1, 47, 46, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, -1, -1, -1, -1, 57, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 965, 
	965, 965, 965, 52, 1011, 965, 965, 965, 
	965, 965, 965, -1, -1, -1, -1, 965, 
	965, 965, 965, 965, 965, 965, 965, -1, 
	-1, -1, -1, 965, -1, -1, -1, -1, 
	965, 965, -1, -1, 965, 965, 965, 965, 
	-1, 965, 965, -1, -1, 965, -1, -1, 
	-1, -1, -1, -1, 1086, -1, -1, 965, 
	965, 965, 965, 965, 965, 965, 965, -1, 
	-1, -1, 965, 965, 965, -1, -1, 965, 
	965, -1, 965, 965, 965, 965, 965, -1, 
	965, 965, 965, -1, -1, -1, 965, 965, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 965, 965, -1, -1, 965, -1, 
	-1, -1, -1, 965, -1, -1, -1, -1, 
	965, -1, 965, 965, 965, 965, 965, -1, 
	-1, -1, -1, -1, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, -1, 
	972, 972, 972, 972, 972, -1, 972, -1, 
	972, 972, 972, 972, -1, 972, -1, 972, 
	972, 972, -1, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	-1, 972, 972, 972, 972, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	-1, -1, -1, -1, -1, -1, 972, 972, 
	972, 972, 1136, -1, -1, 972, 972, 972, 
	972, 972, 972, 972, 972, 972, 972, 972, 
	972, 284, 285, 972, 972, -1, 972, 972, 
	-1, 1134, -1, -1, -1, 972, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1136, 1136, 
	1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 
	1136, 1136, 1136, 1136, 1136, -1, 1136, 1136, 
	1136, 1136, 1136, 1136, 1136, 1134, 1134, 1134, 
	1134, 1134, 1134, 1134, 1134, 1134, 1134, 1134, 
	1134, 1134, 1134, 1134, -1, 1134, 1134, 1134, 
	1134, 1134, 1134, 1134, -1, -1, -1, -1, 
	-1, -1, -1, -1, 972, 972, 972, 972, 
	-1, -1, 972, 972, 972, 972, 972, 972, 
	965, -1, -1, -1, 972, 972, 972, 972, 
	972, 972, 972, 972, -1, -1, -1, -1, 
	972, -1, -1, 113, 231, 972, 972, -1, 
	-1, 972, 972, 972, 972, -1, 972, 972, 
	-1, -1, 972, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 972, 972, 972, 972, 
	972, 972, 972, 972, -1, -1, -1, 972, 
	972, 972, -1, -1, 972, 972, -1, 972, 
	972, 972, 972, 972, -1, 972, 972, 972, 
	-1, -1, -1, 972, 972, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 972, 
	972, -1, -1, 972, -1, -1, -1, -1, 
	972, -1, -1, -1, -1, 972, -1, 972, 
	972, 972, 972, 972, -1, -1, -1, 1136, 
	-1, 1136, 1136, 1136, 1136, 1136, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1134, -1, 
	1134, 1134, 1134, 1134, 1134, -1, -1, 965, 
	-1, -1, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, -1, 975, 975, 
	975, 975, 975, -1, 975, -1, 975, 975, 
	975, 975, -1, 975, -1, 975, 975, 975, 
	-1, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, -1, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, -1, 287, 
	-1, -1, -1, -1, 975, 975, 975, 975, 
	286, -1, -1, 975, 975, 975, 975, 975, 
	975, 975, 975, 975, 975, 975, 975, 975, 
	975, 975, 975, -1, 975, 975, -1, -1, 
	-1, 58, 277, 975, -1, -1, -1, -1, 
	-1, 273, -1, -1, -1, -1, 47, 46, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 76, -1, -1, -1, -1, 57, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 972, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 52, -1, -1, -1, 
	-1, -1, 975, 975, 975, 975, -1, -1, 
	975, 975, 975, 975, 975, 975, -1, -1, 
	-1, -1, 975, 975, 975, 975, 975, 975, 
	975, 975, -1, -1, -1, -1, 975, -1, 
	-1, -1, -1, 975, 975, -1, -1, 975, 
	975, 975, 975, -1, 975, 975, -1, -1, 
	975, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 975, 975, 975, 975, 975, 975, 
	975, 975, -1, -1, -1, 975, 975, 975, 
	-1, -1, 975, 975, -1, 975, 975, 975, 
	975, 975, -1, 975, 975, 975, -1, -1, 
	-1, 975, 975, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 975, 975, -1, 
	-1, 975, -1, -1, -1, -1, 975, -1, 
	-1, -1, -1, 975, -1, 975, 975, 975, 
	975, 975, -1, -1, 972, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	-1, 978, 978, 978, 978, 978, -1, 978, 
	-1, 978, 978, 978, 978, -1, 978, -1, 
	978, 978, 978, -1, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, -1, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, -1, 978, -1, -1, -1, -1, 978, 
	978, 978, 978, 978, -1, -1, 978, 978, 
	978, 978, 978, 978, 978, 978, 978, 978, 
	978, 978, 978, 978, 978, 978, -1, 978, 
	978, 1135, -1, -1, -1, -1, 978, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, -1, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 978, 978, 978, 
	978, -1, -1, 978, 978, 978, 978, 978, 
	978, -1, -1, 975, -1, 978, 978, 978, 
	978, 978, 978, 978, 978, -1, -1, -1, 
	-1, 978, -1, -1, -1, -1, 978, 978, 
	-1, -1, 978, 978, 978, 978, -1, 978, 
	978, -1, -1, 978, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 978, 978, 978, 
	978, 978, 978, 978, 978, -1, -1, -1, 
	978, 978, 978, -1, -1, 978, 978, -1, 
	978, 978, 978, 978, 978, -1, 978, 978, 
	978, -1, -1, -1, 978, 978, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	978, 978, -1, -1, 978, -1, -1, -1, 
	-1, 978, -1, -1, -1, -1, 978, -1, 
	978, 978, 978, 978, 978, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	164, 165, 167, 166, 168, -1, 1135, -1, 
	1135, 1135, 1135, 1135, 1135, -1, -1, 89, 
	-1, -1, 975, 156, -1, -1, -1, 161, 
	162, 163, 86, 85, 155, -1, -1, -1, 
	-1, 149, 150, 151, -1, -1, -1, -1, 
	1011, 147, -1, 171, 173, 175, 160, -1, 
	-1, -1, -1, -1, -1, -1, 152, 78, 
	81, 82, 79, 80, 87, 88, -1, 83, 
	84, -1, -1, -1, -1, 269, -1, -1, 
	-1, -1, 164, 165, 167, 166, 168, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 89, -1, -1, -1, 156, -1, -1, 
	-1, 161, 162, 163, 86, 85, 155, -1, 
	-1, -1, -1, 149, 150, 151, -1, -1, 
	-1, -1, 1011, 147, -1, 171, 173, 175, 
	160, -1, -1, -1, -1, -1, -1, -1, 
	152, -1, -1, -1, -1, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	164, 165, 167, 166, 168, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 89, 
	-1, -1, -1, 156, -1, -1, 978, 161, 
	162, 163, 86, 85, 155, -1, -1, -1, 
	-1, 149, 150, 151, -1, -1, -1, -1, 
	1011, 147, -1, 171, 173, 175, 160, -1, 
	-1, -1, -1, -1, -1, -1, 152, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 268, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, 536, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 169, 
	159, 153, 148, 1011, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1112, 1112, 
	1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 
	532, 533, 535, 534, 1112, -1, 1112, 1112, 
	1112, 1112, 1112, 1112, 1112, -1, -1, 270, 
	154, 158, -1, -1, -1, -1, 157, -1, 
	-1, -1, -1, -1, -1, 978, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, 1011, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 271, 154, 158, 
	-1, -1, -1, -1, 157, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	164, 165, 167, 166, 168, -1, -1, 169, 
	159, 153, 148, 1011, -1, -1, -1, 89, 
	-1, -1, -1, 156, -1, -1, 536, 161, 
	162, 163, 86, 85, 155, -1, -1, -1, 
	-1, 149, 150, 151, -1, -1, -1, -1, 
	1011, 147, -1, 171, 173, 175, 160, 1112, 
	-1, 1112, 1112, 1112, 1112, 1112, 152, -1, 
	-1, -1, 1113, 1113, 1113, 1113, 1113, 1113, 
	1113, 1113, 1113, 1113, 532, 533, 535, 534, 
	1113, -1, 1113, 1113, 1113, 1113, 1113, 1113, 
	1113, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, -1, 
	985, 985, 985, 985, 985, -1, 985, -1, 
	985, 985, 985, 985, -1, 985, -1, 985, 
	985, 985, -1, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	-1, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	-1, 985, -1, -1, -1, -1, 985, 985, 
	985, 985, 985, -1, -1, 985, 985, 985, 
	985, 985, 985, 985, 985, 985, 985, 985, 
	985, 985, 985, 985, 985, -1, 985, 985, 
	-1, -1, -1, -1, -1, 985, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 272, 154, 158, 
	-1, -1, -1, 1113, 157, 1113, 1113, 1113, 
	1113, 1113, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 169, 
	159, 153, 148, 1011, 985, 985, 985, 985, 
	-1, -1, 985, 985, 985, 985, 985, 985, 
	-1, -1, -1, -1, 985, 985, 985, 985, 
	985, 985, 985, 985, -1, -1, -1, -1, 
	985, -1, -1, -1, -1, 985, 985, -1, 
	-1, 985, 985, 985, 985, -1, 985, 985, 
	-1, -1, 985, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 985, 985, 985, 985, 
	985, 985, 985, 985, -1, -1, -1, 985, 
	985, 985, -1, -1, 985, 985, -1, 985, 
	985, 985, 985, 985, -1, 985, 985, 985, 
	536, -1, -1, 985, 985, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 985, 
	985, -1, -1, 985, -1, -1, -1, 536, 
	985, -1, -1, -1, -1, 985, -1, 985, 
	985, 985, 985, 985, 1114, 1114, 1114, 1114, 
	1114, 1114, 1114, 1114, 1114, 1114, 532, 533, 
	535, 534, 1114, -1, 1114, 1114, 1114, 1114, 
	1114, 1114, 1114, 1111, 1111, 1111, 1111, 1111, 
	1111, 1111, 1111, 1111, 1111, 532, 533, 535, 
	534, 1111, -1, 1111, 1111, 1111, 1111, 1111, 
	1111, 1111, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 268, 154, 
	158, 1133, -1, -1, -1, 157, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	169, 159, 153, 148, -1, 1133, 1133, 1133, 
	1133, 1133, 1133, 1133, 1133, 1133, 1133, 1133, 
	1133, 1133, 1133, 1133, -1, 1133, 1133, 1133, 
	1133, 1133, 1133, 1133, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	270, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, -1, -1, 
	-1, -1, -1, -1, -1, 1114, -1, 1114, 
	1114, 1114, 1114, 1114, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 985, -1, -1, 
	-1, -1, -1, -1, 1111, -1, 1111, 1111, 
	1111, 1111, 1111, -1, -1, -1, 271, 154, 
	158, -1, -1, -1, -1, 157, -1, -1, 
	-1, -1, -1, 69, 70, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, 48, 49, 53, 51, -1, -1, -1, 
	169, 159, 153, 148, -1, -1, -1, -1, 
	-1, 54, 55, 56, -1, -1, -1, 89, 
	-1, -1, -1, -1, 50, -1, -1, -1, 
	-1, -1, 86, 85, -1, -1, 1133, -1, 
	1133, 1133, 1133, 1133, 1133, -1, -1, -1, 
	73, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	276, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 274, 275, -1, 90, 91, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 985, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	-1, 989, 989, 989, 989, 989, -1, 989, 
	-1, 989, 989, 989, 989, -1, 989, -1, 
	989, 989, 989, -1, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, -1, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, -1, 989, -1, -1, -1, -1, 989, 
	989, 989, 989, 989, -1, -1, 989, 989, 
	989, 989, 989, 989, 989, 989, 989, 989, 
	989, 989, 989, 989, 989, 989, -1, 989, 
	989, -1, -1, -1, -1, -1, 989, 58, 
	277, -1, -1, -1, -1, -1, -1, 294, 
	-1, -1, -1, -1, 47, 46, 272, 154, 
	158, -1, -1, -1, -1, 157, -1, 76, 
	-1, -1, -1, -1, 57, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	169, 159, 153, 148, -1, -1, -1, -1, 
	-1, -1, 52, 1011, -1, 989, 989, 989, 
	989, -1, -1, 989, 989, 989, 989, 989, 
	989, -1, -1, -1, -1, 989, 989, 989, 
	989, 989, 989, 989, 989, -1, -1, -1, 
	-1, 989, -1, -1, -1, -1, 989, 989, 
	-1, -1, 989, 989, 989, 989, -1, 989, 
	989, -1, -1, 989, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 989, 989, 989, 
	989, 989, 989, 989, 989, -1, -1, -1, 
	989, 989, 989, -1, -1, 989, 989, -1, 
	989, 989, 989, 989, 989, -1, 989, 989, 
	989, -1, -1, -1, 989, 989, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	989, 989, -1, -1, 989, -1, -1, -1, 
	-1, 989, -1, -1, -1, -1, 989, -1, 
	989, 989, 989, 989, 989, -1, -1, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, -1, 991, 991, 991, 991, 991, 
	-1, 991, -1, 991, 991, 991, 991, -1, 
	991, -1, 991, 991, 991, -1, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, -1, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, -1, 991, -1, -1, -1, 
	-1, 293, 991, 991, 991, 991, -1, -1, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	991, 991, 991, 991, 991, 991, 991, 991, 
	-1, 991, 991, -1, -1, -1, -1, -1, 
	991, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 991, 
	991, 991, 991, -1, -1, 991, 991, 991, 
	991, 991, 991, -1, -1, -1, 989, 991, 
	991, 991, 991, 991, 991, 991, 991, -1, 
	-1, -1, -1, 991, -1, -1, -1, -1, 
	991, 991, -1, -1, 991, 991, 991, 991, 
	-1, 991, 991, -1, -1, 991, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 991, 
	991, 991, 991, 991, 991, 991, 991, -1, 
	-1, -1, 991, 991, 991, -1, -1, 991, 
	991, -1, 991, 991, 991, 991, 991, -1, 
	991, 991, 991, -1, -1, -1, 991, 991, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 991, 991, -1, -1, 991, -1, 
	-1, -1, -1, 991, -1, -1, -1, -1, 
	991, -1, 991, 991, 991, 991, 991, -1, 
	-1, -1, 992, 992, 992, 992, 992, 992, 
	992, 992, 992, 992, 992, 992, 992, 992, 
	992, 992, 992, 992, 992, 992, 992, 992, 
	992, 992, 992, 992, 992, -1, 992, 992, 
	992, 992, 992, -1, 992, 989, 992, 992, 
	992, 992, -1, 992, -1, 992, 992, 992, 
	-1, 992, 992, 992, 992, 992, 992, 992, 
	992, 992, 992, 992, 992, 992, -1, 992, 
	992, 992, 992, 992, 992, 992, 992, 992, 
	992, 992, 992, 992, 992, 992, -1, 992, 
	-1, -1, -1, -1, 992, 992, 992, 992, 
	992, -1, -1, 992, 992, 992, 992, 992, 
	992, 992, 992, 992, 992, 992, 992, 992, 
	992, 992, 992, -1, 992, 992, -1, -1, 
	-1, -1, -1, 992, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	58, 277, -1, -1, -1, -1, -1, -1, 
	294, -1, -1, -1, -1, 47, 46, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, -1, -1, -1, -1, 57, -1, -1, 
	-1, -1, 992, 992, 992, 992, -1, -1, 
	992, 992, 992, 992, 992, 992, -1, -1, 
	991, -1, 992, 992, 992, 992, 992, 992, 
	992, 992, -1, 52, -1, -1, 992, -1, 
	-1, -1, -1, 992, 992, -1, -1, 992, 
	992, 992, 992, -1, 992, 992, -1, -1, 
	992, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 992, 992, 992, 992, 992, 992, 
	992, 992, -1, -1, -1, 992, 992, 992, 
	-1, -1, 992, 992, -1, 992, 992, 992, 
	992, 992, -1, 992, 992, 992, -1, -1, 
	-1, 992, 992, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 992, 992, -1, 
	-1, 992, -1, -1, -1, -1, 992, -1, 
	-1, -1, -1, 992, -1, 992, 992, 992, 
	992, 992, -1, -1, 993, 993, 993, 993, 
	993, 993, 993, 993, 993, 993, 993, 993, 
	993, 993, 993, 993, 993, 993, 993, 993, 
	993, 993, 993, 993, 993, 993, 993, -1, 
	993, 993, 993, 993, 993, -1, 993, 991, 
	993, 993, 993, 993, -1, 993, -1, 993, 
	993, 993, -1, 993, 993, 993, 993, 993, 
	993, 993, 993, 993, 993, 993, 993, 993, 
	-1, 993, 993, 993, 993, 993, 993, 993, 
	993, 993, 993, 993, 993, 993, 993, 993, 
	-1, 993, -1, -1, -1, -1, 993, 993, 
	993, 993, 993, -1, -1, 993, 993, 993, 
	993, 993, 993, 993, 993, 993, 993, 993, 
	993, 993, 993, 993, 993, -1, 993, 993, 
	-1, -1, -1, -1, -1, 993, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 993, 993, 993, 993, 
	-1, -1, 993, 993, 993, 993, 993, 993, 
	-1, -1, -1, 992, 993, 993, 993, 993, 
	993, 993, 993, 993, -1, -1, -1, -1, 
	993, -1, -1, -1, -1, 993, 993, -1, 
	-1, 993, 993, 993, 993, -1, 993, 993, 
	-1, -1, 993, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 993, 993, 993, 993, 
	993, 993, 993, 993, -1, -1, -1, 993, 
	993, 993, -1, -1, 993, 993, -1, 993, 
	993, 993, 993, 993, -1, 993, 993, 993, 
	-1, -1, -1, 993, 993, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 993, 
	993, -1, -1, 993, -1, -1, -1, -1, 
	993, -1, -1, -1, -1, 993, -1, 993, 
	993, 993, 993, 993, -1, -1, -1, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, -1, 994, 994, 994, 994, 994, 
	-1, 994, 992, 994, 994, 994, 994, -1, 
	994, -1, 994, 994, 994, -1, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, -1, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, -1, 994, -1, -1, -1, 
	-1, 994, 994, 994, 994, 994, -1, -1, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	994, 994, 994, 994, 994, 994, 994, 994, 
	-1, 994, 994, 1127, -1, -1, -1, -1, 
	994, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1127, 
	1127, 1127, 1127, 1127, 1127, 1127, 1127, 1127, 
	1127, 1127, 1127, 1127, 1127, 1127, -1, 1127, 
	1127, 1127, 1127, 1127, 1127, 1127, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 994, 
	994, 994, 994, -1, -1, 994, 994, 994, 
	994, 994, 994, -1, -1, 993, -1, 994, 
	994, 994, 994, 994, 994, 994, 994, -1, 
	-1, -1, -1, 994, -1, -1, -1, -1, 
	994, 994, -1, -1, 994, 994, 994, 994, 
	-1, 994, 994, -1, -1, 994, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 994, 
	994, 994, 994, 994, 994, 994, 994, -1, 
	-1, -1, 994, 994, 994, -1, -1, 994, 
	994, -1, 994, 994, 994, 994, 994, -1, 
	994, 994, 994, -1, -1, -1, 994, 994, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 994, 994, -1, -1, 994, -1, 
	-1, -1, -1, 994, -1, -1, -1, -1, 
	994, -1, 994, 994, 994, 994, 994, 78, 
	81, 82, 79, 80, 87, 88, -1, 83, 
	84, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 164, 165, 167, 166, 168, -1, 
	1127, -1, 1127, 1127, 1127, 1127, 1127, -1, 
	-1, 89, -1, -1, 993, 156, -1, -1, 
	-1, 161, 162, 163, 86, 85, 155, -1, 
	-1, -1, -1, 149, 150, 151, -1, -1, 
	-1, -1, 1011, 147, -1, 171, 173, 175, 
	160, -1, -1, -1, -1, -1, -1, -1, 
	152, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 141, 142, 
	143, 144, 145, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, -1, 996, 996, 996, 996, 996, 
	-1, 996, -1, 996, 996, 996, 996, -1, 
	996, -1, 996, 996, 996, -1, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, -1, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, -1, 996, -1, -1, -1, 
	994, 996, 996, 996, 996, 996, -1, -1, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	996, 996, 996, 996, 996, 996, 996, 996, 
	-1, 996, 996, -1, -1, -1, -1, -1, 
	996, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 266, 137, 138, 139, 140, -1, 146, 
	154, 158, -1, -1, -1, -1, 157, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, 1011, -1, 996, 
	996, 996, 996, -1, -1, 996, 996, 996, 
	996, 996, 996, -1, -1, -1, -1, 996, 
	996, 996, 996, 996, 996, 996, 996, -1, 
	-1, -1, -1, 996, -1, -1, -1, -1, 
	996, 996, -1, -1, 996, 996, 996, 996, 
	-1, 996, 996, -1, -1, 996, -1, 994, 
	-1, -1, -1, -1, -1, -1, -1, 996, 
	996, 996, 996, 996, 996, 996, 996, -1, 
	-1, -1, 996, 996, 996, -1, -1, 996, 
	996, -1, 996, 996, 996, 996, 996, -1, 
	996, 996, 996, -1, -1, -1, 996, 996, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 996, 996, -1, -1, 996, -1, 
	-1, -1, -1, 996, -1, -1, -1, -1, 
	996, -1, 996, 996, 996, 996, 996, -1, 
	-1, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, 1000, 1000, -1, 1000, 1000, 1000, 
	1000, 1000, -1, 1000, -1, 1000, 1000, 1000, 
	1000, -1, 1000, -1, 1000, 1000, 1000, -1, 
	1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, 1000, 1000, 1000, -1, 1000, 1000, 
	1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, 1000, 1000, 1000, -1, 1000, -1, 
	-1, -1, -1, 1000, 1000, 1000, 1000, 1000, 
	1129, -1, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, 1000, -1, 1000, 1000, -1, -1, 1130, 
	-1, -1, 1000, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1129, 1129, 1129, 1129, 
	1129, 1129, 1129, 1129, 1129, 1129, 1129, 1129, 
	1129, 1129, 1129, 1129, 1129, 1129, 1129, 1129, 
	1129, 1129, 1129, 1130, 1130, 1130, 1130, 1130, 
	1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 
	1130, 1130, 1130, 1130, 1130, 1130, 1130, 1130, 
	1130, 1130, -1, -1, -1, -1, -1, -1, 
	-1, 1000, 1000, 1000, 1000, -1, -1, 1000, 
	1000, 1000, 1000, 1000, 1000, -1, -1, -1, 
	996, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, -1, -1, -1, -1, 1000, -1, -1, 
	-1, -1, 1000, 1000, -1, -1, 1000, 1000, 
	1000, 1000, -1, 1000, 1000, -1, -1, 1000, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 
	1000, -1, -1, -1, 1000, 1000, 1000, -1, 
	-1, 1000, 1000, -1, 1000, 1000, 1000, 1000, 
	1000, -1, 1000, 1000, 1000, -1, -1, -1, 
	1000, 1000, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1000, 1000, -1, -1, 
	1000, -1, -1, -1, -1, 1000, -1, -1, 
	-1, -1, 1000, -1, 1000, 1000, 1000, 1000, 
	1000, -1, -1, -1, -1, 1129, -1, 1129, 
	1129, 1129, 1129, 1129, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1130, -1, 1130, 1130, 
	1130, 1130, 1130, -1, -1, -1, -1, 996, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, -1, 1099, 1099, 1099, 1099, 
	1099, -1, 1099, -1, 1099, 1099, 1099, 1099, 
	-1, 1099, -1, 1099, 1099, 1099, -1, 1099, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, -1, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, -1, 1099, -1, -1, 
	-1, -1, 1099, 1099, 1099, 1099, 1099, -1, 
	-1, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	1099, -1, 1099, 1099, -1, -1, -1, -1, 
	-1, 1099, -1, -1, -1, -1, -1, -1, 
	-1, -1, 266, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1000, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1099, 1099, 1099, 1099, -1, -1, 1099, 1099, 
	1099, 1099, 1099, 1099, -1, -1, -1, -1, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	-1, -1, -1, -1, 1099, -1, -1, -1, 
	-1, 1099, 1099, -1, -1, 1099, 1099, 1099, 
	1099, -1, 1099, 1099, -1, -1, 1099, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 
	-1, -1, -1, 1099, 1099, 1099, -1, -1, 
	1099, 1099, -1, 1099, 1099, 1099, 1099, 1099, 
	-1, 1099, 1099, 1099, -1, -1, -1, 1099, 
	1099, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1099, 1099, -1, -1, 1099, 
	-1, -1, -1, -1, 1099, -1, -1, -1, 
	-1, 1099, -1, 1099, 1099, 1099, 1099, 1099, 
	-1, 1000, 1174, 1174, 1174, 1174, 1174, 1174, 
	1174, -1, 1174, 1174, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1174, 1174, 1174, 
	1174, 1174, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1174, -1, -1, -1, 
	1174, -1, -1, -1, 1174, 1174, 1174, 1174, 
	1174, 1174, -1, -1, -1, -1, 1174, 1174, 
	1174, -1, -1, 1120, -1, 1174, 1174, -1, 
	1174, 1174, 1174, 1174, 1174, -1, -1, -1, 
	-1, -1, -1, 1174, -1, -1, -1, -1, 
	-1, -1, -1, 1121, -1, -1, -1, -1, 
	-1, 1174, 1174, 1174, 1174, 1174, -1, 1120, 
	1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 
	1120, 1120, 1120, 1120, 1120, 1120, 1122, 1120, 
	1120, 1120, 1120, 1120, 1120, 1120, -1, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, -1, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, -1, -1, 
	-1, -1, 1122, 1122, 1122, 1122, 1122, 1122, 
	1122, 1122, 1122, 1122, 1122, 1122, 1122, 1122, 
	1122, -1, 1122, 1122, 1122, 1122, 1122, 1122, 
	1122, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1099, -1, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 1156, -1, 
	-1, 1156, 1156, 1156, 1156, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1156, 1156, 1156, -1, -1, -1, 1156, 
	-1, -1, -1, -1, 1156, -1, -1, -1, 
	-1, -1, 1156, 1156, 1174, 1174, 1174, 1174, 
	1174, -1, 1174, 1174, 1174, -1, -1, -1, 
	1156, 1174, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1174, 1174, -1, -1, 
	1120, 1156, 1120, 1120, 1120, 1120, 1120, -1, 
	-1, -1, 1174, -1, 1174, 1174, 1174, 1174, 
	1174, -1, -1, -1, -1, -1, 1156, 1156, 
	1121, -1, 1121, 1121, 1121, 1121, 1121, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 265, -1, -1, -1, -1, 
	-1, -1, -1, 1122, -1, 1122, 1122, 1122, 
	1122, 1122, -1, -1, -1, -1, -1, -1, 
	1099, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, 1002, -1, 1002, -1, 1002, 1002, 1002, 
	1002, 1002, 1002, -1, 1002, 1002, 1002, -1, 
	-1, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, -1, 1002, 1002, 1002, 1002, -1, -1, 
	-1, 1002, 1002, 1002, 1002, 1002, -1, -1, 
	1002, 1002, 1002, 1002, -1, -1, -1, 1002, 
	-1, -1, -1, 1002, 1002, -1, 1002, 1156, 
	1156, 1002, -1, -1, 1002, -1, 1002, -1, 
	1156, 1156, 724, -1, 1156, 1156, -1, -1, 
	-1, -1, -1, 1002, 1002, -1, -1, 1156, 
	-1, -1, -1, -1, 1156, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1002, -1, -1, -1, -1, 
	-1, -1, 1156, 1156, -1, 1002, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 300, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1002, 1002, 1002, 1002, -1, -1, 1002, 
	1002, 1002, 1002, 1002, 1002, -1, -1, -1, 
	-1, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, -1, -1, 1002, -1, 1002, -1, -1, 
	-1, -1, 1002, 1002, -1, 1002, 1002, 1002, 
	1002, 1002, -1, 1002, 1002, -1, -1, 1002, 
	-1, -1, -1, -1, -1, -1, 1002, -1, 
	1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 
	1002, -1, -1, -1, -1, 1002, 1002, -1, 
	1002, 1002, 1002, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1002, 1002, -1, -1, 1002, 
	-1, 1002, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1002, 1002, 1002, -1, -1, 1002, 
	1002, 1002, -1, -1, -1, -1, -1, 1002, 
	1002, -1, -1, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, 1003, -1, 1003, -1, 1003, 
	1003, 1003, 1003, 1003, 1003, -1, 1003, 1003, 
	1003, -1, -1, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, -1, 1003, 1003, 1003, 1003, 
	-1, -1, -1, 1003, 1003, 1003, 1003, 1003, 
	-1, -1, 1003, 1003, 1003, 1003, -1, -1, 
	-1, 1003, -1, -1, -1, 1003, 1003, -1, 
	1003, -1, -1, 1003, -1, -1, 1003, -1, 
	1003, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1003, 1003, -1, 
	-1, -1, -1, -1, 1123, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1003, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1003, 
	1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 
	1123, 1123, 1123, 1123, 1123, 1123, 1123, -1, 
	1123, 1123, 1123, 1123, 1123, 1123, 1123, -1, 
	-1, -1, -1, 1003, 1003, 1003, 1003, -1, 
	-1, 1003, 1003, 1003, 1003, 1003, 1003, -1, 
	-1, -1, 1002, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, -1, -1, 1003, -1, 1003, 
	-1, -1, -1, -1, 1003, 1003, -1, 1003, 
	1003, 1003, 1003, 1003, -1, 1003, 1003, -1, 
	-1, 1003, -1, -1, -1, -1, -1, -1, 
	1003, -1, 1003, 1003, 1003, 1003, 1003, 1003, 
	1003, 1003, 1003, -1, -1, -1, -1, 1003, 
	1003, -1, 1003, 1003, 1003, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1003, 1003, -1, 
	-1, 1003, -1, 1003, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1003, 1003, 1003, -1, 
	-1, 1003, 1003, 1003, -1, -1, -1, -1, 
	-1, 1003, 1003, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 265, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1123, -1, 1123, 1123, 1123, 1123, 1123, 
	-1, 1002, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, 1004, -1, 1004, -1, 1004, 1004, 
	1004, 1004, 1004, 1004, -1, 1004, 1004, 1004, 
	-1, -1, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, -1, 1004, 1004, 1004, 1004, -1, 
	-1, -1, 1004, 1004, 1004, 1004, 1004, -1, 
	-1, 1004, 1004, 1004, 1004, -1, -1, -1, 
	1004, -1, -1, -1, 1004, 1004, -1, 1004, 
	-1, -1, 1004, 724, -1, 1004, -1, 1004, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1004, 1004, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1004, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1004, -1, 
	-1, -1, -1, -1, 1003, -1, 300, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1004, 1004, 1004, 1004, -1, -1, 
	1004, 1004, 1004, 1004, 1004, 1004, -1, -1, 
	-1, -1, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, -1, -1, 1004, -1, 1004, -1, 
	-1, -1, -1, 1004, 1004, -1, 1004, 1004, 
	1004, 1004, 1004, -1, 1004, 1004, -1, -1, 
	1004, -1, -1, -1, -1, -1, -1, 1004, 
	-1, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 
	1004, 1004, -1, -1, -1, -1, 1004, 1004, 
	-1, 1004, 1004, 1004, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1004, 1004, -1, -1, 
	1004, -1, 1004, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1004, 1004, 1004, -1, -1, 
	1004, 1004, 1004, -1, -1, -1, -1, -1, 
	1004, 1004, -1, 1003, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, 1098, 1098, -1, 
	1098, 1098, 1098, 1098, 1098, -1, 1098, -1, 
	1098, 1098, 1098, 1098, -1, 1098, -1, 1098, 
	1098, 1098, -1, 1098, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 
	-1, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 172, 174, 176, 1098, 1098, 
	-1, 1098, -1, -1, -1, -1, 1098, 1098, 
	1098, 1098, 1098, -1, -1, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, 1098, -1, 1098, 1098, 
	-1, -1, -1, -1, -1, 1098, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1098, 1098, 1098, 1098, 
	-1, -1, 1098, 1098, 1098, 1098, 1098, 1098, 
	-1, -1, -1, 1004, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, -1, -1, -1, -1, 
	1098, -1, -1, -1, -1, 1098, 1098, -1, 
	-1, 1098, 1098, 1098, 1098, -1, 1098, 1098, 
	-1, -1, 1098, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1098, 1098, 1098, 1098, 
	1098, 1098, 1098, 1098, -1, -1, -1, 1098, 
	1098, 1098, -1, -1, 1098, 1098, -1, 1098, 
	1098, 1098, 1098, 1098, -1, 1098, 1098, 1098, 
	-1, -1, -1, 1098, 1098, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1098, 
	1098, -1, -1, 1098, -1, -1, -1, -1, 
	1098, -1, -1, -1, -1, 1098, -1, 170, 
	292, 1098, 1098, 1098, -1, -1, -1, 776, 
	776, 776, 776, 776, 776, 776, 776, 776, 
	776, 776, 776, 776, 776, 776, 776, 776, 
	776, 776, 776, 776, 776, 776, 776, 776, 
	776, 776, -1, 776, 776, 776, 776, 776, 
	-1, 776, 1004, 776, 776, 776, 776, -1, 
	776, -1, 776, 776, 776, -1, -1, 776, 
	776, 776, 776, 776, 776, 776, 776, -1, 
	776, 776, 776, -1, -1, -1, -1, 776, 
	776, 776, 776, 776, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 776, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 776, 776, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 776, 
	776, 776, 776, -1, -1, 776, 776, -1, 
	776, 776, 776, -1, -1, 1098, -1, 776, 
	776, 776, -1, 776, 776, 776, 776, -1, 
	-1, -1, -1, 776, -1, -1, -1, -1, 
	776, -1, -1, -1, 776, 776, 776, 776, 
	-1, 776, 776, -1, -1, 776, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 776, 
	776, 776, 776, 776, 776, 776, 776, -1, 
	-1, -1, -1, 776, 776, -1, -1, 776, 
	776, -1, -1, -1, -1, -1, -1, -1, 
	-1, 776, 776, -1, -1, -1, -1, 776, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 776, 776, -1, 
	-1, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, -1, 958, 958, 958, 958, 958, 958, 
	958, 958, -1, -1, -1, 958, 958, 958, 
	958, 958, -1, 958, 1098, 958, 958, 958, 
	958, -1, 958, -1, 958, 958, 958, -1, 
	-1, 958, -1, -1, 958, 958, 958, 958, 
	958, -1, 958, 958, 958, -1, -1, -1, 
	-1, 958, 958, 958, 958, 958, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 203, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 958, 958, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 958, 958, 958, 958, -1, -1, 958, 
	958, 958, 958, 958, 958, -1, -1, -1, 
	776, 958, 958, 958, 958, 958, 958, 958, 
	958, -1, -1, -1, -1, 958, -1, -1, 
	-1, -1, 958, -1, -1, -1, 958, 958, 
	958, 958, -1, 958, 958, -1, -1, 958, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, -1, 958, 958, -1, -1, 
	-1, -1, -1, 164, 165, 167, 166, 168, 
	296, 958, 958, -1, -1, -1, -1, -1, 
	-1, -1, 89, 958, 958, -1, 156, -1, 
	-1, 958, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	-1, -1, -1, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, 958, 
	958, 152, 947, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 141, 
	142, 143, 144, 145, -1, -1, -1, -1, 
	169, 291, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 776, 
	777, 777, 777, 777, 777, 777, 777, 777, 
	777, 777, 777, 777, 777, 777, 777, 777, 
	777, 777, 777, 777, 777, 777, 777, 777, 
	777, 777, 777, -1, 777, 777, 777, 777, 
	777, -1, 777, -1, 777, 777, 777, 777, 
	-1, 777, -1, 777, 777, 777, -1, -1, 
	777, 777, 777, 777, 777, 777, 777, 777, 
	-1, 777, 777, 777, -1, -1, -1, -1, 
	777, 777, 777, 777, 777, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 777, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 274, 
	275, -1, 777, 777, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 229, 
	312, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 230, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 958, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, 1011, -1, 
	777, 777, 777, 777, -1, -1, 777, 777, 
	-1, 777, 777, 777, -1, -1, -1, -1, 
	777, 777, 777, -1, 777, 777, 777, 777, 
	-1, -1, -1, -1, 777, -1, -1, -1, 
	-1, 777, -1, -1, -1, 777, 777, 777, 
	777, -1, 777, 777, -1, -1, 777, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	777, 777, 777, 777, 777, 777, 777, 777, 
	-1, -1, -1, -1, 777, 777, -1, -1, 
	777, 777, -1, -1, -1, -1, -1, -1, 
	-1, -1, 777, 777, -1, -1, -1, -1, 
	777, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 777, 777, 
	-1, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, 958, 958, 958, 958, 958, 958, 
	958, 958, -1, 958, 958, 958, 958, 958, 
	958, 958, 958, -1, -1, -1, 958, 958, 
	958, 958, 958, -1, 958, -1, 958, 958, 
	958, 958, -1, 958, -1, 958, 958, 958, 
	-1, -1, 958, -1, -1, 958, 958, 958, 
	958, 958, -1, 958, 958, 958, -1, -1, 
	-1, -1, 958, 958, 958, 958, 958, -1, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, -1, -1, -1, -1, -1, 
	-1, -1, 203, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 89, -1, 958, 958, 156, -1, 
	-1, -1, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	-1, -1, -1, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, -1, 
	-1, 152, 947, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 141, 
	142, 143, 144, 145, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 958, 958, 958, 958, -1, -1, 
	958, 958, -1, 958, 958, 958, -1, -1, 
	-1, 777, 958, 958, 958, -1, 958, 958, 
	958, 958, -1, -1, -1, -1, 958, -1, 
	-1, -1, -1, 958, 958, -1, -1, 958, 
	958, 958, 958, -1, 958, 958, -1, -1, 
	958, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 958, 958, -1, 
	-1, 296, -1, -1, -1, -1, -1, -1, 
	-1, 301, 958, 958, -1, -1, -1, -1, 
	-1, -1, -1, -1, 958, 958, -1, -1, 
	-1, -1, 958, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	958, 958, -1, -1, -1, -1, -1, 229, 
	313, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 230, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	777, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, 1011, -1, 
	-1, -1, 840, 840, 840, 840, 840, 840, 
	840, 840, 840, 840, 840, 840, 840, 840, 
	840, 840, -1, 840, 840, 840, 840, 840, 
	840, 840, 840, -1, -1, -1, 840, 840, 
	840, 840, 840, -1, 840, -1, 840, 840, 
	840, 840, -1, 840, -1, 840, 840, 840, 
	-1, -1, 840, -1, -1, 840, 840, 840, 
	840, 840, -1, 840, 840, 840, -1, -1, 
	-1, -1, 840, 840, 840, 840, 840, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	229, 312, -1, -1, -1, 316, -1, -1, 
	-1, -1, -1, 230, 137, 138, 139, 140, 
	-1, 146, 154, 158, 840, 840, -1, -1, 
	157, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 958, -1, -1, -1, -1, 
	-1, -1, -1, 169, 159, 153, 148, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 840, 840, 840, 840, -1, -1, 
	840, 840, 840, 840, 840, 840, -1, -1, 
	-1, -1, 840, 840, 840, 840, 840, 840, 
	840, 840, -1, -1, -1, -1, 840, -1, 
	-1, -1, -1, 840, 840, -1, -1, 840, 
	840, 840, 840, -1, 840, 840, -1, -1, 
	840, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 840, 840, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 840, 840, -1, -1, -1, -1, 
	-1, -1, -1, -1, 840, 840, -1, -1, 
	-1, -1, 840, -1, -1, -1, -1, -1, 
	-1, -1, 958, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	840, 840, -1, -1, -1, -1, 845, 845, 
	845, 845, 845, 845, 845, 845, 845, 845, 
	845, 845, 845, 845, 845, 845, -1, 845, 
	845, 845, 845, 845, 845, 845, 845, -1, 
	-1, -1, 845, 845, 845, 845, 845, -1, 
	845, -1, 845, 845, 845, 845, -1, 845, 
	-1, 845, 845, 845, -1, -1, 845, -1, 
	-1, 845, 845, 845, 845, 845, -1, 845, 
	845, 845, -1, -1, -1, -1, 845, 845, 
	845, 845, 845, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 845, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	845, 845, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 845, 845, 
	845, 845, -1, -1, 845, 845, 845, 845, 
	845, 845, -1, 840, -1, -1, 845, 845, 
	845, 845, 845, 845, 845, 845, -1, -1, 
	-1, -1, 845, -1, -1, -1, -1, 845, 
	845, -1, 301, 845, 845, 845, 845, -1, 
	845, 845, -1, -1, 845, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 845, 845, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 845, 845, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	845, 845, -1, -1, -1, -1, 845, -1, 
	229, 313, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 230, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, -1, -1, -1, 
	157, -1, -1, -1, 845, 845, -1, -1, 
	-1, 1146, -1, 1146, 1146, 1146, 1146, 1146, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 169, 159, 153, 148, -1, 
	-1, -1, -1, -1, -1, 1146, 1146, 1146, 
	1146, 1146, 840, 1146, -1, 1146, -1, -1, 
	-1, -1, 1146, -1, -1, 1146, -1, -1, 
	-1, -1, -1, -1, 1146, 1146, 1146, -1, 
	-1, -1, 1146, 1146, 1146, -1, -1, -1, 
	-1, 1146, 1146, 1146, -1, 1146, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 870, 870, 870, 870, 870, 870, 870, 
	870, 870, 870, 870, 870, 870, 870, 870, 
	870, -1, 870, 870, 870, 870, 870, 870, 
	870, 870, -1, -1, -1, 870, 870, 870, 
	870, 870, -1, 870, -1, 870, 870, 870, 
	870, -1, 870, -1, 870, 870, 870, -1, 
	-1, 870, -1, -1, 870, 870, 870, 870, 
	870, -1, 870, 870, 870, 200, -1, -1, 
	-1, 870, 870, 870, 870, 870, -1, 875, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1146, 1146, -1, -1, 1146, 
	1146, 1146, 1146, -1, 1146, -1, -1, 845, 
	-1, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 
	1146, -1, -1, 870, 870, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1146, -1, 
	1146, 1146, -1, 1146, 1146, -1, -1, 1146, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1146, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1146, 1146, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 870, 870, 870, 870, -1, -1, 870, 
	870, 870, 870, 870, 870, -1, -1, -1, 
	-1, 870, 870, 870, 870, 870, 870, 870, 
	870, -1, 322, 199, -1, 870, -1, -1, 
	-1, -1, 870, 870, -1, 320, 870, 870, 
	870, 870, -1, 870, 870, -1, -1, 870, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 870, 870, 845, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 870, 870, -1, -1, -1, -1, -1, 
	-1, -1, -1, 870, 870, -1, -1, -1, 
	-1, 870, -1, -1, -1, 872, 872, 872, 
	872, 872, 872, 872, 872, 872, 872, 872, 
	872, 872, 872, 872, 872, -1, 872, 872, 
	872, 872, 872, 872, 872, 872, -1, 870, 
	870, 872, 872, 872, 872, 872, -1, 872, 
	-1, 872, 872, 872, 872, -1, 872, -1, 
	872, 872, 872, -1, -1, 872, -1, -1, 
	872, 872, 872, 872, 872, -1, 872, 872, 
	872, 872, -1, -1, -1, 872, 872, 872, 
	872, 872, -1, 872, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 872, 
	872, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 872, 872, 872, 
	872, -1, -1, 872, 872, 872, 872, 872, 
	872, -1, -1, -1, -1, 872, 872, 872, 
	872, 872, 872, 872, 872, -1, 872, 872, 
	-1, 872, -1, -1, -1, -1, 872, 872, 
	-1, -1, 872, 872, 872, 872, -1, 872, 
	872, -1, 870, 872, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	872, 872, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 872, 872, -1, 
	-1, -1, -1, -1, -1, -1, -1, 872, 
	872, -1, -1, -1, -1, 872, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 872, 872, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, -1, 988, 988, 988, 
	988, 988, -1, 988, -1, 988, 988, 988, 
	988, -1, 988, -1, 988, 988, 988, 326, 
	-1, 988, 988, 988, 988, 988, 988, 988, 
	988, 870, 988, 988, 988, -1, -1, -1, 
	-1, 988, 988, 988, 988, 988, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 325, -1, -1, -1, -1, 988, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 988, 988, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, 988, 988, 988, -1, 872, 988, 
	988, -1, 988, 988, 988, -1, -1, -1, 
	-1, 988, 988, 988, -1, 988, 988, 988, 
	988, -1, -1, -1, -1, 988, -1, -1, 
	-1, -1, 988, -1, -1, -1, 988, 988, 
	988, 988, -1, 988, 988, -1, -1, 988, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, 988, 988, 988, 988, 988, 988, 
	988, -1, -1, -1, -1, 988, 988, -1, 
	-1, 988, 988, 322, 199, -1, -1, -1, 
	-1, 324, -1, 988, 988, -1, 320, -1, 
	-1, 988, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 988, 
	988, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 872, 775, 775, 
	775, 775, 775, 775, 775, 775, 775, 775, 
	775, 775, 775, 775, 775, 775, 775, 775, 
	775, 775, 775, 775, 775, 775, 775, 775, 
	775, -1, 775, 775, 775, 775, 775, -1, 
	775, -1, 775, 775, 775, 775, -1, 775, 
	-1, 775, 775, 775, -1, -1, 775, 775, 
	775, 775, 775, 775, 775, 775, -1, 775, 
	775, 775, -1, -1, -1, -1, 775, 775, 
	775, 775, 775, -1, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, -1, -1, 
	-1, -1, -1, 775, -1, -1, -1, 164, 
	165, 167, 166, 168, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 89, -1, 
	775, 775, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, -1, -1, -1, -1, 152, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 141, 142, 143, 144, 145, 
	-1, -1, 988, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 775, 775, 
	775, 775, -1, -1, 775, 775, -1, 775, 
	775, 775, -1, -1, -1, -1, 775, 775, 
	775, -1, 775, 775, 775, 775, -1, -1, 
	-1, -1, 775, -1, -1, -1, -1, 775, 
	-1, -1, -1, 775, 775, 775, 775, -1, 
	775, 775, -1, -1, 775, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 775, 775, 
	775, 775, 775, 775, 775, 775, -1, -1, 
	-1, -1, 775, 775, -1, -1, 775, 775, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	775, 775, -1, -1, -1, -1, 775, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 775, 775, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, -1, -1, -1, -1, 327, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 164, 
	165, 167, 166, 168, -1, -1, 169, 159, 
	153, 148, 1011, -1, -1, -1, 89, -1, 
	-1, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, -1, -1, -1, -1, 152, -1, -1, 
	-1, 78, 81, 82, 79, 80, 87, 88, 
	-1, 83, 84, 141, 142, 143, 144, 145, 
	-1, -1, -1, -1, 164, 165, 167, 166, 
	168, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 89, -1, -1, -1, 156, 
	-1, -1, -1, 161, 162, 163, 86, 85, 
	155, -1, -1, -1, -1, 149, 150, 151, 
	-1, -1, -1, -1, 1011, 147, -1, 171, 
	173, 175, 160, -1, -1, -1, -1, -1, 
	-1, -1, 152, 947, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 775, 
	141, 142, 143, 144, 145, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 324, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 331, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, 69, 70, 78, 
	81, 82, 79, 80, 87, 88, 473, 83, 
	84, -1, -1, 48, 49, 53, 51, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, 1011, 54, 55, 56, -1, -1, 
	-1, 89, -1, -1, -1, -1, 50, -1, 
	-1, -1, -1, -1, 86, 85, 775, -1, 
	229, 330, -1, -1, -1, -1, -1, -1, 
	-1, -1, 73, 230, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, -1, -1, -1, 
	157, -1, -1, 955, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	90, 91, -1, 169, 159, 153, 148, 1011, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	924, 924, 924, 924, 924, 924, 924, 924, 
	924, 924, 924, 924, 924, 924, 924, 924, 
	-1, 924, 924, 924, 924, 924, 924, 924, 
	924, -1, -1, -1, 924, 924, 924, 924, 
	924, -1, 924, -1, 924, 924, 924, 924, 
	-1, 924, -1, 924, 924, 924, -1, -1, 
	924, -1, -1, 924, 924, 924, 924, 924, 
	-1, 924, 924, 924, -1, -1, -1, -1, 
	924, 924, 924, 924, 924, -1, -1, -1, 
	-1, -1, -1, -1, 924, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 924, 924, -1, -1, -1, -1, 
	-1, 58, 471, -1, -1, -1, -1, -1, 
	-1, -1, 472, 470, -1, -1, 47, 46, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 76, -1, -1, -1, -1, 57, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 52, 1011, -1, -1, 
	924, 924, 924, 924, -1, -1, 924, 924, 
	924, 924, 924, 924, -1, -1, -1, -1, 
	924, 924, 924, 924, 924, 924, 924, 924, 
	-1, -1, -1, -1, 924, -1, -1, -1, 
	-1, 924, 924, -1, -1, 924, 924, 924, 
	924, -1, 924, 924, -1, -1, 924, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 924, 924, -1, -1, 327, 
	137, 138, 139, 140, -1, 146, 154, 158, 
	924, 924, -1, -1, 157, -1, -1, -1, 
	-1, -1, 924, 924, -1, -1, -1, -1, 
	924, -1, -1, 1059, 1059, 1059, 1059, 1059, 
	1059, 1059, -1, 1059, 1059, -1, -1, 169, 
	159, 153, 148, -1, -1, -1, 1059, 1059, 
	1059, 1059, 1059, -1, -1, -1, 924, 924, 
	-1, -1, -1, -1, -1, 1059, -1, -1, 
	-1, 1059, -1, -1, -1, 1059, 1059, 1059, 
	1059, 1059, 1059, -1, -1, -1, -1, 1059, 
	1059, 1059, -1, -1, -1, -1, 1059, 1059, 
	-1, 1175, 1175, 1175, 1059, 374, -1, -1, 
	-1, -1, -1, -1, 1059, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1059, 1059, 1059, 1059, 1059, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 924, -1, -1, -1, -1, -1, 331, 
	137, 138, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, 1059, 1059, 1059, 
	1059, 1059, -1, 1059, 1059, 1059, -1, -1, 
	-1, -1, 1059, -1, -1, -1, -1, 924, 
	-1, -1, -1, -1, -1, 376, 377, 169, 
	159, 153, 148, -1, -1, -1, 375, -1, 
	-1, 924, -1, -1, -1, 1059, 1059, 1059, 
	1059, 1059, -1, -1, -1, -1, -1, -1, 
	-1, 229, 330, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 230, 137, 138, 139, 
	140, -1, 146, 154, 158, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 169, 159, 153, 148, 
	922, 922, 922, 922, 922, 922, 922, 922, 
	922, 922, 922, 922, 922, 922, 922, 922, 
	924, 922, 922, 922, 922, 922, 922, 922, 
	922, -1, -1, -1, 922, 922, 922, 922, 
	922, -1, 922, -1, 922, 922, 922, 922, 
	-1, 922, 922, 922, 922, 922, -1, -1, 
	922, -1, -1, 922, 922, 922, 922, 922, 
	-1, 922, 922, 922, -1, -1, -1, -1, 
	922, 922, 922, 922, 922, -1, -1, -1, 
	-1, -1, -1, -1, 922, -1, 343, -1, 
	-1, -1, -1, -1, 922, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 922, 922, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 58, 471, -1, -1, -1, -1, 
	-1, -1, -1, 472, 470, -1, -1, 47, 
	46, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 76, -1, -1, -1, -1, 57, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	922, 922, 922, 922, -1, 52, 922, 922, 
	922, 922, 922, 922, -1, -1, -1, -1, 
	922, 922, 922, 922, 922, 922, 922, 922, 
	-1, -1, -1, -1, 922, -1, -1, -1, 
	-1, 922, 922, -1, -1, 922, 922, 922, 
	922, -1, 922, 922, -1, -1, 922, -1, 
	-1, -1, -1, 922, 342, -1, 922, -1, 
	-1, -1, -1, 922, 922, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	922, 922, -1, -1, -1, -1, -1, -1, 
	-1, -1, 922, 922, -1, -1, -1, -1, 
	922, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 922, 922, 
	-1, -1, 927, 927, 927, 927, 927, 927, 
	927, 927, 927, 927, 927, 927, 927, 927, 
	927, 927, -1, 927, 927, 927, 927, 927, 
	927, 927, 927, -1, -1, -1, 927, 927, 
	927, 927, 927, -1, 927, -1, 927, 927, 
	927, 927, -1, 927, -1, 927, 927, 927, 
	-1, -1, 927, -1, -1, 927, 927, 927, 
	927, 927, -1, 927, 927, 927, -1, -1, 
	-1, -1, 927, 927, 927, 927, 927, -1, 
	-1, -1, -1, -1, -1, -1, 927, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 927, 927, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 927, 927, 927, 927, -1, -1, 
	927, 927, 927, 927, 927, 927, -1, -1, 
	-1, 922, 927, 927, 927, 927, 927, 927, 
	927, 927, -1, -1, -1, -1, 927, -1, 
	-1, -1, -1, 927, 927, -1, -1, 927, 
	927, 927, 927, -1, 927, 927, -1, -1, 
	927, -1, -1, -1, -1, -1, -1, 922, 
	-1, -1, -1, -1, -1, 927, 927, -1, 
	-1, -1, -1, -1, -1, -1, 376, 377, 
	-1, 922, 927, 927, -1, -1, -1, 375, 
	-1, -1, -1, -1, 927, 927, -1, -1, 
	-1, -1, 927, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	927, 927, -1, -1, -1, 899, 899, 899, 
	899, 899, 899, 899, 899, 899, 899, 899, 
	899, 899, 899, 899, 899, -1, 899, 899, 
	899, 899, 899, 899, 899, 899, -1, -1, 
	-1, 899, 899, 899, 899, 899, -1, 899, 
	922, 899, 899, 899, 899, -1, 899, -1, 
	899, 899, 899, -1, -1, 899, -1, -1, 
	899, 899, 899, 899, 899, -1, 899, 899, 
	899, -1, -1, -1, -1, 899, 899, 899, 
	899, 899, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 899, 
	899, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 899, 899, 899, 
	899, -1, -1, 899, 899, 899, 899, 899, 
	899, -1, -1, 927, -1, 899, 899, 899, 
	899, 899, 899, 899, 899, -1, -1, -1, 
	-1, 899, -1, -1, -1, -1, 899, 899, 
	-1, -1, 899, 899, 899, 899, -1, 899, 
	899, -1, -1, 899, -1, -1, -1, -1, 
	-1, 927, -1, -1, -1, -1, -1, -1, 
	899, 899, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 927, -1, 899, 899, -1, 
	-1, -1, -1, -1, -1, 342, -1, 899, 
	899, -1, -1, -1, -1, 899, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 899, 899, -1, -1, 904, 
	904, 904, 904, 904, 904, 904, 904, 904, 
	904, 904, 904, 904, 904, 904, 904, -1, 
	904, 904, 904, 904, 904, 904, 904, 904, 
	-1, -1, -1, 904, 904, 904, 904, 904, 
	-1, 904, 927, 904, 904, 904, 904, -1, 
	904, -1, 904, 904, 904, -1, -1, 904, 
	-1, -1, 904, 904, 904, 904, 904, -1, 
	904, 904, 904, -1, -1, -1, -1, 904, 
	904, 904, 904, 904, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 904, 904, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 904, 
	904, 904, 904, -1, -1, 904, 904, 904, 
	904, 904, 904, -1, -1, -1, 899, 904, 
	904, 904, 904, 904, 904, 904, 904, -1, 
	-1, -1, -1, 904, -1, -1, -1, -1, 
	904, 904, -1, -1, 904, 904, 904, 904, 
	-1, 904, 904, -1, -1, 904, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 904, 904, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 904, 
	904, -1, -1, -1, -1, -1, -1, -1, 
	-1, 904, 904, -1, -1, -1, -1, 904, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 904, 904, -1, 
	-1, -1, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, -1, 1085, 1085, 
	1085, 1085, 1085, -1, 1085, 899, 1085, 1085, 
	1085, 1085, -1, 1085, -1, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, -1, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, -1, 1085, 
	-1, -1, 1085, -1, 1085, 1085, 1085, 1085, 
	1085, -1, -1, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, 1085, -1, 1085, 1085, -1, -1, 
	-1, -1, -1, 1085, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1085, 1085, 1085, 1085, -1, -1, 
	1085, 1085, 1085, 1085, 1085, 1085, -1, -1, 
	904, -1, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, -1, -1, -1, -1, 1085, -1, 
	-1, -1, -1, 1085, 1085, -1, -1, 1085, 
	1085, 1085, 1085, -1, 1085, 1085, -1, -1, 
	1085, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1085, 1085, 1085, 1085, 1085, 1085, 
	1085, 1085, -1, -1, -1, 1085, 1085, 1085, 
	-1, -1, 1085, 1085, -1, 1085, 1085, 1085, 
	1085, 1085, 1085, 1085, 1085, 1085, -1, -1, 
	-1, 1085, 1085, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1085, 1085, -1, 
	-1, 1085, -1, -1, -1, -1, 1085, -1, 
	-1, -1, -1, 1085, -1, 1085, 1085, 1085, 
	1085, 1085, -1, -1, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, -1, 
	1033, 1033, 1033, 1033, 1033, -1, 1033, 904, 
	1033, 1033, 1033, 1033, -1, 1033, -1, 1033, 
	1033, 1033, -1, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	-1, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	-1, 1033, -1, -1, -1, -1, 1033, 1033, 
	1033, 1033, 1033, -1, -1, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, 1033, -1, 1033, 1033, 
	-1, -1, -1, -1, -1, 1033, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1033, 1033, 1033, 1033, 
	-1, -1, 1033, 1033, 1033, 1033, 1033, 1033, 
	-1, -1, -1, 1085, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, -1, -1, -1, -1, 
	1033, -1, -1, -1, -1, 1033, 1033, -1, 
	-1, 1033, 1033, 1033, 1033, -1, 1033, 1033, 
	-1, -1, 1033, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1033, 1033, 1033, 1033, 
	1033, 1033, 1033, 1033, -1, -1, -1, 1033, 
	1033, 1033, -1, -1, 1033, 1033, -1, 1033, 
	1033, 1033, 1033, 1033, -1, 1033, 1033, 1033, 
	-1, -1, -1, 1033, 1033, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1033, 
	1033, -1, -1, 1033, -1, -1, -1, -1, 
	1033, -1, -1, -1, -1, 1033, -1, 1033, 
	1033, 1033, 1033, 1033, -1, -1, -1, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	1056, 1056, -1, 1056, 1056, 1056, 1056, 1056, 
	-1, 1056, 1085, 1056, 1056, 1056, 1056, -1, 
	1056, -1, 1056, 1056, 1056, -1, 1056, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	1056, 1056, 1056, -1, 1056, 1056, 1056, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	1056, 1056, 1056, -1, 1056, -1, -1, -1, 
	-1, 1056, 1056, 1056, 1056, 1056, -1, -1, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, 1056, 
	-1, 1056, 1056, -1, -1, -1, -1, -1, 
	1056, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1056, 
	1056, 1056, 1056, -1, -1, 1056, 1056, 1056, 
	1056, 1056, 1056, -1, -1, 1033, -1, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, -1, 
	-1, -1, -1, 1056, -1, -1, -1, -1, 
	1056, 1056, -1, -1, 1056, 1056, 1056, 1056, 
	-1, 1056, 1056, -1, -1, 1056, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1056, 
	1056, 1056, 1056, 1056, 1056, 1056, 1056, -1, 
	-1, -1, 1056, 1056, 1056, 1056, -1, 1056, 
	1056, -1, 1056, 1056, 1056, 1056, 1056, -1, 
	1056, 1056, 1056, -1, -1, -1, 1056, 1056, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1056, 1056, -1, -1, 1056, -1, 
	-1, -1, -1, 1056, -1, -1, -1, -1, 
	1056, -1, 1056, 1056, 1056, 1056, 1056, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1056, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1033, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 
	-1, 1055, 1055, 1055, 1055, 1055, -1, 1055, 
	-1, 1055, 1055, 1055, 1055, -1, 1055, -1, 
	1055, 1055, 1055, -1, 1055, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 
	1055, -1, 1055, 1055, 1055, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 245, 247, 249, 1055, 
	1055, -1, 1055, -1, -1, -1, -1, 1055, 
	1055, 1055, 1055, 1055, -1, -1, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, 1055, -1, 1055, 
	1055, -1, -1, -1, -1, -1, 1055, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1056, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1055, 1055, 1055, 
	1055, -1, -1, 1055, 1055, 1055, 1055, 1055, 
	1055, -1, -1, -1, -1, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, -1, -1, -1, 
	-1, 1055, -1, -1, -1, -1, 1055, 1055, 
	-1, -1, 1055, 1055, 1055, 1055, -1, 1055, 
	1055, -1, -1, 1055, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1055, 1055, 1055, 
	1055, 1055, 1055, 1055, 1055, -1, -1, -1, 
	1055, 1055, 1055, 1055, -1, 1055, 1055, -1, 
	1055, 1055, 1055, 1055, 1055, -1, 1055, 1055, 
	1055, -1, -1, -1, 1055, 1055, -1, -1, 
	-1, -1, -1, -1, -1, 243, 392, -1, 
	1055, 1055, -1, -1, 1055, -1, -1, -1, 
	-1, 1055, -1, -1, -1, -1, 1055, -1, 
	1055, 1055, 1055, 1055, 1055, -1, -1, 1056, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1055, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, -1, 988, 988, 988, 988, 988, 
	-1, 988, -1, 988, 988, 988, 988, -1, 
	988, -1, 988, 988, 988, 326, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, -1, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, -1, 988, -1, -1, 325, 
	-1, 988, 988, 988, 988, 988, -1, -1, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	-1, 988, 988, -1, -1, -1, -1, -1, 
	988, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1055, 988, 
	988, 988, 988, -1, -1, 988, 988, 988, 
	988, 988, 988, -1, -1, -1, -1, 988, 
	988, 988, 988, 988, 988, 988, 988, -1, 
	-1, -1, -1, 988, -1, -1, -1, -1, 
	988, 988, -1, -1, 988, 988, 988, 988, 
	-1, 988, 988, -1, -1, 988, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 988, 
	988, 988, 988, 988, 988, 988, 988, -1, 
	-1, -1, 988, 988, 988, -1, -1, 988, 
	988, -1, 988, 988, 988, 988, 988, 393, 
	988, 988, 988, -1, -1, -1, 988, 988, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 988, 988, -1, -1, 988, -1, 
	-1, -1, -1, 988, -1, -1, -1, -1, 
	988, -1, 988, 988, 988, 988, 988, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1055, -1, -1, 
	-1, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, -1, 988, 988, 988, 
	988, 988, -1, 988, -1, 988, 988, 988, 
	988, -1, 988, -1, 988, 988, 988, 326, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, -1, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, -1, 988, -1, 
	-1, 325, -1, 988, 988, 988, 988, 988, 
	-1, -1, 988, 988, 988, 988, 988, 988, 
	988, 988, 988, 988, 988, 988, 988, 988, 
	988, 988, -1, 988, 988, -1, -1, -1, 
	-1, -1, 988, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	988, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, 988, 988, 988, -1, -1, 988, 
	988, 988, 988, 988, 988, -1, -1, -1, 
	-1, 988, 988, 988, 988, 988, 988, 988, 
	988, -1, -1, -1, -1, 988, -1, -1, 
	-1, -1, 988, 988, -1, -1, 988, 988, 
	988, 988, -1, 988, 988, -1, -1, 988, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, 988, 988, 988, 988, 988, 988, 
	988, -1, -1, -1, 988, 988, 988, -1, 
	-1, 988, 988, -1, 988, 988, 988, 988, 
	988, 394, 988, 988, 988, -1, 243, 392, 
	988, 988, -1, -1, -1, 3, -1, 41, 
	395, 38, 36, 39, 988, 988, -1, -1, 
	988, -1, -1, -1, -1, 988, -1, -1, 
	43, -1, 988, -1, 988, 988, 988, 988, 
	988, 861, 861, 861, 861, 861, -1, 45, 
	-1, 414, -1, -1, -1, -1, 63, 988, 
	-1, 61, 59, -1, -1, -1, -1, -1, 
	861, 861, 861, -1, -1, -1, 66, 68, 
	67, -1, -1, -1, -1, 92, 93, 94, 
	64, 861, 1059, 1059, 1059, 1059, 1059, 1059, 
	1059, -1, 1059, 1059, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1059, 1059, 1059, 
	1059, 1059, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1059, -1, -1, -1, 
	1059, -1, -1, -1, 1059, 1059, 1059, 1059, 
	1059, 1059, -1, -1, -1, -1, 1059, 1059, 
	1059, -1, -1, -1, -1, 1059, 1059, -1, 
	1175, 1175, 1175, 1059, 434, -1, -1, -1, 
	-1, -1, -1, 1059, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1059, 1059, 1059, 1059, 1059, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 412, 410, 
	62, -1, -1, 409, 411, -1, -1, 413, 
	408, -1, -1, -1, -1, 44, 406, 407, 
	-1, 42, 404, 37, 398, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 405, 396, 
	-1, -1, 402, -1, 403, 397, -1, 399, 
	400, -1, 988, 401, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 164, 165, 167, 166, 168, -1, 861, 
	861, -1, -1, -1, -1, -1, -1, -1, 
	89, -1, -1, -1, 156, -1, -1, -1, 
	161, 162, 163, 86, 85, 155, -1, -1, 
	-1, -1, 149, 150, 151, -1, -1, -1, 
	393, 1011, 147, -1, 171, 173, 175, 160, 
	-1, -1, -1, -1, -1, -1, -1, 152, 
	-1, -1, -1, -1, 1059, 1059, 1059, 1059, 
	1059, -1, 1059, 1059, 1059, -1, -1, -1, 
	-1, 1059, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 436, 437, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 435, -1, 1059, 1059, 1059, 1059, 
	1059, -1, -1, -1, -1, -1, -1, -1, 
	-1, 988, -1, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, -1, 979, 
	979, 979, 979, 979, -1, 979, -1, 979, 
	979, 979, 979, -1, 979, -1, 979, 979, 
	979, -1, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, -1, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, -1, 
	979, -1, -1, -1, -1, 979, 979, 979, 
	979, 979, -1, -1, 979, 979, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	979, 979, 979, 979, -1, 979, 979, -1, 
	-1, -1, -1, -1, 979, -1, 439, 154, 
	158, -1, -1, -1, -1, 157, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	169, 159, 153, 148, 1011, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 979, 979, 979, 979, -1, 
	-1, 979, 979, 979, 979, 979, 979, -1, 
	-1, -1, -1, 979, 979, 979, 979, 979, 
	979, 979, 979, -1, -1, -1, -1, 979, 
	-1, -1, -1, -1, 979, 979, -1, -1, 
	979, 979, 979, 979, -1, 979, 979, -1, 
	-1, 979, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 979, 979, 979, 979, 979, 
	979, 979, 979, -1, -1, -1, 979, 979, 
	979, -1, 394, 979, 979, -1, 979, 979, 
	979, 979, 979, -1, 979, 979, 979, -1, 
	-1, -1, 979, 979, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 979, 979, 
	-1, -1, 979, -1, -1, -1, -1, 979, 
	-1, -1, -1, -1, 979, -1, 979, 979, 
	979, 979, 979, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, -1, 980, 980, 980, 980, 980, 
	-1, 980, -1, 980, 980, 980, 980, -1, 
	980, -1, 980, 980, 980, -1, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, -1, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, -1, 980, -1, -1, -1, 
	-1, 980, 980, 980, 980, 980, -1, -1, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	980, 980, 980, 980, 980, 980, 980, 980, 
	-1, 980, 980, -1, -1, -1, -1, -1, 
	980, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 412, 
	410, 62, -1, -1, 409, 411, -1, -1, 
	413, 408, -1, -1, -1, -1, 44, 406, 
	407, -1, 42, 404, 37, 398, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 405, 
	396, -1, -1, 402, -1, 403, 397, -1, 
	399, 400, -1, -1, 401, -1, -1, 980, 
	980, 980, 980, -1, 979, 980, 980, 980, 
	980, 980, 980, -1, -1, -1, -1, 980, 
	980, 980, 980, 980, 980, 980, 980, -1, 
	-1, -1, -1, 980, -1, -1, -1, -1, 
	980, 980, -1, -1, 980, 980, 980, 980, 
	-1, 980, 980, -1, -1, 980, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 980, 
	980, 980, 980, 980, 980, 980, 980, -1, 
	-1, -1, 980, 980, 980, -1, -1, 980, 
	980, -1, 980, 980, 980, 980, 980, -1, 
	980, 980, 980, -1, -1, -1, 980, 980, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 980, 980, -1, -1, 980, -1, 
	-1, -1, -1, 980, -1, 436, 437, -1, 
	980, -1, 980, 980, 980, 980, 980, -1, 
	-1, -1, -1, 435, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 979, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 69, 
	70, 78, 81, 82, 79, 80, 87, 88, 
	-1, 83, 84, -1, -1, 48, 49, 53, 
	51, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 54, 55, 56, 
	-1, -1, -1, 89, -1, -1, -1, -1, 
	50, -1, -1, -1, -1, -1, 86, 85, 
	-1, -1, -1, -1, -1, -1, -1, 439, 
	154, 158, -1, -1, 73, -1, 157, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 276, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, -1, -1, -1, 
	-1, -1, 90, 91, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	980, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, -1, 982, 982, 982, 
	982, 982, -1, 982, -1, 982, 982, 982, 
	982, -1, 982, -1, 982, 982, 982, -1, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, -1, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, -1, 982, -1, 
	-1, -1, -1, 982, 982, 982, 982, 982, 
	-1, -1, 982, 982, 982, 982, 982, 982, 
	982, 982, 982, 982, 982, 982, 982, 982, 
	982, 982, -1, 982, 982, -1, -1, -1, 
	-1, -1, 982, 58, 277, -1, -1, -1, 
	-1, -1, -1, 476, -1, -1, -1, -1, 
	47, 46, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 76, -1, -1, -1, 980, 
	57, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 52, 1011, 
	-1, 982, 982, 982, 982, -1, -1, 982, 
	982, 982, 982, 982, 982, -1, -1, -1, 
	-1, 982, 982, 982, 982, 982, 982, 982, 
	982, -1, -1, -1, -1, 982, -1, -1, 
	-1, -1, 982, 982, -1, -1, 982, 982, 
	982, 982, -1, 982, 982, -1, -1, 982, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 982, 982, 982, 982, 982, 982, 982, 
	982, -1, -1, -1, 982, 982, 982, -1, 
	-1, 982, 982, -1, 982, 982, 982, 982, 
	982, -1, 982, 982, 982, -1, -1, -1, 
	982, 982, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 982, 982, -1, -1, 
	982, -1, -1, -1, -1, 982, -1, -1, 
	-1, -1, 982, -1, 982, 982, 982, 982, 
	982, -1, -1, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, -1, 983, 
	983, 983, 983, 983, -1, 983, -1, 983, 
	983, 983, 983, -1, 983, -1, 983, 983, 
	983, -1, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, -1, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, -1, 
	983, -1, -1, -1, -1, 983, 983, 983, 
	983, 983, -1, -1, 983, 983, 983, 983, 
	983, 983, 983, 983, 983, 983, 983, 983, 
	983, 983, 983, 983, -1, 983, 983, -1, 
	-1, -1, -1, -1, 983, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 983, 983, 983, 983, -1, 
	-1, 983, 983, 983, 983, 983, 983, -1, 
	-1, -1, 982, 983, 983, 983, 983, 983, 
	983, 983, 983, -1, -1, -1, -1, 983, 
	-1, -1, -1, -1, 983, 983, -1, -1, 
	983, 983, 983, 983, -1, 983, 983, -1, 
	-1, 983, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 983, 983, 983, 983, 983, 
	983, 983, 983, -1, -1, -1, 983, 983, 
	983, -1, -1, 983, 983, -1, 983, 983, 
	983, 983, 983, -1, 983, 983, 983, -1, 
	-1, -1, 983, 983, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 983, 983, 
	-1, -1, 983, -1, -1, -1, -1, 983, 
	-1, -1, -1, -1, 983, -1, 983, 983, 
	983, 983, 983, -1, -1, -1, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, -1, 984, 984, 984, 984, 984, -1, 
	984, 982, 984, 984, 984, 984, -1, 984, 
	-1, 984, 984, 984, -1, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, -1, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, -1, 984, -1, -1, -1, -1, 
	984, 984, 984, 984, 984, -1, -1, 984, 
	984, 984, 984, 984, 984, 984, 984, 984, 
	984, 984, 984, 984, 984, 984, 984, -1, 
	984, 984, -1, -1, -1, -1, -1, 984, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 58, 277, -1, -1, 
	-1, -1, -1, -1, 476, -1, -1, -1, 
	-1, 47, 46, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 76, -1, -1, -1, 
	-1, 57, -1, -1, -1, -1, 984, 984, 
	984, 984, -1, -1, 984, 984, 984, 984, 
	984, 984, -1, -1, 983, -1, 984, 984, 
	984, 984, 984, 984, 984, 984, -1, 52, 
	-1, -1, 984, -1, -1, -1, -1, 984, 
	984, -1, -1, 984, 984, 984, 984, -1, 
	984, 984, -1, -1, 984, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 984, 984, 
	984, 984, 984, 984, 984, 984, -1, -1, 
	-1, 984, 984, 984, -1, -1, 984, 984, 
	-1, 984, 984, 984, 984, 984, -1, 984, 
	984, 984, -1, -1, -1, 984, 984, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 984, 984, -1, -1, 984, -1, -1, 
	-1, -1, 984, -1, -1, -1, -1, 984, 
	-1, 984, 984, 984, 984, 984, -1, -1, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 449, 450, -1, 943, 943, 943, 943, 
	943, -1, 943, 983, 943, 943, 943, 943, 
	-1, 943, -1, 943, 943, 943, -1, -1, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	-1, 943, 943, 943, -1, -1, -1, -1, 
	943, 943, 943, 943, 943, -1, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, -1, -1, -1, 943, -1, -1, 
	-1, 164, 165, 167, 166, 168, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	89, -1, 943, 943, 156, -1, -1, -1, 
	161, 162, 163, 86, 85, 155, -1, -1, 
	-1, -1, 149, 150, 151, -1, -1, -1, 
	-1, 1011, 147, -1, 171, 173, 175, 160, 
	-1, -1, -1, -1, -1, -1, -1, 152, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 141, 142, 143, 
	144, 145, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	943, 943, 943, 943, -1, -1, 943, 943, 
	-1, 943, 943, 943, -1, -1, -1, 984, 
	943, 943, 943, -1, 943, 943, 943, 943, 
	-1, -1, -1, -1, 943, -1, -1, -1, 
	-1, 943, -1, -1, -1, 943, 943, 943, 
	943, -1, 943, 943, -1, -1, 943, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	943, 943, 943, 943, 943, 444, 446, 448, 
	-1, -1, -1, -1, 943, 943, -1, -1, 
	943, 943, -1, -1, -1, -1, -1, -1, 
	-1, -1, 943, 943, -1, -1, -1, -1, 
	943, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 943, 943, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 441, 138, 139, 140, -1, 146, 154, 
	158, -1, -1, -1, -1, 157, -1, 78, 
	81, 82, 79, 80, 87, 88, 984, 83, 
	84, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 164, 165, 167, 166, 168, -1, 
	169, 159, 153, 148, 1011, -1, -1, -1, 
	-1, 89, -1, -1, -1, 156, -1, -1, 
	-1, 161, 162, 163, 86, 85, 155, -1, 
	-1, -1, -1, 149, 150, 151, -1, -1, 
	-1, -1, 1011, 147, -1, 171, 173, 175, 
	160, -1, -1, -1, -1, -1, -1, -1, 
	152, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 141, 142, 
	143, 144, 145, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 952, 952, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, 952, 952, 952, 
	952, 952, 952, 952, 952, -1, 952, 952, 
	952, 952, 952, -1, 952, -1, 952, 952, 
	952, 952, -1, 952, -1, 952, 952, 952, 
	-1, 943, 952, 952, 952, 952, 952, 952, 
	952, 952, -1, 952, 952, 952, -1, -1, 
	-1, -1, 952, 952, 952, 952, 952, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 952, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 952, 952, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 442, 138, 139, 140, -1, 146, 
	154, 158, -1, -1, -1, -1, 157, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, 1011, -1, -1, 
	-1, -1, 952, 952, 952, 952, -1, -1, 
	952, 952, -1, 952, 952, 952, -1, -1, 
	943, -1, 952, 952, 952, -1, 952, 952, 
	952, 952, -1, -1, -1, -1, 952, -1, 
	-1, -1, -1, 952, -1, -1, -1, 952, 
	952, 952, 952, -1, 952, 952, -1, -1, 
	952, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 952, 952, 952, 952, 952, 952, 
	952, 952, -1, -1, -1, -1, 952, 952, 
	-1, -1, 952, 952, -1, -1, -1, -1, 
	-1, -1, -1, -1, 952, 952, -1, -1, 
	-1, -1, 952, 78, 81, 82, 79, 80, 
	87, 88, -1, 83, 84, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 164, 165, 
	167, 166, 168, -1, -1, -1, -1, -1, 
	952, 952, -1, -1, -1, 89, -1, -1, 
	-1, 156, -1, -1, -1, 161, 162, 163, 
	86, 85, 155, -1, -1, -1, -1, 149, 
	150, 151, -1, -1, -1, -1, 1011, 147, 
	-1, 171, 173, 175, 160, -1, -1, -1, 
	-1, -1, -1, -1, 152, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, -1, 141, 142, 143, 144, 145, -1, 
	164, 165, 167, 166, 168, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 89, 
	-1, -1, -1, 156, -1, -1, -1, 161, 
	162, 163, 86, 85, 155, -1, -1, -1, 
	-1, 149, 150, 151, -1, -1, -1, -1, 
	1011, 147, -1, 171, 173, 175, 160, -1, 
	-1, -1, -1, -1, -1, -1, 152, -1, 
	-1, -1, -1, -1, -1, -1, 443, 445, 
	447, -1, -1, -1, 141, 142, 143, 144, 
	145, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 952, -1, -1, -1, -1, 
	-1, -1, 441, 138, 139, 140, -1, 146, 
	154, 158, -1, -1, -1, -1, 157, 451, 
	139, 140, -1, 146, 154, 158, -1, -1, 
	-1, -1, 157, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, -1, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, 1011, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 452, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	164, 165, 167, 166, 168, -1, -1, 169, 
	159, 153, 148, 1011, -1, -1, -1, 89, 
	-1, -1, 952, 156, -1, -1, -1, 161, 
	162, 163, 86, 85, 155, -1, -1, -1, 
	-1, 149, 150, 151, -1, -1, -1, -1, 
	1011, 147, -1, 171, 173, 175, 160, -1, 
	-1, -1, -1, -1, -1, -1, 152, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 141, 142, 143, 144, 
	145, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 442, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 453, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 78, 81, 82, 79, 80, 87, 
	88, -1, 83, 84, -1, -1, -1, 169, 
	159, 153, 148, 1011, -1, 164, 165, 167, 
	166, 168, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 89, -1, -1, -1, 
	156, -1, -1, -1, 161, 162, 163, 86, 
	85, 155, -1, -1, -1, -1, 149, 150, 
	151, -1, -1, -1, -1, 1011, 147, -1, 
	171, 173, 175, 160, -1, -1, -1, -1, 
	-1, -1, -1, 152, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, -1, -1, 
	-1, 141, 142, 143, 144, 145, -1, 164, 
	165, 167, 166, 168, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 89, -1, 
	-1, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, -1, -1, -1, -1, 152, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, -1, 141, 142, 143, 144, 145, 
	-1, 164, 165, 167, 166, 168, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	89, -1, -1, -1, 156, -1, -1, -1, 
	161, 162, 163, 86, 85, 155, -1, -1, 
	-1, -1, 149, 150, 151, -1, -1, -1, 
	-1, 1011, 147, -1, 171, 173, 175, 160, 
	-1, -1, -1, -1, -1, -1, -1, 152, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 141, 142, 143, 
	144, 145, -1, -1, -1, -1, 454, 139, 
	140, -1, 146, 154, 158, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	451, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, 169, 159, 153, 148, 
	1011, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, -1, -1, -1, -1, -1, -1, 
	455, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 452, 139, 140, -1, 146, 154, 
	158, -1, -1, -1, -1, 157, 169, 159, 
	153, 148, 1011, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	169, 159, 153, 148, -1, -1, -1, -1, 
	-1, -1, 456, 139, 140, -1, 146, 154, 
	158, -1, -1, -1, -1, 157, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 164, 165, 167, 166, 168, -1, -1, 
	169, 159, 153, 148, 1011, -1, -1, -1, 
	89, -1, -1, -1, 156, -1, -1, -1, 
	161, 162, 163, 86, 85, 155, -1, -1, 
	-1, -1, 149, 150, 151, -1, -1, -1, 
	-1, 1011, 147, -1, 171, 173, 175, 160, 
	-1, -1, -1, -1, -1, -1, -1, 152, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, -1, -1, 141, 142, 143, 
	144, 145, -1, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 89, -1, -1, -1, 156, -1, 
	-1, -1, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	-1, -1, -1, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, -1, 
	-1, 152, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 141, 
	142, 143, 144, 145, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 453, 139, 140, -1, 146, 154, 
	158, -1, -1, -1, -1, 157, -1, -1, 
	-1, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, -1, -1, 953, 
	953, 953, 953, -1, -1, -1, -1, -1, 
	169, 159, 153, 148, -1, -1, -1, 953, 
	953, 953, -1, 457, 140, 953, 146, 154, 
	158, -1, 953, -1, -1, 157, -1, -1, 
	953, 953, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 953, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	169, 159, 153, 148, 1011, -1, -1, 953, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 953, 953, -1, -1, 
	-1, -1, -1, -1, -1, 458, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, -1, 169, 159, 153, 148, 1011, -1, 
	164, 165, 167, 166, 168, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 89, 
	-1, -1, -1, 156, -1, -1, -1, 161, 
	162, 163, 86, 85, 155, -1, -1, -1, 
	-1, 149, 150, 151, -1, -1, -1, -1, 
	1011, 147, -1, 171, 173, 175, 160, -1, 
	-1, -1, -1, -1, -1, -1, 152, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 141, 142, 143, 144, 
	145, -1, -1, -1, -1, 953, 953, -1, 
	-1, -1, -1, -1, -1, -1, 953, 953, 
	953, -1, 953, 953, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 953, -1, 454, 
	139, 140, 953, 146, 154, 158, -1, -1, 
	-1, -1, 157, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	953, 953, -1, -1, -1, 169, 159, 153, 
	148, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 953, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 455, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 169, 
	159, 153, 148, -1, -1, -1, -1, -1, 
	-1, -1, -1, 460, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 456, 139, 140, -1, 146, 
	154, 158, -1, -1, -1, -1, 157, 169, 
	159, 153, 148, 1011, -1, -1, -1, -1, 
	-1, -1, 78, 81, 82, 79, 80, 87, 
	88, -1, 83, 84, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, 164, 165, 167, 
	166, 168, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 89, -1, -1, -1, 
	156, -1, -1, -1, 161, 162, 163, 86, 
	85, 155, -1, -1, -1, -1, 149, 150, 
	151, -1, -1, -1, -1, 1011, 147, -1, 
	171, 173, 175, 160, -1, -1, -1, -1, 
	-1, -1, -1, 152, -1, -1, -1, 1170, 
	1170, 1170, 1170, 1170, 1170, 1170, -1, 1170, 
	1170, 141, 142, 143, 144, 145, -1, -1, 
	-1, -1, 1170, 1170, 1170, 1170, 1170, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1170, -1, -1, -1, 1170, -1, -1, 
	-1, 1170, 1170, 1170, 1170, 1170, 1170, -1, 
	-1, -1, -1, 1170, 1170, 1170, -1, -1, 
	-1, -1, 1170, 1170, -1, 1170, 1170, 1170, 
	1170, -1, -1, -1, -1, -1, -1, -1, 
	1170, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1170, 1170, 
	1170, 1170, 1170, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1170, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 457, 140, -1, 146, 
	154, 158, -1, -1, -1, -1, 157, -1, 
	459, -1, 146, 154, 158, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, -1, -1, -1, 
	-1, -1, -1, -1, 169, 159, 153, 148, 
	1011, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 458, 140, 
	-1, 146, 154, 158, -1, -1, -1, -1, 
	157, 1170, 1170, 1170, 1170, 1170, -1, 1170, 
	1170, 1170, -1, -1, -1, -1, 1170, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1170, 1170, 169, 159, 153, 148, -1, 
	-1, -1, 1170, -1, -1, -1, -1, -1, 
	-1, 1170, 1170, 1170, 1170, 1170, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 539, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, 1017, -1, 1017, -1, 
	1017, 1017, 1017, 1017, 1017, 1017, -1, 1017, 
	1017, 1017, -1, -1, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, -1, 1017, 1017, 1017, 
	1017, -1, -1, -1, 1017, 1017, 1017, 1017, 
	1017, -1, -1, 1017, 1017, 1017, 1017, -1, 
	-1, -1, 1017, 328, -1, -1, 1017, 1017, 
	-1, 1017, 337, 339, 1017, -1, -1, 1017, 
	340, 1017, -1, -1, -1, -1, -1, -1, 
	-1, 338, -1, -1, -1, -1, 1017, 1017, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1017, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1017, -1, -1, -1, 460, -1, 146, 154, 
	158, -1, -1, -1, -1, 157, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1017, 1017, 1017, 1017, 
	-1, -1, 1017, 1017, 1017, 1017, 1017, 1017, 
	169, 159, 153, 148, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, -1, -1, 1017, -1, 
	1017, -1, -1, -1, -1, 1017, 1017, -1, 
	1017, 1017, 1017, 1017, 1017, -1, 1017, 1017, 
	-1, -1, 1017, -1, -1, -1, -1, -1, 
	-1, 1017, -1, 1017, 1017, 1017, 1017, 1017, 
	1017, 1017, 1017, 1017, -1, -1, -1, -1, 
	1017, 1017, -1, 1017, 1017, 1017, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1017, 1017, 
	462, -1, 1017, -1, 1017, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1017, 1017, 1017, 
	-1, -1, 1017, 1017, 1017, -1, -1, -1, 
	-1, -1, 1017, 1017, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, -1, 1097, 1097, 1097, 
	1097, 1097, -1, 1097, -1, 1097, 1097, 1097, 
	1097, -1, 1097, -1, 1097, 1097, 1097, -1, 
	1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, -1, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, -1, 1097, -1, 
	-1, -1, -1, 1097, 1097, 1097, 1097, 1097, 
	-1, -1, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, 1097, -1, 1097, 1097, -1, -1, -1, 
	-1, -1, 1097, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 459, -1, 146, 154, 158, -1, -1, 
	-1, -1, 157, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, 1097, 1097, 1097, 1097, 1017, -1, 1097, 
	1097, 1097, 1097, 1097, 1097, -1, -1, -1, 
	-1, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, -1, -1, -1, -1, 1097, -1, -1, 
	-1, -1, 1097, 1097, -1, -1, 1097, 1097, 
	1097, 1097, -1, 1097, 1097, -1, -1, 1097, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1097, 1097, 1097, 1097, 1097, 1097, 1097, 
	1097, -1, -1, -1, 1097, 1097, 1097, -1, 
	-1, 1097, 1097, -1, 1097, 1097, 1097, 1097, 
	1097, -1, 1097, 1097, 1097, -1, -1, -1, 
	1097, 1097, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1097, 1097, -1, 539, 
	1097, -1, -1, -1, -1, 1097, -1, -1, 
	-1, -1, 1097, -1, 1097, 1097, 1097, 1097, 
	1097, 78, 81, 82, 79, 80, 87, 88, 
	-1, 83, 84, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 164, 165, 167, 166, 
	168, -1, -1, -1, 1017, -1, -1, -1, 
	-1, -1, -1, 89, -1, -1, -1, 156, 
	-1, -1, -1, 161, 162, 163, 86, 85, 
	155, -1, -1, -1, -1, 149, 150, 151, 
	-1, -1, -1, -1, 1011, 147, -1, 171, 
	173, 175, 160, -1, -1, -1, -1, -1, 
	-1, -1, 152, 947, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	141, 142, 143, 144, 145, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	772, 772, 772, 772, 772, 772, 772, 772, 
	772, 772, 772, 772, 772, 772, 772, 772, 
	772, 772, 772, 772, 772, 772, 772, 772, 
	772, 772, 772, -1, 772, 772, 772, 772, 
	772, -1, 772, -1, 772, 772, 772, 772, 
	-1, 772, -1, 772, 772, 772, -1, -1, 
	772, 772, 772, 772, 772, 772, 772, 772, 
	-1, 772, 772, 772, -1, -1, -1, -1, 
	772, 772, 772, 772, 772, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1097, -1, -1, 772, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 772, 772, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	229, 463, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 230, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, -1, -1, -1, 
	157, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 462, -1, 169, 159, 153, 148, 1011, 
	772, 772, 772, 772, -1, -1, 772, 772, 
	-1, 772, 772, 772, -1, -1, -1, -1, 
	772, 772, 772, -1, 772, 772, 772, 772, 
	-1, -1, -1, -1, 772, -1, -1, -1, 
	-1, 772, -1, -1, -1, 772, 772, 772, 
	772, -1, 772, 772, -1, -1, 772, -1, 
	-1, 1097, -1, -1, -1, -1, -1, -1, 
	772, 772, 772, 772, 772, 772, 772, 772, 
	-1, -1, -1, -1, 772, 772, -1, -1, 
	772, 772, -1, -1, -1, -1, -1, -1, 
	-1, -1, 772, 772, -1, -1, -1, -1, 
	772, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 772, 772, 
	-1, -1, 850, 850, 850, 850, 850, 850, 
	850, 850, 850, 850, 850, 850, 850, 850, 
	850, 850, -1, 850, 850, 850, 850, 850, 
	850, 850, 850, -1, -1, -1, 850, 850, 
	850, 850, 850, -1, 850, -1, 850, 850, 
	850, 850, -1, 850, -1, 850, 850, 850, 
	-1, -1, 850, -1, -1, 850, 850, 850, 
	850, 850, -1, 850, 850, 850, -1, -1, 
	-1, -1, 850, 850, 850, 850, 850, -1, 
	-1, -1, -1, 949, 949, 949, 949, 949, 
	949, 949, 949, 949, -1, 949, 949, -1, 
	-1, 949, 949, 949, 949, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 949, 949, 949, 850, 850, -1, 949, 
	-1, -1, -1, -1, 949, -1, -1, -1, 
	-1, -1, 949, 949, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	949, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	949, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 949, 949, 
	-1, -1, 850, 850, 850, 850, -1, -1, 
	850, 850, 850, 850, 850, 850, -1, -1, 
	-1, 772, 850, 850, 850, 850, 850, 850, 
	850, 850, -1, -1, -1, -1, 850, -1, 
	-1, -1, -1, 850, -1, -1, -1, 850, 
	850, 850, 850, -1, 850, 850, -1, -1, 
	850, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 850, 850, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 850, 850, -1, -1, -1, -1, 
	-1, -1, -1, -1, 850, 850, -1, -1, 
	-1, -1, 850, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	850, 850, -1, -1, -1, -1, -1, 949, 
	949, -1, -1, -1, -1, -1, -1, 949, 
	-1, -1, -1, -1, 949, 949, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 949, 
	-1, -1, -1, -1, 949, -1, -1, -1, 
	772, 849, 849, 849, 849, 849, 849, 849, 
	849, 849, 849, 849, 849, 849, 849, 849, 
	849, -1, 849, 849, 849, 849, 849, 849, 
	849, 849, 949, 949, -1, 849, 849, 849, 
	849, 849, -1, 849, -1, 849, 849, 849, 
	849, -1, 849, -1, 849, 849, 849, -1, 
	-1, 849, -1, -1, 849, 849, 849, 849, 
	849, -1, 849, 849, 849, -1, -1, -1, 
	-1, 849, 849, 849, 849, 849, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 849, 849, -1, -1, -1, 
	-1, 229, 463, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 230, 137, 138, 139, 
	140, -1, 146, 154, 158, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 850, -1, -1, -1, -1, 
	-1, -1, -1, -1, 169, 159, 153, 148, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 849, 849, 849, 849, -1, -1, 849, 
	849, 849, 849, 849, 849, -1, -1, -1, 
	-1, 849, 849, 849, 849, 849, 849, 849, 
	849, -1, -1, -1, -1, 849, -1, -1, 
	-1, -1, 849, 849, -1, -1, 849, 849, 
	849, 849, -1, 849, 849, -1, -1, 849, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 849, 849, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 849, 849, -1, -1, -1, -1, -1, 
	-1, -1, -1, 849, 849, -1, -1, -1, 
	-1, 849, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 849, 
	849, -1, 850, 851, 851, 851, 851, 851, 
	851, 851, 851, 851, 851, 851, 851, 851, 
	851, 851, 851, -1, 851, 851, 851, 851, 
	851, 851, 851, 851, -1, -1, -1, 851, 
	851, 851, 851, 851, -1, 851, -1, 851, 
	851, 851, 851, -1, 851, -1, 851, 851, 
	851, -1, -1, 851, -1, -1, 851, 851, 
	851, 851, 851, -1, 851, 851, 851, -1, 
	-1, -1, -1, 851, 851, 851, 851, 851, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 851, 851, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 851, 851, 851, 851, -1, 
	-1, 851, 851, -1, 851, 851, 851, -1, 
	-1, -1, 849, 851, 851, 851, -1, 851, 
	851, 851, 851, -1, -1, -1, -1, 851, 
	-1, -1, -1, -1, 851, 851, -1, -1, 
	851, 851, 851, 851, -1, 851, 851, -1, 
	-1, 851, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 851, 851, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 851, 851, -1, -1, -1, 
	-1, -1, -1, -1, -1, 851, 851, -1, 
	-1, -1, -1, 851, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 851, 851, -1, -1, -1, 934, 934, 
	934, 934, 934, 934, 934, 934, 934, 934, 
	934, 934, 934, 934, 934, 934, 934, 934, 
	934, 934, 934, 934, 934, 934, 934, 934, 
	934, -1, 934, 934, 934, 934, 934, -1, 
	934, 849, 934, 934, 934, 934, -1, 934, 
	-1, 934, 934, 934, -1, -1, 934, 934, 
	934, 934, 934, 934, 934, 934, -1, 934, 
	934, 934, -1, -1, -1, -1, 934, 934, 
	934, 934, 934, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 934, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	934, 934, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 934, 934, 
	934, 934, -1, -1, 934, 934, -1, 934, 
	934, 934, -1, -1, 851, -1, 934, 934, 
	934, -1, 934, 934, 934, 934, -1, -1, 
	-1, -1, 934, -1, -1, -1, -1, 934, 
	-1, -1, -1, 934, 934, 934, 934, -1, 
	934, 934, -1, -1, 934, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 934, 934, 
	934, 934, 934, 934, 934, 934, -1, -1, 
	-1, -1, 934, 934, -1, -1, 934, 934, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	934, 934, -1, -1, -1, -1, 934, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 934, 934, -1, -1, 
	930, 930, 930, 930, 930, 930, 930, 930, 
	930, 930, 930, 930, 930, 930, 930, 930, 
	930, 930, 930, 930, 930, 930, 930, 930, 
	930, 930, 930, -1, 930, 930, 930, 930, 
	930, -1, 930, 851, 930, 930, 930, 930, 
	-1, 930, -1, 930, 930, 930, -1, -1, 
	930, 309, 311, 930, 930, 930, 930, 930, 
	-1, 930, 930, 930, -1, -1, -1, -1, 
	930, 930, 930, 930, 930, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 930, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 930, 930, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	930, 930, 930, 930, -1, -1, 930, 930, 
	-1, 930, 930, 930, -1, -1, -1, 934, 
	930, 930, 930, -1, 930, 930, 930, 930, 
	-1, -1, -1, -1, 930, -1, -1, -1, 
	-1, 930, -1, -1, -1, 930, 930, 930, 
	930, -1, 930, 930, -1, -1, 930, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	305, 307, 479, 930, 930, 930, 930, 930, 
	-1, -1, -1, -1, 930, 930, -1, -1, 
	930, 930, -1, -1, -1, -1, -1, -1, 
	-1, -1, 930, 930, -1, -1, -1, -1, 
	930, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 930, 930, 
	-1, -1, -1, 931, 931, 931, 931, 931, 
	931, 931, 931, 931, 931, 931, 931, 931, 
	931, 931, 931, 931, 931, 931, 931, 931, 
	931, 931, 931, 931, 931, 931, -1, 931, 
	931, 931, 931, 931, -1, 931, 934, 931, 
	931, 931, 931, -1, 931, -1, 931, 931, 
	931, -1, -1, 931, 931, 931, 931, 931, 
	931, 931, 931, -1, 931, 931, 931, -1, 
	-1, -1, -1, 931, 931, 931, 931, 931, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	931, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 931, 931, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 931, 931, 931, 931, -1, 
	-1, 931, 931, -1, 931, 931, 931, -1, 
	-1, 930, -1, 931, 931, 931, -1, 931, 
	931, 931, 931, -1, -1, -1, -1, 931, 
	-1, -1, -1, -1, 931, -1, -1, -1, 
	931, 931, 931, 931, -1, 931, 931, -1, 
	-1, 931, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 931, 931, 931, 931, 931, 
	931, 931, 931, -1, -1, -1, -1, 931, 
	931, -1, -1, 931, 931, -1, -1, -1, 
	-1, -1, -1, -1, -1, 931, 931, -1, 
	-1, -1, -1, 931, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 931, 931, -1, -1, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, 959, 959, 959, 
	-1, 959, 959, 959, 959, 959, -1, 959, 
	930, 959, 959, 959, 959, 959, 959, -1, 
	959, 959, 959, -1, -1, 959, 959, 959, 
	959, 959, 959, 959, 959, -1, 959, 959, 
	959, 959, -1, -1, -1, 959, 959, 959, 
	959, 959, -1, -1, -1, -1, -1, 959, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 959, -1, -1, 959, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 959, 
	959, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 959, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 959, 959, 959, 
	959, -1, -1, 959, 959, 959, 959, 959, 
	959, -1, -1, -1, 931, 959, 959, 959, 
	959, 959, 959, 959, 959, -1, -1, 959, 
	-1, 959, -1, -1, -1, -1, 959, 959, 
	-1, 959, 959, 959, 959, 959, -1, 959, 
	959, -1, -1, 959, -1, -1, -1, -1, 
	-1, -1, 959, -1, 959, 959, 959, 959, 
	959, 959, 959, 959, 959, -1, -1, -1, 
	-1, 959, 959, -1, 959, 959, 959, -1, 
	-1, -1, -1, -1, -1, -1, -1, 959, 
	959, 304, 306, 478, -1, 959, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 959, 959, -1, -1, -1, 
	846, 846, 846, 846, 846, 846, 846, 846, 
	846, 846, 846, 846, 846, 846, 846, 846, 
	-1, 846, 846, 846, 846, 846, 846, 846, 
	846, -1, -1, -1, 846, 846, 846, 846, 
	846, -1, 846, 931, 846, 846, 846, 846, 
	-1, 846, -1, 846, 846, 846, -1, -1, 
	846, -1, -1, 846, 846, 846, 846, 846, 
	-1, 846, 846, 846, -1, -1, -1, -1, 
	846, 846, 846, 846, 846, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 328, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 846, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 846, 846, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	846, 846, 846, 846, -1, -1, 846, 846, 
	846, 846, 846, 846, -1, -1, 959, -1, 
	846, 846, 846, 846, 846, 846, 846, 846, 
	-1, -1, -1, -1, 846, -1, -1, -1, 
	-1, 846, 846, -1, -1, 846, 846, 846, 
	846, -1, 846, 846, -1, -1, 846, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 846, 846, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	846, 846, -1, -1, -1, -1, -1, -1, 
	-1, -1, 846, 846, -1, -1, -1, -1, 
	846, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 846, 846, 
	-1, -1, 847, 847, 847, 847, 847, 847, 
	847, 847, 847, 847, 847, 847, 847, 847, 
	847, 847, -1, 847, 847, 847, 847, 847, 
	847, 847, 847, -1, -1, -1, 847, 847, 
	847, 847, 847, -1, 847, 959, 847, 847, 
	847, 847, -1, 847, -1, 847, 847, 847, 
	-1, -1, 847, -1, -1, 847, 847, 847, 
	847, 847, -1, 847, 847, 847, -1, -1, 
	-1, -1, 847, 847, 847, 847, 847, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 3, -1, 41, 
	485, 38, 36, 39, -1, 847, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 847, 847, -1, -1, 
	-1, 861, 861, 861, 861, 861, -1, 45, 
	-1, 60, -1, -1, -1, -1, 63, -1, 
	-1, 61, -1, -1, -1, -1, -1, -1, 
	861, 861, 861, -1, -1, -1, 66, 68, 
	67, -1, -1, -1, -1, 92, 93, 94, 
	-1, 72, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 847, 847, 847, 847, -1, -1, 
	847, 847, 847, 847, 847, 847, -1, -1, 
	-1, 846, 847, 847, 847, 847, 847, 847, 
	847, 847, -1, -1, -1, -1, 847, -1, 
	-1, -1, -1, 847, 847, -1, -1, 847, 
	847, 847, 847, -1, 847, 847, -1, -1, 
	847, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 847, 847, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 847, 847, -1, -1, -1, -1, 
	-1, -1, -1, -1, 847, 847, -1, 501, 
	62, -1, 847, 500, 502, 486, 499, -1, 
	498, -1, -1, -1, -1, 44, 496, 497, 
	487, 42, 495, 37, 488, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	847, 847, 493, -1, 494, 489, -1, 490, 
	491, -1, -1, 492, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 503, -1, -1, 
	846, -1, -1, -1, -1, -1, -1, 861, 
	861, 871, 871, 871, 871, 871, 871, 871, 
	871, 871, 871, 871, 871, 871, 871, 871, 
	871, -1, 871, 871, 871, 871, 871, 871, 
	871, 871, -1, -1, -1, 871, 871, 871, 
	871, 871, -1, 871, -1, 871, 871, 871, 
	871, -1, 871, -1, 871, 871, 871, -1, 
	-1, 871, -1, -1, 871, 871, 871, 871, 
	871, -1, 871, 871, 871, 871, -1, -1, 
	-1, 871, 871, 871, 871, 871, -1, 871, 
	1169, 1169, 1169, 1169, 1169, 1169, 1169, -1, 
	1169, 1169, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1169, 1169, 1169, 1169, 1169, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1169, 871, 871, -1, 1169, -1, 
	-1, -1, 1169, 1169, 1169, 1169, 1169, 1169, 
	-1, -1, -1, -1, 1169, 1169, 1169, -1, 
	-1, -1, -1, 1169, 1169, -1, 1169, 1169, 
	1169, 1169, 1169, -1, -1, -1, -1, -1, 
	-1, 1169, -1, 847, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1169, 
	1169, 1169, 1169, 1169, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1169, 871, 871, 871, 871, -1, -1, 871, 
	871, 871, 871, 871, 871, -1, -1, -1, 
	-1, 871, 871, 871, 871, 871, 871, 871, 
	871, -1, 871, 871, -1, 871, -1, -1, 
	-1, -1, 871, 871, -1, -1, 871, 871, 
	871, 871, -1, 871, 871, -1, -1, 871, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 871, 871, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 871, 871, -1, -1, -1, -1, -1, 
	-1, -1, -1, 871, 871, -1, -1, -1, 
	-1, 871, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 847, -1, -1, -1, -1, 871, 
	871, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1169, 1169, 1169, 1169, 1169, -1, 
	1169, 1169, 1169, -1, -1, -1, -1, 1169, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1169, 1169, -1, -1, -1, -1, 
	-1, -1, -1, 1169, -1, -1, -1, -1, 
	-1, -1, 1169, 1169, 1169, 1169, 1169, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	877, 877, 877, 877, 877, 877, 877, 877, 
	877, 877, 877, 877, 877, 877, 877, 877, 
	-1, 877, 877, 877, 877, 877, 877, 877, 
	877, -1, 871, -1, 877, 877, 877, 877, 
	877, -1, 877, -1, 877, 877, 877, 877, 
	-1, 877, -1, 877, 877, 877, -1, -1, 
	877, -1, -1, 877, 877, 877, 877, 877, 
	-1, 877, 877, 877, 877, -1, -1, -1, 
	877, 877, 877, 877, 877, -1, 877, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	501, 62, -1, -1, 500, 502, 486, 499, 
	-1, 498, -1, -1, -1, -1, 44, 496, 
	497, 487, 42, 495, 37, 488, 505, -1, 
	-1, -1, 877, 877, -1, -1, -1, -1, 
	-1, -1, -1, 493, -1, 494, 489, -1, 
	490, 491, -1, -1, 492, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 503, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 871, -1, -1, -1, -1, -1, -1, 
	877, 877, 877, 877, -1, -1, 877, 877, 
	877, 877, 877, 877, -1, -1, -1, -1, 
	877, 877, 877, 877, 877, 877, 877, 877, 
	-1, 877, 877, 504, 877, -1, -1, -1, 
	-1, 877, 877, -1, -1, 877, 877, 877, 
	877, -1, 877, 877, -1, -1, 877, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 877, 877, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	877, 877, -1, -1, -1, -1, -1, -1, 
	-1, -1, 877, 877, -1, -1, -1, -1, 
	877, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 877, 877, 
	-1, -1, 938, 938, 938, 938, 938, 938, 
	938, 938, 938, 938, 938, 938, 938, 938, 
	938, 938, 938, 938, 938, 938, 938, 938, 
	938, 938, 938, 938, 938, -1, 938, 938, 
	938, 938, 938, -1, 938, -1, 938, 938, 
	938, 938, -1, 938, -1, 938, 938, 938, 
	-1, -1, 938, 938, 938, 938, 938, 938, 
	938, 938, -1, 938, 938, 938, -1, -1, 
	-1, -1, 938, 938, 938, 938, 938, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 938, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 938, 938, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 938, 938, 938, 938, -1, -1, 
	938, 938, -1, 938, 938, 938, -1, -1, 
	-1, 877, 938, 938, 938, -1, 938, 938, 
	938, 938, -1, -1, -1, -1, 938, -1, 
	-1, -1, -1, 938, -1, -1, -1, 938, 
	938, 938, 938, -1, 938, 938, -1, -1, 
	938, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 938, 938, 938, 938, 938, 938, 
	938, 938, -1, -1, -1, -1, 938, 938, 
	-1, -1, 938, 938, -1, -1, -1, -1, 
	-1, -1, -1, -1, 938, 938, -1, -1, 
	-1, -1, 938, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	938, 938, -1, -1, -1, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	-1, 986, 986, 986, 986, 986, -1, 986, 
	877, 986, 986, 986, 986, -1, 986, -1, 
	986, 986, 986, -1, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, -1, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, -1, 986, -1, -1, -1, -1, 986, 
	986, 986, 986, 986, -1, -1, 986, 986, 
	986, 986, 986, 986, 986, 986, 986, 986, 
	986, 986, 986, 986, 986, 986, -1, 986, 
	986, -1, -1, -1, -1, -1, 986, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 986, 986, 986, 
	986, -1, -1, 986, 986, 986, 986, 986, 
	986, -1, -1, 938, -1, 986, 986, 986, 
	986, 986, 986, 986, 986, -1, -1, -1, 
	-1, 986, -1, -1, -1, -1, 986, 986, 
	-1, -1, 986, 986, 986, 986, -1, 986, 
	986, -1, -1, 986, -1, -1, -1, -1, 
	-1, -1, -1, -1, 504, 986, 986, 986, 
	986, 986, 986, 986, 986, -1, -1, -1, 
	986, 986, 986, -1, -1, 986, 986, -1, 
	986, 986, 986, 986, 986, -1, 986, 986, 
	986, -1, -1, -1, 986, 986, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	986, 986, -1, -1, 986, -1, -1, -1, 
	-1, 986, -1, -1, -1, -1, 986, -1, 
	986, 986, 986, 986, 986, -1, -1, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, -1, 987, 987, 987, 987, 987, 
	-1, 987, 938, 987, 987, 987, 987, -1, 
	987, -1, 987, 987, 987, -1, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, -1, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, -1, 987, -1, -1, -1, 
	-1, 987, 987, 987, 987, 987, -1, -1, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	987, 987, 987, 987, 987, 987, 987, 987, 
	-1, 987, 987, -1, -1, -1, -1, -1, 
	987, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 987, 
	987, 987, 987, -1, -1, 987, 987, 987, 
	987, 987, 987, -1, -1, -1, 986, 987, 
	987, 987, 987, 987, 987, 987, 987, -1, 
	-1, -1, -1, 987, -1, -1, -1, -1, 
	987, 987, -1, -1, 987, 987, 987, 987, 
	-1, 987, 987, -1, -1, 987, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 987, 
	987, 987, 987, 987, 987, 987, 987, -1, 
	-1, -1, 987, 987, 987, -1, -1, 987, 
	987, -1, 987, 987, 987, 987, 987, -1, 
	987, 987, 987, -1, -1, -1, 987, 987, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 987, 987, -1, -1, 987, -1, 
	-1, -1, -1, 987, -1, -1, -1, -1, 
	987, -1, 987, 987, 987, 987, 987, -1, 
	-1, -1, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, 957, 957, 957, 
	957, 957, 957, 957, 957, -1, 957, 957, 
	957, 957, 957, -1, 957, 986, 957, 957, 
	957, 957, -1, 957, -1, 957, 957, 957, 
	-1, -1, 957, 957, 957, 957, 957, 957, 
	957, 957, -1, 957, 957, 957, -1, -1, 
	-1, -1, 957, 957, 957, 957, 957, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 957, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 274, 275, -1, 957, 957, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 957, 957, 957, 957, -1, -1, 
	957, 957, 957, 957, 957, 957, -1, -1, 
	987, -1, 957, 957, 957, 957, 957, 957, 
	957, 957, -1, -1, -1, -1, 957, -1, 
	-1, -1, -1, 957, 957, -1, -1, 957, 
	957, 957, 957, -1, 957, 957, -1, -1, 
	957, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 957, 957, 957, 957, 957, 957, 
	957, 957, -1, -1, -1, -1, 957, 957, 
	-1, -1, 957, 957, -1, -1, -1, -1, 
	-1, -1, -1, -1, 957, 957, -1, -1, 
	-1, -1, 957, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	957, 957, -1, -1, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, -1, 
	1101, 1101, 1101, 1101, 1101, -1, 1101, 987, 
	1101, 1101, 1101, 1101, -1, 1101, -1, 1101, 
	1101, 1101, -1, 1101, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	-1, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	-1, 1101, -1, -1, 506, 507, 1101, 1101, 
	1101, 1101, 1101, -1, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, 1101, -1, 1101, 1101, 
	-1, -1, -1, -1, -1, 1101, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1101, 1101, 1101, 1101, 
	-1, -1, 1101, 1101, 1101, 1101, 1101, 1101, 
	-1, -1, -1, 957, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, -1, -1, -1, -1, 
	1101, -1, -1, -1, -1, 1101, 1101, -1, 
	-1, 1101, 1101, 1101, 1101, -1, 1101, 1101, 
	-1, -1, 1101, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1101, 1101, 1101, 1101, 
	1101, 1101, 1101, 1101, -1, -1, -1, 1101, 
	1101, 1101, -1, -1, 1101, 1101, -1, 1101, 
	1101, 1101, 1101, 1101, -1, 1101, 1101, 1101, 
	-1, -1, -1, 1101, 1101, -1, -1, -1, 
	-1, -1, -1, -1, 1101, 1101, 1101, 1101, 
	1101, -1, -1, 1101, -1, -1, -1, -1, 
	1101, -1, 1101, 1101, 1101, 1101, -1, 1101, 
	1101, 1101, 1101, 1101, -1, -1, -1, 773, 
	773, 773, 773, 773, 773, 773, 773, 773, 
	773, 773, 773, 773, 773, 773, 773, 773, 
	773, 773, 773, 773, 773, 773, 773, 773, 
	773, 773, -1, 773, 773, 773, 773, 773, 
	-1, 773, 957, 773, 773, 773, 773, -1, 
	773, -1, 773, 773, 773, -1, -1, 773, 
	773, 773, 773, 773, 773, 773, 773, -1, 
	773, 773, 773, -1, -1, -1, -1, 773, 
	773, 773, 773, 773, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 773, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 274, 275, 
	-1, 773, 773, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 773, 
	773, 773, 773, -1, -1, 773, 773, -1, 
	773, 773, 773, -1, -1, 1101, -1, 773, 
	773, 773, -1, 773, 773, 773, 773, -1, 
	-1, -1, -1, 773, -1, -1, -1, -1, 
	773, -1, -1, -1, 773, 773, 773, 773, 
	-1, 773, 773, -1, -1, 773, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 773, 
	773, 773, 773, 773, 773, 773, 773, -1, 
	-1, -1, -1, 773, 773, -1, -1, 773, 
	773, -1, -1, -1, -1, -1, -1, -1, 
	-1, 773, 773, -1, -1, -1, -1, 773, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 773, 773, -1, 
	-1, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, 1012, -1, 1012, 1101, 1012, 1012, 1012, 
	1012, 1012, 1012, -1, 1012, 1012, 1012, -1, 
	-1, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, -1, 1012, 1012, 1012, 1012, -1, -1, 
	-1, 1012, 1012, 1012, 1012, 1012, -1, 1012, 
	1012, 1012, 1012, 1012, 1012, 1012, -1, 1012, 
	-1, -1, -1, 1012, 1012, -1, 1012, -1, 
	-1, 1012, -1, -1, 1012, -1, 1012, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1012, 1012, -1, -1, -1, 
	-1, -1, 1012, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1012, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1012, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1012, 1012, 1012, 1012, -1, -1, 1012, 
	1012, 1012, 1012, 1012, 1012, -1, -1, -1, 
	773, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, -1, -1, 1012, -1, 1012, -1, -1, 
	-1, -1, 1012, 1012, -1, 1012, 1012, 1012, 
	1012, 1012, -1, 1012, 1012, -1, -1, 1012, 
	-1, 1012, 1012, -1, -1, -1, 1012, -1, 
	1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 
	1012, -1, -1, -1, -1, 1012, 1012, -1, 
	1012, 1012, 1012, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1012, 1012, -1, -1, 1012, 
	-1, 1012, 1012, -1, -1, -1, 1012, 1012, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1012, 1012, 1012, -1, -1, 1012, 
	1012, 1012, -1, -1, -1, -1, -1, 1012, 
	1012, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 773, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, 1013, -1, 1013, -1, 
	1013, 1013, 1013, 1013, 1013, 1013, -1, 1013, 
	1013, 1013, -1, -1, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, -1, 1013, 1013, 1013, 
	1013, -1, -1, -1, 1013, 1013, 1013, 1013, 
	1013, -1, 1013, 1013, 1013, 1013, 1013, 1013, 
	1013, -1, 1013, -1, -1, -1, 1013, 1013, 
	-1, 1013, -1, -1, 1013, -1, -1, 1013, 
	-1, 1013, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1013, 1013, 
	-1, -1, -1, -1, -1, 1013, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1013, -1, 
	-1, -1, 1012, -1, -1, -1, -1, -1, 
	1013, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1013, 1013, 1013, 1013, 
	-1, -1, 1013, 1013, 1013, 1013, 1013, 1013, 
	-1, -1, 1012, 1012, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, -1, -1, 1013, -1, 
	1013, -1, -1, -1, -1, 1013, 1013, -1, 
	1013, 1013, 1013, 1013, 1013, -1, 1013, 1013, 
	-1, -1, 1013, -1, 1013, 1013, -1, -1, 
	-1, 1013, -1, 1013, 1013, 1013, 1013, 1013, 
	1013, 1013, 1013, 1013, -1, -1, -1, -1, 
	1013, 1013, -1, 1013, 1013, 1013, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1013, 1013, 
	-1, -1, 1013, -1, 1013, 1013, -1, -1, 
	-1, 1013, 1013, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1013, 1013, 1013, 
	-1, 1012, 1013, 1013, 1013, -1, -1, -1, 
	-1, -1, 1013, 1013, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, 1014, -1, 1014, -1, 1014, 1014, 1014, 
	1014, 1014, 1014, -1, 1014, 1014, 1014, -1, 
	-1, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, -1, 1014, 1014, 1014, 1014, -1, -1, 
	-1, 1014, 1014, 1014, 1014, 1014, -1, 1014, 
	1014, 1014, 1014, 1014, 1014, 1014, -1, 1014, 
	-1, -1, -1, 1014, 1014, -1, 1014, -1, 
	-1, 1014, -1, -1, 1014, -1, 1014, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1014, 1014, -1, -1, -1, 
	-1, -1, 1014, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1014, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1014, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1013, -1, -1, 
	-1, 1014, 1014, 1014, 1014, -1, -1, 1014, 
	1014, 1014, 1014, 1014, 1014, -1, -1, -1, 
	-1, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, -1, -1, 1014, -1, 1014, -1, -1, 
	-1, -1, 1014, 1014, -1, 1014, 1014, 1014, 
	1014, 1014, -1, 1014, 1014, 1013, 1013, 1014, 
	-1, 1014, 1014, -1, -1, -1, 1014, -1, 
	1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 
	1014, -1, -1, -1, -1, 1014, 1014, -1, 
	1014, 1014, 1014, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1014, 1014, -1, -1, 1014, 
	-1, 1014, 1014, -1, -1, -1, 1014, 1014, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1014, 1014, 1014, -1, -1, 1014, 
	1014, 1014, -1, -1, -1, -1, -1, 1014, 
	1014, -1, -1, -1, 920, 920, 920, 920, 
	920, 920, 920, 920, 920, 920, 920, 920, 
	920, 920, 920, 920, 1013, 920, 920, 920, 
	920, 920, 920, 920, 920, -1, -1, -1, 
	920, 920, 920, 920, 920, -1, 920, -1, 
	920, 920, 920, 920, -1, 920, 515, 920, 
	920, 920, -1, -1, 920, -1, -1, 920, 
	920, 920, 920, 920, -1, 920, 920, 920, 
	-1, -1, -1, -1, 920, 920, 920, 920, 
	920, -1, -1, -1, -1, -1, -1, -1, 
	920, -1, -1, -1, -1, -1, -1, -1, 
	920, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 920, 920, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 920, 920, 920, 920, 
	-1, -1, 920, 920, 920, 920, 920, 920, 
	-1, -1, 1014, -1, 920, 920, 920, 920, 
	920, 920, 920, 920, -1, -1, -1, -1, 
	920, -1, -1, -1, -1, 920, 920, -1, 
	-1, 920, 920, 920, 920, -1, 920, 920, 
	-1, -1, 920, -1, -1, -1, -1, 514, 
	-1, -1, 920, -1, -1, -1, -1, 920, 
	920, -1, 1014, 1014, -1, -1, -1, -1, 
	-1, -1, -1, -1, 920, 920, -1, -1, 
	-1, -1, -1, -1, -1, -1, 920, 920, 
	-1, -1, -1, -1, 920, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 920, 920, -1, -1, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, -1, 1081, 1081, 1081, 1081, 1081, -1, 
	1081, 1014, 1081, 1081, 1081, 1081, -1, 1081, 
	-1, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, -1, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, -1, 1081, -1, -1, 1081, -1, 
	1081, 1081, 1081, 1081, 1081, -1, -1, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, 1081, -1, 
	1081, 1081, -1, -1, -1, -1, -1, 1081, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1081, 1081, 
	1081, 1081, -1, -1, 1081, 1081, 1081, 1081, 
	1081, 1081, -1, -1, -1, 920, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, -1, -1, 
	-1, -1, 1081, -1, -1, -1, -1, 1081, 
	1081, -1, -1, 1081, 1081, 1081, 1081, -1, 
	1081, 1081, -1, -1, 1081, -1, -1, -1, 
	-1, -1, -1, 920, -1, -1, 1081, 1081, 
	1081, 1081, 1081, 1081, 1081, 1081, -1, -1, 
	-1, 1081, 1081, 1081, -1, 920, 1081, 1081, 
	-1, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 
	1081, 1081, -1, -1, -1, 1081, 1081, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1081, 1081, -1, -1, 1081, -1, -1, 
	-1, -1, 1081, -1, 1081, 1081, -1, 1081, 
	-1, 1081, 1081, 1081, 1081, 1081, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 920, -1, -1, -1, 
	-1, -1, -1, -1, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, -1, 
	1037, 1037, 1037, 1037, 1037, -1, 1037, -1, 
	1037, 1037, 1037, 1037, -1, 1037, -1, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	-1, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	-1, 1037, -1, -1, 1037, -1, 1037, 1037, 
	1037, 1037, 1037, -1, -1, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, -1, 1037, 1037, 
	-1, -1, -1, -1, -1, 1037, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1081, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1037, 1037, 1037, 1037, 
	-1, -1, 1037, 1037, 1037, 1037, 1037, 1037, 
	-1, -1, -1, -1, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, -1, -1, -1, -1, 
	1037, -1, -1, -1, -1, 1037, 1037, -1, 
	514, 1037, 1037, 1037, 1037, -1, 1037, 1037, 
	-1, -1, 1037, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, -1, -1, -1, 1037, 
	1037, 1037, 1037, -1, 1037, 1037, -1, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	-1, -1, -1, 1037, 1037, 1037, -1, -1, 
	-1, 1037, 1037, -1, 1037, 1037, -1, 1037, 
	1037, -1, -1, 1037, -1, 1037, 1037, -1, 
	1037, -1, 1037, 1037, -1, 1037, 1081, 1037, 
	1037, 1037, 1037, 1037, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1037, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, -1, 1038, 1038, 1038, 1038, 1038, -1, 
	1038, -1, 1038, 1038, 1038, 1038, -1, 1038, 
	-1, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, -1, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, -1, 1038, -1, -1, 1038, -1, 
	1038, 1038, 1038, 1038, 1038, -1, -1, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, 1038, -1, 
	1038, 1038, -1, -1, -1, -1, -1, 1038, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1037, 1038, 1038, 
	1038, 1038, -1, -1, 1038, 1038, 1038, 1038, 
	1038, 1038, -1, -1, -1, -1, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, -1, -1, 
	-1, -1, 1038, -1, -1, -1, -1, 1038, 
	1038, -1, -1, 1038, 1038, 1038, 1038, -1, 
	1038, 1038, -1, -1, 1038, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1038, 1038, 
	1038, 1038, 1038, 1038, 1038, 1038, -1, -1, 
	-1, 1038, 1038, 1038, 1038, -1, 1038, 1038, 
	-1, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 
	1038, 1038, -1, -1, -1, 1038, 1038, 1038, 
	-1, -1, -1, 1038, 1038, -1, 1038, 1038, 
	-1, 1038, 1038, -1, -1, 1038, -1, 1038, 
	1038, -1, 1038, -1, 1038, 1038, -1, 1038, 
	-1, 1038, 1038, 1038, 1038, 1038, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1038, 
	-1, -1, -1, -1, 1037, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	-1, 1082, 1082, 1082, 1082, 1082, -1, 1082, 
	-1, 1082, 1082, 1082, 1082, -1, 1082, -1, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, -1, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, -1, 1082, -1, -1, 1082, -1, 1082, 
	1082, 1082, 1082, 1082, -1, -1, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, 1082, -1, 1082, 
	1082, -1, -1, -1, -1, -1, 1082, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1038, 
	-1, -1, -1, -1, -1, 1082, 1082, 1082, 
	1082, -1, -1, 1082, 1082, 1082, 1082, 1082, 
	1082, -1, -1, -1, -1, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, -1, -1, -1, 
	-1, 1082, -1, -1, -1, -1, 1082, 1082, 
	-1, -1, 1082, 1082, 1082, 1082, -1, 1082, 
	1082, -1, -1, 1082, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1082, 1082, 1082, 
	1082, 1082, 1082, 1082, 1082, -1, -1, -1, 
	1082, 1082, 1082, -1, -1, 1082, 1082, -1, 
	1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 
	1082, -1, -1, -1, 1082, 1082, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1082, 1082, -1, -1, 1082, -1, -1, -1, 
	-1, 1082, -1, 1082, 1082, -1, 1082, -1, 
	1082, 1082, 1082, 1082, 1082, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1038, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, -1, 1039, 1039, 1039, 1039, 1039, 
	-1, 1039, -1, 1039, 1039, 1039, 1039, -1, 
	1039, -1, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, -1, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, -1, 1039, -1, -1, 1039, 
	-1, 1039, 1039, 1039, 1039, 1039, -1, -1, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 
	-1, 1039, 1039, -1, -1, -1, -1, -1, 
	1039, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1082, 1039, 
	1039, 1039, 1039, -1, -1, 1039, 1039, 1039, 
	1039, 1039, 1039, -1, -1, -1, -1, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, -1, 
	-1, -1, -1, 1039, -1, -1, -1, -1, 
	1039, 1039, -1, -1, 1039, 1039, 1039, 1039, 
	-1, 1039, 1039, -1, -1, 1039, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1039, 
	1039, 1039, 1039, 1039, 1039, 1039, 1039, -1, 
	-1, -1, 1039, 1039, 1039, 1039, -1, 1039, 
	1039, -1, 1039, 1039, 1039, 1039, 1039, 1039, 
	1039, 1039, 1039, -1, -1, -1, 1039, 1039, 
	1039, -1, -1, -1, 1039, 1039, -1, 1039, 
	1039, -1, 1039, 1039, -1, -1, 1039, -1, 
	1039, 1039, -1, 1039, -1, 1039, 1039, -1, 
	1039, -1, 1039, 1039, 1039, 1039, 1039, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1039, -1, -1, -1, -1, 1082, -1, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, -1, 1040, 1040, 1040, 1040, 1040, 
	-1, 1040, -1, 1040, 1040, 1040, 1040, -1, 
	1040, -1, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, 1040, -1, -1, 1040, 
	-1, 1040, 1040, 1040, 1040, 1040, -1, -1, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 
	-1, 1040, 1040, -1, -1, -1, -1, -1, 
	1040, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1039, -1, -1, -1, -1, -1, -1, 1040, 
	1040, 1040, 1040, -1, -1, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, 1040, -1, -1, -1, -1, 
	1040, 1040, -1, -1, 1040, 1040, 1040, 1040, 
	-1, 1040, 1040, -1, -1, 1040, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1040, 
	1040, 1040, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, 1040, 1040, 1040, 1040, -1, 1040, 
	1040, -1, 1040, 1040, 1040, 1040, 1040, 1040, 
	1040, 1040, 1040, -1, -1, -1, 1040, 1040, 
	1040, -1, -1, -1, 1040, 1040, -1, 1040, 
	1040, -1, 1040, 1040, -1, -1, 1040, -1, 
	1040, 1040, -1, 1040, -1, 1040, 1040, -1, 
	1040, -1, 1040, 1040, 1040, 1040, 1040, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1039, 
	1040, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, -1, 1083, 1083, 1083, 
	1083, 1083, -1, 1083, -1, 1083, 1083, 1083, 
	1083, -1, 1083, -1, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, -1, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, -1, 1083, -1, 
	-1, 1083, -1, 1083, 1083, 1083, 1083, 1083, 
	-1, -1, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, 1083, -1, 1083, 1083, -1, -1, -1, 
	-1, -1, 1083, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1040, 1083, 1083, 1083, 1083, -1, -1, 1083, 
	1083, 1083, 1083, 1083, 1083, -1, -1, -1, 
	-1, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, -1, -1, -1, -1, 1083, -1, -1, 
	-1, -1, 1083, 1083, -1, -1, 1083, 1083, 
	1083, 1083, -1, 1083, 1083, -1, -1, 1083, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 
	1083, -1, -1, -1, 1083, 1083, 1083, -1, 
	-1, 1083, 1083, -1, 1083, 1083, 1083, 1083, 
	1083, 1083, 1083, 1083, 1083, -1, -1, -1, 
	1083, 1083, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1083, 1083, -1, -1, 
	1083, -1, -1, -1, -1, 1083, -1, 1083, 
	1083, -1, 1083, -1, 1083, 1083, 1083, 1083, 
	1083, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1040, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, -1, 1084, 1084, 1084, 1084, 
	1084, -1, 1084, -1, 1084, 1084, 1084, 1084, 
	-1, 1084, -1, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, -1, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, -1, 1084, -1, -1, 
	1084, -1, 1084, 1084, 1084, 1084, 1084, -1, 
	-1, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	1084, -1, 1084, 1084, -1, -1, -1, -1, 
	-1, 1084, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1083, -1, -1, -1, -1, -1, 
	1084, 1084, 1084, 1084, -1, -1, 1084, 1084, 
	1084, 1084, 1084, 1084, -1, -1, -1, -1, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	-1, -1, -1, -1, 1084, -1, -1, -1, 
	-1, 1084, 1084, -1, -1, 1084, 1084, 1084, 
	1084, -1, 1084, 1084, -1, -1, 1084, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 
	-1, -1, -1, 1084, 1084, 1084, -1, -1, 
	1084, 1084, -1, 1084, 1084, 1084, 1084, 1084, 
	1084, 1084, 1084, 1084, -1, -1, -1, 1084, 
	1084, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1084, 1084, -1, -1, 1084, 
	-1, -1, -1, -1, 1084, -1, 1084, 1084, 
	-1, 1084, -1, 1084, 1084, 1084, 1084, 1084, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, -1, -1, -1, -1, -1, 
	-1, 1083, -1, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 89, -1, -1, -1, 156, -1, 
	-1, -1, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	-1, -1, -1, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, -1, 
	-1, 152, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 141, 
	142, 143, 144, 145, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, 960, 960, 960, 960, 960, 960, 
	960, 960, -1, 960, 960, 960, 960, 960, 
	-1, 960, -1, 960, 960, 960, 960, -1, 
	960, -1, 960, 960, 960, -1, -1, 960, 
	960, 960, 960, 960, 960, 960, 960, -1, 
	960, 960, 960, -1, -1, -1, -1, 960, 
	960, 960, 960, 960, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1084, -1, -1, 960, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 960, 960, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 543, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, 1011, 960, 
	960, 960, 960, -1, -1, 960, 960, -1, 
	960, 960, 960, -1, -1, -1, -1, 960, 
	960, 960, -1, 960, 960, 960, 960, -1, 
	-1, -1, -1, 960, -1, -1, -1, -1, 
	960, -1, -1, -1, 960, 960, 960, 960, 
	-1, 960, 960, -1, -1, 960, -1, -1, 
	1084, -1, -1, -1, -1, -1, -1, 960, 
	960, 960, 960, 960, 960, 960, 960, -1, 
	-1, -1, -1, 960, 960, -1, -1, 960, 
	960, -1, -1, -1, -1, -1, -1, -1, 
	-1, 960, 960, -1, -1, -1, -1, 960, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, 960, 960, -1, 
	-1, -1, 89, -1, -1, -1, 156, -1, 
	-1, -1, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	-1, -1, -1, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, -1, 
	-1, 152, 78, 81, 82, 79, 80, 87, 
	88, -1, 83, 84, -1, -1, -1, 141, 
	142, 143, 144, 145, -1, 164, 165, 167, 
	166, 168, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 89, -1, -1, -1, 
	156, -1, -1, -1, 161, 162, 163, 86, 
	85, 155, -1, -1, -1, -1, 149, 150, 
	151, -1, -1, -1, -1, 1011, 147, -1, 
	171, 173, 175, 160, -1, -1, -1, -1, 
	-1, -1, -1, 152, 947, 1158, 1158, 1158, 
	1158, 1158, 1158, 1158, -1, 1158, 1158, -1, 
	-1, 141, 142, 143, 144, 145, -1, -1, 
	1158, 1158, 1158, 1158, 1158, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1158, 
	-1, -1, -1, 1158, -1, -1, -1, 1158, 
	1158, 1158, 1158, 1158, 1158, -1, -1, -1, 
	-1, 1158, 1158, 1158, -1, -1, -1, -1, 
	1158, 1158, -1, 1158, 1158, 1158, 1158, -1, 
	-1, -1, -1, -1, -1, -1, 1158, 1158, 
	960, -1, -1, -1, -1, -1, -1, 544, 
	-1, -1, -1, -1, 1158, 1158, 1158, 1158, 
	1158, -1, 230, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, -1, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, 1011, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 229, 545, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 230, 137, 138, 139, 
	140, -1, 146, 154, 158, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 169, 159, 153, 148, 
	1011, -1, -1, -1, -1, -1, -1, 960, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1158, 
	1158, 1158, 1158, 1158, -1, 1158, 1158, 1158, 
	-1, -1, -1, 1158, 1158, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1158, 
	1158, 1158, 1158, 1158, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 546, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 543, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, -1, -1, -1, 
	157, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 169, 159, 153, 148, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, -1, 1054, 1054, 1054, 1054, 1054, 
	-1, 1054, -1, 1054, 1054, 1054, 1054, -1, 
	1054, -1, 1054, 1054, 1054, -1, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, -1, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, -1, 1054, -1, -1, -1, 
	-1, 1054, 1054, 1054, 1054, 1054, -1, -1, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, 1054, 
	-1, 1054, 1054, -1, -1, -1, -1, -1, 
	1054, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1054, 
	1054, 1054, 1054, -1, -1, 1054, 1054, 1054, 
	1054, 1054, 1054, -1, -1, -1, -1, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, -1, 
	-1, -1, -1, 1054, -1, -1, -1, -1, 
	1054, 1054, -1, -1, 1054, 1054, 1054, 1054, 
	-1, 1054, 1054, -1, -1, 1054, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1054, 
	1054, 1054, 1054, 1054, 1054, 1054, 1054, -1, 
	-1, -1, 1054, 1054, 1054, 1054, -1, 1054, 
	1054, -1, 1054, 1054, 1054, 1054, 1054, -1, 
	1054, 1054, 1054, -1, -1, -1, 1054, 1054, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1054, 1054, -1, -1, 1054, -1, 
	-1, -1, -1, 1054, -1, -1, -1, -1, 
	1054, -1, 1054, 1054, 1054, 1054, 1054, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1054, -1, -1, -1, -1, -1, -1, -1, 
	544, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 230, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, -1, -1, -1, 
	157, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 169, 159, 153, 148, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 229, 545, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 230, 137, 138, 
	139, 140, -1, 146, 154, 158, -1, -1, 
	-1, -1, 157, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1054, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, 1028, 1028, -1, 1028, 1028, 1028, 
	1028, 1028, -1, 1028, -1, 1028, 1028, 1028, 
	1028, -1, 1028, -1, 1028, 1028, 1028, 546, 
	1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, 1028, 1028, 1028, -1, 1028, 1028, 
	1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, 1028, 1028, 1028, -1, 1028, -1, 
	-1, -1, -1, 1028, 1028, 1028, 1028, 1028, 
	-1, -1, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, 1028, -1, 1028, 1028, -1, -1, -1, 
	-1, -1, 1028, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1054, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1028, 1028, 1028, 1028, -1, -1, 1028, 
	1028, 1028, 1028, 1028, 1028, -1, -1, -1, 
	-1, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, -1, -1, -1, -1, 1028, -1, -1, 
	-1, -1, 1028, 1028, -1, -1, 1028, 1028, 
	1028, 1028, -1, 1028, 1028, -1, -1, 1028, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 
	1028, -1, -1, -1, 1028, 1028, 1028, -1, 
	-1, 1028, 1028, -1, 1028, 1028, 1028, 1028, 
	1028, -1, 1028, 1028, 1028, -1, -1, -1, 
	1028, 1028, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1028, 1028, -1, -1, 
	1028, -1, -1, -1, -1, 1028, -1, -1, 
	-1, -1, 1028, -1, 1028, 1028, 1028, 1028, 
	1028, -1, -1, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, 1029, 1029, -1, 1029, 
	1029, 1029, 1029, 1029, -1, 1029, -1, 1029, 
	1029, 1029, 1029, -1, 1029, -1, 1029, 1029, 
	1029, -1, 1029, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, 1029, 1029, 1029, -1, 
	1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, 1029, 1029, 1029, -1, 
	1029, -1, -1, -1, -1, 1029, 1029, 1029, 
	1029, 1029, -1, -1, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, 1029, -1, 1029, 1029, -1, 
	-1, -1, -1, -1, 1029, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1029, 1029, 1029, 1029, -1, 
	-1, 1029, 1029, 1029, 1029, 1029, 1029, -1, 
	-1, -1, 1028, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, -1, -1, -1, -1, 1029, 
	-1, -1, -1, -1, 1029, 1029, -1, -1, 
	1029, 1029, 1029, 1029, -1, 1029, 1029, -1, 
	-1, 1029, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1029, 1029, 1029, 1029, 1029, 
	1029, 1029, 1029, -1, -1, -1, 1029, 1029, 
	1029, -1, -1, 1029, 1029, -1, 1029, 1029, 
	1029, 1029, 1029, -1, 1029, 1029, 1029, -1, 
	-1, -1, 1029, 1029, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1029, 1029, 
	-1, -1, 1029, -1, -1, -1, -1, 1029, 
	-1, -1, -1, -1, 1029, -1, 1029, 1029, 
	1029, 1029, 1029, -1, -1, -1, 894, 894, 
	894, 894, 894, 894, 894, 894, 894, 894, 
	894, 894, 894, 894, 894, 894, -1, 894, 
	894, 894, 894, 894, 894, 894, 894, -1, 
	-1, -1, 894, 894, 894, 894, 894, -1, 
	894, 1028, 894, 894, 894, 894, -1, 894, 
	-1, 894, 894, 894, -1, -1, 894, -1, 
	-1, 894, 894, 894, 894, 894, -1, 894, 
	894, 894, -1, -1, -1, -1, 894, 894, 
	894, 894, 894, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1151, -1, 1151, 1151, 1151, 1151, 1151, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1151, -1, -1, -1, 
	894, 894, -1, -1, -1, 1151, 1151, 1151, 
	1151, 1151, -1, 1151, -1, 1151, -1, -1, 
	-1, -1, 1151, -1, -1, 1151, 1151, -1, 
	-1, -1, -1, -1, 1151, 1151, 1151, -1, 
	-1, -1, 1151, 1151, 1151, -1, -1, -1, 
	-1, 1151, 1151, 1151, 1151, 1151, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 894, 894, 
	894, 894, -1, -1, 894, 894, -1, 894, 
	894, 894, -1, -1, 1029, -1, 894, 894, 
	894, -1, 894, 894, 894, 894, -1, -1, 
	-1, -1, 894, -1, -1, -1, -1, 894, 
	894, -1, -1, 894, 894, 894, 894, -1, 
	894, 894, -1, -1, 894, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 894, 894, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 894, 894, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	894, 894, 1151, 1151, 1151, -1, 894, 1151, 
	1151, -1, -1, 1151, 1151, -1, -1, -1, 
	-1, 1151, 1151, 1151, -1, 1151, 1151, 1151, 
	1151, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1151, 1151, 894, 894, 1151, -1, 
	1151, 1151, -1, 1151, 1151, -1, -1, 1151, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 817, -1, 817, 817, 817, 817, 817, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1029, 817, -1, -1, -1, 
	-1, -1, -1, 1151, 1151, 817, 817, 817, 
	817, 817, -1, 817, -1, 817, -1, -1, 
	-1, -1, 817, -1, -1, 817, 817, -1, 
	-1, -1, -1, -1, 817, 817, 817, -1, 
	-1, -1, 817, 817, 817, -1, -1, -1, 
	-1, 817, 817, 817, 817, 817, 818, -1, 
	818, 818, 818, 818, 818, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 818, -1, -1, -1, -1, -1, -1, 
	-1, -1, 818, 818, 818, 818, 818, -1, 
	818, -1, 818, -1, -1, -1, -1, 818, 
	-1, -1, 818, 818, -1, -1, -1, -1, 
	-1, 818, 818, 818, -1, -1, -1, 818, 
	818, 818, -1, -1, -1, -1, 818, 818, 
	818, 818, 818, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 894, 
	-1, -1, 817, 817, 817, -1, -1, 817, 
	817, -1, -1, 817, 817, -1, -1, -1, 
	-1, 817, 817, 817, -1, 817, 817, 817, 
	817, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 817, 817, -1, -1, 817, -1, 
	817, 817, -1, 817, 817, -1, -1, 817, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 818, 
	818, 818, -1, -1, 818, 818, -1, -1, 
	818, 818, -1, 817, 817, -1, 818, 818, 
	818, -1, 818, 818, 818, 818, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 818, 
	818, -1, -1, 818, -1, 818, 818, -1, 
	818, 818, -1, 819, 818, 819, 819, 819, 
	819, 819, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 819, -1, 
	-1, -1, -1, -1, -1, -1, 894, 819, 
	819, 819, 819, 819, -1, 819, -1, 819, 
	818, 818, -1, -1, 819, -1, -1, 819, 
	819, -1, -1, -1, -1, -1, 819, 819, 
	819, -1, -1, -1, 819, 819, 819, -1, 
	-1, -1, -1, 819, 819, 819, 819, 819, 
	820, -1, 820, 820, 820, 820, 820, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 820, -1, -1, -1, -1, 
	-1, -1, -1, -1, 820, 820, 820, 820, 
	820, -1, 820, -1, 820, -1, -1, -1, 
	-1, 820, -1, -1, 820, 820, -1, -1, 
	-1, -1, -1, 820, 820, 820, -1, -1, 
	-1, 820, 820, 820, -1, -1, -1, -1, 
	820, 820, 820, 820, 820, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 819, 819, 819, -1, 
	-1, 819, 819, -1, -1, 819, 819, -1, 
	-1, -1, -1, 819, 819, 819, -1, 819, 
	819, 819, 819, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 819, 819, -1, -1, 
	819, -1, 819, 819, -1, 819, 819, -1, 
	-1, 819, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 820, 820, 820, -1, -1, 820, 820, 
	-1, -1, 820, 820, -1, 819, 819, -1, 
	820, 820, 820, -1, 820, 820, 820, 820, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 820, 820, -1, -1, 820, -1, 820, 
	820, -1, 820, 820, -1, 821, 820, 821, 
	821, 821, 821, 821, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	821, -1, -1, -1, -1, -1, -1, -1, 
	-1, 821, 821, 821, 821, 821, -1, 821, 
	-1, 821, 820, 820, -1, -1, 821, -1, 
	-1, 821, 821, -1, -1, -1, -1, -1, 
	821, 821, 821, -1, -1, -1, 821, 821, 
	821, -1, -1, -1, -1, 821, 821, 821, 
	821, 821, 822, -1, 822, 822, 822, 822, 
	822, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 822, -1, -1, 
	-1, -1, -1, -1, -1, -1, 822, 822, 
	822, 822, 822, -1, 822, -1, 822, -1, 
	-1, -1, -1, 822, -1, -1, 822, 822, 
	-1, -1, -1, -1, -1, 822, 822, 822, 
	-1, -1, -1, 822, 822, 822, -1, -1, 
	-1, -1, 822, 822, 822, 822, 822, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 821, 821, 
	821, -1, -1, 821, 821, -1, -1, 821, 
	821, -1, -1, -1, -1, 821, 821, 821, 
	-1, 821, 821, 821, 821, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 821, 821, 
	-1, -1, 821, -1, 821, 821, -1, 821, 
	821, -1, -1, 821, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 822, 822, 822, -1, -1, 
	822, 822, -1, -1, 822, 822, -1, 821, 
	821, -1, 822, 822, 822, -1, 822, 822, 
	822, 822, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 822, 822, -1, -1, 822, 
	-1, 822, 822, -1, 822, 822, -1, 823, 
	822, 823, 823, 823, 823, 823, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 823, -1, -1, -1, -1, -1, 
	-1, -1, -1, 823, 823, 823, 823, 823, 
	-1, 823, -1, 823, 822, 822, -1, -1, 
	823, -1, -1, 823, 823, -1, -1, -1, 
	-1, -1, 823, 823, 823, -1, -1, -1, 
	823, 823, 823, -1, -1, -1, -1, 823, 
	823, 823, 823, 823, 824, -1, 824, 824, 
	824, 824, 824, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 824, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	824, 824, 824, 824, 824, -1, 824, -1, 
	824, -1, -1, -1, -1, 824, -1, -1, 
	824, 824, -1, -1, -1, -1, -1, 824, 
	824, 824, -1, -1, -1, 824, 824, 824, 
	-1, -1, -1, -1, 824, 824, 824, 824, 
	824, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	823, 823, 823, -1, -1, 823, 823, -1, 
	-1, 823, 823, -1, -1, -1, -1, 823, 
	823, 823, -1, 823, 823, 823, 823, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	823, 823, -1, -1, 823, -1, 823, 823, 
	-1, 823, 823, -1, -1, 823, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 824, 824, 824, 
	-1, -1, 824, 824, -1, -1, 824, 824, 
	-1, 823, 823, -1, 824, 824, 824, -1, 
	824, 824, 824, 824, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 824, 824, -1, 
	-1, 824, -1, 824, 824, -1, 824, 824, 
	-1, 825, 824, 825, 825, 825, 825, 825, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 825, -1, -1, -1, 
	-1, -1, -1, -1, -1, 825, 825, 825, 
	825, 825, -1, 825, -1, 825, 824, 824, 
	-1, -1, 825, -1, -1, 825, 825, -1, 
	-1, -1, -1, -1, 825, 825, 825, -1, 
	-1, -1, 825, 825, 825, -1, -1, -1, 
	-1, 825, 825, 825, 825, 825, 826, -1, 
	826, 826, 826, 826, 826, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 826, -1, -1, -1, -1, -1, -1, 
	-1, -1, 826, 826, 826, 826, 826, -1, 
	826, -1, 826, -1, -1, -1, -1, 826, 
	-1, -1, 826, 826, -1, -1, -1, -1, 
	-1, 826, 826, 826, -1, -1, -1, 826, 
	826, 826, -1, -1, -1, -1, 826, 826, 
	826, 826, 826, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 825, 825, 825, -1, -1, 825, 
	825, -1, -1, 825, 825, -1, -1, -1, 
	-1, 825, 825, 825, -1, 825, 825, 825, 
	825, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 825, 825, -1, -1, 825, -1, 
	825, 825, -1, 825, 825, -1, -1, 825, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 826, 
	826, 826, -1, -1, 826, 826, -1, -1, 
	826, 826, -1, 825, 825, -1, 826, 826, 
	826, -1, 826, 826, 826, 826, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 826, 
	826, -1, -1, 826, -1, 826, 826, -1, 
	826, 826, -1, 827, 826, 827, 827, 827, 
	827, 827, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 827, -1, 
	-1, -1, -1, -1, -1, -1, -1, 827, 
	827, 827, 827, 827, -1, 827, -1, 827, 
	826, 826, -1, -1, 827, -1, -1, 827, 
	827, -1, -1, -1, -1, -1, 827, 827, 
	827, -1, -1, -1, 827, 827, 827, -1, 
	-1, -1, -1, 827, 827, 827, 827, 827, 
	828, -1, 828, 828, 828, 828, 828, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 828, -1, -1, -1, -1, 
	-1, -1, -1, -1, 828, 828, 828, 828, 
	828, -1, 828, -1, 828, -1, -1, -1, 
	-1, 828, -1, -1, 828, 828, -1, -1, 
	-1, -1, -1, 828, 828, 828, -1, -1, 
	-1, 828, 828, 828, -1, -1, -1, -1, 
	828, 828, 828, 828, 828, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 827, 827, 827, -1, 
	-1, 827, 827, -1, -1, 827, 827, -1, 
	-1, -1, -1, 827, 827, 827, -1, 827, 
	827, 827, 827, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 827, 827, -1, -1, 
	827, -1, 827, 827, -1, 827, 827, -1, 
	-1, 827, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 828, 828, 828, -1, -1, 828, 828, 
	-1, -1, 828, 828, -1, 827, 827, -1, 
	828, 828, 828, -1, 828, 828, 828, 828, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 828, 828, -1, -1, 828, -1, 828, 
	828, -1, 828, 828, -1, 829, 828, 829, 
	829, 829, 829, 829, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	829, -1, -1, -1, -1, -1, -1, -1, 
	-1, 829, 829, 829, 829, 829, -1, 829, 
	-1, 829, 828, 828, -1, -1, 829, -1, 
	-1, 829, 829, -1, -1, -1, -1, -1, 
	829, 829, 829, -1, -1, -1, 829, 829, 
	829, -1, -1, -1, -1, 829, 829, 829, 
	829, 829, 830, -1, 830, 830, 830, 830, 
	830, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 830, -1, -1, 
	-1, -1, -1, -1, -1, -1, 830, 830, 
	830, 830, 830, -1, 830, -1, 830, -1, 
	-1, -1, -1, 830, -1, -1, 830, 830, 
	-1, -1, -1, -1, -1, 830, 830, 830, 
	-1, -1, -1, 830, 830, 830, -1, -1, 
	-1, -1, 830, 830, 830, 830, 830, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 829, 829, 
	829, -1, -1, 829, 829, -1, -1, 829, 
	829, -1, -1, -1, -1, 829, 829, 829, 
	-1, 829, 829, 829, 829, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 829, 829, 
	-1, -1, 829, -1, 829, 829, -1, 829, 
	829, -1, -1, 829, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 830, 830, 830, -1, -1, 
	830, 830, -1, -1, 830, 830, -1, 829, 
	829, -1, 830, 830, 830, -1, 830, 830, 
	830, 830, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 830, 830, -1, -1, 830, 
	-1, 830, 830, -1, 830, 830, -1, 831, 
	830, 831, 831, 831, 831, 831, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 831, -1, -1, -1, -1, -1, 
	-1, -1, -1, 831, 831, 831, 831, 831, 
	-1, 831, -1, 831, 830, 830, -1, -1, 
	831, -1, -1, 831, 831, -1, -1, -1, 
	-1, -1, 831, 831, 831, -1, -1, -1, 
	831, 831, 831, -1, -1, -1, -1, 831, 
	831, 831, 831, 831, 832, -1, 832, 832, 
	832, 832, 832, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 832, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	832, 832, 832, 832, 832, -1, 832, -1, 
	832, -1, -1, -1, -1, 832, -1, -1, 
	832, 832, -1, -1, -1, -1, -1, 832, 
	832, 832, -1, -1, -1, 832, 832, 832, 
	-1, -1, -1, -1, 832, 832, 832, 832, 
	832, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	831, 831, 831, -1, -1, 831, 831, -1, 
	-1, 831, 831, -1, -1, -1, -1, 831, 
	831, 831, -1, 831, 831, 831, 831, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	831, 831, -1, -1, 831, -1, 831, 831, 
	-1, 831, 831, -1, -1, 831, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 832, 832, 832, 
	-1, -1, 832, 832, -1, -1, 832, 832, 
	-1, 831, 831, -1, 832, 832, 832, -1, 
	832, 832, 832, 832, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 832, 832, -1, 
	-1, 832, -1, 832, 832, -1, 832, 832, 
	-1, 833, 832, 833, 833, 833, 833, 833, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 833, -1, -1, -1, 
	-1, -1, -1, -1, -1, 833, 833, 833, 
	833, 833, -1, 833, -1, 833, 832, 832, 
	-1, -1, 833, -1, -1, 833, 833, -1, 
	-1, -1, -1, -1, 833, 833, 833, -1, 
	-1, -1, 833, 833, 833, -1, -1, -1, 
	-1, 833, 833, 833, 833, 833, 878, 878, 
	878, 878, 878, 878, 878, 878, 878, 878, 
	878, 878, 878, 878, 878, 878, -1, 878, 
	878, 878, 878, 878, 878, 878, 878, -1, 
	-1, -1, 878, 878, 878, 878, 878, -1, 
	878, -1, 878, 878, 878, 878, -1, 878, 
	-1, 878, 878, 878, -1, -1, 878, -1, 
	-1, 878, 878, 878, 878, 878, -1, 878, 
	878, 878, -1, -1, -1, -1, 878, 878, 
	878, 878, 878, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	878, 878, 833, 833, 833, -1, -1, 833, 
	833, -1, -1, 833, 833, -1, -1, -1, 
	-1, 833, 833, 833, -1, 833, 833, 833, 
	833, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 833, 833, -1, -1, 833, -1, 
	833, 833, -1, 833, 833, -1, -1, 833, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 878, 878, 
	878, 878, -1, -1, 878, 878, -1, 878, 
	878, 878, -1, 833, 833, -1, 878, 878, 
	878, -1, 878, 878, 878, 878, -1, -1, 
	-1, -1, 878, -1, -1, -1, -1, 878, 
	-1, -1, -1, 878, 878, 878, 878, -1, 
	878, 878, -1, -1, 878, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 878, 878, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 878, 878, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	878, 878, -1, -1, -1, -1, 878, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 878, 878, -1, -1, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, -1, 1094, 1094, 1094, 1094, 
	1094, -1, 1094, -1, 1094, 1094, 1094, 1094, 
	-1, 1094, -1, 1094, 1094, 1094, -1, 1094, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, -1, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, -1, 1094, -1, -1, 
	-1, -1, 1094, 1094, 1094, 1094, 1094, -1, 
	-1, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	1094, -1, 1094, 1094, -1, -1, -1, -1, 
	-1, 1094, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1094, 1094, 1094, 1094, -1, -1, 1094, 1094, 
	1094, 1094, 1094, 1094, -1, -1, -1, 878, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	-1, -1, -1, -1, 1094, -1, -1, -1, 
	-1, 1094, 1094, -1, -1, 1094, 1094, 1094, 
	1094, -1, 1094, 1094, -1, -1, 1094, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1094, 1094, 1094, 1094, 1094, 1094, 1094, 1094, 
	-1, -1, -1, 1094, 1094, 1094, -1, -1, 
	1094, 1094, -1, 1094, 1094, 1094, 1094, 1094, 
	-1, 1094, 1094, 1094, -1, -1, -1, 1094, 
	1094, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1094, 1094, -1, -1, 1094, 
	-1, -1, -1, -1, 1094, -1, -1, -1, 
	-1, 1094, -1, 1094, 1094, 1094, 1094, 1094, 
	-1, 1174, 1174, 1174, 1174, 1174, 1174, 1174, 
	-1, 1174, 1174, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1174, 1174, 1174, 1174, 
	1174, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1174, -1, -1, 878, 1174, 
	-1, -1, -1, 1174, 1174, 1174, 1174, 1174, 
	1174, -1, -1, -1, -1, 1174, 1174, 1174, 
	-1, -1, -1, -1, 1174, 1174, -1, 1174, 
	1174, 1174, 1174, -1, -1, -1, -1, -1, 
	-1, -1, 1174, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1174, 1174, 1174, 1174, 1174, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1174, -1, -1, -1, -1, -1, -1, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, -1, 1095, 1095, 1095, 1095, 
	1095, -1, 1095, -1, 1095, 1095, 1095, 1095, 
	-1, 1095, -1, 1095, 1095, 1095, -1, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, -1, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, -1, 1095, -1, -1, 
	-1, 1094, 1095, 1095, 1095, 1095, 1095, -1, 
	-1, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	1095, -1, 1095, 1095, -1, -1, -1, -1, 
	-1, 1095, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1174, 1174, 1174, 1174, 1174, 
	-1, 1174, 1174, 1174, -1, -1, -1, -1, 
	1174, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1174, 1174, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1174, -1, 1174, 1174, 1174, 1174, 1174, 
	1095, 1095, 1095, 1095, -1, -1, 1095, 1095, 
	1095, 1095, 1095, 1095, -1, -1, -1, -1, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	-1, -1, 585, -1, 1095, -1, -1, -1, 
	-1, 1095, 1095, -1, -1, 1095, 1095, 1095, 
	1095, -1, 1095, 1095, -1, -1, 1095, -1, 
	1094, -1, -1, -1, -1, -1, -1, -1, 
	1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 
	-1, -1, -1, 1095, 1095, 1095, -1, -1, 
	1095, 1095, -1, 1095, 1095, 1095, 1095, 1095, 
	-1, 1095, 1095, 1095, -1, -1, -1, 1095, 
	1095, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1095, 1095, -1, -1, 1095, 
	-1, -1, -1, -1, 1095, -1, -1, -1, 
	-1, 1095, -1, 1095, 1095, 1095, 1095, 1095, 
	-1, -1, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, -1, 1096, 1096, 
	1096, 1096, 1096, -1, 1096, -1, 1096, 1096, 
	1096, 1096, -1, 1096, -1, 1096, 1096, 1096, 
	-1, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, -1, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, -1, 1096, 
	-1, -1, -1, -1, 1096, 1096, 1096, 1096, 
	1096, -1, -1, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, 1096, -1, 1096, 1096, -1, -1, 
	-1, -1, -1, 1096, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1096, 1096, 1096, 1096, -1, -1, 
	1096, 1096, 1096, 1096, 1096, 1096, -1, -1, 
	-1, 1095, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, -1, -1, -1, -1, 1096, -1, 
	-1, -1, -1, 1096, 1096, -1, -1, 1096, 
	1096, 1096, 1096, -1, 1096, 1096, -1, -1, 
	1096, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1096, -1, -1, -1, 1096, 1096, 1096, 
	-1, -1, 1096, 1096, -1, 1096, 1096, 1096, 
	1096, 1096, -1, 1096, 1096, 1096, -1, -1, 
	-1, 1096, 1096, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1096, 1096, -1, 
	-1, 1096, -1, -1, -1, -1, 1096, -1, 
	-1, -1, -1, 1096, -1, 1096, 1096, 1096, 
	1096, 1096, -1, -1, -1, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	-1, 1100, 1100, 1100, 1100, 1100, -1, 1100, 
	1095, 1100, 1100, 1100, 1100, -1, 1100, -1, 
	1100, 1100, 1100, -1, 1100, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, -1, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, -1, 1100, -1, -1, -1, -1, 1100, 
	1100, 1100, 1100, 1100, -1, -1, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, 1100, -1, 1100, 
	1100, -1, -1, -1, -1, -1, 1100, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1100, 1100, 1100, 
	1100, -1, -1, 1100, 1100, 1100, 1100, 1100, 
	1100, -1, -1, 1096, -1, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, -1, -1, -1, 
	-1, 1100, -1, -1, -1, -1, 1100, 1100, 
	-1, -1, 1100, 1100, 1100, 1100, -1, 1100, 
	1100, -1, -1, 1100, -1, -1, -1, -1, 
	-1, -1, -1, 585, -1, 1100, 1100, 1100, 
	1100, 1100, 1100, 1100, 1100, -1, -1, -1, 
	1100, 1100, 1100, -1, -1, 1100, 1100, -1, 
	1100, 1100, 1100, 1100, 1100, -1, 1100, 1100, 
	1100, -1, -1, -1, 1100, 1100, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1100, 1100, -1, -1, 1100, -1, -1, -1, 
	-1, 1100, -1, -1, -1, -1, 1100, -1, 
	1100, 1100, 1100, 1100, 1100, 1173, 1173, 1173, 
	1173, 1173, 1173, 1173, -1, 1173, 1173, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1173, 1173, 1173, 1173, 1173, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1173, 
	-1, -1, 1096, 1173, -1, -1, -1, 1173, 
	1173, 1173, 1173, 1173, 1173, -1, -1, -1, 
	-1, 1173, 1173, 1173, -1, -1, -1, -1, 
	1173, 1173, -1, 1173, 1173, 1173, 1173, 1173, 
	-1, -1, -1, -1, -1, -1, 1173, 78, 
	81, 82, 79, 80, 87, 88, -1, 83, 
	84, -1, -1, -1, 1173, 1173, 1173, 1173, 
	1173, -1, 164, 165, 167, 166, 168, -1, 
	-1, -1, -1, -1, -1, 1173, -1, -1, 
	-1, 89, -1, -1, -1, 156, -1, -1, 
	-1, 161, 162, 163, 86, 85, 155, -1, 
	-1, -1, -1, 149, 150, 151, -1, -1, 
	-1, -1, 1011, 147, -1, 171, 173, 175, 
	160, -1, -1, -1, -1, -1, -1, -1, 
	152, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 141, 142, 
	143, 144, 145, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1100, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1173, 
	1173, 1173, 1173, 1173, -1, 1173, 1173, 1173, 
	-1, -1, -1, -1, 1173, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1173, 
	1173, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1173, -1, 1173, 
	1173, 1173, 1173, 1173, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 589, 137, 138, 139, 140, -1, 146, 
	154, 158, -1, -1, -1, -1, 157, -1, 
	-1, -1, -1, -1, -1, 1100, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 169, 159, 153, 148, 1011, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, -1, 995, 995, 995, 995, 995, -1, 
	995, -1, 995, 995, 995, 995, -1, 995, 
	-1, 995, 995, 995, -1, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, -1, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, -1, 995, -1, -1, -1, -1, 
	995, 995, 995, 995, 995, -1, -1, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, -1, 
	995, 995, -1, -1, -1, -1, -1, 995, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 995, 995, 
	995, 995, -1, -1, 995, 995, 995, 995, 
	995, 995, -1, -1, -1, -1, 995, 995, 
	995, 995, 995, 995, 995, 995, -1, -1, 
	-1, -1, 995, -1, -1, -1, -1, 995, 
	995, -1, -1, 995, 995, 995, 995, -1, 
	995, 995, -1, -1, 995, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 995, 995, 
	995, 995, 995, 995, 995, 995, -1, -1, 
	-1, 995, 995, 995, -1, -1, 995, 995, 
	-1, 995, 995, 995, 995, 995, -1, 995, 
	995, 995, -1, -1, -1, 995, 995, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 995, 995, -1, -1, 995, -1, -1, 
	-1, -1, 995, -1, -1, -1, -1, 995, 
	-1, 995, 995, 995, 995, 995, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, -1, 981, 981, 981, 
	981, 981, -1, 981, -1, 981, 981, 981, 
	981, -1, 981, -1, 981, 981, 981, -1, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, -1, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, -1, 981, -1, 
	-1, -1, -1, 981, 981, 981, 981, 981, 
	-1, -1, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, -1, 981, 981, -1, -1, -1, 
	-1, -1, 981, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 995, 
	-1, 981, 981, 981, 981, -1, -1, 981, 
	981, 981, 981, 981, 981, -1, -1, -1, 
	-1, 981, 981, 981, 981, 981, 981, 981, 
	981, -1, -1, -1, -1, 981, -1, -1, 
	-1, -1, 981, 981, -1, -1, 981, 981, 
	981, 981, -1, 981, 981, -1, -1, 981, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 981, 981, 981, 981, 981, 981, 981, 
	981, -1, -1, -1, 981, 981, 981, -1, 
	-1, 981, 981, -1, 981, 981, 981, 981, 
	981, -1, 981, 981, 981, -1, -1, -1, 
	981, 981, 589, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, 981, 981, -1, 157, 
	981, -1, -1, -1, -1, 981, -1, -1, 
	-1, -1, 981, -1, 981, 981, 981, 981, 
	981, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, -1, -1, 
	-1, -1, -1, -1, -1, -1, 995, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, -1, 963, 963, 963, 963, 963, 
	-1, 963, -1, 963, 963, 963, 963, -1, 
	963, -1, 963, 963, 963, -1, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, -1, 963, 963, 963, 963, 
	963, 963, 963, 963, 963, 963, 963, 963, 
	963, 963, 963, -1, -1, -1, -1, -1, 
	-1, 963, 963, 963, 963, -1, -1, -1, 
	278, 279, 963, 280, 281, 282, 283, 963, 
	963, 963, 963, 963, -1, -1, 963, 963, 
	-1, 963, 963, -1, -1, -1, -1, -1, 
	963, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 981, -1, -1, -1, -1, 963, 
	963, 963, 963, -1, -1, 963, 963, 963, 
	963, 963, 963, -1, -1, -1, -1, 963, 
	963, 963, 963, 963, 963, 963, 963, -1, 
	-1, -1, -1, 963, -1, -1, -1, -1, 
	963, 963, -1, -1, 963, 963, 963, 963, 
	-1, 963, 963, -1, -1, 963, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 963, 
	963, 963, 963, 963, 963, 963, 963, -1, 
	-1, -1, 963, 963, 963, -1, -1, 963, 
	963, -1, 963, 963, 963, 963, 963, -1, 
	963, 963, 963, -1, -1, -1, 963, 963, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 963, 963, -1, -1, 963, -1, 
	-1, -1, -1, 963, -1, -1, -1, -1, 
	963, -1, 963, 963, 963, 963, 963, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 981, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, -1, 964, 964, 
	964, 964, 964, -1, 964, -1, 964, 964, 
	964, 964, -1, 964, -1, 964, 964, 964, 
	-1, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, -1, 964, 
	964, 964, 964, 964, 964, 964, 964, 964, 
	964, 964, 964, 964, 964, 964, -1, -1, 
	-1, -1, -1, -1, 964, 964, 964, 964, 
	-1, -1, -1, 278, 279, 964, 280, 281, 
	282, 283, 964, 964, 964, 964, 964, -1, 
	-1, 964, 964, -1, 964, 964, -1, -1, 
	-1, -1, -1, 964, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	963, -1, 964, 964, 964, 964, -1, -1, 
	964, 964, 964, 964, 964, 964, -1, -1, 
	-1, -1, 964, 964, 964, 964, 964, 964, 
	964, 964, -1, -1, -1, -1, 964, -1, 
	-1, -1, -1, 964, 964, -1, -1, 964, 
	964, 964, 964, -1, 964, 964, -1, -1, 
	964, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 964, 964, 964, 964, 964, 964, 
	964, 964, -1, -1, -1, 964, 964, 964, 
	-1, -1, 964, 964, -1, 964, 964, 964, 
	964, 964, -1, 964, 964, 964, -1, -1, 
	-1, 964, 964, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 964, 964, -1, 
	-1, 964, -1, -1, -1, -1, 964, -1, 
	-1, -1, -1, 964, -1, 964, 964, 964, 
	964, 964, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 963, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	769, 769, 769, -1, 769, 769, 769, 769, 
	769, -1, 769, -1, 769, 769, 769, 769, 
	-1, 769, -1, 769, 769, 769, -1, -1, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	-1, 769, 769, 769, -1, -1, -1, -1, 
	769, 769, 769, 769, 769, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 769, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 769, 769, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 964, -1, -1, -1, -1, 
	769, 769, 769, 769, -1, -1, 769, 769, 
	-1, 769, 769, 769, -1, -1, -1, -1, 
	769, 769, 769, -1, 769, 769, 769, 769, 
	-1, -1, -1, -1, 769, -1, -1, -1, 
	-1, 769, -1, -1, -1, 769, 769, 769, 
	769, -1, 769, 769, -1, -1, 769, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	769, 769, 769, 769, 769, 769, 769, 769, 
	-1, -1, -1, -1, 769, 769, -1, -1, 
	769, 769, -1, -1, -1, -1, -1, -1, 
	-1, -1, 769, 769, -1, -1, -1, -1, 
	769, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 769, 769, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 964, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 943, 943, 943, 943, 
	943, 943, 943, 943, 449, 450, -1, 943, 
	943, 943, 943, 943, -1, 943, -1, 943, 
	943, 943, 943, -1, 943, -1, 943, 943, 
	943, -1, -1, 943, 943, 943, 943, 943, 
	943, 943, 943, -1, 943, 943, 943, -1, 
	-1, -1, -1, 943, 943, 943, 943, 943, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	943, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 943, 943, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 769, -1, 943, 943, 943, 943, -1, 
	-1, 943, 943, -1, 943, 943, 943, -1, 
	-1, -1, -1, 943, 943, 943, -1, 943, 
	943, 943, 943, -1, -1, -1, -1, 943, 
	-1, -1, -1, -1, 943, -1, -1, -1, 
	943, 943, 943, 943, -1, 943, 943, -1, 
	-1, 943, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 943, 943, 943, 943, 943, 
	594, 446, 448, -1, -1, -1, -1, 943, 
	943, -1, -1, 943, 943, -1, -1, -1, 
	-1, -1, -1, -1, -1, 943, 943, -1, 
	-1, -1, -1, 943, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 943, 943, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	769, 940, 940, 940, 940, 940, 940, 940, 
	940, 940, 940, 940, 940, 940, 940, 940, 
	940, 940, 940, 940, 940, 940, 940, 940, 
	940, 940, 940, 940, -1, 940, 940, 940, 
	940, 940, -1, 940, -1, 940, 940, 940, 
	940, -1, 940, -1, 940, 940, 940, -1, 
	-1, 940, 940, 940, 940, 940, 940, 940, 
	940, -1, 940, 940, 940, -1, -1, -1, 
	-1, 940, 940, 940, 940, 940, -1, -1, 
	-1, -1, -1, 78, 81, 82, 79, 80, 
	87, 88, -1, 83, 84, -1, 940, -1, 
	-1, -1, -1, -1, -1, -1, 164, 165, 
	167, 166, 168, -1, -1, -1, -1, -1, 
	-1, -1, -1, 940, 940, 89, -1, -1, 
	-1, 156, -1, -1, -1, 161, 162, 163, 
	86, 85, 155, -1, -1, -1, -1, 149, 
	150, 151, -1, -1, -1, -1, 1011, 147, 
	-1, 171, 173, 175, 160, -1, -1, -1, 
	-1, -1, -1, -1, 152, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 141, 142, 143, 144, 145, -1, 
	-1, -1, -1, -1, 943, -1, -1, -1, 
	-1, 940, 940, 940, 940, -1, -1, 940, 
	940, -1, 940, 940, 940, -1, -1, -1, 
	-1, 940, 940, 940, -1, 940, 940, 940, 
	940, -1, -1, -1, -1, 940, -1, -1, 
	-1, -1, 940, -1, -1, -1, 940, 940, 
	940, 940, -1, 940, 940, -1, -1, 940, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 940, 940, 940, 940, 940, 940, 940, 
	940, -1, -1, -1, -1, 940, 940, -1, 
	-1, 940, 940, -1, -1, -1, -1, -1, 
	-1, -1, -1, 940, 940, -1, -1, -1, 
	-1, 940, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 940, 
	940, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 943, -1, 591, 137, 138, 
	139, 140, -1, 146, 154, 158, -1, -1, 
	-1, -1, 157, -1, 69, 70, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, 48, 49, 53, 51, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, 1011, 54, 55, 56, -1, -1, -1, 
	89, -1, -1, -1, -1, 50, -1, -1, 
	-1, -1, -1, 86, 85, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 73, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 90, 
	91, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 940, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 593, 445, 447, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	58, 277, -1, -1, -1, -1, -1, -1, 
	592, -1, -1, -1, -1, 47, 46, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, -1, -1, -1, -1, 57, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 52, 1011, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 940, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, -1, 966, 966, 
	966, 966, 966, -1, 966, -1, 966, 966, 
	966, 966, -1, 966, -1, 966, 966, 966, 
	-1, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, -1, 966, 
	966, 966, 966, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, -1, -1, 
	-1, -1, -1, -1, 966, 966, 966, 966, 
	-1, -1, -1, 966, 966, 966, 966, 966, 
	966, 966, 966, 966, 966, 966, 966, 284, 
	285, 966, 966, -1, 966, 966, -1, -1, 
	-1, -1, -1, 966, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 966, 966, 966, 966, -1, -1, 
	966, 966, 966, 966, 966, 966, -1, -1, 
	-1, -1, 966, 966, 966, 966, 966, 966, 
	966, 966, -1, -1, -1, -1, 966, -1, 
	-1, -1, -1, 966, 966, -1, -1, 966, 
	966, 966, 966, -1, 966, 966, -1, -1, 
	966, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 966, 966, 966, 966, 966, 966, 
	966, 966, -1, -1, -1, 966, 966, 966, 
	-1, -1, 966, 966, -1, 966, 966, 966, 
	966, 966, -1, 966, 966, 966, -1, -1, 
	-1, 966, 966, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 966, 966, -1, 
	-1, 966, -1, -1, -1, -1, 966, -1, 
	-1, -1, -1, 966, -1, 966, 966, 966, 
	966, 966, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 591, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, -1, 967, 967, 
	967, 967, 967, -1, 967, -1, 967, 967, 
	967, 967, -1, 967, -1, 967, 967, 967, 
	-1, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, -1, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, -1, -1, 
	-1, -1, -1, 966, 967, 967, 967, 967, 
	-1, -1, -1, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 284, 
	285, 967, 967, -1, 967, 967, -1, -1, 
	-1, -1, -1, 967, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 58, 277, -1, -1, -1, -1, -1, 
	-1, 592, -1, -1, -1, -1, 47, 46, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 76, -1, -1, -1, -1, 57, -1, 
	-1, -1, 967, 967, 967, 967, -1, -1, 
	967, 967, 967, 967, 967, 967, -1, -1, 
	-1, -1, 967, 967, 967, 967, 967, 967, 
	967, 967, -1, -1, 52, -1, 967, -1, 
	-1, -1, -1, 967, 967, -1, -1, 967, 
	967, 967, 967, -1, 967, 967, -1, -1, 
	967, -1, 966, -1, -1, -1, -1, -1, 
	-1, -1, 967, 967, 967, 967, 967, 967, 
	967, 967, -1, -1, -1, 967, 967, 967, 
	-1, -1, 967, 967, -1, 967, 967, 967, 
	967, 967, -1, 967, 967, 967, -1, -1, 
	-1, 967, 967, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 967, 967, -1, 
	-1, 967, -1, -1, -1, -1, 967, -1, 
	-1, -1, -1, 967, -1, 967, 967, 967, 
	967, 967, -1, -1, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, -1, 
	968, 968, 968, 968, 968, -1, 968, -1, 
	968, 968, 968, 968, -1, 968, -1, 968, 
	968, 968, -1, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	-1, 968, 968, 968, 968, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	-1, -1, -1, -1, -1, -1, 968, 968, 
	968, 968, -1, -1, -1, 968, 968, 968, 
	968, 968, 968, 968, 968, 968, 968, 968, 
	968, 284, 285, 968, 968, -1, 968, 968, 
	-1, -1, -1, -1, -1, 968, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 968, 968, 968, 968, 
	-1, -1, 968, 968, 968, 968, 968, 968, 
	-1, -1, -1, 967, 968, 968, 968, 968, 
	968, 968, 968, 968, -1, -1, -1, -1, 
	968, -1, -1, -1, -1, 968, 968, -1, 
	-1, 968, 968, 968, 968, -1, 968, 968, 
	-1, -1, 968, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 968, 968, 968, 968, 
	968, 968, 968, 968, -1, -1, -1, 968, 
	968, 968, -1, -1, 968, 968, -1, 968, 
	968, 968, 968, 968, -1, 968, 968, 968, 
	-1, -1, -1, 968, 968, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 968, 
	968, -1, -1, 968, -1, -1, -1, -1, 
	968, -1, -1, -1, -1, 968, -1, 968, 
	968, 968, 968, 968, -1, -1, -1, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, -1, 969, 969, 969, 969, 969, 
	-1, 969, 967, 969, 969, 969, 969, -1, 
	969, -1, 969, 969, 969, -1, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, -1, 969, 969, 969, 969, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, -1, -1, -1, -1, -1, 
	-1, 969, 969, 969, 969, -1, -1, -1, 
	969, 969, 969, 969, 969, 969, 969, 969, 
	969, 969, 969, 969, 284, 285, 969, 969, 
	-1, 969, 969, -1, -1, -1, -1, -1, 
	969, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 969, 
	969, 969, 969, -1, -1, 969, 969, 969, 
	969, 969, 969, -1, -1, 968, -1, 969, 
	969, 969, 969, 969, 969, 969, 969, -1, 
	-1, -1, -1, 969, -1, -1, -1, -1, 
	969, 969, -1, -1, 969, 969, 969, 969, 
	-1, 969, 969, -1, -1, 969, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 969, 
	969, 969, 969, 969, 969, 969, 969, -1, 
	-1, -1, 969, 969, 969, -1, -1, 969, 
	969, -1, 969, 969, 969, 969, 969, -1, 
	969, 969, 969, -1, -1, -1, 969, 969, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 969, 969, -1, -1, 969, -1, 
	-1, -1, -1, 969, -1, -1, -1, -1, 
	969, -1, 969, 969, 969, 969, 969, -1, 
	-1, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, -1, 970, 970, 970, 
	970, 970, -1, 970, 968, 970, 970, 970, 
	970, -1, 970, -1, 970, 970, 970, -1, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, -1, 970, 970, 
	970, 970, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, -1, -1, -1, 
	-1, -1, -1, 970, 970, 970, 970, -1, 
	-1, -1, 970, 970, 970, 970, 970, 970, 
	970, 970, 970, 970, 970, 970, 284, 285, 
	970, 970, -1, 970, 970, -1, -1, -1, 
	-1, -1, 970, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 970, 970, 970, 970, -1, -1, 970, 
	970, 970, 970, 970, 970, -1, -1, -1, 
	969, 970, 970, 970, 970, 970, 970, 970, 
	970, -1, -1, -1, -1, 970, -1, -1, 
	-1, -1, 970, 970, -1, -1, 970, 970, 
	970, 970, -1, 970, 970, -1, -1, 970, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 970, 970, 970, 970, 970, 970, 970, 
	970, -1, -1, -1, 970, 970, 970, -1, 
	-1, 970, 970, -1, 970, 970, 970, 970, 
	970, -1, 970, 970, 970, -1, -1, -1, 
	970, 970, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 970, 970, -1, -1, 
	970, -1, -1, -1, -1, 970, -1, -1, 
	-1, -1, 970, -1, 970, 970, 970, 970, 
	970, -1, -1, -1, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, -1, 
	971, 971, 971, 971, 971, -1, 971, 969, 
	971, 971, 971, 971, -1, 971, -1, 971, 
	971, 971, -1, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	-1, 971, 971, 971, 971, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	-1, -1, -1, -1, -1, -1, 971, 971, 
	971, 971, -1, -1, -1, 971, 971, 971, 
	971, 971, 971, 971, 971, 971, 971, 971, 
	971, 284, 285, 971, 971, -1, 971, 971, 
	-1, -1, -1, -1, -1, 971, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 971, 971, 971, 971, 
	-1, -1, 971, 971, 971, 971, 971, 971, 
	-1, -1, 970, -1, 971, 971, 971, 971, 
	971, 971, 971, 971, -1, -1, -1, -1, 
	971, -1, -1, -1, -1, 971, 971, -1, 
	-1, 971, 971, 971, 971, -1, 971, 971, 
	-1, -1, 971, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 971, 971, 971, 971, 
	971, 971, 971, 971, -1, -1, -1, 971, 
	971, 971, -1, -1, 971, 971, -1, 971, 
	971, 971, 971, 971, -1, 971, 971, 971, 
	-1, -1, -1, 971, 971, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 971, 
	971, -1, -1, 971, -1, -1, -1, -1, 
	971, -1, -1, -1, -1, 971, -1, 971, 
	971, 971, 971, 971, -1, -1, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, -1, 973, 973, 973, 973, 973, -1, 
	973, 970, 973, 973, 973, 973, -1, 973, 
	-1, 973, 973, 973, -1, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, -1, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, -1, 287, -1, -1, -1, -1, 
	973, 973, 973, 973, 286, -1, -1, 973, 
	973, 973, 973, 973, 973, 973, 973, 973, 
	973, 973, 973, 973, 973, 973, 973, -1, 
	973, 973, -1, -1, -1, -1, -1, 973, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 973, 973, 
	973, 973, -1, -1, 973, 973, 973, 973, 
	973, 973, -1, -1, -1, 971, 973, 973, 
	973, 973, 973, 973, 973, 973, -1, -1, 
	-1, -1, 973, -1, -1, -1, -1, 973, 
	973, -1, -1, 973, 973, 973, 973, -1, 
	973, 973, -1, -1, 973, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 973, 973, 
	973, 973, 973, 973, 973, 973, -1, -1, 
	-1, 973, 973, 973, -1, -1, 973, 973, 
	-1, 973, 973, 973, 973, 973, -1, 973, 
	973, 973, -1, -1, -1, 973, 973, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 973, 973, -1, -1, 973, -1, -1, 
	-1, -1, 973, -1, -1, -1, -1, 973, 
	-1, 973, 973, 973, 973, 973, -1, -1, 
	-1, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, -1, 974, 974, 974, 
	974, 974, -1, 974, 971, 974, 974, 974, 
	974, -1, 974, -1, 974, 974, 974, -1, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, -1, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, -1, 287, -1, 
	-1, -1, -1, 974, 974, 974, 974, 286, 
	-1, -1, 974, 974, 974, 974, 974, 974, 
	974, 974, 974, 974, 974, 974, 974, 974, 
	974, 974, -1, 974, 974, -1, -1, -1, 
	-1, -1, 974, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 974, 974, 974, 974, -1, -1, 974, 
	974, 974, 974, 974, 974, -1, -1, 973, 
	-1, 974, 974, 974, 974, 974, 974, 974, 
	974, -1, -1, -1, -1, 974, -1, -1, 
	-1, -1, 974, 974, -1, -1, 974, 974, 
	974, 974, -1, 974, 974, -1, -1, 974, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 974, 974, 974, 974, 974, 974, 974, 
	974, -1, -1, -1, 974, 974, 974, -1, 
	-1, 974, 974, -1, 974, 974, 974, 974, 
	974, -1, 974, 974, 974, -1, -1, -1, 
	974, 974, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 974, 974, -1, -1, 
	974, -1, -1, -1, -1, 974, -1, -1, 
	-1, -1, 974, -1, 974, 974, 974, 974, 
	974, -1, -1, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, -1, 977, 
	977, 977, 977, 977, -1, 977, 973, 977, 
	977, 977, 977, -1, 977, -1, 977, 977, 
	977, -1, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, -1, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, -1, 
	977, -1, -1, -1, -1, 977, 977, 977, 
	977, 977, -1, -1, 977, 977, 977, 977, 
	977, 977, 977, 977, 977, 977, 977, 977, 
	977, 977, 977, 977, -1, 977, 977, -1, 
	-1, -1, -1, -1, 977, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 977, 977, 977, 977, -1, 
	-1, 977, 977, 977, 977, 977, 977, -1, 
	-1, -1, 974, 977, 977, 977, 977, 977, 
	977, 977, 977, -1, -1, -1, -1, 977, 
	-1, -1, -1, -1, 977, 977, -1, -1, 
	977, 977, 977, 977, -1, 977, 977, -1, 
	-1, 977, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 977, 977, 977, 977, 977, 
	977, 977, 977, -1, -1, -1, 977, 977, 
	977, -1, -1, 977, 977, -1, 977, 977, 
	977, 977, 977, -1, 977, 977, 977, -1, 
	-1, -1, 977, 977, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 977, 977, 
	-1, -1, 977, -1, -1, -1, -1, 977, 
	-1, -1, -1, -1, 977, -1, 977, 977, 
	977, 977, 977, -1, -1, -1, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, -1, 976, 976, 976, 976, 976, -1, 
	976, 974, 976, 976, 976, 976, -1, 976, 
	-1, 976, 976, 976, -1, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, -1, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, -1, 976, -1, -1, -1, -1, 
	976, 976, 976, 976, 976, -1, -1, 976, 
	976, 976, 976, 976, 976, 976, 976, 976, 
	976, 976, 976, 976, 976, 976, 976, -1, 
	976, 976, -1, -1, -1, -1, -1, 976, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 976, 976, 
	976, 976, -1, -1, 976, 976, 976, 976, 
	976, 976, -1, -1, 977, -1, 976, 976, 
	976, 976, 976, 976, 976, 976, -1, -1, 
	-1, -1, 976, -1, -1, -1, -1, 976, 
	976, -1, -1, 976, 976, 976, 976, -1, 
	976, 976, -1, -1, 976, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 976, 976, 
	976, 976, 976, 976, 976, 976, -1, -1, 
	-1, 976, 976, 976, -1, -1, 976, 976, 
	-1, 976, 976, 976, 976, 976, -1, 976, 
	976, 976, -1, -1, -1, 976, 976, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 976, 976, -1, -1, 976, -1, -1, 
	-1, -1, 976, -1, -1, -1, -1, 976, 
	-1, 976, 976, 976, 976, 976, -1, -1, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, -1, 997, 997, 997, 997, 
	997, -1, 997, 977, 997, 997, 997, 997, 
	-1, 997, -1, 997, 997, 997, -1, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, -1, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, -1, 997, -1, -1, 
	-1, -1, 997, 997, 997, 997, 997, -1, 
	-1, 997, 997, 997, 997, 997, 997, 997, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	997, -1, 997, 997, -1, -1, -1, -1, 
	-1, 997, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	997, 997, 997, 997, -1, -1, 997, 997, 
	997, 997, 997, 997, -1, -1, -1, 976, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	-1, -1, -1, -1, 997, -1, -1, -1, 
	-1, 997, 997, -1, -1, 997, 997, 997, 
	997, -1, 997, 997, -1, -1, 997, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	997, 997, 997, 997, 997, 997, 997, 997, 
	-1, -1, -1, 997, 997, 997, -1, -1, 
	997, 997, -1, 997, 997, 997, 997, 997, 
	-1, 997, 997, 997, -1, -1, -1, 997, 
	997, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 997, 997, -1, -1, 997, 
	-1, -1, -1, -1, 997, -1, -1, -1, 
	-1, 997, -1, 997, 997, 997, 997, 997, 
	-1, -1, -1, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, 1001, -1, 1001, 976, 1001, 
	1001, 1001, 1001, 1001, 1001, -1, 1001, 1001, 
	1001, -1, -1, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, -1, 1001, 1001, 1001, 1001, 
	-1, -1, -1, 1001, 1001, 1001, 1001, 1001, 
	-1, -1, 1001, 1001, 1001, 1001, -1, -1, 
	-1, 1001, -1, -1, -1, 1001, 1001, -1, 
	1001, -1, -1, 1001, -1, -1, 1001, -1, 
	1001, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1001, 1001, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1001, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1001, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1001, 1001, 1001, 1001, -1, 
	-1, 1001, 1001, 1001, 1001, 1001, 1001, -1, 
	-1, 997, -1, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, -1, -1, 1001, -1, 1001, 
	-1, -1, -1, -1, 1001, 1001, -1, 1001, 
	1001, 1001, 1001, 1001, -1, 1001, 1001, -1, 
	-1, 1001, -1, -1, -1, -1, -1, -1, 
	1001, -1, 1001, 1001, 1001, 1001, 1001, 1001, 
	1001, 1001, 1001, -1, -1, -1, -1, 1001, 
	1001, -1, 1001, 1001, 1001, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1001, 1001, -1, 
	-1, 1001, -1, 1001, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1001, 1001, 1001, -1, 
	-1, 1001, 1001, 1001, -1, -1, -1, -1, 
	-1, 1001, 1001, 1158, 1158, 1158, 1158, 1158, 
	1158, 1158, -1, 1158, 1158, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1158, 1158, 
	1158, 1158, 1158, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1158, -1, -1, 
	997, 1158, -1, -1, -1, 1158, 1158, 1158, 
	1158, 1158, 1158, -1, -1, -1, -1, 1158, 
	1158, 1158, -1, -1, -1, -1, 1158, 1158, 
	-1, 1158, 1158, 1158, 1158, -1, -1, -1, 
	-1, -1, -1, -1, 1158, 1158, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1158, 1158, 1158, 1158, 1158, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 848, 848, 
	848, 848, 848, 848, 848, 848, 848, 848, 
	848, 848, 848, 848, 848, 848, -1, 848, 
	848, 848, 848, 848, 848, 848, 848, -1, 
	-1, -1, 848, 848, 848, 848, 848, -1, 
	848, -1, 848, 848, 848, 848, -1, 848, 
	-1, 848, 848, 848, -1, -1, 848, -1, 
	-1, 848, 848, 848, 848, 848, -1, 848, 
	848, 848, -1, -1, -1, -1, 848, 848, 
	848, 848, 848, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1001, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	848, 848, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1158, 1158, 1158, 
	1158, 1158, -1, 1158, 1158, 1158, -1, -1, 
	-1, 1158, 1158, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1158, 1158, 1158, 
	1158, 1158, -1, -1, -1, -1, 848, 848, 
	848, 848, -1, -1, 848, 848, 848, 848, 
	848, 848, -1, -1, 599, -1, 848, 848, 
	848, 848, 848, 848, 848, 848, -1, -1, 
	-1, -1, 848, -1, -1, -1, -1, 848, 
	848, -1, -1, 848, 848, 848, 848, -1, 
	848, 848, -1, 1001, 848, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 848, 848, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 848, 848, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	848, 848, -1, -1, -1, -1, 848, -1, 
	69, 70, 78, 81, 82, 79, 80, 87, 
	88, -1, 83, 84, -1, -1, 48, 49, 
	53, 51, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 848, 848, 54, 55, 
	56, -1, -1, -1, 89, -1, -1, -1, 
	-1, 50, -1, -1, -1, -1, -1, 86, 
	85, 69, 70, 78, 81, 82, 79, 80, 
	87, 88, -1, 83, 84, 73, -1, 48, 
	49, 53, 51, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 276, -1, 54, 
	55, 56, -1, -1, -1, 89, -1, -1, 
	-1, -1, 50, -1, -1, -1, -1, -1, 
	86, 85, -1, 90, 91, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 73, -1, 
	-1, 244, 246, 248, 242, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 276, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 90, 91, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 848, 
	-1, -1, -1, -1, 58, 277, -1, -1, 
	-1, -1, -1, -1, 604, -1, -1, -1, 
	-1, 47, 46, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 76, -1, -1, -1, 
	-1, 57, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 58, 277, -1, 
	-1, -1, -1, -1, -1, 602, -1, 52, 
	1011, -1, 47, 46, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 76, -1, -1, 
	-1, -1, 57, -1, -1, -1, -1, -1, 
	-1, -1, 243, 241, 603, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	52, 1011, -1, 774, 774, 774, 774, 774, 
	774, 774, 774, 774, 774, 774, 774, 774, 
	774, 774, 774, 774, 774, 774, 774, 774, 
	774, 774, 774, 774, 774, 774, 848, 774, 
	774, 774, 774, 774, -1, 774, -1, 774, 
	774, 774, 774, -1, 774, -1, 774, 774, 
	774, -1, -1, 774, 774, 774, 774, 774, 
	774, 774, 774, -1, 774, 774, 774, -1, 
	-1, -1, -1, 774, 774, 774, 774, 774, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1145, 
	774, 1145, 1145, 1145, 1145, 1145, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 774, 774, -1, 
	-1, -1, -1, 1145, 1145, 1145, 1145, 1145, 
	-1, 1145, -1, 1145, -1, -1, -1, -1, 
	1145, -1, -1, 1145, -1, -1, -1, -1, 
	-1, -1, 1145, 1145, 1145, -1, -1, -1, 
	1145, 1145, 1145, -1, -1, -1, -1, 1145, 
	1145, 1145, -1, 1145, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 774, 774, 774, 774, -1, 
	-1, 774, 774, -1, 774, 774, 774, -1, 
	-1, -1, -1, 774, 774, 774, -1, 774, 
	774, 774, 774, -1, -1, -1, -1, 774, 
	-1, -1, -1, -1, 774, 599, -1, -1, 
	774, 774, 774, 774, -1, 774, 774, -1, 
	-1, 774, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 774, 774, 774, 774, 774, 
	774, 774, 774, -1, -1, -1, -1, 774, 
	774, -1, -1, 774, 774, -1, -1, -1, 
	-1, -1, -1, -1, -1, 774, 774, -1, 
	-1, 1145, 1145, 774, -1, 1145, 1145, 1145, 
	1145, -1, 1145, -1, -1, -1, -1, 1145, 
	1145, 1145, 1145, 1145, 1145, 1145, 1145, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 774, 774, -1, 1145, -1, 1145, 1145, 
	-1, 1145, 1145, -1, -1, 1145, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1145, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1145, 1145, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 929, 
	929, 929, 929, 929, 929, 929, 929, 929, 
	929, 929, 929, 929, 929, 929, 929, 929, 
	929, 929, 929, 929, 929, 929, 929, 929, 
	929, 929, -1, 929, 929, 929, 929, 929, 
	-1, 929, -1, 929, 929, 929, 929, -1, 
	929, -1, 929, 929, 929, -1, -1, 929, 
	929, 929, 929, 929, 929, 929, 929, -1, 
	929, 929, 929, -1, -1, -1, -1, 929, 
	929, 929, 929, 929, -1, -1, -1, -1, 
	-1, -1, -1, -1, 774, -1, -1, -1, 
	-1, -1, -1, -1, 929, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 58, 277, -1, 
	-1, 929, 929, -1, -1, 604, -1, -1, 
	-1, -1, 47, 46, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 76, -1, -1, 
	-1, -1, 57, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 58, 277, 
	-1, -1, -1, -1, -1, -1, 602, -1, 
	52, -1, -1, 47, 46, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 76, 929, 
	929, 929, 929, 57, -1, 929, 929, -1, 
	929, 929, 929, 243, 241, 603, -1, 929, 
	929, 929, -1, 929, 929, 929, 929, -1, 
	-1, -1, -1, 929, -1, -1, -1, -1, 
	929, 52, -1, -1, 929, 929, 929, 929, 
	-1, 929, 929, 774, -1, 929, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 929, 
	929, 929, 929, 929, 929, 929, 929, -1, 
	-1, -1, -1, 929, 929, -1, -1, 929, 
	929, -1, -1, -1, -1, -1, -1, -1, 
	-1, 929, 929, -1, -1, -1, -1, 929, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 929, 929, -1, 
	-1, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, -1, 1031, 1031, 1031, 
	1031, 1031, -1, 1031, -1, 1031, 1031, 1031, 
	1031, -1, 1031, -1, 1031, 1031, 1031, -1, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, -1, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, -1, 1031, -1, 
	-1, -1, -1, 1031, 1031, 1031, 1031, 1031, 
	-1, -1, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, 1031, -1, 1031, 1031, -1, -1, -1, 
	-1, -1, 1031, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1031, 1031, 1031, 1031, -1, -1, 1031, 
	1031, 1031, 1031, 1031, 1031, -1, -1, -1, 
	929, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, -1, -1, -1, -1, 1031, -1, -1, 
	-1, -1, 1031, 1031, -1, -1, 1031, 1031, 
	1031, 1031, -1, 1031, 1031, -1, -1, 1031, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 
	1031, -1, -1, -1, 1031, 1031, 1031, -1, 
	-1, 1031, 1031, -1, 1031, 1031, 1031, 1031, 
	1031, -1, 1031, 1031, 1031, -1, -1, -1, 
	1031, 1031, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1031, 1031, -1, -1, 
	1031, -1, -1, -1, -1, 1031, -1, -1, 
	-1, -1, 1031, -1, 1031, 1031, 1031, 1031, 
	1031, -1, -1, -1, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, 1030, 1030, -1, 
	1030, 1030, 1030, 1030, 1030, -1, 1030, 929, 
	1030, 1030, 1030, 1030, -1, 1030, -1, 1030, 
	1030, 1030, -1, 1030, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 
	-1, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 
	-1, 1030, -1, -1, -1, -1, 1030, 1030, 
	1030, 1030, 1030, -1, -1, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, 1030, -1, 1030, 1030, 
	-1, -1, -1, -1, -1, 1030, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1030, 1030, 1030, 1030, 
	-1, -1, 1030, 1030, 1030, 1030, 1030, 1030, 
	-1, -1, 1031, -1, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, -1, -1, -1, -1, 
	1030, -1, -1, -1, -1, 1030, 1030, -1, 
	-1, 1030, 1030, 1030, 1030, -1, 1030, 1030, 
	-1, -1, 1030, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1030, 1030, 1030, 1030, 
	1030, 1030, 1030, 1030, -1, -1, -1, 1030, 
	1030, 1030, -1, -1, 1030, 1030, -1, 1030, 
	1030, 1030, 1030, 1030, -1, 1030, 1030, 1030, 
	-1, -1, -1, 1030, 1030, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1030, 
	1030, -1, -1, 1030, -1, -1, -1, -1, 
	1030, -1, -1, -1, -1, 1030, -1, 1030, 
	1030, 1030, 1030, 1030, -1, -1, 839, 839, 
	839, 839, 839, 839, 839, 839, 839, 839, 
	839, 839, 839, 839, 839, 839, -1, 839, 
	839, 839, 839, 839, 839, 839, 839, -1, 
	-1, -1, 839, 839, 839, 839, 839, -1, 
	839, 1031, 839, 839, 839, 839, -1, 839, 
	-1, 839, 839, 839, -1, -1, 839, -1, 
	-1, 839, 839, 839, 839, 839, -1, 839, 
	839, 839, -1, -1, -1, -1, 839, 839, 
	839, 839, 839, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	839, 839, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 839, 839, 
	839, 839, -1, -1, 839, 839, -1, 839, 
	839, 839, -1, -1, -1, 1030, 839, 839, 
	839, -1, 839, 839, 839, 839, -1, -1, 
	-1, -1, 839, -1, -1, -1, -1, 839, 
	839, -1, -1, 839, 839, 839, 839, -1, 
	839, 839, -1, -1, 839, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 839, 839, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 839, 839, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	839, 839, -1, -1, -1, -1, 839, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 839, 839, -1, -1, 
	-1, 844, 844, 844, 844, 844, 844, 844, 
	844, 844, 844, 844, 844, 844, 844, 844, 
	844, -1, 844, 844, 844, 844, 844, 844, 
	844, 844, -1, -1, -1, 844, 844, 844, 
	844, 844, -1, 844, 1030, 844, 844, 844, 
	844, -1, 844, -1, 844, 844, 844, -1, 
	-1, 844, -1, -1, 844, 844, 844, 844, 
	844, -1, 844, 844, 844, -1, -1, -1, 
	-1, 844, 844, 844, 844, 844, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 844, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 844, 844, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 844, 844, 844, 844, -1, -1, 844, 
	844, 844, 844, 844, 844, -1, -1, 839, 
	-1, 844, 844, 844, 844, 844, 844, 844, 
	844, -1, -1, -1, -1, 844, -1, -1, 
	-1, -1, 844, 844, -1, -1, 844, 844, 
	844, 844, -1, 844, 844, -1, -1, 844, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 844, 844, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 844, 844, -1, -1, -1, -1, -1, 
	-1, -1, -1, 844, 844, -1, -1, -1, 
	-1, 844, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 844, 
	844, -1, -1, 867, 867, 867, 867, 867, 
	867, 867, 867, 867, 867, 867, 867, 867, 
	867, 867, 867, -1, 867, 867, 867, 867, 
	867, 867, 867, 867, -1, -1, -1, 867, 
	867, 867, 867, 867, -1, 867, 839, 867, 
	867, 867, 867, -1, 867, -1, 867, 867, 
	867, -1, -1, 867, -1, -1, 867, 867, 
	867, 867, 867, -1, 867, 867, 867, -1, 
	-1, -1, -1, 867, 867, 867, 867, 867, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 799, -1, 
	799, 799, 799, 799, 799, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 867, 867, -1, 
	-1, -1, 799, 799, 799, 799, 799, -1, 
	799, -1, 799, -1, -1, -1, -1, 799, 
	-1, -1, 799, -1, -1, -1, -1, -1, 
	-1, 799, 799, 799, -1, -1, -1, 799, 
	799, 799, -1, -1, -1, -1, 799, 799, 
	799, -1, 799, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 867, 867, 867, 867, -1, 
	-1, 867, 867, 867, 867, 867, 867, -1, 
	-1, -1, 844, 867, 867, 867, 867, 867, 
	867, 867, 867, -1, -1, -1, -1, 867, 
	-1, -1, -1, -1, 867, 867, -1, -1, 
	867, 867, 867, 867, -1, 867, 867, -1, 
	-1, 867, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 867, 867, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 867, 867, -1, -1, -1, 
	-1, -1, -1, -1, -1, 867, 867, -1, 
	799, 799, -1, 867, 799, 799, 799, 799, 
	-1, 799, -1, -1, -1, -1, 799, 799, 
	799, 799, 799, 799, 799, 799, -1, -1, 
	-1, 800, -1, 800, 800, 800, 800, 800, 
	-1, 867, 867, 799, -1, 799, 799, -1, 
	799, 799, -1, -1, 799, -1, -1, -1, 
	-1, -1, -1, -1, -1, 800, 800, 800, 
	800, 800, -1, 800, -1, 800, -1, -1, 
	-1, -1, 800, -1, -1, 800, 799, -1, 
	-1, 844, -1, -1, 800, 800, 800, -1, 
	799, 799, 800, 800, 800, -1, -1, -1, 
	-1, 800, 800, 800, -1, 800, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 801, 
	-1, 801, 801, 801, 801, 801, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 801, 801, 801, 801, 801, 
	-1, 801, -1, 801, -1, -1, -1, -1, 
	801, -1, -1, 801, -1, -1, -1, -1, 
	-1, -1, 801, 801, 801, -1, -1, -1, 
	801, 801, 801, -1, -1, -1, -1, 801, 
	801, 801, -1, 801, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 800, 800, -1, -1, 800, 
	800, 800, 800, -1, 800, -1, -1, -1, 
	-1, 800, 800, 800, 800, 800, 800, 800, 
	800, -1, -1, -1, 867, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 800, -1, 
	800, 800, -1, 800, 800, -1, -1, 800, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 800, -1, -1, -1, -1, -1, -1, 
	-1, 801, 801, 800, 800, 801, 801, 801, 
	801, -1, 801, -1, -1, -1, -1, 801, 
	801, 801, 801, 801, 801, 801, 801, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 801, -1, 801, 801, 
	-1, 801, 801, -1, 802, 801, 802, 802, 
	802, 802, 802, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 801, 
	802, 802, 802, 802, 802, -1, 802, -1, 
	802, 801, 801, -1, -1, 802, -1, -1, 
	802, -1, -1, 867, -1, -1, -1, 802, 
	802, 802, -1, -1, -1, 802, 802, 802, 
	-1, -1, -1, -1, 802, 802, 802, -1, 
	802, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 803, -1, 803, 803, 803, 803, 
	803, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 803, 803, 
	803, 803, 803, -1, 803, -1, 803, -1, 
	-1, -1, -1, 803, -1, -1, 803, -1, 
	-1, -1, -1, -1, -1, 803, 803, 803, 
	-1, -1, -1, 803, 803, 803, -1, -1, 
	-1, -1, 803, 803, 803, -1, 803, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 802, 802, 
	-1, -1, 802, 802, 802, 802, -1, 802, 
	-1, -1, -1, -1, 802, 802, 802, 802, 
	802, 802, 802, 802, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 802, -1, 802, 802, -1, 802, 802, 
	-1, -1, 802, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 802, -1, -1, -1, 
	-1, -1, -1, -1, 803, 803, 802, 802, 
	803, 803, 803, 803, -1, 803, -1, -1, 
	-1, -1, 803, 803, 803, 803, 803, 803, 
	803, 803, -1, -1, -1, 804, -1, 804, 
	804, 804, 804, 804, -1, -1, -1, 803, 
	-1, 803, 803, -1, 803, 803, -1, -1, 
	803, -1, -1, -1, -1, -1, -1, -1, 
	-1, 804, 804, 804, 804, 804, -1, 804, 
	-1, 804, -1, -1, -1, -1, 804, -1, 
	-1, 804, 803, -1, -1, -1, -1, -1, 
	804, 804, 804, -1, 803, 803, 804, 804, 
	804, -1, -1, -1, -1, 804, 804, 804, 
	-1, 804, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 805, -1, 805, 805, 805, 
	805, 805, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 805, 
	805, 805, 805, 805, -1, 805, -1, 805, 
	-1, -1, -1, -1, 805, -1, -1, 805, 
	-1, -1, -1, -1, -1, -1, 805, 805, 
	805, -1, -1, -1, 805, 805, 805, -1, 
	-1, -1, -1, 805, 805, 805, -1, 805, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 804, 
	804, -1, -1, 804, 804, 804, 804, -1, 
	804, -1, -1, -1, -1, 804, 804, 804, 
	804, 804, 804, 804, 804, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 804, -1, 804, 804, -1, 804, 
	804, -1, -1, 804, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 804, -1, -1, 
	-1, -1, -1, -1, -1, 805, 805, 804, 
	804, 805, 805, 805, 805, -1, 805, -1, 
	-1, -1, -1, 805, 805, 805, 805, 805, 
	805, 805, 805, -1, -1, -1, 806, -1, 
	806, 806, 806, 806, 806, -1, -1, -1, 
	805, -1, 805, 805, -1, 805, 805, -1, 
	-1, 805, -1, -1, -1, -1, -1, -1, 
	-1, -1, 806, 806, 806, 806, 806, -1, 
	806, -1, 806, -1, -1, -1, -1, 806, 
	-1, -1, 806, 805, -1, -1, -1, -1, 
	-1, 806, 806, 806, -1, 805, 805, 806, 
	806, 806, -1, -1, -1, -1, 806, 806, 
	806, -1, 806, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 807, -1, 807, 807, 
	807, 807, 807, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	807, 807, 807, 807, 807, -1, 807, -1, 
	807, -1, -1, -1, -1, 807, -1, -1, 
	807, -1, -1, -1, -1, -1, -1, 807, 
	807, 807, -1, -1, -1, 807, 807, 807, 
	-1, -1, -1, -1, 807, 807, 807, -1, 
	807, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	806, 806, -1, -1, 806, 806, 806, 806, 
	-1, 806, -1, -1, -1, -1, 806, 806, 
	806, 806, 806, 806, 806, 806, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 806, -1, 806, 806, -1, 
	806, 806, -1, -1, 806, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 806, -1, 
	-1, -1, -1, -1, -1, -1, 807, 807, 
	806, 806, 807, 807, 807, 807, -1, 807, 
	-1, -1, -1, -1, 807, 807, 807, 807, 
	807, 807, 807, 807, -1, -1, -1, 808, 
	-1, 808, 808, 808, 808, 808, -1, -1, 
	-1, 807, -1, 807, 807, -1, 807, 807, 
	-1, -1, 807, -1, -1, -1, -1, -1, 
	-1, -1, -1, 808, 808, 808, 808, 808, 
	-1, 808, -1, 808, -1, -1, -1, -1, 
	808, -1, -1, 808, 807, -1, -1, -1, 
	-1, -1, 808, 808, 808, -1, 807, 807, 
	808, 808, 808, -1, -1, -1, -1, 808, 
	808, 808, -1, 808, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 809, -1, 809, 
	809, 809, 809, 809, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 809, 809, 809, 809, 809, -1, 809, 
	-1, 809, -1, -1, -1, -1, 809, -1, 
	-1, 809, -1, -1, -1, -1, -1, -1, 
	809, 809, 809, -1, -1, -1, 809, 809, 
	809, -1, -1, -1, -1, 809, 809, 809, 
	-1, 809, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 808, 808, -1, -1, 808, 808, 808, 
	808, -1, 808, -1, -1, -1, -1, 808, 
	808, 808, 808, 808, 808, 808, 808, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 808, -1, 808, 808, 
	-1, 808, 808, -1, -1, 808, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 808, 
	-1, -1, -1, -1, -1, -1, -1, 809, 
	809, 808, 808, 809, 809, 809, 809, -1, 
	809, -1, -1, -1, -1, 809, 809, 809, 
	809, 809, 809, 809, 809, -1, -1, -1, 
	810, -1, 810, 810, 810, 810, 810, -1, 
	-1, -1, 809, -1, 809, 809, -1, 809, 
	809, -1, -1, 809, -1, -1, -1, -1, 
	-1, -1, -1, -1, 810, 810, 810, 810, 
	810, -1, 810, -1, 810, -1, -1, -1, 
	-1, 810, -1, -1, 810, 809, -1, -1, 
	-1, -1, -1, 810, 810, 810, -1, 809, 
	809, 810, 810, 810, -1, -1, -1, -1, 
	810, 810, 810, -1, 810, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 811, -1, 
	811, 811, 811, 811, 811, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 811, 811, 811, 811, 811, -1, 
	811, -1, 811, -1, -1, -1, -1, 811, 
	-1, -1, 811, -1, -1, -1, -1, -1, 
	-1, 811, 811, 811, -1, -1, -1, 811, 
	811, 811, -1, -1, -1, -1, 811, 811, 
	811, -1, 811, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 810, 810, -1, -1, 810, 810, 
	810, 810, -1, 810, -1, -1, -1, -1, 
	810, 810, 810, 810, 810, 810, 810, 810, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 810, -1, 810, 
	810, -1, 810, 810, -1, -1, 810, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	810, -1, -1, -1, -1, -1, -1, -1, 
	811, 811, 810, 810, 811, 811, 811, 811, 
	-1, 811, -1, -1, -1, -1, 811, 811, 
	811, 811, 811, 811, 811, 811, -1, -1, 
	-1, 812, -1, 812, 812, 812, 812, 812, 
	-1, -1, -1, 811, -1, 811, 811, -1, 
	811, 811, -1, -1, 811, -1, -1, -1, 
	-1, -1, -1, -1, -1, 812, 812, 812, 
	812, 812, -1, 812, -1, 812, -1, -1, 
	-1, -1, 812, -1, -1, 812, 811, -1, 
	-1, -1, -1, -1, 812, 812, 812, -1, 
	811, 811, 812, 812, 812, -1, -1, -1, 
	-1, 812, 812, 812, -1, 812, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 813, 
	-1, 813, 813, 813, 813, 813, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 813, 813, 813, 813, 813, 
	-1, 813, -1, 813, -1, -1, -1, -1, 
	813, -1, -1, 813, -1, -1, -1, -1, 
	-1, -1, 813, 813, 813, -1, -1, -1, 
	813, 813, 813, -1, -1, -1, -1, 813, 
	813, 813, -1, 813, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 812, 812, -1, -1, 812, 
	812, 812, 812, -1, 812, -1, -1, -1, 
	-1, 812, 812, 812, 812, 812, 812, 812, 
	812, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 812, -1, 
	812, 812, -1, 812, 812, -1, -1, 812, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 812, -1, -1, -1, -1, -1, -1, 
	-1, 813, 813, 812, 812, 813, 813, 813, 
	813, -1, 813, -1, -1, -1, -1, 813, 
	813, 813, 813, 813, 813, 813, 813, -1, 
	-1, -1, 814, -1, 814, 814, 814, 814, 
	814, -1, -1, -1, 813, -1, 813, 813, 
	-1, 813, 813, -1, -1, 813, -1, -1, 
	-1, -1, -1, -1, -1, -1, 814, 814, 
	814, 814, 814, -1, 814, -1, 814, -1, 
	-1, -1, -1, 814, -1, -1, 814, 813, 
	-1, -1, -1, -1, -1, 814, 814, 814, 
	-1, 813, 813, 814, 814, 814, -1, -1, 
	-1, -1, 814, 814, 814, -1, 814, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	864, -1, 864, 864, 864, 864, 864, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 864, 864, 864, 864, 
	864, -1, 864, -1, 864, -1, -1, -1, 
	-1, 864, -1, -1, 864, -1, -1, -1, 
	-1, -1, -1, 864, 864, 864, -1, -1, 
	-1, 864, 864, 864, -1, -1, -1, -1, 
	864, 864, 864, -1, 864, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 814, 814, -1, -1, 
	814, 814, 814, 814, -1, 814, -1, -1, 
	-1, -1, 814, 814, 814, 814, 814, 814, 
	814, 814, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 814, 
	-1, 814, 814, -1, 814, 814, -1, -1, 
	814, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 814, -1, -1, -1, -1, -1, 
	-1, -1, 864, 864, 814, 814, 864, 864, 
	864, 864, -1, 864, -1, -1, -1, -1, 
	864, 864, 864, 864, 864, 864, 864, 864, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 864, -1, 864, 
	864, -1, 864, 864, -1, -1, 864, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	873, 873, 873, 873, 873, 873, 873, 873, 
	873, 873, 873, 873, 873, 873, 873, 873, 
	864, 873, 873, 873, 873, 873, 873, 873, 
	873, -1, 864, 864, 873, 873, 873, 873, 
	873, -1, 873, -1, 873, 873, 873, 873, 
	-1, 873, -1, 873, 873, 873, -1, -1, 
	873, -1, -1, 873, 873, 873, 873, 873, 
	-1, 873, 873, 873, 873, -1, -1, -1, 
	873, 873, 873, 873, 873, -1, 873, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 873, 873, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	873, 873, 873, 873, -1, -1, 873, 873, 
	873, 873, 873, 873, -1, -1, -1, -1, 
	873, 873, 873, 873, 873, 873, 873, 873, 
	-1, 873, 873, -1, 873, -1, -1, -1, 
	-1, 873, 873, -1, -1, 873, 873, 873, 
	873, -1, 873, 873, -1, -1, 873, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 873, 873, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	873, 873, -1, -1, -1, -1, -1, -1, 
	-1, -1, 873, 873, -1, -1, -1, -1, 
	873, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 873, 873, 
	-1, -1, 936, 936, 936, 936, 936, 936, 
	936, 936, 936, 936, 936, 936, 936, 936, 
	936, 936, 936, 936, 936, 936, 936, 936, 
	936, 936, 936, 936, 936, -1, 936, 936, 
	936, 936, 936, -1, 936, -1, 936, 936, 
	936, 936, -1, 936, -1, 936, 936, 936, 
	-1, -1, 936, 936, 936, 936, 936, 936, 
	936, 936, -1, 936, 936, 936, -1, -1, 
	-1, -1, 936, 936, 936, 936, 936, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 936, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 936, 936, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 936, 936, 936, 936, -1, -1, 
	936, 936, -1, 936, 936, 936, -1, -1, 
	-1, 873, 936, 936, 936, -1, 936, 936, 
	936, 936, -1, -1, -1, -1, 936, -1, 
	-1, -1, -1, 936, -1, -1, -1, 936, 
	936, 936, 936, -1, 936, 936, -1, -1, 
	936, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 936, 936, 936, 936, 936, 936, 
	936, 936, -1, -1, -1, -1, 936, 936, 
	-1, -1, 936, 936, -1, -1, -1, -1, 
	-1, -1, -1, -1, 936, 936, -1, -1, 
	-1, -1, 936, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	936, 936, -1, -1, -1, 897, 897, 897, 
	897, 897, 897, 897, 897, 897, 897, 897, 
	897, 897, 897, 897, 897, -1, 897, 897, 
	897, 897, 897, 897, 897, 897, -1, -1, 
	-1, 897, 897, 897, 897, 897, -1, 897, 
	873, 897, 897, 897, 897, -1, 897, -1, 
	897, 897, 897, -1, -1, 897, -1, -1, 
	897, 897, 897, 897, 897, -1, 897, 897, 
	897, -1, -1, -1, -1, 897, 897, 897, 
	897, 897, -1, -1, -1, -1, -1, -1, 
	-1, 103, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 897, 
	897, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 897, 897, 897, 
	897, -1, -1, 897, 897, 897, 897, 897, 
	897, -1, -1, 936, -1, 897, 897, 897, 
	897, 897, 897, 897, 897, -1, -1, -1, 
	-1, 897, -1, -1, -1, -1, 897, 897, 
	-1, -1, 897, 897, 897, 897, -1, 897, 
	897, -1, -1, 897, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	897, 897, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 897, 897, -1, 
	-1, -1, -1, -1, -1, -1, -1, 897, 
	897, -1, -1, -1, -1, 897, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 897, 897, -1, -1, -1, 
	-1, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, 1015, 936, 1015, -1, 1015, 1015, 1015, 
	1015, 1015, 1015, -1, 1015, 1015, 1015, -1, 
	-1, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, -1, 1015, 1015, 1015, 1015, -1, -1, 
	-1, 1015, 1015, 1015, 1015, 1015, -1, 1015, 
	1015, 1015, 1015, 1015, 1015, 1015, -1, 1015, 
	-1, -1, -1, 1015, 1015, -1, 1015, -1, 
	-1, 1015, -1, -1, 1015, -1, 1015, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1015, 1015, -1, -1, -1, 
	-1, -1, 1015, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1015, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1015, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1015, 1015, 1015, 1015, -1, -1, 1015, 
	1015, 1015, 1015, 1015, 1015, -1, 897, -1, 
	-1, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, -1, -1, 1015, -1, 1015, -1, -1, 
	-1, -1, 1015, 1015, -1, 1015, 1015, 1015, 
	1015, 1015, -1, 1015, 1015, -1, -1, 1015, 
	-1, 1015, 1015, -1, 897, -1, 1015, -1, 
	1015, 1015, 1015, 1015, 1015, 1015, 1015, 1015, 
	1015, -1, -1, -1, -1, 1015, 1015, -1, 
	1015, 1015, 1015, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1015, 1015, -1, -1, 1015, 
	-1, 1015, 1015, -1, -1, -1, 1015, 1015, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1015, 1015, 1015, -1, -1, 1015, 
	1015, 1015, -1, -1, -1, -1, -1, 1015, 
	1015, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 897, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, 1016, -1, 1016, -1, 
	1016, 1016, 1016, 1016, 1016, 1016, -1, 1016, 
	1016, 1016, -1, -1, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, -1, 1016, 1016, 1016, 
	1016, -1, -1, -1, 1016, 1016, 1016, 1016, 
	1016, -1, 1016, 1016, 1016, 1016, 1016, 1016, 
	1016, -1, 1016, -1, -1, -1, 1016, 1016, 
	-1, 1016, -1, -1, 1016, -1, -1, 1016, 
	-1, 1016, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1016, 1016, 
	-1, -1, -1, -1, -1, 1016, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1016, -1, 
	-1, -1, 1015, -1, -1, -1, -1, -1, 
	1016, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1016, 1016, 1016, 1016, 
	-1, -1, 1016, 1016, 1016, 1016, 1016, 1016, 
	-1, -1, 1015, 1015, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, -1, -1, 1016, -1, 
	1016, -1, -1, -1, -1, 1016, 1016, -1, 
	1016, 1016, 1016, 1016, 1016, -1, 1016, 1016, 
	-1, -1, 1016, -1, 1016, 1016, -1, -1, 
	-1, 1016, -1, 1016, 1016, 1016, 1016, 1016, 
	1016, 1016, 1016, 1016, -1, -1, -1, -1, 
	1016, 1016, -1, 1016, 1016, 1016, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1016, 1016, 
	-1, -1, 1016, -1, 1016, 1016, -1, -1, 
	-1, 1016, 1016, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1016, 1016, 1016, 
	-1, 1015, 1016, 1016, 1016, -1, -1, -1, 
	-1, -1, 1016, 1016, -1, -1, 921, 921, 
	921, 921, 921, 921, 921, 921, 921, 921, 
	921, 921, 921, 921, 921, 921, -1, 921, 
	921, 921, 921, 921, 921, 921, 921, -1, 
	-1, -1, 921, 921, 921, 921, 921, -1, 
	921, -1, 921, 921, 921, 921, -1, 921, 
	921, 921, 921, 921, -1, -1, 921, -1, 
	-1, 921, 921, 921, 921, 921, -1, 921, 
	921, 921, -1, -1, -1, -1, 921, 921, 
	921, 921, 921, -1, -1, -1, -1, -1, 
	-1, -1, 921, -1, -1, -1, -1, -1, 
	-1, -1, 921, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	921, 921, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 921, 921, 
	921, 921, -1, -1, 921, 921, 921, 921, 
	921, 921, -1, -1, -1, 1016, 921, 921, 
	921, 921, 921, 921, 921, 921, -1, -1, 
	-1, -1, 921, -1, -1, -1, -1, 921, 
	921, -1, -1, 921, 921, 921, 921, -1, 
	921, 921, -1, -1, 921, -1, -1, -1, 
	-1, 921, -1, -1, 921, -1, -1, -1, 
	-1, 921, 921, -1, -1, 1016, 1016, -1, 
	-1, -1, -1, -1, -1, -1, 921, 921, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	921, 921, -1, -1, -1, -1, 921, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 921, 921, -1, -1, 
	-1, 926, 926, 926, 926, 926, 926, 926, 
	926, 926, 926, 926, 926, 926, 926, 926, 
	926, -1, 926, 926, 926, 926, 926, 926, 
	926, 926, -1, -1, -1, 926, 926, 926, 
	926, 926, -1, 926, 1016, 926, 926, 926, 
	926, -1, 926, -1, 926, 926, 926, -1, 
	-1, 926, -1, -1, 926, 926, 926, 926, 
	926, -1, 926, 926, 926, -1, -1, -1, 
	-1, 926, 926, 926, 926, 926, -1, -1, 
	-1, -1, -1, -1, -1, 926, -1, -1, 
	-1, -1, -1, -1, -1, 609, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 926, 926, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 926, 926, 926, 926, -1, -1, 926, 
	926, 926, 926, 926, 926, -1, -1, 921, 
	-1, 926, 926, 926, 926, 926, 926, 926, 
	926, -1, -1, -1, -1, 926, -1, -1, 
	-1, -1, 926, 926, -1, -1, 926, 926, 
	926, 926, -1, 926, 926, -1, -1, 926, 
	-1, -1, -1, -1, -1, 921, -1, 608, 
	-1, -1, -1, -1, 926, 926, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 921, 
	-1, 926, 926, -1, -1, -1, -1, -1, 
	-1, -1, -1, 926, 926, -1, -1, -1, 
	-1, 926, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 926, 
	926, -1, -1, 919, 919, 919, 919, 919, 
	919, 919, 919, 919, 919, 919, 919, 919, 
	919, 919, 919, -1, 919, 919, 919, 919, 
	919, 919, 919, 919, -1, -1, -1, 919, 
	919, 919, 919, 919, -1, 919, 921, 919, 
	919, 919, 919, -1, 919, -1, 919, 919, 
	919, -1, -1, 919, -1, -1, 919, 919, 
	919, 919, 919, -1, 919, 919, 919, -1, 
	-1, -1, -1, 919, 919, 919, 919, 919, 
	-1, -1, -1, -1, -1, -1, -1, 919, 
	-1, -1, -1, -1, -1, -1, -1, 919, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 919, 919, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 919, 919, 919, 919, -1, 
	-1, 919, 919, 919, 919, 919, 919, -1, 
	-1, -1, 926, 919, 919, 919, 919, 919, 
	919, 919, 919, -1, -1, -1, -1, 919, 
	-1, -1, -1, -1, 919, 919, -1, -1, 
	919, 919, 919, 919, -1, 919, 919, -1, 
	-1, 919, -1, -1, -1, -1, -1, -1, 
	926, 919, -1, -1, -1, -1, 919, 919, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 926, 919, 919, -1, -1, -1, 
	-1, -1, -1, -1, -1, 919, 919, -1, 
	-1, -1, -1, 919, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 919, 919, -1, -1, -1, -1, -1, 
	898, 898, 898, 898, 898, 898, 898, 898, 
	898, 898, 898, 898, 898, 898, 898, 898, 
	-1, 898, 898, 898, 898, 898, 898, 898, 
	898, -1, -1, -1, 898, 898, 898, 898, 
	898, 926, 898, -1, 898, 898, 898, 898, 
	-1, 898, -1, 898, 898, 898, -1, -1, 
	898, -1, -1, 898, 898, 898, 898, 898, 
	-1, 898, 898, 898, -1, -1, -1, -1, 
	898, 898, 898, 898, 898, -1, -1, -1, 
	-1, -1, -1, -1, 103, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 898, 898, -1, -1, -1, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, 1156, -1, -1, 1156, 1156, 1156, 
	1156, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1156, 1156, 1156, 
	-1, -1, -1, 1156, -1, -1, -1, -1, 
	1156, -1, -1, -1, -1, -1, 1156, 1156, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1156, -1, -1, -1, 
	898, 898, 898, 898, -1, -1, 898, 898, 
	-1, 898, 898, 898, 919, 1156, -1, -1, 
	898, 898, 898, -1, 898, 898, 898, 898, 
	-1, -1, -1, -1, 898, -1, -1, -1, 
	-1, 898, 1156, 1156, -1, 898, 898, 898, 
	898, -1, 898, 898, -1, -1, 898, -1, 
	-1, -1, 919, -1, -1, -1, -1, -1, 
	-1, -1, -1, 898, 898, -1, -1, -1, 
	-1, -1, -1, -1, 919, -1, -1, -1, 
	898, 898, -1, -1, -1, -1, -1, -1, 
	608, -1, 898, 898, -1, -1, -1, -1, 
	898, -1, -1, -1, 900, 900, 900, 900, 
	900, 900, 900, 900, 900, 900, 900, 900, 
	900, 900, 900, 900, -1, 900, 900, 900, 
	900, 900, 900, 900, 900, -1, 898, 898, 
	900, 900, 900, 900, 900, -1, 900, -1, 
	900, 900, 900, 900, -1, 900, -1, 900, 
	900, 900, -1, -1, 900, -1, -1, 900, 
	900, 900, 900, 900, -1, 900, 900, 900, 
	-1, -1, -1, 919, 900, 900, 900, 900, 
	900, -1, -1, 1156, 1156, -1, -1, -1, 
	-1, -1, -1, -1, 1156, 1156, 746, -1, 
	1156, 1156, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1156, -1, -1, -1, -1, 
	1156, -1, -1, -1, -1, -1, 900, 900, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1156, 1156, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 300, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 900, 900, 900, 900, 
	-1, -1, 900, 900, 900, 900, 900, 900, 
	-1, -1, -1, -1, 900, 900, 900, 900, 
	900, 900, 900, 900, -1, -1, -1, -1, 
	900, -1, -1, -1, -1, 900, 900, -1, 
	-1, 900, 900, 900, 900, -1, 900, 900, 
	-1, 898, 900, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 900, 
	900, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 900, 900, -1, -1, 
	-1, -1, -1, -1, -1, -1, 900, 900, 
	-1, -1, -1, -1, 900, -1, -1, -1, 
	909, 909, 909, 909, 909, 909, 909, 909, 
	909, 909, 909, 909, 909, 909, 909, 909, 
	-1, 909, 909, 909, 909, 909, 909, 909, 
	909, -1, 900, 900, 909, 909, 909, 909, 
	909, -1, 909, -1, 909, 909, 909, 909, 
	-1, 909, -1, 909, 909, 909, -1, -1, 
	909, -1, -1, 909, 909, 909, 909, 909, 
	-1, 909, 909, 909, -1, -1, -1, -1, 
	909, 909, 909, 909, 909, -1, 1059, 1059, 
	1059, 1059, 1059, 1059, 1059, -1, 1059, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1059, 1059, 1059, 1059, 1059, -1, -1, 
	898, -1, -1, -1, -1, -1, -1, -1, 
	1059, -1, 909, 909, 1059, -1, -1, -1, 
	1059, 1059, 1059, 1059, 1059, 1059, -1, -1, 
	-1, -1, 1059, 1059, 1059, -1, -1, -1, 
	-1, 1059, 1059, -1, 1175, 1175, 1175, 1059, 
	-1, -1, -1, -1, -1, -1, -1, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1059, 1059, 1059, 
	1059, 1059, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 630, -1, 
	909, 909, 909, 909, -1, -1, 909, 909, 
	909, 909, 909, 909, -1, -1, -1, -1, 
	909, 909, 909, 909, 909, 909, 909, 909, 
	-1, -1, -1, -1, 909, -1, -1, -1, 
	-1, 909, 909, -1, -1, 909, 909, 909, 
	909, -1, 909, 909, -1, 900, 909, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 909, 909, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	909, 909, -1, -1, -1, -1, -1, -1, 
	-1, -1, 909, 909, -1, -1, -1, -1, 
	909, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 909, 909, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1059, 1059, 1059, 1059, 1059, -1, 1059, 1059, 
	1059, -1, -1, -1, -1, 1059, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	376, 377, 1078, 1078, 1078, 1078, 1078, 1078, 
	1078, 375, 1078, 1078, -1, -1, -1, -1, 
	1059, 1059, 1059, 1059, 1059, 1078, 1078, 1078, 
	1078, 1078, -1, -1, 900, -1, -1, -1, 
	-1, -1, -1, -1, 1078, -1, -1, -1, 
	1078, -1, -1, -1, 1078, 1078, 1078, 1078, 
	1078, 1078, -1, -1, -1, -1, 1078, 1078, 
	1078, -1, -1, -1, -1, 1078, 1078, -1, 
	1078, 1078, 1078, 1078, 1078, -1, -1, -1, 
	-1, -1, -1, 1078, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1078, 1078, 1078, 1078, 1078, -1, -1, 
	274, 275, -1, -1, -1, -1, -1, 746, 
	-1, -1, 1078, -1, -1, -1, -1, -1, 
	78, 81, 82, 79, 80, 87, 88, -1, 
	83, 84, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 164, 165, 167, 166, 168, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 89, -1, -1, -1, 156, -1, 
	-1, 909, 161, 162, 163, 86, 85, 155, 
	-1, -1, -1, -1, 149, 150, 151, -1, 
	-1, -1, 300, 1011, 147, -1, 171, 173, 
	175, 160, -1, -1, -1, -1, -1, -1, 
	-1, 152, 635, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 141, 
	142, 143, 144, 145, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1078, 1078, 1078, 1078, 
	1078, -1, 1078, 1078, 1078, -1, -1, -1, 
	-1, 1078, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1078, 1078, -1, -1, 
	-1, -1, -1, -1, -1, 1078, -1, -1, 
	-1, -1, -1, -1, 1078, 1078, 1078, 1078, 
	1078, -1, -1, -1, -1, -1, -1, -1, 
	909, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 637, 137, 138, 139, 140, -1, 
	146, 154, 158, -1, -1, -1, 636, 157, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 169, 159, 153, 148, 1011, -1, 
	-1, -1, -1, -1, -1, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	-1, 1023, 1023, 1023, 1023, 1023, -1, 1023, 
	-1, 1023, 1023, 1023, 1023, -1, 1023, -1, 
	1023, 1023, 1023, -1, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, -1, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, -1, 1023, -1, -1, -1, -1, 1023, 
	1023, 1023, 1023, 1023, -1, -1, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, -1, 1023, 
	1023, -1, -1, -1, -1, -1, 1023, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1023, 1023, 1023, 
	1023, -1, -1, 1023, 1023, 1023, 1023, 1023, 
	1023, -1, -1, -1, -1, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, -1, -1, -1, 
	-1, 1023, -1, -1, -1, -1, 1023, 1023, 
	-1, -1, 1023, 1023, 1023, 1023, -1, 1023, 
	1023, 376, 377, 1023, -1, -1, -1, -1, 
	-1, -1, 375, -1, -1, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, -1, -1, -1, 
	1023, 1023, 1023, -1, -1, 1023, 1023, -1, 
	1023, 1023, 1023, 1023, 1023, -1, 1023, 1023, 
	1023, -1, -1, -1, 1023, 1023, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1023, 1023, -1, -1, 1023, -1, -1, -1, 
	-1, 1023, -1, -1, -1, -1, 1023, -1, 
	1023, 1023, 1023, 1023, 1023, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, 1026, 1026, -1, 1026, 1026, 
	1026, 1026, 1026, -1, 1026, -1, 1026, 1026, 
	1026, 1026, -1, 1026, -1, 1026, 1026, 1026, 
	-1, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, 1026, 1026, 1026, -1, 1026, 
	1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, 1026, 1026, 1026, -1, 1026, 
	-1, -1, -1, -1, 1026, 1026, 1026, 1026, 
	1026, -1, -1, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, 1026, -1, 1026, 1026, -1, -1, 
	-1, -1, -1, 1026, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1026, 1026, 1026, 1026, 1023, -1, 
	1026, 1026, 1026, 1026, 1026, 1026, -1, -1, 
	-1, -1, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, -1, -1, -1, -1, 1026, -1, 
	-1, -1, -1, 1026, 1026, -1, -1, 1026, 
	1026, 1026, 1026, -1, 1026, 1026, -1, -1, 
	1026, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1026, 1026, 1026, 1026, 1026, 1026, 
	1026, 1026, -1, -1, -1, 1026, 1026, 1026, 
	-1, -1, 1026, 1026, -1, 1026, 1026, 1026, 
	1026, 1026, -1, 1026, 1026, 1026, -1, -1, 
	-1, 1026, 1026, 637, 137, 138, 139, 140, 
	-1, 146, 154, 158, -1, 1026, 1026, 636, 
	157, 1026, -1, -1, -1, -1, 1026, -1, 
	-1, -1, -1, 1026, -1, 1026, 1026, 1026, 
	1026, 1026, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 169, 159, 153, 148, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1023, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 
	1027, -1, 1027, 1027, 1027, 1027, 1027, -1, 
	1027, -1, 1027, 1027, 1027, 1027, -1, 1027, 
	-1, 1027, 1027, 1027, -1, 1027, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 
	1027, 1027, -1, 1027, 1027, 1027, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 
	1027, 1027, -1, 1027, -1, -1, -1, -1, 
	1027, 1027, 1027, 1027, 1027, -1, -1, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, 1027, -1, 
	1027, 1027, -1, -1, -1, -1, -1, 1027, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1026, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1027, 1027, 
	1027, 1027, -1, -1, 1027, 1027, 1027, 1027, 
	1027, 1027, -1, -1, -1, -1, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, -1, -1, 
	-1, -1, 1027, -1, -1, -1, -1, 1027, 
	1027, -1, -1, 1027, 1027, 1027, 1027, -1, 
	1027, 1027, -1, -1, 1027, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1027, 1027, 
	1027, 1027, 1027, 1027, 1027, 1027, -1, -1, 
	-1, 1027, 1027, 1027, -1, -1, 1027, 1027, 
	-1, 1027, 1027, 1027, 1027, 1027, -1, 1027, 
	1027, 1027, -1, -1, -1, 1027, 1027, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1027, 1027, -1, -1, 1027, -1, -1, 
	-1, -1, 1027, -1, -1, -1, -1, 1027, 
	-1, 1027, 1027, 1027, 1027, 1027, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1026, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, 1024, 1024, -1, 1024, 
	1024, 1024, 1024, 1024, -1, 1024, -1, 1024, 
	1024, 1024, 1024, -1, 1024, -1, 1024, 1024, 
	1024, -1, 1024, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, 1024, 1024, 1024, -1, 
	1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, 1024, 1024, 1024, -1, 
	1024, -1, -1, -1, -1, 1024, 1024, 1024, 
	1024, 1024, -1, -1, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, 1024, -1, 1024, 1024, -1, 
	-1, -1, -1, -1, 1024, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1024, 1024, 1024, 1024, 1027, 
	-1, 1024, 1024, 1024, 1024, 1024, 1024, -1, 
	-1, -1, -1, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, -1, -1, -1, -1, 1024, 
	-1, -1, -1, -1, 1024, 1024, -1, -1, 
	1024, 1024, 1024, 1024, -1, 1024, 1024, -1, 
	-1, 1024, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1024, 1024, 1024, 1024, 1024, 
	1024, 1024, 1024, -1, -1, -1, 1024, 1024, 
	1024, -1, -1, 1024, 1024, -1, 1024, 1024, 
	1024, 1024, 1024, -1, 1024, 1024, 1024, -1, 
	-1, -1, 1024, 1024, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1024, 1024, 
	-1, -1, 1024, -1, -1, -1, -1, 1024, 
	-1, -1, -1, -1, 1024, -1, 1024, 1024, 
	1024, 1024, 1024, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1027, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	1025, 1025, -1, 1025, 1025, 1025, 1025, 1025, 
	-1, 1025, -1, 1025, 1025, 1025, 1025, -1, 
	1025, -1, 1025, 1025, 1025, -1, 1025, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	1025, 1025, 1025, -1, 1025, 1025, 1025, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	1025, 1025, 1025, -1, 1025, -1, -1, -1, 
	-1, 1025, 1025, 1025, 1025, 1025, -1, -1, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 
	-1, 1025, 1025, -1, -1, -1, -1, -1, 
	1025, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1024, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1025, 
	1025, 1025, 1025, -1, -1, 1025, 1025, 1025, 
	1025, 1025, 1025, -1, -1, -1, -1, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, -1, 
	-1, -1, -1, 1025, -1, -1, -1, -1, 
	1025, 1025, -1, -1, 1025, 1025, 1025, 1025, 
	-1, 1025, 1025, -1, -1, 1025, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1025, 
	1025, 1025, 1025, 1025, 1025, 1025, 1025, -1, 
	-1, -1, 1025, 1025, 1025, -1, -1, 1025, 
	1025, -1, 1025, 1025, 1025, 1025, 1025, -1, 
	1025, 1025, 1025, -1, -1, -1, 1025, 1025, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1025, 1025, -1, -1, 1025, -1, 
	-1, -1, -1, 1025, -1, -1, -1, -1, 
	1025, -1, 1025, 1025, 1025, 1025, 1025, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1024, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, -1, 
	1032, 1032, 1032, 1032, 1032, -1, 1032, -1, 
	1032, 1032, 1032, 1032, -1, 1032, -1, 1032, 
	1032, 1032, -1, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	-1, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	-1, 1032, -1, -1, -1, -1, 1032, 1032, 
	1032, 1032, 1032, -1, -1, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, 1032, -1, 1032, 1032, 
	-1, -1, -1, -1, -1, 1032, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1032, 1032, 1032, 1032, 
	1025, -1, 1032, 1032, 1032, 1032, 1032, 1032, 
	-1, -1, -1, -1, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, -1, -1, -1, -1, 
	1032, -1, -1, -1, -1, 1032, 1032, -1, 
	-1, 1032, 1032, 1032, 1032, -1, 1032, 1032, 
	-1, -1, 1032, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1032, 1032, 1032, 1032, 
	1032, 1032, 1032, 1032, -1, -1, -1, 1032, 
	1032, 1032, -1, -1, 1032, 1032, -1, 1032, 
	1032, 1032, 1032, 1032, -1, 1032, 1032, 1032, 
	-1, -1, -1, 1032, 1032, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1032, 
	1032, -1, -1, 1032, -1, -1, -1, -1, 
	1032, -1, -1, -1, -1, 1032, -1, 1032, 
	1032, 1032, 1032, 1032, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1025, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, 1073, 1073, -1, 1073, 1073, 1073, 1073, 
	1073, -1, 1073, -1, 1073, 1073, 1073, 1073, 
	-1, 1073, -1, 1073, 1073, 1073, -1, 1073, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, 1073, 1073, 1073, -1, 1073, 1073, 1073, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, 1073, 1073, 1073, -1, 1073, -1, -1, 
	-1, -1, 1073, 1073, 1073, 1073, 1073, -1, 
	-1, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	1073, -1, 1073, 1073, -1, -1, -1, -1, 
	-1, 1073, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1032, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1073, 1073, 1073, 1073, -1, -1, 1073, 1073, 
	1073, 1073, 1073, 1073, -1, -1, -1, -1, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	-1, -1, -1, -1, 1073, -1, -1, -1, 
	-1, 1073, 1073, -1, -1, 1073, 1073, 1073, 
	1073, -1, 1073, 1073, -1, -1, 1073, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 
	-1, -1, -1, 1073, 1073, 1073, -1, -1, 
	1073, 1073, -1, 1073, 1073, 1073, 1073, 1073, 
	-1, 1073, 1073, 1073, -1, -1, -1, 1073, 
	1073, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1073, 1073, -1, -1, 1073, 
	-1, -1, -1, -1, 1073, -1, -1, -1, 
	-1, 1073, -1, 1073, 1073, 1073, 1073, 1073, 
	1166, 1166, 1166, 1166, 1166, 1166, 1166, -1, 
	1166, 1166, -1, -1, 1032, -1, -1, -1, 
	-1, -1, -1, 1166, 1166, 1166, 1166, 1166, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1166, -1, -1, -1, 1166, -1, 
	-1, -1, 1166, 1166, 1166, 1166, 1166, 1166, 
	-1, -1, -1, -1, 1166, 1166, 1166, -1, 
	-1, -1, -1, 1166, 1166, 1166, 1166, 1166, 
	1166, 1166, 1166, -1, -1, -1, -1, -1, 
	-1, 1166, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1166, 
	1166, 1166, 1166, 1166, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1073, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1166, 1166, 1166, 1166, 1166, -1, 
	1166, 1166, 1166, -1, -1, -1, -1, 1166, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1166, 1166, -1, -1, 1166, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1166, 1166, 1166, 1166, 1166, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 641, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1073, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, 1072, 1072, 1072, -1, 1072, 1072, 1072, 
	1072, 1072, -1, 1072, -1, 1072, 1072, 1072, 
	1072, -1, 1072, -1, 1072, 1072, 1072, -1, 
	1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, 1072, 1072, 1072, 1072, -1, 1072, 1072, 
	1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	557, 559, 561, 1072, 1072, -1, 1072, -1, 
	-1, -1, -1, 1072, 1072, 1072, 1072, 1072, 
	-1, -1, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, 1072, -1, 1072, 1072, -1, -1, -1, 
	-1, -1, 1072, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1072, 1072, 1072, 1072, -1, -1, 1072, 
	1072, 1072, 1072, 1072, 1072, -1, -1, -1, 
	-1, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, -1, -1, -1, -1, 1072, -1, -1, 
	-1, -1, 1072, 1072, -1, -1, 1072, 1072, 
	1072, 1072, -1, 1072, 1072, -1, -1, 1072, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 
	1072, -1, -1, -1, 1072, 1072, 1072, -1, 
	-1, 1072, 1072, -1, 1072, 1072, 1072, 1072, 
	1072, -1, 1072, 1072, 1072, -1, -1, -1, 
	1072, 1072, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1072, 1072, -1, -1, 
	1072, -1, 555, 642, -1, 1072, -1, -1, 
	-1, -1, 1072, -1, 1072, 1072, 1072, 1072, 
	1072, -1, -1, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, -1, 1051, 
	1051, 1051, 1051, 1051, -1, 1051, -1, 1051, 
	1051, 1051, 1051, -1, 1051, -1, 1051, 1051, 
	1051, -1, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, -1, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, -1, 
	1051, -1, -1, -1, -1, 1051, 1051, 1051, 
	1051, 1051, -1, -1, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, -1, 1051, 1051, -1, 
	-1, -1, -1, -1, 1051, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1051, 1051, 1051, 1051, -1, 
	-1, 1051, 1051, 1051, 1051, 1051, 1051, -1, 
	-1, -1, 1072, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, -1, -1, -1, -1, 1051, 
	-1, -1, -1, -1, 1051, 1051, -1, -1, 
	1051, 1051, 1051, 1051, -1, 1051, 1051, -1, 
	-1, 1051, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, -1, -1, -1, 1051, 1051, 
	1051, 1051, -1, 1051, 1051, -1, 1051, 1051, 
	1051, 1051, 1051, -1, 1051, 1051, 1051, -1, 
	-1, -1, 1051, 1051, -1, -1, -1, -1, 
	-1, -1, -1, 1051, 1051, -1, 1051, 1051, 
	-1, -1, 1051, -1, -1, -1, -1, 1051, 
	-1, -1, -1, -1, 1051, -1, 1051, 1051, 
	1051, 1051, 1051, -1, -1, -1, 641, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1051, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1072, -1, -1, -1, -1, -1, -1, 
	-1, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, -1, 1052, 1052, 1052, 
	1052, 1052, -1, 1052, -1, 1052, 1052, 1052, 
	1052, -1, 1052, -1, 1052, 1052, 1052, -1, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, -1, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, -1, 1052, -1, 
	-1, -1, -1, 1052, 1052, 1052, 1052, 1052, 
	-1, -1, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, 1052, -1, 1052, 1052, -1, -1, -1, 
	-1, -1, 1052, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1051, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1052, 1052, 1052, 1052, -1, -1, 1052, 
	1052, 1052, 1052, 1052, 1052, -1, -1, -1, 
	-1, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, -1, -1, -1, -1, 1052, -1, -1, 
	-1, -1, 1052, 1052, -1, -1, 1052, 1052, 
	1052, 1052, -1, 1052, 1052, -1, -1, 1052, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1052, 1052, 1052, 1052, 1052, 1052, 1052, 
	1052, -1, -1, -1, 1052, 1052, 1052, 1052, 
	-1, 1052, 1052, -1, 1052, 1052, 1052, 1052, 
	1052, -1, 1052, 1052, 1052, -1, -1, -1, 
	1052, 1052, -1, 555, 642, -1, -1, -1, 
	-1, 1052, 1052, -1, 1052, 1052, -1, -1, 
	1052, -1, -1, -1, -1, 1052, -1, -1, 
	-1, -1, 1052, 1051, 1052, 1052, 1052, 1052, 
	1052, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1052, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, -1, 1053, 
	1053, 1053, 1053, 1053, -1, 1053, -1, 1053, 
	1053, 1053, 1053, -1, 1053, -1, 1053, 1053, 
	1053, -1, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, -1, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, -1, 
	1053, -1, -1, -1, -1, 1053, 1053, 1053, 
	1053, 1053, -1, -1, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, 1053, -1, 1053, 1053, -1, 
	-1, -1, -1, -1, 1053, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1052, 1053, 1053, 1053, 1053, -1, 
	-1, 1053, 1053, 1053, 1053, 1053, 1053, -1, 
	-1, -1, -1, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, -1, -1, -1, -1, 1053, 
	-1, -1, -1, -1, 1053, 1053, -1, -1, 
	1053, 1053, 1053, 1053, -1, 1053, 1053, -1, 
	-1, 1053, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1053, 1053, 1053, 1053, 1053, 
	1053, 1053, 1053, -1, -1, -1, 1053, 1053, 
	1053, 1053, -1, 1053, 1053, -1, 1053, 1053, 
	1053, 1053, 1053, -1, 1053, 1053, 1053, -1, 
	-1, -1, 1053, 1053, -1, -1, -1, -1, 
	-1, -1, -1, 1053, 1053, -1, 1053, 1053, 
	-1, -1, 1053, -1, -1, -1, -1, 1053, 
	-1, -1, -1, -1, 1053, -1, 1053, 1053, 
	1053, 1053, 1053, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1053, -1, -1, -1, 
	-1, 1052, -1, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, -1, 1057, 
	1057, 1057, 1057, 1057, -1, 1057, -1, 1057, 
	1057, 1057, 1057, -1, 1057, -1, 1057, 1057, 
	1057, -1, 1057, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, 1057, -1, 
	1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, 1057, -1, 
	1057, -1, -1, -1, -1, 1057, 1057, 1057, 
	1057, 1057, -1, -1, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, -1, 1057, 1057, -1, 
	-1, -1, -1, -1, 1057, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1053, -1, -1, -1, 
	-1, -1, -1, 1057, 1057, 1057, 1057, -1, 
	-1, 1057, 1057, 1057, 1057, 1057, 1057, -1, 
	-1, -1, -1, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, -1, -1, -1, -1, 1057, 
	-1, -1, -1, -1, 1057, 1057, -1, -1, 
	1057, 1057, 1057, 1057, -1, 1057, 1057, -1, 
	-1, 1057, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1057, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, -1, -1, -1, 1057, 1057, 
	1057, 1057, -1, 1057, 1057, -1, 1057, 1057, 
	1057, 1057, 1057, -1, 1057, 1057, 1057, -1, 
	-1, -1, 1057, 1057, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1057, 1057, 
	-1, -1, 1057, -1, -1, -1, -1, 1057, 
	-1, -1, -1, -1, 1057, -1, 1057, 1057, 
	1057, 1057, 1057, 1060, 1060, 1060, 1060, 1060, 
	1060, 1060, -1, 1060, 1060, -1, -1, -1, 
	-1, -1, -1, 1053, 1057, -1, 1060, 1060, 
	1060, 1060, 1060, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1060, -1, -1, 
	-1, 1060, -1, -1, -1, 1060, 1060, 1060, 
	1060, 1060, 1060, -1, -1, -1, -1, 1060, 
	1060, 1060, -1, -1, -1, -1, 1179, 1060, 
	-1, 1060, 1060, 1060, 1060, -1, -1, -1, 
	-1, -1, -1, -1, 1060, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1060, 1060, 1060, 1060, 1060, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, 1005, -1, 1005, -1, 
	1005, 1005, 1005, 1005, 1005, 1005, -1, 1005, 
	1005, 1005, -1, -1, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, -1, 1005, 1005, 1005, 
	1005, -1, -1, -1, 1005, 1005, 1005, 1005, 
	1005, -1, -1, 1005, 1005, 1005, 1005, -1, 
	-1, -1, 1005, -1, 1057, -1, 1005, 1005, 
	-1, 1005, -1, -1, 1005, -1, -1, 1005, 
	-1, 1005, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1005, 1005, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 652, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1060, 1060, 1060, 
	1060, 1060, -1, 1060, 1060, 1176, 1005, -1, 
	-1, -1, 1060, -1, -1, -1, -1, -1, 
	1005, -1, -1, -1, -1, 653, 654, 655, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1060, 1060, 1060, 
	1176, 1176, -1, -1, 1005, 1005, 1005, 1005, 
	-1, -1, 1005, 1005, 1005, 1005, 1005, 1005, 
	-1, -1, -1, -1, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, -1, -1, 1005, -1, 
	1005, -1, -1, -1, -1, 1005, 1005, -1, 
	1005, 1005, 1005, 1005, 1005, -1, 1005, 1005, 
	-1, -1, 1005, 1057, -1, -1, -1, -1, 
	-1, 1005, -1, 1005, 1005, 1005, 1005, 1005, 
	1005, 1005, 1005, 1005, -1, -1, -1, -1, 
	1005, 1005, -1, 1005, 1005, 1005, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1005, 1005, 
	-1, -1, 1005, -1, 1005, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1005, 1005, 1005, 
	-1, -1, 1005, 1005, 1005, -1, -1, -1, 
	-1, -1, 1005, 1005, -1, -1, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, 1006, -1, 
	1006, -1, 1006, 1006, 1006, 1006, 1006, 1006, 
	-1, 1006, 1006, 1006, -1, -1, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, -1, 1006, 
	1006, 1006, 1006, -1, -1, -1, 1006, 1006, 
	1006, 1006, 1006, -1, -1, 1006, 1006, 1006, 
	1006, -1, -1, -1, 1006, -1, -1, -1, 
	1006, 1006, -1, 1006, -1, -1, 1006, -1, 
	-1, 1006, -1, 1006, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1006, 1006, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1006, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1006, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1006, 1006, 
	1006, 1006, -1, -1, 1006, 1006, 1006, 1006, 
	1006, 1006, -1, -1, -1, 1005, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, -1, -1, 
	1006, -1, 1006, -1, -1, -1, -1, 1006, 
	1006, -1, 1006, 1006, 1006, 1006, 1006, -1, 
	1006, 1006, -1, -1, 1006, -1, -1, -1, 
	-1, -1, -1, 1006, -1, 1006, 1006, 1006, 
	1006, 1006, 1006, 1006, 1006, 1006, -1, -1, 
	-1, -1, 1006, 1006, -1, 1006, 1006, 1006, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1006, 1006, -1, -1, 1006, -1, 1006, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1006, 
	1006, 1006, -1, -1, 1006, 1006, 1006, -1, 
	-1, -1, -1, -1, 1006, 1006, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1005, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, 1008, -1, 1008, 
	-1, 1008, 1008, 1008, 1008, 1008, 1008, -1, 
	1008, 1008, 1008, -1, -1, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, -1, 1008, 1008, 
	1008, 1008, -1, -1, -1, 1008, 1008, 1008, 
	1008, 1008, -1, -1, 1008, 1008, 1008, 1008, 
	-1, -1, -1, 1008, -1, -1, -1, 1008, 
	1008, -1, 1008, -1, -1, 1008, -1, -1, 
	1008, -1, 1008, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1008, 
	1008, -1, -1, -1, -1, 652, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1008, 
	-1, -1, -1, -1, -1, -1, 653, 654, 
	655, 1008, -1, -1, -1, -1, -1, 1006, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1008, 1008, 1008, 
	1008, -1, -1, 1008, 1008, 1008, 1008, 1008, 
	1008, -1, -1, -1, -1, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, -1, -1, 1008, 
	-1, 1008, -1, -1, -1, -1, 1008, 1008, 
	-1, 1008, 1008, 1008, 1008, 1008, -1, 1008, 
	1008, -1, -1, 1008, -1, -1, -1, -1, 
	-1, -1, 1008, -1, 1008, 1008, 1008, 1008, 
	1008, 1008, 1008, 1008, 1008, -1, -1, -1, 
	-1, 1008, 1008, -1, 1008, 1008, 1008, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1008, 
	1008, -1, -1, 1008, -1, 1008, -1, -1, 
	-1, -1, -1, 78, 81, 82, 79, 80, 
	87, 88, -1, 83, 84, -1, 1008, 1008, 
	1008, -1, -1, 1008, 1008, 1008, 164, 165, 
	167, 166, 168, 1008, 1008, -1, 1006, -1, 
	-1, -1, -1, -1, -1, 89, -1, -1, 
	-1, 156, -1, -1, -1, 161, 162, 163, 
	86, 85, 155, -1, -1, -1, -1, 149, 
	150, 151, -1, -1, -1, -1, 1011, 147, 
	-1, 171, 173, 175, 160, -1, -1, -1, 
	-1, -1, -1, -1, 152, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 998, 998, 
	998, 998, 998, 998, 998, 998, 998, 998, 
	998, 998, 998, 998, 998, 998, 998, 998, 
	998, 998, 998, 998, 998, 998, 998, 998, 
	998, -1, 998, 998, 998, 998, 998, -1, 
	998, -1, 998, 998, 998, 998, -1, 998, 
	-1, 998, 998, 998, -1, 998, 998, 998, 
	998, 998, 998, 998, 998, 998, 998, 998, 
	998, 998, -1, 998, 998, 998, 998, 998, 
	998, 998, 998, 998, 998, 998, 998, 998, 
	998, 998, -1, 998, -1, -1, -1, -1, 
	998, 998, 998, 998, 998, -1, 1008, 998, 
	998, 998, 998, 998, 998, 998, 998, 998, 
	998, 998, 998, 998, 998, 998, 998, -1, 
	998, 998, -1, -1, -1, -1, -1, 998, 
	-1, -1, -1, 658, 154, 158, -1, -1, 
	-1, -1, 157, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, 1011, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 998, 998, 
	998, 998, -1, -1, 998, 998, 998, 998, 
	998, 998, -1, -1, -1, -1, 998, 998, 
	998, 998, 998, 998, 998, 998, -1, -1, 
	-1, -1, 998, -1, -1, -1, -1, 998, 
	998, -1, -1, 998, 998, 998, 998, -1, 
	998, 998, -1, -1, 998, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1008, 998, 998, 
	998, 998, 998, 998, 998, 998, -1, -1, 
	-1, 998, 998, 998, -1, -1, 998, 998, 
	-1, 998, 998, 998, 998, 998, -1, 998, 
	998, 998, -1, -1, -1, 998, 998, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 998, 998, -1, -1, 998, -1, -1, 
	-1, -1, 998, -1, -1, -1, -1, 998, 
	-1, 998, 998, 998, 998, 998, 1059, 1059, 
	1059, 1059, 1059, 1059, 1059, -1, 1059, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1059, 1059, 1059, 1059, 1059, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1059, -1, -1, -1, 1059, -1, -1, -1, 
	1059, 1059, 1059, 1059, 1059, 1059, -1, -1, 
	-1, -1, 1059, 1059, 1059, -1, -1, -1, 
	-1, 1059, 1059, -1, 1175, 1175, 1175, 1059, 
	-1, -1, -1, -1, -1, -1, -1, 1059, 
	1091, 1091, 1091, 1091, 1091, 1091, 1091, -1, 
	1091, 1091, -1, -1, -1, 1059, 1059, 1059, 
	1059, 1059, -1, 1091, 1091, 1091, 1091, 1091, 
	-1, -1, -1, -1, -1, -1, 659, -1, 
	-1, -1, 1091, -1, -1, -1, 1091, -1, 
	-1, -1, 1091, 1091, 1091, 1091, 1091, 1091, 
	-1, -1, -1, -1, 1091, 1091, 1091, -1, 
	-1, -1, -1, 1091, 1091, -1, 1091, 1091, 
	1091, 1091, 1091, -1, -1, -1, -1, -1, 
	-1, 1091, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1091, 
	1091, 1091, 1091, 1091, -1, -1, 274, 275, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1091, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 998, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1059, 1059, 1059, 1059, 1059, -1, 1059, 1059, 
	1059, -1, -1, -1, -1, 1059, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	436, 437, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 435, -1, 
	1059, 1059, 1059, 1059, 1059, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1091, 1091, 1091, 1091, 1091, -1, 
	1091, 1091, 1091, -1, -1, -1, -1, 1091, 
	-1, -1, -1, -1, -1, -1, 998, -1, 
	-1, -1, 1091, 1091, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1091, -1, 1091, 1091, 1091, 1091, 1091, -1, 
	-1, -1, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, 951, 951, 951, 
	951, 951, 951, 951, 951, -1, 951, 951, 
	951, 951, 951, -1, 951, -1, 951, 951, 
	951, 951, -1, 951, -1, 951, 951, 951, 
	-1, -1, 951, 951, 951, 951, 951, 951, 
	951, 951, -1, 951, 951, 951, -1, -1, 
	-1, -1, 951, 951, 951, 951, 951, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 658, 154, 158, 951, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 951, 951, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 951, 951, 951, 951, -1, -1, 
	951, 951, -1, 951, 951, 951, -1, -1, 
	-1, -1, 951, 951, 951, -1, 951, 951, 
	951, 951, -1, -1, -1, -1, 951, -1, 
	-1, -1, -1, 951, -1, -1, -1, 951, 
	951, 951, 951, -1, 951, 951, -1, -1, 
	951, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 951, 951, 951, 951, 951, 951, 
	951, 951, -1, -1, -1, -1, 951, 951, 
	-1, -1, 951, 951, -1, -1, -1, -1, 
	-1, -1, -1, -1, 951, 951, -1, -1, 
	-1, -1, 951, -1, 69, 70, 78, 81, 
	82, 79, 80, 87, 88, -1, 83, 84, 
	-1, -1, 48, 49, 53, 51, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	951, 951, 54, 55, 56, -1, -1, -1, 
	89, -1, -1, -1, -1, 50, -1, -1, 
	-1, -1, -1, 86, 85, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 73, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 276, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 274, 275, -1, 90, 
	91, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 942, 942, 942, 
	942, 942, 942, 942, 942, 942, 942, 942, 
	942, 942, 942, 942, 942, 942, 942, 942, 
	942, 942, 942, 942, 942, 942, 942, 942, 
	-1, 942, 942, 942, 942, 942, -1, 942, 
	-1, 942, 942, 942, 942, -1, 942, -1, 
	942, 942, 942, -1, -1, 942, 942, 942, 
	942, 942, 942, 942, 942, -1, 942, 942, 
	942, -1, -1, -1, -1, 942, 942, 942, 
	942, 942, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 942, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 942, 
	942, -1, -1, 951, -1, -1, -1, -1, 
	58, 277, -1, -1, -1, -1, -1, -1, 
	663, -1, -1, -1, -1, 47, 46, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, -1, -1, -1, -1, 57, -1, -1, 
	-1, 436, 437, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 435, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 52, 1011, 942, 942, 942, 
	942, -1, -1, 942, 942, -1, 942, 942, 
	942, -1, -1, -1, -1, 942, 942, 942, 
	-1, 942, 942, 942, 942, -1, -1, -1, 
	-1, 942, -1, -1, -1, -1, 942, -1, 
	-1, -1, 942, 942, 942, 942, -1, 942, 
	942, -1, -1, 942, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 942, 942, 942, 
	942, 942, 942, 942, 942, -1, -1, -1, 
	-1, 942, 942, -1, -1, 942, 942, -1, 
	-1, -1, 951, -1, -1, -1, -1, 942, 
	942, -1, -1, -1, -1, 942, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 942, 942, -1, -1, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	939, 939, -1, 939, 939, 939, 939, 939, 
	-1, 939, -1, 939, 939, 939, 939, -1, 
	939, -1, 939, 939, 939, -1, -1, 939, 
	939, 939, 939, 939, 939, 939, 939, -1, 
	939, 939, 939, -1, -1, -1, -1, 939, 
	939, 939, 939, 939, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 939, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 939, 939, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 939, 
	939, 939, 939, -1, -1, 939, 939, -1, 
	939, 939, 939, -1, -1, -1, 942, 939, 
	939, 939, -1, 939, 939, 939, 939, -1, 
	-1, -1, -1, 939, -1, -1, -1, -1, 
	939, -1, -1, -1, 939, 939, 939, 939, 
	-1, 939, 939, -1, -1, 939, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 939, 
	939, 939, 939, 939, 939, 939, 939, -1, 
	-1, -1, -1, 939, 939, -1, -1, 939, 
	939, -1, -1, -1, -1, -1, -1, -1, 
	-1, 939, 939, -1, -1, -1, -1, 939, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 939, 939, -1, 
	-1, -1, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, -1, 990, 990, 
	990, 990, 990, -1, 990, 942, 990, 990, 
	990, 990, -1, 990, -1, 990, 990, 990, 
	-1, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, -1, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, -1, 990, 
	-1, -1, -1, -1, 990, 990, 990, 990, 
	990, -1, -1, 990, 990, 990, 990, 990, 
	990, 990, 990, 990, 990, 990, 990, 990, 
	990, 990, 990, -1, 990, 990, -1, -1, 
	-1, -1, -1, 990, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 58, 277, -1, -1, -1, -1, -1, 
	-1, 663, -1, -1, -1, -1, 47, 46, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 76, -1, -1, -1, -1, 57, -1, 
	-1, -1, 990, 990, 990, 990, -1, -1, 
	990, 990, 990, 990, 990, 990, -1, -1, 
	939, -1, 990, 990, 990, 990, 990, 990, 
	990, 990, -1, -1, 52, -1, 990, -1, 
	-1, -1, -1, 990, 990, -1, -1, 990, 
	990, 990, 990, -1, 990, 990, -1, -1, 
	990, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 990, 990, 990, 990, 990, 990, 
	990, 990, -1, -1, -1, 990, 990, 990, 
	-1, -1, 990, 990, -1, 990, 990, 990, 
	990, 990, -1, 990, 990, 990, -1, -1, 
	-1, 990, 990, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 990, 990, -1, 
	-1, 990, -1, -1, -1, -1, 990, -1, 
	-1, -1, -1, 990, -1, 990, 990, 990, 
	990, 990, 78, 81, 82, 79, 80, 87, 
	88, -1, 83, 84, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 164, 165, 167, 
	166, 168, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 89, -1, -1, 939, 
	156, -1, -1, -1, 161, 162, 163, 86, 
	85, 155, -1, -1, -1, -1, 149, 150, 
	151, -1, -1, -1, -1, 1011, 147, -1, 
	171, 173, 175, 160, -1, -1, -1, -1, 
	-1, -1, -1, 152, 669, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 141, 142, 143, 144, 145, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, -1, 771, 771, 771, 
	771, 771, -1, 771, -1, 771, 771, 771, 
	771, -1, 771, -1, 771, 771, 771, -1, 
	-1, 771, 771, 771, 771, 771, 771, 771, 
	771, -1, 771, 771, 771, -1, -1, -1, 
	-1, 771, 771, 771, 771, 771, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 990, -1, -1, 771, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 771, 771, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 637, 137, 138, 139, 
	140, -1, 146, 154, 158, -1, -1, -1, 
	636, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 169, 159, 153, 148, 
	1011, 771, 771, 771, 771, -1, -1, 771, 
	771, -1, 771, 771, 771, -1, -1, -1, 
	-1, 771, 771, 771, -1, 771, 771, 771, 
	771, -1, -1, -1, -1, 771, -1, -1, 
	-1, -1, 771, -1, -1, -1, 771, 771, 
	771, 771, -1, 771, 771, -1, -1, 771, 
	-1, -1, 990, -1, -1, -1, -1, -1, 
	-1, 771, 771, 771, 771, 771, 771, 771, 
	771, -1, -1, -1, -1, 771, 771, -1, 
	-1, 771, 771, -1, -1, -1, -1, -1, 
	-1, -1, -1, 771, 771, -1, -1, -1, 
	-1, 771, -1, 69, 70, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, 48, 49, 53, 51, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 771, 
	771, 54, 55, 56, -1, -1, -1, 89, 
	-1, -1, -1, -1, 50, -1, -1, -1, 
	-1, -1, 86, 85, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	73, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	276, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 90, 91, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 770, 770, 770, 770, 
	770, 770, 770, 770, 770, 770, 770, 770, 
	770, 770, 770, 770, 770, 770, 770, 770, 
	770, 770, 770, 770, 770, 770, 770, -1, 
	770, 770, 770, 770, 770, -1, 770, -1, 
	770, 770, 770, 770, -1, 770, -1, 770, 
	770, 770, -1, -1, 770, 770, 770, 770, 
	770, 770, 770, 770, -1, 770, 770, 770, 
	-1, -1, -1, -1, 770, 770, 770, 770, 
	770, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 770, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 770, 770, 
	-1, -1, 771, -1, -1, -1, -1, 58, 
	277, -1, -1, -1, -1, -1, -1, 671, 
	-1, -1, -1, -1, 47, 46, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 76, 
	-1, -1, -1, -1, 57, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 52, 1011, 770, 770, 770, 770, 
	-1, -1, 770, 770, -1, 770, 770, 770, 
	-1, -1, -1, -1, 770, 770, 770, -1, 
	770, 770, 770, 770, -1, -1, -1, -1, 
	770, -1, -1, -1, -1, 770, -1, -1, 
	-1, 770, 770, 770, 770, -1, 770, 770, 
	-1, -1, 770, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 770, 770, 770, 770, 
	770, 770, 770, 770, -1, -1, -1, -1, 
	770, 770, -1, -1, 770, 770, -1, -1, 
	-1, 771, -1, -1, -1, -1, 770, 770, 
	-1, -1, -1, -1, 770, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 770, 770, -1, -1, -1, -1, 
	-1, 935, 935, 935, 935, 935, 935, 935, 
	935, 935, 935, 935, 935, 935, 935, 935, 
	935, 935, 935, 935, 935, 935, 935, 935, 
	935, 935, 935, 935, -1, 935, 935, 935, 
	935, 935, -1, 935, -1, 935, 935, 935, 
	935, -1, 935, -1, 935, 935, 935, -1, 
	-1, 935, 935, 935, 935, 935, 935, 935, 
	935, -1, 935, 935, 935, -1, -1, -1, 
	-1, 935, 935, 935, 935, 935, -1, -1, 
	-1, -1, -1, -1, -1, 637, 137, 138, 
	139, 140, -1, 146, 154, 158, 935, -1, 
	-1, 636, 157, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 935, 935, -1, -1, -1, 
	-1, -1, -1, -1, -1, 169, 159, 153, 
	148, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 935, 935, 935, 935, -1, -1, 935, 
	935, -1, 935, 935, 935, 770, -1, -1, 
	-1, 935, 935, 935, -1, 935, 935, 935, 
	935, -1, -1, -1, -1, 935, -1, -1, 
	-1, -1, 935, -1, -1, -1, 935, 935, 
	935, 935, -1, 935, 935, -1, -1, 935, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 935, 935, 935, 935, 935, 935, 935, 
	935, -1, -1, -1, -1, 935, 935, -1, 
	-1, 935, 935, -1, -1, -1, -1, -1, 
	-1, -1, -1, 935, 935, -1, -1, -1, 
	-1, 935, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 935, 
	935, -1, -1, 876, 876, 876, 876, 876, 
	876, 876, 876, 876, 876, 876, 876, 876, 
	876, 876, 876, -1, 876, 876, 876, 876, 
	876, 876, 876, 876, -1, -1, -1, 876, 
	876, 876, 876, 876, 770, 876, -1, 876, 
	876, 876, 876, -1, 876, -1, 876, 876, 
	876, -1, -1, 876, -1, -1, 876, 876, 
	876, 876, 876, -1, 876, 876, 876, 876, 
	-1, -1, -1, 876, 876, 876, 876, 876, 
	-1, 876, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 876, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 876, 876, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	58, 277, -1, -1, -1, -1, -1, -1, 
	671, -1, -1, -1, -1, 47, 46, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	76, -1, -1, -1, -1, 57, -1, -1, 
	-1, -1, -1, 876, 876, 876, 876, -1, 
	-1, 876, 876, 876, 876, 876, 876, -1, 
	-1, -1, 935, 876, 876, 876, 876, 876, 
	876, 876, 876, 52, 876, 876, -1, 876, 
	-1, -1, -1, -1, 876, 876, -1, -1, 
	876, 876, 876, 876, -1, 876, 876, 876, 
	-1, 876, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 876, 876, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 876, 876, -1, -1, -1, 
	-1, -1, -1, -1, -1, 876, 876, -1, 
	-1, -1, -1, 876, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 876, 876, -1, -1, -1, 923, 923, 
	923, 923, 923, 923, 923, 923, 923, 923, 
	923, 923, 923, 923, 923, 923, -1, 923, 
	923, 923, 923, 923, 923, 923, 923, -1, 
	-1, -1, 923, 923, 923, 923, 923, -1, 
	923, 935, 923, 923, 923, 923, -1, 923, 
	-1, 923, 923, 923, -1, -1, 923, -1, 
	-1, 923, 923, 923, 923, 923, -1, 923, 
	923, 923, -1, -1, -1, -1, 923, 923, 
	923, 923, 923, -1, -1, -1, -1, -1, 
	-1, -1, 923, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	923, 923, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 923, 923, 
	923, 923, -1, -1, 923, 923, 923, 923, 
	923, 923, -1, -1, 876, -1, 923, 923, 
	923, 923, 923, 923, 923, 923, -1, -1, 
	-1, -1, 923, -1, -1, -1, -1, 923, 
	923, -1, -1, 923, 923, 923, 923, -1, 
	923, 923, -1, -1, 923, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 923, 923, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 923, 923, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	923, 923, -1, -1, -1, -1, 923, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 923, 923, -1, -1, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	961, 961, 961, -1, 961, 961, 961, 961, 
	961, -1, 961, 876, 961, 961, 961, 961, 
	-1, 961, -1, 961, 961, 961, -1, -1, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	-1, 961, 961, 961, -1, -1, -1, -1, 
	961, 961, 961, 961, 961, -1, 1157, 1157, 
	1157, 1157, 1157, 1157, 1157, -1, 1157, 1157, 
	-1, -1, -1, -1, -1, 961, -1, -1, 
	-1, 1157, 1157, 1157, 1157, 1157, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1157, -1, 961, 961, 1157, -1, -1, -1, 
	1157, 1157, 1157, 1157, 1157, 1157, -1, -1, 
	-1, -1, 1157, 1157, 1157, -1, -1, -1, 
	-1, 1157, 1157, -1, 1157, 1157, 1157, 1157, 
	-1, -1, -1, -1, -1, -1, -1, 1157, 
	1157, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1157, 1157, 1157, 
	1157, 1157, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	961, 961, 961, 961, -1, -1, 961, 961, 
	-1, 961, 961, 961, -1, -1, -1, 923, 
	961, 961, 961, -1, 961, 961, 961, 961, 
	-1, -1, -1, -1, 961, -1, -1, -1, 
	-1, 961, -1, -1, -1, 961, 961, 961, 
	961, -1, 961, 961, -1, -1, 961, -1, 
	-1, -1, -1, -1, -1, 923, -1, -1, 
	961, 961, 961, 961, 961, 961, 961, 961, 
	-1, -1, -1, -1, 961, 961, -1, 923, 
	961, 961, -1, -1, -1, -1, -1, -1, 
	-1, -1, 961, 961, -1, -1, -1, -1, 
	961, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 961, 961, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1157, 1157, 1157, 1157, 1157, -1, 1157, 1157, 
	1157, -1, -1, -1, 1157, 1157, -1, 1022, 
	1022, 1022, 1022, 1022, 1022, 1022, 923, 1022, 
	1022, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1022, 1022, 1022, 1022, 1022, -1, 
	1157, 1157, 1157, 1157, 1157, -1, -1, -1, 
	-1, 1022, -1, -1, -1, 1022, -1, -1, 
	-1, 1022, 1022, 1022, 1022, 1022, 1022, -1, 
	-1, -1, -1, 1022, 1022, 1022, -1, -1, 
	-1, -1, 1022, 1022, -1, 1022, 1022, 1022, 
	1022, -1, -1, -1, -1, -1, -1, -1, 
	1022, 1022, -1, -1, 1059, 1059, 1059, 1059, 
	1059, 1059, 1059, -1, 1059, 1059, 1022, 1022, 
	1022, 1022, 1022, -1, -1, 274, 275, 1059, 
	1059, 1059, 1059, 1059, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1059, -1, 
	-1, -1, 1059, -1, -1, -1, 1059, 1059, 
	1059, 1059, 1059, 1059, -1, -1, -1, -1, 
	1059, 1059, 1059, -1, -1, -1, -1, 1175, 
	1059, 1058, 1175, 1175, 1175, 1059, 688, -1, 
	-1, -1, -1, -1, -1, 1059, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 961, -1, 1059, 1059, 1059, 1059, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1022, 1022, 1022, 1022, 1022, -1, 1022, 
	1022, 1022, -1, -1, -1, 1022, 1022, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1022, 1022, 1022, 1022, 1022, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	961, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1059, 1059, 
	1059, 1059, 1059, -1, 1059, 1059, 1175, -1, 
	-1, -1, -1, 1059, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 690, 691, 
	-1, -1, 689, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1059, 1059, 
	1059, 1059, 1059, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, 1071, 1071, -1, 1071, 
	1071, 1071, 1071, 1071, -1, 1071, -1, 1071, 
	1071, 1071, 1071, -1, 1071, -1, 1071, 1071, 
	1071, -1, 1071, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, 1071, 1071, 1071, -1, 
	1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, 1071, 1071, 1071, -1, 
	1071, -1, -1, -1, -1, 1071, 1071, 1071, 
	1071, 1071, -1, -1, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, 1071, -1, 1071, 1071, -1, 
	-1, -1, -1, -1, 1071, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1071, 1071, 1071, 1071, -1, 
	-1, 1071, 1071, 1071, 1071, 1071, 1071, -1, 
	-1, -1, -1, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, -1, -1, -1, -1, 1071, 
	-1, -1, -1, -1, 1071, 1071, -1, -1, 
	1071, 1071, 1071, 1071, -1, 1071, 1071, -1, 
	-1, 1071, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1071, 1071, 1071, 1071, 1071, 
	1071, 1071, 1071, -1, -1, -1, 1071, 1071, 
	1071, -1, -1, 1071, 1071, -1, 1071, 1071, 
	1071, 1071, 1071, -1, 1071, 1071, 1071, -1, 
	-1, -1, 1071, 1071, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1071, 1071, 
	-1, -1, 1071, -1, -1, -1, -1, 1071, 
	-1, -1, -1, -1, 1071, -1, 1071, 1071, 
	1071, 1071, 1071, 69, 70, 78, 81, 82, 
	79, 80, 87, 88, -1, 83, 84, -1, 
	-1, 48, 49, 53, 51, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 54, 55, 56, -1, -1, -1, 89, 
	-1, -1, -1, -1, 50, -1, -1, -1, 
	-1, -1, 86, 85, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, -1, -1, 
	73, -1, -1, -1, -1, -1, -1, 164, 
	165, 167, 166, 168, -1, -1, -1, -1, 
	276, -1, -1, -1, -1, -1, 89, -1, 
	-1, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, 90, 91, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, -1, -1, -1, -1, 152, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 141, 142, 143, 144, 145, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1071, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 58, 
	277, -1, -1, -1, -1, -1, -1, 714, 
	-1, -1, -1, -1, 47, 46, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 76, 
	-1, -1, -1, -1, 57, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 52, 1011, -1, -1, 717, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, 690, 
	691, -1, -1, 689, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, 1011, 1071, 999, 999, 999, 999, 
	999, 999, 999, 999, 999, 999, 999, 999, 
	999, 999, 999, 999, 999, 999, 999, 999, 
	999, 999, 999, 999, 999, 999, 999, -1, 
	999, 999, 999, 999, 999, -1, 999, -1, 
	999, 999, 999, 999, -1, 999, -1, 999, 
	999, 999, -1, 999, 999, 999, 999, 999, 
	999, 999, 999, 999, 999, 999, 999, 999, 
	-1, 999, 999, 999, 999, 999, 999, 999, 
	999, 999, 999, 999, 999, 999, 999, 999, 
	-1, 999, -1, -1, -1, -1, 999, 999, 
	999, 999, 999, -1, -1, 999, 999, 999, 
	999, 999, 999, 999, 999, 999, 999, 999, 
	999, 999, 999, 999, 999, -1, 999, 999, 
	-1, -1, -1, -1, -1, 999, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 999, 999, 999, 999, 
	-1, -1, 999, 999, 999, 999, 999, 999, 
	-1, -1, -1, -1, 999, 999, 999, 999, 
	999, 999, 999, 999, -1, -1, -1, -1, 
	999, -1, -1, -1, -1, 999, 999, -1, 
	-1, 999, 999, 999, 999, -1, 999, 999, 
	-1, -1, 999, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 999, 999, 999, 999, 
	999, 999, 999, 999, -1, -1, -1, 999, 
	999, 999, -1, -1, 999, 999, -1, 999, 
	999, 999, 999, 999, -1, 999, 999, 999, 
	-1, -1, -1, 999, 999, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 999, 
	999, -1, -1, 999, -1, -1, -1, -1, 
	999, -1, -1, -1, -1, 999, -1, 999, 
	999, 999, 999, 999, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1075, 1075, 
	1075, 1075, 1075, 1075, 1075, -1, 1075, 1075, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1075, 1075, 1075, 1075, 1075, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1075, -1, -1, -1, 1075, -1, -1, -1, 
	1075, 1075, 1075, 1075, 1075, 1075, -1, -1, 
	-1, -1, 1075, 1075, 1075, -1, -1, -1, 
	-1, 1075, 1075, -1, 1075, 1075, 1075, 1075, 
	1075, -1, -1, -1, -1, -1, -1, 1075, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1075, 1075, 1075, 
	1075, 1075, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1075, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 999, -1, -1, 
	-1, -1, -1, -1, 948, 948, 948, 948, 
	948, 948, 948, 948, 948, -1, 948, 948, 
	-1, -1, 948, 948, 948, 948, -1, -1, 
	58, 277, -1, -1, -1, -1, -1, -1, 
	714, -1, 948, 948, 948, 47, 46, -1, 
	948, -1, -1, -1, -1, 948, -1, -1, 
	76, -1, -1, 948, 948, 57, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 948, -1, -1, -1, -1, -1, -1, 
	1075, 1075, 1075, 1075, 1075, -1, 1075, 1075, 
	1075, 948, -1, 52, -1, 1075, -1, 717, 
	137, 138, 139, 140, -1, 146, 154, 158, 
	1075, 1075, -1, -1, 157, -1, -1, 948, 
	948, 1075, -1, -1, -1, -1, -1, -1, 
	1075, 1075, 1075, 1075, 1075, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 169, 
	159, 153, 148, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 999, 941, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	941, 941, 941, 941, 941, 941, 941, 941, 
	-1, 941, 941, 941, 941, 941, -1, 941, 
	-1, 941, 941, 941, 941, -1, 941, -1, 
	941, 941, 941, -1, -1, 941, 941, 941, 
	941, 941, 941, 941, 941, -1, 941, 941, 
	941, -1, -1, -1, -1, 941, 941, 941, 
	941, 941, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 941, -1, -1, -1, -1, -1, 
	948, 948, -1, -1, -1, -1, -1, -1, 
	948, -1, -1, -1, -1, 948, 948, 941, 
	941, -1, -1, -1, -1, -1, -1, -1, 
	948, -1, -1, -1, -1, 948, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 948, 948, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 941, 941, 941, 
	941, -1, -1, 941, 941, -1, 941, 941, 
	941, -1, -1, -1, -1, 941, 941, 941, 
	-1, 941, 941, 941, 941, -1, -1, -1, 
	-1, 941, -1, -1, -1, -1, 941, -1, 
	-1, -1, 941, 941, 941, 941, -1, 941, 
	941, -1, -1, 941, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 941, 941, 941, 
	941, 941, 941, 941, 941, -1, -1, -1, 
	-1, 941, 941, -1, -1, 941, 941, -1, 
	-1, -1, -1, -1, -1, -1, -1, 941, 
	941, -1, -1, -1, -1, 941, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 941, 941, -1, -1, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, -1, 1034, 1034, 1034, 1034, 1034, 
	-1, 1034, -1, 1034, 1034, 1034, 1034, -1, 
	1034, -1, 1034, 1034, 1034, -1, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, -1, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, -1, 1034, -1, -1, -1, 
	-1, 1034, 1034, 1034, 1034, 1034, -1, -1, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 
	-1, 1034, 1034, -1, -1, -1, -1, -1, 
	1034, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1034, 
	1034, 1034, 1034, -1, -1, 1034, 1034, 1034, 
	1034, 1034, 1034, -1, -1, -1, 941, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, -1, 
	-1, -1, -1, 1034, -1, -1, -1, -1, 
	1034, 1034, -1, -1, 1034, 1034, 1034, 1034, 
	-1, 1034, 1034, -1, -1, 1034, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1034, 
	1034, 1034, 1034, 1034, 1034, 1034, 1034, -1, 
	-1, -1, 1034, 1034, 1034, -1, -1, 1034, 
	1034, -1, 1034, 1034, 1034, 1034, 1034, -1, 
	1034, 1034, 1034, -1, -1, -1, 1034, 1034, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1034, 1034, -1, -1, 1034, -1, 
	-1, -1, -1, 1034, -1, -1, -1, -1, 
	1034, -1, 1034, 1034, 1034, 1034, 1034, -1, 
	-1, -1, 768, 768, 768, 768, 768, 768, 
	768, 768, 768, 768, 768, 768, 768, 768, 
	768, 768, 768, 768, 768, 768, 768, 768, 
	768, 768, 768, 768, 768, -1, 768, 768, 
	768, 768, 768, -1, 768, 941, 768, 768, 
	768, 768, -1, 768, -1, 768, 768, 768, 
	-1, -1, 768, 768, 768, 768, 768, 768, 
	768, 768, -1, 768, 768, 768, -1, -1, 
	-1, -1, 768, 768, 768, 768, 768, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 768, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 768, 768, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 768, 768, 768, 768, -1, -1, 
	768, 768, -1, 768, 768, 768, -1, -1, 
	1034, -1, 768, 768, 768, -1, 768, 768, 
	768, 768, -1, -1, -1, -1, 768, -1, 
	-1, -1, -1, 768, -1, -1, -1, 768, 
	768, 768, 768, -1, 768, 768, -1, -1, 
	768, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 768, 768, 768, 768, 768, 768, 
	768, 768, -1, -1, -1, -1, 768, 768, 
	-1, -1, 768, 768, -1, -1, -1, -1, 
	-1, -1, -1, -1, 768, 768, -1, -1, 
	-1, -1, 768, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	768, 768, -1, -1, 877, 877, 877, 877, 
	877, 877, 877, 877, 877, 877, 877, 877, 
	877, 877, 877, 877, -1, 877, 877, 877, 
	877, 877, 877, 877, 877, -1, -1, -1, 
	877, 877, 877, 877, 877, -1, 877, 1034, 
	877, 877, 877, 877, -1, 877, -1, 877, 
	877, 877, -1, -1, 877, -1, -1, 877, 
	877, 877, 877, 877, -1, 877, 877, 877, 
	-1, -1, -1, -1, 877, 877, 877, 877, 
	877, -1, 1076, 1076, 1076, 1076, 1076, 1076, 
	1076, -1, 1076, 1076, -1, -1, -1, -1, 
	877, -1, -1, -1, -1, 1076, 1076, 1076, 
	1076, 1076, -1, -1, -1, -1, -1, -1, 
	-1, -1, 505, -1, 1076, -1, 877, 877, 
	1076, -1, -1, -1, 1076, 1076, 1076, 1076, 
	1076, 1076, -1, -1, -1, -1, 1076, 1076, 
	1076, -1, -1, -1, -1, 1076, 1076, -1, 
	1076, 1076, 1076, 1076, 1076, -1, -1, -1, 
	-1, -1, -1, 1076, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1076, 1076, 1076, 1076, 1076, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1076, -1, 877, 877, 877, 877, 
	-1, -1, 877, 877, 877, 877, 877, 877, 
	-1, -1, -1, 768, 877, 877, 877, 877, 
	877, 877, 877, 877, -1, -1, -1, 728, 
	877, -1, -1, -1, -1, 877, 877, -1, 
	-1, 877, 877, 877, 877, -1, 877, 877, 
	877, -1, 877, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 877, 
	877, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 877, 877, -1, -1, 
	-1, -1, -1, -1, -1, -1, 877, 877, 
	-1, -1, -1, -1, 877, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 877, 877, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1076, 1076, 1076, 1076, 
	1076, -1, 1076, 1076, 1076, -1, -1, -1, 
	-1, 1076, -1, -1, -1, -1, -1, -1, 
	-1, -1, 768, -1, 1076, 1076, 1077, 1077, 
	1077, 1077, 1077, 1077, 1077, 1076, 1077, 1077, 
	-1, -1, -1, -1, 1076, 1076, 1076, 1076, 
	1076, 1077, 1077, 1077, 1077, 1077, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1077, -1, -1, -1, 1077, -1, -1, -1, 
	1077, 1077, 1077, 1077, 1077, 1077, -1, -1, 
	-1, -1, 1077, 1077, 1077, -1, -1, -1, 
	-1, 1077, 1077, -1, 1077, 1077, 1077, 1077, 
	1077, -1, -1, -1, -1, -1, -1, 1077, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1077, 1077, 1077, 
	1077, 1077, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1077, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, 1068, 877, 1068, 1068, 
	1068, 1068, 1068, -1, 1068, -1, 1068, 1068, 
	1068, 1068, -1, 1068, -1, 1068, 1068, 1068, 
	-1, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, 1068, 1068, -1, 1068, 
	1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, 1068, 1068, -1, 1068, 
	-1, -1, -1, -1, 1068, 1068, 1068, 1068, 
	1068, -1, -1, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, 1068, -1, 1068, 1068, -1, -1, 
	-1, -1, -1, 1068, -1, -1, -1, -1, 
	1077, 1077, 1077, 1077, 1077, -1, 1077, 1077, 
	1077, -1, -1, -1, -1, 1077, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1077, 1077, -1, -1, -1, -1, -1, -1, 
	-1, 1077, -1, -1, -1, -1, -1, -1, 
	1077, 1077, 1077, 1077, 1077, -1, -1, -1, 
	-1, -1, -1, -1, 877, -1, -1, -1, 
	-1, -1, 1068, 1068, 1068, 1068, -1, -1, 
	1068, 1068, 1068, 1068, 1068, 1068, -1, -1, 
	-1, -1, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, -1, -1, -1, -1, 1068, -1, 
	-1, -1, -1, 1068, 1068, -1, -1, 1068, 
	1068, 1068, 1068, -1, 1068, 1068, -1, -1, 
	1068, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1068, 1068, 1068, 1068, 1068, 1068, 
	1068, 1068, -1, -1, -1, 1068, 1068, 1068, 
	-1, -1, 1068, 1068, -1, 1068, 1068, 1068, 
	1068, 1068, -1, 1068, 1068, 1068, -1, -1, 
	-1, 1068, 1068, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1068, 1068, -1, 
	-1, 1068, -1, 1068, 1068, -1, 1068, -1, 
	-1, -1, -1, 1068, -1, 1068, 1068, 1068, 
	1068, 1068, 1166, 1166, 1166, 1166, 1166, 1166, 
	1166, -1, 1166, 1166, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1166, 1166, 1166, 
	1166, 1166, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1166, -1, -1, -1, 
	1166, -1, -1, -1, 1166, 1166, 1166, 1166, 
	1166, 1166, -1, -1, -1, -1, 1166, 1166, 
	1166, -1, -1, -1, -1, 1166, 1166, 1166, 
	1166, 1166, 1166, 1166, -1, -1, -1, -1, 
	728, -1, -1, 1166, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1166, 1166, 1166, 1166, 1166, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1166, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1068, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1166, 1166, 1166, 1166, 
	1166, -1, 1166, 1166, 1166, -1, -1, -1, 
	-1, 1166, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1166, 1166, -1, -1, 
	1166, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1166, 1166, 1166, 1166, 
	1166, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 733, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1068, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, 1069, -1, 1069, 
	1069, 1069, 1069, 1069, -1, 1069, -1, 1069, 
	1069, 1069, 1069, -1, 1069, -1, 1069, 1069, 
	1069, -1, 1069, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, 1069, 1069, -1, 
	1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, 1069, 1069, -1, 
	1069, -1, -1, -1, -1, 1069, 1069, 1069, 
	1069, 1069, -1, -1, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, 1069, -1, 1069, 1069, -1, 
	-1, -1, -1, -1, 1069, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1069, 1069, 1069, 1069, -1, 
	-1, 1069, 1069, 1069, 1069, 1069, 1069, -1, 
	-1, -1, -1, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, -1, -1, -1, -1, 1069, 
	-1, -1, -1, -1, 1069, 1069, -1, -1, 
	1069, 1069, 1069, 1069, -1, 1069, 1069, -1, 
	-1, 1069, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1069, 1069, 1069, 1069, 1069, 
	1069, 1069, 1069, -1, -1, -1, 1069, 1069, 
	1069, -1, -1, 1069, 1069, -1, 1069, 1069, 
	1069, 1069, 1069, -1, 1069, 1069, 1069, -1, 
	-1, -1, 1069, 1069, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1069, 1069, 
	-1, -1, 1069, -1, 1069, 1069, -1, 1069, 
	-1, -1, -1, -1, 1069, -1, 1069, 1069, 
	1069, 1069, 1069, -1, -1, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 
	-1, 1070, 1070, 1070, 1070, 1070, -1, 1070, 
	-1, 1070, 1070, 1070, 1070, -1, 1070, -1, 
	1070, 1070, 1070, -1, 1070, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 
	1070, -1, 1070, 1070, 1070, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 
	1070, -1, 1070, -1, -1, -1, -1, 1070, 
	1070, 1070, 1070, 1070, -1, -1, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, 1070, -1, 1070, 
	1070, -1, -1, -1, -1, -1, 1070, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1070, 1070, 1070, 
	1070, -1, -1, 1070, 1070, 1070, 1070, 1070, 
	1070, -1, -1, -1, 1069, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, -1, -1, -1, 
	-1, 1070, -1, -1, -1, -1, 1070, 1070, 
	-1, -1, 1070, 1070, 1070, 1070, -1, 1070, 
	1070, -1, -1, 1070, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1070, 1070, 1070, 
	1070, 1070, 1070, 1070, 1070, -1, -1, -1, 
	1070, 1070, 1070, -1, -1, 1070, 1070, -1, 
	1070, 1070, 1070, 1070, 1070, -1, 1070, 1070, 
	1070, -1, -1, -1, 1070, 1070, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1070, 1070, -1, -1, 1070, -1, 1070, 1070, 
	-1, 1070, -1, -1, -1, -1, 1070, -1, 
	1070, 1070, 1070, 1070, 1070, -1, -1, -1, 
	733, -1, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, -1, 1074, 1074, 
	1074, 1074, 1074, 1069, 1074, -1, 1074, 1074, 
	1074, 1074, -1, 1074, -1, 1074, 1074, 1074, 
	-1, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, -1, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, -1, 1074, 
	-1, -1, -1, -1, 1074, 1074, 1074, 1074, 
	1074, -1, -1, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, 1074, -1, 1074, 1074, -1, -1, 
	-1, -1, -1, 1074, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1074, 1074, 1074, 1074, -1, -1, 
	1074, 1074, 1074, 1074, 1074, 1074, 1070, -1, 
	-1, -1, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, -1, -1, -1, -1, 1074, -1, 
	-1, -1, -1, 1074, 1074, -1, -1, 1074, 
	1074, 1074, 1074, -1, 1074, 1074, -1, -1, 
	1074, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1074, 1074, 1074, 1074, 1074, 1074, 
	1074, 1074, -1, -1, -1, 1074, 1074, 1074, 
	-1, -1, 1074, 1074, -1, 1074, 1074, 1074, 
	1074, 1074, -1, 1074, 1074, 1074, -1, -1, 
	-1, 1074, 1074, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1074, 1074, -1, 
	-1, 1074, -1, -1, -1, -1, 1074, -1, 
	-1, -1, -1, 1074, -1, 1074, 1074, 1074, 
	1074, 1074, 1165, 1165, 1165, 1165, 1165, 1165, 
	1165, -1, 1165, 1165, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1165, 1165, 1165, 
	1165, 1165, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1165, 1070, -1, -1, 
	1165, -1, -1, -1, 1165, 1165, 1165, 1165, 
	1165, 1165, -1, -1, -1, -1, 1165, 1165, 
	1165, -1, -1, -1, -1, 1165, 1165, 1165, 
	1165, 1165, 1165, 1165, 1165, -1, -1, -1, 
	-1, -1, -1, 1165, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, -1, -1, 
	-1, 1165, 1165, 1165, 1165, 1165, -1, 164, 
	165, 167, 166, 168, -1, -1, -1, -1, 
	-1, -1, 1165, -1, -1, -1, 89, -1, 
	-1, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, -1, -1, -1, -1, 152, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 141, 142, 143, 144, 145, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1074, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1165, 1165, 1165, 1165, 
	1165, -1, 1165, 1165, 1165, -1, -1, -1, 
	-1, 1165, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1165, 1165, -1, -1, 
	1165, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1165, 1165, 1165, 1165, 
	1165, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 738, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, 1074, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, 1011, 767, 767, 767, 767, 767, 
	767, 767, 767, 767, 767, 767, 767, 767, 
	767, 767, 767, 767, 767, 767, 767, 767, 
	767, 767, 767, 767, 767, 767, -1, 767, 
	767, 767, 767, 767, -1, 767, -1, 767, 
	767, 767, 767, -1, 767, -1, 767, 767, 
	767, -1, -1, 767, 767, 767, 767, 767, 
	767, 767, 767, -1, 767, 767, 767, -1, 
	-1, -1, -1, 767, 767, 767, 767, 767, 
	-1, -1, -1, 950, 950, 950, 950, 950, 
	950, 950, 950, 950, -1, 950, 950, -1, 
	767, 950, 950, 950, 950, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 950, 950, 950, -1, 767, 767, 950, 
	-1, -1, -1, -1, 950, -1, -1, -1, 
	-1, -1, 950, 950, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	950, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	950, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 274, 275, -1, 950, 950, 
	-1, -1, -1, 767, 767, 767, 767, -1, 
	-1, 767, 767, -1, 767, 767, 767, -1, 
	-1, -1, -1, 767, 767, 767, -1, 767, 
	767, 767, 767, -1, -1, -1, -1, 767, 
	-1, -1, -1, -1, 767, -1, -1, -1, 
	767, 767, 767, 767, -1, 767, 767, -1, 
	-1, 767, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 767, 767, 767, 767, 767, 
	767, 767, 767, -1, -1, -1, -1, 767, 
	767, -1, -1, 767, 767, -1, -1, -1, 
	-1, -1, -1, -1, -1, 767, 767, -1, 
	-1, -1, -1, 767, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 767, 767, -1, -1, -1, -1, 950, 
	950, -1, -1, -1, -1, -1, -1, 950, 
	-1, -1, -1, -1, 950, 950, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 950, 
	-1, -1, -1, -1, 950, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 950, 950, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 767, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1088, 1088, 1088, 1088, 1088, 
	1088, 1088, -1, 1088, 1088, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1088, 1088, 
	1088, 1088, 1088, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1088, -1, -1, 
	-1, 1088, -1, -1, -1, 1088, 1088, 1088, 
	1088, 1088, 1088, -1, -1, -1, -1, 1088, 
	1088, 1088, -1, -1, -1, -1, 1088, 1088, 
	-1, 1088, 1088, 1088, 1088, 1088, -1, 738, 
	137, 138, 139, 140, 1088, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, 1088, 1088, 1088, 1088, 1088, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1088, -1, -1, -1, 169, 
	159, 153, 148, -1, -1, -1, -1, -1, 
	-1, -1, -1, 767, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, 1007, -1, 1007, -1, 
	1007, 1007, 1007, 1007, 1007, 1007, -1, 1007, 
	1007, 1007, -1, -1, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, -1, 1007, 1007, 1007, 
	1007, -1, -1, -1, 1007, 1007, 1007, 1007, 
	1007, -1, -1, 1007, 1007, 1007, 1007, -1, 
	-1, -1, 1007, -1, -1, -1, 1007, 1007, 
	-1, 1007, -1, -1, 1007, -1, -1, 1007, 
	-1, 1007, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1007, 1007, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1088, 1088, 1088, 
	1088, 1088, -1, 1088, 1088, 1088, -1, -1, 
	-1, -1, 1088, -1, -1, -1, 1007, -1, 
	-1, -1, -1, -1, -1, 1088, 1088, -1, 
	1007, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1088, -1, 1088, 1088, 1088, 
	1088, 1088, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1007, 1007, 1007, 1007, 
	-1, -1, 1007, 1007, 1007, 1007, 1007, 1007, 
	-1, -1, -1, -1, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, -1, -1, 1007, -1, 
	1007, -1, -1, -1, -1, 1007, 1007, -1, 
	1007, 1007, 1007, 1007, 1007, -1, 1007, 1007, 
	-1, -1, 1007, -1, -1, -1, -1, -1, 
	-1, 1007, -1, 1007, 1007, 1007, 1007, 1007, 
	1007, 1007, 1007, 1007, -1, -1, -1, -1, 
	1007, 1007, -1, 1007, 1007, 1007, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1007, 1007, 
	-1, -1, 1007, -1, 1007, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 1007, 1007, 1007, 
	-1, -1, 1007, 1007, 1007, -1, -1, -1, 
	-1, -1, 1007, 1007, -1, -1, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, -1, 
	1009, -1, 1009, 1009, 1009, 1009, 1009, 1009, 
	-1, 1009, 1009, 1009, -1, -1, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, -1, 1009, 
	1009, 1009, 1009, -1, -1, -1, 1009, 1009, 
	1009, 1009, 1009, -1, -1, 1009, 1009, 1009, 
	1009, -1, -1, -1, 1009, -1, -1, -1, 
	1009, 1009, -1, 1009, -1, -1, 1009, -1, 
	-1, 1009, -1, 1009, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1009, 1009, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1009, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1009, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 1009, 1009, 
	1009, 1009, -1, -1, 1009, 1009, 1009, 1009, 
	1009, 1009, -1, -1, -1, 1007, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, -1, -1, 
	1009, -1, 1009, -1, -1, -1, -1, 1009, 
	1009, -1, 1009, 1009, 1009, 1009, 1009, -1, 
	1009, 1009, -1, -1, 1009, -1, -1, -1, 
	-1, -1, -1, 1009, -1, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, -1, -1, 
	-1, -1, 1009, 1009, -1, 1009, 1009, 1009, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1009, 1009, -1, -1, 1009, -1, 1009, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1009, 
	1009, 1009, -1, -1, 1009, 1009, 1009, -1, 
	-1, -1, -1, -1, 1009, 1009, -1, 1089, 
	1089, 1089, 1089, 1089, 1089, 1089, -1, 1089, 
	1089, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1089, 1089, 1089, 1089, 1089, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1089, -1, -1, 1007, 1089, -1, -1, 
	-1, 1089, 1089, 1089, 1089, 1089, 1089, -1, 
	-1, -1, -1, 1089, 1089, 1089, -1, -1, 
	-1, -1, 1089, 1089, -1, 1089, 1089, 1089, 
	1089, 1089, -1, -1, -1, -1, -1, -1, 
	1089, 1090, 1090, 1090, 1090, 1090, 1090, 1090, 
	-1, 1090, 1090, -1, -1, -1, 1089, 1089, 
	1089, 1089, 1089, -1, 1090, 1090, 1090, 1090, 
	1090, -1, -1, -1, -1, -1, -1, 1089, 
	-1, -1, -1, 1090, -1, -1, -1, 1090, 
	-1, -1, -1, 1090, 1090, 1090, 1090, 1090, 
	1090, -1, -1, -1, -1, 1090, 1090, 1090, 
	-1, -1, -1, -1, 1090, 1090, -1, 1090, 
	1090, 1090, 1090, 1090, -1, -1, -1, -1, 
	-1, -1, 1090, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1090, 1090, 1090, 1090, 1090, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1090, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1009, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1089, 1089, 1089, 1089, 1089, -1, 1089, 
	1089, 1089, -1, -1, -1, -1, 1089, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1089, 1089, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1089, 
	-1, 1089, 1089, 1089, 1089, 1089, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1090, 1090, 1090, 1090, 1090, 
	-1, 1090, 1090, 1090, -1, -1, -1, -1, 
	1090, -1, -1, -1, -1, -1, 1009, -1, 
	-1, -1, -1, 1090, 1090, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1090, -1, 1090, 1090, 1090, 1090, 1090, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	-1, 925, 925, 925, 925, 925, 925, 925, 
	925, -1, -1, -1, 925, 925, 925, 925, 
	925, -1, 925, -1, 925, 925, 925, 925, 
	-1, 925, -1, 925, 925, 925, -1, -1, 
	925, -1, -1, 925, 925, 925, 925, 925, 
	-1, 925, 925, 925, -1, -1, -1, -1, 
	925, 925, 925, 925, 925, -1, -1, -1, 
	-1, -1, -1, -1, 925, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 925, 925, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	925, 925, 925, 925, -1, -1, 925, 925, 
	925, 925, 925, 925, -1, -1, -1, -1, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	-1, -1, -1, -1, 925, -1, -1, -1, 
	-1, 925, 925, -1, -1, 925, 925, 925, 
	925, -1, 925, 925, -1, -1, 925, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 925, 925, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	925, 925, -1, -1, -1, -1, -1, -1, 
	-1, -1, 925, 925, -1, -1, -1, -1, 
	925, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 925, 925, 
	-1, -1, 906, 906, 906, 906, 906, 906, 
	906, 906, 906, 906, 906, 906, 906, 906, 
	906, 906, -1, 906, 906, 906, 906, 906, 
	906, 906, 906, -1, -1, -1, 906, 906, 
	906, 906, 906, -1, 906, -1, 906, 906, 
	906, 906, -1, 906, -1, 906, 906, 906, 
	-1, -1, 906, -1, -1, 906, 906, 906, 
	906, 906, -1, 906, 906, 906, -1, -1, 
	-1, -1, 906, 906, 906, 906, 906, -1, 
	1059, 1059, 1059, 1059, 1059, 1059, 1059, -1, 
	1059, 1059, -1, -1, -1, -1, 749, -1, 
	-1, -1, -1, 1059, 1059, 1059, 1059, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1059, -1, 906, 906, 1059, -1, 
	-1, -1, 1059, 1059, 1059, 1059, 1059, 1059, 
	-1, -1, -1, -1, 1059, 1059, 1059, -1, 
	-1, -1, -1, 1175, 1059, 1058, 1175, 1175, 
	1175, 1059, -1, -1, -1, -1, -1, -1, 
	-1, 1059, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1059, 
	1059, 1059, 1059, 1059, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	751, -1, 906, 906, 906, 906, -1, -1, 
	906, 906, 906, 906, 906, 906, -1, -1, 
	-1, 925, 906, 906, 906, 906, 906, 906, 
	906, 906, -1, -1, -1, -1, 906, -1, 
	-1, -1, -1, 906, 906, -1, -1, 906, 
	906, 906, 906, -1, 906, 906, 748, -1, 
	906, -1, -1, -1, -1, -1, -1, 925, 
	-1, -1, -1, -1, -1, 906, 906, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 925, 906, 906, -1, -1, -1, -1, 
	-1, -1, -1, -1, 906, 906, -1, -1, 
	-1, -1, 906, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	906, 906, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1059, 1059, 1059, 1059, 1059, -1, 
	1059, 1059, 1175, -1, -1, -1, -1, 1059, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	925, -1, 690, 691, -1, -1, 689, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, -1, 1065, 
	1065, -1, 1059, 1059, 1059, 1059, 1059, -1, 
	-1, -1, 1065, 1065, 1065, 1065, 1065, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1065, -1, -1, -1, 1065, -1, -1, 
	-1, 1065, 1065, 1065, 1065, 1065, 1065, -1, 
	-1, -1, -1, 1065, 1065, 1065, -1, -1, 
	-1, -1, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, -1, -1, -1, -1, -1, -1, 
	1065, -1, -1, -1, 78, 81, 82, 79, 
	80, 87, 88, -1, 83, 84, 1065, 1065, 
	1065, 1065, 1065, -1, -1, 274, 275, 164, 
	165, 167, 166, 168, -1, -1, -1, 1065, 
	-1, -1, -1, -1, -1, -1, 89, -1, 
	-1, -1, 156, -1, -1, -1, 161, 162, 
	163, 86, 85, 155, -1, -1, -1, -1, 
	149, 150, 151, -1, -1, -1, -1, 1011, 
	147, -1, 171, 173, 175, 160, -1, -1, 
	-1, -1, -1, 906, -1, 152, 947, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 141, 142, 143, 144, 145, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1065, 1065, 1065, 1065, 1065, -1, 1065, 
	1065, 1065, -1, -1, -1, -1, 1065, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1065, 1065, -1, -1, 1065, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1065, 1065, 1065, 1065, 1065, -1, -1, 
	-1, -1, 906, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 229, 758, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 230, 137, 
	138, 139, 140, -1, 146, 154, 158, -1, 
	-1, -1, -1, 157, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 169, 159, 
	153, 148, 1011, 852, 852, 852, 852, 852, 
	852, 852, 852, 852, 852, 852, 852, 852, 
	852, 852, 852, -1, 852, 852, 852, 852, 
	852, 852, 852, 852, -1, -1, -1, 852, 
	852, 852, 852, 852, -1, 852, -1, 852, 
	852, 852, 852, -1, 852, -1, 852, 852, 
	852, -1, -1, 852, -1, -1, 852, 852, 
	852, 852, 852, -1, 852, 852, 852, -1, 
	-1, -1, -1, 852, 852, 852, 852, 852, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 852, 852, -1, 
	-1, -1, -1, 1156, 1156, 1156, 1156, 1156, 
	1156, 1156, 1156, 1156, 1156, 1156, 1156, -1, 
	-1, 1156, 1156, 1156, 1156, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 748, 
	-1, 1156, 1156, 1156, -1, -1, -1, 1156, 
	-1, -1, -1, -1, 1156, -1, -1, -1, 
	-1, -1, 1156, 1156, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1156, -1, -1, 852, 852, 852, 852, -1, 
	-1, 852, 852, 852, 852, 852, 852, -1, 
	-1, 1156, -1, 852, 852, 852, 852, 852, 
	852, 852, 852, -1, -1, -1, -1, 852, 
	-1, -1, -1, -1, 852, 852, 1156, 1156, 
	852, 852, 852, 852, -1, 852, 852, -1, 
	-1, 852, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 852, 852, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 852, 852, -1, -1, -1, 
	-1, -1, -1, 690, 691, 852, 852, 689, 
	-1, -1, -1, 852, -1, -1, -1, 863, 
	863, 863, 863, 863, 863, 863, 863, 863, 
	863, 863, 863, 863, 863, 863, 863, -1, 
	863, 863, 863, 863, 863, 863, 863, 863, 
	-1, 852, 852, 863, 863, 863, 863, 863, 
	-1, 863, -1, 863, 863, 863, 863, -1, 
	863, -1, 863, 863, 863, -1, -1, 863, 
	-1, -1, 863, 863, 863, 863, 863, -1, 
	863, 863, 863, -1, -1, -1, -1, 863, 
	863, 863, 863, 863, -1, -1, -1, 1156, 
	1156, -1, -1, -1, -1, -1, -1, -1, 
	1156, 1156, 761, -1, 1156, 1156, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1156, 
	-1, -1, -1, -1, 1156, -1, -1, -1, 
	-1, 863, 863, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1156, 1156, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 300, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 863, 
	863, 863, 863, -1, -1, 863, 863, 863, 
	863, 863, 863, -1, -1, -1, -1, 863, 
	863, 863, 863, 863, 863, 863, 863, -1, 
	-1, -1, -1, 863, -1, -1, -1, -1, 
	863, 863, -1, -1, 863, 863, 863, 863, 
	-1, 863, 863, -1, 852, 863, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 863, 863, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 863, 
	863, -1, -1, -1, -1, -1, -1, -1, 
	-1, 863, 863, -1, -1, -1, -1, 863, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 863, 863, -1, 
	-1, -1, -1, -1, 229, 758, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 230, 
	137, 138, 139, 140, -1, 146, 154, 158, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 169, 
	159, 153, 148, -1, -1, -1, -1, -1, 
	-1, -1, -1, 852, 903, 903, 903, 903, 
	903, 903, 903, 903, 903, 903, 903, 903, 
	903, 903, 903, 903, -1, 903, 903, 903, 
	903, 903, 903, 903, 903, -1, -1, -1, 
	903, 903, 903, 903, 903, -1, 903, -1, 
	903, 903, 903, 903, -1, 903, -1, 903, 
	903, 903, -1, -1, 903, -1, -1, 903, 
	903, 903, 903, 903, -1, 903, 903, 903, 
	-1, -1, -1, -1, 903, 903, 903, 903, 
	903, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 903, 903, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	863, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 903, 903, 903, 903, 
	-1, -1, 903, 903, 903, 903, 903, 903, 
	-1, -1, -1, -1, 903, 903, 903, 903, 
	903, 903, 903, 903, -1, -1, -1, -1, 
	903, -1, -1, -1, -1, 903, 903, -1, 
	-1, 903, 903, 903, 903, -1, 903, 903, 
	-1, -1, 903, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 903, 
	903, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 903, 903, -1, -1, 
	-1, -1, -1, -1, -1, -1, 903, 903, 
	-1, -1, -1, -1, 903, -1, -1, 863, 
	1061, 1061, 1061, 1061, 1061, 1061, 1061, -1, 
	1061, 1061, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 1061, 1061, 1061, 1061, 1061, 
	-1, -1, 903, 903, -1, -1, -1, -1, 
	-1, -1, 1061, -1, -1, -1, 1061, -1, 
	-1, -1, 1061, 1061, 1061, 1061, 1061, 1061, 
	-1, -1, -1, -1, 1061, 1061, 1061, -1, 
	-1, -1, -1, 1061, 1061, 1061, 1061, 1061, 
	1061, 1061, 1061, -1, -1, -1, -1, -1, 
	-1, 1061, -1, 761, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 1061, 
	1061, 1061, 1061, 1061, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1061, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 862, 862, 862, 
	862, 862, 862, 862, 862, 862, 862, 862, 
	862, 862, 862, 862, 862, -1, 862, 862, 
	862, 862, 862, 862, 862, 862, 300, -1, 
	-1, 862, 862, 862, 862, 862, -1, 862, 
	-1, 862, 862, 862, 862, -1, 862, -1, 
	862, 862, 862, -1, -1, 862, -1, -1, 
	862, 862, 862, 862, 862, -1, 862, 862, 
	862, -1, -1, -1, -1, 862, 862, 862, 
	862, 862, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 903, -1, 862, 
	862, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1061, 1061, 1061, 1061, 1061, -1, 
	1061, 1061, 1061, -1, -1, -1, -1, 1061, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1061, 1061, -1, -1, 1061, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1061, 1061, 1061, 1061, 1061, -1, 
	-1, -1, -1, -1, -1, 862, 862, 862, 
	862, -1, -1, 862, 862, 862, 862, 862, 
	862, -1, -1, -1, -1, 862, 862, 862, 
	862, 862, 862, 862, 862, -1, -1, -1, 
	-1, 862, -1, -1, -1, -1, 862, 862, 
	-1, -1, 862, 862, 862, 862, -1, 862, 
	862, -1, -1, 862, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	862, 862, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 903, 862, 862, -1, 
	-1, -1, -1, -1, -1, -1, -1, 862, 
	862, -1, -1, -1, -1, 862, 1062, 1062, 
	1062, 1062, 1062, 1062, 1062, -1, 1062, 1062, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1062, 1062, 1062, 1062, 1062, -1, -1, 
	-1, -1, -1, 862, 862, -1, -1, -1, 
	1062, -1, -1, -1, 1062, -1, -1, -1, 
	1062, 1062, 1062, 1062, 1062, 1062, -1, -1, 
	-1, -1, 1062, 1062, 1062, -1, -1, -1, 
	-1, 1062, 1062, 1062, 1062, 1062, 1062, 1062, 
	1062, -1, -1, -1, -1, -1, -1, 1062, 
	1063, 1063, 1063, 1063, 1063, 1063, 1063, -1, 
	1063, 1063, -1, -1, -1, 1062, 1062, 1062, 
	1062, 1062, -1, 1063, 1063, 1063, 1063, 1063, 
	-1, -1, -1, -1, -1, -1, 1062, -1, 
	-1, -1, 1063, -1, -1, -1, 1063, -1, 
	-1, -1, 1063, 1063, 1063, 1063, 1063, 1063, 
	-1, -1, -1, -1, 1063, 1063, 1063, -1, 
	-1, -1, -1, 1063, 1063, 1063, 1063, 1063, 
	1063, 1063, 1063, -1, -1, -1, -1, -1, 
	-1, 1063, 1064, 1064, 1064, 1064, 1064, 1064, 
	1064, -1, 1064, 1064, -1, -1, -1, 1063, 
	1063, 1063, 1063, 1063, -1, 1064, 1064, 1064, 
	1064, 1064, -1, -1, -1, -1, -1, -1, 
	1063, -1, -1, -1, 1064, -1, -1, -1, 
	1064, -1, -1, -1, 1064, 1064, 1064, 1064, 
	1064, 1064, -1, -1, -1, -1, 1064, 1064, 
	1064, -1, -1, -1, -1, 1064, 1064, 1064, 
	1064, 1064, 1064, 1064, 1064, -1, -1, -1, 
	-1, -1, -1, 1064, -1, -1, 862, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 1064, 1064, 1064, 1064, 1064, -1, -1, 
	1062, 1062, 1062, 1062, 1062, -1, 1062, 1062, 
	1062, -1, 1064, -1, -1, 1062, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1062, 1062, -1, -1, 1062, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	1062, 1062, 1062, 1062, 1062, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1063, 1063, 1063, 1063, 1063, -1, 
	1063, 1063, 1063, -1, -1, -1, -1, 1063, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1063, 1063, -1, -1, 1063, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 1063, 1063, 1063, 1063, 1063, -1, 
	-1, -1, -1, -1, -1, 862, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1064, 1064, 1064, 1064, 
	1064, -1, 1064, 1064, 1064, -1, -1, -1, 
	-1, 1064, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1064, 1064, -1, -1, 
	1064, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 1064, 1064, 1064, 1064, 
	1064, 905, 905, 905, 905, 905, 905, 905, 
	905, 905, 905, 905, 905, 905, 905, 905, 
	905, -1, 905, 905, 905, 905, 905, 905, 
	905, 905, -1, -1, -1, 905, 905, 905, 
	905, 905, -1, 905, -1, 905, 905, 905, 
	905, -1, 905, -1, 905, 905, 905, -1, 
	-1, 905, -1, -1, 905, 905, 905, 905, 
	905, -1, 905, 905, 905, -1, -1, -1, 
	-1, 905, 905, 905, 905, 905, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 905, 905, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 905, 905, 905, 905, -1, -1, 905, 
	905, 905, 905, 905, 905, -1, -1, -1, 
	-1, 905, 905, 905, 905, 905, 905, 905, 
	905, -1, -1, -1, -1, 905, -1, -1, 
	-1, -1, 905, 905, -1, -1, 905, 905, 
	905, 905, -1, 905, 905, -1, -1, 905, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 905, 905, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 905, 905, -1, -1, -1, -1, -1, 
	-1, -1, -1, 905, 905, -1, -1, -1, 
	-1, 905, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 905, 
	905, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 905, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 905
};

static int pid_0_parser_owners[] = {
	0, 0, 0, 4, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	0, 5, 7, 9, 0, 0, 0, 0, 
	0, 10, 0, 11, 0, 0, 0, 0, 
	13, 0, 15, 0, 0, 0, 16, 14, 
	0, 14, 19, 0, 0, 0, 0, 0, 
	43, 0, 0, 0, 47, 14, 49, 50, 
	0, 0, 0, 0, 0, 2, 44, 2, 
	52, 55, 3, 46, 3, 2, 57, 68, 
	44, 66, 70, 2, 2, 12, 59, 12, 
	3, 18, 71, 18, 59, 12, 72, 74, 
	18, 75, 77, 12, 12, 78, 83, 18, 
	84, 87, 0, 0, 88, 100, 45, 100, 
	101, 104, 101, 109, 79, 110, 45, 111, 
	45, 122, 133, 100, 152, 153, 18, 154, 
	162, 105, 73, 163, 164, 165, 166, 173, 
	118, 118, 170, 170, 73, 187, 69, 187, 
	69, 46, 188, 189, 51, 51, 51, 51, 
	51, 92, 92, 92, 92, 193, 4, 194, 
	4, 156, 198, 199, 218, 219, 60, 204, 
	221, 222, 225, 51, 51, 51, 204, 0, 
	0, 0, 0, 0, 254, 223, 0, 0, 
	286, 0, 0, 0, 51, 223, 287, 296, 
	0, 0, 0, 297, 0, 0, 0, 0, 
	256, 223, 223, 303, 0, 65, 65, 65, 
	65, 0, 44, 44, 44, 0, 0, 0, 
	0, 314, 0, 0, 256, 256, 0, 327, 
	2, 2, 2, 2, 46, 1, 3, 3, 
	329, 305, 85, 0, 0, 340, 14, 341, 
	341, 12, 12, 86, 345, 18, 18, 18, 
	0, 0, 45, 45, 45, 374, 69, 69, 
	239, 239, 0, 0, 2, 66, 316, 324, 
	0, 3, 117, 117, 117, 57, 73, 73, 
	73, 360, 360, 360, 12, 94, 324, 94, 
	18, 404, 90, 95, 105, 95, 118, 96, 
	170, 96, 405, 300, 120, 300, 0, 0, 
	217, 217, 217, 406, 100, 305, 318, 407, 
	57, 57, 0, 403, 6, 6, 6, 408, 
	6, 6, 6, 6, 6, 6, 6, 6, 
	6, 6, 6, 6, 409, 6, 6, 6, 
	6, 6, 6, 6, 6, 69, 278, 410, 
	6, 6, 6, 6, 6, 411, 6, 79, 
	6, 6, 6, 6, 312, 6, 312, 6, 
	6, 6, 424, 444, 6, 60, 445, 6, 
	6, 6, 6, 6, 446, 6, 6, 6, 
	92, 92, 92, 448, 6, 6, 6, 6, 
	6, 403, 51, 51, 76, 76, 76, 76, 
	93, 93, 93, 93, 156, 94, 94, 76, 
	60, 60, 108, 95, 95, 341, 341, 96, 
	96, 97, 108, 451, 300, 447, 239, 67, 
	67, 67, 67, 67, 458, 447, 6, 6, 
	485, 316, 117, 316, 65, 65, 65, 486, 
	487, 85, 330, 330, 330, 97, 67, 67, 
	67, 524, 86, 97, 108, 516, 525, 330, 
	330, 80, 80, 80, 80, 80, 551, 67, 
	217, 346, 346, 346, 81, 81, 81, 81, 
	81, 318, 117, 318, 85, 85, 346, 346, 
	80, 80, 80, 516, 94, 86, 86, 553, 
	108, 90, 95, 81, 81, 81, 96, 573, 
	577, 80, 300, 120, 6, 6, 6, 6, 
	582, 0, 6, 6, 81, 6, 6, 6, 
	11, 420, 420, 420, 6, 6, 6, 586, 
	6, 6, 6, 6, 90, 90, 600, 601, 
	6, 609, 616, 16, 600, 6, 120, 120, 
	623, 6, 6, 6, 6, 278, 6, 6, 
	626, 625, 6, 625, 253, 253, 253, 630, 
	108, 632, 2, 620, 633, 620, 638, 6, 
	6, 82, 82, 82, 82, 82, 129, 129, 
	129, 129, 12, 642, 6, 6, 644, 649, 
	278, 278, 651, 98, 652, 98, 6, 6, 
	82, 82, 82, 98, 6, 97, 691, 312, 
	640, 98, 98, 342, 342, 700, 108, 641, 
	640, 82, 702, 169, 169, 169, 97, 641, 
	97, 589, 589, 76, 76, 76, 708, 93, 
	93, 93, 6, 6, 705, 705, 168, 168, 
	168, 97, 168, 8, 8, 8, 6, 8, 
	8, 8, 8, 8, 8, 8, 8, 8, 
	8, 8, 8, 67, 8, 8, 8, 8, 
	8, 8, 8, 8, 720, 67, 67, 8, 
	8, 8, 8, 8, 654, 8, 108, 8, 
	8, 8, 8, 710, 8, 710, 8, 8, 
	8, 328, 722, 8, 500, 500, 8, 8, 
	8, 8, 8, 730, 8, 8, 8, 80, 
	80, 97, 80, 8, 8, 8, 8, 8, 
	654, 734, 81, 81, 253, 81, 89, 89, 
	89, 89, 89, 91, 91, 91, 91, 91, 
	735, 737, 183, 183, 183, 216, 216, 216, 
	735, 216, 298, 298, 298, 89, 89, 89, 
	180, 180, 91, 91, 91, 8, 8, 98, 
	98, 98, 590, 590, 590, -1, 89, 99, 
	648, 99, 620, 91, 648, -1, 99, 99, 
	-1, 342, 342, 169, 620, 99, 99, 102, 
	-1, 102, 103, 180, 103, -1, -1, 102, 
	589, 103, 98, -1, -1, 102, 102, -1, 
	103, -1, 168, 705, -1, 129, 129, 129, 
	354, 354, 354, 373, 373, 373, -1, 82, 
	82, -1, 82, 169, -1, -1, -1, 4, 
	-1, 4, 168, 8, 8, 8, 8, -1, 
	-1, 8, 8, -1, 8, 8, 8, -1, 
	0, -1, -1, 8, 8, 8, -1, 8, 
	8, 8, 8, -1, 328, -1, 328, 8, 
	-1, 168, -1, 500, 8, -1, -1, -1, 
	8, 8, 8, 8, -1, 8, 8, -1, 
	-1, 8, -1, 44, 44, 44, 128, 128, 
	128, 128, 371, 371, 371, 371, 8, 8, 
	-1, 2, 183, -1, 2, 46, 1, 3, 
	3, 216, 298, 8, 8, -1, -1, 14, 
	-1, -1, 12, 12, -1, 8, 8, -1, 
	18, 291, 291, 8, 216, -1, -1, 69, 
	69, -1, 590, 99, 99, -1, 66, 116, 
	116, 116, 183, 116, 501, 501, 57, 180, 
	180, 180, 102, 102, 102, 102, 103, 103, 
	202, 8, 8, -1, -1, 105, -1, 118, 
	-1, 170, -1, -1, 89, 89, 99, 89, 
	354, 91, 91, 373, 91, 238, 238, 238, 
	-1, 57, -1, 0, 202, -1, 102, -1, 
	-1, 103, 202, -1, 6, 106, 17, 17, 
	17, 17, 17, 17, 17, 17, 17, 17, 
	17, 17, 17, 17, 17, 17, 69, 17, 
	17, 17, 17, 17, 17, 17, 17, -1, 
	79, 106, 17, 17, 17, 17, 17, 106, 
	17, -1, 17, 17, 17, 17, 60, 17, 
	-1, 17, 17, 17, -1, -1, 17, -1, 
	454, 17, 17, 17, 17, 17, -1, 17, 
	17, 17, -1, 51, 51, -1, 17, 17, 
	17, 17, 17, -1, -1, 156, -1, -1, 
	-1, 60, 17, 237, 237, 237, 341, 237, 
	-1, 227, 227, 227, 227, 300, -1, 239, 
	98, -1, 522, 522, 227, -1, -1, 128, 
	128, 128, 316, 116, 316, 65, 65, 65, 
	17, 17, 85, 501, 371, 371, 371, -1, 
	291, 291, 291, 86, 538, 538, 116, 121, 
	121, 121, 121, 121, -1, -1, 498, 498, 
	498, 217, 498, -1, 202, 238, -1, -1, 
	-1, 317, 283, 117, 498, 85, 121, 121, 
	121, 130, 130, 130, 130, 202, 86, 202, 
	116, 283, 90, -1, 8, 317, -1, 121, 
	608, 608, 608, 300, 120, 317, -1, -1, 
	202, 106, -1, 317, -1, 238, 17, 17, 
	17, 17, -1, -1, 17, 17, 17, 17, 
	17, 17, 106, -1, 106, 90, 17, 17, 
	17, 17, 17, 17, 17, 17, -1, 120, 
	-1, -1, 17, -1, -1, 106, 278, 17, 
	17, -1, -1, 17, 17, 17, 17, -1, 
	17, 17, -1, -1, 17, 365, 365, 365, 
	365, 123, 123, 123, 123, 123, -1, 237, 
	-1, 17, 17, 317, 237, 212, -1, 454, 
	522, 278, 550, 550, -1, 212, 17, 17, 
	123, 123, 123, -1, 99, -1, -1, -1, 
	17, 17, -1, 283, 283, 283, 17, -1, 
	-1, 123, 538, -1, 102, 106, -1, -1, 
	227, -1, 454, 454, 76, 76, 76, -1, 
	237, -1, 124, 124, 124, 124, 124, -1, 
	-1, -1, -1, -1, 17, 17, -1, 6, 
	227, 227, 227, 317, 125, 125, 125, 125, 
	125, 124, 124, 124, 67, 317, -1, -1, 
	608, 294, -1, 212, 294, 294, 294, 294, 
	-1, -1, 124, 125, 125, 125, 317, 108, 
	317, 464, 228, 228, 228, 228, 126, 126, 
	126, 126, 126, -1, 125, 228, 565, 565, 
	464, 317, -1, 713, 713, 121, 121, -1, 
	-1, -1, 97, 80, -1, 126, 126, 126, 
	130, 130, 130, -1, -1, 253, 81, -1, 
	252, 252, 252, -1, 252, -1, 126, -1, 
	20, 20, 20, 212, 20, 20, 20, 20, 
	20, 20, 20, 20, 20, 20, 20, 20, 
	550, 20, 20, 20, 20, 20, 20, 20, 
	20, -1, 98, -1, 20, 20, 20, 20, 
	20, -1, 20, -1, 20, 20, 20, 20, 
	-1, 20, 342, 20, 20, 20, -1, -1, 
	20, 212, -1, 20, 20, 20, 20, 20, 
	-1, 20, 20, 20, 365, 365, 365, -1, 
	20, 20, 20, 20, 20, -1, 129, 129, 
	129, -1, 464, 464, 464, -1, -1, 123, 
	123, -1, -1, 82, 169, 517, 517, 517, 
	-1, -1, -1, -1, 8, 8, 8, 8, 
	-1, -1, 8, 8, 574, 8, 8, 8, 
	-1, -1, 20, 20, 8, 8, 8, 17, 
	8, 8, 8, 8, 565, 328, -1, 328, 
	8, 713, 168, -1, 500, 8, -1, -1, 
	-1, 8, 8, 8, 8, -1, 8, 8, 
	124, 124, 8, -1, -1, 294, 294, 294, 
	-1, 228, -1, -1, 252, 17, -1, 8, 
	8, -1, 125, 125, -1, 232, 232, 232, 
	232, -1, 216, 298, 8, 8, -1, 17, 
	232, 228, 228, 228, 252, -1, -1, 8, 
	20, 20, 20, 20, 8, 216, 20, 20, 
	-1, 20, 20, 20, 126, 126, -1, -1, 
	20, 20, 20, 183, 20, 20, 20, 20, 
	180, 180, 180, 102, 20, -1, 102, 103, 
	103, 20, 8, -1, -1, 20, 20, 20, 
	20, -1, 20, 20, -1, 574, 20, 574, 
	89, 615, 615, 615, 373, 91, -1, 521, 
	521, 521, -1, 20, 20, -1, -1, -1, 
	-1, 229, 229, 229, 229, -1, -1, -1, 
	20, 20, -1, -1, 229, -1, 17, -1, 
	-1, -1, 20, 20, 537, 537, 537, -1, 
	20, 517, 517, -1, 21, 21, 21, 21, 
	21, 21, 21, 21, 21, 21, 21, 21, 
	21, 21, 21, 21, -1, 21, 21, 21, 
	21, 21, 21, 21, 21, -1, 20, 20, 
	21, 21, 21, 21, 21, -1, 21, -1, 
	21, 21, 21, 21, -1, 21, -1, 21, 
	21, 21, -1, -1, 21, -1, -1, 21, 
	21, 21, 21, 21, -1, 21, 21, 21, 
	-1, -1, -1, -1, 21, 21, 21, 21, 
	21, -1, -1, 348, 348, 348, -1, 348, 
	128, 128, 128, -1, 232, 351, 351, 351, 
	-1, 351, -1, -1, 501, 371, 371, 371, 
	-1, 291, 291, 291, -1, -1, -1, 232, 
	232, 232, -1, -1, -1, -1, 21, 21, 
	-1, 615, -1, -1, 629, 202, -1, 521, 
	-1, 127, 127, 127, 127, 127, 176, 176, 
	176, 176, 176, 177, 177, 177, 177, 177, 
	-1, 116, -1, 184, 184, 184, 184, 184, 
	127, 127, 127, -1, 537, 176, 176, 176, 
	-1, 202, 177, 177, 177, -1, 238, 521, 
	-1, 127, 184, 184, 184, -1, 176, -1, 
	229, -1, -1, 177, -1, -1, 230, 230, 
	230, 230, -1, 184, 21, 21, 21, 21, 
	-1, 230, 21, 21, 537, 21, 21, 21, 
	229, 229, 229, -1, 21, 21, 21, -1, 
	21, 21, 21, 21, -1, -1, -1, -1, 
	21, 210, -1, -1, -1, 21, 547, -1, 
	547, 21, 21, 21, 21, -1, 21, 21, 
	454, 522, 21, 231, 231, 231, 231, 348, 
	-1, -1, -1, -1, -1, 210, 231, 21, 
	21, 351, -1, 210, 283, 283, 283, 549, 
	549, 549, 348, 538, 21, 21, 106, -1, 
	203, 227, 203, 454, 351, -1, 21, 21, 
	203, 237, -1, -1, 21, -1, 203, 203, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	-1, 22, 22, 22, 22, 22, 22, 22, 
	22, 608, 21, 21, 22, 22, 22, 22, 
	22, -1, 22, 629, 22, 22, 22, 22, 
	-1, 22, -1, 22, 22, 22, -1, -1, 
	22, -1, -1, 22, 22, 22, 22, 22, 
	-1, 22, 22, 22, -1, -1, 121, 121, 
	22, 22, 22, 22, 22, -1, 629, 629, 
	-1, 130, 130, 130, -1, -1, -1, 127, 
	127, 564, 564, 564, 176, 176, -1, 132, 
	-1, 177, 177, -1, 212, 230, -1, -1, 
	20, 184, 184, 226, 226, 226, 226, 226, 
	-1, 550, 22, 22, -1, 210, -1, -1, 
	132, 132, 132, 132, 132, 230, 230, 230, 
	-1, -1, 226, 226, 226, -1, 210, 549, 
	210, -1, -1, -1, -1, 547, -1, 132, 
	132, 132, 212, 226, 203, 203, -1, 547, 
	-1, 210, 231, -1, -1, 365, 365, 365, 
	132, -1, -1, 375, -1, 375, 375, 375, 
	375, -1, 375, 464, 464, 464, -1, 549, 
	123, 123, 231, 231, 231, -1, -1, 203, 
	22, 22, 22, 22, -1, -1, 22, 22, 
	-1, 22, 22, 22, -1, -1, -1, -1, 
	22, 22, 22, -1, 22, 22, 22, 22, 
	-1, -1, -1, -1, 22, 565, -1, -1, 
	-1, 22, 713, -1, -1, 22, 22, 22, 
	22, -1, 22, 22, -1, 21, 22, -1, 
	-1, 124, 124, -1, -1, -1, 294, 294, 
	294, 564, 228, 22, 22, 252, 520, 520, 
	520, -1, 520, 125, 125, -1, -1, -1, 
	22, 22, -1, -1, -1, 540, 540, 540, 
	-1, 540, 22, 22, -1, 252, -1, -1, 
	22, 20, 20, 20, 20, -1, -1, 20, 
	20, 564, 20, 20, 20, 126, 126, -1, 
	-1, 20, 20, 20, -1, 20, 20, 20, 
	20, 132, 132, -1, 132, 20, 22, 22, 
	-1, -1, 20, -1, -1, -1, 20, 20, 
	20, 20, -1, 20, 20, -1, 574, 20, 
	574, -1, 235, -1, 235, 235, 235, 235, 
	-1, 235, -1, -1, 20, 20, 206, -1, 
	206, 226, 226, -1, -1, 206, 206, -1, 
	-1, 20, 20, -1, 206, 206, 132, 132, 
	206, 206, 375, -1, 20, -1, 206, -1, 
	375, 20, 517, 517, 375, 375, -1, 206, 
	-1, -1, -1, -1, 21, -1, -1, 23, 
	23, 23, 23, 23, 23, 23, 23, 23, 
	23, 23, 23, 23, 23, 23, 23, 20, 
	23, 23, 23, 23, 23, 23, 23, 23, 
	-1, 132, 520, 23, 23, 23, 23, 23, 
	-1, 23, -1, 23, 23, 23, 23, -1, 
	23, 540, 23, 23, 23, 520, 540, 23, 
	-1, -1, 23, 23, 23, 23, 23, -1, 
	23, 23, 23, 622, 622, 622, -1, 23, 
	23, 23, 23, 23, -1, 232, -1, -1, 
	-1, 214, 214, 214, 214, -1, -1, 520, 
	-1, 214, 413, 413, 413, 203, 413, 214, 
	-1, 214, 214, -1, -1, -1, -1, -1, 
	-1, -1, 615, 244, 244, 244, 244, 244, 
	-1, 23, 23, -1, 637, 637, 637, -1, 
	-1, -1, 206, 206, -1, -1, -1, -1, 
	-1, 22, 244, 244, 244, -1, -1, 414, 
	414, 414, -1, 414, 398, 398, 398, 398, 
	398, 235, -1, 244, -1, -1, -1, 235, 
	521, -1, -1, 235, 235, 206, 206, -1, 
	-1, 229, -1, 398, 398, 398, 635, 635, 
	635, 666, 635, 666, 666, 666, 666, 372, 
	372, 372, -1, 372, 398, 537, -1, 23, 
	23, 23, 23, -1, -1, 23, 23, -1, 
	23, 23, 23, 729, 729, 729, -1, 23, 
	23, 23, 235, 23, 23, 23, 23, -1, 
	536, 536, 536, 23, 536, 659, 659, 659, 
	23, 659, -1, 622, 23, 23, 23, 23, 
	-1, 23, 23, -1, -1, 23, -1, -1, 
	-1, 611, 611, 611, 611, -1, -1, -1, 
	-1, -1, 23, 23, -1, -1, 413, -1, 
	541, 541, 541, -1, 541, -1, -1, 23, 
	23, 214, -1, 214, 214, 214, 214, 214, 
	214, 23, 23, -1, 637, -1, 413, 23, 
	22, -1, -1, 24, 24, 24, 24, 24, 
	24, 24, 24, 24, 24, 24, 24, 24, 
	24, 24, 24, 414, 24, 24, 24, 24, 
	24, 24, 24, 24, 629, 23, 23, 24, 
	24, 24, 24, 24, -1, 24, -1, 24, 
	24, 24, 24, 414, 24, -1, 24, 24, 
	24, -1, 635, 24, -1, -1, 24, 24, 
	24, 24, 24, 372, 24, 24, 24, 629, 
	372, 244, 244, 24, 24, 24, 24, 24, 
	127, 127, 635, 729, -1, 176, 176, -1, 
	-1, -1, 177, 177, -1, -1, 230, -1, 
	666, -1, 184, 184, 536, -1, -1, -1, 
	-1, 659, 398, 398, -1, -1, 210, -1, 
	-1, -1, 536, -1, -1, 24, 24, 659, 
	-1, -1, 178, 178, 178, 178, 178, 178, 
	178, 178, 178, 178, 178, 178, 547, -1, 
	178, 178, 178, 178, 541, 203, 203, -1, 
	547, 541, 210, 231, -1, -1, -1, 536, 
	178, 178, 178, -1, -1, -1, 178, 334, 
	334, 334, 334, 178, -1, -1, -1, 334, 
	549, 178, 178, 206, 206, 334, -1, 334, 
	334, -1, -1, 611, 611, 611, -1, 178, 
	611, 611, 611, 24, 24, 24, 24, -1, 
	-1, 24, 24, -1, 24, 24, 24, -1, 
	178, -1, -1, 24, 24, 24, -1, 24, 
	24, 24, 24, -1, -1, -1, -1, 24, 
	-1, -1, -1, -1, 24, 178, 178, -1, 
	24, 24, 24, 24, -1, 24, 24, -1, 
	23, 24, -1, -1, -1, 548, 548, 548, 
	-1, 548, -1, 205, -1, 205, 24, 24, 
	-1, -1, 205, 205, -1, -1, 205, -1, 
	-1, 205, 205, 24, 24, 205, 205, -1, 
	606, 606, 606, 205, 606, 24, 24, -1, 
	-1, -1, 564, 24, 205, -1, -1, 25, 
	25, 25, 25, 25, 25, 25, 25, 25, 
	25, 25, 25, 25, 25, 25, 25, -1, 
	25, 25, 25, 25, 25, 25, 25, 25, 
	-1, 24, 24, 25, 25, 25, 25, 25, 
	-1, 25, -1, 25, 25, 25, 25, -1, 
	25, -1, 25, 25, 25, -1, -1, 25, 
	-1, -1, 25, 25, 25, 25, 25, -1, 
	25, 25, 25, 334, 334, 334, 334, 25, 
	25, 25, 25, 25, -1, -1, 178, 178, 
	-1, 375, -1, -1, -1, -1, 375, 178, 
	178, 178, -1, 178, 178, -1, 245, 245, 
	245, 245, 245, -1, -1, -1, 178, 23, 
	-1, -1, -1, 178, 668, 668, 668, -1, 
	668, 25, 25, -1, -1, 245, 245, 245, 
	-1, 548, 132, -1, -1, -1, 548, 205, 
	205, 246, 246, 246, 246, 246, 245, -1, 
	-1, 178, 178, 367, 367, 367, 367, -1, 
	-1, -1, -1, -1, 606, -1, -1, -1, 
	246, 246, 246, -1, 178, 247, 247, 247, 
	247, 247, 205, 205, -1, -1, -1, 606, 
	-1, 246, 548, -1, -1, -1, -1, -1, 
	520, -1, -1, -1, 247, 247, 247, 25, 
	25, 25, 25, -1, -1, 25, 25, -1, 
	25, 25, 25, -1, -1, 247, -1, 25, 
	25, 25, -1, 25, 25, 25, 25, -1, 
	660, 660, 660, 25, 660, 727, 727, 727, 
	25, 727, -1, -1, 25, 25, 25, 25, 
	-1, 25, 25, -1, 24, 25, -1, 368, 
	368, 368, 368, -1, -1, -1, -1, -1, 
	-1, -1, 25, 25, -1, -1, 320, 206, 
	320, -1, -1, -1, -1, 320, 320, 25, 
	25, -1, -1, -1, 320, 320, -1, -1, 
	668, 25, 25, -1, -1, 668, -1, 25, 
	-1, -1, -1, 26, 26, 26, 26, 26, 
	26, 26, 26, 26, 26, 26, 26, 26, 
	26, 26, 26, 235, 26, 26, 26, 26, 
	26, 26, 26, 26, -1, 25, 25, 26, 
	26, 26, 26, 26, 622, 26, -1, 26, 
	26, 26, 26, -1, 26, -1, 26, 26, 
	26, -1, -1, 26, 245, 245, 26, 26, 
	26, 26, 26, -1, 26, 26, 26, 712, 
	712, 712, -1, 26, 26, 26, 26, 26, 
	-1, -1, 214, -1, 214, 214, 214, 214, 
	214, 214, 367, 367, 367, 637, -1, 246, 
	246, 636, 636, 636, 660, 636, -1, -1, 
	-1, 727, -1, 24, -1, 248, 248, 248, 
	248, 248, 660, -1, -1, 26, 26, 727, 
	-1, -1, -1, 247, 247, -1, -1, 249, 
	249, 249, 249, 249, 248, 248, 248, -1, 
	-1, -1, 320, 320, -1, -1, -1, -1, 
	369, 369, 369, 369, -1, 248, 249, 249, 
	249, -1, -1, -1, 372, -1, -1, -1, 
	-1, 372, 244, 244, -1, -1, -1, 249, 
	-1, -1, -1, -1, 729, 320, -1, -1, 
	205, 205, -1, -1, -1, -1, 368, 368, 
	368, 666, -1, 26, 26, 26, 26, -1, 
	-1, 26, 26, -1, 26, 26, 26, 370, 
	370, 370, 370, 26, 26, 26, -1, 26, 
	26, 26, 26, -1, -1, -1, -1, 26, 
	-1, -1, -1, -1, 26, -1, -1, 712, 
	26, 26, 26, 26, -1, 26, 26, -1, 
	25, 26, -1, -1, 325, -1, 325, -1, 
	536, -1, -1, 325, 325, -1, 26, 26, 
	-1, -1, 325, 325, -1, 636, 614, 614, 
	614, -1, 614, 26, 26, -1, -1, 712, 
	-1, -1, -1, -1, -1, 26, 26, -1, 
	-1, -1, -1, 26, -1, 636, -1, 27, 
	27, 27, 27, 27, 27, 27, 27, 27, 
	27, 27, 27, 27, 27, 27, 27, -1, 
	27, 27, 27, 27, 27, 27, 27, 27, 
	-1, 26, 26, 27, 27, 27, 27, 27, 
	-1, 27, -1, 27, 27, 27, 27, -1, 
	27, -1, 27, 27, 27, -1, -1, 27, 
	-1, -1, 27, 27, 27, 27, 27, -1, 
	27, 27, 27, 248, 248, -1, -1, 27, 
	27, 27, 27, 27, -1, -1, -1, -1, 
	563, 563, 563, -1, 563, 249, 249, 369, 
	369, 369, -1, -1, -1, -1, 250, 250, 
	250, 250, 250, -1, -1, -1, -1, 25, 
	-1, 251, 251, 251, 251, 251, -1, -1, 
	-1, 27, 27, -1, -1, 250, 250, 250, 
	325, 325, -1, 558, 558, 558, 558, 558, 
	251, 251, 251, -1, -1, -1, 250, -1, 
	-1, -1, 614, -1, -1, -1, 370, 370, 
	370, 251, 558, 558, 558, -1, -1, -1, 
	614, -1, -1, 325, 334, 334, 334, 334, 
	-1, -1, -1, 558, -1, -1, -1, 542, 
	-1, 542, 542, 542, 542, 576, 576, 576, 
	576, -1, 178, 320, 320, -1, -1, 27, 
	27, 27, 27, -1, -1, 27, 27, -1, 
	27, 27, 27, -1, -1, -1, -1, 27, 
	27, 27, -1, 27, 27, 27, 27, -1, 
	-1, -1, -1, 27, 542, -1, -1, -1, 
	27, -1, -1, -1, 27, 27, 27, 27, 
	-1, 27, 27, -1, 26, 27, -1, 621, 
	621, 621, -1, 621, 563, -1, -1, 319, 
	-1, 319, 27, 27, -1, 178, 319, 319, 
	-1, -1, -1, -1, 205, 319, 319, 27, 
	27, 319, 319, 548, 563, -1, -1, 319, 
	-1, 27, 27, -1, -1, -1, -1, 27, 
	319, -1, -1, 28, 28, 28, 28, 28, 
	28, 28, 28, 28, 28, 28, 28, 28, 
	28, 28, 28, 563, 28, 28, 28, 28, 
	28, 28, 28, 28, -1, 27, 27, 28, 
	28, 28, 28, 28, -1, 28, -1, 28, 
	28, 28, 28, -1, 28, -1, 28, 28, 
	28, -1, -1, 28, 250, 250, 28, 28, 
	28, 28, 28, -1, 28, 28, 28, 251, 
	251, -1, -1, 28, 28, 28, 28, 28, 
	-1, -1, -1, -1, -1, 215, 215, 215, 
	215, 558, 558, -1, -1, 215, 542, -1, 
	-1, -1, -1, 215, 542, 215, 215, 215, 
	542, 542, -1, 26, -1, -1, 576, 576, 
	576, -1, -1, -1, -1, 28, 28, -1, 
	607, 607, 607, 621, 607, -1, -1, -1, 
	621, -1, -1, 319, 319, -1, -1, -1, 
	-1, -1, 546, -1, 546, 546, 546, 546, 
	-1, 546, -1, -1, -1, 245, 245, 542, 
	552, 552, 552, 552, 552, 552, 552, 552, 
	552, 552, 552, 552, 552, 552, 319, 319, 
	-1, 325, 325, 624, -1, 624, 624, 624, 
	624, -1, 624, 367, 367, 367, 215, 546, 
	246, 246, -1, 28, 28, 28, 28, -1, 
	-1, 28, 28, -1, 28, 28, 28, -1, 
	-1, -1, -1, 28, 28, 28, -1, 28, 
	28, 28, 28, 552, 247, 247, -1, 28, 
	624, -1, -1, -1, 28, -1, -1, -1, 
	28, 28, 28, 28, -1, 28, 28, -1, 
	27, 28, -1, -1, 331, 331, 331, 331, 
	331, 331, 331, 331, 331, 331, 28, 28, 
	-1, -1, 331, -1, 331, 331, 331, 331, 
	331, 331, 331, 28, 28, 215, -1, 215, 
	215, 215, 215, 215, 215, 28, 28, 368, 
	368, 368, -1, 28, 607, -1, -1, 29, 
	29, 29, 29, 29, 29, 29, 29, 29, 
	29, 29, 29, 29, 29, 29, 29, 607, 
	29, 29, 29, 29, 29, 29, 29, 29, 
	-1, 28, 28, 29, 29, 29, 29, 29, 
	-1, 29, 552, 29, 29, 29, 29, -1, 
	29, -1, 29, 29, 29, -1, -1, 29, 
	-1, 546, 29, 29, 29, 29, 29, 546, 
	29, 29, 29, 546, 546, -1, 636, 29, 
	29, 29, 29, 29, -1, -1, -1, -1, 
	712, 503, 503, 503, 503, -1, -1, -1, 
	-1, 503, 624, -1, -1, -1, 636, 503, 
	624, 503, 503, -1, 624, 624, -1, 27, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 29, 29, -1, -1, -1, 452, 452, 
	452, 452, 452, 452, 452, 452, 452, 452, 
	452, 452, -1, -1, 452, 452, 452, 452, 
	-1, -1, -1, -1, -1, 331, -1, 331, 
	331, 331, 331, 331, 452, 452, 452, -1, 
	-1, -1, 452, -1, 248, 248, -1, 452, 
	-1, -1, -1, -1, -1, 452, 452, -1, 
	-1, -1, -1, -1, 319, 319, 249, 249, 
	369, 369, 369, 452, -1, -1, -1, 29, 
	29, 29, 29, -1, -1, 29, 29, -1, 
	29, 29, 29, -1, 452, -1, -1, 29, 
	29, 29, -1, 29, 29, 29, 29, -1, 
	-1, -1, -1, 29, -1, -1, -1, -1, 
	29, 452, 452, -1, 29, 29, 29, 29, 
	-1, 29, 29, 614, 28, 29, -1, 370, 
	370, 370, -1, -1, -1, 490, -1, 490, 
	-1, 614, 29, 29, 490, 490, -1, -1, 
	-1, -1, -1, 490, 490, -1, -1, 29, 
	29, -1, -1, 503, 503, 503, 503, 503, 
	503, 29, 29, -1, -1, -1, -1, 29, 
	-1, -1, -1, 30, 30, 30, 30, 30, 
	30, 30, 30, 30, 30, 30, 30, 30, 
	30, 30, 30, -1, 30, 30, 30, 30, 
	30, 30, 30, 30, -1, 29, 29, 30, 
	30, 30, 30, 30, -1, 30, -1, 30, 
	30, 30, 30, -1, 30, -1, 30, 30, 
	30, -1, -1, 30, -1, -1, 30, 30, 
	30, 30, 30, -1, 30, 30, 30, -1, 
	-1, -1, -1, 30, 30, 30, 30, 30, 
	-1, -1, 452, 452, -1, 343, 343, 343, 
	343, -1, -1, 452, 452, 343, -1, 452, 
	452, -1, -1, 343, -1, 343, 343, -1, 
	-1, -1, 452, 28, -1, -1, -1, 452, 
	-1, -1, -1, -1, 563, 30, 30, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 490, 490, 559, 559, 559, 559, 559, 
	-1, -1, -1, -1, -1, 452, 452, -1, 
	-1, -1, -1, -1, -1, 250, 250, -1, 
	-1, -1, 559, 559, 559, -1, -1, -1, 
	251, 251, -1, -1, 490, -1, -1, -1, 
	-1, -1, -1, 559, -1, -1, -1, -1, 
	-1, -1, 558, 558, -1, -1, -1, -1, 
	-1, -1, -1, 30, 30, 30, 30, -1, 
	-1, 30, 30, -1, 30, 30, 30, 576, 
	576, 576, -1, 30, 30, 30, -1, 30, 
	30, 30, 30, -1, 621, -1, -1, 30, 
	-1, 621, -1, -1, 30, -1, -1, -1, 
	30, 30, 30, 30, -1, 30, 30, -1, 
	29, 30, 511, 511, 511, 511, -1, -1, 
	542, -1, 511, -1, -1, -1, 30, 30, 
	511, -1, 511, 511, -1, -1, -1, -1, 
	319, -1, -1, 30, 30, 343, -1, 343, 
	343, 343, 343, 343, 343, 30, 30, 215, 
	-1, -1, -1, 30, -1, -1, -1, 31, 
	31, 31, 31, 31, 31, 31, 31, 31, 
	31, 31, 31, 31, 31, 31, 31, -1, 
	31, 31, 31, 31, 31, 31, 31, 31, 
	-1, 30, 30, 31, 31, 31, 31, 31, 
	-1, 31, -1, 31, 31, 31, 31, -1, 
	31, -1, 31, 31, 31, -1, -1, 31, 
	-1, -1, 31, 31, 31, 31, 31, -1, 
	31, 31, 31, -1, -1, -1, -1, 31, 
	31, 31, 31, 31, -1, -1, 215, -1, 
	215, 215, 215, 215, 215, 215, -1, -1, 
	-1, 559, 559, -1, -1, 607, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 29, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	607, 31, 31, -1, -1, -1, 266, 266, 
	266, 266, 266, 266, 266, 266, 266, 266, 
	266, 266, -1, 552, 266, 266, 266, 266, 
	-1, -1, -1, -1, -1, 511, 511, 511, 
	511, 511, -1, -1, 266, 266, 266, -1, 
	-1, -1, 266, -1, -1, -1, -1, 266, 
	-1, -1, -1, -1, -1, 266, 266, -1, 
	-1, -1, 490, 490, -1, -1, -1, -1, 
	-1, -1, -1, 266, -1, -1, -1, 31, 
	31, 31, 31, -1, -1, 31, 31, -1, 
	31, 31, 31, -1, 266, -1, -1, 31, 
	31, 31, -1, 31, 31, 31, 31, -1, 
	-1, 400, -1, 31, -1, -1, -1, -1, 
	31, 266, 266, -1, 31, 31, 31, 31, 
	-1, 31, 31, -1, 30, 31, 331, -1, 
	-1, -1, 400, 400, 400, 400, 400, -1, 
	-1, -1, 31, 31, -1, -1, 507, 507, 
	507, 507, -1, -1, -1, -1, 507, 31, 
	31, 400, 400, 400, 507, -1, 507, 507, 
	-1, 31, 31, -1, -1, -1, -1, 31, 
	-1, -1, 400, 32, 32, 32, 32, 32, 
	32, 32, 32, 32, 32, 32, 32, 32, 
	32, 32, 32, -1, 32, 32, 32, 32, 
	32, 32, 32, 32, -1, 31, 31, 32, 
	32, 32, 32, 32, -1, 32, -1, 32, 
	32, 32, 32, -1, 32, -1, 32, 32, 
	32, -1, -1, 32, -1, -1, 32, 32, 
	32, 32, 32, -1, 32, 32, 32, -1, 
	-1, -1, -1, 32, 32, 32, 32, 32, 
	-1, -1, 266, 266, 503, 503, 503, 503, 
	503, 503, -1, 266, 266, 266, -1, 266, 
	266, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 266, 30, -1, -1, -1, 266, 
	-1, -1, -1, -1, -1, 32, 32, 627, 
	627, 627, 627, 627, 627, 627, 627, 627, 
	627, 627, 627, 627, 627, -1, -1, -1, 
	-1, -1, -1, -1, -1, 266, 266, -1, 
	-1, -1, -1, 400, 400, -1, 400, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	266, 507, 507, 507, 507, 507, -1, 669, 
	-1, 669, 669, 669, 669, -1, 669, -1, 
	-1, -1, 627, -1, -1, -1, -1, -1, 
	-1, -1, -1, 32, 32, 32, 32, -1, 
	-1, 32, 32, -1, 32, 32, 32, -1, 
	400, 400, -1, 32, 32, 32, -1, 32, 
	32, 32, 32, -1, 669, 401, -1, 32, 
	-1, -1, -1, -1, 32, -1, -1, -1, 
	32, 32, 32, 32, -1, 32, 32, -1, 
	31, 32, -1, -1, -1, -1, 401, 401, 
	401, 401, 401, -1, -1, -1, 32, 32, 
	-1, -1, 504, 504, 504, 504, -1, -1, 
	-1, -1, 504, 32, 32, 401, 401, 401, 
	504, -1, 504, 504, -1, 32, 32, -1, 
	-1, -1, -1, 32, -1, -1, 401, 33, 
	33, 33, 33, 33, 33, 33, 33, 33, 
	33, 33, 33, 33, 33, 33, 33, -1, 
	33, 33, 33, 33, 33, 33, 33, 33, 
	-1, 32, 32, 33, 33, 33, 33, 33, 
	-1, 33, -1, 33, 33, 33, 33, -1, 
	33, -1, 33, 33, 33, -1, -1, 33, 
	-1, -1, 33, 33, 33, 33, 33, -1, 
	33, 33, 33, -1, -1, -1, -1, 33, 
	33, 33, 33, 33, -1, -1, 343, -1, 
	343, 343, 343, 343, 343, 343, 669, -1, 
	-1, -1, -1, -1, 669, -1, -1, -1, 
	669, 669, -1, -1, -1, -1, -1, 31, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 33, 33, 676, 676, 676, 676, 676, 
	676, 676, 676, 676, 676, 676, 676, 676, 
	676, 674, 674, 674, 674, 674, 674, 674, 
	674, 674, 674, 674, 674, 674, 674, 401, 
	401, -1, 401, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 504, 504, 504, 504, 
	504, 504, -1, -1, -1, 670, -1, 670, 
	670, 670, 670, -1, 670, -1, 676, -1, 
	-1, -1, 559, 559, -1, -1, -1, 33, 
	33, 33, 33, -1, 674, 33, 33, -1, 
	33, 33, 33, -1, 401, 401, -1, 33, 
	33, 33, -1, 33, 33, 33, 33, -1, 
	-1, 402, 670, 33, -1, -1, -1, -1, 
	33, -1, -1, -1, 33, 33, 33, 33, 
	-1, 33, 33, -1, 32, 33, -1, -1, 
	-1, -1, 402, 402, 402, 402, 402, -1, 
	-1, -1, 33, 33, -1, -1, 505, 505, 
	505, 505, -1, -1, -1, -1, 505, 33, 
	33, 402, 402, 402, 505, -1, 505, 505, 
	-1, 33, 33, -1, -1, -1, -1, 33, 
	-1, -1, 402, 34, 34, 34, 34, 34, 
	34, 34, 34, 34, 34, 34, 34, 34, 
	34, 34, 34, 674, 34, 34, 34, 34, 
	34, 34, 34, 34, -1, 33, 33, 34, 
	34, 34, 34, 34, -1, 34, -1, 34, 
	34, 34, 34, -1, 34, -1, 34, 34, 
	34, -1, -1, 34, -1, -1, 34, 34, 
	34, 34, 34, -1, 34, 34, 34, -1, 
	-1, -1, -1, 34, 34, 34, 34, 34, 
	-1, -1, -1, 506, 506, 506, 506, -1, 
	-1, -1, -1, 506, 670, -1, -1, -1, 
	-1, 506, 670, 506, 506, -1, 670, 670, 
	-1, -1, -1, 32, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 34, 34, 677, 
	677, 677, 677, 677, 677, 677, 677, 677, 
	677, 677, 677, 677, 677, 678, 678, 678, 
	678, 678, 678, 678, 678, 678, 678, 678, 
	678, 678, 678, 402, 402, -1, 402, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	505, 505, 505, 505, 505, 505, -1, -1, 
	-1, 508, 508, 508, 508, -1, -1, -1, 
	-1, 508, 677, -1, -1, -1, 266, 508, 
	-1, 508, 508, 34, 34, 34, 34, -1, 
	678, 34, 34, -1, 34, 34, 34, -1, 
	402, 402, -1, 34, 34, 34, -1, 34, 
	34, 34, 34, -1, 711, 711, 711, 34, 
	711, -1, -1, -1, 34, -1, -1, -1, 
	34, 34, 34, 34, -1, 34, 34, -1, 
	33, 34, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 34, 34, 
	-1, 266, 507, 507, 507, 507, 507, -1, 
	-1, -1, -1, 34, 34, 506, 506, 506, 
	506, 506, 506, 627, -1, 34, 34, -1, 
	-1, -1, -1, 34, -1, -1, -1, 35, 
	35, 35, 35, 35, 35, 35, 35, 35, 
	35, 35, 35, 35, 35, 35, 35, -1, 
	35, 35, 35, 35, 35, 35, 35, 35, 
	-1, 34, 34, 35, 35, 35, 35, 35, 
	-1, 35, -1, 35, 35, 35, 35, -1, 
	35, -1, 35, 35, 35, -1, -1, 35, 
	-1, -1, 35, 35, 35, 35, 35, -1, 
	35, 35, 35, -1, -1, -1, -1, 35, 
	35, 35, 35, 35, 508, 508, 508, 508, 
	508, 497, 497, 497, 497, -1, -1, -1, 
	-1, 497, -1, -1, -1, -1, -1, 497, 
	711, 497, 497, 497, -1, -1, -1, 33, 
	-1, -1, -1, -1, -1, -1, 711, -1, 
	-1, 35, 35, -1, -1, -1, 453, 453, 
	453, 453, 453, 453, 453, 453, 453, 453, 
	453, 453, -1, -1, 453, 453, 453, 453, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 711, 453, 453, 453, -1, 
	-1, -1, 453, -1, -1, -1, -1, 453, 
	-1, -1, -1, -1, -1, 453, 453, 671, 
	-1, 671, 671, 671, 671, -1, 671, -1, 
	-1, -1, 497, 453, -1, -1, -1, 35, 
	35, 35, 35, -1, -1, 35, 35, -1, 
	35, 35, 35, -1, 453, -1, -1, 35, 
	35, 35, -1, 35, 35, 35, 35, -1, 
	-1, -1, -1, 35, 671, -1, -1, -1, 
	35, 453, 453, -1, 35, 35, 35, 35, 
	-1, 35, 35, -1, 34, 35, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 35, 35, -1, 504, 504, 504, 
	504, 504, 504, -1, -1, -1, -1, 35, 
	35, 497, -1, 497, 497, 497, 497, 497, 
	497, 35, 35, -1, -1, -1, -1, 35, 
	-1, -1, -1, 36, 36, 36, 36, 36, 
	36, 36, 36, 36, 36, 36, 36, 36, 
	36, 36, 36, -1, 36, 36, 36, 36, 
	36, 36, 36, 36, -1, 35, 35, 36, 
	36, 36, 36, 36, -1, 36, -1, 36, 
	36, 36, 36, -1, 36, -1, 36, 36, 
	36, -1, -1, 36, -1, -1, 36, 36, 
	36, 36, 36, -1, 36, 36, 36, -1, 
	-1, -1, -1, 36, 36, 36, 36, 36, 
	-1, -1, 453, 453, -1, -1, -1, -1, 
	-1, -1, -1, 453, 453, 453, 671, 453, 
	453, -1, -1, -1, 671, -1, -1, -1, 
	671, 671, 453, 34, -1, -1, -1, 453, 
	-1, -1, -1, -1, 674, 36, 36, 679, 
	679, 679, 679, 679, 679, 679, 679, 679, 
	679, 679, 679, 679, 679, -1, -1, -1, 
	-1, -1, -1, -1, -1, 453, 453, 680, 
	680, 680, 680, 680, 680, 680, 680, 680, 
	680, 680, 680, 680, 680, -1, -1, -1, 
	453, 572, 572, 572, 572, 572, -1, -1, 
	572, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 679, -1, -1, -1, -1, -1, 
	572, 572, 572, 36, 36, 36, 36, -1, 
	-1, 36, 36, -1, 36, 36, 36, -1, 
	-1, 572, 680, 36, 36, 36, -1, 36, 
	36, 36, 36, -1, -1, 675, -1, 36, 
	-1, -1, -1, -1, 36, -1, -1, -1, 
	36, 36, 36, 36, -1, 36, 36, -1, 
	35, 36, -1, -1, -1, -1, 675, 675, 
	675, 675, 675, -1, -1, -1, 36, 36, 
	-1, 505, 505, 505, 505, 505, 505, -1, 
	-1, -1, -1, 36, 36, 675, 675, 675, 
	-1, -1, -1, -1, -1, 36, 36, -1, 
	-1, -1, -1, 36, -1, -1, 675, 37, 
	37, 37, 37, 37, 37, 37, 37, 37, 
	37, 37, 37, 37, 37, 37, 37, -1, 
	37, 37, 37, 37, 37, 37, 37, 37, 
	-1, 36, 36, 37, 37, 37, 37, 37, 
	-1, 37, -1, 37, 37, 37, 37, -1, 
	37, 572, 37, 37, 37, -1, -1, 37, 
	-1, -1, 37, 37, 37, 37, 37, -1, 
	37, 37, 37, -1, -1, -1, -1, 37, 
	37, 37, 37, 37, -1, -1, 506, 506, 
	506, 506, 506, 506, -1, -1, 681, 681, 
	681, 681, 681, 681, 681, 681, 681, 681, 
	681, 681, 681, 681, -1, -1, -1, 35, 
	-1, -1, -1, 699, 699, 699, 699, 699, 
	-1, 37, 37, -1, -1, -1, -1, 572, 
	572, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 699, 699, 699, -1, 619, -1, 
	619, 619, 619, 619, -1, -1, -1, 675, 
	675, 681, 675, 699, 682, 682, 682, 682, 
	682, 682, 682, 682, 682, 682, 682, 682, 
	682, 682, -1, -1, -1, 508, 508, 508, 
	508, 508, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 619, -1, -1, -1, 37, 
	37, 37, 37, -1, -1, 37, 37, -1, 
	37, 37, 37, -1, 675, 675, -1, 37, 
	37, 37, -1, 37, 37, 37, 37, 682, 
	-1, -1, -1, 37, -1, -1, -1, -1, 
	37, -1, -1, -1, 37, 37, 37, 37, 
	-1, 37, 37, -1, 36, 37, -1, -1, 
	-1, -1, -1, -1, 711, -1, -1, -1, 
	-1, -1, 37, 37, 509, 509, 509, 509, 
	-1, -1, -1, -1, 509, -1, -1, 37, 
	37, -1, 509, -1, 509, 509, -1, -1, 
	-1, 37, 37, 497, -1, -1, -1, 37, 
	-1, -1, -1, 38, 38, 38, 38, 38, 
	38, 38, 38, 38, 38, 38, 38, 38, 
	38, 38, 38, -1, 38, 38, 38, 38, 
	38, 38, 38, 38, -1, 37, 37, 38, 
	38, 38, 38, 38, -1, 38, -1, 38, 
	38, 38, 38, -1, 38, -1, 38, 38, 
	38, -1, -1, 38, -1, 619, 38, 38, 
	38, 38, 38, 619, 38, 38, 38, 619, 
	619, 699, 699, 38, 38, 38, 38, 38, 
	-1, -1, 497, -1, 497, 497, 497, 497, 
	497, 497, 683, 683, 683, 683, 683, 683, 
	683, 683, 683, 683, 683, 683, 683, 683, 
	-1, -1, -1, 36, 728, 728, 728, -1, 
	728, -1, -1, -1, -1, 38, 38, 684, 
	684, 684, 684, 684, 684, 684, 684, 684, 
	684, 684, 684, 684, 684, 685, 685, 685, 
	685, 685, 685, 685, 685, 685, 685, 685, 
	685, 685, 685, -1, -1, 683, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 509, 
	509, 509, 509, 509, 686, 686, 686, 686, 
	686, 686, 686, 686, 686, 686, 686, 686, 
	686, 686, 684, -1, -1, -1, 453, -1, 
	-1, -1, -1, 38, 38, 38, 38, -1, 
	685, 38, 38, -1, 38, 38, 38, -1, 
	-1, -1, -1, 38, 38, 38, -1, 38, 
	38, 38, 38, -1, -1, -1, -1, 38, 
	-1, -1, -1, -1, 38, -1, -1, 686, 
	38, 38, 38, 38, -1, 38, 38, -1, 
	37, 38, 510, 510, 510, 510, -1, -1, 
	-1, -1, 510, -1, -1, -1, 38, 38, 
	510, 453, 510, 510, -1, -1, -1, -1, 
	-1, -1, -1, 38, 38, -1, -1, -1, 
	728, -1, -1, -1, -1, 38, 38, -1, 
	-1, -1, -1, 38, -1, -1, 728, 39, 
	39, 39, 39, 39, 39, 39, 39, 39, 
	39, 39, 39, 39, 39, 39, 39, -1, 
	39, 39, 39, 39, 39, 39, 39, 39, 
	-1, 38, 38, 39, 39, 39, 39, 39, 
	-1, 39, -1, 39, 39, 39, 39, -1, 
	39, -1, 39, 39, 39, -1, -1, 39, 
	-1, -1, 39, 39, 39, 39, 39, -1, 
	39, 39, 39, -1, -1, -1, -1, 39, 
	39, 39, 39, 39, -1, -1, -1, -1, 
	592, 592, 592, 592, 592, 592, 592, 592, 
	592, 592, -1, -1, -1, -1, 592, -1, 
	592, 592, 592, 592, 592, 592, 592, 37, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 39, 39, -1, -1, -1, 585, 585, 
	585, 585, 585, 585, 585, 585, 585, 585, 
	585, 585, -1, -1, 585, 585, 585, 585, 
	-1, -1, 572, -1, -1, 510, 510, 510, 
	510, 510, -1, -1, 585, 585, 585, -1, 
	-1, -1, 585, -1, -1, -1, -1, 585, 
	-1, -1, -1, -1, -1, 585, 585, 715, 
	-1, 715, 715, 715, 715, -1, 715, -1, 
	-1, -1, -1, 585, -1, -1, -1, 39, 
	39, 39, 39, -1, -1, 39, 39, -1, 
	39, 39, 39, -1, 585, -1, -1, 39, 
	39, 39, -1, 39, 39, 39, 39, -1, 
	572, 572, -1, 39, 715, -1, -1, -1, 
	39, 585, 585, -1, 39, 39, 39, 39, 
	-1, 39, 39, -1, 38, 39, -1, -1, 
	593, 593, 593, 593, 593, 593, 593, 593, 
	593, 593, 39, 39, -1, -1, 593, -1, 
	593, 593, 593, 593, 593, 593, 593, 39, 
	39, 592, -1, 592, 592, 592, 592, 592, 
	-1, 39, 39, -1, -1, -1, -1, 39, 
	-1, -1, -1, 40, 40, 40, 40, 40, 
	40, 40, 40, 40, 40, 40, 40, 40, 
	40, 40, 40, -1, 40, 40, 40, 40, 
	40, 40, 40, 40, -1, 39, 39, 40, 
	40, 40, 40, 40, -1, 40, -1, 40, 
	40, 40, 40, -1, 40, -1, 40, 40, 
	40, -1, -1, 40, -1, -1, 40, 40, 
	40, 40, 40, -1, 40, 40, 40, -1, 
	-1, -1, -1, 40, 40, 40, 40, 40, 
	-1, -1, 585, 585, -1, -1, -1, -1, 
	-1, -1, -1, 585, 585, 585, 715, 585, 
	585, -1, -1, -1, 715, -1, -1, -1, 
	715, 715, 585, 38, -1, -1, -1, 585, 
	-1, -1, -1, -1, -1, 40, 40, -1, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, -1, -1, 
	-1, -1, -1, -1, -1, 585, 585, -1, 
	-1, 593, -1, 593, 593, 593, 593, 593, 
	-1, -1, -1, -1, 619, -1, -1, -1, 
	585, 619, 699, 699, -1, -1, -1, 672, 
	-1, 672, 672, 672, 672, -1, 672, -1, 
	-1, -1, 672, 687, -1, -1, -1, -1, 
	-1, 672, 672, 40, 40, 40, 40, 672, 
	-1, 40, 40, -1, 40, 40, 40, -1, 
	672, -1, -1, 40, 40, 40, -1, 40, 
	40, 40, 40, -1, 672, 243, -1, 40, 
	-1, -1, -1, -1, 40, -1, -1, -1, 
	40, 40, 40, 40, -1, 40, 40, -1, 
	39, 40, -1, -1, -1, -1, 243, 243, 
	243, 243, 243, -1, -1, -1, 40, 40, 
	509, 509, 509, 509, 509, -1, -1, -1, 
	-1, -1, -1, 40, 40, 243, 243, 243, 
	-1, -1, -1, -1, -1, 40, 40, -1, 
	-1, -1, -1, 40, -1, -1, 243, 41, 
	41, 41, 41, 41, 41, 41, 41, 41, 
	41, 41, 41, 41, 41, 41, 41, -1, 
	41, 41, 41, 41, 41, 41, 41, 41, 
	-1, 40, 40, 41, 41, 41, 41, 41, 
	-1, 41, -1, 41, 41, 41, 41, -1, 
	41, -1, 41, 41, 41, -1, -1, 41, 
	-1, -1, 41, 41, 41, 41, 41, -1, 
	41, 41, 41, -1, -1, -1, -1, 41, 
	41, 41, 41, 41, -1, -1, -1, -1, 
	-1, 728, -1, -1, -1, -1, 672, 672, 
	-1, -1, -1, -1, 672, -1, -1, 728, 
	672, 672, -1, -1, -1, -1, -1, 39, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 41, 41, 139, 139, 139, 139, 139, 
	139, 139, -1, 139, 139, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 139, 139, 
	139, 139, 139, -1, -1, -1, -1, 243, 
	243, -1, 243, -1, -1, 139, -1, -1, 
	-1, 139, -1, -1, -1, 139, 139, 139, 
	139, 139, 139, -1, -1, -1, -1, 139, 
	139, 139, -1, -1, -1, -1, 139, 139, 
	-1, 139, 139, 139, 139, -1, -1, 41, 
	41, 41, 41, -1, 139, 41, 41, -1, 
	41, 41, 41, -1, 243, 243, -1, 41, 
	41, 41, -1, 41, 41, 41, 41, -1, 
	-1, -1, -1, 41, -1, -1, -1, -1, 
	41, -1, -1, -1, 41, 41, 41, 41, 
	-1, 41, 41, -1, 40, 41, 510, 510, 
	510, 510, 510, -1, -1, -1, -1, -1, 
	-1, -1, 41, 41, -1, -1, 716, -1, 
	716, 716, 716, 716, -1, 716, -1, 41, 
	41, -1, -1, -1, -1, -1, -1, -1, 
	-1, 41, 41, -1, -1, -1, -1, 41, 
	-1, -1, -1, 42, 42, 42, 42, 42, 
	42, 42, 42, 42, 42, 42, 42, 42, 
	42, 42, 42, 716, 42, 42, 42, 42, 
	42, 42, 42, 42, -1, 41, 41, 42, 
	42, 42, 42, 42, -1, 42, -1, 42, 
	42, 42, 42, -1, 42, -1, 42, 42, 
	42, -1, -1, 42, -1, -1, 42, 42, 
	42, 42, 42, -1, 42, 42, 42, -1, 
	-1, -1, -1, 42, 42, 42, 42, 42, 
	-1, -1, 592, 688, 688, 688, 688, 688, 
	688, 688, 688, 688, 688, 688, 688, 688, 
	688, -1, -1, 139, 139, 139, -1, -1, 
	-1, -1, 139, 40, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 42, 42, 733, 
	733, 733, 733, 733, 733, 733, 733, 733, 
	733, 733, 733, 733, 733, 139, 139, 139, 
	139, 139, -1, -1, -1, -1, 688, 717, 
	717, 717, 717, 717, 717, 717, 717, 717, 
	717, 717, 717, 717, 717, -1, -1, 689, 
	689, 689, 689, 689, 689, 689, 689, 689, 
	689, 689, 689, 689, 689, 716, -1, -1, 
	-1, -1, 733, 716, -1, -1, 585, 716, 
	716, -1, -1, 42, 42, 42, 42, -1, 
	-1, 42, 42, -1, 42, 42, 42, -1, 
	-1, -1, 717, 42, 42, 42, -1, 42, 
	42, 42, 42, -1, -1, -1, -1, 42, 
	-1, -1, 689, -1, 42, -1, -1, -1, 
	42, 42, 42, 42, -1, 42, 42, -1, 
	41, 42, 593, -1, 594, 594, 594, 594, 
	594, 594, 594, 594, 594, 594, 42, 42, 
	-1, 585, 594, -1, 594, 594, 594, 594, 
	594, 594, 594, 42, 42, -1, -1, -1, 
	-1, -1, -1, -1, -1, 42, 42, -1, 
	-1, -1, -1, 42, -1, -1, -1, 48, 
	48, 48, 48, 48, 48, 48, 48, 48, 
	48, 48, 48, 48, 48, 48, 48, -1, 
	48, 48, 48, 48, 48, 48, 48, 48, 
	-1, 42, 42, 48, 48, 48, 48, 48, 
	-1, 48, -1, 48, 48, 48, 48, -1, 
	48, 689, 48, 48, 48, -1, -1, 48, 
	-1, -1, 48, 48, 48, 48, 48, -1, 
	48, 48, 48, -1, -1, -1, -1, 48, 
	48, 48, 48, 48, -1, -1, -1, 332, 
	595, 595, 595, 595, 595, 595, 595, 595, 
	595, 595, -1, -1, -1, -1, 595, -1, 
	595, 595, 595, 595, 595, 595, 595, 41, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 48, 48, 332, 332, 332, 332, 332, 
	332, 332, 332, 332, 332, 332, 332, 332, 
	332, 332, -1, 332, 332, 332, 332, 332, 
	332, 332, -1, -1, -1, 594, -1, 594, 
	594, 594, 594, 594, -1, 718, 718, 718, 
	718, 718, 718, 718, 718, 718, 718, 718, 
	718, 718, 718, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	672, -1, -1, -1, -1, -1, -1, 48, 
	48, 48, 48, -1, -1, 48, 48, -1, 
	48, 48, 48, -1, -1, -1, -1, 48, 
	48, 48, -1, 48, 48, 48, 48, -1, 
	718, -1, -1, 48, -1, -1, -1, -1, 
	48, -1, -1, -1, 48, 48, 48, 48, 
	-1, 48, 48, -1, 42, 48, -1, -1, 
	243, 243, -1, 243, -1, -1, -1, -1, 
	-1, -1, 48, 48, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 48, 
	48, 595, -1, 595, 595, 595, 595, 595, 
	-1, 48, 48, -1, -1, -1, -1, 48, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 243, 243, -1, 
	-1, -1, -1, -1, 332, -1, 332, 332, 
	332, 332, 332, -1, -1, 48, 48, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 48, -1, 53, 53, 53, 53, 53, 
	53, 53, 53, 53, 53, 53, 53, 53, 
	53, 53, 53, 53, 53, 53, 53, 53, 
	53, 53, 53, 53, 53, 53, -1, 53, 
	53, 53, 53, 53, -1, 53, -1, 53, 
	53, 53, 53, -1, 53, -1, 53, 53, 
	53, -1, -1, 53, 53, 53, 53, 53, 
	53, 53, 53, 42, 53, 53, 53, -1, 
	-1, -1, -1, 53, 53, 53, 53, 53, 
	-1, -1, -1, 333, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	53, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 53, 53, 333, 
	333, 333, 333, 333, 333, 333, 333, 333, 
	333, 333, 333, 333, 333, 333, -1, 333, 
	333, 333, 333, 333, 333, 333, -1, -1, 
	-1, -1, -1, -1, 139, 139, 139, -1, 
	-1, -1, -1, 139, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 139, 139, 
	139, 139, -1, 53, 53, 53, 53, -1, 
	-1, 53, 53, -1, 53, 53, 53, -1, 
	-1, -1, -1, 53, 53, 53, -1, 53, 
	53, 53, 53, -1, -1, -1, -1, 53, 
	-1, -1, -1, -1, 53, -1, -1, -1, 
	53, 53, 53, 53, -1, 53, 53, -1, 
	-1, 53, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 53, 53, 53, 53, 53, 
	53, 53, 53, 717, -1, -1, -1, 53, 
	53, -1, -1, 53, 53, -1, -1, -1, 
	-1, -1, -1, -1, -1, 53, 53, -1, 
	-1, -1, -1, 53, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	333, -1, 333, 333, 333, 333, 333, -1, 
	-1, 53, 53, -1, -1, 54, 54, 54, 
	54, 54, 54, 54, 54, 54, 54, 54, 
	54, 54, 54, 54, 54, 54, 54, 54, 
	54, 54, 54, 54, 54, 54, 54, 54, 
	-1, 54, 54, 54, 54, 54, -1, 54, 
	-1, 54, 54, 54, 54, -1, 54, -1, 
	54, 54, 54, -1, -1, 54, 54, 54, 
	54, 54, 54, 54, 54, -1, 54, 54, 
	54, -1, 689, -1, -1, 54, 54, 54, 
	54, 54, -1, -1, 56, 56, 56, 56, 
	56, 56, 56, -1, 56, 56, -1, -1, 
	-1, -1, 54, -1, -1, 54, -1, 56, 
	56, 56, 56, 56, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 56, 54, 
	54, -1, 56, -1, -1, -1, 56, 56, 
	56, 56, 56, 56, -1, -1, -1, -1, 
	56, 56, 56, -1, -1, -1, -1, 56, 
	56, -1, 56, 56, 56, 56, -1, -1, 
	-1, 732, -1, -1, -1, 56, -1, -1, 
	-1, -1, -1, -1, -1, -1, 594, -1, 
	-1, -1, -1, 56, 56, 56, 56, 56, 
	-1, -1, 732, 732, 732, 732, 732, -1, 
	-1, -1, -1, -1, -1, 54, 54, 54, 
	54, -1, -1, 54, 54, -1, 54, 54, 
	54, 732, 732, 732, 53, 54, 54, 54, 
	-1, 54, 54, 54, 54, -1, -1, -1, 
	-1, 54, 732, -1, -1, -1, 54, -1, 
	-1, -1, 54, 54, 54, 54, -1, 54, 
	54, 718, -1, 54, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 54, 54, 54, 
	54, 54, 54, 54, 54, -1, -1, -1, 
	-1, 54, 54, -1, 54, 54, 54, -1, 
	-1, -1, -1, -1, -1, -1, -1, 54, 
	54, -1, -1, -1, -1, 54, -1, -1, 
	-1, -1, 595, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 54, 54, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 56, 56, 
	56, 56, 56, -1, 56, 56, 56, -1, 
	-1, -1, 48, 56, 58, 58, 58, 58, 
	58, 58, 58, 53, 58, 58, -1, -1, 
	-1, -1, -1, 732, 732, -1, 732, 58, 
	58, 58, 58, 58, -1, -1, 56, 56, 
	56, 56, 56, -1, -1, -1, 58, -1, 
	-1, -1, 58, -1, -1, -1, 58, 58, 
	58, 58, 58, 58, -1, -1, -1, -1, 
	58, 58, 58, -1, -1, -1, -1, 58, 
	58, -1, 58, 58, 58, 58, -1, -1, 
	732, 732, -1, -1, -1, 58, -1, -1, 
	61, 61, 61, 61, 61, 61, 61, -1, 
	61, 61, -1, 58, 58, 58, 58, 58, 
	-1, -1, -1, 61, 61, 61, 61, 61, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 61, -1, -1, -1, 61, -1, 
	-1, -1, 61, 61, 61, 61, 61, 61, 
	-1, -1, -1, -1, 61, 61, 61, -1, 
	335, -1, -1, 61, 61, -1, 61, 61, 
	61, 61, -1, -1, -1, -1, -1, -1, 
	-1, 61, -1, -1, -1, -1, -1, 336, 
	-1, -1, -1, -1, -1, -1, 54, 61, 
	61, 61, 61, 61, 335, 335, 335, 335, 
	335, 335, 335, 335, 335, 335, 335, 335, 
	335, 335, 335, -1, 335, 335, 335, 335, 
	335, 335, 335, 336, 336, 336, 336, 336, 
	336, 336, 336, 336, 336, 336, 336, 336, 
	336, 336, 336, 336, 336, 336, 336, 336, 
	336, 336, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 58, 58, 
	58, 58, 58, -1, 58, 58, 58, -1, 
	-1, -1, -1, 58, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 58, 58, 
	58, 58, 58, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 54, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 61, 61, 61, 61, 61, -1, 
	61, 61, 61, -1, -1, -1, -1, 61, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 335, -1, 335, 
	335, 335, 335, 335, -1, -1, -1, -1, 
	-1, -1, 61, 61, 61, 61, 61, -1, 
	-1, -1, -1, -1, 336, -1, 336, 336, 
	336, 336, 336, -1, -1, -1, -1, -1, 
	-1, -1, 131, -1, 131, 131, 131, 131, 
	131, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 131, -1, -1, 
	-1, -1, -1, -1, -1, -1, 131, 131, 
	131, 131, 131, -1, 131, -1, 131, -1, 
	-1, -1, -1, 131, -1, -1, 131, 131, 
	-1, -1, -1, -1, -1, 131, 131, 131, 
	-1, -1, -1, 131, 131, 131, -1, -1, 
	-1, -1, 131, 131, 131, 131, 131, 62, 
	62, 62, 62, 62, 62, 62, 62, 62, 
	62, 62, 62, 62, 62, 62, 62, 62, 
	62, 62, 62, 62, 62, 62, 62, 62, 
	62, 62, -1, 62, 62, 62, 62, 62, 
	-1, 62, -1, 62, 62, 62, 62, -1, 
	62, -1, 62, 62, 62, -1, -1, 62, 
	62, 62, 62, 62, 62, 62, 62, -1, 
	62, 62, 62, -1, -1, -1, -1, 62, 
	62, 62, 62, 62, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 62, -1, -1, -1, 
	-1, -1, -1, -1, -1, 54, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, 62, 131, 131, 131, -1, -1, 
	131, 131, -1, -1, 131, 131, -1, -1, 
	-1, -1, 131, 131, 131, -1, 131, 131, 
	131, 131, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 131, 131, -1, -1, 131, 
	-1, 131, 131, -1, 131, 131, -1, -1, 
	131, -1, -1, -1, -1, -1, -1, 56, 
	56, 56, 56, 56, -1, 56, 56, 56, 
	-1, -1, -1, -1, 56, -1, -1, 62, 
	62, 62, 62, -1, -1, 62, 62, -1, 
	62, 62, 62, -1, 131, 131, -1, 62, 
	62, 62, -1, 62, 62, 62, 62, 56, 
	56, 56, 56, 62, -1, -1, -1, -1, 
	62, -1, -1, -1, 62, 62, 62, 62, 
	-1, 62, 62, -1, -1, 62, -1, -1, 
	-1, -1, -1, -1, 337, -1, -1, 62, 
	62, 62, 62, 62, 62, 62, 62, -1, 
	-1, 131, -1, 62, 62, -1, -1, 62, 
	62, -1, -1, -1, -1, -1, -1, -1, 
	-1, 62, 62, 338, -1, -1, -1, 62, 
	337, 337, 337, 337, 337, 337, 337, 337, 
	337, 337, 337, 337, 337, 337, 337, -1, 
	337, 337, 337, 337, 337, 337, 337, -1, 
	-1, -1, 339, -1, -1, 62, 62, 338, 
	338, 338, 338, 338, 338, 338, 338, 338, 
	338, 338, 338, 338, 338, 338, 338, 338, 
	338, 338, 338, 338, 338, 338, -1, -1, 
	-1, -1, -1, -1, -1, -1, 339, 339, 
	339, 339, 339, 339, 339, 339, 339, 339, 
	339, 339, 339, 339, 339, 339, 339, 339, 
	339, 339, 339, 339, 339, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 58, 
	58, 58, 58, 58, -1, 58, 58, 58, 
	-1, -1, -1, -1, 58, -1, -1, -1, 
	-1, -1, -1, 673, -1, 673, 673, 673, 
	673, 337, 673, 337, 337, 337, 337, 337, 
	-1, -1, -1, -1, -1, 673, 673, 58, 
	58, 58, 58, 673, -1, -1, -1, -1, 
	-1, -1, -1, -1, 673, -1, -1, -1, 
	338, -1, 338, 338, 338, 338, 338, -1, 
	673, -1, -1, -1, -1, -1, -1, -1, 
	62, -1, -1, 61, 61, 61, 61, 61, 
	-1, 61, 61, 61, -1, -1, -1, 339, 
	61, 339, 339, 339, 339, 339, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 61, 61, 61, 61, 63, 
	63, 63, 63, 63, 63, 63, 63, 63, 
	63, 63, 63, 63, 63, 63, 63, 63, 
	63, 63, 63, 63, 63, 63, 63, 63, 
	63, 63, -1, 63, 63, 63, 63, 63, 
	-1, 63, -1, 63, 63, 63, 63, -1, 
	63, -1, 63, 63, 63, -1, -1, 63, 
	63, 63, 63, 63, 63, 63, 63, -1, 
	63, 63, 63, -1, -1, -1, -1, 63, 
	63, 63, 63, 63, -1, -1, -1, 344, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 63, -1, -1, -1, 
	-1, -1, 673, 673, -1, -1, -1, 62, 
	673, -1, -1, -1, 673, 673, -1, -1, 
	-1, 63, 63, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, 344, 
	344, 344, 344, 344, 344, 344, 344, 344, 
	344, 344, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 63, 
	63, 63, 63, -1, -1, 63, 63, -1, 
	63, 63, 63, -1, -1, -1, -1, 63, 
	63, 63, -1, 63, 63, 63, 63, -1, 
	-1, -1, -1, 63, -1, -1, -1, -1, 
	63, -1, -1, -1, 63, 63, 63, 63, 
	-1, 63, 63, -1, -1, 63, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 63, 
	63, 63, 63, 63, 63, 63, 63, -1, 
	-1, -1, -1, 63, 63, -1, -1, 63, 
	63, -1, -1, -1, -1, -1, -1, -1, 
	-1, 63, 63, -1, -1, -1, -1, 63, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 344, -1, 344, 344, 
	344, 344, 344, -1, -1, 63, 63, -1, 
	-1, 64, 64, 64, 64, 64, 64, 64, 
	64, 64, 64, 64, 64, 64, 64, 64, 
	64, 64, 64, 64, 64, 64, 64, 64, 
	64, 64, 64, 64, -1, 64, 64, 64, 
	64, 64, 131, 64, -1, 64, 64, 64, 
	64, -1, 64, -1, 64, 64, 64, -1, 
	-1, 64, 64, 64, 64, 64, 64, 64, 
	64, -1, 64, 64, 64, -1, -1, -1, 
	-1, 64, 64, 64, 64, 64, -1, -1, 
	-1, 499, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 64, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 64, 64, 499, 499, 499, 
	499, 499, 499, 499, 499, 499, 499, 499, 
	499, 499, 499, 499, -1, 499, 499, 499, 
	499, 499, 499, 499, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 64, 64, 64, 64, -1, -1, 64, 
	64, -1, 64, 64, 64, -1, -1, -1, 
	63, 64, 64, 64, -1, 64, 64, 64, 
	64, -1, -1, -1, -1, 64, -1, -1, 
	-1, -1, 64, -1, -1, -1, 64, 64, 
	64, 64, -1, 64, 64, -1, -1, 64, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 64, 64, 64, 64, 64, 64, 64, 
	64, -1, -1, -1, -1, 64, 64, -1, 
	-1, 64, 64, -1, -1, -1, -1, -1, 
	-1, -1, -1, 64, 64, -1, -1, -1, 
	-1, 64, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 499, -1, 
	499, 499, 499, 499, 499, -1, -1, 64, 
	64, -1, -1, -1, 107, 107, 107, 107, 
	107, 107, 107, 107, 107, 107, 107, 107, 
	107, 107, 107, 107, -1, 107, 107, 107, 
	107, 107, 107, 107, 107, -1, -1, -1, 
	107, 107, 107, 107, 107, -1, 107, 63, 
	107, 107, 107, 107, -1, 107, -1, 107, 
	107, 107, -1, -1, 107, -1, -1, 107, 
	107, 107, 107, 107, -1, 107, 107, 107, 
	-1, -1, -1, -1, 107, 107, 107, 107, 
	107, -1, 112, 112, 112, 112, 112, 112, 
	112, -1, 112, 112, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 112, 112, 112, 
	112, 112, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 112, -1, 107, 107, 
	112, -1, -1, -1, 112, 112, 112, 112, 
	112, 112, -1, -1, 673, -1, 112, 112, 
	112, -1, -1, -1, -1, 112, 112, -1, 
	112, 112, 112, 112, -1, -1, -1, -1, 
	-1, -1, -1, 112, 112, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 112, 112, 112, 112, 112, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 107, 107, 107, 107, 
	-1, -1, 107, 107, -1, 107, 107, 107, 
	-1, -1, 64, -1, 107, 107, 107, -1, 
	107, 107, 107, 107, -1, -1, -1, -1, 
	107, -1, -1, -1, -1, 107, -1, -1, 
	-1, 107, 107, 107, 107, -1, 107, 107, 
	-1, -1, 107, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 107, 
	107, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 107, 107, -1, -1, 
	-1, -1, -1, -1, -1, -1, 107, 107, 
	-1, -1, -1, -1, 107, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 107, 107, -1, -1, -1, -1, 
	-1, 112, 112, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 112, 112, 112, 112, 
	112, -1, 112, 112, 112, -1, -1, -1, 
	-1, 112, -1, -1, -1, -1, -1, -1, 
	-1, 64, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 112, 112, 112, 112, 
	112, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, -1, 113, 113, 113, 
	113, 113, -1, 113, -1, 113, 113, 113, 
	113, -1, 113, -1, 113, 113, 113, -1, 
	-1, 113, 113, 113, 113, 113, 113, 113, 
	113, -1, 113, 113, 113, -1, -1, -1, 
	-1, 113, 113, 113, 113, 113, -1, -1, 
	119, 119, 119, 119, 119, 119, 119, -1, 
	119, 119, -1, -1, -1, -1, 113, -1, 
	-1, -1, -1, 119, 119, 119, 119, 119, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 119, 113, 113, -1, 119, -1, 
	-1, -1, 119, 119, 119, 119, 119, 119, 
	-1, -1, -1, -1, 119, 119, 119, -1, 
	-1, -1, -1, 119, 119, -1, 119, 119, 
	119, 119, 119, -1, -1, -1, -1, -1, 
	-1, 119, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 119, 
	119, 119, 119, 119, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 113, 113, 113, 113, -1, -1, 113, 
	113, -1, 113, 113, 113, -1, -1, -1, 
	-1, 113, 113, 113, -1, 113, 113, 113, 
	113, -1, -1, -1, -1, 113, -1, -1, 
	-1, -1, 113, -1, -1, -1, 113, 113, 
	113, 113, -1, 113, 113, -1, -1, 113, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 113, 113, 113, 113, 113, 113, 113, 
	113, -1, -1, -1, -1, 113, 113, -1, 
	-1, 113, 113, -1, -1, -1, -1, -1, 
	-1, -1, -1, 113, 113, -1, -1, -1, 
	-1, 113, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 113, 
	113, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 119, 119, 119, 119, 119, -1, 
	119, 119, 119, 512, -1, -1, -1, 119, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 119, 119, -1, -1, -1, -1, 
	-1, -1, -1, 119, -1, 513, -1, -1, 
	-1, -1, 119, 119, 119, 119, 119, 512, 
	512, 512, 512, 512, 512, 512, 512, 512, 
	512, 512, 512, 512, 512, 512, -1, 512, 
	512, 512, 512, 512, 512, 512, 514, 119, 
	-1, 513, 513, 513, 513, 513, 513, 513, 
	513, 513, 513, 513, 513, 513, 513, 513, 
	-1, 513, 513, 513, 513, 513, 513, 513, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 514, 514, 514, 514, 514, 514, 
	514, 514, 514, 514, 514, 514, 514, 514, 
	514, -1, 514, 514, 514, 514, 514, 514, 
	514, -1, -1, -1, -1, 107, 107, 107, 
	107, -1, -1, 107, 107, -1, 107, 107, 
	107, -1, -1, -1, -1, 107, 107, 107, 
	-1, 107, 107, 107, 107, -1, -1, -1, 
	-1, 107, -1, -1, -1, -1, 107, -1, 
	-1, -1, 107, 107, 107, 107, -1, 107, 
	107, -1, 113, 107, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	107, 107, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 107, 107, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	107, -1, -1, -1, -1, 107, -1, -1, 
	512, -1, 512, 512, 512, 512, 512, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 513, 107, 513, 513, 513, 513, 
	513, -1, 112, 112, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 112, 112, 112, 
	112, 112, -1, 112, 112, 112, -1, -1, 
	-1, -1, 112, 514, -1, 514, 514, 514, 
	514, 514, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 112, 112, 112, 
	112, -1, -1, -1, -1, -1, -1, -1, 
	-1, 113, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, -1, 114, 114, 
	114, 114, 114, -1, 114, -1, 114, 114, 
	114, 114, -1, 114, -1, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, -1, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, -1, 114, 
	-1, -1, 114, -1, 114, 114, 114, 114, 
	114, -1, -1, 114, 114, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, 114, 114, 
	114, 114, 114, -1, 114, 114, -1, -1, 
	-1, -1, -1, 114, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 114, 114, 114, 114, -1, -1, 
	114, 114, 114, 114, 114, 114, -1, -1, 
	-1, -1, 114, 114, 114, 114, 114, 114, 
	114, 114, -1, -1, -1, -1, 114, -1, 
	-1, -1, -1, 114, 114, -1, -1, 114, 
	114, 114, 114, -1, 114, 114, -1, -1, 
	114, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 114, 114, 114, 114, 114, 114, 
	114, 114, -1, -1, -1, 114, 114, 114, 
	-1, -1, 114, 114, -1, 114, 114, 114, 
	114, 114, 114, 114, 114, 114, -1, -1, 
	-1, 114, 114, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 114, 114, -1, 
	-1, 114, -1, -1, -1, -1, 114, -1, 
	-1, -1, -1, 114, -1, 114, 114, 114, 
	114, 114, -1, -1, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, -1, 
	115, 115, 115, 115, 115, -1, 115, -1, 
	115, 115, 115, 115, -1, 115, -1, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	-1, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	119, 115, -1, -1, 115, -1, 115, 115, 
	115, 115, 115, -1, -1, 115, 115, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	115, 115, 115, 115, 115, 515, 115, 115, 
	-1, -1, -1, -1, -1, 115, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 515, 515, 515, 515, 515, 515, 515, 
	515, 515, 515, 515, 515, 515, 515, 515, 
	-1, 515, 515, 515, 515, 515, 515, 515, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 115, 115, 115, 115, 
	-1, -1, 115, 115, 115, 115, 115, 115, 
	-1, -1, -1, 114, 115, 115, 115, 115, 
	115, 115, 115, 115, -1, -1, -1, -1, 
	115, -1, -1, -1, -1, 115, 115, -1, 
	-1, 115, 115, 115, 115, -1, 115, 115, 
	-1, -1, 115, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 115, 115, 115, 115, 
	115, 115, 115, 115, -1, -1, -1, 115, 
	115, 115, -1, -1, 115, 115, -1, 115, 
	115, 115, 115, 115, 115, 115, 115, 115, 
	-1, -1, -1, 115, 115, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 115, 
	115, -1, -1, 115, -1, -1, -1, -1, 
	115, -1, 115, 115, -1, 115, -1, 115, 
	115, 115, 115, 115, 134, 134, 134, 134, 
	134, 134, 134, 134, 134, -1, 134, 134, 
	-1, -1, 134, 134, 134, 134, -1, -1, 
	-1, -1, 515, -1, 515, 515, 515, 515, 
	515, -1, 134, 134, 134, -1, -1, -1, 
	134, -1, 114, -1, -1, 134, -1, -1, 
	-1, -1, -1, 134, 134, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 134, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 134, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 134, 134, -1, 134, 
	134, -1, -1, -1, -1, -1, -1, 135, 
	135, 135, 135, 135, 135, 135, 135, 135, 
	135, 135, 135, 135, 135, 135, 135, 135, 
	135, 135, 135, 135, 135, 135, 135, 135, 
	135, 135, -1, 135, 135, 135, 135, 135, 
	-1, 135, -1, 135, 135, 135, 135, -1, 
	135, -1, 135, 135, 135, -1, 135, 135, 
	135, 135, 135, 135, 135, 135, 135, 135, 
	135, 135, 135, -1, 135, 135, 135, 135, 
	135, 135, 135, 135, 135, 135, 135, 135, 
	135, 135, 135, -1, -1, -1, -1, -1, 
	-1, 135, 135, 135, 135, 115, -1, -1, 
	135, 135, 135, 135, 135, 135, 135, 135, 
	135, 135, 135, 135, -1, -1, 135, 135, 
	-1, 135, 135, -1, -1, -1, -1, -1, 
	135, -1, -1, -1, -1, -1, -1, -1, 
	134, 134, -1, -1, -1, -1, -1, -1, 
	134, -1, -1, -1, -1, 134, 134, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	134, -1, -1, -1, -1, 134, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 135, 
	135, 135, 135, 134, 134, 135, 135, 135, 
	135, 135, 135, -1, -1, -1, -1, 135, 
	135, 135, 135, 135, 135, 135, 135, -1, 
	-1, -1, -1, 135, -1, -1, -1, -1, 
	135, 135, -1, -1, 135, 135, 135, 135, 
	-1, 135, 135, -1, -1, 135, -1, -1, 
	-1, -1, -1, -1, 115, -1, -1, 135, 
	135, 135, 135, 135, 135, 135, 135, -1, 
	-1, -1, 135, 135, 135, -1, -1, 135, 
	135, -1, 135, 135, 135, 135, 135, -1, 
	135, 135, 135, -1, -1, -1, 135, 135, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 135, 135, -1, -1, 135, -1, 
	-1, -1, -1, 135, -1, -1, -1, -1, 
	135, -1, 135, 135, 135, 135, 135, -1, 
	-1, -1, -1, -1, 136, 136, 136, 136, 
	136, 136, 136, 136, 136, 136, 136, 136, 
	136, 136, 136, 136, 136, 136, 136, 136, 
	136, 136, 136, 136, 136, 136, 136, -1, 
	136, 136, 136, 136, 136, -1, 136, -1, 
	136, 136, 136, 136, -1, 136, -1, 136, 
	136, 136, -1, 136, 136, 136, 136, 136, 
	136, 136, 136, 136, 136, 136, 136, 136, 
	-1, 136, 136, 136, 136, 136, 136, 136, 
	136, 136, 136, 136, 136, 136, 136, 136, 
	-1, -1, -1, -1, -1, -1, 136, 136, 
	136, 136, 587, -1, -1, 136, 136, 136, 
	136, 136, 136, 136, 136, 136, 136, 136, 
	136, 136, 136, 136, 136, -1, 136, 136, 
	-1, 588, -1, -1, -1, 136, -1, -1, 
	-1, -1, -1, -1, -1, -1, 587, 587, 
	587, 587, 587, 587, 587, 587, 587, 587, 
	587, 587, 587, 587, 587, -1, 587, 587, 
	587, 587, 587, 587, 587, 588, 588, 588, 
	588, 588, 588, 588, 588, 588, 588, 588, 
	588, 588, 588, 588, -1, 588, 588, 588, 
	588, 588, 588, 588, -1, -1, -1, -1, 
	-1, -1, -1, -1, 136, 136, 136, 136, 
	-1, -1, 136, 136, 136, 136, 136, 136, 
	135, -1, -1, -1, 136, 136, 136, 136, 
	136, 136, 136, 136, -1, -1, -1, -1, 
	136, -1, -1, 115, 115, 136, 136, -1, 
	-1, 136, 136, 136, 136, -1, 136, 136, 
	-1, -1, 136, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 136, 136, 136, 136, 
	136, 136, 136, 136, -1, -1, -1, 136, 
	136, 136, -1, -1, 136, 136, -1, 136, 
	136, 136, 136, 136, -1, 136, 136, 136, 
	-1, -1, -1, 136, 136, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 136, 
	136, -1, -1, 136, -1, -1, -1, -1, 
	136, -1, -1, -1, -1, 136, -1, 136, 
	136, 136, 136, 136, -1, -1, -1, 587, 
	-1, 587, 587, 587, 587, 587, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 588, -1, 
	588, 588, 588, 588, 588, -1, -1, 135, 
	-1, -1, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, -1, 137, 137, 
	137, 137, 137, -1, 137, -1, 137, 137, 
	137, 137, -1, 137, -1, 137, 137, 137, 
	-1, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, -1, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, -1, 137, 
	-1, -1, -1, -1, 137, 137, 137, 137, 
	137, -1, -1, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, -1, 137, 137, -1, -1, 
	-1, 134, 134, 137, -1, -1, -1, -1, 
	-1, 134, -1, -1, -1, -1, 134, 134, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 134, -1, -1, -1, -1, 134, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 136, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 134, -1, -1, -1, 
	-1, -1, 137, 137, 137, 137, -1, -1, 
	137, 137, 137, 137, 137, 137, -1, -1, 
	-1, -1, 137, 137, 137, 137, 137, 137, 
	137, 137, -1, -1, -1, -1, 137, -1, 
	-1, -1, -1, 137, 137, -1, -1, 137, 
	137, 137, 137, -1, 137, 137, -1, -1, 
	137, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 137, 137, 137, 137, 137, 137, 
	137, 137, -1, -1, -1, 137, 137, 137, 
	-1, -1, 137, 137, -1, 137, 137, 137, 
	137, 137, -1, 137, 137, 137, -1, -1, 
	-1, 137, 137, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 137, 137, -1, 
	-1, 137, -1, -1, -1, -1, 137, -1, 
	-1, -1, -1, 137, -1, 137, 137, 137, 
	137, 137, -1, -1, 136, 138, 138, 138, 
	138, 138, 138, 138, 138, 138, 138, 138, 
	138, 138, 138, 138, 138, 138, 138, 138, 
	138, 138, 138, 138, 138, 138, 138, 138, 
	-1, 138, 138, 138, 138, 138, -1, 138, 
	-1, 138, 138, 138, 138, -1, 138, -1, 
	138, 138, 138, -1, 138, 138, 138, 138, 
	138, 138, 138, 138, 138, 138, 138, 138, 
	138, -1, 138, 138, 138, 138, 138, 138, 
	138, 138, 138, 138, 138, 138, 138, 138, 
	138, -1, 138, -1, -1, -1, -1, 138, 
	138, 138, 138, 138, -1, -1, 138, 138, 
	138, 138, 138, 138, 138, 138, 138, 138, 
	138, 138, 138, 138, 138, 138, -1, 138, 
	138, 591, -1, -1, -1, -1, 138, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 591, 591, 591, 
	591, 591, 591, 591, 591, 591, 591, 591, 
	591, 591, 591, 591, -1, 591, 591, 591, 
	591, 591, 591, 591, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 138, 138, 
	138, -1, -1, 138, 138, 138, 138, 138, 
	138, -1, -1, 137, -1, 138, 138, 138, 
	138, 138, 138, 138, 138, -1, -1, -1, 
	-1, 138, -1, -1, -1, -1, 138, 138, 
	-1, -1, 138, 138, 138, 138, -1, 138, 
	138, -1, -1, 138, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 138, 138, 138, 
	138, 138, 138, 138, 138, -1, -1, -1, 
	138, 138, 138, -1, -1, 138, 138, -1, 
	138, 138, 138, 138, 138, -1, 138, 138, 
	138, -1, -1, -1, 138, 138, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	138, 138, -1, -1, 138, -1, -1, -1, 
	-1, 138, -1, -1, -1, -1, 138, -1, 
	138, 138, 138, 138, 138, 140, 140, 140, 
	140, 140, 140, 140, -1, 140, 140, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	140, 140, 140, 140, 140, -1, 591, -1, 
	591, 591, 591, 591, 591, -1, -1, 140, 
	-1, -1, 137, 140, -1, -1, -1, 140, 
	140, 140, 140, 140, 140, -1, -1, -1, 
	-1, 140, 140, 140, -1, -1, -1, -1, 
	140, 140, -1, 140, 140, 140, 140, -1, 
	-1, -1, -1, -1, -1, -1, 140, 141, 
	141, 141, 141, 141, 141, 141, -1, 141, 
	141, -1, -1, -1, -1, 140, -1, -1, 
	-1, -1, 141, 141, 141, 141, 141, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 141, -1, -1, -1, 141, -1, -1, 
	-1, 141, 141, 141, 141, 141, 141, -1, 
	-1, -1, -1, 141, 141, 141, -1, -1, 
	-1, -1, 141, 141, -1, 141, 141, 141, 
	141, -1, -1, -1, -1, -1, -1, -1, 
	141, -1, -1, -1, -1, 142, 142, 142, 
	142, 142, 142, 142, -1, 142, 142, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	142, 142, 142, 142, 142, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 142, 
	-1, -1, -1, 142, -1, -1, 138, 142, 
	142, 142, 142, 142, 142, -1, -1, -1, 
	-1, 142, 142, 142, -1, -1, -1, -1, 
	142, 142, -1, 142, 142, 142, 142, -1, 
	-1, -1, -1, -1, -1, -1, 142, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 140, 140, 140, 
	-1, -1, -1, -1, 140, -1, -1, -1, 
	-1, -1, 596, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 140, 
	140, 140, 140, 140, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 596, 596, 
	596, 596, 596, 596, 596, 596, 596, 596, 
	596, 596, 596, 596, 596, -1, 596, 596, 
	596, 596, 596, 596, 596, -1, -1, 141, 
	141, 141, -1, -1, -1, -1, 141, -1, 
	-1, -1, -1, -1, -1, 138, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 141, 141, 141, 141, 141, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 142, 142, 142, 
	-1, -1, -1, -1, 142, 143, 143, 143, 
	143, 143, 143, 143, -1, 143, 143, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 143, 143, 143, 143, -1, -1, 142, 
	142, 142, 142, 142, -1, -1, -1, 143, 
	-1, -1, -1, 143, -1, -1, 597, 143, 
	143, 143, 143, 143, 143, -1, -1, -1, 
	-1, 143, 143, 143, -1, -1, -1, -1, 
	143, 143, -1, 143, 143, 143, 143, 596, 
	-1, 596, 596, 596, 596, 596, 143, -1, 
	-1, -1, 597, 597, 597, 597, 597, 597, 
	597, 597, 597, 597, 597, 597, 597, 597, 
	597, -1, 597, 597, 597, 597, 597, 597, 
	597, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 144, 144, 144, 144, 
	144, 144, 144, 144, 144, 144, 144, 144, 
	144, 144, 144, 144, 144, 144, 144, 144, 
	144, 144, 144, 144, 144, 144, 144, -1, 
	144, 144, 144, 144, 144, -1, 144, -1, 
	144, 144, 144, 144, -1, 144, -1, 144, 
	144, 144, -1, 144, 144, 144, 144, 144, 
	144, 144, 144, 144, 144, 144, 144, 144, 
	-1, 144, 144, 144, 144, 144, 144, 144, 
	144, 144, 144, 144, 144, 144, 144, 144, 
	-1, 144, -1, -1, -1, -1, 144, 144, 
	144, 144, 144, -1, -1, 144, 144, 144, 
	144, 144, 144, 144, 144, 144, 144, 144, 
	144, 144, 144, 144, 144, -1, 144, 144, 
	-1, -1, -1, -1, -1, 144, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 143, 143, 143, 
	-1, -1, -1, 597, 143, 597, 597, 597, 
	597, 597, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 143, 
	143, 143, 143, 143, 144, 144, 144, 144, 
	-1, -1, 144, 144, 144, 144, 144, 144, 
	-1, -1, -1, -1, 144, 144, 144, 144, 
	144, 144, 144, 144, -1, -1, -1, -1, 
	144, -1, -1, -1, -1, 144, 144, -1, 
	-1, 144, 144, 144, 144, -1, 144, 144, 
	-1, -1, 144, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 144, 144, 144, 144, 
	144, 144, 144, 144, -1, -1, -1, 144, 
	144, 144, -1, -1, 144, 144, -1, 144, 
	144, 144, 144, 144, -1, 144, 144, 144, 
	598, -1, -1, 144, 144, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 144, 
	144, -1, -1, 144, -1, -1, -1, 599, 
	144, -1, -1, -1, -1, 144, -1, 144, 
	144, 144, 144, 144, 598, 598, 598, 598, 
	598, 598, 598, 598, 598, 598, 598, 598, 
	598, 598, 598, -1, 598, 598, 598, 598, 
	598, 598, 598, 599, 599, 599, 599, 599, 
	599, 599, 599, 599, 599, 599, 599, 599, 
	599, 599, -1, 599, 599, 599, 599, 599, 
	599, 599, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 140, 140, 
	140, 602, -1, -1, -1, 140, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	140, 140, 140, 140, -1, 602, 602, 602, 
	602, 602, 602, 602, 602, 602, 602, 602, 
	602, 602, 602, 602, -1, 602, 602, 602, 
	602, 602, 602, 602, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	141, 141, 141, -1, -1, -1, -1, 141, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 141, 141, 141, 141, -1, -1, 
	-1, -1, -1, -1, -1, 598, -1, 598, 
	598, 598, 598, 598, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 144, -1, -1, 
	-1, -1, -1, -1, 599, -1, 599, 599, 
	599, 599, 599, -1, -1, -1, 142, 142, 
	142, -1, -1, -1, -1, 142, -1, -1, 
	-1, -1, -1, 172, 172, 172, 172, 172, 
	172, 172, 172, 172, -1, 172, 172, -1, 
	-1, 172, 172, 172, 172, -1, -1, -1, 
	142, 142, 142, 142, -1, -1, -1, -1, 
	-1, 172, 172, 172, -1, -1, -1, 172, 
	-1, -1, -1, -1, 172, -1, -1, -1, 
	-1, -1, 172, 172, -1, -1, 602, -1, 
	602, 602, 602, 602, 602, -1, -1, -1, 
	172, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	172, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 172, 172, -1, 172, 172, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 144, 145, 145, 145, 
	145, 145, 145, 145, 145, 145, 145, 145, 
	145, 145, 145, 145, 145, 145, 145, 145, 
	145, 145, 145, 145, 145, 145, 145, 145, 
	-1, 145, 145, 145, 145, 145, -1, 145, 
	-1, 145, 145, 145, 145, -1, 145, -1, 
	145, 145, 145, -1, 145, 145, 145, 145, 
	145, 145, 145, 145, 145, 145, 145, 145, 
	145, -1, 145, 145, 145, 145, 145, 145, 
	145, 145, 145, 145, 145, 145, 145, 145, 
	145, -1, 145, -1, -1, -1, -1, 145, 
	145, 145, 145, 145, -1, -1, 145, 145, 
	145, 145, 145, 145, 145, 145, 145, 145, 
	145, 145, 145, 145, 145, 145, -1, 145, 
	145, -1, -1, -1, -1, -1, 145, 172, 
	172, -1, -1, -1, -1, -1, -1, 172, 
	-1, -1, -1, -1, 172, 172, 143, 143, 
	143, -1, -1, -1, -1, 143, -1, 172, 
	-1, -1, -1, -1, 172, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	143, 143, 143, 143, -1, -1, -1, -1, 
	-1, -1, 172, 172, -1, 145, 145, 145, 
	145, -1, -1, 145, 145, 145, 145, 145, 
	145, -1, -1, -1, -1, 145, 145, 145, 
	145, 145, 145, 145, 145, -1, -1, -1, 
	-1, 145, -1, -1, -1, -1, 145, 145, 
	-1, -1, 145, 145, 145, 145, -1, 145, 
	145, -1, -1, 145, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 145, 145, 145, 
	145, 145, 145, 145, 145, -1, -1, -1, 
	145, 145, 145, -1, -1, 145, 145, -1, 
	145, 145, 145, 145, 145, -1, 145, 145, 
	145, -1, -1, -1, 145, 145, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	145, 145, -1, -1, 145, -1, -1, -1, 
	-1, 145, -1, -1, -1, -1, 145, -1, 
	145, 145, 145, 145, 145, -1, -1, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	146, 146, -1, 146, 146, 146, 146, 146, 
	-1, 146, -1, 146, 146, 146, 146, -1, 
	146, -1, 146, 146, 146, -1, 146, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	146, 146, 146, -1, 146, 146, 146, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	146, 146, 146, -1, 146, -1, -1, -1, 
	-1, 146, 146, 146, 146, 146, -1, -1, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	146, 146, 146, 146, 146, 146, 146, 146, 
	-1, 146, 146, -1, -1, -1, -1, -1, 
	146, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 146, 
	146, 146, 146, -1, -1, 146, 146, 146, 
	146, 146, 146, -1, -1, -1, 145, 146, 
	146, 146, 146, 146, 146, 146, 146, -1, 
	-1, -1, -1, 146, -1, -1, -1, -1, 
	146, 146, -1, -1, 146, 146, 146, 146, 
	-1, 146, 146, -1, -1, 146, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 146, 
	146, 146, 146, 146, 146, 146, 146, -1, 
	-1, -1, 146, 146, 146, -1, -1, 146, 
	146, -1, 146, 146, 146, 146, 146, -1, 
	146, 146, 146, -1, -1, -1, 146, 146, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 146, 146, -1, -1, 146, -1, 
	-1, -1, -1, 146, -1, -1, -1, -1, 
	146, -1, 146, 146, 146, 146, 146, -1, 
	-1, -1, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, -1, 147, 147, 
	147, 147, 147, -1, 147, 145, 147, 147, 
	147, 147, -1, 147, -1, 147, 147, 147, 
	-1, 147, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, 147, -1, 147, 
	147, 147, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, 147, -1, 147, 
	-1, -1, -1, -1, 147, 147, 147, 147, 
	147, -1, -1, 147, 147, 147, 147, 147, 
	147, 147, 147, 147, 147, 147, 147, 147, 
	147, 147, 147, -1, 147, 147, -1, -1, 
	-1, -1, -1, 147, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	172, 172, -1, -1, -1, -1, -1, -1, 
	172, -1, -1, -1, -1, 172, 172, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	172, -1, -1, -1, -1, 172, -1, -1, 
	-1, -1, 147, 147, 147, 147, -1, -1, 
	147, 147, 147, 147, 147, 147, -1, -1, 
	146, -1, 147, 147, 147, 147, 147, 147, 
	147, 147, -1, 172, -1, -1, 147, -1, 
	-1, -1, -1, 147, 147, -1, -1, 147, 
	147, 147, 147, -1, 147, 147, -1, -1, 
	147, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 147, 147, 147, 147, 147, 147, 
	147, 147, -1, -1, -1, 147, 147, 147, 
	-1, -1, 147, 147, -1, 147, 147, 147, 
	147, 147, -1, 147, 147, 147, -1, -1, 
	-1, 147, 147, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 147, 147, -1, 
	-1, 147, -1, -1, -1, -1, 147, -1, 
	-1, -1, -1, 147, -1, 147, 147, 147, 
	147, 147, -1, -1, 148, 148, 148, 148, 
	148, 148, 148, 148, 148, 148, 148, 148, 
	148, 148, 148, 148, 148, 148, 148, 148, 
	148, 148, 148, 148, 148, 148, 148, -1, 
	148, 148, 148, 148, 148, -1, 148, 146, 
	148, 148, 148, 148, -1, 148, -1, 148, 
	148, 148, -1, 148, 148, 148, 148, 148, 
	148, 148, 148, 148, 148, 148, 148, 148, 
	-1, 148, 148, 148, 148, 148, 148, 148, 
	148, 148, 148, 148, 148, 148, 148, 148, 
	-1, 148, -1, -1, -1, -1, 148, 148, 
	148, 148, 148, -1, -1, 148, 148, 148, 
	148, 148, 148, 148, 148, 148, 148, 148, 
	148, 148, 148, 148, 148, -1, 148, 148, 
	-1, -1, -1, -1, -1, 148, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 148, 148, 148, 148, 
	-1, -1, 148, 148, 148, 148, 148, 148, 
	-1, -1, -1, 147, 148, 148, 148, 148, 
	148, 148, 148, 148, -1, -1, -1, -1, 
	148, -1, -1, -1, -1, 148, 148, -1, 
	-1, 148, 148, 148, 148, -1, 148, 148, 
	-1, -1, 148, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 148, 148, 148, 148, 
	148, 148, 148, 148, -1, -1, -1, 148, 
	148, 148, -1, -1, 148, 148, -1, 148, 
	148, 148, 148, 148, -1, 148, 148, 148, 
	-1, -1, -1, 148, 148, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 148, 
	148, -1, -1, 148, -1, -1, -1, -1, 
	148, -1, -1, -1, -1, 148, -1, 148, 
	148, 148, 148, 148, -1, -1, -1, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, -1, 149, 149, 149, 149, 149, 
	-1, 149, 147, 149, 149, 149, 149, -1, 
	149, -1, 149, 149, 149, -1, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, -1, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, -1, 149, -1, -1, -1, 
	-1, 149, 149, 149, 149, 149, -1, -1, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	-1, 149, 149, 603, -1, -1, -1, -1, 
	149, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 603, 
	603, 603, 603, 603, 603, 603, 603, 603, 
	603, 603, 603, 603, 603, 603, -1, 603, 
	603, 603, 603, 603, 603, 603, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 149, 
	149, 149, 149, -1, -1, 149, 149, 149, 
	149, 149, 149, -1, -1, 148, -1, 149, 
	149, 149, 149, 149, 149, 149, 149, -1, 
	-1, -1, -1, 149, -1, -1, -1, -1, 
	149, 149, -1, -1, 149, 149, 149, 149, 
	-1, 149, 149, -1, -1, 149, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 149, 
	149, 149, 149, 149, 149, 149, 149, -1, 
	-1, -1, 149, 149, 149, -1, -1, 149, 
	149, -1, 149, 149, 149, 149, 149, -1, 
	149, 149, 149, -1, -1, -1, 149, 149, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 149, 149, -1, -1, 149, -1, 
	-1, -1, -1, 149, -1, -1, -1, -1, 
	149, -1, 149, 149, 149, 149, 149, 150, 
	150, 150, 150, 150, 150, 150, -1, 150, 
	150, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 150, 150, 150, 150, 150, -1, 
	603, -1, 603, 603, 603, 603, 603, -1, 
	-1, 150, -1, -1, 148, 150, -1, -1, 
	-1, 150, 150, 150, 150, 150, 150, -1, 
	-1, -1, -1, 150, 150, 150, -1, -1, 
	-1, -1, 150, 150, -1, 150, 150, 150, 
	150, -1, -1, -1, -1, -1, -1, -1, 
	150, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 150, 150, 
	150, 150, 150, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, -1, 151, 151, 151, 151, 151, 
	-1, 151, -1, 151, 151, 151, 151, -1, 
	151, -1, 151, 151, 151, -1, 151, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, 151, -1, 151, 151, 151, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, 151, -1, 151, -1, -1, -1, 
	149, 151, 151, 151, 151, 151, -1, -1, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	151, 151, 151, 151, 151, 151, 151, 151, 
	-1, 151, 151, -1, -1, -1, -1, -1, 
	151, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 150, 150, 150, 150, 150, -1, 150, 
	150, 150, -1, -1, -1, -1, 150, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 150, 150, 150, 150, 150, -1, 151, 
	151, 151, 151, -1, -1, 151, 151, 151, 
	151, 151, 151, -1, -1, -1, -1, 151, 
	151, 151, 151, 151, 151, 151, 151, -1, 
	-1, -1, -1, 151, -1, -1, -1, -1, 
	151, 151, -1, -1, 151, 151, 151, 151, 
	-1, 151, 151, -1, -1, 151, -1, 149, 
	-1, -1, -1, -1, -1, -1, -1, 151, 
	151, 151, 151, 151, 151, 151, 151, -1, 
	-1, -1, 151, 151, 151, -1, -1, 151, 
	151, -1, 151, 151, 151, 151, 151, -1, 
	151, 151, 151, -1, -1, -1, 151, 151, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 151, 151, -1, -1, 151, -1, 
	-1, -1, -1, 151, -1, -1, -1, -1, 
	151, -1, 151, 151, 151, 151, 151, -1, 
	-1, 155, 155, 155, 155, 155, 155, 155, 
	155, 155, 155, 155, 155, 155, 155, 155, 
	155, 155, 155, 155, 155, 155, 155, 155, 
	155, 155, 155, 155, -1, 155, 155, 155, 
	155, 155, -1, 155, -1, 155, 155, 155, 
	155, -1, 155, -1, 155, 155, 155, -1, 
	155, 155, 155, 155, 155, 155, 155, 155, 
	155, 155, 155, 155, 155, -1, 155, 155, 
	155, 155, 155, 155, 155, 155, 155, 155, 
	155, 155, 155, 155, 155, -1, 155, -1, 
	-1, -1, -1, 155, 155, 155, 155, 155, 
	604, -1, 155, 155, 155, 155, 155, 155, 
	155, 155, 155, 155, 155, 155, 155, 155, 
	155, 155, -1, 155, 155, -1, -1, 605, 
	-1, -1, 155, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 604, 604, 604, 604, 
	604, 604, 604, 604, 604, 604, 604, 604, 
	604, 604, 604, 604, 604, 604, 604, 604, 
	604, 604, 604, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, -1, -1, -1, -1, -1, -1, 
	-1, 155, 155, 155, 155, -1, -1, 155, 
	155, 155, 155, 155, 155, -1, -1, -1, 
	151, 155, 155, 155, 155, 155, 155, 155, 
	155, -1, -1, -1, -1, 155, -1, -1, 
	-1, -1, 155, 155, -1, -1, 155, 155, 
	155, 155, -1, 155, 155, -1, -1, 155, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 155, 155, 155, 155, 155, 155, 155, 
	155, -1, -1, -1, 155, 155, 155, -1, 
	-1, 155, 155, -1, 155, 155, 155, 155, 
	155, -1, 155, 155, 155, -1, -1, -1, 
	155, 155, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 155, 155, -1, -1, 
	155, -1, -1, -1, -1, 155, -1, -1, 
	-1, -1, 155, -1, 155, 155, 155, 155, 
	155, -1, -1, -1, -1, 604, -1, 604, 
	604, 604, 604, 604, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 605, -1, 605, 605, 
	605, 605, 605, -1, -1, -1, -1, 151, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	157, 157, 157, -1, 157, 157, 157, 157, 
	157, -1, 157, -1, 157, 157, 157, 157, 
	-1, 157, -1, 157, 157, 157, -1, 157, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	157, 157, 157, 157, -1, 157, 157, 157, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	157, 157, 157, 157, -1, 157, -1, -1, 
	-1, -1, 157, 157, 157, 157, 157, -1, 
	-1, 157, 157, 157, 157, 157, 157, 157, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	157, -1, 157, 157, -1, -1, -1, -1, 
	-1, 157, -1, -1, -1, -1, -1, -1, 
	-1, -1, 150, 150, 150, 150, 150, -1, 
	150, 150, 150, -1, -1, -1, -1, 150, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 155, -1, -1, -1, -1, -1, 
	-1, -1, 150, 150, 150, 150, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	157, 157, 157, 157, -1, -1, 157, 157, 
	157, 157, 157, 157, -1, -1, -1, -1, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, 157, 157, -1, -1, 157, 157, 157, 
	157, -1, 157, 157, -1, -1, 157, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	157, 157, 157, 157, 157, 157, 157, 157, 
	-1, -1, -1, 157, 157, 157, -1, -1, 
	157, 157, -1, 157, 157, 157, 157, 157, 
	-1, 157, 157, 157, -1, -1, -1, 157, 
	157, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 157, 157, -1, -1, 157, 
	-1, -1, -1, -1, 157, -1, -1, -1, 
	-1, 157, -1, 157, 157, 157, 157, 157, 
	-1, 155, 158, 158, 158, 158, 158, 158, 
	158, -1, 158, 158, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 158, 158, 158, 
	158, 158, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 158, -1, -1, -1, 
	158, -1, -1, -1, 158, 158, 158, 158, 
	158, 158, -1, -1, -1, -1, 158, 158, 
	158, -1, -1, 653, -1, 158, 158, -1, 
	158, 158, 158, 158, 158, -1, -1, -1, 
	-1, -1, -1, 158, -1, -1, -1, -1, 
	-1, -1, -1, 706, -1, -1, -1, -1, 
	-1, 158, 158, 158, 158, 158, -1, 653, 
	653, 653, 653, 653, 653, 653, 653, 653, 
	653, 653, 653, 653, 653, 653, 707, 653, 
	653, 653, 653, 653, 653, 653, -1, 706, 
	706, 706, 706, 706, 706, 706, 706, 706, 
	706, 706, 706, 706, 706, 706, -1, 706, 
	706, 706, 706, 706, 706, 706, -1, -1, 
	-1, -1, 707, 707, 707, 707, 707, 707, 
	707, 707, 707, 707, 707, 707, 707, 707, 
	707, -1, 707, 707, 707, 707, 707, 707, 
	707, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 157, -1, 643, 643, 643, 643, 643, 
	643, 643, 643, 643, 643, 643, 643, -1, 
	-1, 643, 643, 643, 643, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 643, 643, 643, -1, -1, -1, 643, 
	-1, -1, -1, -1, 643, -1, -1, -1, 
	-1, -1, 643, 643, 158, 158, 158, 158, 
	158, -1, 158, 158, 158, -1, -1, -1, 
	643, 158, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 158, 158, -1, -1, 
	653, 643, 653, 653, 653, 653, 653, -1, 
	-1, -1, 158, -1, 158, 158, 158, 158, 
	158, -1, -1, -1, -1, -1, 643, 643, 
	706, -1, 706, 706, 706, 706, 706, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 158, -1, -1, -1, -1, 
	-1, -1, -1, 707, -1, 707, 707, 707, 
	707, 707, -1, -1, -1, -1, -1, -1, 
	157, 159, 159, 159, 159, 159, 159, 159, 
	159, 159, 159, 159, 159, 159, 159, 159, 
	159, 159, 159, 159, 159, 159, 159, 159, 
	159, 159, 159, 159, 159, 159, 159, 159, 
	159, 159, -1, 159, -1, 159, 159, 159, 
	159, 159, 159, -1, 159, 159, 159, -1, 
	-1, 159, 159, 159, 159, 159, 159, 159, 
	159, -1, 159, 159, 159, 159, -1, -1, 
	-1, 159, 159, 159, 159, 159, -1, -1, 
	159, 159, 159, 159, -1, -1, -1, 159, 
	-1, -1, -1, 159, 159, -1, 159, 643, 
	643, 159, -1, -1, 159, -1, 159, -1, 
	643, 643, 643, -1, 643, 643, -1, -1, 
	-1, -1, -1, 159, 159, -1, -1, 643, 
	-1, -1, -1, -1, 643, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 159, -1, -1, -1, -1, 
	-1, -1, 643, 643, -1, 159, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 643, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 159, 159, 159, 159, -1, -1, 159, 
	159, 159, 159, 159, 159, -1, -1, -1, 
	-1, 159, 159, 159, 159, 159, 159, 159, 
	159, -1, -1, 159, -1, 159, -1, -1, 
	-1, -1, 159, 159, -1, 159, 159, 159, 
	159, 159, -1, 159, 159, -1, -1, 159, 
	-1, -1, -1, -1, -1, -1, 159, -1, 
	159, 159, 159, 159, 159, 159, 159, 159, 
	159, -1, -1, -1, -1, 159, 159, -1, 
	159, 159, 159, -1, -1, -1, -1, -1, 
	-1, -1, -1, 159, 159, -1, -1, 159, 
	-1, 159, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 159, 159, 159, -1, -1, 159, 
	159, 159, -1, -1, -1, -1, -1, 159, 
	159, -1, -1, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, -1, 160, -1, 160, 
	160, 160, 160, 160, 160, -1, 160, 160, 
	160, -1, -1, 160, 160, 160, 160, 160, 
	160, 160, 160, -1, 160, 160, 160, 160, 
	-1, -1, -1, 160, 160, 160, 160, 160, 
	-1, -1, 160, 160, 160, 160, -1, -1, 
	-1, 160, -1, -1, -1, 160, 160, -1, 
	160, -1, -1, 160, -1, -1, 160, -1, 
	160, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 160, 160, -1, 
	-1, -1, -1, -1, 726, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 160, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 160, 
	726, 726, 726, 726, 726, 726, 726, 726, 
	726, 726, 726, 726, 726, 726, 726, -1, 
	726, 726, 726, 726, 726, 726, 726, -1, 
	-1, -1, -1, 160, 160, 160, 160, -1, 
	-1, 160, 160, 160, 160, 160, 160, -1, 
	-1, -1, 159, 160, 160, 160, 160, 160, 
	160, 160, 160, -1, -1, 160, -1, 160, 
	-1, -1, -1, -1, 160, 160, -1, 160, 
	160, 160, 160, 160, -1, 160, 160, -1, 
	-1, 160, -1, -1, -1, -1, -1, -1, 
	160, -1, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, -1, -1, -1, -1, 160, 
	160, -1, 160, 160, 160, -1, -1, -1, 
	-1, -1, -1, -1, -1, 160, 160, -1, 
	-1, 160, -1, 160, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 160, 160, 160, -1, 
	-1, 160, 160, 160, -1, -1, -1, -1, 
	-1, 160, 160, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 158, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 726, -1, 726, 726, 726, 726, 726, 
	-1, 159, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, -1, 161, -1, 161, 161, 
	161, 161, 161, 161, -1, 161, 161, 161, 
	-1, -1, 161, 161, 161, 161, 161, 161, 
	161, 161, -1, 161, 161, 161, 161, -1, 
	-1, -1, 161, 161, 161, 161, 161, -1, 
	-1, 161, 161, 161, 161, -1, -1, -1, 
	161, -1, -1, -1, 161, 161, -1, 161, 
	-1, -1, 161, 643, -1, 161, -1, 161, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 161, 161, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 161, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 161, -1, 
	-1, -1, -1, -1, 160, -1, 643, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 161, 161, 161, 161, -1, -1, 
	161, 161, 161, 161, 161, 161, -1, -1, 
	-1, -1, 161, 161, 161, 161, 161, 161, 
	161, 161, -1, -1, 161, -1, 161, -1, 
	-1, -1, -1, 161, 161, -1, 161, 161, 
	161, 161, 161, -1, 161, 161, -1, -1, 
	161, -1, -1, -1, -1, -1, -1, 161, 
	-1, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, -1, -1, -1, -1, 161, 161, 
	-1, 161, 161, 161, -1, -1, -1, -1, 
	-1, -1, -1, -1, 161, 161, -1, -1, 
	161, -1, 161, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 161, 161, 161, -1, -1, 
	161, 161, 161, -1, -1, -1, -1, -1, 
	161, 161, -1, 160, 167, 167, 167, 167, 
	167, 167, 167, 167, 167, 167, 167, 167, 
	167, 167, 167, 167, 167, 167, 167, 167, 
	167, 167, 167, 167, 167, 167, 167, -1, 
	167, 167, 167, 167, 167, -1, 167, -1, 
	167, 167, 167, 167, -1, 167, -1, 167, 
	167, 167, -1, 167, 167, 167, 167, 167, 
	167, 167, 167, 167, 167, 167, 167, 167, 
	-1, 167, 167, 167, 167, 167, 167, 167, 
	167, 167, 167, 167, 167, 167, 167, 167, 
	-1, 167, -1, -1, -1, -1, 167, 167, 
	167, 167, 167, -1, -1, 167, 167, 167, 
	167, 167, 167, 167, 167, 167, 167, 167, 
	167, 167, 167, 167, 167, -1, 167, 167, 
	-1, -1, -1, -1, -1, 167, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 167, 167, 167, 167, 
	-1, -1, 167, 167, 167, 167, 167, 167, 
	-1, -1, -1, 161, 167, 167, 167, 167, 
	167, 167, 167, 167, -1, -1, -1, -1, 
	167, -1, -1, -1, -1, 167, 167, -1, 
	-1, 167, 167, 167, 167, -1, 167, 167, 
	-1, -1, 167, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 167, 167, 167, 167, 
	167, 167, 167, 167, -1, -1, -1, 167, 
	167, 167, -1, -1, 167, 167, -1, 167, 
	167, 167, 167, 167, -1, 167, 167, 167, 
	-1, -1, -1, 167, 167, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 167, 
	167, -1, -1, 167, -1, -1, -1, -1, 
	167, -1, -1, -1, -1, 167, -1, 167, 
	167, 167, 167, 167, -1, -1, -1, 171, 
	171, 171, 171, 171, 171, 171, 171, 171, 
	171, 171, 171, 171, 171, 171, 171, 171, 
	171, 171, 171, 171, 171, 171, 171, 171, 
	171, 171, -1, 171, 171, 171, 171, 171, 
	-1, 171, 161, 171, 171, 171, 171, -1, 
	171, -1, 171, 171, 171, -1, -1, 171, 
	171, 171, 171, 171, 171, 171, 171, -1, 
	171, 171, 171, -1, -1, -1, -1, 171, 
	171, 171, 171, 171, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 171, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 171, 171, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 171, 
	171, 171, 171, -1, -1, 171, 171, -1, 
	171, 171, 171, -1, -1, 167, -1, 171, 
	171, 171, -1, 171, 171, 171, 171, -1, 
	-1, -1, -1, 171, -1, -1, -1, -1, 
	171, -1, -1, -1, 171, 171, 171, 171, 
	-1, 171, 171, -1, -1, 171, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 171, 
	171, 171, 171, 171, 171, 171, 171, -1, 
	-1, -1, -1, 171, 171, -1, -1, 171, 
	171, -1, -1, -1, -1, -1, -1, -1, 
	-1, 171, 171, -1, -1, -1, -1, 171, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 171, 171, -1, 
	-1, 174, 174, 174, 174, 174, 174, 174, 
	174, 174, 174, 174, 174, 174, 174, 174, 
	174, -1, 174, 174, 174, 174, 174, 174, 
	174, 174, -1, -1, -1, 174, 174, 174, 
	174, 174, -1, 174, 167, 174, 174, 174, 
	174, -1, 174, -1, 174, 174, 174, -1, 
	-1, 174, -1, -1, 174, 174, 174, 174, 
	174, -1, 174, 174, 174, -1, -1, -1, 
	-1, 174, 174, 174, 174, 174, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 174, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 174, 174, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 174, 174, 174, 174, -1, -1, 174, 
	174, 174, 174, 174, 174, -1, -1, -1, 
	171, 174, 174, 174, 174, 174, 174, 174, 
	174, -1, -1, -1, -1, 174, -1, -1, 
	-1, -1, 174, -1, -1, -1, 174, 174, 
	174, 174, -1, 174, 174, -1, -1, 174, 
	181, 181, 181, 181, 181, 181, 181, -1, 
	181, 181, -1, -1, 174, 174, -1, -1, 
	-1, -1, -1, 181, 181, 181, 181, 181, 
	174, 174, 174, -1, -1, -1, -1, -1, 
	-1, -1, 181, 174, 174, -1, 181, -1, 
	-1, 174, 181, 181, 181, 181, 181, 181, 
	-1, -1, -1, -1, 181, 181, 181, -1, 
	-1, -1, -1, 181, 181, -1, 181, 181, 
	181, 181, -1, -1, -1, -1, -1, 174, 
	174, 181, 181, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 181, 
	181, 181, 181, 181, -1, -1, -1, -1, 
	167, 167, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 171, 
	175, 175, 175, 175, 175, 175, 175, 175, 
	175, 175, 175, 175, 175, 175, 175, 175, 
	175, 175, 175, 175, 175, 175, 175, 175, 
	175, 175, 175, -1, 175, 175, 175, 175, 
	175, -1, 175, -1, 175, 175, 175, 175, 
	-1, 175, -1, 175, 175, 175, -1, -1, 
	175, 175, 175, 175, 175, 175, 175, 175, 
	-1, 175, 175, 175, -1, -1, -1, -1, 
	175, 175, 175, 175, 175, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 175, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 175, 
	175, -1, 175, 175, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 181, 
	181, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 181, 181, 181, 181, 181, -1, 
	181, 181, 181, -1, -1, -1, -1, 181, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 174, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 181, 181, 181, 181, 181, -1, 
	175, 175, 175, 175, -1, -1, 175, 175, 
	-1, 175, 175, 175, -1, -1, -1, -1, 
	175, 175, 175, -1, 175, 175, 175, 175, 
	-1, -1, -1, -1, 175, -1, -1, -1, 
	-1, 175, -1, -1, -1, 175, 175, 175, 
	175, -1, 175, 175, -1, -1, 175, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	175, 175, 175, 175, 175, 175, 175, 175, 
	-1, -1, -1, -1, 175, 175, -1, -1, 
	175, 175, -1, -1, -1, -1, -1, -1, 
	-1, -1, 175, 175, -1, -1, -1, -1, 
	175, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 175, 175, 
	-1, 174, 179, 179, 179, 179, 179, 179, 
	179, 179, 179, 179, 179, 179, 179, 179, 
	179, 179, -1, 179, 179, 179, 179, 179, 
	179, 179, 179, -1, -1, -1, 179, 179, 
	179, 179, 179, -1, 179, -1, 179, 179, 
	179, 179, -1, 179, -1, 179, 179, 179, 
	-1, -1, 179, -1, -1, 179, 179, 179, 
	179, 179, -1, 179, 179, 179, -1, -1, 
	-1, -1, 179, 179, 179, 179, 179, -1, 
	182, 182, 182, 182, 182, 182, 182, -1, 
	182, 182, -1, -1, -1, -1, -1, -1, 
	-1, -1, 179, 182, 182, 182, 182, 182, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 182, -1, 179, 179, 182, -1, 
	-1, -1, 182, 182, 182, 182, 182, 182, 
	-1, -1, -1, -1, 182, 182, 182, -1, 
	-1, -1, -1, 182, 182, -1, 182, 182, 
	182, 182, -1, -1, -1, -1, -1, -1, 
	-1, 182, 182, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 182, 
	182, 182, 182, 182, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 179, 179, 179, 179, -1, -1, 
	179, 179, -1, 179, 179, 179, -1, -1, 
	-1, 175, 179, 179, 179, -1, 179, 179, 
	179, 179, -1, -1, -1, -1, 179, -1, 
	-1, -1, -1, 179, 179, -1, -1, 179, 
	179, 179, 179, -1, 179, 179, -1, -1, 
	179, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 179, 179, -1, 
	-1, 174, -1, -1, -1, -1, -1, -1, 
	-1, 179, 179, 179, -1, -1, -1, -1, 
	-1, -1, -1, -1, 179, 179, -1, -1, 
	-1, -1, 179, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	179, 179, -1, -1, -1, -1, -1, 182, 
	182, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 182, 182, 182, 182, 182, -1, 
	182, 182, 182, -1, -1, -1, -1, 182, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	175, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 182, 182, 182, 182, 182, -1, 
	-1, -1, 185, 185, 185, 185, 185, 185, 
	185, 185, 185, 185, 185, 185, 185, 185, 
	185, 185, -1, 185, 185, 185, 185, 185, 
	185, 185, 185, -1, -1, -1, 185, 185, 
	185, 185, 185, -1, 185, -1, 185, 185, 
	185, 185, -1, 185, -1, 185, 185, 185, 
	-1, -1, 185, -1, -1, 185, 185, 185, 
	185, 185, -1, 185, 185, 185, -1, -1, 
	-1, -1, 185, 185, 185, 185, 185, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	181, 181, -1, -1, -1, 185, -1, -1, 
	-1, -1, -1, 181, 181, 181, 181, 181, 
	-1, 181, 181, 181, 185, 185, -1, -1, 
	181, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 179, -1, -1, -1, -1, 
	-1, -1, -1, 181, 181, 181, 181, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 185, 185, 185, 185, -1, -1, 
	185, 185, 185, 185, 185, 185, -1, -1, 
	-1, -1, 185, 185, 185, 185, 185, 185, 
	185, 185, -1, -1, -1, -1, 185, -1, 
	-1, -1, -1, 185, 185, -1, -1, 185, 
	185, 185, 185, -1, 185, 185, -1, -1, 
	185, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 185, 185, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 185, 185, -1, -1, -1, -1, 
	-1, -1, -1, -1, 185, 185, -1, -1, 
	-1, -1, 185, -1, -1, -1, -1, -1, 
	-1, -1, 179, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	185, 185, -1, -1, -1, -1, 186, 186, 
	186, 186, 186, 186, 186, 186, 186, 186, 
	186, 186, 186, 186, 186, 186, -1, 186, 
	186, 186, 186, 186, 186, 186, 186, -1, 
	-1, -1, 186, 186, 186, 186, 186, -1, 
	186, -1, 186, 186, 186, 186, -1, 186, 
	-1, 186, 186, 186, -1, -1, 186, -1, 
	-1, 186, 186, 186, 186, 186, -1, 186, 
	186, 186, -1, -1, -1, -1, 186, 186, 
	186, 186, 186, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 186, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	186, 186, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 186, 186, 
	186, 186, -1, -1, 186, 186, 186, 186, 
	186, 186, -1, 185, -1, -1, 186, 186, 
	186, 186, 186, 186, 186, 186, -1, -1, 
	-1, -1, 186, -1, -1, -1, -1, 186, 
	186, -1, 179, 186, 186, 186, 186, -1, 
	186, 186, -1, -1, 186, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 186, 186, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 186, 186, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	186, 186, -1, -1, -1, -1, 186, -1, 
	182, 182, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 182, 182, 182, 182, 182, 
	-1, 182, 182, 182, -1, -1, -1, -1, 
	182, -1, -1, -1, 186, 186, -1, -1, 
	-1, 190, -1, 190, 190, 190, 190, 190, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 182, 182, 182, 182, -1, 
	-1, -1, -1, -1, -1, 190, 190, 190, 
	190, 190, 185, 190, -1, 190, -1, -1, 
	-1, -1, 190, -1, -1, 190, -1, -1, 
	-1, -1, -1, -1, 190, 190, 190, -1, 
	-1, -1, 190, 190, 190, -1, -1, -1, 
	-1, 190, 190, 190, -1, 190, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 191, 191, 191, 191, 191, 191, 191, 
	191, 191, 191, 191, 191, 191, 191, 191, 
	191, -1, 191, 191, 191, 191, 191, 191, 
	191, 191, -1, -1, -1, 191, 191, 191, 
	191, 191, -1, 191, -1, 191, 191, 191, 
	191, -1, 191, -1, 191, 191, 191, -1, 
	-1, 191, -1, -1, 191, 191, 191, 191, 
	191, -1, 191, 191, 191, 191, -1, -1, 
	-1, 191, 191, 191, 191, 191, -1, 191, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 190, 190, -1, -1, 190, 
	190, 190, 190, -1, 190, -1, -1, 186, 
	-1, 190, 190, 190, 190, 190, 190, 190, 
	190, -1, -1, 191, 191, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 190, -1, 
	190, 190, -1, 190, 190, -1, -1, 190, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 190, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 190, 190, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 191, 191, 191, 191, -1, -1, 191, 
	191, 191, 191, 191, 191, -1, -1, -1, 
	-1, 191, 191, 191, 191, 191, 191, 191, 
	191, -1, 191, 191, -1, 191, -1, -1, 
	-1, -1, 191, 191, -1, 190, 191, 191, 
	191, 191, -1, 191, 191, -1, -1, 191, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 191, 191, 186, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 191, 191, -1, -1, -1, -1, -1, 
	-1, -1, -1, 191, 191, -1, -1, -1, 
	-1, 191, -1, -1, -1, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, -1, 192, 192, 
	192, 192, 192, 192, 192, 192, -1, 191, 
	191, 192, 192, 192, 192, 192, -1, 192, 
	-1, 192, 192, 192, 192, -1, 192, -1, 
	192, 192, 192, -1, -1, 192, -1, -1, 
	192, 192, 192, 192, 192, -1, 192, 192, 
	192, 192, -1, -1, -1, 192, 192, 192, 
	192, 192, -1, 192, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 192, 
	192, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 192, 192, 192, 
	192, -1, -1, 192, 192, 192, 192, 192, 
	192, -1, -1, -1, -1, 192, 192, 192, 
	192, 192, 192, 192, 192, -1, 192, 192, 
	-1, 192, -1, -1, -1, -1, 192, 192, 
	-1, -1, 192, 192, 192, 192, -1, 192, 
	192, -1, 191, 192, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	192, 192, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 192, 192, -1, 
	-1, -1, -1, -1, -1, -1, -1, 192, 
	192, -1, -1, -1, -1, 192, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 192, 192, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 195, 195, 195, 195, 195, 195, 195, 
	195, 195, 195, 195, 195, 195, 195, 195, 
	195, 195, 195, 195, 195, 195, 195, 195, 
	195, 195, 195, 195, -1, 195, 195, 195, 
	195, 195, -1, 195, -1, 195, 195, 195, 
	195, -1, 195, -1, 195, 195, 195, 195, 
	-1, 195, 195, 195, 195, 195, 195, 195, 
	195, 191, 195, 195, 195, -1, -1, -1, 
	-1, 195, 195, 195, 195, 195, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 195, -1, -1, -1, -1, 195, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 195, 195, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 195, 195, 195, 195, -1, 192, 195, 
	195, -1, 195, 195, 195, -1, -1, -1, 
	-1, 195, 195, 195, -1, 195, 195, 195, 
	195, -1, -1, -1, -1, 195, -1, -1, 
	-1, -1, 195, -1, -1, -1, 195, 195, 
	195, 195, -1, 195, 195, -1, -1, 195, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 195, 195, 195, 195, 195, 195, 195, 
	195, -1, -1, -1, -1, 195, 195, -1, 
	-1, 195, 195, 191, 191, -1, -1, -1, 
	-1, 195, -1, 195, 195, -1, 190, -1, 
	-1, 195, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 195, 
	195, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 192, 196, 196, 
	196, 196, 196, 196, 196, 196, 196, 196, 
	196, 196, 196, 196, 196, 196, 196, 196, 
	196, 196, 196, 196, 196, 196, 196, 196, 
	196, -1, 196, 196, 196, 196, 196, -1, 
	196, -1, 196, 196, 196, 196, -1, 196, 
	-1, 196, 196, 196, -1, -1, 196, 196, 
	196, 196, 196, 196, 196, 196, -1, 196, 
	196, 196, -1, -1, -1, -1, 196, 196, 
	196, 196, 196, -1, 197, 197, 197, 197, 
	197, 197, 197, -1, 197, 197, -1, -1, 
	-1, -1, -1, 196, -1, -1, -1, 197, 
	197, 197, 197, 197, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 197, -1, 
	196, 196, 197, -1, -1, -1, 197, 197, 
	197, 197, 197, 197, -1, -1, -1, -1, 
	197, 197, 197, -1, -1, -1, -1, 197, 
	197, -1, 197, 197, 197, 197, -1, -1, 
	-1, -1, -1, -1, -1, 197, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 197, 197, 197, 197, 197, 
	-1, -1, 195, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 196, 196, 
	196, 196, -1, -1, 196, 196, -1, 196, 
	196, 196, -1, -1, -1, -1, 196, 196, 
	196, -1, 196, 196, 196, 196, -1, -1, 
	-1, -1, 196, -1, -1, -1, -1, 196, 
	-1, -1, -1, 196, 196, 196, 196, -1, 
	196, 196, -1, -1, 196, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 196, 196, 
	196, 196, 196, 196, 196, 196, -1, -1, 
	-1, -1, 196, 196, -1, -1, 196, 196, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	196, 196, -1, -1, -1, -1, 196, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 196, 196, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 195, -1, -1, -1, -1, 197, 197, 
	197, 197, 197, -1, 197, 197, 197, -1, 
	-1, -1, -1, 197, 200, 200, 200, 200, 
	200, 200, 200, -1, 200, 200, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 200, 
	200, 200, 200, 200, -1, -1, 197, 197, 
	197, 197, 197, -1, -1, -1, 200, -1, 
	-1, -1, 200, -1, -1, -1, 200, 200, 
	200, 200, 200, 200, -1, -1, -1, -1, 
	200, 200, 200, -1, -1, -1, -1, 200, 
	200, -1, 200, 200, 200, 200, -1, -1, 
	-1, -1, -1, -1, -1, 200, -1, -1, 
	-1, 201, 201, 201, 201, 201, 201, 201, 
	-1, 201, 201, 200, 200, 200, 200, 200, 
	-1, -1, -1, -1, 201, 201, 201, 201, 
	201, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 201, -1, -1, -1, 201, 
	-1, -1, -1, 201, 201, 201, 201, 201, 
	201, -1, -1, -1, -1, 201, 201, 201, 
	-1, -1, -1, -1, 201, 201, -1, 201, 
	201, 201, 201, -1, -1, -1, -1, -1, 
	-1, -1, 201, 201, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 196, 
	201, 201, 201, 201, 201, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 195, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 200, 200, 
	200, 200, 200, -1, 200, 200, 200, -1, 
	-1, -1, -1, 200, -1, 288, 288, 288, 
	288, 288, 288, 288, 288, 288, 288, 288, 
	288, -1, -1, 288, 288, 288, 288, -1, 
	-1, -1, -1, -1, -1, -1, 200, 200, 
	200, 200, 200, 288, 288, 288, -1, -1, 
	-1, 288, -1, -1, -1, -1, 288, -1, 
	-1, -1, -1, -1, 288, 288, 196, -1, 
	201, 201, -1, -1, -1, -1, -1, -1, 
	-1, -1, 288, 201, 201, 201, 201, 201, 
	-1, 201, 201, 201, -1, -1, -1, -1, 
	201, -1, -1, 288, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	288, 288, -1, 201, 201, 201, 201, 201, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	207, 207, 207, 207, 207, 207, 207, 207, 
	207, 207, 207, 207, 207, 207, 207, 207, 
	-1, 207, 207, 207, 207, 207, 207, 207, 
	207, -1, -1, -1, 207, 207, 207, 207, 
	207, -1, 207, -1, 207, 207, 207, 207, 
	-1, 207, -1, 207, 207, 207, -1, -1, 
	207, -1, -1, 207, 207, 207, 207, 207, 
	-1, 207, 207, 207, -1, -1, -1, -1, 
	207, 207, 207, 207, 207, -1, -1, -1, 
	-1, -1, -1, -1, 207, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 207, 207, -1, -1, -1, -1, 
	-1, 288, 288, -1, -1, -1, -1, -1, 
	-1, -1, 288, 288, -1, -1, 288, 288, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 288, -1, -1, -1, -1, 288, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 288, 288, -1, -1, 
	207, 207, 207, 207, -1, -1, 207, 207, 
	207, 207, 207, 207, -1, -1, -1, -1, 
	207, 207, 207, 207, 207, 207, 207, 207, 
	-1, -1, -1, -1, 207, -1, -1, -1, 
	-1, 207, 207, -1, -1, 207, 207, 207, 
	207, -1, 207, 207, -1, -1, 207, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 207, 207, -1, -1, 197, 
	197, 197, 197, 197, -1, 197, 197, 197, 
	207, 207, -1, -1, 197, -1, -1, -1, 
	-1, -1, 207, 207, -1, -1, -1, -1, 
	207, -1, -1, 220, 220, 220, 220, 220, 
	220, 220, -1, 220, 220, -1, -1, 197, 
	197, 197, 197, -1, -1, -1, 220, 220, 
	220, 220, 220, -1, -1, -1, 207, 207, 
	-1, -1, -1, -1, -1, 220, -1, -1, 
	-1, 220, -1, -1, -1, 220, 220, 220, 
	220, 220, 220, -1, -1, -1, -1, 220, 
	220, 220, -1, -1, -1, -1, 220, 220, 
	-1, 220, 220, 220, 220, 220, -1, -1, 
	-1, -1, -1, -1, 220, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 220, 220, 220, 220, 220, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 207, -1, -1, -1, -1, -1, 200, 
	200, 200, 200, 200, -1, 200, 200, 200, 
	-1, -1, -1, -1, 200, 220, 220, 220, 
	220, 220, -1, 220, 220, 220, -1, -1, 
	-1, -1, 220, -1, -1, -1, -1, 207, 
	-1, -1, -1, -1, -1, 220, 220, 200, 
	200, 200, 200, -1, -1, -1, 220, -1, 
	-1, 207, -1, -1, -1, 220, 220, 220, 
	220, 220, -1, -1, -1, -1, -1, -1, 
	-1, 201, 201, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 201, 201, 201, 201, 
	201, -1, 201, 201, 201, -1, -1, -1, 
	-1, 201, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 201, 201, 201, 201, 
	208, 208, 208, 208, 208, 208, 208, 208, 
	208, 208, 208, 208, 208, 208, 208, 208, 
	207, 208, 208, 208, 208, 208, 208, 208, 
	208, -1, -1, -1, 208, 208, 208, 208, 
	208, -1, 208, -1, 208, 208, 208, 208, 
	-1, 208, 208, 208, 208, 208, -1, -1, 
	208, -1, -1, 208, 208, 208, 208, 208, 
	-1, 208, 208, 208, -1, -1, -1, -1, 
	208, 208, 208, 208, 208, -1, -1, -1, 
	-1, -1, -1, -1, 208, -1, 208, -1, 
	-1, -1, -1, -1, 208, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 208, 208, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 288, 288, -1, -1, -1, -1, 
	-1, -1, -1, 288, 288, -1, -1, 288, 
	288, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 288, -1, -1, -1, -1, 288, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	208, 208, 208, 208, -1, 288, 208, 208, 
	208, 208, 208, 208, -1, -1, -1, -1, 
	208, 208, 208, 208, 208, 208, 208, 208, 
	-1, -1, -1, -1, 208, -1, -1, -1, 
	-1, 208, 208, -1, -1, 208, 208, 208, 
	208, -1, 208, 208, -1, -1, 208, -1, 
	-1, -1, -1, 208, 208, -1, 208, -1, 
	-1, -1, -1, 208, 208, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	208, 208, -1, -1, -1, -1, -1, -1, 
	-1, -1, 208, 208, -1, -1, -1, -1, 
	208, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 208, 208, 
	-1, -1, 209, 209, 209, 209, 209, 209, 
	209, 209, 209, 209, 209, 209, 209, 209, 
	209, 209, -1, 209, 209, 209, 209, 209, 
	209, 209, 209, -1, -1, -1, 209, 209, 
	209, 209, 209, -1, 209, -1, 209, 209, 
	209, 209, -1, 209, -1, 209, 209, 209, 
	-1, -1, 209, -1, -1, 209, 209, 209, 
	209, 209, -1, 209, 209, 209, -1, -1, 
	-1, -1, 209, 209, 209, 209, 209, -1, 
	-1, -1, -1, -1, -1, -1, 209, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 209, 209, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 209, 209, 209, 209, -1, -1, 
	209, 209, 209, 209, 209, 209, -1, -1, 
	-1, 208, 209, 209, 209, 209, 209, 209, 
	209, 209, -1, -1, -1, -1, 209, -1, 
	-1, -1, -1, 209, 209, -1, -1, 209, 
	209, 209, 209, -1, 209, 209, -1, -1, 
	209, -1, -1, -1, -1, -1, -1, 208, 
	-1, -1, -1, -1, -1, 209, 209, -1, 
	-1, -1, -1, -1, -1, -1, 220, 220, 
	-1, 208, 209, 209, -1, -1, -1, 220, 
	-1, -1, -1, -1, 209, 209, -1, -1, 
	-1, -1, 209, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	209, 209, -1, -1, -1, 211, 211, 211, 
	211, 211, 211, 211, 211, 211, 211, 211, 
	211, 211, 211, 211, 211, -1, 211, 211, 
	211, 211, 211, 211, 211, 211, -1, -1, 
	-1, 211, 211, 211, 211, 211, -1, 211, 
	208, 211, 211, 211, 211, -1, 211, -1, 
	211, 211, 211, -1, -1, 211, -1, -1, 
	211, 211, 211, 211, 211, -1, 211, 211, 
	211, -1, -1, -1, -1, 211, 211, 211, 
	211, 211, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 211, 
	211, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 211, 211, 211, 
	211, -1, -1, 211, 211, 211, 211, 211, 
	211, -1, -1, 209, -1, 211, 211, 211, 
	211, 211, 211, 211, 211, -1, -1, -1, 
	-1, 211, -1, -1, -1, -1, 211, 211, 
	-1, -1, 211, 211, 211, 211, -1, 211, 
	211, -1, -1, 211, -1, -1, -1, -1, 
	-1, 209, -1, -1, -1, -1, -1, -1, 
	211, 211, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 209, -1, 211, 211, -1, 
	-1, -1, -1, -1, -1, 208, -1, 211, 
	211, -1, -1, -1, -1, 211, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 211, 211, -1, -1, 213, 
	213, 213, 213, 213, 213, 213, 213, 213, 
	213, 213, 213, 213, 213, 213, 213, -1, 
	213, 213, 213, 213, 213, 213, 213, 213, 
	-1, -1, -1, 213, 213, 213, 213, 213, 
	-1, 213, 209, 213, 213, 213, 213, -1, 
	213, -1, 213, 213, 213, -1, -1, 213, 
	-1, -1, 213, 213, 213, 213, 213, -1, 
	213, 213, 213, -1, -1, -1, -1, 213, 
	213, 213, 213, 213, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 213, 213, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 213, 
	213, 213, 213, -1, -1, 213, 213, 213, 
	213, 213, 213, -1, -1, -1, 211, 213, 
	213, 213, 213, 213, 213, 213, 213, -1, 
	-1, -1, -1, 213, -1, -1, -1, -1, 
	213, 213, -1, -1, 213, 213, 213, 213, 
	-1, 213, 213, -1, -1, 213, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 213, 213, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 213, 
	213, -1, -1, -1, -1, -1, -1, -1, 
	-1, 213, 213, -1, -1, -1, -1, 213, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 213, 213, -1, 
	-1, -1, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, -1, 224, 224, 
	224, 224, 224, -1, 224, 211, 224, 224, 
	224, 224, -1, 224, -1, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, -1, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, -1, 224, 
	-1, -1, 224, -1, 224, 224, 224, 224, 
	224, -1, -1, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, -1, 224, 224, -1, -1, 
	-1, -1, -1, 224, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 224, 224, 224, 224, -1, -1, 
	224, 224, 224, 224, 224, 224, -1, -1, 
	213, -1, 224, 224, 224, 224, 224, 224, 
	224, 224, -1, -1, -1, -1, 224, -1, 
	-1, -1, -1, 224, 224, -1, -1, 224, 
	224, 224, 224, -1, 224, 224, -1, -1, 
	224, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 224, 224, 224, 224, 224, 224, 
	224, 224, -1, -1, -1, 224, 224, 224, 
	-1, -1, 224, 224, -1, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, -1, -1, 
	-1, 224, 224, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 224, 224, -1, 
	-1, 224, -1, -1, -1, -1, 224, -1, 
	-1, -1, -1, 224, -1, 224, 224, 224, 
	224, 224, -1, -1, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, -1, 
	233, 233, 233, 233, 233, -1, 233, 213, 
	233, 233, 233, 233, -1, 233, -1, 233, 
	233, 233, -1, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	-1, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	-1, 233, -1, -1, -1, -1, 233, 233, 
	233, 233, 233, -1, -1, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, -1, 233, 233, 
	-1, -1, -1, -1, -1, 233, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 233, 233, 233, 233, 
	-1, -1, 233, 233, 233, 233, 233, 233, 
	-1, -1, -1, 224, 233, 233, 233, 233, 
	233, 233, 233, 233, -1, -1, -1, -1, 
	233, -1, -1, -1, -1, 233, 233, -1, 
	-1, 233, 233, 233, 233, -1, 233, 233, 
	-1, -1, 233, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 233, 233, 233, 233, 
	233, 233, 233, 233, -1, -1, -1, 233, 
	233, 233, -1, -1, 233, 233, -1, 233, 
	233, 233, 233, 233, -1, 233, 233, 233, 
	-1, -1, -1, 233, 233, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 233, 
	233, -1, -1, 233, -1, -1, -1, -1, 
	233, -1, -1, -1, -1, 233, -1, 233, 
	233, 233, 233, 233, -1, -1, -1, 234, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, -1, 234, 234, 234, 234, 234, 
	-1, 234, 224, 234, 234, 234, 234, -1, 
	234, -1, 234, 234, 234, -1, 234, 234, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, 234, -1, 234, 234, 234, 234, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, 234, -1, 234, -1, -1, -1, 
	-1, 234, 234, 234, 234, 234, -1, -1, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, 234, 234, 234, 234, 234, 234, 
	-1, 234, 234, -1, -1, -1, -1, -1, 
	234, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 234, 
	234, 234, 234, -1, -1, 234, 234, 234, 
	234, 234, 234, -1, -1, 233, -1, 234, 
	234, 234, 234, 234, 234, 234, 234, -1, 
	-1, -1, -1, 234, -1, -1, -1, -1, 
	234, 234, -1, -1, 234, 234, 234, 234, 
	-1, 234, 234, -1, -1, 234, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 234, 
	234, 234, 234, 234, 234, 234, 234, -1, 
	-1, -1, 234, 234, 234, 234, -1, 234, 
	234, -1, 234, 234, 234, 234, 234, -1, 
	234, 234, 234, -1, -1, -1, 234, 234, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 234, 234, -1, -1, 234, -1, 
	-1, -1, -1, 234, -1, -1, -1, -1, 
	234, -1, 234, 234, 234, 234, 234, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	234, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 233, 236, 236, 236, 
	236, 236, 236, 236, 236, 236, 236, 236, 
	236, 236, 236, 236, 236, 236, 236, 236, 
	236, 236, 236, 236, 236, 236, 236, 236, 
	-1, 236, 236, 236, 236, 236, -1, 236, 
	-1, 236, 236, 236, 236, -1, 236, -1, 
	236, 236, 236, -1, 236, 236, 236, 236, 
	236, 236, 236, 236, 236, 236, 236, 236, 
	236, -1, 236, 236, 236, 236, 236, 236, 
	236, 236, 236, 236, 236, 236, 236, 236, 
	236, -1, 236, -1, -1, -1, -1, 236, 
	236, 236, 236, 236, -1, -1, 236, 236, 
	236, 236, 236, 236, 236, 236, 236, 236, 
	236, 236, 236, 236, 236, 236, -1, 236, 
	236, -1, -1, -1, -1, -1, 236, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	234, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 236, 236, 236, 
	236, -1, -1, 236, 236, 236, 236, 236, 
	236, -1, -1, -1, -1, 236, 236, 236, 
	236, 236, 236, 236, 236, -1, -1, -1, 
	-1, 236, -1, -1, -1, -1, 236, 236, 
	-1, -1, 236, 236, 236, 236, -1, 236, 
	236, -1, -1, 236, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 236, 236, 236, 
	236, 236, 236, 236, 236, -1, -1, -1, 
	236, 236, 236, 236, -1, 236, 236, -1, 
	236, 236, 236, 236, 236, -1, 236, 236, 
	236, -1, -1, -1, 236, 236, -1, -1, 
	-1, -1, -1, -1, -1, 236, 236, -1, 
	236, 236, -1, -1, 236, -1, -1, -1, 
	-1, 236, -1, -1, -1, -1, 236, -1, 
	236, 236, 236, 236, 236, -1, -1, 234, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 236, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, -1, 240, 240, 240, 240, 240, 
	-1, 240, -1, 240, 240, 240, 240, -1, 
	240, -1, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, -1, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, -1, 240, -1, -1, 240, 
	-1, 240, 240, 240, 240, 240, -1, -1, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	-1, 240, 240, -1, -1, -1, -1, -1, 
	240, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 236, 240, 
	240, 240, 240, -1, -1, 240, 240, 240, 
	240, 240, 240, -1, -1, -1, -1, 240, 
	240, 240, 240, 240, 240, 240, 240, -1, 
	-1, -1, -1, 240, -1, -1, -1, -1, 
	240, 240, -1, -1, 240, 240, 240, 240, 
	-1, 240, 240, -1, -1, 240, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 240, 
	240, 240, 240, 240, 240, 240, 240, -1, 
	-1, -1, 240, 240, 240, -1, -1, 240, 
	240, -1, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, -1, -1, -1, 240, 240, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 240, 240, -1, -1, 240, -1, 
	-1, -1, -1, 240, -1, -1, -1, -1, 
	240, -1, 240, 240, 240, 240, 240, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 236, -1, -1, 
	-1, 241, 241, 241, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, 241, 241, 241, 
	241, 241, 241, 241, -1, 241, 241, 241, 
	241, 241, -1, 241, -1, 241, 241, 241, 
	241, -1, 241, -1, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, -1, 241, 241, 
	241, 241, 241, 241, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, -1, 241, -1, 
	-1, 241, -1, 241, 241, 241, 241, 241, 
	-1, -1, 241, 241, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, 241, 241, 241, 
	241, 241, -1, 241, 241, -1, -1, -1, 
	-1, -1, 241, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	240, -1, -1, -1, -1, -1, -1, -1, 
	-1, 241, 241, 241, 241, -1, -1, 241, 
	241, 241, 241, 241, 241, -1, -1, -1, 
	-1, 241, 241, 241, 241, 241, 241, 241, 
	241, -1, -1, -1, -1, 241, -1, -1, 
	-1, -1, 241, 241, -1, -1, 241, 241, 
	241, 241, -1, 241, 241, -1, -1, 241, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 241, 241, 241, 241, 241, 241, 241, 
	241, -1, -1, -1, 241, 241, 241, -1, 
	-1, 241, 241, -1, 241, 241, 241, 241, 
	241, 241, 241, 241, 241, -1, 236, 236, 
	241, 241, -1, -1, -1, 242, -1, 242, 
	242, 242, 242, 242, 241, 241, -1, -1, 
	241, -1, -1, -1, -1, 241, -1, -1, 
	242, -1, 241, -1, 241, 241, 241, 241, 
	241, 242, 242, 242, 242, 242, -1, 242, 
	-1, 242, -1, -1, -1, -1, 242, 240, 
	-1, 242, 242, -1, -1, -1, -1, -1, 
	242, 242, 242, -1, -1, -1, 242, 242, 
	242, -1, -1, -1, -1, 242, 242, 242, 
	242, 242, 255, 255, 255, 255, 255, 255, 
	255, -1, 255, 255, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 255, 255, 255, 
	255, 255, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 255, -1, -1, -1, 
	255, -1, -1, -1, 255, 255, 255, 255, 
	255, 255, -1, -1, -1, -1, 255, 255, 
	255, -1, -1, -1, -1, 255, 255, -1, 
	255, 255, 255, 255, 255, -1, -1, -1, 
	-1, -1, -1, 255, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 255, 255, 255, 255, 255, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 242, 242, 
	242, -1, -1, 242, 242, -1, -1, 242, 
	242, -1, -1, -1, -1, 242, 242, 242, 
	-1, 242, 242, 242, 242, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 242, 242, 
	-1, -1, 242, -1, 242, 242, -1, 242, 
	242, -1, 241, 242, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 259, 259, 
	259, 259, 259, 259, 259, -1, 259, 259, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 259, 259, 259, 259, 259, -1, 242, 
	242, -1, -1, -1, -1, -1, -1, -1, 
	259, -1, -1, -1, 259, -1, -1, -1, 
	259, 259, 259, 259, 259, 259, -1, -1, 
	-1, -1, 259, 259, 259, -1, -1, -1, 
	240, 259, 259, -1, 259, 259, 259, 259, 
	-1, -1, -1, -1, -1, -1, -1, 259, 
	-1, -1, -1, -1, 255, 255, 255, 255, 
	255, -1, 255, 255, 255, -1, -1, -1, 
	-1, 255, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 255, 255, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 255, -1, 255, 255, 255, 255, 
	255, -1, -1, -1, -1, -1, -1, -1, 
	-1, 241, -1, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, -1, 257, 
	257, 257, 257, 257, -1, 257, -1, 257, 
	257, 257, 257, -1, 257, -1, 257, 257, 
	257, -1, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, -1, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, -1, 
	257, -1, -1, -1, -1, 257, 257, 257, 
	257, 257, -1, -1, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, -1, 257, 257, -1, 
	-1, -1, -1, -1, 257, -1, 259, 259, 
	259, -1, -1, -1, -1, 259, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	259, 259, 259, 259, 259, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 257, 257, 257, 257, -1, 
	-1, 257, 257, 257, 257, 257, 257, -1, 
	-1, -1, -1, 257, 257, 257, 257, 257, 
	257, 257, 257, -1, -1, -1, -1, 257, 
	-1, -1, -1, -1, 257, 257, -1, -1, 
	257, 257, 257, 257, -1, 257, 257, -1, 
	-1, 257, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 257, 257, 257, 257, 257, 
	257, 257, 257, -1, -1, -1, 257, 257, 
	257, -1, 241, 257, 257, -1, 257, 257, 
	257, 257, 257, -1, 257, 257, 257, -1, 
	-1, -1, 257, 257, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 257, 257, 
	-1, -1, 257, -1, -1, -1, -1, 257, 
	-1, -1, -1, -1, 257, -1, 257, 257, 
	257, 257, 257, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, -1, 258, 258, 258, 258, 258, 
	-1, 258, -1, 258, 258, 258, 258, -1, 
	258, -1, 258, 258, 258, -1, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, -1, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, -1, 258, -1, -1, -1, 
	-1, 258, 258, 258, 258, 258, -1, -1, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	258, 258, 258, 258, 258, 258, 258, 258, 
	-1, 258, 258, -1, -1, -1, -1, -1, 
	258, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 242, 
	242, 242, -1, -1, 242, 242, -1, -1, 
	242, 242, -1, -1, -1, -1, 242, 242, 
	242, -1, 242, 242, 242, 242, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 242, 
	242, -1, -1, 242, -1, 242, 242, -1, 
	242, 242, -1, -1, 242, -1, -1, 258, 
	258, 258, 258, -1, 257, 258, 258, 258, 
	258, 258, 258, -1, -1, -1, -1, 258, 
	258, 258, 258, 258, 258, 258, 258, -1, 
	-1, -1, -1, 258, -1, -1, -1, -1, 
	258, 258, -1, -1, 258, 258, 258, 258, 
	-1, 258, 258, -1, -1, 258, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 258, 
	258, 258, 258, 258, 258, 258, 258, -1, 
	-1, -1, 258, 258, 258, -1, -1, 258, 
	258, -1, 258, 258, 258, 258, 258, -1, 
	258, 258, 258, -1, -1, -1, 258, 258, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 258, 258, -1, -1, 258, -1, 
	-1, -1, -1, 258, -1, 255, 255, -1, 
	258, -1, 258, 258, 258, 258, 258, -1, 
	-1, -1, -1, 255, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 257, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 295, 
	295, 295, 295, 295, 295, 295, 295, 295, 
	-1, 295, 295, -1, -1, 295, 295, 295, 
	295, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 295, 295, 295, 
	-1, -1, -1, 295, -1, -1, -1, -1, 
	295, -1, -1, -1, -1, -1, 295, 295, 
	-1, -1, -1, -1, -1, -1, -1, 259, 
	259, 259, -1, -1, 295, -1, 259, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 295, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 259, 259, 259, 259, -1, -1, -1, 
	-1, -1, 295, 295, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	258, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, -1, 260, 260, 260, 
	260, 260, -1, 260, -1, 260, 260, 260, 
	260, -1, 260, -1, 260, 260, 260, -1, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, -1, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, -1, 260, -1, 
	-1, -1, -1, 260, 260, 260, 260, 260, 
	-1, -1, 260, 260, 260, 260, 260, 260, 
	260, 260, 260, 260, 260, 260, 260, 260, 
	260, 260, -1, 260, 260, -1, -1, -1, 
	-1, -1, 260, 295, 295, -1, -1, -1, 
	-1, -1, -1, 295, -1, -1, -1, -1, 
	295, 295, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 295, -1, -1, -1, 258, 
	295, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 295, 295, 
	-1, 260, 260, 260, 260, -1, -1, 260, 
	260, 260, 260, 260, 260, -1, -1, -1, 
	-1, 260, 260, 260, 260, 260, 260, 260, 
	260, -1, -1, -1, -1, 260, -1, -1, 
	-1, -1, 260, 260, -1, -1, 260, 260, 
	260, 260, -1, 260, 260, -1, -1, 260, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 260, 260, 260, 260, 260, 260, 260, 
	260, -1, -1, -1, 260, 260, 260, -1, 
	-1, 260, 260, -1, 260, 260, 260, 260, 
	260, -1, 260, 260, 260, -1, -1, -1, 
	260, 260, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 260, 260, -1, -1, 
	260, -1, -1, -1, -1, 260, -1, -1, 
	-1, -1, 260, -1, 260, 260, 260, 260, 
	260, -1, -1, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, -1, 261, 
	261, 261, 261, 261, -1, 261, -1, 261, 
	261, 261, 261, -1, 261, -1, 261, 261, 
	261, -1, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, -1, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, -1, 
	261, -1, -1, -1, -1, 261, 261, 261, 
	261, 261, -1, -1, 261, 261, 261, 261, 
	261, 261, 261, 261, 261, 261, 261, 261, 
	261, 261, 261, 261, -1, 261, 261, -1, 
	-1, -1, -1, -1, 261, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 261, 261, 261, 261, -1, 
	-1, 261, 261, 261, 261, 261, 261, -1, 
	-1, -1, 260, 261, 261, 261, 261, 261, 
	261, 261, 261, -1, -1, -1, -1, 261, 
	-1, -1, -1, -1, 261, 261, -1, -1, 
	261, 261, 261, 261, -1, 261, 261, -1, 
	-1, 261, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 261, 261, 261, 261, 261, 
	261, 261, 261, -1, -1, -1, 261, 261, 
	261, -1, -1, 261, 261, -1, 261, 261, 
	261, 261, 261, -1, 261, 261, 261, -1, 
	-1, -1, 261, 261, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 261, 261, 
	-1, -1, 261, -1, -1, -1, -1, 261, 
	-1, -1, -1, -1, 261, -1, 261, 261, 
	261, 261, 261, -1, -1, -1, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, -1, 262, 262, 262, 262, 262, -1, 
	262, 260, 262, 262, 262, 262, -1, 262, 
	-1, 262, 262, 262, -1, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, -1, 262, 262, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, -1, 262, -1, -1, -1, -1, 
	262, 262, 262, 262, 262, -1, -1, 262, 
	262, 262, 262, 262, 262, 262, 262, 262, 
	262, 262, 262, 262, 262, 262, 262, -1, 
	262, 262, -1, -1, -1, -1, -1, 262, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 295, 295, -1, -1, 
	-1, -1, -1, -1, 295, -1, -1, -1, 
	-1, 295, 295, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 295, -1, -1, -1, 
	-1, 295, -1, -1, -1, -1, 262, 262, 
	262, 262, -1, -1, 262, 262, 262, 262, 
	262, 262, -1, -1, 261, -1, 262, 262, 
	262, 262, 262, 262, 262, 262, -1, 295, 
	-1, -1, 262, -1, -1, -1, -1, 262, 
	262, -1, -1, 262, 262, 262, 262, -1, 
	262, 262, -1, -1, 262, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 262, 262, 
	262, 262, 262, 262, 262, 262, -1, -1, 
	-1, 262, 262, 262, -1, -1, 262, 262, 
	-1, 262, 262, 262, 262, 262, -1, 262, 
	262, 262, -1, -1, -1, 262, 262, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 262, 262, -1, -1, 262, -1, -1, 
	-1, -1, 262, -1, -1, -1, -1, 262, 
	-1, 262, 262, 262, 262, 262, -1, -1, 
	263, 263, 263, 263, 263, 263, 263, 263, 
	263, 263, 263, 263, 263, 263, 263, 263, 
	263, 263, 263, 263, 263, 263, 263, 263, 
	263, 263, 263, -1, 263, 263, 263, 263, 
	263, -1, 263, 261, 263, 263, 263, 263, 
	-1, 263, -1, 263, 263, 263, -1, -1, 
	263, 263, 263, 263, 263, 263, 263, 263, 
	-1, 263, 263, 263, -1, -1, -1, -1, 
	263, 263, 263, 263, 263, -1, 264, 264, 
	264, 264, 264, 264, 264, -1, 264, 264, 
	-1, -1, -1, -1, -1, 263, -1, -1, 
	-1, 264, 264, 264, 264, 264, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	264, -1, 263, 263, 264, -1, -1, -1, 
	264, 264, 264, 264, 264, 264, -1, -1, 
	-1, -1, 264, 264, 264, -1, -1, -1, 
	-1, 264, 264, -1, 264, 264, 264, 264, 
	-1, -1, -1, -1, -1, -1, -1, 264, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 264, 264, 264, 
	264, 264, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	263, 263, 263, 263, -1, -1, 263, 263, 
	-1, 263, 263, 263, -1, -1, -1, 262, 
	263, 263, 263, -1, 263, 263, 263, 263, 
	-1, -1, -1, -1, 263, -1, -1, -1, 
	-1, 263, -1, -1, -1, 263, 263, 263, 
	263, -1, 263, 263, -1, -1, 263, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	263, 263, 263, 263, 263, 263, 263, 263, 
	-1, -1, -1, -1, 263, 263, -1, -1, 
	263, 263, -1, -1, -1, -1, -1, -1, 
	-1, -1, 263, 263, -1, -1, -1, -1, 
	263, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 263, 263, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 264, 264, 264, 264, -1, 264, 264, 
	264, -1, -1, -1, -1, 264, -1, 265, 
	265, 265, 265, 265, 265, 265, 262, 265, 
	265, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 265, 265, 265, 265, 265, -1, 
	264, 264, 264, 264, 264, -1, -1, -1, 
	-1, 265, -1, -1, -1, 265, -1, -1, 
	-1, 265, 265, 265, 265, 265, 265, -1, 
	-1, -1, -1, 265, 265, 265, -1, -1, 
	-1, -1, 265, 265, -1, 265, 265, 265, 
	265, -1, -1, -1, -1, -1, -1, -1, 
	265, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 265, 265, 
	265, 265, 265, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 267, 267, 267, 267, 267, 267, 
	267, 267, 267, 267, 267, 267, 267, 267, 
	267, 267, 267, 267, 267, 267, 267, 267, 
	267, 267, 267, 267, 267, -1, 267, 267, 
	267, 267, 267, -1, 267, -1, 267, 267, 
	267, 267, -1, 267, -1, 267, 267, 267, 
	-1, 263, 267, 267, 267, 267, 267, 267, 
	267, 267, -1, 267, 267, 267, -1, -1, 
	-1, -1, 267, 267, 267, 267, 267, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 267, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 267, 267, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 265, 265, 265, 265, -1, 265, 
	265, 265, -1, -1, -1, -1, 265, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 265, 265, 265, 265, 265, -1, -1, 
	-1, -1, 267, 267, 267, 267, -1, -1, 
	267, 267, -1, 267, 267, 267, -1, -1, 
	263, -1, 267, 267, 267, -1, 267, 267, 
	267, 267, -1, -1, -1, -1, 267, -1, 
	-1, -1, -1, 267, -1, -1, -1, 267, 
	267, 267, 267, -1, 267, 267, -1, -1, 
	267, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 267, 267, 267, 267, 267, 267, 
	267, 267, -1, -1, -1, -1, 267, 267, 
	-1, -1, 267, 267, -1, -1, -1, -1, 
	-1, -1, -1, -1, 267, 267, -1, -1, 
	-1, -1, 267, 268, 268, 268, 268, 268, 
	268, 268, -1, 268, 268, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 268, 268, 
	268, 268, 268, -1, -1, -1, -1, -1, 
	267, 267, -1, -1, -1, 268, -1, -1, 
	-1, 268, -1, -1, -1, 268, 268, 268, 
	268, 268, 268, -1, -1, -1, -1, 268, 
	268, 268, -1, -1, -1, -1, 268, 268, 
	-1, 268, 268, 268, 268, -1, -1, -1, 
	-1, -1, -1, -1, 268, 269, 269, 269, 
	269, 269, 269, 269, -1, 269, 269, -1, 
	-1, -1, 268, 268, 268, 268, 268, -1, 
	269, 269, 269, 269, 269, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 269, 
	-1, -1, -1, 269, -1, -1, -1, 269, 
	269, 269, 269, 269, 269, -1, -1, -1, 
	-1, 269, 269, 269, -1, -1, -1, -1, 
	269, 269, -1, 269, 269, 269, 269, -1, 
	-1, -1, -1, -1, -1, -1, 269, -1, 
	-1, -1, -1, -1, -1, -1, 263, 263, 
	263, -1, -1, -1, 269, 269, 269, 269, 
	269, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 267, -1, -1, -1, -1, 
	-1, -1, 264, 264, 264, 264, -1, 264, 
	264, 264, -1, -1, -1, -1, 264, 268, 
	268, 268, -1, 268, 268, 268, -1, -1, 
	-1, -1, 268, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 264, 264, 264, 264, -1, -1, -1, 
	-1, -1, -1, -1, -1, 268, 268, 268, 
	268, 268, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 269, 269, 269, -1, 269, 269, 269, 
	-1, -1, -1, -1, 269, 270, 270, 270, 
	270, 270, 270, 270, -1, 270, 270, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	270, 270, 270, 270, 270, -1, -1, 269, 
	269, 269, 269, 269, -1, -1, -1, 270, 
	-1, -1, 267, 270, -1, -1, -1, 270, 
	270, 270, 270, 270, 270, -1, -1, -1, 
	-1, 270, 270, 270, -1, -1, -1, -1, 
	270, 270, -1, 270, 270, 270, 270, -1, 
	-1, -1, -1, -1, -1, -1, 270, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 270, 270, 270, 270, 
	270, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 265, 265, 265, 265, -1, 
	265, 265, 265, -1, -1, -1, -1, 265, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 265, 265, 265, 265, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 270, 270, 270, -1, 270, 270, 270, 
	-1, -1, -1, -1, 270, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 271, 271, 271, 271, 271, 271, 
	271, -1, 271, 271, -1, -1, -1, 270, 
	270, 270, 270, 270, -1, 271, 271, 271, 
	271, 271, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 271, -1, -1, -1, 
	271, -1, -1, -1, 271, 271, 271, 271, 
	271, 271, -1, -1, -1, -1, 271, 271, 
	271, -1, -1, -1, -1, 271, 271, -1, 
	271, 271, 271, 271, -1, -1, -1, -1, 
	-1, -1, -1, 271, 272, 272, 272, 272, 
	272, 272, 272, -1, 272, 272, -1, -1, 
	-1, 271, 271, 271, 271, 271, -1, 272, 
	272, 272, 272, 272, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 272, -1, 
	-1, -1, 272, -1, -1, -1, 272, 272, 
	272, 272, 272, 272, -1, -1, -1, -1, 
	272, 272, 272, -1, -1, -1, -1, 272, 
	272, -1, 272, 272, 272, 272, -1, -1, 
	-1, -1, -1, -1, -1, 272, 273, 273, 
	273, 273, 273, 273, 273, -1, 273, 273, 
	-1, -1, -1, 272, 272, 272, 272, 272, 
	-1, 273, 273, 273, 273, 273, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	273, -1, -1, -1, 273, -1, -1, -1, 
	273, 273, 273, 273, 273, 273, -1, -1, 
	-1, -1, 273, 273, 273, -1, -1, -1, 
	-1, 273, 273, -1, 273, 273, 273, 273, 
	-1, -1, -1, -1, -1, -1, -1, 273, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 273, 273, 273, 
	273, 273, -1, -1, -1, -1, 271, 271, 
	271, -1, 271, 271, 271, -1, -1, -1, 
	-1, 271, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	268, 268, 268, -1, 268, 268, 268, -1, 
	-1, -1, -1, 268, 271, 271, 271, 271, 
	271, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 268, 268, 
	268, 268, -1, -1, -1, -1, -1, -1, 
	272, 272, 272, -1, 272, 272, 272, -1, 
	-1, -1, -1, 272, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 269, 269, 269, -1, 269, 269, 
	269, -1, -1, -1, -1, 269, 272, 272, 
	272, 272, 272, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	269, 269, 269, 269, -1, -1, -1, -1, 
	-1, -1, 273, 273, 273, -1, 273, 273, 
	273, -1, -1, -1, -1, 273, 274, 274, 
	274, 274, 274, 274, 274, -1, 274, 274, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 274, 274, 274, 274, 274, -1, -1, 
	273, 273, 273, 273, 273, -1, -1, -1, 
	274, -1, -1, -1, 274, -1, -1, -1, 
	274, 274, 274, 274, 274, 274, -1, -1, 
	-1, -1, 274, 274, 274, -1, -1, -1, 
	-1, 274, 274, -1, 274, 274, 274, 274, 
	-1, -1, -1, -1, -1, -1, -1, 274, 
	275, 275, 275, 275, 275, 275, 275, -1, 
	275, 275, -1, -1, -1, 274, 274, 274, 
	274, 274, -1, 275, 275, 275, 275, 275, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 275, -1, -1, -1, 275, -1, 
	-1, -1, 275, 275, 275, 275, 275, 275, 
	-1, -1, -1, -1, 275, 275, 275, -1, 
	-1, -1, -1, 275, 275, -1, 275, 275, 
	275, 275, -1, -1, -1, -1, -1, -1, 
	-1, 275, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 275, 
	275, 275, 275, 275, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 270, 270, 270, -1, 270, 270, 
	270, -1, -1, -1, -1, 270, -1, -1, 
	-1, 646, 646, 646, 646, 646, 646, 646, 
	646, 646, 646, 646, 646, -1, -1, 646, 
	646, 646, 646, -1, -1, -1, -1, -1, 
	270, 270, 270, 270, -1, -1, -1, 646, 
	646, 646, -1, 274, 274, 646, 274, 274, 
	274, -1, 646, -1, -1, 274, -1, -1, 
	646, 646, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 646, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	274, 274, 274, 274, 274, -1, -1, 646, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 646, 646, -1, -1, 
	-1, -1, -1, -1, -1, 275, 275, -1, 
	275, 275, 275, -1, -1, -1, -1, 275, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 276, 276, 276, 
	276, 276, 276, 276, -1, 276, 276, -1, 
	-1, -1, 275, 275, 275, 275, 275, -1, 
	276, 276, 276, 276, 276, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 276, 
	-1, -1, -1, 276, -1, -1, -1, 276, 
	276, 276, 276, 276, 276, -1, -1, -1, 
	-1, 276, 276, 276, -1, -1, -1, -1, 
	276, 276, -1, 276, 276, 276, 276, -1, 
	-1, -1, -1, -1, -1, -1, 276, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 276, 276, 276, 276, 
	276, -1, -1, -1, -1, 646, 646, -1, 
	-1, -1, -1, -1, -1, -1, 646, 646, 
	646, -1, 646, 646, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 646, -1, 271, 
	271, 271, 646, 271, 271, 271, -1, -1, 
	-1, -1, 271, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	646, 646, -1, -1, -1, 271, 271, 271, 
	271, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 646, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 272, 272, 272, -1, 272, 272, 272, 
	-1, -1, -1, -1, 272, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 272, 
	272, 272, 272, -1, -1, -1, -1, -1, 
	-1, -1, -1, 276, -1, 276, 276, 276, 
	-1, -1, -1, -1, 276, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 273, 273, 273, -1, 273, 
	273, 273, -1, -1, -1, -1, 273, 276, 
	276, 276, 276, 276, -1, -1, -1, -1, 
	-1, -1, 277, 277, 277, 277, 277, 277, 
	277, -1, 277, 277, -1, -1, -1, -1, 
	-1, 273, 273, 273, 273, 277, 277, 277, 
	277, 277, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 277, -1, -1, -1, 
	277, -1, -1, -1, 277, 277, 277, 277, 
	277, 277, -1, -1, -1, -1, 277, 277, 
	277, -1, -1, -1, -1, 277, 277, -1, 
	277, 277, 277, 277, -1, -1, -1, -1, 
	-1, -1, -1, 277, -1, -1, -1, 352, 
	352, 352, 352, 352, 352, 352, -1, 352, 
	352, 277, 277, 277, 277, 277, -1, -1, 
	-1, -1, 352, 352, 352, 352, 352, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 352, -1, -1, -1, 352, -1, -1, 
	-1, 352, 352, 352, 352, 352, 352, -1, 
	-1, -1, -1, 352, 352, 352, -1, -1, 
	-1, -1, 352, 352, -1, 352, 352, 352, 
	352, -1, -1, -1, -1, -1, -1, -1, 
	352, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 352, 352, 
	352, 352, 352, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 352, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 274, 274, -1, 274, 
	274, 274, -1, -1, -1, -1, 274, -1, 
	277, -1, 277, 277, 277, -1, -1, -1, 
	-1, 277, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 274, 274, 274, 274, -1, -1, -1, 
	-1, -1, -1, -1, 277, 277, 277, 277, 
	277, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 275, 275, 
	-1, 275, 275, 275, -1, -1, -1, -1, 
	275, 352, 352, 352, 352, 352, -1, 352, 
	352, 352, -1, -1, -1, -1, 352, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 352, 352, 275, 275, 275, 275, -1, 
	-1, -1, 352, -1, -1, -1, -1, -1, 
	-1, 352, 352, 352, 352, 352, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 352, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 279, 279, 279, 279, 
	279, 279, 279, 279, 279, 279, 279, 279, 
	279, 279, 279, 279, 279, 279, 279, 279, 
	279, 279, 279, 279, 279, 279, 279, 279, 
	279, 279, 279, 279, 279, -1, 279, -1, 
	279, 279, 279, 279, 279, 279, -1, 279, 
	279, 279, -1, -1, 279, 279, 279, 279, 
	279, 279, 279, 279, -1, 279, 279, 279, 
	279, -1, -1, -1, 279, 279, 279, 279, 
	279, -1, -1, 279, 279, 279, 279, -1, 
	-1, -1, 279, 279, -1, -1, 279, 279, 
	-1, 279, 279, 279, 279, -1, -1, 279, 
	279, 279, -1, -1, -1, -1, -1, -1, 
	-1, 279, -1, -1, -1, -1, 279, 279, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 279, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	279, -1, -1, -1, 276, -1, 276, 276, 
	276, -1, -1, -1, -1, 276, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 279, 279, 279, 279, 
	-1, -1, 279, 279, 279, 279, 279, 279, 
	276, 276, 276, 276, 279, 279, 279, 279, 
	279, 279, 279, 279, -1, -1, 279, -1, 
	279, -1, -1, -1, -1, 279, 279, -1, 
	279, 279, 279, 279, 279, -1, 279, 279, 
	-1, -1, 279, -1, -1, -1, -1, -1, 
	-1, 279, -1, 279, 279, 279, 279, 279, 
	279, 279, 279, 279, -1, -1, -1, -1, 
	279, 279, -1, 279, 279, 279, -1, -1, 
	-1, -1, -1, -1, -1, -1, 279, 279, 
	279, -1, 279, -1, 279, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 279, 279, 279, 
	-1, -1, 279, 279, 279, -1, -1, -1, 
	-1, -1, 279, 279, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, -1, 280, 280, 280, 
	280, 280, -1, 280, -1, 280, 280, 280, 
	280, -1, 280, -1, 280, 280, 280, -1, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, -1, 280, 280, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, -1, 280, -1, 
	-1, -1, -1, 280, 280, 280, 280, 280, 
	-1, -1, 280, 280, 280, 280, 280, 280, 
	280, 280, 280, 280, 280, 280, 280, 280, 
	280, 280, -1, 280, 280, -1, -1, -1, 
	-1, -1, 280, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 277, -1, 277, 277, 277, -1, -1, 
	-1, -1, 277, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 277, 277, 277, 
	277, 280, 280, 280, 280, 279, -1, 280, 
	280, 280, 280, 280, 280, -1, -1, -1, 
	-1, 280, 280, 280, 280, 280, 280, 280, 
	280, -1, -1, -1, -1, 280, -1, -1, 
	-1, -1, 280, 280, -1, -1, 280, 280, 
	280, 280, -1, 280, 280, -1, -1, 280, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 280, 280, 280, 280, 280, 280, 280, 
	280, -1, -1, -1, 280, 280, 280, -1, 
	-1, 280, 280, -1, 280, 280, 280, 280, 
	280, -1, 280, 280, 280, -1, -1, -1, 
	280, 280, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 280, 280, -1, 352, 
	280, -1, -1, -1, -1, 280, -1, -1, 
	-1, -1, 280, -1, 280, 280, 280, 280, 
	280, 281, 281, 281, 281, 281, 281, 281, 
	-1, 281, 281, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 281, 281, 281, 281, 
	281, -1, -1, -1, 279, -1, -1, -1, 
	-1, -1, -1, 281, -1, -1, -1, 281, 
	-1, -1, -1, 281, 281, 281, 281, 281, 
	281, -1, -1, -1, -1, 281, 281, 281, 
	-1, -1, -1, -1, 281, 281, -1, 281, 
	281, 281, 281, -1, -1, -1, -1, -1, 
	-1, -1, 281, 281, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	281, 281, 281, 281, 281, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	282, 282, 282, 282, 282, 282, 282, 282, 
	282, 282, 282, 282, 282, 282, 282, 282, 
	282, 282, 282, 282, 282, 282, 282, 282, 
	282, 282, 282, -1, 282, 282, 282, 282, 
	282, -1, 282, -1, 282, 282, 282, 282, 
	-1, 282, -1, 282, 282, 282, -1, -1, 
	282, 282, 282, 282, 282, 282, 282, 282, 
	-1, 282, 282, 282, -1, -1, -1, -1, 
	282, 282, 282, 282, 282, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 280, -1, -1, 282, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 282, 282, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	281, 281, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 281, 281, 281, 281, 281, 
	-1, 281, 281, 281, -1, -1, -1, -1, 
	281, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 279, -1, 281, 281, 281, 281, 281, 
	282, 282, 282, 282, -1, -1, 282, 282, 
	-1, 282, 282, 282, -1, -1, -1, -1, 
	282, 282, 282, -1, 282, 282, 282, 282, 
	-1, -1, -1, -1, 282, -1, -1, -1, 
	-1, 282, -1, -1, -1, 282, 282, 282, 
	282, -1, 282, 282, -1, -1, 282, -1, 
	-1, 280, -1, -1, -1, -1, -1, -1, 
	282, 282, 282, 282, 282, 282, 282, 282, 
	-1, -1, -1, -1, 282, 282, -1, -1, 
	282, 282, -1, -1, -1, -1, -1, -1, 
	-1, -1, 282, 282, -1, -1, -1, -1, 
	282, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 282, 282, 
	-1, -1, 284, 284, 284, 284, 284, 284, 
	284, 284, 284, 284, 284, 284, 284, 284, 
	284, 284, -1, 284, 284, 284, 284, 284, 
	284, 284, 284, -1, -1, -1, 284, 284, 
	284, 284, 284, -1, 284, -1, 284, 284, 
	284, 284, -1, 284, -1, 284, 284, 284, 
	-1, -1, 284, -1, -1, 284, 284, 284, 
	284, 284, -1, 284, 284, 284, -1, -1, 
	-1, -1, 284, 284, 284, 284, 284, -1, 
	-1, -1, -1, 692, 692, 692, 692, 692, 
	692, 692, 692, 692, -1, 692, 692, -1, 
	-1, 692, 692, 692, 692, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 692, 692, 692, 284, 284, -1, 692, 
	-1, -1, -1, -1, 692, -1, -1, -1, 
	-1, -1, 692, 692, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	692, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	692, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 692, 692, 
	-1, -1, 284, 284, 284, 284, -1, -1, 
	284, 284, 284, 284, 284, 284, -1, -1, 
	-1, 282, 284, 284, 284, 284, 284, 284, 
	284, 284, -1, -1, -1, -1, 284, -1, 
	-1, -1, -1, 284, -1, -1, -1, 284, 
	284, 284, 284, -1, 284, 284, -1, -1, 
	284, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 284, 284, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 284, 284, -1, -1, -1, -1, 
	-1, -1, -1, -1, 284, 284, -1, -1, 
	-1, -1, 284, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	284, 284, -1, -1, -1, -1, -1, 692, 
	692, -1, -1, -1, -1, -1, -1, 692, 
	-1, -1, -1, -1, 692, 692, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 692, 
	-1, -1, -1, -1, 692, -1, -1, -1, 
	282, 285, 285, 285, 285, 285, 285, 285, 
	285, 285, 285, 285, 285, 285, 285, 285, 
	285, -1, 285, 285, 285, 285, 285, 285, 
	285, 285, 692, 692, -1, 285, 285, 285, 
	285, 285, -1, 285, -1, 285, 285, 285, 
	285, -1, 285, -1, 285, 285, 285, -1, 
	-1, 285, -1, -1, 285, 285, 285, 285, 
	285, -1, 285, 285, 285, -1, -1, -1, 
	-1, 285, 285, 285, 285, 285, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 285, 285, -1, -1, -1, 
	-1, 281, 281, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 281, 281, 281, 281, 
	281, -1, 281, 281, 281, -1, -1, -1, 
	-1, 281, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 284, -1, -1, -1, -1, 
	-1, -1, -1, -1, 281, 281, 281, 281, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 285, 285, 285, 285, -1, -1, 285, 
	285, 285, 285, 285, 285, -1, -1, -1, 
	-1, 285, 285, 285, 285, 285, 285, 285, 
	285, -1, -1, -1, -1, 285, -1, -1, 
	-1, -1, 285, 285, -1, -1, 285, 285, 
	285, 285, -1, 285, 285, -1, -1, 285, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 285, 285, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 285, 285, -1, -1, -1, -1, -1, 
	-1, -1, -1, 285, 285, -1, -1, -1, 
	-1, 285, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 285, 
	285, -1, 284, 289, 289, 289, 289, 289, 
	289, 289, 289, 289, 289, 289, 289, 289, 
	289, 289, 289, -1, 289, 289, 289, 289, 
	289, 289, 289, 289, -1, -1, -1, 289, 
	289, 289, 289, 289, -1, 289, -1, 289, 
	289, 289, 289, -1, 289, -1, 289, 289, 
	289, -1, -1, 289, -1, -1, 289, 289, 
	289, 289, 289, -1, 289, 289, 289, -1, 
	-1, -1, -1, 289, 289, 289, 289, 289, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 289, 289, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 289, 289, 289, 289, -1, 
	-1, 289, 289, -1, 289, 289, 289, -1, 
	-1, -1, 285, 289, 289, 289, -1, 289, 
	289, 289, 289, -1, -1, -1, -1, 289, 
	-1, -1, -1, -1, 289, 289, -1, -1, 
	289, 289, 289, 289, -1, 289, 289, -1, 
	-1, 289, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 289, 289, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 289, 289, -1, -1, -1, 
	-1, -1, -1, -1, -1, 289, 289, -1, 
	-1, -1, -1, 289, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 289, 289, -1, -1, -1, 290, 290, 
	290, 290, 290, 290, 290, 290, 290, 290, 
	290, 290, 290, 290, 290, 290, 290, 290, 
	290, 290, 290, 290, 290, 290, 290, 290, 
	290, -1, 290, 290, 290, 290, 290, -1, 
	290, 285, 290, 290, 290, 290, -1, 290, 
	-1, 290, 290, 290, -1, -1, 290, 290, 
	290, 290, 290, 290, 290, 290, -1, 290, 
	290, 290, -1, -1, -1, -1, 290, 290, 
	290, 290, 290, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 290, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	290, 290, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 290, 290, 
	290, 290, -1, -1, 290, 290, -1, 290, 
	290, 290, -1, -1, 289, -1, 290, 290, 
	290, -1, 290, 290, 290, 290, -1, -1, 
	-1, -1, 290, -1, -1, -1, -1, 290, 
	-1, -1, -1, 290, 290, 290, 290, -1, 
	290, 290, -1, -1, 290, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 290, 290, 
	290, 290, 290, 290, 290, 290, -1, -1, 
	-1, -1, 290, 290, -1, -1, 290, 290, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	290, 290, -1, -1, -1, -1, 290, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 290, 290, -1, -1, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	292, 292, 292, -1, 292, 292, 292, 292, 
	292, -1, 292, 289, 292, 292, 292, 292, 
	-1, 292, -1, 292, 292, 292, -1, -1, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	-1, 292, 292, 292, -1, -1, -1, -1, 
	292, 292, 292, 292, 292, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 292, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 292, 292, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	292, 292, 292, 292, -1, -1, 292, 292, 
	-1, 292, 292, 292, -1, -1, -1, 290, 
	292, 292, 292, -1, 292, 292, 292, 292, 
	-1, -1, -1, -1, 292, -1, -1, -1, 
	-1, 292, -1, -1, -1, 292, 292, 292, 
	292, -1, 292, 292, -1, -1, 292, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	292, 292, 292, 292, 292, 292, 292, 292, 
	-1, -1, -1, -1, 292, 292, -1, -1, 
	292, 292, -1, -1, -1, -1, -1, -1, 
	-1, -1, 292, 292, -1, -1, -1, -1, 
	292, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 292, 292, 
	-1, -1, -1, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 293, 293, -1, 293, 
	293, 293, 293, 293, -1, 293, 290, 293, 
	293, 293, 293, -1, 293, -1, 293, 293, 
	293, -1, -1, 293, 293, 293, 293, 293, 
	293, 293, 293, -1, 293, 293, 293, -1, 
	-1, -1, -1, 293, 293, 293, 293, 293, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	293, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 293, 293, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 293, 293, 293, 293, -1, 
	-1, 293, 293, -1, 293, 293, 293, -1, 
	-1, 292, -1, 293, 293, 293, -1, 293, 
	293, 293, 293, -1, -1, -1, -1, 293, 
	-1, -1, -1, -1, 293, -1, -1, -1, 
	293, 293, 293, 293, -1, 293, 293, -1, 
	-1, 293, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 293, 293, 293, 293, 293, 
	293, 293, 293, -1, -1, -1, -1, 293, 
	293, -1, -1, 293, 293, -1, -1, -1, 
	-1, -1, -1, -1, -1, 293, 293, -1, 
	-1, -1, -1, 293, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 293, 293, -1, -1, 299, 299, 299, 
	299, 299, 299, 299, 299, 299, 299, 299, 
	299, 299, 299, 299, 299, 299, 299, 299, 
	299, 299, 299, 299, 299, 299, 299, 299, 
	-1, 299, 299, 299, 299, 299, -1, 299, 
	292, 299, 299, 299, 299, 299, 299, -1, 
	299, 299, 299, -1, -1, 299, 299, 299, 
	299, 299, 299, 299, 299, -1, 299, 299, 
	299, 299, -1, -1, -1, 299, 299, 299, 
	299, 299, -1, -1, -1, -1, -1, 299, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 299, -1, -1, 299, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 299, 
	299, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 299, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 299, 299, 299, 
	299, -1, -1, 299, 299, 299, 299, 299, 
	299, -1, -1, -1, 293, 299, 299, 299, 
	299, 299, 299, 299, 299, -1, -1, 299, 
	-1, 299, -1, -1, -1, -1, 299, 299, 
	-1, 299, 299, 299, 299, 299, -1, 299, 
	299, -1, -1, 299, -1, -1, -1, -1, 
	-1, -1, 299, -1, 299, 299, 299, 299, 
	299, 299, 299, 299, 299, -1, -1, -1, 
	-1, 299, 299, -1, 299, 299, 299, -1, 
	-1, -1, -1, -1, -1, -1, -1, 299, 
	299, 292, 292, 292, -1, 299, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 299, 299, -1, -1, -1, 
	301, 301, 301, 301, 301, 301, 301, 301, 
	301, 301, 301, 301, 301, 301, 301, 301, 
	-1, 301, 301, 301, 301, 301, 301, 301, 
	301, -1, -1, -1, 301, 301, 301, 301, 
	301, -1, 301, 293, 301, 301, 301, 301, 
	-1, 301, -1, 301, 301, 301, -1, -1, 
	301, -1, -1, 301, 301, 301, 301, 301, 
	-1, 301, 301, 301, -1, -1, -1, -1, 
	301, 301, 301, 301, 301, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 301, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 301, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 301, 301, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	301, 301, 301, 301, -1, -1, 301, 301, 
	301, 301, 301, 301, -1, -1, 299, -1, 
	301, 301, 301, 301, 301, 301, 301, 301, 
	-1, -1, -1, -1, 301, -1, -1, -1, 
	-1, 301, 301, -1, -1, 301, 301, 301, 
	301, -1, 301, 301, -1, -1, 301, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 301, 301, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	301, 301, -1, -1, -1, -1, -1, -1, 
	-1, -1, 301, 301, -1, -1, -1, -1, 
	301, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 301, 301, 
	-1, -1, 302, 302, 302, 302, 302, 302, 
	302, 302, 302, 302, 302, 302, 302, 302, 
	302, 302, -1, 302, 302, 302, 302, 302, 
	302, 302, 302, -1, -1, -1, 302, 302, 
	302, 302, 302, -1, 302, 299, 302, 302, 
	302, 302, -1, 302, -1, 302, 302, 302, 
	-1, -1, 302, -1, -1, 302, 302, 302, 
	302, 302, -1, 302, 302, 302, -1, -1, 
	-1, -1, 302, 302, 302, 302, 302, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 304, -1, 304, 
	304, 304, 304, 304, -1, 302, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 302, 302, -1, -1, 
	-1, 304, 304, 304, 304, 304, -1, 304, 
	-1, 304, -1, -1, -1, -1, 304, -1, 
	-1, 304, -1, -1, -1, -1, -1, -1, 
	304, 304, 304, -1, -1, -1, 304, 304, 
	304, -1, -1, -1, -1, 304, 304, 304, 
	-1, 304, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 302, 302, 302, 302, -1, -1, 
	302, 302, 302, 302, 302, 302, -1, -1, 
	-1, 301, 302, 302, 302, 302, 302, 302, 
	302, 302, -1, -1, -1, -1, 302, -1, 
	-1, -1, -1, 302, 302, -1, -1, 302, 
	302, 302, 302, -1, 302, 302, -1, -1, 
	302, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 302, 302, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 302, 302, -1, -1, -1, -1, 
	-1, -1, -1, -1, 302, 302, -1, 304, 
	304, -1, 302, 304, 304, 304, 304, -1, 
	304, -1, -1, -1, -1, 304, 304, 304, 
	304, 304, 304, 304, 304, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	302, 302, 304, -1, 304, 304, -1, 304, 
	304, -1, -1, 304, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 304, -1, -1, 
	301, -1, -1, -1, -1, -1, -1, 304, 
	304, 306, 306, 306, 306, 306, 306, 306, 
	306, 306, 306, 306, 306, 306, 306, 306, 
	306, -1, 306, 306, 306, 306, 306, 306, 
	306, 306, -1, -1, -1, 306, 306, 306, 
	306, 306, -1, 306, -1, 306, 306, 306, 
	306, -1, 306, -1, 306, 306, 306, -1, 
	-1, 306, -1, -1, 306, 306, 306, 306, 
	306, -1, 306, 306, 306, 306, -1, -1, 
	-1, 306, 306, 306, 306, 306, -1, 306, 
	359, 359, 359, 359, 359, 359, 359, -1, 
	359, 359, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 359, 359, 359, 359, 359, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 359, 306, 306, -1, 359, -1, 
	-1, -1, 359, 359, 359, 359, 359, 359, 
	-1, -1, -1, -1, 359, 359, 359, -1, 
	-1, -1, -1, 359, 359, -1, 359, 359, 
	359, 359, 359, -1, -1, -1, -1, -1, 
	-1, 359, -1, 302, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 359, 
	359, 359, 359, 359, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	359, 306, 306, 306, 306, -1, -1, 306, 
	306, 306, 306, 306, 306, -1, -1, -1, 
	-1, 306, 306, 306, 306, 306, 306, 306, 
	306, -1, 306, 306, -1, 306, -1, -1, 
	-1, -1, 306, 306, -1, -1, 306, 306, 
	306, 306, -1, 306, 306, -1, -1, 306, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 306, 306, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 306, 306, -1, -1, -1, -1, -1, 
	-1, -1, -1, 306, 306, -1, -1, -1, 
	-1, 306, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 302, -1, -1, -1, -1, 306, 
	306, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 359, 359, 359, 359, 359, -1, 
	359, 359, 359, -1, -1, -1, -1, 359, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 359, 359, -1, -1, -1, -1, 
	-1, -1, -1, 359, -1, -1, -1, -1, 
	-1, -1, 359, 359, 359, 359, 359, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	307, 307, 307, 307, 307, 307, 307, 307, 
	307, 307, 307, 307, 307, 307, 307, 307, 
	-1, 307, 307, 307, 307, 307, 307, 307, 
	307, -1, 306, -1, 307, 307, 307, 307, 
	307, -1, 307, -1, 307, 307, 307, 307, 
	-1, 307, -1, 307, 307, 307, -1, -1, 
	307, -1, -1, 307, 307, 307, 307, 307, 
	-1, 307, 307, 307, 307, -1, -1, -1, 
	307, 307, 307, 307, 307, -1, 307, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	304, 304, -1, -1, 304, 304, 304, 304, 
	-1, 304, -1, -1, -1, -1, 304, 304, 
	304, 304, 304, 304, 304, 304, 307, -1, 
	-1, -1, 307, 307, -1, -1, -1, -1, 
	-1, -1, -1, 304, -1, 304, 304, -1, 
	304, 304, -1, -1, 304, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 304, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 306, -1, -1, -1, -1, -1, -1, 
	307, 307, 307, 307, -1, -1, 307, 307, 
	307, 307, 307, 307, -1, -1, -1, -1, 
	307, 307, 307, 307, 307, 307, 307, 307, 
	-1, 307, 307, 307, 307, -1, -1, -1, 
	-1, 307, 307, -1, -1, 307, 307, 307, 
	307, -1, 307, 307, -1, -1, 307, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 307, 307, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	307, 307, -1, -1, -1, -1, -1, -1, 
	-1, -1, 307, 307, -1, -1, -1, -1, 
	307, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 307, 307, 
	-1, -1, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, 308, 308, 308, 
	308, 308, 308, 308, 308, -1, 308, 308, 
	308, 308, 308, -1, 308, -1, 308, 308, 
	308, 308, -1, 308, -1, 308, 308, 308, 
	-1, -1, 308, 308, 308, 308, 308, 308, 
	308, 308, -1, 308, 308, 308, -1, -1, 
	-1, -1, 308, 308, 308, 308, 308, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 308, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 308, 308, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 308, 308, 308, 308, -1, -1, 
	308, 308, -1, 308, 308, 308, -1, -1, 
	-1, 307, 308, 308, 308, -1, 308, 308, 
	308, 308, -1, -1, -1, -1, 308, -1, 
	-1, -1, -1, 308, -1, -1, -1, 308, 
	308, 308, 308, -1, 308, 308, -1, -1, 
	308, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 308, 308, 308, 308, 308, 308, 
	308, 308, -1, -1, -1, -1, 308, 308, 
	-1, -1, 308, 308, -1, -1, -1, -1, 
	-1, -1, -1, -1, 308, 308, -1, -1, 
	-1, -1, 308, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	308, 308, -1, -1, -1, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	-1, 309, 309, 309, 309, 309, -1, 309, 
	307, 309, 309, 309, 309, -1, 309, -1, 
	309, 309, 309, -1, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, -1, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, -1, 309, -1, -1, -1, -1, 309, 
	309, 309, 309, 309, -1, -1, 309, 309, 
	309, 309, 309, 309, 309, 309, 309, 309, 
	309, 309, 309, 309, 309, 309, -1, 309, 
	309, -1, -1, -1, -1, -1, 309, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 309, 309, 309, 
	309, -1, -1, 309, 309, 309, 309, 309, 
	309, -1, -1, 308, -1, 309, 309, 309, 
	309, 309, 309, 309, 309, -1, -1, -1, 
	-1, 309, -1, -1, -1, -1, 309, 309, 
	-1, -1, 309, 309, 309, 309, -1, 309, 
	309, -1, -1, 309, -1, -1, -1, -1, 
	-1, -1, -1, -1, 307, 309, 309, 309, 
	309, 309, 309, 309, 309, -1, -1, -1, 
	309, 309, 309, -1, -1, 309, 309, -1, 
	309, 309, 309, 309, 309, -1, 309, 309, 
	309, -1, -1, -1, 309, 309, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	309, 309, -1, -1, 309, -1, -1, -1, 
	-1, 309, -1, -1, -1, -1, 309, -1, 
	309, 309, 309, 309, 309, -1, -1, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, -1, 310, 310, 310, 310, 310, 
	-1, 310, 308, 310, 310, 310, 310, -1, 
	310, -1, 310, 310, 310, -1, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, -1, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, -1, 310, -1, -1, -1, 
	-1, 310, 310, 310, 310, 310, -1, -1, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	310, 310, 310, 310, 310, 310, 310, 310, 
	-1, 310, 310, -1, -1, -1, -1, -1, 
	310, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 310, 
	310, 310, 310, -1, -1, 310, 310, 310, 
	310, 310, 310, -1, -1, -1, 309, 310, 
	310, 310, 310, 310, 310, 310, 310, -1, 
	-1, -1, -1, 310, -1, -1, -1, -1, 
	310, 310, -1, -1, 310, 310, 310, 310, 
	-1, 310, 310, -1, -1, 310, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 310, 
	310, 310, 310, 310, 310, 310, 310, -1, 
	-1, -1, 310, 310, 310, -1, -1, 310, 
	310, -1, 310, 310, 310, 310, 310, -1, 
	310, 310, 310, -1, -1, -1, 310, 310, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 310, 310, -1, -1, 310, -1, 
	-1, -1, -1, 310, -1, -1, -1, -1, 
	310, -1, 310, 310, 310, 310, 310, -1, 
	-1, -1, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, 311, 311, 311, 
	311, 311, 311, 311, 311, -1, 311, 311, 
	311, 311, 311, -1, 311, 309, 311, 311, 
	311, 311, -1, 311, -1, 311, 311, 311, 
	-1, -1, 311, 311, 311, 311, 311, 311, 
	311, 311, -1, 311, 311, 311, -1, -1, 
	-1, -1, 311, 311, 311, 311, 311, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 311, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 311, 311, -1, 311, 311, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 311, 311, 311, 311, -1, -1, 
	311, 311, 311, 311, 311, 311, -1, -1, 
	310, -1, 311, 311, 311, 311, 311, 311, 
	311, 311, -1, -1, -1, -1, 311, -1, 
	-1, -1, -1, 311, 311, -1, -1, 311, 
	311, 311, 311, -1, 311, 311, -1, -1, 
	311, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 311, 311, 311, 311, 311, 311, 
	311, 311, -1, -1, -1, -1, 311, 311, 
	-1, -1, 311, 311, -1, -1, -1, -1, 
	-1, -1, -1, -1, 311, 311, -1, -1, 
	-1, -1, 311, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	311, 311, -1, -1, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, 313, 313, -1, 
	313, 313, 313, 313, 313, -1, 313, 310, 
	313, 313, 313, 313, -1, 313, -1, 313, 
	313, 313, -1, 313, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, 313, 313, 313, 
	-1, 313, 313, 313, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, 313, 313, 313, 
	-1, 313, -1, -1, 313, 313, 313, 313, 
	313, 313, 313, -1, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, 313, 313, 313, 
	313, 313, 313, 313, 313, -1, 313, 313, 
	-1, -1, -1, -1, -1, 313, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 313, 313, 313, 313, 
	-1, -1, 313, 313, 313, 313, 313, 313, 
	-1, -1, -1, 311, 313, 313, 313, 313, 
	313, 313, 313, 313, -1, -1, -1, -1, 
	313, -1, -1, -1, -1, 313, 313, -1, 
	-1, 313, 313, 313, 313, -1, 313, 313, 
	-1, -1, 313, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 313, 313, 313, 313, 
	313, 313, 313, 313, -1, -1, -1, 313, 
	313, 313, -1, -1, 313, 313, -1, 313, 
	313, 313, 313, 313, -1, 313, 313, 313, 
	-1, -1, -1, 313, 313, -1, -1, -1, 
	-1, -1, -1, -1, 313, 313, 313, 313, 
	313, -1, -1, 313, -1, -1, -1, -1, 
	313, -1, 313, 313, 313, 313, -1, 313, 
	313, 313, 313, 313, -1, -1, -1, 315, 
	315, 315, 315, 315, 315, 315, 315, 315, 
	315, 315, 315, 315, 315, 315, 315, 315, 
	315, 315, 315, 315, 315, 315, 315, 315, 
	315, 315, -1, 315, 315, 315, 315, 315, 
	-1, 315, 311, 315, 315, 315, 315, -1, 
	315, -1, 315, 315, 315, -1, -1, 315, 
	315, 315, 315, 315, 315, 315, 315, -1, 
	315, 315, 315, -1, -1, -1, -1, 315, 
	315, 315, 315, 315, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 315, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 315, 315, 
	-1, 315, 315, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 315, 
	315, 315, 315, -1, -1, 315, 315, -1, 
	315, 315, 315, -1, -1, 313, -1, 315, 
	315, 315, -1, 315, 315, 315, 315, -1, 
	-1, -1, -1, 315, -1, -1, -1, -1, 
	315, -1, -1, -1, 315, 315, 315, 315, 
	-1, 315, 315, -1, -1, 315, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 315, 
	315, 315, 315, 315, 315, 315, 315, -1, 
	-1, -1, -1, 315, 315, -1, -1, 315, 
	315, -1, -1, -1, -1, -1, -1, -1, 
	-1, 315, 315, -1, -1, -1, -1, 315, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 315, 315, -1, 
	-1, 321, 321, 321, 321, 321, 321, 321, 
	321, 321, 321, 321, 321, 321, 321, 321, 
	321, 321, 321, 321, 321, 321, 321, 321, 
	321, 321, 321, 321, 321, 321, 321, 321, 
	321, 321, -1, 321, 313, 321, 321, 321, 
	321, 321, 321, -1, 321, 321, 321, -1, 
	-1, 321, 321, 321, 321, 321, 321, 321, 
	321, -1, 321, 321, 321, 321, -1, -1, 
	-1, 321, 321, 321, 321, 321, -1, 321, 
	321, 321, 321, 321, 321, 321, -1, 321, 
	-1, -1, -1, 321, 321, -1, 321, -1, 
	-1, 321, -1, -1, 321, -1, 321, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 321, 321, -1, -1, -1, 
	-1, -1, 321, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 321, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 321, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 321, 321, 321, 321, -1, -1, 321, 
	321, 321, 321, 321, 321, -1, -1, -1, 
	315, 321, 321, 321, 321, 321, 321, 321, 
	321, -1, -1, 321, -1, 321, -1, -1, 
	-1, -1, 321, 321, -1, 321, 321, 321, 
	321, 321, -1, 321, 321, -1, -1, 321, 
	-1, 321, 321, -1, -1, -1, 321, -1, 
	321, 321, 321, 321, 321, 321, 321, 321, 
	321, -1, -1, -1, -1, 321, 321, -1, 
	321, 321, 321, -1, -1, -1, -1, -1, 
	-1, -1, -1, 321, 321, -1, -1, 321, 
	-1, 321, 321, -1, -1, -1, 321, 321, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 321, 321, 321, -1, -1, 321, 
	321, 321, -1, -1, -1, -1, -1, 321, 
	321, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 315, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 322, 322, 322, 322, 
	322, 322, 322, 322, 322, 322, 322, 322, 
	322, 322, 322, 322, 322, 322, 322, 322, 
	322, 322, 322, 322, 322, 322, 322, 322, 
	322, 322, 322, 322, 322, -1, 322, -1, 
	322, 322, 322, 322, 322, 322, -1, 322, 
	322, 322, -1, -1, 322, 322, 322, 322, 
	322, 322, 322, 322, -1, 322, 322, 322, 
	322, -1, -1, -1, 322, 322, 322, 322, 
	322, -1, 322, 322, 322, 322, 322, 322, 
	322, -1, 322, -1, -1, -1, 322, 322, 
	-1, 322, -1, -1, 322, -1, -1, 322, 
	-1, 322, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 322, 322, 
	-1, -1, -1, -1, -1, 322, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 322, -1, 
	-1, -1, 321, -1, -1, -1, -1, -1, 
	322, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 322, 322, 322, 322, 
	-1, -1, 322, 322, 322, 322, 322, 322, 
	-1, -1, 321, 321, 322, 322, 322, 322, 
	322, 322, 322, 322, -1, -1, 322, -1, 
	322, -1, -1, -1, -1, 322, 322, -1, 
	322, 322, 322, 322, 322, -1, 322, 322, 
	-1, -1, 322, -1, 322, 322, -1, -1, 
	-1, 322, -1, 322, 322, 322, 322, 322, 
	322, 322, 322, 322, -1, -1, -1, -1, 
	322, 322, -1, 322, 322, 322, -1, -1, 
	-1, -1, -1, -1, -1, -1, 322, 322, 
	-1, -1, 322, -1, 322, 322, -1, -1, 
	-1, 322, 322, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 322, 322, 322, 
	-1, 321, 322, 322, 322, -1, -1, -1, 
	-1, -1, 322, 322, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 323, 323, 323, 323, 323, 323, 323, 
	323, 323, 323, 323, 323, 323, 323, 323, 
	323, 323, 323, 323, 323, 323, 323, 323, 
	323, 323, 323, 323, 323, 323, 323, 323, 
	323, 323, -1, 323, -1, 323, 323, 323, 
	323, 323, 323, -1, 323, 323, 323, -1, 
	-1, 323, 323, 323, 323, 323, 323, 323, 
	323, -1, 323, 323, 323, 323, -1, -1, 
	-1, 323, 323, 323, 323, 323, -1, 323, 
	323, 323, 323, 323, 323, 323, -1, 323, 
	-1, -1, -1, 323, 323, -1, 323, -1, 
	-1, 323, -1, -1, 323, -1, 323, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 323, 323, -1, -1, -1, 
	-1, -1, 323, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 323, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 323, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 322, -1, -1, 
	-1, 323, 323, 323, 323, -1, -1, 323, 
	323, 323, 323, 323, 323, -1, -1, -1, 
	-1, 323, 323, 323, 323, 323, 323, 323, 
	323, -1, -1, 323, -1, 323, -1, -1, 
	-1, -1, 323, 323, -1, 323, 323, 323, 
	323, 323, -1, 323, 323, 322, 322, 323, 
	-1, 323, 323, -1, -1, -1, 323, -1, 
	323, 323, 323, 323, 323, 323, 323, 323, 
	323, -1, -1, -1, -1, 323, 323, -1, 
	323, 323, 323, -1, -1, -1, -1, -1, 
	-1, -1, -1, 323, 323, -1, -1, 323, 
	-1, 323, 323, -1, -1, -1, 323, 323, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 323, 323, 323, -1, -1, 323, 
	323, 323, -1, -1, -1, -1, -1, 323, 
	323, -1, -1, -1, 326, 326, 326, 326, 
	326, 326, 326, 326, 326, 326, 326, 326, 
	326, 326, 326, 326, 322, 326, 326, 326, 
	326, 326, 326, 326, 326, -1, -1, -1, 
	326, 326, 326, 326, 326, -1, 326, -1, 
	326, 326, 326, 326, -1, 326, 326, 326, 
	326, 326, -1, -1, 326, -1, -1, 326, 
	326, 326, 326, 326, -1, 326, 326, 326, 
	-1, -1, -1, -1, 326, 326, 326, 326, 
	326, -1, -1, -1, -1, -1, -1, -1, 
	326, -1, -1, -1, -1, -1, -1, -1, 
	326, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 326, 326, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 326, 326, 326, 326, 
	-1, -1, 326, 326, 326, 326, 326, 326, 
	-1, -1, 323, -1, 326, 326, 326, 326, 
	326, 326, 326, 326, -1, -1, -1, -1, 
	326, -1, -1, -1, -1, 326, 326, -1, 
	-1, 326, 326, 326, 326, -1, 326, 326, 
	-1, -1, 326, -1, -1, -1, -1, 326, 
	-1, -1, 326, -1, -1, -1, -1, 326, 
	326, -1, 323, 323, -1, -1, -1, -1, 
	-1, -1, -1, -1, 326, 326, -1, -1, 
	-1, -1, -1, -1, -1, -1, 326, 326, 
	-1, -1, -1, -1, 326, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 326, 326, -1, -1, 347, 347, 
	347, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, 347, 347, 347, 347, 347, 347, 
	347, -1, 347, 347, 347, 347, 347, -1, 
	347, 323, 347, 347, 347, 347, -1, 347, 
	-1, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, -1, 347, 347, 347, 347, 347, 
	347, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, -1, 347, -1, -1, 347, -1, 
	347, 347, 347, 347, 347, -1, -1, 347, 
	347, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, 347, 347, 347, 347, 347, -1, 
	347, 347, -1, -1, -1, -1, -1, 347, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 347, 347, 
	347, 347, -1, -1, 347, 347, 347, 347, 
	347, 347, -1, -1, -1, 326, 347, 347, 
	347, 347, 347, 347, 347, 347, -1, -1, 
	-1, -1, 347, -1, -1, -1, -1, 347, 
	347, -1, -1, 347, 347, 347, 347, -1, 
	347, 347, -1, -1, 347, -1, -1, -1, 
	-1, -1, -1, 326, -1, -1, 347, 347, 
	347, 347, 347, 347, 347, 347, -1, -1, 
	-1, 347, 347, 347, -1, 326, 347, 347, 
	-1, 347, 347, 347, 347, 347, 347, 347, 
	347, 347, -1, -1, -1, 347, 347, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 347, 347, -1, -1, 347, -1, -1, 
	-1, -1, 347, -1, 347, 347, -1, 347, 
	-1, 347, 347, 347, 347, 347, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 326, -1, -1, -1, 
	-1, -1, -1, -1, 349, 349, 349, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	349, 349, 349, 349, 349, 349, 349, -1, 
	349, 349, 349, 349, 349, -1, 349, -1, 
	349, 349, 349, 349, -1, 349, -1, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	-1, 349, 349, 349, 349, 349, 349, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	-1, 349, -1, -1, 349, -1, 349, 349, 
	349, 349, 349, -1, -1, 349, 349, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	349, 349, 349, 349, 349, -1, 349, 349, 
	-1, -1, -1, -1, -1, 349, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 347, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 349, 349, 349, 349, 
	-1, -1, 349, 349, 349, 349, 349, 349, 
	-1, -1, -1, -1, 349, 349, 349, 349, 
	349, 349, 349, 349, -1, -1, -1, -1, 
	349, -1, -1, -1, -1, 349, 349, -1, 
	326, 349, 349, 349, 349, -1, 349, 349, 
	-1, -1, 349, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 349, 349, 349, 349, 
	349, 349, 349, 349, -1, -1, -1, 349, 
	349, 349, 349, -1, 349, 349, -1, 349, 
	349, 349, 349, 349, 349, 349, 349, 349, 
	-1, -1, -1, 349, 349, 349, -1, -1, 
	-1, 349, 349, -1, 349, 349, -1, 349, 
	349, -1, -1, 349, -1, 349, 349, -1, 
	349, -1, 349, 349, -1, 349, 347, 349, 
	349, 349, 349, 349, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 349, 350, 350, 
	350, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, 350, 350, 350, 350, 350, 350, 
	350, -1, 350, 350, 350, 350, 350, -1, 
	350, -1, 350, 350, 350, 350, -1, 350, 
	-1, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, -1, 350, 350, 350, 350, 350, 
	350, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, -1, 350, -1, -1, 350, -1, 
	350, 350, 350, 350, 350, -1, -1, 350, 
	350, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, 350, 350, 350, 350, 350, -1, 
	350, 350, -1, -1, -1, -1, -1, 350, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 349, 350, 350, 
	350, 350, -1, -1, 350, 350, 350, 350, 
	350, 350, -1, -1, -1, -1, 350, 350, 
	350, 350, 350, 350, 350, 350, -1, -1, 
	-1, -1, 350, -1, -1, -1, -1, 350, 
	350, -1, -1, 350, 350, 350, 350, -1, 
	350, 350, -1, -1, 350, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 350, 350, 
	350, 350, 350, 350, 350, 350, -1, -1, 
	-1, 350, 350, 350, 350, -1, 350, 350, 
	-1, 350, 350, 350, 350, 350, 350, 350, 
	350, 350, -1, -1, -1, 350, 350, 350, 
	-1, -1, -1, 350, 350, -1, 350, 350, 
	-1, 350, 350, -1, -1, 350, -1, 350, 
	350, -1, 350, -1, 350, 350, -1, 350, 
	-1, 350, 350, 350, 350, 350, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 350, 
	-1, -1, -1, -1, 349, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	-1, 353, 353, 353, 353, 353, -1, 353, 
	-1, 353, 353, 353, 353, -1, 353, -1, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, -1, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, -1, 353, -1, -1, 353, -1, 353, 
	353, 353, 353, 353, -1, -1, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, -1, 353, 
	353, -1, -1, -1, -1, -1, 353, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 350, 
	-1, -1, -1, -1, -1, 353, 353, 353, 
	353, -1, -1, 353, 353, 353, 353, 353, 
	353, -1, -1, -1, -1, 353, 353, 353, 
	353, 353, 353, 353, 353, -1, -1, -1, 
	-1, 353, -1, -1, -1, -1, 353, 353, 
	-1, -1, 353, 353, 353, 353, -1, 353, 
	353, -1, -1, 353, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 353, 353, 353, 
	353, 353, 353, 353, 353, -1, -1, -1, 
	353, 353, 353, -1, -1, 353, 353, -1, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, -1, -1, -1, 353, 353, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	353, 353, -1, -1, 353, -1, -1, -1, 
	-1, 353, -1, 353, 353, -1, 353, -1, 
	353, 353, 353, 353, 353, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 350, 355, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	355, 355, -1, 355, 355, 355, 355, 355, 
	-1, 355, -1, 355, 355, 355, 355, -1, 
	355, -1, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, -1, 355, 355, 355, 355, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, -1, 355, -1, -1, 355, 
	-1, 355, 355, 355, 355, 355, -1, -1, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, 355, 355, 355, 355, 355, 
	-1, 355, 355, -1, -1, -1, -1, -1, 
	355, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 353, 355, 
	355, 355, 355, -1, -1, 355, 355, 355, 
	355, 355, 355, -1, -1, -1, -1, 355, 
	355, 355, 355, 355, 355, 355, 355, -1, 
	-1, -1, -1, 355, -1, -1, -1, -1, 
	355, 355, -1, -1, 355, 355, 355, 355, 
	-1, 355, 355, -1, -1, 355, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 355, 
	355, 355, 355, 355, 355, 355, 355, -1, 
	-1, -1, 355, 355, 355, 355, -1, 355, 
	355, -1, 355, 355, 355, 355, 355, 355, 
	355, 355, 355, -1, -1, -1, 355, 355, 
	355, -1, -1, -1, 355, 355, -1, 355, 
	355, -1, 355, 355, -1, -1, 355, -1, 
	355, 355, -1, 355, -1, 355, 355, -1, 
	355, -1, 355, 355, 355, 355, 355, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	355, -1, -1, -1, -1, 353, -1, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, -1, 356, 356, 356, 356, 356, 
	-1, 356, -1, 356, 356, 356, 356, -1, 
	356, -1, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, -1, 356, 356, 356, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, -1, 356, -1, -1, 356, 
	-1, 356, 356, 356, 356, 356, -1, -1, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, 356, 356, 356, 356, 356, 
	-1, 356, 356, -1, -1, -1, -1, -1, 
	356, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	355, -1, -1, -1, -1, -1, -1, 356, 
	356, 356, 356, -1, -1, 356, 356, 356, 
	356, 356, 356, -1, -1, -1, -1, 356, 
	356, 356, 356, 356, 356, 356, 356, -1, 
	-1, -1, -1, 356, -1, -1, -1, -1, 
	356, 356, -1, -1, 356, 356, 356, 356, 
	-1, 356, 356, -1, -1, 356, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 356, 
	356, 356, 356, 356, 356, 356, 356, -1, 
	-1, -1, 356, 356, 356, 356, -1, 356, 
	356, -1, 356, 356, 356, 356, 356, 356, 
	356, 356, 356, -1, -1, -1, 356, 356, 
	356, -1, -1, -1, 356, 356, -1, 356, 
	356, -1, 356, 356, -1, -1, 356, -1, 
	356, 356, -1, 356, -1, 356, 356, -1, 
	356, -1, 356, 356, 356, 356, 356, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 355, 
	356, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, -1, 357, 357, 357, 
	357, 357, -1, 357, -1, 357, 357, 357, 
	357, -1, 357, -1, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, -1, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, -1, 357, -1, 
	-1, 357, -1, 357, 357, 357, 357, 357, 
	-1, -1, 357, 357, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, 357, 357, 357, 
	357, 357, -1, 357, 357, -1, -1, -1, 
	-1, -1, 357, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	356, 357, 357, 357, 357, -1, -1, 357, 
	357, 357, 357, 357, 357, -1, -1, -1, 
	-1, 357, 357, 357, 357, 357, 357, 357, 
	357, -1, -1, -1, -1, 357, -1, -1, 
	-1, -1, 357, 357, -1, -1, 357, 357, 
	357, 357, -1, 357, 357, -1, -1, 357, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 357, 357, 357, 357, 357, 357, 357, 
	357, -1, -1, -1, 357, 357, 357, -1, 
	-1, 357, 357, -1, 357, 357, 357, 357, 
	357, 357, 357, 357, 357, -1, -1, -1, 
	357, 357, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 357, 357, -1, -1, 
	357, -1, -1, -1, -1, 357, -1, 357, 
	357, -1, 357, -1, 357, 357, 357, 357, 
	357, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 356, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, -1, 358, 358, 358, 358, 
	358, -1, 358, -1, 358, 358, 358, 358, 
	-1, 358, -1, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, -1, 358, 358, 358, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, -1, 358, -1, -1, 
	358, -1, 358, 358, 358, 358, 358, -1, 
	-1, 358, 358, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	358, -1, 358, 358, -1, -1, -1, -1, 
	-1, 358, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 357, -1, -1, -1, -1, -1, 
	358, 358, 358, 358, -1, -1, 358, 358, 
	358, 358, 358, 358, -1, -1, -1, -1, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	-1, -1, -1, -1, 358, -1, -1, -1, 
	-1, 358, 358, -1, -1, 358, 358, 358, 
	358, -1, 358, 358, -1, -1, 358, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	358, 358, 358, 358, 358, 358, 358, 358, 
	-1, -1, -1, 358, 358, 358, -1, -1, 
	358, 358, -1, 358, 358, 358, 358, 358, 
	358, 358, 358, 358, -1, -1, -1, 358, 
	358, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 358, 358, -1, -1, 358, 
	-1, -1, -1, -1, 358, -1, 358, 358, 
	-1, 358, -1, 358, 358, 358, 358, 358, 
	361, 361, 361, 361, 361, 361, 361, -1, 
	361, 361, -1, -1, -1, -1, -1, -1, 
	-1, 357, -1, 361, 361, 361, 361, 361, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 361, -1, -1, -1, 361, -1, 
	-1, -1, 361, 361, 361, 361, 361, 361, 
	-1, -1, -1, -1, 361, 361, 361, -1, 
	-1, -1, -1, 361, 361, -1, 361, 361, 
	361, 361, -1, -1, -1, -1, -1, -1, 
	-1, 361, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 361, 
	361, 361, 361, 361, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 362, 
	362, 362, 362, 362, 362, 362, 362, 362, 
	362, 362, 362, 362, 362, 362, 362, 362, 
	362, 362, 362, 362, 362, 362, 362, 362, 
	362, 362, -1, 362, 362, 362, 362, 362, 
	-1, 362, -1, 362, 362, 362, 362, -1, 
	362, -1, 362, 362, 362, -1, -1, 362, 
	362, 362, 362, 362, 362, 362, 362, -1, 
	362, 362, 362, -1, -1, -1, -1, 362, 
	362, 362, 362, 362, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 358, -1, -1, 362, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 362, 362, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 361, 361, 361, 361, 361, -1, 
	361, 361, 361, -1, -1, -1, -1, 361, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 361, 361, 361, 361, 361, 362, 
	362, 362, 362, -1, -1, 362, 362, -1, 
	362, 362, 362, -1, -1, -1, -1, 362, 
	362, 362, -1, 362, 362, 362, 362, -1, 
	-1, -1, -1, 362, -1, -1, -1, -1, 
	362, -1, -1, -1, 362, 362, 362, 362, 
	-1, 362, 362, -1, -1, 362, -1, -1, 
	358, -1, -1, -1, -1, -1, -1, 362, 
	362, 362, 362, 362, 362, 362, 362, -1, 
	-1, -1, -1, 362, 362, -1, -1, 362, 
	362, -1, -1, -1, -1, -1, -1, -1, 
	-1, 362, 362, -1, -1, -1, -1, 362, 
	363, 363, 363, 363, 363, 363, 363, -1, 
	363, 363, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 363, 363, 363, 363, 363, 
	-1, -1, -1, -1, -1, 362, 362, -1, 
	-1, -1, 363, -1, -1, -1, 363, -1, 
	-1, -1, 363, 363, 363, 363, 363, 363, 
	-1, -1, -1, -1, 363, 363, 363, -1, 
	-1, -1, -1, 363, 363, -1, 363, 363, 
	363, 363, -1, -1, -1, -1, -1, -1, 
	-1, 363, 364, 364, 364, 364, 364, 364, 
	364, -1, 364, 364, -1, -1, -1, 363, 
	363, 363, 363, 363, -1, 364, 364, 364, 
	364, 364, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 364, -1, -1, -1, 
	364, -1, -1, -1, 364, 364, 364, 364, 
	364, 364, -1, -1, -1, -1, 364, 364, 
	364, -1, -1, -1, -1, 364, 364, -1, 
	364, 364, 364, 364, -1, -1, -1, -1, 
	-1, -1, -1, 364, 364, 366, 366, 366, 
	366, 366, 366, 366, -1, 366, 366, -1, 
	-1, 364, 364, 364, 364, 364, -1, -1, 
	366, 366, 366, 366, 366, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 366, 
	-1, -1, -1, 366, -1, -1, -1, 366, 
	366, 366, 366, 366, 366, -1, -1, -1, 
	-1, 366, 366, 366, -1, -1, -1, -1, 
	366, 366, -1, 366, 366, 366, 366, -1, 
	-1, -1, -1, -1, -1, -1, 366, 366, 
	362, -1, -1, -1, -1, -1, -1, 363, 
	-1, -1, -1, -1, 366, 366, 366, 366, 
	366, -1, 363, 363, 363, 363, 363, -1, 
	363, 363, 363, -1, -1, -1, -1, 363, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 363, 363, 363, 363, 363, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 364, 364, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 364, 364, 364, 364, 
	364, -1, 364, 364, 364, -1, -1, -1, 
	-1, 364, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 364, 364, 364, 364, 
	364, -1, -1, -1, -1, -1, -1, 362, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 366, 
	366, 366, 366, 366, -1, 366, 366, 366, 
	-1, -1, -1, 366, 366, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 366, 
	366, 366, 366, 366, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 366, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 361, 361, 361, 361, 361, 
	-1, 361, 361, 361, -1, -1, -1, -1, 
	361, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 361, 361, 361, 361, 376, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	376, 376, -1, 376, 376, 376, 376, 376, 
	-1, 376, -1, 376, 376, 376, 376, -1, 
	376, -1, 376, 376, 376, -1, 376, 376, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	376, 376, 376, -1, 376, 376, 376, 376, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	376, 376, 376, -1, 376, -1, -1, -1, 
	-1, 376, 376, 376, 376, 376, -1, -1, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	376, 376, 376, 376, 376, 376, 376, 376, 
	-1, 376, 376, -1, -1, -1, -1, -1, 
	376, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 376, 
	376, 376, 376, -1, -1, 376, 376, 376, 
	376, 376, 376, -1, -1, -1, -1, 376, 
	376, 376, 376, 376, 376, 376, 376, -1, 
	-1, -1, -1, 376, -1, -1, -1, -1, 
	376, 376, -1, -1, 376, 376, 376, 376, 
	-1, 376, 376, -1, -1, 376, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 376, 
	376, 376, 376, 376, 376, 376, 376, -1, 
	-1, -1, 376, 376, 376, 376, -1, 376, 
	376, -1, 376, 376, 376, 376, 376, -1, 
	376, 376, 376, -1, -1, -1, 376, 376, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 376, 376, -1, -1, 376, -1, 
	-1, -1, -1, 376, -1, -1, -1, -1, 
	376, -1, 376, 376, 376, 376, 376, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	376, -1, -1, -1, -1, -1, -1, -1, 
	363, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 363, 363, 363, 363, 363, 
	-1, 363, 363, 363, -1, -1, -1, -1, 
	363, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 363, 363, 363, 363, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 364, 364, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 364, 364, 364, 
	364, 364, -1, 364, 364, 364, -1, -1, 
	-1, -1, 364, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 364, 364, 364, 
	364, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	376, -1, -1, -1, -1, -1, -1, -1, 
	-1, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, -1, 377, 377, 377, 
	377, 377, -1, 377, -1, 377, 377, 377, 
	377, -1, 377, -1, 377, 377, 377, 366, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, -1, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, -1, 377, -1, 
	-1, -1, -1, 377, 377, 377, 377, 377, 
	-1, -1, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, -1, 377, 377, -1, -1, -1, 
	-1, -1, 377, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 376, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 377, 377, 377, 377, -1, -1, 377, 
	377, 377, 377, 377, 377, -1, -1, -1, 
	-1, 377, 377, 377, 377, 377, 377, 377, 
	377, -1, -1, -1, -1, 377, -1, -1, 
	-1, -1, 377, 377, -1, -1, 377, 377, 
	377, 377, -1, 377, 377, -1, -1, 377, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 377, 377, 377, 377, 377, 377, 377, 
	377, -1, -1, -1, 377, 377, 377, -1, 
	-1, 377, 377, -1, 377, 377, 377, 377, 
	377, -1, 377, 377, 377, -1, -1, -1, 
	377, 377, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 377, 377, -1, -1, 
	377, -1, -1, -1, -1, 377, -1, -1, 
	-1, -1, 377, -1, 377, 377, 377, 377, 
	377, -1, -1, 378, 378, 378, 378, 378, 
	378, 378, 378, 378, 378, 378, 378, 378, 
	378, 378, 378, 378, 378, 378, 378, 378, 
	378, 378, 378, 378, 378, 378, -1, 378, 
	378, 378, 378, 378, -1, 378, -1, 378, 
	378, 378, 378, -1, 378, -1, 378, 378, 
	378, -1, 378, 378, 378, 378, 378, 378, 
	378, 378, 378, 378, 378, 378, 378, -1, 
	378, 378, 378, 378, 378, 378, 378, 378, 
	378, 378, 378, 378, 378, 378, 378, -1, 
	378, -1, -1, -1, -1, 378, 378, 378, 
	378, 378, -1, -1, 378, 378, 378, 378, 
	378, 378, 378, 378, 378, 378, 378, 378, 
	378, 378, 378, 378, -1, 378, 378, -1, 
	-1, -1, -1, -1, 378, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 378, 378, 378, 378, -1, 
	-1, 378, 378, 378, 378, 378, 378, -1, 
	-1, -1, 377, 378, 378, 378, 378, 378, 
	378, 378, 378, -1, -1, -1, -1, 378, 
	-1, -1, -1, -1, 378, 378, -1, -1, 
	378, 378, 378, 378, -1, 378, 378, -1, 
	-1, 378, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 378, 378, 378, 378, 378, 
	378, 378, 378, -1, -1, -1, 378, 378, 
	378, -1, -1, 378, 378, -1, 378, 378, 
	378, 378, 378, -1, 378, 378, 378, -1, 
	-1, -1, 378, 378, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 378, 378, 
	-1, -1, 378, -1, -1, -1, -1, 378, 
	-1, -1, -1, -1, 378, -1, 378, 378, 
	378, 378, 378, -1, -1, -1, 379, 379, 
	379, 379, 379, 379, 379, 379, 379, 379, 
	379, 379, 379, 379, 379, 379, -1, 379, 
	379, 379, 379, 379, 379, 379, 379, -1, 
	-1, -1, 379, 379, 379, 379, 379, -1, 
	379, 377, 379, 379, 379, 379, -1, 379, 
	-1, 379, 379, 379, -1, -1, 379, -1, 
	-1, 379, 379, 379, 379, 379, -1, 379, 
	379, 379, -1, -1, -1, -1, 379, 379, 
	379, 379, 379, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 380, -1, 380, 380, 380, 380, 380, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 380, -1, -1, -1, 
	379, 379, -1, -1, -1, 380, 380, 380, 
	380, 380, -1, 380, -1, 380, -1, -1, 
	-1, -1, 380, -1, -1, 380, 380, -1, 
	-1, -1, -1, -1, 380, 380, 380, -1, 
	-1, -1, 380, 380, 380, -1, -1, -1, 
	-1, 380, 380, 380, 380, 380, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 379, 379, 
	379, 379, -1, -1, 379, 379, -1, 379, 
	379, 379, -1, -1, 378, -1, 379, 379, 
	379, -1, 379, 379, 379, 379, -1, -1, 
	-1, -1, 379, -1, -1, -1, -1, 379, 
	379, -1, -1, 379, 379, 379, 379, -1, 
	379, 379, -1, -1, 379, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 379, 379, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 379, 379, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	379, 379, 380, 380, 380, -1, 379, 380, 
	380, -1, -1, 380, 380, -1, -1, -1, 
	-1, 380, 380, 380, -1, 380, 380, 380, 
	380, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 380, 380, 379, 379, 380, -1, 
	380, 380, -1, 380, 380, -1, -1, 380, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 381, -1, 381, 381, 381, 381, 381, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 378, 381, -1, -1, -1, 
	-1, -1, -1, 380, 380, 381, 381, 381, 
	381, 381, -1, 381, -1, 381, -1, -1, 
	-1, -1, 381, -1, -1, 381, 381, -1, 
	-1, -1, -1, -1, 381, 381, 381, -1, 
	-1, -1, 381, 381, 381, -1, -1, -1, 
	-1, 381, 381, 381, 381, 381, 382, -1, 
	382, 382, 382, 382, 382, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 382, -1, -1, -1, -1, -1, -1, 
	-1, -1, 382, 382, 382, 382, 382, -1, 
	382, -1, 382, -1, -1, -1, -1, 382, 
	-1, -1, 382, 382, -1, -1, -1, -1, 
	-1, 382, 382, 382, -1, -1, -1, 382, 
	382, 382, -1, -1, -1, -1, 382, 382, 
	382, 382, 382, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 379, 
	-1, -1, 381, 381, 381, -1, -1, 381, 
	381, -1, -1, 381, 381, -1, -1, -1, 
	-1, 381, 381, 381, -1, 381, 381, 381, 
	381, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 381, 381, -1, -1, 381, -1, 
	381, 381, -1, 381, 381, -1, -1, 381, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 382, 
	382, 382, -1, -1, 382, 382, -1, -1, 
	382, 382, -1, 381, 381, -1, 382, 382, 
	382, -1, 382, 382, 382, 382, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 382, 
	382, -1, -1, 382, -1, 382, 382, -1, 
	382, 382, -1, 383, 382, 383, 383, 383, 
	383, 383, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 383, -1, 
	-1, -1, -1, -1, -1, -1, 379, 383, 
	383, 383, 383, 383, -1, 383, -1, 383, 
	382, 382, -1, -1, 383, -1, -1, 383, 
	383, -1, -1, -1, -1, -1, 383, 383, 
	383, -1, -1, -1, 383, 383, 383, -1, 
	-1, -1, -1, 383, 383, 383, 383, 383, 
	384, -1, 384, 384, 384, 384, 384, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 384, -1, -1, -1, -1, 
	-1, -1, -1, -1, 384, 384, 384, 384, 
	384, -1, 384, -1, 384, -1, -1, -1, 
	-1, 384, -1, -1, 384, 384, -1, -1, 
	-1, -1, -1, 384, 384, 384, -1, -1, 
	-1, 384, 384, 384, -1, -1, -1, -1, 
	384, 384, 384, 384, 384, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 383, 383, 383, -1, 
	-1, 383, 383, -1, -1, 383, 383, -1, 
	-1, -1, -1, 383, 383, 383, -1, 383, 
	383, 383, 383, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 383, 383, -1, -1, 
	383, -1, 383, 383, -1, 383, 383, -1, 
	-1, 383, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 384, 384, 384, -1, -1, 384, 384, 
	-1, -1, 384, 384, -1, 383, 383, -1, 
	384, 384, 384, -1, 384, 384, 384, 384, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 384, 384, -1, -1, 384, -1, 384, 
	384, -1, 384, 384, -1, 385, 384, 385, 
	385, 385, 385, 385, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	385, -1, -1, -1, -1, -1, -1, -1, 
	-1, 385, 385, 385, 385, 385, -1, 385, 
	-1, 385, 384, 384, -1, -1, 385, -1, 
	-1, 385, 385, -1, -1, -1, -1, -1, 
	385, 385, 385, -1, -1, -1, 385, 385, 
	385, -1, -1, -1, -1, 385, 385, 385, 
	385, 385, 386, -1, 386, 386, 386, 386, 
	386, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 386, -1, -1, 
	-1, -1, -1, -1, -1, -1, 386, 386, 
	386, 386, 386, -1, 386, -1, 386, -1, 
	-1, -1, -1, 386, -1, -1, 386, 386, 
	-1, -1, -1, -1, -1, 386, 386, 386, 
	-1, -1, -1, 386, 386, 386, -1, -1, 
	-1, -1, 386, 386, 386, 386, 386, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 385, 385, 
	385, -1, -1, 385, 385, -1, -1, 385, 
	385, -1, -1, -1, -1, 385, 385, 385, 
	-1, 385, 385, 385, 385, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 385, 385, 
	-1, -1, 385, -1, 385, 385, -1, 385, 
	385, -1, -1, 385, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 386, 386, 386, -1, -1, 
	386, 386, -1, -1, 386, 386, -1, 385, 
	385, -1, 386, 386, 386, -1, 386, 386, 
	386, 386, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 386, 386, -1, -1, 386, 
	-1, 386, 386, -1, 386, 386, -1, 387, 
	386, 387, 387, 387, 387, 387, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 387, -1, -1, -1, -1, -1, 
	-1, -1, -1, 387, 387, 387, 387, 387, 
	-1, 387, -1, 387, 386, 386, -1, -1, 
	387, -1, -1, 387, 387, -1, -1, -1, 
	-1, -1, 387, 387, 387, -1, -1, -1, 
	387, 387, 387, -1, -1, -1, -1, 387, 
	387, 387, 387, 387, 388, -1, 388, 388, 
	388, 388, 388, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 388, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	388, 388, 388, 388, 388, -1, 388, -1, 
	388, -1, -1, -1, -1, 388, -1, -1, 
	388, 388, -1, -1, -1, -1, -1, 388, 
	388, 388, -1, -1, -1, 388, 388, 388, 
	-1, -1, -1, -1, 388, 388, 388, 388, 
	388, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	387, 387, 387, -1, -1, 387, 387, -1, 
	-1, 387, 387, -1, -1, -1, -1, 387, 
	387, 387, -1, 387, 387, 387, 387, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	387, 387, -1, -1, 387, -1, 387, 387, 
	-1, 387, 387, -1, -1, 387, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 388, 388, 388, 
	-1, -1, 388, 388, -1, -1, 388, 388, 
	-1, 387, 387, -1, 388, 388, 388, -1, 
	388, 388, 388, 388, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 388, 388, -1, 
	-1, 388, -1, 388, 388, -1, 388, 388, 
	-1, 389, 388, 389, 389, 389, 389, 389, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 389, -1, -1, -1, 
	-1, -1, -1, -1, -1, 389, 389, 389, 
	389, 389, -1, 389, -1, 389, 388, 388, 
	-1, -1, 389, -1, -1, 389, 389, -1, 
	-1, -1, -1, -1, 389, 389, 389, -1, 
	-1, -1, 389, 389, 389, -1, -1, -1, 
	-1, 389, 389, 389, 389, 389, 390, -1, 
	390, 390, 390, 390, 390, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 390, -1, -1, -1, -1, -1, -1, 
	-1, -1, 390, 390, 390, 390, 390, -1, 
	390, -1, 390, -1, -1, -1, -1, 390, 
	-1, -1, 390, 390, -1, -1, -1, -1, 
	-1, 390, 390, 390, -1, -1, -1, 390, 
	390, 390, -1, -1, -1, -1, 390, 390, 
	390, 390, 390, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 389, 389, 389, -1, -1, 389, 
	389, -1, -1, 389, 389, -1, -1, -1, 
	-1, 389, 389, 389, -1, 389, 389, 389, 
	389, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 389, 389, -1, -1, 389, -1, 
	389, 389, -1, 389, 389, -1, -1, 389, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 390, 
	390, 390, -1, -1, 390, 390, -1, -1, 
	390, 390, -1, 389, 389, -1, 390, 390, 
	390, -1, 390, 390, 390, 390, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 390, 
	390, -1, -1, 390, -1, 390, 390, -1, 
	390, 390, -1, 391, 390, 391, 391, 391, 
	391, 391, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 391, -1, 
	-1, -1, -1, -1, -1, -1, -1, 391, 
	391, 391, 391, 391, -1, 391, -1, 391, 
	390, 390, -1, -1, 391, -1, -1, 391, 
	391, -1, -1, -1, -1, -1, 391, 391, 
	391, -1, -1, -1, 391, 391, 391, -1, 
	-1, -1, -1, 391, 391, 391, 391, 391, 
	392, -1, 392, 392, 392, 392, 392, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 392, -1, -1, -1, -1, 
	-1, -1, -1, -1, 392, 392, 392, 392, 
	392, -1, 392, -1, 392, -1, -1, -1, 
	-1, 392, -1, -1, 392, 392, -1, -1, 
	-1, -1, -1, 392, 392, 392, -1, -1, 
	-1, 392, 392, 392, -1, -1, -1, -1, 
	392, 392, 392, 392, 392, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 391, 391, 391, -1, 
	-1, 391, 391, -1, -1, 391, 391, -1, 
	-1, -1, -1, 391, 391, 391, -1, 391, 
	391, 391, 391, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 391, 391, -1, -1, 
	391, -1, 391, 391, -1, 391, 391, -1, 
	-1, 391, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 392, 392, 392, -1, -1, 392, 392, 
	-1, -1, 392, 392, -1, 391, 391, -1, 
	392, 392, 392, -1, 392, 392, 392, 392, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 392, 392, -1, -1, 392, -1, 392, 
	392, -1, 392, 392, -1, 393, 392, 393, 
	393, 393, 393, 393, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	393, -1, -1, -1, -1, -1, -1, -1, 
	-1, 393, 393, 393, 393, 393, -1, 393, 
	-1, 393, 392, 392, -1, -1, 393, -1, 
	-1, 393, 393, -1, -1, -1, -1, -1, 
	393, 393, 393, -1, -1, -1, 393, 393, 
	393, -1, -1, -1, -1, 393, 393, 393, 
	393, 393, 394, -1, 394, 394, 394, 394, 
	394, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 394, -1, -1, 
	-1, -1, -1, -1, -1, -1, 394, 394, 
	394, 394, 394, -1, 394, -1, 394, -1, 
	-1, -1, -1, 394, -1, -1, 394, 394, 
	-1, -1, -1, -1, -1, 394, 394, 394, 
	-1, -1, -1, 394, 394, 394, -1, -1, 
	-1, -1, 394, 394, 394, 394, 394, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 393, 393, 
	393, -1, -1, 393, 393, -1, -1, 393, 
	393, -1, -1, -1, -1, 393, 393, 393, 
	-1, 393, 393, 393, 393, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 393, 393, 
	-1, -1, 393, -1, 393, 393, -1, 393, 
	393, -1, -1, 393, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 394, 394, 394, -1, -1, 
	394, 394, -1, -1, 394, 394, -1, 393, 
	393, -1, 394, 394, 394, -1, 394, 394, 
	394, 394, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 394, 394, -1, -1, 394, 
	-1, 394, 394, -1, 394, 394, -1, 395, 
	394, 395, 395, 395, 395, 395, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 395, -1, -1, -1, -1, -1, 
	-1, -1, -1, 395, 395, 395, 395, 395, 
	-1, 395, -1, 395, 394, 394, -1, -1, 
	395, -1, -1, 395, 395, -1, -1, -1, 
	-1, -1, 395, 395, 395, -1, -1, -1, 
	395, 395, 395, -1, -1, -1, -1, 395, 
	395, 395, 395, 395, 396, -1, 396, 396, 
	396, 396, 396, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 396, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	396, 396, 396, 396, 396, -1, 396, -1, 
	396, -1, -1, -1, -1, 396, -1, -1, 
	396, 396, -1, -1, -1, -1, -1, 396, 
	396, 396, -1, -1, -1, 396, 396, 396, 
	-1, -1, -1, -1, 396, 396, 396, 396, 
	396, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	395, 395, 395, -1, -1, 395, 395, -1, 
	-1, 395, 395, -1, -1, -1, -1, 395, 
	395, 395, -1, 395, 395, 395, 395, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	395, 395, -1, -1, 395, -1, 395, 395, 
	-1, 395, 395, -1, -1, 395, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 396, 396, 396, 
	-1, -1, 396, 396, -1, -1, 396, 396, 
	-1, 395, 395, -1, 396, 396, 396, -1, 
	396, 396, 396, 396, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 396, 396, -1, 
	-1, 396, -1, 396, 396, -1, 396, 396, 
	-1, 397, 396, 397, 397, 397, 397, 397, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 397, -1, -1, -1, 
	-1, -1, -1, -1, -1, 397, 397, 397, 
	397, 397, -1, 397, -1, 397, 396, 396, 
	-1, -1, 397, -1, -1, 397, 397, -1, 
	-1, -1, -1, -1, 397, 397, 397, -1, 
	-1, -1, 397, 397, 397, -1, -1, -1, 
	-1, 397, 397, 397, 397, 397, 399, 399, 
	399, 399, 399, 399, 399, 399, 399, 399, 
	399, 399, 399, 399, 399, 399, -1, 399, 
	399, 399, 399, 399, 399, 399, 399, -1, 
	-1, -1, 399, 399, 399, 399, 399, -1, 
	399, -1, 399, 399, 399, 399, -1, 399, 
	-1, 399, 399, 399, -1, -1, 399, -1, 
	-1, 399, 399, 399, 399, 399, -1, 399, 
	399, 399, -1, -1, -1, -1, 399, 399, 
	399, 399, 399, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	399, 399, 397, 397, 397, -1, -1, 397, 
	397, -1, -1, 397, 397, -1, -1, -1, 
	-1, 397, 397, 397, -1, 397, 397, 397, 
	397, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 397, 397, -1, -1, 397, -1, 
	397, 397, -1, 397, 397, -1, -1, 397, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 399, 399, 
	399, 399, -1, -1, 399, 399, -1, 399, 
	399, 399, -1, 397, 397, -1, 399, 399, 
	399, -1, 399, 399, 399, 399, -1, -1, 
	-1, -1, 399, -1, -1, -1, -1, 399, 
	-1, -1, -1, 399, 399, 399, 399, -1, 
	399, 399, -1, -1, 399, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 399, 399, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 399, 399, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	399, 399, -1, -1, -1, -1, 399, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 399, 399, -1, -1, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	412, 412, 412, -1, 412, 412, 412, 412, 
	412, -1, 412, -1, 412, 412, 412, 412, 
	-1, 412, -1, 412, 412, 412, -1, 412, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	412, 412, 412, 412, -1, 412, 412, 412, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	412, 412, 412, 412, -1, 412, -1, -1, 
	-1, -1, 412, 412, 412, 412, 412, -1, 
	-1, 412, 412, 412, 412, 412, 412, 412, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	412, -1, 412, 412, -1, -1, -1, -1, 
	-1, 412, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	412, 412, 412, 412, -1, -1, 412, 412, 
	412, 412, 412, 412, -1, -1, -1, 399, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	-1, -1, -1, -1, 412, -1, -1, -1, 
	-1, 412, 412, -1, -1, 412, 412, 412, 
	412, -1, 412, 412, -1, -1, 412, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	412, 412, 412, 412, 412, 412, 412, 412, 
	-1, -1, -1, 412, 412, 412, -1, -1, 
	412, 412, -1, 412, 412, 412, 412, 412, 
	-1, 412, 412, 412, -1, -1, -1, 412, 
	412, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 412, 412, -1, -1, 412, 
	-1, -1, -1, -1, 412, -1, -1, -1, 
	-1, 412, -1, 412, 412, 412, 412, 412, 
	-1, 415, 415, 415, 415, 415, 415, 415, 
	-1, 415, 415, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 415, 415, 415, 415, 
	415, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 415, -1, -1, 399, 415, 
	-1, -1, -1, 415, 415, 415, 415, 415, 
	415, -1, -1, -1, -1, 415, 415, 415, 
	-1, -1, -1, -1, 415, 415, -1, 415, 
	415, 415, 415, -1, -1, -1, -1, -1, 
	-1, -1, 415, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	415, 415, 415, 415, 415, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 415, -1, -1, -1, -1, -1, -1, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	416, 416, 416, -1, 416, 416, 416, 416, 
	416, -1, 416, -1, 416, 416, 416, 416, 
	-1, 416, -1, 416, 416, 416, -1, 416, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	416, 416, 416, 416, -1, 416, 416, 416, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	416, 416, 416, 416, -1, 416, -1, -1, 
	-1, 412, 416, 416, 416, 416, 416, -1, 
	-1, 416, 416, 416, 416, 416, 416, 416, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	416, -1, 416, 416, -1, -1, -1, -1, 
	-1, 416, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 415, 415, 415, 415, 415, 
	-1, 415, 415, 415, -1, -1, -1, -1, 
	415, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 415, 415, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 415, -1, 415, 415, 415, 415, 415, 
	416, 416, 416, 416, -1, -1, 416, 416, 
	416, 416, 416, 416, -1, -1, -1, -1, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	-1, -1, 415, -1, 416, -1, -1, -1, 
	-1, 416, 416, -1, -1, 416, 416, 416, 
	416, -1, 416, 416, -1, -1, 416, -1, 
	412, -1, -1, -1, -1, -1, -1, -1, 
	416, 416, 416, 416, 416, 416, 416, 416, 
	-1, -1, -1, 416, 416, 416, -1, -1, 
	416, 416, -1, 416, 416, 416, 416, 416, 
	-1, 416, 416, 416, -1, -1, -1, 416, 
	416, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 416, 416, -1, -1, 416, 
	-1, -1, -1, -1, 416, -1, -1, -1, 
	-1, 416, -1, 416, 416, 416, 416, 416, 
	-1, -1, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, -1, 417, 417, 
	417, 417, 417, -1, 417, -1, 417, 417, 
	417, 417, -1, 417, -1, 417, 417, 417, 
	-1, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, -1, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, -1, 417, 
	-1, -1, -1, -1, 417, 417, 417, 417, 
	417, -1, -1, 417, 417, 417, 417, 417, 
	417, 417, 417, 417, 417, 417, 417, 417, 
	417, 417, 417, -1, 417, 417, -1, -1, 
	-1, -1, -1, 417, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 417, 417, 417, 417, -1, -1, 
	417, 417, 417, 417, 417, 417, -1, -1, 
	-1, 416, 417, 417, 417, 417, 417, 417, 
	417, 417, -1, -1, -1, -1, 417, -1, 
	-1, -1, -1, 417, 417, -1, -1, 417, 
	417, 417, 417, -1, 417, 417, -1, -1, 
	417, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 417, 417, 417, 417, 417, 417, 
	417, 417, -1, -1, -1, 417, 417, 417, 
	-1, -1, 417, 417, -1, 417, 417, 417, 
	417, 417, -1, 417, 417, 417, -1, -1, 
	-1, 417, 417, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 417, 417, -1, 
	-1, 417, -1, -1, -1, -1, 417, -1, 
	-1, -1, -1, 417, -1, 417, 417, 417, 
	417, 417, -1, -1, -1, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	-1, 418, 418, 418, 418, 418, -1, 418, 
	416, 418, 418, 418, 418, -1, 418, -1, 
	418, 418, 418, -1, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, -1, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, -1, 418, -1, -1, -1, -1, 418, 
	418, 418, 418, 418, -1, -1, 418, 418, 
	418, 418, 418, 418, 418, 418, 418, 418, 
	418, 418, 418, 418, 418, 418, -1, 418, 
	418, -1, -1, -1, -1, -1, 418, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 418, 418, 418, 
	418, -1, -1, 418, 418, 418, 418, 418, 
	418, -1, -1, 417, -1, 418, 418, 418, 
	418, 418, 418, 418, 418, -1, -1, -1, 
	-1, 418, -1, -1, -1, -1, 418, 418, 
	-1, -1, 418, 418, 418, 418, -1, 418, 
	418, -1, -1, 418, -1, -1, -1, -1, 
	-1, -1, -1, 415, -1, 418, 418, 418, 
	418, 418, 418, 418, 418, -1, -1, -1, 
	418, 418, 418, -1, -1, 418, 418, -1, 
	418, 418, 418, 418, 418, -1, 418, 418, 
	418, -1, -1, -1, 418, 418, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	418, 418, -1, -1, 418, -1, -1, -1, 
	-1, 418, -1, -1, -1, -1, 418, -1, 
	418, 418, 418, 418, 418, 419, 419, 419, 
	419, 419, 419, 419, -1, 419, 419, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	419, 419, 419, 419, 419, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 419, 
	-1, -1, 417, 419, -1, -1, -1, 419, 
	419, 419, 419, 419, 419, -1, -1, -1, 
	-1, 419, 419, 419, -1, -1, -1, -1, 
	419, 419, -1, 419, 419, 419, 419, 419, 
	-1, -1, -1, -1, -1, -1, 419, 421, 
	421, 421, 421, 421, 421, 421, -1, 421, 
	421, -1, -1, -1, 419, 419, 419, 419, 
	419, -1, 421, 421, 421, 421, 421, -1, 
	-1, -1, -1, -1, -1, 419, -1, -1, 
	-1, 421, -1, -1, -1, 421, -1, -1, 
	-1, 421, 421, 421, 421, 421, 421, -1, 
	-1, -1, -1, 421, 421, 421, -1, -1, 
	-1, -1, 421, 421, -1, 421, 421, 421, 
	421, -1, -1, -1, -1, -1, -1, -1, 
	421, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 421, 421, 
	421, 421, 421, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 418, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 419, 
	419, 419, 419, 419, -1, 419, 419, 419, 
	-1, -1, -1, -1, 419, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 419, 
	419, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 419, -1, 419, 
	419, 419, 419, 419, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 421, 421, 421, 421, 421, -1, 421, 
	421, 421, -1, -1, -1, -1, 421, -1, 
	-1, -1, -1, -1, -1, 418, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 421, 421, 421, 421, 421, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, -1, 422, 422, 422, 422, 422, -1, 
	422, -1, 422, 422, 422, 422, -1, 422, 
	-1, 422, 422, 422, -1, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, -1, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, -1, 422, -1, -1, -1, -1, 
	422, 422, 422, 422, 422, -1, -1, 422, 
	422, 422, 422, 422, 422, 422, 422, 422, 
	422, 422, 422, 422, 422, 422, 422, -1, 
	422, 422, -1, -1, -1, -1, -1, 422, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 422, 422, 
	422, 422, -1, -1, 422, 422, 422, 422, 
	422, 422, -1, -1, -1, -1, 422, 422, 
	422, 422, 422, 422, 422, 422, -1, -1, 
	-1, -1, 422, -1, -1, -1, -1, 422, 
	422, -1, -1, 422, 422, 422, 422, -1, 
	422, 422, -1, -1, 422, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 422, 422, 
	422, 422, 422, 422, 422, 422, -1, -1, 
	-1, 422, 422, 422, -1, -1, 422, 422, 
	-1, 422, 422, 422, 422, 422, -1, 422, 
	422, 422, -1, -1, -1, 422, 422, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 422, 422, -1, -1, 422, -1, -1, 
	-1, -1, 422, -1, -1, -1, -1, 422, 
	-1, 422, 422, 422, 422, 422, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, -1, 423, 423, 423, 
	423, 423, -1, 423, -1, 423, 423, 423, 
	423, -1, 423, -1, 423, 423, 423, -1, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, -1, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, -1, 423, -1, 
	-1, -1, -1, 423, 423, 423, 423, 423, 
	-1, -1, 423, 423, 423, 423, 423, 423, 
	423, 423, 423, 423, 423, 423, 423, 423, 
	423, 423, -1, 423, 423, -1, -1, -1, 
	-1, -1, 423, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 422, 
	-1, 423, 423, 423, 423, -1, -1, 423, 
	423, 423, 423, 423, 423, -1, -1, -1, 
	-1, 423, 423, 423, 423, 423, 423, 423, 
	423, -1, -1, -1, -1, 423, -1, -1, 
	-1, -1, 423, 423, -1, -1, 423, 423, 
	423, 423, -1, 423, 423, -1, -1, 423, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 423, 423, 423, 423, 423, 423, 423, 
	423, -1, -1, -1, 423, 423, 423, -1, 
	-1, 423, 423, -1, 423, 423, 423, 423, 
	423, -1, 423, 423, 423, -1, -1, -1, 
	423, 423, 421, 421, 421, 421, 421, -1, 
	421, 421, 421, -1, 423, 423, -1, 421, 
	423, -1, -1, -1, -1, 423, -1, -1, 
	-1, -1, 423, -1, 423, 423, 423, 423, 
	423, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 421, 421, 421, 421, -1, -1, 
	-1, -1, -1, -1, -1, -1, 422, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, -1, 425, 425, 425, 425, 425, 
	-1, 425, -1, 425, 425, 425, 425, -1, 
	425, -1, 425, 425, 425, -1, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, -1, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, -1, -1, -1, -1, -1, 
	-1, 425, 425, 425, 425, -1, -1, -1, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, -1, -1, 425, 425, 
	-1, 425, 425, -1, -1, -1, -1, -1, 
	425, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 423, -1, -1, -1, -1, 425, 
	425, 425, 425, -1, -1, 425, 425, 425, 
	425, 425, 425, -1, -1, -1, -1, 425, 
	425, 425, 425, 425, 425, 425, 425, -1, 
	-1, -1, -1, 425, -1, -1, -1, -1, 
	425, 425, -1, -1, 425, 425, 425, 425, 
	-1, 425, 425, -1, -1, 425, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 425, 
	425, 425, 425, 425, 425, 425, 425, -1, 
	-1, -1, 425, 425, 425, -1, -1, 425, 
	425, -1, 425, 425, 425, 425, 425, -1, 
	425, 425, 425, -1, -1, -1, 425, 425, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 425, 425, -1, -1, 425, -1, 
	-1, -1, -1, 425, -1, -1, -1, -1, 
	425, -1, 425, 425, 425, 425, 425, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 423, 426, 426, 426, 426, 426, 426, 
	426, 426, 426, 426, 426, 426, 426, 426, 
	426, 426, 426, 426, 426, 426, 426, 426, 
	426, 426, 426, 426, 426, -1, 426, 426, 
	426, 426, 426, -1, 426, -1, 426, 426, 
	426, 426, -1, 426, -1, 426, 426, 426, 
	-1, 426, 426, 426, 426, 426, 426, 426, 
	426, 426, 426, 426, 426, 426, -1, 426, 
	426, 426, 426, 426, 426, 426, 426, 426, 
	426, 426, 426, 426, 426, 426, -1, -1, 
	-1, -1, -1, -1, 426, 426, 426, 426, 
	-1, -1, -1, 426, 426, 426, 426, 426, 
	426, 426, 426, 426, 426, 426, 426, -1, 
	-1, 426, 426, -1, 426, 426, -1, -1, 
	-1, -1, -1, 426, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	425, -1, 426, 426, 426, 426, -1, -1, 
	426, 426, 426, 426, 426, 426, -1, -1, 
	-1, -1, 426, 426, 426, 426, 426, 426, 
	426, 426, -1, -1, -1, -1, 426, -1, 
	-1, -1, -1, 426, 426, -1, -1, 426, 
	426, 426, 426, -1, 426, 426, -1, -1, 
	426, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 426, 426, 426, 426, 426, 426, 
	426, 426, -1, -1, -1, 426, 426, 426, 
	-1, -1, 426, 426, -1, 426, 426, 426, 
	426, 426, -1, 426, 426, 426, -1, -1, 
	-1, 426, 426, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 426, 426, -1, 
	-1, 426, -1, -1, -1, -1, 426, -1, 
	-1, -1, -1, 426, -1, 426, 426, 426, 
	426, 426, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 425, 
	427, 427, 427, 427, 427, 427, 427, 427, 
	427, 427, 427, 427, 427, 427, 427, 427, 
	427, 427, 427, 427, 427, 427, 427, 427, 
	427, 427, 427, -1, 427, 427, 427, 427, 
	427, -1, 427, -1, 427, 427, 427, 427, 
	-1, 427, -1, 427, 427, 427, -1, -1, 
	427, 427, 427, 427, 427, 427, 427, 427, 
	-1, 427, 427, 427, -1, -1, -1, -1, 
	427, 427, 427, 427, 427, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 427, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 427, 427, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 426, -1, -1, -1, -1, 
	427, 427, 427, 427, -1, -1, 427, 427, 
	-1, 427, 427, 427, -1, -1, -1, -1, 
	427, 427, 427, -1, 427, 427, 427, 427, 
	-1, -1, -1, -1, 427, -1, -1, -1, 
	-1, 427, -1, -1, -1, 427, 427, 427, 
	427, -1, 427, 427, -1, -1, 427, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	427, 427, 427, 427, 427, 427, 427, 427, 
	-1, -1, -1, -1, 427, 427, -1, -1, 
	427, 427, -1, -1, -1, -1, -1, -1, 
	-1, -1, 427, 427, -1, -1, -1, -1, 
	427, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 427, 427, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 426, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, 428, 428, 428, 
	428, 428, 428, 428, 428, 428, -1, 428, 
	428, 428, 428, 428, -1, 428, -1, 428, 
	428, 428, 428, -1, 428, -1, 428, 428, 
	428, -1, -1, 428, 428, 428, 428, 428, 
	428, 428, 428, -1, 428, 428, 428, -1, 
	-1, -1, -1, 428, 428, 428, 428, 428, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	428, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 428, 428, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 427, -1, 428, 428, 428, 428, -1, 
	-1, 428, 428, -1, 428, 428, 428, -1, 
	-1, -1, -1, 428, 428, 428, -1, 428, 
	428, 428, 428, -1, -1, -1, -1, 428, 
	-1, -1, -1, -1, 428, -1, -1, -1, 
	428, 428, 428, 428, -1, 428, 428, -1, 
	-1, 428, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 428, 428, 428, 428, 428, 
	428, 428, 428, -1, -1, -1, -1, 428, 
	428, -1, -1, 428, 428, -1, -1, -1, 
	-1, -1, -1, -1, -1, 428, 428, -1, 
	-1, -1, -1, 428, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 428, 428, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	427, 429, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, 429, 429, 429, 429, 
	429, 429, 429, 429, -1, 429, 429, 429, 
	429, 429, -1, 429, -1, 429, 429, 429, 
	429, -1, 429, -1, 429, 429, 429, -1, 
	-1, 429, 429, 429, 429, 429, 429, 429, 
	429, -1, 429, 429, 429, -1, -1, -1, 
	-1, 429, 429, 429, 429, 429, -1, -1, 
	-1, -1, -1, 430, 430, 430, 430, 430, 
	430, 430, -1, 430, 430, -1, 429, -1, 
	-1, -1, -1, -1, -1, -1, 430, 430, 
	430, 430, 430, -1, -1, -1, -1, -1, 
	-1, -1, -1, 429, 429, 430, -1, -1, 
	-1, 430, -1, -1, -1, 430, 430, 430, 
	430, 430, 430, -1, -1, -1, -1, 430, 
	430, 430, -1, -1, -1, -1, 430, 430, 
	-1, 430, 430, 430, 430, -1, -1, -1, 
	-1, -1, -1, -1, 430, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 430, 430, 430, 430, 430, -1, 
	-1, -1, -1, -1, 428, -1, -1, -1, 
	-1, 429, 429, 429, 429, -1, -1, 429, 
	429, -1, 429, 429, 429, -1, -1, -1, 
	-1, 429, 429, 429, -1, 429, 429, 429, 
	429, -1, -1, -1, -1, 429, -1, -1, 
	-1, -1, 429, -1, -1, -1, 429, 429, 
	429, 429, -1, 429, 429, -1, -1, 429, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 429, 429, 429, 429, 429, 429, 429, 
	429, -1, -1, -1, -1, 429, 429, -1, 
	-1, 429, 429, -1, -1, -1, -1, -1, 
	-1, -1, -1, 429, 429, -1, -1, -1, 
	-1, 429, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 429, 
	429, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 428, -1, 430, 430, 430, 
	430, 430, -1, 430, 430, 430, -1, -1, 
	-1, -1, 430, -1, 431, 431, 431, 431, 
	431, 431, 431, 431, 431, -1, 431, 431, 
	-1, -1, 431, 431, 431, 431, -1, -1, 
	-1, -1, -1, -1, -1, 430, 430, 430, 
	430, 430, 431, 431, 431, -1, -1, -1, 
	431, -1, -1, -1, -1, 431, -1, -1, 
	-1, -1, -1, 431, 431, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 431, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 431, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 431, 
	431, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 429, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 428, 428, 428, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	431, 431, -1, -1, -1, -1, -1, -1, 
	431, -1, -1, -1, -1, 431, 431, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	431, -1, -1, -1, -1, 431, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 431, 431, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 429, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, -1, 432, 432, 
	432, 432, 432, -1, 432, -1, 432, 432, 
	432, 432, -1, 432, -1, 432, 432, 432, 
	-1, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, -1, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, -1, -1, 
	-1, -1, -1, -1, 432, 432, 432, 432, 
	-1, -1, -1, 432, 432, 432, 432, 432, 
	432, 432, 432, 432, 432, 432, 432, 432, 
	432, 432, 432, -1, 432, 432, -1, -1, 
	-1, -1, -1, 432, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 432, 432, 432, 432, -1, -1, 
	432, 432, 432, 432, 432, 432, -1, -1, 
	-1, -1, 432, 432, 432, 432, 432, 432, 
	432, 432, -1, -1, -1, -1, 432, -1, 
	-1, -1, -1, 432, 432, -1, -1, 432, 
	432, 432, 432, -1, 432, 432, -1, -1, 
	432, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 432, 432, 432, 432, 432, 432, 
	432, 432, -1, -1, -1, 432, 432, 432, 
	-1, -1, 432, 432, -1, 432, 432, 432, 
	432, 432, -1, 432, 432, 432, -1, -1, 
	-1, 432, 432, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 432, 432, -1, 
	-1, 432, -1, -1, -1, -1, 432, -1, 
	-1, -1, -1, 432, -1, 432, 432, 432, 
	432, 432, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 430, 430, 
	430, 430, 430, -1, 430, 430, 430, -1, 
	-1, -1, -1, 430, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 430, 430, 
	430, 430, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, -1, 433, 433, 
	433, 433, 433, -1, 433, -1, 433, 433, 
	433, 433, -1, 433, -1, 433, 433, 433, 
	-1, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, -1, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, -1, -1, 
	-1, -1, -1, 432, 433, 433, 433, 433, 
	-1, -1, -1, 433, 433, 433, 433, 433, 
	433, 433, 433, 433, 433, 433, 433, 433, 
	433, 433, 433, -1, 433, 433, -1, -1, 
	-1, -1, -1, 433, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 431, 431, -1, -1, -1, -1, -1, 
	-1, 431, -1, -1, -1, -1, 431, 431, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 431, -1, -1, -1, -1, 431, -1, 
	-1, -1, 433, 433, 433, 433, -1, -1, 
	433, 433, 433, 433, 433, 433, -1, -1, 
	-1, -1, 433, 433, 433, 433, 433, 433, 
	433, 433, -1, -1, 431, -1, 433, -1, 
	-1, -1, -1, 433, 433, -1, -1, 433, 
	433, 433, 433, -1, 433, 433, -1, -1, 
	433, -1, 432, -1, -1, -1, -1, -1, 
	-1, -1, 433, 433, 433, 433, 433, 433, 
	433, 433, -1, -1, -1, 433, 433, 433, 
	-1, -1, 433, 433, -1, 433, 433, 433, 
	433, 433, -1, 433, 433, 433, -1, -1, 
	-1, 433, 433, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 433, 433, -1, 
	-1, 433, -1, -1, -1, -1, 433, -1, 
	-1, -1, -1, 433, -1, 433, 433, 433, 
	433, 433, -1, -1, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, -1, 
	434, 434, 434, 434, 434, -1, 434, -1, 
	434, 434, 434, 434, -1, 434, -1, 434, 
	434, 434, -1, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	-1, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	-1, -1, -1, -1, -1, -1, 434, 434, 
	434, 434, -1, -1, -1, 434, 434, 434, 
	434, 434, 434, 434, 434, 434, 434, 434, 
	434, 434, 434, 434, 434, -1, 434, 434, 
	-1, -1, -1, -1, -1, 434, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 434, 434, 434, 434, 
	-1, -1, 434, 434, 434, 434, 434, 434, 
	-1, -1, -1, 433, 434, 434, 434, 434, 
	434, 434, 434, 434, -1, -1, -1, -1, 
	434, -1, -1, -1, -1, 434, 434, -1, 
	-1, 434, 434, 434, 434, -1, 434, 434, 
	-1, -1, 434, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 434, 434, 434, 434, 
	434, 434, 434, 434, -1, -1, -1, 434, 
	434, 434, -1, -1, 434, 434, -1, 434, 
	434, 434, 434, 434, -1, 434, 434, 434, 
	-1, -1, -1, 434, 434, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 434, 
	434, -1, -1, 434, -1, -1, -1, -1, 
	434, -1, -1, -1, -1, 434, -1, 434, 
	434, 434, 434, 434, -1, -1, -1, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, -1, 435, 435, 435, 435, 435, 
	-1, 435, 433, 435, 435, 435, 435, -1, 
	435, -1, 435, 435, 435, -1, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, -1, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, -1, -1, -1, -1, -1, 
	-1, 435, 435, 435, 435, -1, -1, -1, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	435, 435, 435, 435, 435, 435, 435, 435, 
	-1, 435, 435, -1, -1, -1, -1, -1, 
	435, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 435, 
	435, 435, 435, -1, -1, 435, 435, 435, 
	435, 435, 435, -1, -1, 434, -1, 435, 
	435, 435, 435, 435, 435, 435, 435, -1, 
	-1, -1, -1, 435, -1, -1, -1, -1, 
	435, 435, -1, -1, 435, 435, 435, 435, 
	-1, 435, 435, -1, -1, 435, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 435, 
	435, 435, 435, 435, 435, 435, 435, -1, 
	-1, -1, 435, 435, 435, -1, -1, 435, 
	435, -1, 435, 435, 435, 435, 435, -1, 
	435, 435, 435, -1, -1, -1, 435, 435, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 435, 435, -1, -1, 435, -1, 
	-1, -1, -1, 435, -1, -1, -1, -1, 
	435, -1, 435, 435, 435, 435, 435, -1, 
	-1, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, -1, 436, 436, 436, 
	436, 436, -1, 436, 434, 436, 436, 436, 
	436, -1, 436, -1, 436, 436, 436, -1, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, -1, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, -1, -1, -1, 
	-1, -1, -1, 436, 436, 436, 436, -1, 
	-1, -1, 436, 436, 436, 436, 436, 436, 
	436, 436, 436, 436, 436, 436, 436, 436, 
	436, 436, -1, 436, 436, -1, -1, -1, 
	-1, -1, 436, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 436, 436, 436, 436, -1, -1, 436, 
	436, 436, 436, 436, 436, -1, -1, -1, 
	435, 436, 436, 436, 436, 436, 436, 436, 
	436, -1, -1, -1, -1, 436, -1, -1, 
	-1, -1, 436, 436, -1, -1, 436, 436, 
	436, 436, -1, 436, 436, -1, -1, 436, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 436, 436, 436, 436, 436, 436, 436, 
	436, -1, -1, -1, 436, 436, 436, -1, 
	-1, 436, 436, -1, 436, 436, 436, 436, 
	436, -1, 436, 436, 436, -1, -1, -1, 
	436, 436, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 436, 436, -1, -1, 
	436, -1, -1, -1, -1, 436, -1, -1, 
	-1, -1, 436, -1, 436, 436, 436, 436, 
	436, -1, -1, -1, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, -1, 
	437, 437, 437, 437, 437, -1, 437, 435, 
	437, 437, 437, 437, -1, 437, -1, 437, 
	437, 437, -1, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	-1, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	-1, -1, -1, -1, -1, -1, 437, 437, 
	437, 437, -1, -1, -1, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, -1, 437, 437, 
	-1, -1, -1, -1, -1, 437, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 437, 437, 437, 437, 
	-1, -1, 437, 437, 437, 437, 437, 437, 
	-1, -1, 436, -1, 437, 437, 437, 437, 
	437, 437, 437, 437, -1, -1, -1, -1, 
	437, -1, -1, -1, -1, 437, 437, -1, 
	-1, 437, 437, 437, 437, -1, 437, 437, 
	-1, -1, 437, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 437, 437, 437, 437, 
	437, 437, 437, 437, -1, -1, -1, 437, 
	437, 437, -1, -1, 437, 437, -1, 437, 
	437, 437, 437, 437, -1, 437, 437, 437, 
	-1, -1, -1, 437, 437, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 437, 
	437, -1, -1, 437, -1, -1, -1, -1, 
	437, -1, -1, -1, -1, 437, -1, 437, 
	437, 437, 437, 437, -1, -1, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, -1, 438, 438, 438, 438, 438, -1, 
	438, 436, 438, 438, 438, 438, -1, 438, 
	-1, 438, 438, 438, -1, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, -1, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, -1, 438, -1, -1, -1, -1, 
	438, 438, 438, 438, 438, -1, -1, 438, 
	438, 438, 438, 438, 438, 438, 438, 438, 
	438, 438, 438, 438, 438, 438, 438, -1, 
	438, 438, -1, -1, -1, -1, -1, 438, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 438, 438, 
	438, 438, -1, -1, 438, 438, 438, 438, 
	438, 438, -1, -1, -1, 437, 438, 438, 
	438, 438, 438, 438, 438, 438, -1, -1, 
	-1, -1, 438, -1, -1, -1, -1, 438, 
	438, -1, -1, 438, 438, 438, 438, -1, 
	438, 438, -1, -1, 438, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 438, 438, 
	438, 438, 438, 438, 438, 438, -1, -1, 
	-1, 438, 438, 438, -1, -1, 438, 438, 
	-1, 438, 438, 438, 438, 438, -1, 438, 
	438, 438, -1, -1, -1, 438, 438, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 438, 438, -1, -1, 438, -1, -1, 
	-1, -1, 438, -1, -1, -1, -1, 438, 
	-1, 438, 438, 438, 438, 438, -1, -1, 
	-1, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, -1, 439, 439, 439, 
	439, 439, -1, 439, 437, 439, 439, 439, 
	439, -1, 439, -1, 439, 439, 439, -1, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, -1, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, -1, 439, -1, 
	-1, -1, -1, 439, 439, 439, 439, 439, 
	-1, -1, 439, 439, 439, 439, 439, 439, 
	439, 439, 439, 439, 439, 439, 439, 439, 
	439, 439, -1, 439, 439, -1, -1, -1, 
	-1, -1, 439, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 439, 439, 439, 439, -1, -1, 439, 
	439, 439, 439, 439, 439, -1, -1, 438, 
	-1, 439, 439, 439, 439, 439, 439, 439, 
	439, -1, -1, -1, -1, 439, -1, -1, 
	-1, -1, 439, 439, -1, -1, 439, 439, 
	439, 439, -1, 439, 439, -1, -1, 439, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 439, 439, 439, 439, 439, 439, 439, 
	439, -1, -1, -1, 439, 439, 439, -1, 
	-1, 439, 439, -1, 439, 439, 439, 439, 
	439, -1, 439, 439, 439, -1, -1, -1, 
	439, 439, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 439, 439, -1, -1, 
	439, -1, -1, -1, -1, 439, -1, -1, 
	-1, -1, 439, -1, 439, 439, 439, 439, 
	439, -1, -1, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, -1, 440, 
	440, 440, 440, 440, -1, 440, 438, 440, 
	440, 440, 440, -1, 440, -1, 440, 440, 
	440, -1, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, -1, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, -1, 
	440, -1, -1, -1, -1, 440, 440, 440, 
	440, 440, -1, -1, 440, 440, 440, 440, 
	440, 440, 440, 440, 440, 440, 440, 440, 
	440, 440, 440, 440, -1, 440, 440, -1, 
	-1, -1, -1, -1, 440, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 440, 440, 440, 440, -1, 
	-1, 440, 440, 440, 440, 440, 440, -1, 
	-1, -1, 439, 440, 440, 440, 440, 440, 
	440, 440, 440, -1, -1, -1, -1, 440, 
	-1, -1, -1, -1, 440, 440, -1, -1, 
	440, 440, 440, 440, -1, 440, 440, -1, 
	-1, 440, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 440, 440, 440, 440, 440, 
	440, 440, 440, -1, -1, -1, 440, 440, 
	440, -1, -1, 440, 440, -1, 440, 440, 
	440, 440, 440, -1, 440, 440, 440, -1, 
	-1, -1, 440, 440, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 440, 440, 
	-1, -1, 440, -1, -1, -1, -1, 440, 
	-1, -1, -1, -1, 440, -1, 440, 440, 
	440, 440, 440, -1, -1, -1, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, -1, 441, 441, 441, 441, 441, -1, 
	441, 439, 441, 441, 441, 441, -1, 441, 
	-1, 441, 441, 441, -1, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, -1, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, -1, 441, -1, -1, -1, -1, 
	441, 441, 441, 441, 441, -1, -1, 441, 
	441, 441, 441, 441, 441, 441, 441, 441, 
	441, 441, 441, 441, 441, 441, 441, -1, 
	441, 441, -1, -1, -1, -1, -1, 441, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 441, 441, 
	441, 441, -1, -1, 441, 441, 441, 441, 
	441, 441, -1, -1, 440, -1, 441, 441, 
	441, 441, 441, 441, 441, 441, -1, -1, 
	-1, -1, 441, -1, -1, -1, -1, 441, 
	441, -1, -1, 441, 441, 441, 441, -1, 
	441, 441, -1, -1, 441, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 441, 441, 
	441, 441, 441, 441, 441, 441, -1, -1, 
	-1, 441, 441, 441, -1, -1, 441, 441, 
	-1, 441, 441, 441, 441, 441, -1, 441, 
	441, 441, -1, -1, -1, 441, 441, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 441, 441, -1, -1, 441, -1, -1, 
	-1, -1, 441, -1, -1, -1, -1, 441, 
	-1, 441, 441, 441, 441, 441, -1, -1, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, -1, 442, 442, 442, 442, 
	442, -1, 442, 440, 442, 442, 442, 442, 
	-1, 442, -1, 442, 442, 442, -1, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, -1, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, -1, 442, -1, -1, 
	-1, -1, 442, 442, 442, 442, 442, -1, 
	-1, 442, 442, 442, 442, 442, 442, 442, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	442, -1, 442, 442, -1, -1, -1, -1, 
	-1, 442, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	442, 442, 442, 442, -1, -1, 442, 442, 
	442, 442, 442, 442, -1, -1, -1, 441, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	-1, -1, -1, -1, 442, -1, -1, -1, 
	-1, 442, 442, -1, -1, 442, 442, 442, 
	442, -1, 442, 442, -1, -1, 442, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	442, 442, 442, 442, 442, 442, 442, 442, 
	-1, -1, -1, 442, 442, 442, -1, -1, 
	442, 442, -1, 442, 442, 442, 442, 442, 
	-1, 442, 442, 442, -1, -1, -1, 442, 
	442, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 442, 442, -1, -1, 442, 
	-1, -1, -1, -1, 442, -1, -1, -1, 
	-1, 442, -1, 442, 442, 442, 442, 442, 
	-1, -1, -1, 443, 443, 443, 443, 443, 
	443, 443, 443, 443, 443, 443, 443, 443, 
	443, 443, 443, 443, 443, 443, 443, 443, 
	443, 443, 443, 443, 443, 443, 443, 443, 
	443, 443, 443, 443, -1, 443, 441, 443, 
	443, 443, 443, 443, 443, -1, 443, 443, 
	443, -1, -1, 443, 443, 443, 443, 443, 
	443, 443, 443, -1, 443, 443, 443, 443, 
	-1, -1, -1, 443, 443, 443, 443, 443, 
	-1, -1, 443, 443, 443, 443, -1, -1, 
	-1, 443, -1, -1, -1, 443, 443, -1, 
	443, -1, -1, 443, -1, -1, 443, -1, 
	443, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 443, 443, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 443, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 443, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 443, 443, 443, 443, -1, 
	-1, 443, 443, 443, 443, 443, 443, -1, 
	-1, 442, -1, 443, 443, 443, 443, 443, 
	443, 443, 443, -1, -1, 443, -1, 443, 
	-1, -1, -1, -1, 443, 443, -1, 443, 
	443, 443, 443, 443, -1, 443, 443, -1, 
	-1, 443, -1, -1, -1, -1, -1, -1, 
	443, -1, 443, 443, 443, 443, 443, 443, 
	443, 443, 443, -1, -1, -1, -1, 443, 
	443, -1, 443, 443, 443, -1, -1, -1, 
	-1, -1, -1, -1, -1, 443, 443, -1, 
	-1, 443, -1, 443, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 443, 443, 443, -1, 
	-1, 443, 443, 443, -1, -1, -1, -1, 
	-1, 443, 443, 449, 449, 449, 449, 449, 
	449, 449, -1, 449, 449, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 449, 449, 
	449, 449, 449, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 449, -1, -1, 
	442, 449, -1, -1, -1, 449, 449, 449, 
	449, 449, 449, -1, -1, -1, -1, 449, 
	449, 449, -1, -1, -1, -1, 449, 449, 
	-1, 449, 449, 449, 449, -1, -1, -1, 
	-1, -1, -1, -1, 449, 449, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 449, 449, 449, 449, 449, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 450, 450, 
	450, 450, 450, 450, 450, 450, 450, 450, 
	450, 450, 450, 450, 450, 450, -1, 450, 
	450, 450, 450, 450, 450, 450, 450, -1, 
	-1, -1, 450, 450, 450, 450, 450, -1, 
	450, -1, 450, 450, 450, 450, -1, 450, 
	-1, 450, 450, 450, -1, -1, 450, -1, 
	-1, 450, 450, 450, 450, 450, -1, 450, 
	450, 450, -1, -1, -1, -1, 450, 450, 
	450, 450, 450, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 443, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	450, 450, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 449, 449, 449, 
	449, 449, -1, 449, 449, 449, -1, -1, 
	-1, 449, 449, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 449, 449, 449, 
	449, 449, -1, -1, -1, -1, 450, 450, 
	450, 450, -1, -1, 450, 450, 450, 450, 
	450, 450, -1, -1, 449, -1, 450, 450, 
	450, 450, 450, 450, 450, 450, -1, -1, 
	-1, -1, 450, -1, -1, -1, -1, 450, 
	450, -1, -1, 450, 450, 450, 450, -1, 
	450, 450, -1, 443, 450, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 450, 450, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 450, 450, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	450, 450, -1, -1, -1, -1, 450, -1, 
	455, 455, 455, 455, 455, 455, 455, 455, 
	455, -1, 455, 455, -1, -1, 455, 455, 
	455, 455, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 450, 450, 455, 455, 
	455, -1, -1, -1, 455, -1, -1, -1, 
	-1, 455, -1, -1, -1, -1, -1, 455, 
	455, 456, 456, 456, 456, 456, 456, 456, 
	456, 456, -1, 456, 456, 455, -1, 456, 
	456, 456, 456, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 455, -1, 456, 
	456, 456, -1, -1, -1, 456, -1, -1, 
	-1, -1, 456, -1, -1, -1, -1, -1, 
	456, 456, -1, 455, 455, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 456, -1, 
	-1, 456, 456, 456, 456, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 456, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 456, 456, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 450, 
	-1, -1, -1, -1, 455, 455, -1, -1, 
	-1, -1, -1, -1, 455, -1, -1, -1, 
	-1, 455, 455, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 455, -1, -1, -1, 
	-1, 455, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 456, 456, -1, 
	-1, -1, -1, -1, -1, 456, -1, 455, 
	455, -1, 456, 456, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 456, -1, -1, 
	-1, -1, 456, -1, -1, -1, -1, -1, 
	-1, -1, 456, 456, 456, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	456, 456, -1, 457, 457, 457, 457, 457, 
	457, 457, 457, 457, 457, 457, 457, 457, 
	457, 457, 457, 457, 457, 457, 457, 457, 
	457, 457, 457, 457, 457, 457, 450, 457, 
	457, 457, 457, 457, -1, 457, -1, 457, 
	457, 457, 457, -1, 457, -1, 457, 457, 
	457, -1, -1, 457, 457, 457, 457, 457, 
	457, 457, 457, -1, 457, 457, 457, -1, 
	-1, -1, -1, 457, 457, 457, 457, 457, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 466, 
	457, 466, 466, 466, 466, 466, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 457, 457, -1, 
	-1, -1, -1, 466, 466, 466, 466, 466, 
	-1, 466, -1, 466, -1, -1, -1, -1, 
	466, -1, -1, 466, -1, -1, -1, -1, 
	-1, -1, 466, 466, 466, -1, -1, -1, 
	466, 466, 466, -1, -1, -1, -1, 466, 
	466, 466, -1, 466, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 457, 457, 457, 457, -1, 
	-1, 457, 457, -1, 457, 457, 457, -1, 
	-1, -1, -1, 457, 457, 457, -1, 457, 
	457, 457, 457, -1, -1, -1, -1, 457, 
	-1, -1, -1, -1, 457, 449, -1, -1, 
	457, 457, 457, 457, -1, 457, 457, -1, 
	-1, 457, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 457, 457, 457, 457, 457, 
	457, 457, 457, -1, -1, -1, -1, 457, 
	457, -1, -1, 457, 457, -1, -1, -1, 
	-1, -1, -1, -1, -1, 457, 457, -1, 
	-1, 466, 466, 457, -1, 466, 466, 466, 
	466, -1, 466, -1, -1, -1, -1, 466, 
	466, 466, 466, 466, 466, 466, 466, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 457, 457, -1, 466, -1, 466, 466, 
	-1, 466, 466, -1, -1, 466, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 466, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 466, 466, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, 459, 459, 459, 459, 459, 459, 
	459, 459, -1, 459, 459, 459, 459, 459, 
	-1, 459, -1, 459, 459, 459, 459, -1, 
	459, -1, 459, 459, 459, -1, -1, 459, 
	459, 459, 459, 459, 459, 459, 459, -1, 
	459, 459, 459, -1, -1, -1, -1, 459, 
	459, 459, 459, 459, -1, -1, -1, -1, 
	-1, -1, -1, -1, 457, -1, -1, -1, 
	-1, -1, -1, -1, 459, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 455, 455, -1, 
	-1, 459, 459, -1, -1, 455, -1, -1, 
	-1, -1, 455, 455, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 455, -1, -1, 
	-1, -1, 455, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 456, 456, 
	-1, -1, -1, -1, -1, -1, 456, -1, 
	455, -1, -1, 456, 456, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 456, 459, 
	459, 459, 459, 456, -1, 459, 459, -1, 
	459, 459, 459, 456, 456, 456, -1, 459, 
	459, 459, -1, 459, 459, 459, 459, -1, 
	-1, -1, -1, 459, -1, -1, -1, -1, 
	459, 456, -1, -1, 459, 459, 459, 459, 
	-1, 459, 459, 457, -1, 459, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 459, 
	459, 459, 459, 459, 459, 459, 459, -1, 
	-1, -1, -1, 459, 459, -1, -1, 459, 
	459, -1, -1, -1, -1, -1, -1, -1, 
	-1, 459, 459, -1, -1, -1, -1, 459, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 459, 459, -1, 
	-1, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, -1, 460, 460, 460, 
	460, 460, -1, 460, -1, 460, 460, 460, 
	460, -1, 460, -1, 460, 460, 460, -1, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, -1, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, -1, 460, -1, 
	-1, -1, -1, 460, 460, 460, 460, 460, 
	-1, -1, 460, 460, 460, 460, 460, 460, 
	460, 460, 460, 460, 460, 460, 460, 460, 
	460, 460, -1, 460, 460, -1, -1, -1, 
	-1, -1, 460, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 460, 460, 460, 460, -1, -1, 460, 
	460, 460, 460, 460, 460, -1, -1, -1, 
	459, 460, 460, 460, 460, 460, 460, 460, 
	460, -1, -1, -1, -1, 460, -1, -1, 
	-1, -1, 460, 460, -1, -1, 460, 460, 
	460, 460, -1, 460, 460, -1, -1, 460, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 460, 460, 460, 460, 460, 460, 460, 
	460, -1, -1, -1, 460, 460, 460, -1, 
	-1, 460, 460, -1, 460, 460, 460, 460, 
	460, -1, 460, 460, 460, -1, -1, -1, 
	460, 460, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 460, 460, -1, -1, 
	460, -1, -1, -1, -1, 460, -1, -1, 
	-1, -1, 460, -1, 460, 460, 460, 460, 
	460, -1, -1, -1, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, -1, 
	461, 461, 461, 461, 461, -1, 461, 459, 
	461, 461, 461, 461, -1, 461, -1, 461, 
	461, 461, -1, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	-1, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	-1, 461, -1, -1, -1, -1, 461, 461, 
	461, 461, 461, -1, -1, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, -1, 461, 461, 
	-1, -1, -1, -1, -1, 461, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 461, 461, 461, 461, 
	-1, -1, 461, 461, 461, 461, 461, 461, 
	-1, -1, 460, -1, 461, 461, 461, 461, 
	461, 461, 461, 461, -1, -1, -1, -1, 
	461, -1, -1, -1, -1, 461, 461, -1, 
	-1, 461, 461, 461, 461, -1, 461, 461, 
	-1, -1, 461, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 461, 461, 461, 461, 
	461, 461, 461, 461, -1, -1, -1, 461, 
	461, 461, -1, -1, 461, 461, -1, 461, 
	461, 461, 461, 461, -1, 461, 461, 461, 
	-1, -1, -1, 461, 461, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 461, 
	461, -1, -1, 461, -1, -1, -1, -1, 
	461, -1, -1, -1, -1, 461, -1, 461, 
	461, 461, 461, 461, -1, -1, 462, 462, 
	462, 462, 462, 462, 462, 462, 462, 462, 
	462, 462, 462, 462, 462, 462, -1, 462, 
	462, 462, 462, 462, 462, 462, 462, -1, 
	-1, -1, 462, 462, 462, 462, 462, -1, 
	462, 460, 462, 462, 462, 462, -1, 462, 
	-1, 462, 462, 462, -1, -1, 462, -1, 
	-1, 462, 462, 462, 462, 462, -1, 462, 
	462, 462, -1, -1, -1, -1, 462, 462, 
	462, 462, 462, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	462, 462, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 462, 462, 
	462, 462, -1, -1, 462, 462, -1, 462, 
	462, 462, -1, -1, -1, 461, 462, 462, 
	462, -1, 462, 462, 462, 462, -1, -1, 
	-1, -1, 462, -1, -1, -1, -1, 462, 
	462, -1, -1, 462, 462, 462, 462, -1, 
	462, 462, -1, -1, 462, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 462, 462, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 462, 462, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	462, 462, -1, -1, -1, -1, 462, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 462, 462, -1, -1, 
	-1, 463, 463, 463, 463, 463, 463, 463, 
	463, 463, 463, 463, 463, 463, 463, 463, 
	463, -1, 463, 463, 463, 463, 463, 463, 
	463, 463, -1, -1, -1, 463, 463, 463, 
	463, 463, -1, 463, 461, 463, 463, 463, 
	463, -1, 463, -1, 463, 463, 463, -1, 
	-1, 463, -1, -1, 463, 463, 463, 463, 
	463, -1, 463, 463, 463, -1, -1, -1, 
	-1, 463, 463, 463, 463, 463, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 463, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 463, 463, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 463, 463, 463, 463, -1, -1, 463, 
	463, 463, 463, 463, 463, -1, -1, 462, 
	-1, 463, 463, 463, 463, 463, 463, 463, 
	463, -1, -1, -1, -1, 463, -1, -1, 
	-1, -1, 463, 463, -1, -1, 463, 463, 
	463, 463, -1, 463, 463, -1, -1, 463, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 463, 463, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 463, 463, -1, -1, -1, -1, -1, 
	-1, -1, -1, 463, 463, -1, -1, -1, 
	-1, 463, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 463, 
	463, -1, -1, 465, 465, 465, 465, 465, 
	465, 465, 465, 465, 465, 465, 465, 465, 
	465, 465, 465, -1, 465, 465, 465, 465, 
	465, 465, 465, 465, -1, -1, -1, 465, 
	465, 465, 465, 465, -1, 465, 462, 465, 
	465, 465, 465, -1, 465, -1, 465, 465, 
	465, -1, -1, 465, -1, -1, 465, 465, 
	465, 465, 465, -1, 465, 465, 465, -1, 
	-1, -1, -1, 465, 465, 465, 465, 465, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 467, -1, 
	467, 467, 467, 467, 467, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 465, 465, -1, 
	-1, -1, 467, 467, 467, 467, 467, -1, 
	467, -1, 467, -1, -1, -1, -1, 467, 
	-1, -1, 467, -1, -1, -1, -1, -1, 
	-1, 467, 467, 467, -1, -1, -1, 467, 
	467, 467, -1, -1, -1, -1, 467, 467, 
	467, -1, 467, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 465, 465, 465, 465, -1, 
	-1, 465, 465, 465, 465, 465, 465, -1, 
	-1, -1, 463, 465, 465, 465, 465, 465, 
	465, 465, 465, -1, -1, -1, -1, 465, 
	-1, -1, -1, -1, 465, 465, -1, -1, 
	465, 465, 465, 465, -1, 465, 465, -1, 
	-1, 465, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 465, 465, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 465, 465, -1, -1, -1, 
	-1, -1, -1, -1, -1, 465, 465, -1, 
	467, 467, -1, 465, 467, 467, 467, 467, 
	-1, 467, -1, -1, -1, -1, 467, 467, 
	467, 467, 467, 467, 467, 467, -1, -1, 
	-1, 468, -1, 468, 468, 468, 468, 468, 
	-1, 465, 465, 467, -1, 467, 467, -1, 
	467, 467, -1, -1, 467, -1, -1, -1, 
	-1, -1, -1, -1, -1, 468, 468, 468, 
	468, 468, -1, 468, -1, 468, -1, -1, 
	-1, -1, 468, -1, -1, 468, 467, -1, 
	-1, 463, -1, -1, 468, 468, 468, -1, 
	467, 467, 468, 468, 468, -1, -1, -1, 
	-1, 468, 468, 468, -1, 468, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 469, 
	-1, 469, 469, 469, 469, 469, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 469, 469, 469, 469, 469, 
	-1, 469, -1, 469, -1, -1, -1, -1, 
	469, -1, -1, 469, -1, -1, -1, -1, 
	-1, -1, 469, 469, 469, -1, -1, -1, 
	469, 469, 469, -1, -1, -1, -1, 469, 
	469, 469, -1, 469, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 468, 468, -1, -1, 468, 
	468, 468, 468, -1, 468, -1, -1, -1, 
	-1, 468, 468, 468, 468, 468, 468, 468, 
	468, -1, -1, -1, 465, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 468, -1, 
	468, 468, -1, 468, 468, -1, -1, 468, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 468, -1, -1, -1, -1, -1, -1, 
	-1, 469, 469, 468, 468, 469, 469, 469, 
	469, -1, 469, -1, -1, -1, -1, 469, 
	469, 469, 469, 469, 469, 469, 469, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 469, -1, 469, 469, 
	-1, 469, 469, -1, 470, 469, 470, 470, 
	470, 470, 470, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 469, 
	470, 470, 470, 470, 470, -1, 470, -1, 
	470, 469, 469, -1, -1, 470, -1, -1, 
	470, -1, -1, 465, -1, -1, -1, 470, 
	470, 470, -1, -1, -1, 470, 470, 470, 
	-1, -1, -1, -1, 470, 470, 470, -1, 
	470, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 471, -1, 471, 471, 471, 471, 
	471, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 471, 471, 
	471, 471, 471, -1, 471, -1, 471, -1, 
	-1, -1, -1, 471, -1, -1, 471, -1, 
	-1, -1, -1, -1, -1, 471, 471, 471, 
	-1, -1, -1, 471, 471, 471, -1, -1, 
	-1, -1, 471, 471, 471, -1, 471, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 470, 470, 
	-1, -1, 470, 470, 470, 470, -1, 470, 
	-1, -1, -1, -1, 470, 470, 470, 470, 
	470, 470, 470, 470, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 470, -1, 470, 470, -1, 470, 470, 
	-1, -1, 470, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 470, -1, -1, -1, 
	-1, -1, -1, -1, 471, 471, 470, 470, 
	471, 471, 471, 471, -1, 471, -1, -1, 
	-1, -1, 471, 471, 471, 471, 471, 471, 
	471, 471, -1, -1, -1, 472, -1, 472, 
	472, 472, 472, 472, -1, -1, -1, 471, 
	-1, 471, 471, -1, 471, 471, -1, -1, 
	471, -1, -1, -1, -1, -1, -1, -1, 
	-1, 472, 472, 472, 472, 472, -1, 472, 
	-1, 472, -1, -1, -1, -1, 472, -1, 
	-1, 472, 471, -1, -1, -1, -1, -1, 
	472, 472, 472, -1, 471, 471, 472, 472, 
	472, -1, -1, -1, -1, 472, 472, 472, 
	-1, 472, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 473, -1, 473, 473, 473, 
	473, 473, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 473, 
	473, 473, 473, 473, -1, 473, -1, 473, 
	-1, -1, -1, -1, 473, -1, -1, 473, 
	-1, -1, -1, -1, -1, -1, 473, 473, 
	473, -1, -1, -1, 473, 473, 473, -1, 
	-1, -1, -1, 473, 473, 473, -1, 473, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 472, 
	472, -1, -1, 472, 472, 472, 472, -1, 
	472, -1, -1, -1, -1, 472, 472, 472, 
	472, 472, 472, 472, 472, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 472, -1, 472, 472, -1, 472, 
	472, -1, -1, 472, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 472, -1, -1, 
	-1, -1, -1, -1, -1, 473, 473, 472, 
	472, 473, 473, 473, 473, -1, 473, -1, 
	-1, -1, -1, 473, 473, 473, 473, 473, 
	473, 473, 473, -1, -1, -1, 474, -1, 
	474, 474, 474, 474, 474, -1, -1, -1, 
	473, -1, 473, 473, -1, 473, 473, -1, 
	-1, 473, -1, -1, -1, -1, -1, -1, 
	-1, -1, 474, 474, 474, 474, 474, -1, 
	474, -1, 474, -1, -1, -1, -1, 474, 
	-1, -1, 474, 473, -1, -1, -1, -1, 
	-1, 474, 474, 474, -1, 473, 473, 474, 
	474, 474, -1, -1, -1, -1, 474, 474, 
	474, -1, 474, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 475, -1, 475, 475, 
	475, 475, 475, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	475, 475, 475, 475, 475, -1, 475, -1, 
	475, -1, -1, -1, -1, 475, -1, -1, 
	475, -1, -1, -1, -1, -1, -1, 475, 
	475, 475, -1, -1, -1, 475, 475, 475, 
	-1, -1, -1, -1, 475, 475, 475, -1, 
	475, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	474, 474, -1, -1, 474, 474, 474, 474, 
	-1, 474, -1, -1, -1, -1, 474, 474, 
	474, 474, 474, 474, 474, 474, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 474, -1, 474, 474, -1, 
	474, 474, -1, -1, 474, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 474, -1, 
	-1, -1, -1, -1, -1, -1, 475, 475, 
	474, 474, 475, 475, 475, 475, -1, 475, 
	-1, -1, -1, -1, 475, 475, 475, 475, 
	475, 475, 475, 475, -1, -1, -1, 476, 
	-1, 476, 476, 476, 476, 476, -1, -1, 
	-1, 475, -1, 475, 475, -1, 475, 475, 
	-1, -1, 475, -1, -1, -1, -1, -1, 
	-1, -1, -1, 476, 476, 476, 476, 476, 
	-1, 476, -1, 476, -1, -1, -1, -1, 
	476, -1, -1, 476, 475, -1, -1, -1, 
	-1, -1, 476, 476, 476, -1, 475, 475, 
	476, 476, 476, -1, -1, -1, -1, 476, 
	476, 476, -1, 476, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 477, -1, 477, 
	477, 477, 477, 477, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 477, 477, 477, 477, 477, -1, 477, 
	-1, 477, -1, -1, -1, -1, 477, -1, 
	-1, 477, -1, -1, -1, -1, -1, -1, 
	477, 477, 477, -1, -1, -1, 477, 477, 
	477, -1, -1, -1, -1, 477, 477, 477, 
	-1, 477, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 476, 476, -1, -1, 476, 476, 476, 
	476, -1, 476, -1, -1, -1, -1, 476, 
	476, 476, 476, 476, 476, 476, 476, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 476, -1, 476, 476, 
	-1, 476, 476, -1, -1, 476, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 476, 
	-1, -1, -1, -1, -1, -1, -1, 477, 
	477, 476, 476, 477, 477, 477, 477, -1, 
	477, -1, -1, -1, -1, 477, 477, 477, 
	477, 477, 477, 477, 477, -1, -1, -1, 
	478, -1, 478, 478, 478, 478, 478, -1, 
	-1, -1, 477, -1, 477, 477, -1, 477, 
	477, -1, -1, 477, -1, -1, -1, -1, 
	-1, -1, -1, -1, 478, 478, 478, 478, 
	478, -1, 478, -1, 478, -1, -1, -1, 
	-1, 478, -1, -1, 478, 477, -1, -1, 
	-1, -1, -1, 478, 478, 478, -1, 477, 
	477, 478, 478, 478, -1, -1, -1, -1, 
	478, 478, 478, -1, 478, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 479, -1, 
	479, 479, 479, 479, 479, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 479, 479, 479, 479, 479, -1, 
	479, -1, 479, -1, -1, -1, -1, 479, 
	-1, -1, 479, -1, -1, -1, -1, -1, 
	-1, 479, 479, 479, -1, -1, -1, 479, 
	479, 479, -1, -1, -1, -1, 479, 479, 
	479, -1, 479, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 478, 478, -1, -1, 478, 478, 
	478, 478, -1, 478, -1, -1, -1, -1, 
	478, 478, 478, 478, 478, 478, 478, 478, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 478, -1, 478, 
	478, -1, 478, 478, -1, -1, 478, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	478, -1, -1, -1, -1, -1, -1, -1, 
	479, 479, 478, 478, 479, 479, 479, 479, 
	-1, 479, -1, -1, -1, -1, 479, 479, 
	479, 479, 479, 479, 479, 479, -1, -1, 
	-1, 480, -1, 480, 480, 480, 480, 480, 
	-1, -1, -1, 479, -1, 479, 479, -1, 
	479, 479, -1, -1, 479, -1, -1, -1, 
	-1, -1, -1, -1, -1, 480, 480, 480, 
	480, 480, -1, 480, -1, 480, -1, -1, 
	-1, -1, 480, -1, -1, 480, 479, -1, 
	-1, -1, -1, -1, 480, 480, 480, -1, 
	479, 479, 480, 480, 480, -1, -1, -1, 
	-1, 480, 480, 480, -1, 480, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 481, 
	-1, 481, 481, 481, 481, 481, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 481, 481, 481, 481, 481, 
	-1, 481, -1, 481, -1, -1, -1, -1, 
	481, -1, -1, 481, -1, -1, -1, -1, 
	-1, -1, 481, 481, 481, -1, -1, -1, 
	481, 481, 481, -1, -1, -1, -1, 481, 
	481, 481, -1, 481, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 480, 480, -1, -1, 480, 
	480, 480, 480, -1, 480, -1, -1, -1, 
	-1, 480, 480, 480, 480, 480, 480, 480, 
	480, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 480, -1, 
	480, 480, -1, 480, 480, -1, -1, 480, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 480, -1, -1, -1, -1, -1, -1, 
	-1, 481, 481, 480, 480, 481, 481, 481, 
	481, -1, 481, -1, -1, -1, -1, 481, 
	481, 481, 481, 481, 481, 481, 481, -1, 
	-1, -1, 482, -1, 482, 482, 482, 482, 
	482, -1, -1, -1, 481, -1, 481, 481, 
	-1, 481, 481, -1, -1, 481, -1, -1, 
	-1, -1, -1, -1, -1, -1, 482, 482, 
	482, 482, 482, -1, 482, -1, 482, -1, 
	-1, -1, -1, 482, -1, -1, 482, 481, 
	-1, -1, -1, -1, -1, 482, 482, 482, 
	-1, 481, 481, 482, 482, 482, -1, -1, 
	-1, -1, 482, 482, 482, -1, 482, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	483, -1, 483, 483, 483, 483, 483, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 483, 483, 483, 483, 
	483, -1, 483, -1, 483, -1, -1, -1, 
	-1, 483, -1, -1, 483, -1, -1, -1, 
	-1, -1, -1, 483, 483, 483, -1, -1, 
	-1, 483, 483, 483, -1, -1, -1, -1, 
	483, 483, 483, -1, 483, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 482, 482, -1, -1, 
	482, 482, 482, 482, -1, 482, -1, -1, 
	-1, -1, 482, 482, 482, 482, 482, 482, 
	482, 482, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 482, 
	-1, 482, 482, -1, 482, 482, -1, -1, 
	482, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 482, -1, -1, -1, -1, -1, 
	-1, -1, 483, 483, 482, 482, 483, 483, 
	483, 483, -1, 483, -1, -1, -1, -1, 
	483, 483, 483, 483, 483, 483, 483, 483, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 483, -1, 483, 
	483, -1, 483, 483, -1, -1, 483, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	484, 484, 484, 484, 484, 484, 484, 484, 
	484, 484, 484, 484, 484, 484, 484, 484, 
	483, 484, 484, 484, 484, 484, 484, 484, 
	484, -1, 483, 483, 484, 484, 484, 484, 
	484, -1, 484, -1, 484, 484, 484, 484, 
	-1, 484, -1, 484, 484, 484, -1, -1, 
	484, -1, -1, 484, 484, 484, 484, 484, 
	-1, 484, 484, 484, 484, -1, -1, -1, 
	484, 484, 484, 484, 484, -1, 484, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 484, 484, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	484, 484, 484, 484, -1, -1, 484, 484, 
	484, 484, 484, 484, -1, -1, -1, -1, 
	484, 484, 484, 484, 484, 484, 484, 484, 
	-1, 484, 484, -1, 484, -1, -1, -1, 
	-1, 484, 484, -1, -1, 484, 484, 484, 
	484, -1, 484, 484, -1, -1, 484, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 484, 484, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	484, 484, -1, -1, -1, -1, -1, -1, 
	-1, -1, 484, 484, -1, -1, -1, -1, 
	484, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 484, 484, 
	-1, -1, 488, 488, 488, 488, 488, 488, 
	488, 488, 488, 488, 488, 488, 488, 488, 
	488, 488, 488, 488, 488, 488, 488, 488, 
	488, 488, 488, 488, 488, -1, 488, 488, 
	488, 488, 488, -1, 488, -1, 488, 488, 
	488, 488, -1, 488, -1, 488, 488, 488, 
	-1, -1, 488, 488, 488, 488, 488, 488, 
	488, 488, -1, 488, 488, 488, -1, -1, 
	-1, -1, 488, 488, 488, 488, 488, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 488, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 488, 488, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 488, 488, 488, 488, -1, -1, 
	488, 488, -1, 488, 488, 488, -1, -1, 
	-1, 484, 488, 488, 488, -1, 488, 488, 
	488, 488, -1, -1, -1, -1, 488, -1, 
	-1, -1, -1, 488, -1, -1, -1, 488, 
	488, 488, 488, -1, 488, 488, -1, -1, 
	488, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 488, 488, 488, 488, 488, 488, 
	488, 488, -1, -1, -1, -1, 488, 488, 
	-1, -1, 488, 488, -1, -1, -1, -1, 
	-1, -1, -1, -1, 488, 488, -1, -1, 
	-1, -1, 488, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	488, 488, -1, -1, -1, 489, 489, 489, 
	489, 489, 489, 489, 489, 489, 489, 489, 
	489, 489, 489, 489, 489, -1, 489, 489, 
	489, 489, 489, 489, 489, 489, -1, -1, 
	-1, 489, 489, 489, 489, 489, -1, 489, 
	484, 489, 489, 489, 489, -1, 489, -1, 
	489, 489, 489, -1, -1, 489, -1, -1, 
	489, 489, 489, 489, 489, -1, 489, 489, 
	489, -1, -1, -1, -1, 489, 489, 489, 
	489, 489, -1, -1, -1, -1, -1, -1, 
	-1, 489, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 489, 
	489, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 489, 489, 489, 
	489, -1, -1, 489, 489, 489, 489, 489, 
	489, -1, -1, 488, -1, 489, 489, 489, 
	489, 489, 489, 489, 489, -1, -1, -1, 
	-1, 489, -1, -1, -1, -1, 489, 489, 
	-1, -1, 489, 489, 489, 489, -1, 489, 
	489, -1, -1, 489, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	489, 489, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 489, 489, -1, 
	-1, -1, -1, -1, -1, -1, -1, 489, 
	489, -1, -1, -1, -1, 489, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 489, 489, -1, -1, -1, 
	-1, 491, 491, 491, 491, 491, 491, 491, 
	491, 491, 491, 491, 491, 491, 491, 491, 
	491, 491, 491, 491, 491, 491, 491, 491, 
	491, 491, 491, 491, 491, 491, 491, 491, 
	491, 491, 488, 491, -1, 491, 491, 491, 
	491, 491, 491, -1, 491, 491, 491, -1, 
	-1, 491, 491, 491, 491, 491, 491, 491, 
	491, -1, 491, 491, 491, 491, -1, -1, 
	-1, 491, 491, 491, 491, 491, -1, 491, 
	491, 491, 491, 491, 491, 491, -1, 491, 
	-1, -1, -1, 491, 491, -1, 491, -1, 
	-1, 491, -1, -1, 491, -1, 491, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 491, 491, -1, -1, -1, 
	-1, -1, 491, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 491, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 491, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 491, 491, 491, 491, -1, -1, 491, 
	491, 491, 491, 491, 491, -1, 489, -1, 
	-1, 491, 491, 491, 491, 491, 491, 491, 
	491, -1, -1, 491, -1, 491, -1, -1, 
	-1, -1, 491, 491, -1, 491, 491, 491, 
	491, 491, -1, 491, 491, -1, -1, 491, 
	-1, 491, 491, -1, 489, -1, 491, -1, 
	491, 491, 491, 491, 491, 491, 491, 491, 
	491, -1, -1, -1, -1, 491, 491, -1, 
	491, 491, 491, -1, -1, -1, -1, -1, 
	-1, -1, -1, 491, 491, -1, -1, 491, 
	-1, 491, 491, -1, -1, -1, 491, 491, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 491, 491, 491, -1, -1, 491, 
	491, 491, -1, -1, -1, -1, -1, 491, 
	491, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 489, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 492, 492, 492, 492, 
	492, 492, 492, 492, 492, 492, 492, 492, 
	492, 492, 492, 492, 492, 492, 492, 492, 
	492, 492, 492, 492, 492, 492, 492, 492, 
	492, 492, 492, 492, 492, -1, 492, -1, 
	492, 492, 492, 492, 492, 492, -1, 492, 
	492, 492, -1, -1, 492, 492, 492, 492, 
	492, 492, 492, 492, -1, 492, 492, 492, 
	492, -1, -1, -1, 492, 492, 492, 492, 
	492, -1, 492, 492, 492, 492, 492, 492, 
	492, -1, 492, -1, -1, -1, 492, 492, 
	-1, 492, -1, -1, 492, -1, -1, 492, 
	-1, 492, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 492, 492, 
	-1, -1, -1, -1, -1, 492, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 492, -1, 
	-1, -1, 491, -1, -1, -1, -1, -1, 
	492, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 492, 492, 492, 492, 
	-1, -1, 492, 492, 492, 492, 492, 492, 
	-1, -1, 491, 491, 492, 492, 492, 492, 
	492, 492, 492, 492, -1, -1, 492, -1, 
	492, -1, -1, -1, -1, 492, 492, -1, 
	492, 492, 492, 492, 492, -1, 492, 492, 
	-1, -1, 492, -1, 492, 492, -1, -1, 
	-1, 492, -1, 492, 492, 492, 492, 492, 
	492, 492, 492, 492, -1, -1, -1, -1, 
	492, 492, -1, 492, 492, 492, -1, -1, 
	-1, -1, -1, -1, -1, -1, 492, 492, 
	-1, -1, 492, -1, 492, 492, -1, -1, 
	-1, 492, 492, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 492, 492, 492, 
	-1, 491, 492, 492, 492, -1, -1, -1, 
	-1, -1, 492, 492, -1, -1, 493, 493, 
	493, 493, 493, 493, 493, 493, 493, 493, 
	493, 493, 493, 493, 493, 493, -1, 493, 
	493, 493, 493, 493, 493, 493, 493, -1, 
	-1, -1, 493, 493, 493, 493, 493, -1, 
	493, -1, 493, 493, 493, 493, -1, 493, 
	493, 493, 493, 493, -1, -1, 493, -1, 
	-1, 493, 493, 493, 493, 493, -1, 493, 
	493, 493, -1, -1, -1, -1, 493, 493, 
	493, 493, 493, -1, -1, -1, -1, -1, 
	-1, -1, 493, -1, -1, -1, -1, -1, 
	-1, -1, 493, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	493, 493, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 493, 493, 
	493, 493, -1, -1, 493, 493, 493, 493, 
	493, 493, -1, -1, -1, 492, 493, 493, 
	493, 493, 493, 493, 493, 493, -1, -1, 
	-1, -1, 493, -1, -1, -1, -1, 493, 
	493, -1, -1, 493, 493, 493, 493, -1, 
	493, 493, -1, -1, 493, -1, -1, -1, 
	-1, 493, -1, -1, 493, -1, -1, -1, 
	-1, 493, 493, -1, -1, 492, 492, -1, 
	-1, -1, -1, -1, -1, -1, 493, 493, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	493, 493, -1, -1, -1, -1, 493, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 493, 493, -1, -1, 
	-1, 494, 494, 494, 494, 494, 494, 494, 
	494, 494, 494, 494, 494, 494, 494, 494, 
	494, -1, 494, 494, 494, 494, 494, 494, 
	494, 494, -1, -1, -1, 494, 494, 494, 
	494, 494, -1, 494, 492, 494, 494, 494, 
	494, -1, 494, -1, 494, 494, 494, -1, 
	-1, 494, -1, -1, 494, 494, 494, 494, 
	494, -1, 494, 494, 494, -1, -1, -1, 
	-1, 494, 494, 494, 494, 494, -1, -1, 
	-1, -1, -1, -1, -1, 494, -1, -1, 
	-1, -1, -1, -1, -1, 494, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 494, 494, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 494, 494, 494, 494, -1, -1, 494, 
	494, 494, 494, 494, 494, -1, -1, 493, 
	-1, 494, 494, 494, 494, 494, 494, 494, 
	494, -1, -1, -1, -1, 494, -1, -1, 
	-1, -1, 494, 494, -1, -1, 494, 494, 
	494, 494, -1, 494, 494, -1, -1, 494, 
	-1, -1, -1, -1, -1, 493, -1, 494, 
	-1, -1, -1, -1, 494, 494, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 493, 
	-1, 494, 494, -1, -1, -1, -1, -1, 
	-1, -1, -1, 494, 494, -1, -1, -1, 
	-1, 494, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 494, 
	494, -1, -1, 495, 495, 495, 495, 495, 
	495, 495, 495, 495, 495, 495, 495, 495, 
	495, 495, 495, -1, 495, 495, 495, 495, 
	495, 495, 495, 495, -1, -1, -1, 495, 
	495, 495, 495, 495, -1, 495, 493, 495, 
	495, 495, 495, -1, 495, -1, 495, 495, 
	495, -1, -1, 495, -1, -1, 495, 495, 
	495, 495, 495, -1, 495, 495, 495, -1, 
	-1, -1, -1, 495, 495, 495, 495, 495, 
	-1, -1, -1, -1, -1, -1, -1, 495, 
	-1, -1, -1, -1, -1, -1, -1, 495, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 495, 495, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 495, 495, 495, 495, -1, 
	-1, 495, 495, 495, 495, 495, 495, -1, 
	-1, -1, 494, 495, 495, 495, 495, 495, 
	495, 495, 495, -1, -1, -1, -1, 495, 
	-1, -1, -1, -1, 495, 495, -1, -1, 
	495, 495, 495, 495, -1, 495, 495, -1, 
	-1, 495, -1, -1, -1, -1, -1, -1, 
	494, 495, -1, -1, -1, -1, 495, 495, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 494, 495, 495, -1, -1, -1, 
	-1, -1, -1, -1, -1, 495, 495, -1, 
	-1, -1, -1, 495, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 495, 495, -1, -1, -1, -1, -1, 
	496, 496, 496, 496, 496, 496, 496, 496, 
	496, 496, 496, 496, 496, 496, 496, 496, 
	-1, 496, 496, 496, 496, 496, 496, 496, 
	496, -1, -1, -1, 496, 496, 496, 496, 
	496, 494, 496, -1, 496, 496, 496, 496, 
	-1, 496, -1, 496, 496, 496, -1, -1, 
	496, -1, -1, 496, 496, 496, 496, 496, 
	-1, 496, 496, 496, -1, -1, -1, -1, 
	496, 496, 496, 496, 496, -1, -1, -1, 
	-1, -1, -1, -1, 496, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 496, 496, -1, -1, -1, 701, 
	701, 701, 701, 701, 701, 701, 701, 701, 
	701, 701, 701, -1, -1, 701, 701, 701, 
	701, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 701, 701, 701, 
	-1, -1, -1, 701, -1, -1, -1, -1, 
	701, -1, -1, -1, -1, -1, 701, 701, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 701, -1, -1, -1, 
	496, 496, 496, 496, -1, -1, 496, 496, 
	-1, 496, 496, 496, 495, 701, -1, -1, 
	496, 496, 496, -1, 496, 496, 496, 496, 
	-1, -1, -1, -1, 496, -1, -1, -1, 
	-1, 496, 701, 701, -1, 496, 496, 496, 
	496, -1, 496, 496, -1, -1, 496, -1, 
	-1, -1, 495, -1, -1, -1, -1, -1, 
	-1, -1, -1, 496, 496, -1, -1, -1, 
	-1, -1, -1, -1, 495, -1, -1, -1, 
	496, 496, -1, -1, -1, -1, -1, -1, 
	494, -1, 496, 496, -1, -1, -1, -1, 
	496, -1, -1, -1, 502, 502, 502, 502, 
	502, 502, 502, 502, 502, 502, 502, 502, 
	502, 502, 502, 502, -1, 502, 502, 502, 
	502, 502, 502, 502, 502, -1, 496, 496, 
	502, 502, 502, 502, 502, -1, 502, -1, 
	502, 502, 502, 502, -1, 502, -1, 502, 
	502, 502, -1, -1, 502, -1, -1, 502, 
	502, 502, 502, 502, -1, 502, 502, 502, 
	-1, -1, -1, 495, 502, 502, 502, 502, 
	502, -1, -1, 701, 701, -1, -1, -1, 
	-1, -1, -1, -1, 701, 701, 701, -1, 
	701, 701, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 701, -1, -1, -1, -1, 
	701, -1, -1, -1, -1, -1, 502, 502, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 701, 701, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 701, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 502, 502, 502, 502, 
	-1, -1, 502, 502, 502, 502, 502, 502, 
	-1, -1, -1, -1, 502, 502, 502, 502, 
	502, 502, 502, 502, -1, -1, -1, -1, 
	502, -1, -1, -1, -1, 502, 502, -1, 
	-1, 502, 502, 502, 502, -1, 502, 502, 
	-1, 496, 502, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 502, 
	502, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 502, 502, -1, -1, 
	-1, -1, -1, -1, -1, -1, 502, 502, 
	-1, -1, -1, -1, 502, -1, -1, -1, 
	518, 518, 518, 518, 518, 518, 518, 518, 
	518, 518, 518, 518, 518, 518, 518, 518, 
	-1, 518, 518, 518, 518, 518, 518, 518, 
	518, -1, 502, 502, 518, 518, 518, 518, 
	518, -1, 518, -1, 518, 518, 518, 518, 
	-1, 518, -1, 518, 518, 518, -1, -1, 
	518, -1, -1, 518, 518, 518, 518, 518, 
	-1, 518, 518, 518, -1, -1, -1, -1, 
	518, 518, 518, 518, 518, -1, 519, 519, 
	519, 519, 519, 519, 519, -1, 519, 519, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 519, 519, 519, 519, 519, -1, -1, 
	496, -1, -1, -1, -1, -1, -1, -1, 
	519, -1, 518, 518, 519, -1, -1, -1, 
	519, 519, 519, 519, 519, 519, -1, -1, 
	-1, -1, 519, 519, 519, -1, -1, -1, 
	-1, 519, 519, -1, 519, 519, 519, 519, 
	-1, -1, -1, -1, -1, -1, -1, 519, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 519, 519, 519, 
	519, 519, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 519, -1, 
	518, 518, 518, 518, -1, -1, 518, 518, 
	518, 518, 518, 518, -1, -1, -1, -1, 
	518, 518, 518, 518, 518, 518, 518, 518, 
	-1, -1, -1, -1, 518, -1, -1, -1, 
	-1, 518, 518, -1, -1, 518, 518, 518, 
	518, -1, 518, 518, -1, 502, 518, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 518, 518, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	518, 518, -1, -1, -1, -1, -1, -1, 
	-1, -1, 518, 518, -1, -1, -1, -1, 
	518, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 518, 518, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	519, 519, 519, 519, 519, -1, 519, 519, 
	519, -1, -1, -1, -1, 519, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	519, 519, 523, 523, 523, 523, 523, 523, 
	523, 519, 523, 523, -1, -1, -1, -1, 
	519, 519, 519, 519, 519, 523, 523, 523, 
	523, 523, -1, -1, 502, -1, -1, -1, 
	-1, -1, -1, -1, 523, -1, -1, -1, 
	523, -1, -1, -1, 523, 523, 523, 523, 
	523, 523, -1, -1, -1, -1, 523, 523, 
	523, -1, -1, -1, -1, 523, 523, -1, 
	523, 523, 523, 523, 523, -1, -1, -1, 
	-1, -1, -1, 523, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 523, 523, 523, 523, 523, -1, -1, 
	523, 523, -1, -1, -1, -1, -1, 701, 
	-1, -1, 523, -1, -1, -1, -1, -1, 
	526, 526, 526, 526, 526, 526, 526, -1, 
	526, 526, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 526, 526, 526, 526, 526, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 526, -1, -1, -1, 526, -1, 
	-1, 518, 526, 526, 526, 526, 526, 526, 
	-1, -1, -1, -1, 526, 526, 526, -1, 
	-1, -1, 701, 526, 526, -1, 526, 526, 
	526, 526, -1, -1, -1, -1, -1, -1, 
	-1, 526, 526, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 526, 
	526, 526, 526, 526, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 523, 523, 523, 523, 
	523, -1, 523, 523, 523, -1, -1, -1, 
	-1, 523, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 523, 523, -1, -1, 
	-1, -1, -1, -1, -1, 523, -1, -1, 
	-1, -1, -1, -1, 523, 523, 523, 523, 
	523, -1, -1, -1, -1, -1, -1, -1, 
	518, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 526, 526, 526, 526, 526, -1, 
	526, 526, 526, -1, -1, -1, 526, 526, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 526, 526, 526, 526, 526, -1, 
	-1, -1, -1, -1, -1, 527, 527, 527, 
	527, 527, 527, 527, 527, 527, 527, 527, 
	527, 527, 527, 527, 527, 527, 527, 527, 
	527, 527, 527, 527, 527, 527, 527, 527, 
	-1, 527, 527, 527, 527, 527, -1, 527, 
	-1, 527, 527, 527, 527, -1, 527, -1, 
	527, 527, 527, -1, 527, 527, 527, 527, 
	527, 527, 527, 527, 527, 527, 527, 527, 
	527, -1, 527, 527, 527, 527, 527, 527, 
	527, 527, 527, 527, 527, 527, 527, 527, 
	527, -1, 527, -1, -1, -1, -1, 527, 
	527, 527, 527, 527, -1, -1, 527, 527, 
	527, 527, 527, 527, 527, 527, 527, 527, 
	527, 527, 527, 527, 527, 527, -1, 527, 
	527, -1, -1, -1, -1, -1, 527, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 527, 527, 527, 
	527, -1, -1, 527, 527, 527, 527, 527, 
	527, -1, -1, -1, -1, 527, 527, 527, 
	527, 527, 527, 527, 527, -1, -1, -1, 
	-1, 527, -1, -1, -1, -1, 527, 527, 
	-1, -1, 527, 527, 527, 527, -1, 527, 
	527, 519, 519, 527, -1, -1, -1, -1, 
	-1, -1, 519, -1, -1, 527, 527, 527, 
	527, 527, 527, 527, 527, -1, -1, -1, 
	527, 527, 527, -1, -1, 527, 527, -1, 
	527, 527, 527, 527, 527, -1, 527, 527, 
	527, -1, -1, -1, 527, 527, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	527, 527, -1, -1, 527, -1, -1, -1, 
	-1, 527, -1, -1, -1, -1, 527, -1, 
	527, 527, 527, 527, 527, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 528, 528, 528, 528, 528, 528, 
	528, 528, 528, 528, 528, 528, 528, 528, 
	528, 528, 528, 528, 528, 528, 528, 528, 
	528, 528, 528, 528, 528, -1, 528, 528, 
	528, 528, 528, -1, 528, -1, 528, 528, 
	528, 528, -1, 528, -1, 528, 528, 528, 
	-1, 528, 528, 528, 528, 528, 528, 528, 
	528, 528, 528, 528, 528, 528, -1, 528, 
	528, 528, 528, 528, 528, 528, 528, 528, 
	528, 528, 528, 528, 528, 528, -1, 528, 
	-1, -1, -1, -1, 528, 528, 528, 528, 
	528, -1, -1, 528, 528, 528, 528, 528, 
	528, 528, 528, 528, 528, 528, 528, 528, 
	528, 528, 528, -1, 528, 528, -1, -1, 
	-1, -1, -1, 528, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 528, 528, 528, 528, 527, -1, 
	528, 528, 528, 528, 528, 528, -1, -1, 
	-1, -1, 528, 528, 528, 528, 528, 528, 
	528, 528, -1, -1, -1, -1, 528, -1, 
	-1, -1, -1, 528, 528, -1, -1, 528, 
	528, 528, 528, -1, 528, 528, -1, -1, 
	528, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 528, 528, 528, 528, 528, 528, 
	528, 528, -1, -1, -1, 528, 528, 528, 
	-1, -1, 528, 528, -1, 528, 528, 528, 
	528, 528, -1, 528, 528, 528, -1, -1, 
	-1, 528, 528, 526, 526, 526, 526, 526, 
	-1, 526, 526, 526, -1, 528, 528, 526, 
	526, 528, -1, -1, -1, -1, 528, -1, 
	-1, -1, -1, 528, -1, 528, 528, 528, 
	528, 528, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 526, 526, 526, 526, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 527, 529, 529, 
	529, 529, 529, 529, 529, 529, 529, 529, 
	529, 529, 529, 529, 529, 529, 529, 529, 
	529, 529, 529, 529, 529, 529, 529, 529, 
	529, -1, 529, 529, 529, 529, 529, -1, 
	529, -1, 529, 529, 529, 529, -1, 529, 
	-1, 529, 529, 529, -1, 529, 529, 529, 
	529, 529, 529, 529, 529, 529, 529, 529, 
	529, 529, -1, 529, 529, 529, 529, 529, 
	529, 529, 529, 529, 529, 529, 529, 529, 
	529, 529, -1, 529, -1, -1, -1, -1, 
	529, 529, 529, 529, 529, -1, -1, 529, 
	529, 529, 529, 529, 529, 529, 529, 529, 
	529, 529, 529, 529, 529, 529, 529, -1, 
	529, 529, -1, -1, -1, -1, -1, 529, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 528, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 529, 529, 
	529, 529, -1, -1, 529, 529, 529, 529, 
	529, 529, -1, -1, -1, -1, 529, 529, 
	529, 529, 529, 529, 529, 529, -1, -1, 
	-1, -1, 529, -1, -1, -1, -1, 529, 
	529, -1, -1, 529, 529, 529, 529, -1, 
	529, 529, -1, -1, 529, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 529, 529, 
	529, 529, 529, 529, 529, 529, -1, -1, 
	-1, 529, 529, 529, -1, -1, 529, 529, 
	-1, 529, 529, 529, 529, 529, -1, 529, 
	529, 529, -1, -1, -1, 529, 529, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 529, 529, -1, -1, 529, -1, -1, 
	-1, -1, 529, -1, -1, -1, -1, 529, 
	-1, 529, 529, 529, 529, 529, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 528, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, -1, 530, 
	530, 530, 530, 530, -1, 530, -1, 530, 
	530, 530, 530, -1, 530, -1, 530, 530, 
	530, -1, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, -1, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, -1, 
	530, -1, -1, -1, -1, 530, 530, 530, 
	530, 530, -1, -1, 530, 530, 530, 530, 
	530, 530, 530, 530, 530, 530, 530, 530, 
	530, 530, 530, 530, -1, 530, 530, -1, 
	-1, -1, -1, -1, 530, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 530, 530, 530, 530, 529, 
	-1, 530, 530, 530, 530, 530, 530, -1, 
	-1, -1, -1, 530, 530, 530, 530, 530, 
	530, 530, 530, -1, -1, -1, -1, 530, 
	-1, -1, -1, -1, 530, 530, -1, -1, 
	530, 530, 530, 530, -1, 530, 530, -1, 
	-1, 530, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 530, 530, 530, 530, 530, 
	530, 530, 530, -1, -1, -1, 530, 530, 
	530, -1, -1, 530, 530, -1, 530, 530, 
	530, 530, 530, -1, 530, 530, 530, -1, 
	-1, -1, 530, 530, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 530, 530, 
	-1, -1, 530, -1, -1, -1, -1, 530, 
	-1, -1, -1, -1, 530, -1, 530, 530, 
	530, 530, 530, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 529, 531, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	531, 531, -1, 531, 531, 531, 531, 531, 
	-1, 531, -1, 531, 531, 531, 531, -1, 
	531, -1, 531, 531, 531, -1, 531, 531, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	531, 531, 531, -1, 531, 531, 531, 531, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	531, 531, 531, -1, 531, -1, -1, -1, 
	-1, 531, 531, 531, 531, 531, -1, -1, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	531, 531, 531, 531, 531, 531, 531, 531, 
	-1, 531, 531, -1, -1, -1, -1, -1, 
	531, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 530, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 531, 
	531, 531, 531, -1, -1, 531, 531, 531, 
	531, 531, 531, -1, -1, -1, -1, 531, 
	531, 531, 531, 531, 531, 531, 531, -1, 
	-1, -1, -1, 531, -1, -1, -1, -1, 
	531, 531, -1, -1, 531, 531, 531, 531, 
	-1, 531, 531, -1, -1, 531, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 531, 
	531, 531, 531, 531, 531, 531, 531, -1, 
	-1, -1, 531, 531, 531, -1, -1, 531, 
	531, -1, 531, 531, 531, 531, 531, -1, 
	531, 531, 531, -1, -1, -1, 531, 531, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 531, 531, -1, -1, 531, -1, 
	-1, -1, -1, 531, -1, -1, -1, -1, 
	531, -1, 531, 531, 531, 531, 531, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 530, 532, 532, 532, 532, 
	532, 532, 532, 532, 532, 532, 532, 532, 
	532, 532, 532, 532, 532, 532, 532, 532, 
	532, 532, 532, 532, 532, 532, 532, -1, 
	532, 532, 532, 532, 532, -1, 532, -1, 
	532, 532, 532, 532, -1, 532, -1, 532, 
	532, 532, -1, 532, 532, 532, 532, 532, 
	532, 532, 532, 532, 532, 532, 532, 532, 
	-1, 532, 532, 532, 532, 532, 532, 532, 
	532, 532, 532, 532, 532, 532, 532, 532, 
	-1, 532, -1, -1, -1, -1, 532, 532, 
	532, 532, 532, -1, -1, 532, 532, 532, 
	532, 532, 532, 532, 532, 532, 532, 532, 
	532, 532, 532, 532, 532, -1, 532, 532, 
	-1, -1, -1, -1, -1, 532, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 532, 532, 532, 532, 
	531, -1, 532, 532, 532, 532, 532, 532, 
	-1, -1, -1, -1, 532, 532, 532, 532, 
	532, 532, 532, 532, -1, -1, -1, -1, 
	532, -1, -1, -1, -1, 532, 532, -1, 
	-1, 532, 532, 532, 532, -1, 532, 532, 
	-1, -1, 532, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 532, 532, 532, 532, 
	532, 532, 532, 532, -1, -1, -1, 532, 
	532, 532, -1, -1, 532, 532, -1, 532, 
	532, 532, 532, 532, -1, 532, 532, 532, 
	-1, -1, -1, 532, 532, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 532, 
	532, -1, -1, 532, -1, -1, -1, -1, 
	532, -1, -1, -1, -1, 532, -1, 532, 
	532, 532, 532, 532, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 531, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, -1, 533, 533, 533, 533, 
	533, -1, 533, -1, 533, 533, 533, 533, 
	-1, 533, -1, 533, 533, 533, -1, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, -1, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, -1, 533, -1, -1, 
	-1, -1, 533, 533, 533, 533, 533, -1, 
	-1, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, -1, 533, 533, -1, -1, -1, -1, 
	-1, 533, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 532, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	533, 533, 533, 533, -1, -1, 533, 533, 
	533, 533, 533, 533, -1, -1, -1, -1, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	-1, -1, -1, -1, 533, -1, -1, -1, 
	-1, 533, 533, -1, -1, 533, 533, 533, 
	533, -1, 533, 533, -1, -1, 533, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	-1, -1, -1, 533, 533, 533, -1, -1, 
	533, 533, -1, 533, 533, 533, 533, 533, 
	-1, 533, 533, 533, -1, -1, -1, 533, 
	533, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 533, 533, -1, -1, 533, 
	-1, -1, -1, -1, 533, -1, -1, -1, 
	-1, 533, -1, 533, 533, 533, 533, 533, 
	534, 534, 534, 534, 534, 534, 534, -1, 
	534, 534, -1, -1, 532, -1, -1, -1, 
	-1, -1, -1, 534, 534, 534, 534, 534, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 534, -1, -1, -1, 534, -1, 
	-1, -1, 534, 534, 534, 534, 534, 534, 
	-1, -1, -1, -1, 534, 534, 534, -1, 
	-1, -1, -1, 534, 534, 534, 534, 534, 
	534, 534, 534, -1, -1, -1, -1, -1, 
	-1, 534, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 534, 
	534, 534, 534, 534, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 533, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 534, 534, 534, 534, 534, -1, 
	534, 534, 534, -1, -1, -1, -1, 534, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 534, 534, -1, -1, 534, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 534, 534, 534, 534, 534, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 534, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	533, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, -1, 535, 535, 535, 
	535, 535, -1, 535, -1, 535, 535, 535, 
	535, -1, 535, -1, 535, 535, 535, -1, 
	535, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, 535, -1, 535, 535, 
	535, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, 535, -1, 535, -1, 
	-1, -1, -1, 535, 535, 535, 535, 535, 
	-1, -1, 535, 535, 535, 535, 535, 535, 
	535, 535, 535, 535, 535, 535, 535, 535, 
	535, 535, -1, 535, 535, -1, -1, -1, 
	-1, -1, 535, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 535, 535, 535, 535, -1, -1, 535, 
	535, 535, 535, 535, 535, -1, -1, -1, 
	-1, 535, 535, 535, 535, 535, 535, 535, 
	535, -1, -1, -1, -1, 535, -1, -1, 
	-1, -1, 535, 535, -1, -1, 535, 535, 
	535, 535, -1, 535, 535, -1, -1, 535, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 535, 535, 535, 535, 535, 535, 535, 
	535, -1, -1, -1, 535, 535, 535, -1, 
	-1, 535, 535, -1, 535, 535, 535, 535, 
	535, -1, 535, 535, 535, -1, -1, -1, 
	535, 535, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 535, 535, -1, -1, 
	535, -1, 535, 535, -1, 535, -1, -1, 
	-1, -1, 535, -1, 535, 535, 535, 535, 
	535, -1, -1, 539, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, -1, 539, 
	539, 539, 539, 539, -1, 539, -1, 539, 
	539, 539, 539, -1, 539, -1, 539, 539, 
	539, -1, 539, 539, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, 539, -1, 
	539, 539, 539, 539, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, 539, -1, 
	539, -1, -1, -1, -1, 539, 539, 539, 
	539, 539, -1, -1, 539, 539, 539, 539, 
	539, 539, 539, 539, 539, 539, 539, 539, 
	539, 539, 539, 539, -1, 539, 539, -1, 
	-1, -1, -1, -1, 539, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 539, 539, 539, 539, -1, 
	-1, 539, 539, 539, 539, 539, 539, -1, 
	-1, -1, 535, 539, 539, 539, 539, 539, 
	539, 539, 539, -1, -1, -1, -1, 539, 
	-1, -1, -1, -1, 539, 539, -1, -1, 
	539, 539, 539, 539, -1, 539, 539, -1, 
	-1, 539, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 539, 539, 539, 539, 539, 
	539, 539, 539, -1, -1, -1, 539, 539, 
	539, 539, -1, 539, 539, -1, 539, 539, 
	539, 539, 539, -1, 539, 539, 539, -1, 
	-1, -1, 539, 539, -1, -1, -1, -1, 
	-1, -1, -1, 539, 539, -1, 539, 539, 
	-1, -1, 539, -1, -1, -1, -1, 539, 
	-1, -1, -1, -1, 539, -1, 539, 539, 
	539, 539, 539, -1, -1, -1, 534, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 539, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 535, -1, -1, -1, -1, -1, -1, 
	-1, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, -1, 543, 543, 543, 
	543, 543, -1, 543, -1, 543, 543, 543, 
	543, -1, 543, -1, 543, 543, 543, -1, 
	543, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, 543, -1, 543, 543, 
	543, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, 543, -1, 543, -1, 
	-1, -1, -1, 543, 543, 543, 543, 543, 
	-1, -1, 543, 543, 543, 543, 543, 543, 
	543, 543, 543, 543, 543, 543, 543, 543, 
	543, 543, -1, 543, 543, -1, -1, -1, 
	-1, -1, 543, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 539, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 543, 543, 543, 543, -1, -1, 543, 
	543, 543, 543, 543, 543, -1, -1, -1, 
	-1, 543, 543, 543, 543, 543, 543, 543, 
	543, -1, -1, -1, -1, 543, -1, -1, 
	-1, -1, 543, 543, -1, -1, 543, 543, 
	543, 543, -1, 543, 543, -1, -1, 543, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 543, 543, 543, 543, 543, 543, 543, 
	543, -1, -1, -1, 543, 543, 543, 543, 
	-1, 543, 543, -1, 543, 543, 543, 543, 
	543, -1, 543, 543, 543, -1, -1, -1, 
	543, 543, -1, 535, 535, -1, -1, -1, 
	-1, 543, 543, -1, 543, 543, -1, -1, 
	543, -1, -1, -1, -1, 543, -1, -1, 
	-1, -1, 543, 539, 543, 543, 543, 543, 
	543, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 543, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, 544, 544, -1, 544, 
	544, 544, 544, 544, -1, 544, -1, 544, 
	544, 544, 544, -1, 544, -1, 544, 544, 
	544, -1, 544, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, 544, 544, 544, -1, 
	544, 544, 544, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, 544, 544, 544, -1, 
	544, -1, -1, -1, -1, 544, 544, 544, 
	544, 544, -1, -1, 544, 544, 544, 544, 
	544, 544, 544, 544, 544, 544, 544, 544, 
	544, 544, 544, 544, -1, 544, 544, -1, 
	-1, -1, -1, -1, 544, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 543, 544, 544, 544, 544, -1, 
	-1, 544, 544, 544, 544, 544, 544, -1, 
	-1, -1, -1, 544, 544, 544, 544, 544, 
	544, 544, 544, -1, -1, -1, -1, 544, 
	-1, -1, -1, -1, 544, 544, -1, -1, 
	544, 544, 544, 544, -1, 544, 544, -1, 
	-1, 544, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 544, 544, 544, 544, 544, 
	544, 544, 544, -1, -1, -1, 544, 544, 
	544, 544, -1, 544, 544, -1, 544, 544, 
	544, 544, 544, -1, 544, 544, 544, -1, 
	-1, -1, 544, 544, -1, -1, -1, -1, 
	-1, -1, -1, 544, 544, -1, 544, 544, 
	-1, -1, 544, -1, -1, -1, -1, 544, 
	-1, -1, -1, -1, 544, -1, 544, 544, 
	544, 544, 544, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 544, -1, -1, -1, 
	-1, 543, -1, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, -1, 545, 
	545, 545, 545, 545, -1, 545, -1, 545, 
	545, 545, 545, -1, 545, -1, 545, 545, 
	545, -1, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, -1, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, -1, 
	545, -1, -1, -1, -1, 545, 545, 545, 
	545, 545, -1, -1, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, -1, 545, 545, -1, 
	-1, -1, -1, -1, 545, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 544, -1, -1, -1, 
	-1, -1, -1, 545, 545, 545, 545, -1, 
	-1, 545, 545, 545, 545, 545, 545, -1, 
	-1, -1, -1, 545, 545, 545, 545, 545, 
	545, 545, 545, -1, -1, -1, -1, 545, 
	-1, -1, -1, -1, 545, 545, -1, -1, 
	545, 545, 545, 545, -1, 545, 545, -1, 
	-1, 545, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 545, 545, 545, 545, 545, 
	545, 545, 545, -1, -1, -1, 545, 545, 
	545, 545, -1, 545, 545, -1, 545, 545, 
	545, 545, 545, -1, 545, 545, 545, -1, 
	-1, -1, 545, 545, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 545, 545, 
	-1, -1, 545, -1, -1, -1, -1, 545, 
	-1, -1, -1, -1, 545, -1, 545, 545, 
	545, 545, 545, 554, 554, 554, 554, 554, 
	554, 554, -1, 554, 554, -1, -1, -1, 
	-1, -1, -1, 544, 545, -1, 554, 554, 
	554, 554, 554, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 554, -1, -1, 
	-1, 554, -1, -1, -1, 554, 554, 554, 
	554, 554, 554, -1, -1, -1, -1, 554, 
	554, 554, -1, -1, -1, -1, 554, 554, 
	-1, 554, 554, 554, 554, -1, -1, -1, 
	-1, -1, -1, -1, 554, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 554, 554, 554, 554, 554, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 555, 555, 555, 555, 
	555, 555, 555, 555, 555, 555, 555, 555, 
	555, 555, 555, 555, 555, 555, 555, 555, 
	555, 555, 555, 555, 555, 555, 555, 555, 
	555, 555, 555, 555, 555, -1, 555, -1, 
	555, 555, 555, 555, 555, 555, -1, 555, 
	555, 555, -1, -1, 555, 555, 555, 555, 
	555, 555, 555, 555, -1, 555, 555, 555, 
	555, -1, -1, -1, 555, 555, 555, 555, 
	555, -1, -1, 555, 555, 555, 555, -1, 
	-1, -1, 555, -1, 545, -1, 555, 555, 
	-1, 555, -1, -1, 555, -1, -1, 555, 
	-1, 555, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 555, 555, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 554, -1, -1, -1, 
	-1, -1, -1, -1, -1, 554, 554, 554, 
	554, 554, -1, 554, 554, 554, 555, -1, 
	-1, -1, 554, -1, -1, -1, -1, -1, 
	555, -1, -1, -1, -1, 554, 554, 554, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 554, 554, 554, 
	554, 554, -1, -1, 555, 555, 555, 555, 
	-1, -1, 555, 555, 555, 555, 555, 555, 
	-1, -1, -1, -1, 555, 555, 555, 555, 
	555, 555, 555, 555, -1, -1, 555, -1, 
	555, -1, -1, -1, -1, 555, 555, -1, 
	555, 555, 555, 555, 555, -1, 555, 555, 
	-1, -1, 555, 545, -1, -1, -1, -1, 
	-1, 555, -1, 555, 555, 555, 555, 555, 
	555, 555, 555, 555, -1, -1, -1, -1, 
	555, 555, -1, 555, 555, 555, -1, -1, 
	-1, -1, -1, -1, -1, -1, 555, 555, 
	-1, -1, 555, -1, 555, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 555, 555, 555, 
	-1, -1, 555, 555, 555, -1, -1, -1, 
	-1, -1, 555, 555, -1, -1, 556, 556, 
	556, 556, 556, 556, 556, 556, 556, 556, 
	556, 556, 556, 556, 556, 556, 556, 556, 
	556, 556, 556, 556, 556, 556, 556, 556, 
	556, 556, 556, 556, 556, 556, 556, -1, 
	556, -1, 556, 556, 556, 556, 556, 556, 
	-1, 556, 556, 556, -1, -1, 556, 556, 
	556, 556, 556, 556, 556, 556, -1, 556, 
	556, 556, 556, -1, -1, -1, 556, 556, 
	556, 556, 556, -1, -1, 556, 556, 556, 
	556, -1, -1, -1, 556, -1, -1, -1, 
	556, 556, -1, 556, -1, -1, 556, -1, 
	-1, 556, -1, 556, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	556, 556, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	556, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 556, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 556, 556, 
	556, 556, -1, -1, 556, 556, 556, 556, 
	556, 556, -1, -1, -1, 555, 556, 556, 
	556, 556, 556, 556, 556, 556, -1, -1, 
	556, -1, 556, -1, -1, -1, -1, 556, 
	556, -1, 556, 556, 556, 556, 556, -1, 
	556, 556, -1, -1, 556, -1, -1, -1, 
	-1, -1, -1, 556, -1, 556, 556, 556, 
	556, 556, 556, 556, 556, 556, -1, -1, 
	-1, -1, 556, 556, -1, 556, 556, 556, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	556, 556, -1, -1, 556, -1, 556, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 556, 
	556, 556, -1, -1, 556, 556, 556, -1, 
	-1, -1, -1, -1, 556, 556, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 555, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, -1, 557, 
	-1, 557, 557, 557, 557, 557, 557, -1, 
	557, 557, 557, -1, -1, 557, 557, 557, 
	557, 557, 557, 557, 557, -1, 557, 557, 
	557, 557, -1, -1, -1, 557, 557, 557, 
	557, 557, -1, -1, 557, 557, 557, 557, 
	-1, -1, -1, 557, -1, -1, -1, 557, 
	557, -1, 557, -1, -1, 557, -1, -1, 
	557, -1, 557, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 557, 
	557, -1, -1, -1, -1, 554, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 557, 
	-1, -1, -1, -1, -1, -1, 554, 554, 
	554, 557, -1, -1, -1, -1, -1, 556, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 557, 557, 557, 
	557, -1, -1, 557, 557, 557, 557, 557, 
	557, -1, -1, -1, -1, 557, 557, 557, 
	557, 557, 557, 557, 557, -1, -1, 557, 
	-1, 557, -1, -1, -1, -1, 557, 557, 
	-1, 557, 557, 557, 557, 557, -1, 557, 
	557, -1, -1, 557, -1, -1, -1, -1, 
	-1, -1, 557, -1, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, -1, -1, -1, 
	-1, 557, 557, -1, 557, 557, 557, -1, 
	-1, -1, -1, -1, -1, -1, -1, 557, 
	557, -1, -1, 557, -1, 557, -1, -1, 
	-1, -1, -1, 560, 560, 560, 560, 560, 
	560, 560, -1, 560, 560, -1, 557, 557, 
	557, -1, -1, 557, 557, 557, 560, 560, 
	560, 560, 560, 557, 557, -1, 556, -1, 
	-1, -1, -1, -1, -1, 560, -1, -1, 
	-1, 560, -1, -1, -1, 560, 560, 560, 
	560, 560, 560, -1, -1, -1, -1, 560, 
	560, 560, -1, -1, -1, -1, 560, 560, 
	-1, 560, 560, 560, 560, -1, -1, -1, 
	-1, -1, -1, -1, 560, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 561, 561, 
	561, 561, 561, 561, 561, 561, 561, 561, 
	561, 561, 561, 561, 561, 561, 561, 561, 
	561, 561, 561, 561, 561, 561, 561, 561, 
	561, -1, 561, 561, 561, 561, 561, -1, 
	561, -1, 561, 561, 561, 561, -1, 561, 
	-1, 561, 561, 561, -1, 561, 561, 561, 
	561, 561, 561, 561, 561, 561, 561, 561, 
	561, 561, -1, 561, 561, 561, 561, 561, 
	561, 561, 561, 561, 561, 561, 561, 561, 
	561, 561, -1, 561, -1, -1, -1, -1, 
	561, 561, 561, 561, 561, -1, 557, 561, 
	561, 561, 561, 561, 561, 561, 561, 561, 
	561, 561, 561, 561, 561, 561, 561, -1, 
	561, 561, -1, -1, -1, -1, -1, 561, 
	-1, -1, -1, 560, 560, 560, -1, -1, 
	-1, -1, 560, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 560, 560, 560, 
	560, 560, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 561, 561, 
	561, 561, -1, -1, 561, 561, 561, 561, 
	561, 561, -1, -1, -1, -1, 561, 561, 
	561, 561, 561, 561, 561, 561, -1, -1, 
	-1, -1, 561, -1, -1, -1, -1, 561, 
	561, -1, -1, 561, 561, 561, 561, -1, 
	561, 561, -1, -1, 561, -1, -1, -1, 
	-1, -1, -1, -1, -1, 557, 561, 561, 
	561, 561, 561, 561, 561, 561, -1, -1, 
	-1, 561, 561, 561, -1, -1, 561, 561, 
	-1, 561, 561, 561, 561, 561, -1, 561, 
	561, 561, -1, -1, -1, 561, 561, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 561, 561, -1, -1, 561, -1, -1, 
	-1, -1, 561, -1, -1, -1, -1, 561, 
	-1, 561, 561, 561, 561, 561, 562, 562, 
	562, 562, 562, 562, 562, -1, 562, 562, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 562, 562, 562, 562, 562, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	562, -1, -1, -1, 562, -1, -1, -1, 
	562, 562, 562, 562, 562, 562, -1, -1, 
	-1, -1, 562, 562, 562, -1, -1, -1, 
	-1, 562, 562, -1, 562, 562, 562, 562, 
	-1, -1, -1, -1, -1, -1, -1, 562, 
	566, 566, 566, 566, 566, 566, 566, -1, 
	566, 566, -1, -1, -1, 562, 562, 562, 
	562, 562, -1, 566, 566, 566, 566, 566, 
	-1, -1, -1, -1, -1, -1, 562, -1, 
	-1, -1, 566, -1, -1, -1, 566, -1, 
	-1, -1, 566, 566, 566, 566, 566, 566, 
	-1, -1, -1, -1, 566, 566, 566, -1, 
	-1, -1, -1, 566, 566, -1, 566, 566, 
	566, 566, 566, -1, -1, -1, -1, -1, 
	-1, 566, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 566, 
	566, 566, 566, 566, -1, -1, 566, 566, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	566, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 561, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	562, 562, 562, 562, 562, -1, 562, 562, 
	562, -1, -1, -1, -1, 562, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	562, 562, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 562, -1, 
	562, 562, 562, 562, 562, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 566, 566, 566, 566, 566, -1, 
	566, 566, 566, -1, -1, -1, -1, 566, 
	-1, -1, -1, -1, -1, -1, 561, -1, 
	-1, -1, 566, 566, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	566, -1, 566, 566, 566, 566, 566, -1, 
	-1, -1, 567, 567, 567, 567, 567, 567, 
	567, 567, 567, 567, 567, 567, 567, 567, 
	567, 567, 567, 567, 567, 567, 567, 567, 
	567, 567, 567, 567, 567, -1, 567, 567, 
	567, 567, 567, -1, 567, -1, 567, 567, 
	567, 567, -1, 567, -1, 567, 567, 567, 
	-1, -1, 567, 567, 567, 567, 567, 567, 
	567, 567, -1, 567, 567, 567, -1, -1, 
	-1, -1, 567, 567, 567, 567, 567, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 560, 560, 560, 567, 
	-1, -1, -1, 560, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 567, 567, -1, -1, 
	-1, -1, -1, -1, -1, -1, 560, 560, 
	560, 560, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 567, 567, 567, 567, -1, -1, 
	567, 567, -1, 567, 567, 567, -1, -1, 
	-1, -1, 567, 567, 567, -1, 567, 567, 
	567, 567, -1, -1, -1, -1, 567, -1, 
	-1, -1, -1, 567, -1, -1, -1, 567, 
	567, 567, 567, -1, 567, 567, -1, -1, 
	567, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 567, 567, 567, 567, 567, 567, 
	567, 567, -1, -1, -1, -1, 567, 567, 
	-1, -1, 567, 567, -1, -1, -1, -1, 
	-1, -1, -1, -1, 567, 567, -1, -1, 
	-1, -1, 567, -1, 568, 568, 568, 568, 
	568, 568, 568, 568, 568, -1, 568, 568, 
	-1, -1, 568, 568, 568, 568, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	567, 567, 568, 568, 568, -1, -1, -1, 
	568, -1, -1, -1, -1, 568, -1, -1, 
	-1, -1, -1, 568, 568, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 568, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 568, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 568, 568, -1, 568, 
	568, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 569, 569, 569, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	-1, 569, 569, 569, 569, 569, -1, 569, 
	-1, 569, 569, 569, 569, -1, 569, -1, 
	569, 569, 569, -1, -1, 569, 569, 569, 
	569, 569, 569, 569, 569, -1, 569, 569, 
	569, -1, -1, -1, -1, 569, 569, 569, 
	569, 569, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 569, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 569, 
	569, -1, -1, 567, -1, -1, -1, -1, 
	568, 568, -1, -1, -1, -1, -1, -1, 
	568, -1, -1, -1, -1, 568, 568, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	568, -1, -1, -1, -1, 568, -1, -1, 
	-1, 562, 562, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 562, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 568, 568, 569, 569, 569, 
	569, -1, -1, 569, 569, -1, 569, 569, 
	569, -1, -1, -1, -1, 569, 569, 569, 
	-1, 569, 569, 569, 569, -1, -1, -1, 
	-1, 569, -1, -1, -1, -1, 569, -1, 
	-1, -1, 569, 569, 569, 569, -1, 569, 
	569, -1, -1, 569, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 569, 569, 569, 
	569, 569, 569, 569, 569, -1, -1, -1, 
	-1, 569, 569, -1, -1, 569, 569, -1, 
	-1, -1, 567, -1, -1, -1, -1, 569, 
	569, -1, -1, -1, -1, 569, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 569, 569, -1, -1, 570, 
	570, 570, 570, 570, 570, 570, 570, 570, 
	570, 570, 570, 570, 570, 570, 570, 570, 
	570, 570, 570, 570, 570, 570, 570, 570, 
	570, 570, -1, 570, 570, 570, 570, 570, 
	-1, 570, -1, 570, 570, 570, 570, -1, 
	570, -1, 570, 570, 570, -1, -1, 570, 
	570, 570, 570, 570, 570, 570, 570, -1, 
	570, 570, 570, -1, -1, -1, -1, 570, 
	570, 570, 570, 570, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 570, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 570, 570, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 570, 
	570, 570, 570, -1, -1, 570, 570, -1, 
	570, 570, 570, -1, -1, -1, 569, 570, 
	570, 570, -1, 570, 570, 570, 570, -1, 
	-1, -1, -1, 570, -1, -1, -1, -1, 
	570, -1, -1, -1, 570, 570, 570, 570, 
	-1, 570, 570, -1, -1, 570, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 570, 
	570, 570, 570, 570, 570, 570, 570, -1, 
	-1, -1, -1, 570, 570, -1, -1, 570, 
	570, -1, -1, -1, -1, -1, -1, -1, 
	-1, 570, 570, -1, -1, -1, -1, 570, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 570, 570, -1, 
	-1, -1, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, -1, 571, 571, 
	571, 571, 571, -1, 571, 569, 571, 571, 
	571, 571, -1, 571, -1, 571, 571, 571, 
	-1, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, -1, 571, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, -1, 571, 
	-1, -1, -1, -1, 571, 571, 571, 571, 
	571, -1, -1, 571, 571, 571, 571, 571, 
	571, 571, 571, 571, 571, 571, 571, 571, 
	571, 571, 571, -1, 571, 571, -1, -1, 
	-1, -1, -1, 571, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 568, 568, -1, -1, -1, -1, -1, 
	-1, 568, -1, -1, -1, -1, 568, 568, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 568, -1, -1, -1, -1, 568, -1, 
	-1, -1, 571, 571, 571, 571, -1, -1, 
	571, 571, 571, 571, 571, 571, -1, -1, 
	570, -1, 571, 571, 571, 571, 571, 571, 
	571, 571, -1, -1, 568, -1, 571, -1, 
	-1, -1, -1, 571, 571, -1, -1, 571, 
	571, 571, 571, -1, 571, 571, -1, -1, 
	571, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 571, 571, 571, 571, 571, 571, 
	571, 571, -1, -1, -1, 571, 571, 571, 
	-1, -1, 571, 571, -1, 571, 571, 571, 
	571, 571, -1, 571, 571, 571, -1, -1, 
	-1, 571, 571, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 571, 571, -1, 
	-1, 571, -1, -1, -1, -1, 571, -1, 
	-1, -1, -1, 571, -1, 571, 571, 571, 
	571, 571, 575, 575, 575, 575, 575, 575, 
	575, -1, 575, 575, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 575, 575, 575, 
	575, 575, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 575, -1, -1, 570, 
	575, -1, -1, -1, 575, 575, 575, 575, 
	575, 575, -1, -1, -1, -1, 575, 575, 
	575, -1, -1, -1, -1, 575, 575, -1, 
	575, 575, 575, 575, -1, -1, -1, -1, 
	-1, -1, -1, 575, 575, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 575, 575, 575, 575, 575, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 578, 578, 578, 578, 578, 578, 578, 
	578, 578, 578, 578, 578, 578, 578, 578, 
	578, 578, 578, 578, 578, 578, 578, 578, 
	578, 578, 578, 578, -1, 578, 578, 578, 
	578, 578, -1, 578, -1, 578, 578, 578, 
	578, -1, 578, -1, 578, 578, 578, -1, 
	-1, 578, 578, 578, 578, 578, 578, 578, 
	578, -1, 578, 578, 578, -1, -1, -1, 
	-1, 578, 578, 578, 578, 578, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 571, -1, -1, 578, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 578, 578, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 575, 575, 575, 575, 
	575, -1, 575, 575, 575, -1, -1, -1, 
	575, 575, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 575, 575, 575, 575, 
	575, 578, 578, 578, 578, -1, -1, 578, 
	578, -1, 578, 578, 578, -1, -1, -1, 
	-1, 578, 578, 578, -1, 578, 578, 578, 
	578, -1, -1, -1, -1, 578, -1, -1, 
	-1, -1, 578, -1, -1, -1, 578, 578, 
	578, 578, -1, 578, 578, -1, -1, 578, 
	-1, -1, 571, -1, -1, -1, -1, -1, 
	-1, 578, 578, 578, 578, 578, 578, 578, 
	578, -1, -1, -1, -1, 578, 578, -1, 
	-1, 578, 578, -1, -1, -1, -1, -1, 
	-1, -1, -1, 578, 578, -1, -1, -1, 
	-1, 578, -1, 579, 579, 579, 579, 579, 
	579, 579, 579, 579, -1, 579, 579, -1, 
	-1, 579, 579, 579, 579, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 578, 
	578, 579, 579, 579, -1, -1, -1, 579, 
	-1, -1, -1, -1, 579, -1, -1, -1, 
	-1, -1, 579, 579, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	579, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	579, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 579, 579, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 580, 580, 580, 580, 
	580, 580, 580, 580, 580, 580, 580, 580, 
	580, 580, 580, 580, 580, 580, 580, 580, 
	580, 580, 580, 580, 580, 580, 580, -1, 
	580, 580, 580, 580, 580, -1, 580, -1, 
	580, 580, 580, 580, -1, 580, -1, 580, 
	580, 580, -1, -1, 580, 580, 580, 580, 
	580, 580, 580, 580, -1, 580, 580, 580, 
	-1, -1, -1, -1, 580, 580, 580, 580, 
	580, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 580, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 580, 580, 
	-1, -1, 578, -1, -1, -1, -1, 579, 
	579, -1, -1, -1, -1, -1, -1, 579, 
	-1, -1, -1, -1, 579, 579, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 579, 
	-1, -1, -1, -1, 579, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 579, 579, 580, 580, 580, 580, 
	-1, -1, 580, 580, -1, 580, 580, 580, 
	-1, -1, -1, -1, 580, 580, 580, -1, 
	580, 580, 580, 580, -1, -1, -1, -1, 
	580, -1, -1, -1, -1, 580, -1, -1, 
	-1, 580, 580, 580, 580, -1, 580, 580, 
	-1, -1, 580, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 580, 580, 580, 580, 
	580, 580, 580, 580, -1, -1, -1, -1, 
	580, 580, -1, -1, 580, 580, -1, -1, 
	-1, 578, -1, -1, -1, -1, 580, 580, 
	-1, -1, -1, -1, 580, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 580, 580, -1, -1, -1, -1, 
	-1, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 581, 581, -1, 581, 581, 581, 
	581, 581, -1, 581, -1, 581, 581, 581, 
	581, -1, 581, -1, 581, 581, 581, -1, 
	-1, 581, 581, 581, 581, 581, 581, 581, 
	581, -1, 581, 581, 581, -1, -1, -1, 
	-1, 581, 581, 581, 581, 581, -1, -1, 
	-1, -1, -1, -1, -1, 575, 575, 575, 
	575, 575, -1, 575, 575, 575, 581, -1, 
	-1, 575, 575, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 581, 581, -1, -1, -1, 
	-1, -1, -1, -1, -1, 575, 575, 575, 
	575, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 581, 581, 581, 581, -1, -1, 581, 
	581, -1, 581, 581, 581, 580, -1, -1, 
	-1, 581, 581, 581, -1, 581, 581, 581, 
	581, -1, -1, -1, -1, 581, -1, -1, 
	-1, -1, 581, -1, -1, -1, 581, 581, 
	581, 581, -1, 581, 581, -1, -1, 581, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 581, 581, 581, 581, 581, 581, 581, 
	581, -1, -1, -1, -1, 581, 581, -1, 
	-1, 581, 581, -1, -1, -1, -1, -1, 
	-1, -1, -1, 581, 581, -1, -1, -1, 
	-1, 581, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 581, 
	581, -1, -1, 583, 583, 583, 583, 583, 
	583, 583, 583, 583, 583, 583, 583, 583, 
	583, 583, 583, -1, 583, 583, 583, 583, 
	583, 583, 583, 583, -1, -1, -1, 583, 
	583, 583, 583, 583, 580, 583, -1, 583, 
	583, 583, 583, -1, 583, -1, 583, 583, 
	583, -1, -1, 583, -1, -1, 583, 583, 
	583, 583, 583, -1, 583, 583, 583, 583, 
	-1, -1, -1, 583, 583, 583, 583, 583, 
	-1, 583, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 583, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 583, 583, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	579, 579, -1, -1, -1, -1, -1, -1, 
	579, -1, -1, -1, -1, 579, 579, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	579, -1, -1, -1, -1, 579, -1, -1, 
	-1, -1, -1, 583, 583, 583, 583, -1, 
	-1, 583, 583, 583, 583, 583, 583, -1, 
	-1, -1, 581, 583, 583, 583, 583, 583, 
	583, 583, 583, 579, 583, 583, -1, 583, 
	-1, -1, -1, -1, 583, 583, -1, -1, 
	583, 583, 583, 583, -1, 583, 583, 583, 
	-1, 583, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 583, 583, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 583, 583, -1, -1, -1, 
	-1, -1, -1, -1, -1, 583, 583, -1, 
	-1, -1, -1, 583, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 583, 583, -1, -1, -1, 584, 584, 
	584, 584, 584, 584, 584, 584, 584, 584, 
	584, 584, 584, 584, 584, 584, -1, 584, 
	584, 584, 584, 584, 584, 584, 584, -1, 
	-1, -1, 584, 584, 584, 584, 584, -1, 
	584, 581, 584, 584, 584, 584, -1, 584, 
	-1, 584, 584, 584, -1, -1, 584, -1, 
	-1, 584, 584, 584, 584, 584, -1, 584, 
	584, 584, -1, -1, -1, -1, 584, 584, 
	584, 584, 584, -1, -1, -1, -1, -1, 
	-1, -1, 584, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	584, 584, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 584, 584, 
	584, 584, -1, -1, 584, 584, 584, 584, 
	584, 584, -1, -1, 583, -1, 584, 584, 
	584, 584, 584, 584, 584, 584, -1, -1, 
	-1, -1, 584, -1, -1, -1, -1, 584, 
	584, -1, -1, 584, 584, 584, 584, -1, 
	584, 584, -1, -1, 584, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 584, 584, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 584, 584, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	584, 584, -1, -1, -1, -1, 584, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 584, 584, -1, -1, 
	610, 610, 610, 610, 610, 610, 610, 610, 
	610, 610, 610, 610, 610, 610, 610, 610, 
	610, 610, 610, 610, 610, 610, 610, 610, 
	610, 610, 610, -1, 610, 610, 610, 610, 
	610, -1, 610, 583, 610, 610, 610, 610, 
	-1, 610, -1, 610, 610, 610, -1, -1, 
	610, 610, 610, 610, 610, 610, 610, 610, 
	-1, 610, 610, 610, -1, -1, -1, -1, 
	610, 610, 610, 610, 610, -1, 612, 612, 
	612, 612, 612, 612, 612, -1, 612, 612, 
	-1, -1, -1, -1, -1, 610, -1, -1, 
	-1, 612, 612, 612, 612, 612, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	612, -1, 610, 610, 612, -1, -1, -1, 
	612, 612, 612, 612, 612, 612, -1, -1, 
	-1, -1, 612, 612, 612, -1, -1, -1, 
	-1, 612, 612, -1, 612, 612, 612, 612, 
	-1, -1, -1, -1, -1, -1, -1, 612, 
	612, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 612, 612, 612, 
	612, 612, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	610, 610, 610, 610, -1, -1, 610, 610, 
	-1, 610, 610, 610, -1, -1, -1, 584, 
	610, 610, 610, -1, 610, 610, 610, 610, 
	-1, -1, -1, -1, 610, -1, -1, -1, 
	-1, 610, -1, -1, -1, 610, 610, 610, 
	610, -1, 610, 610, -1, -1, 610, -1, 
	-1, -1, -1, -1, -1, 584, -1, -1, 
	610, 610, 610, 610, 610, 610, 610, 610, 
	-1, -1, -1, -1, 610, 610, -1, 584, 
	610, 610, -1, -1, -1, -1, -1, -1, 
	-1, -1, 610, 610, -1, -1, -1, -1, 
	610, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 610, 610, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	612, 612, 612, 612, 612, -1, 612, 612, 
	612, -1, -1, -1, 612, 612, -1, 613, 
	613, 613, 613, 613, 613, 613, 584, 613, 
	613, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 613, 613, 613, 613, 613, -1, 
	612, 612, 612, 612, 612, -1, -1, -1, 
	-1, 613, -1, -1, -1, 613, -1, -1, 
	-1, 613, 613, 613, 613, 613, 613, -1, 
	-1, -1, -1, 613, 613, 613, -1, -1, 
	-1, -1, 613, 613, -1, 613, 613, 613, 
	613, -1, -1, -1, -1, -1, -1, -1, 
	613, 613, -1, -1, 617, 617, 617, 617, 
	617, 617, 617, -1, 617, 617, 613, 613, 
	613, 613, 613, -1, -1, 613, 613, 617, 
	617, 617, 617, 617, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 617, -1, 
	-1, -1, 617, -1, -1, -1, 617, 617, 
	617, 617, 617, 617, -1, -1, -1, -1, 
	617, 617, 617, -1, -1, -1, -1, 617, 
	617, 617, 617, 617, 617, 617, 617, -1, 
	-1, -1, -1, -1, -1, 617, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 610, -1, 617, 617, 617, 617, 617, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 613, 613, 613, 613, 613, -1, 613, 
	613, 613, -1, -1, -1, 613, 613, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 613, 613, 613, 613, 613, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	610, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 617, 617, 
	617, 617, 617, -1, 617, 617, 617, -1, 
	-1, -1, -1, 617, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 617, 617, 
	-1, -1, 617, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 617, 617, 
	617, 617, 617, 618, 618, 618, 618, 618, 
	618, 618, 618, 618, 618, 618, 618, 618, 
	618, 618, 618, 618, 618, 618, 618, 618, 
	618, 618, 618, 618, 618, 618, -1, 618, 
	618, 618, 618, 618, -1, 618, -1, 618, 
	618, 618, 618, -1, 618, -1, 618, 618, 
	618, -1, 618, 618, 618, 618, 618, 618, 
	618, 618, 618, 618, 618, 618, 618, -1, 
	618, 618, 618, 618, 618, 618, 618, 618, 
	618, 618, 618, 618, 618, 618, 618, -1, 
	618, -1, -1, -1, -1, 618, 618, 618, 
	618, 618, -1, -1, 618, 618, 618, 618, 
	618, 618, 618, 618, 618, 618, 618, 618, 
	618, 618, 618, 618, -1, 618, 618, -1, 
	-1, -1, -1, -1, 618, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 618, 618, 618, 618, -1, 
	-1, 618, 618, 618, 618, 618, 618, -1, 
	-1, -1, -1, 618, 618, 618, 618, 618, 
	618, 618, 618, -1, -1, -1, -1, 618, 
	-1, -1, -1, -1, 618, 618, -1, -1, 
	618, 618, 618, 618, -1, 618, 618, -1, 
	-1, 618, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 618, 618, 618, 618, 618, 
	618, 618, 618, -1, -1, -1, 618, 618, 
	618, -1, -1, 618, 618, -1, 618, 618, 
	618, 618, 618, -1, 618, 618, 618, -1, 
	-1, -1, 618, 618, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 618, 618, 
	-1, -1, 618, -1, -1, -1, -1, 618, 
	-1, -1, -1, -1, 618, -1, 618, 618, 
	618, 618, 618, 628, 628, 628, 628, 628, 
	628, 628, 628, 628, -1, 628, 628, -1, 
	-1, 628, 628, 628, 628, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 628, 628, 628, -1, -1, -1, 628, 
	-1, -1, -1, -1, 628, -1, -1, -1, 
	-1, -1, 628, 628, 631, 631, 631, 631, 
	631, 631, 631, -1, 631, 631, -1, -1, 
	628, -1, -1, -1, -1, -1, -1, 631, 
	631, 631, 631, 631, -1, -1, -1, -1, 
	628, -1, -1, -1, -1, -1, 631, -1, 
	-1, -1, 631, -1, -1, -1, 631, 631, 
	631, 631, 631, 631, -1, -1, 628, 628, 
	631, 631, 631, -1, -1, -1, -1, 631, 
	631, -1, 631, 631, 631, 631, -1, -1, 
	-1, -1, -1, -1, -1, 631, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 631, 631, 631, 631, 631, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 618, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 628, 
	628, -1, -1, -1, -1, -1, -1, 628, 
	-1, -1, -1, -1, 628, 628, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 628, 
	-1, -1, -1, -1, 628, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 628, 628, -1, -1, 631, 631, 
	631, 631, 631, -1, 631, 631, 631, -1, 
	-1, -1, -1, 631, -1, -1, -1, 617, 
	617, -1, -1, 617, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 631, 631, 
	631, 631, 631, 618, 634, 634, 634, 634, 
	634, 634, 634, 634, 634, 634, 634, 634, 
	634, 634, 634, 634, 634, 634, 634, 634, 
	634, 634, 634, 634, 634, 634, 634, -1, 
	634, 634, 634, 634, 634, -1, 634, -1, 
	634, 634, 634, 634, -1, 634, -1, 634, 
	634, 634, -1, 634, 634, 634, 634, 634, 
	634, 634, 634, 634, 634, 634, 634, 634, 
	-1, 634, 634, 634, 634, 634, 634, 634, 
	634, 634, 634, 634, 634, 634, 634, 634, 
	-1, 634, -1, -1, -1, -1, 634, 634, 
	634, 634, 634, -1, -1, 634, 634, 634, 
	634, 634, 634, 634, 634, 634, 634, 634, 
	634, 634, 634, 634, 634, -1, 634, 634, 
	-1, -1, -1, -1, -1, 634, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 634, 634, 634, 634, 
	-1, -1, 634, 634, 634, 634, 634, 634, 
	-1, -1, -1, -1, 634, 634, 634, 634, 
	634, 634, 634, 634, -1, -1, -1, -1, 
	634, -1, -1, -1, -1, 634, 634, -1, 
	-1, 634, 634, 634, 634, -1, 634, 634, 
	-1, -1, 634, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 634, 634, 634, 634, 
	634, 634, 634, 634, -1, -1, -1, 634, 
	634, 634, -1, -1, 634, 634, -1, 634, 
	634, 634, 634, 634, -1, 634, 634, 634, 
	-1, -1, -1, 634, 634, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 634, 
	634, -1, -1, 634, -1, -1, -1, -1, 
	634, -1, -1, -1, -1, 634, -1, 634, 
	634, 634, 634, 634, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 655, 655, 
	655, 655, 655, 655, 655, -1, 655, 655, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 655, 655, 655, 655, 655, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	655, -1, -1, -1, 655, -1, -1, -1, 
	655, 655, 655, 655, 655, 655, -1, -1, 
	-1, -1, 655, 655, 655, -1, -1, -1, 
	-1, 655, 655, -1, 655, 655, 655, 655, 
	655, -1, -1, -1, -1, -1, -1, 655, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 655, 655, 655, 
	655, 655, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 655, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 634, -1, -1, 
	-1, -1, -1, -1, 741, 741, 741, 741, 
	741, 741, 741, 741, 741, -1, 741, 741, 
	-1, -1, 741, 741, 741, 741, -1, -1, 
	628, 628, -1, -1, -1, -1, -1, -1, 
	628, -1, 741, 741, 741, 628, 628, -1, 
	741, -1, -1, -1, -1, 741, -1, -1, 
	628, -1, -1, 741, 741, 628, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 741, -1, -1, -1, -1, -1, -1, 
	655, 655, 655, 655, 655, -1, 655, 655, 
	655, 741, -1, 628, -1, 655, -1, 631, 
	631, 631, 631, 631, -1, 631, 631, 631, 
	655, 655, -1, -1, 631, -1, -1, 741, 
	741, 655, -1, -1, -1, -1, -1, -1, 
	655, 655, 655, 655, 655, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 631, 
	631, 631, 631, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 634, 639, 639, 639, 
	639, 639, 639, 639, 639, 639, 639, 639, 
	639, 639, 639, 639, 639, 639, 639, 639, 
	639, 639, 639, 639, 639, 639, 639, 639, 
	-1, 639, 639, 639, 639, 639, -1, 639, 
	-1, 639, 639, 639, 639, -1, 639, -1, 
	639, 639, 639, -1, -1, 639, 639, 639, 
	639, 639, 639, 639, 639, -1, 639, 639, 
	639, -1, -1, -1, -1, 639, 639, 639, 
	639, 639, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 639, -1, -1, -1, -1, -1, 
	741, 741, -1, -1, -1, -1, -1, -1, 
	741, -1, -1, -1, -1, 741, 741, 639, 
	639, -1, -1, -1, -1, -1, -1, -1, 
	741, -1, -1, -1, -1, 741, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 741, 741, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 639, 639, 639, 
	639, -1, -1, 639, 639, -1, 639, 639, 
	639, -1, -1, -1, -1, 639, 639, 639, 
	-1, 639, 639, 639, 639, -1, -1, -1, 
	-1, 639, -1, -1, -1, -1, 639, -1, 
	-1, -1, 639, 639, 639, 639, -1, 639, 
	639, -1, -1, 639, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 639, 639, 639, 
	639, 639, 639, 639, 639, -1, -1, -1, 
	-1, 639, 639, -1, -1, 639, 639, -1, 
	-1, -1, -1, -1, -1, -1, -1, 639, 
	639, -1, -1, -1, -1, 639, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 639, 639, -1, -1, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, -1, 645, 645, 645, 645, 645, 
	-1, 645, -1, 645, 645, 645, 645, -1, 
	645, -1, 645, 645, 645, -1, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, -1, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, -1, 645, -1, -1, -1, 
	-1, 645, 645, 645, 645, 645, -1, -1, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	-1, 645, 645, -1, -1, -1, -1, -1, 
	645, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 645, 
	645, 645, 645, -1, -1, 645, 645, 645, 
	645, 645, 645, -1, -1, -1, 639, 645, 
	645, 645, 645, 645, 645, 645, 645, -1, 
	-1, -1, -1, 645, -1, -1, -1, -1, 
	645, 645, -1, -1, 645, 645, 645, 645, 
	-1, 645, 645, -1, -1, 645, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 645, 
	645, 645, 645, 645, 645, 645, 645, -1, 
	-1, -1, 645, 645, 645, -1, -1, 645, 
	645, -1, 645, 645, 645, 645, 645, -1, 
	645, 645, 645, -1, -1, -1, 645, 645, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 645, 645, -1, -1, 645, -1, 
	-1, -1, -1, 645, -1, -1, -1, -1, 
	645, -1, 645, 645, 645, 645, 645, -1, 
	-1, -1, 647, 647, 647, 647, 647, 647, 
	647, 647, 647, 647, 647, 647, 647, 647, 
	647, 647, 647, 647, 647, 647, 647, 647, 
	647, 647, 647, 647, 647, -1, 647, 647, 
	647, 647, 647, -1, 647, 639, 647, 647, 
	647, 647, -1, 647, -1, 647, 647, 647, 
	-1, -1, 647, 647, 647, 647, 647, 647, 
	647, 647, -1, 647, 647, 647, -1, -1, 
	-1, -1, 647, 647, 647, 647, 647, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 647, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 647, 647, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 647, 647, 647, 647, -1, -1, 
	647, 647, -1, 647, 647, 647, -1, -1, 
	645, -1, 647, 647, 647, -1, 647, 647, 
	647, 647, -1, -1, -1, -1, 647, -1, 
	-1, -1, -1, 647, -1, -1, -1, 647, 
	647, 647, 647, -1, 647, 647, -1, -1, 
	647, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 647, 647, 647, 647, 647, 647, 
	647, 647, -1, -1, -1, -1, 647, 647, 
	-1, -1, 647, 647, -1, -1, -1, -1, 
	-1, -1, -1, -1, 647, 647, -1, -1, 
	-1, -1, 647, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	647, 647, -1, -1, 650, 650, 650, 650, 
	650, 650, 650, 650, 650, 650, 650, 650, 
	650, 650, 650, 650, -1, 650, 650, 650, 
	650, 650, 650, 650, 650, -1, -1, -1, 
	650, 650, 650, 650, 650, -1, 650, 645, 
	650, 650, 650, 650, -1, 650, -1, 650, 
	650, 650, -1, -1, 650, -1, -1, 650, 
	650, 650, 650, 650, -1, 650, 650, 650, 
	-1, -1, -1, -1, 650, 650, 650, 650, 
	650, -1, 656, 656, 656, 656, 656, 656, 
	656, -1, 656, 656, -1, -1, -1, -1, 
	650, -1, -1, -1, -1, 656, 656, 656, 
	656, 656, -1, -1, -1, -1, -1, -1, 
	-1, -1, 650, -1, 656, -1, 650, 650, 
	656, -1, -1, -1, 656, 656, 656, 656, 
	656, 656, -1, -1, -1, -1, 656, 656, 
	656, -1, -1, -1, -1, 656, 656, -1, 
	656, 656, 656, 656, 656, -1, -1, -1, 
	-1, -1, -1, 656, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 656, 656, 656, 656, 656, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 656, -1, 650, 650, 650, 650, 
	-1, -1, 650, 650, 650, 650, 650, 650, 
	-1, -1, -1, 647, 650, 650, 650, 650, 
	650, 650, 650, 650, -1, -1, -1, 650, 
	650, -1, -1, -1, -1, 650, 650, -1, 
	-1, 650, 650, 650, 650, -1, 650, 650, 
	650, -1, 650, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 650, 
	650, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 650, 650, -1, -1, 
	-1, -1, -1, -1, -1, -1, 650, 650, 
	-1, -1, -1, -1, 650, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 650, 650, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 656, 656, 656, 656, 
	656, -1, 656, 656, 656, -1, -1, -1, 
	-1, 656, -1, -1, -1, -1, -1, -1, 
	-1, -1, 647, -1, 656, 656, 657, 657, 
	657, 657, 657, 657, 657, 656, 657, 657, 
	-1, -1, -1, -1, 656, 656, 656, 656, 
	656, 657, 657, 657, 657, 657, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	657, -1, -1, -1, 657, -1, -1, -1, 
	657, 657, 657, 657, 657, 657, -1, -1, 
	-1, -1, 657, 657, 657, -1, -1, -1, 
	-1, 657, 657, -1, 657, 657, 657, 657, 
	657, -1, -1, -1, -1, -1, -1, 657, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 657, 657, 657, 
	657, 657, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 657, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 650, 658, 658, 
	658, 658, 658, -1, 658, -1, 658, 658, 
	658, 658, -1, 658, -1, 658, 658, 658, 
	-1, 658, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 658, -1, 658, 
	658, 658, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 658, -1, 658, 
	-1, -1, -1, -1, 658, 658, 658, 658, 
	658, -1, -1, 658, 658, 658, 658, 658, 
	658, 658, 658, 658, 658, 658, 658, 658, 
	658, 658, 658, -1, 658, 658, -1, -1, 
	-1, -1, -1, 658, -1, -1, -1, -1, 
	657, 657, 657, 657, 657, -1, 657, 657, 
	657, -1, -1, -1, -1, 657, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	657, 657, -1, -1, -1, -1, -1, -1, 
	-1, 657, -1, -1, -1, -1, -1, -1, 
	657, 657, 657, 657, 657, -1, -1, -1, 
	-1, -1, -1, -1, 650, -1, -1, -1, 
	-1, -1, 658, 658, 658, 658, -1, -1, 
	658, 658, 658, 658, 658, 658, -1, -1, 
	-1, -1, 658, 658, 658, 658, 658, 658, 
	658, 658, -1, -1, -1, -1, 658, -1, 
	-1, -1, -1, 658, 658, -1, -1, 658, 
	658, 658, 658, -1, 658, 658, -1, -1, 
	658, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 658, 658, 658, 658, 658, 658, 
	658, 658, -1, -1, -1, 658, 658, 658, 
	-1, -1, 658, 658, -1, 658, 658, 658, 
	658, 658, -1, 658, 658, 658, -1, -1, 
	-1, 658, 658, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 658, 658, -1, 
	-1, 658, -1, 658, 658, -1, 658, -1, 
	-1, -1, -1, 658, -1, 658, 658, 658, 
	658, 658, 661, 661, 661, 661, 661, 661, 
	661, -1, 661, 661, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 661, 661, 661, 
	661, 661, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 661, -1, -1, -1, 
	661, -1, -1, -1, 661, 661, 661, 661, 
	661, 661, -1, -1, -1, -1, 661, 661, 
	661, -1, -1, -1, -1, 661, 661, 661, 
	661, 661, 661, 661, -1, -1, -1, -1, 
	650, -1, -1, 661, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 661, 661, 661, 661, 661, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 661, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 658, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 661, 661, 661, 661, 
	661, -1, 661, 661, 661, -1, -1, -1, 
	-1, 661, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 661, 661, -1, -1, 
	661, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 661, 661, 661, 661, 
	661, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 661, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 658, 662, 662, 662, 662, 662, 
	662, 662, 662, 662, 662, 662, 662, 662, 
	662, 662, 662, 662, 662, 662, 662, 662, 
	662, 662, 662, 662, 662, 662, -1, 662, 
	662, 662, 662, 662, -1, 662, -1, 662, 
	662, 662, 662, -1, 662, -1, 662, 662, 
	662, -1, 662, 662, 662, 662, 662, 662, 
	662, 662, 662, 662, 662, 662, 662, -1, 
	662, 662, 662, 662, 662, 662, 662, 662, 
	662, 662, 662, 662, 662, 662, 662, -1, 
	662, -1, -1, -1, -1, 662, 662, 662, 
	662, 662, -1, -1, 662, 662, 662, 662, 
	662, 662, 662, 662, 662, 662, 662, 662, 
	662, 662, 662, 662, -1, 662, 662, -1, 
	-1, -1, -1, -1, 662, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 662, 662, 662, 662, -1, 
	-1, 662, 662, 662, 662, 662, 662, -1, 
	-1, -1, -1, 662, 662, 662, 662, 662, 
	662, 662, 662, -1, -1, -1, -1, 662, 
	-1, -1, -1, -1, 662, 662, -1, -1, 
	662, 662, 662, 662, -1, 662, 662, -1, 
	-1, 662, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 662, 662, 662, 662, 662, 
	662, 662, 662, -1, -1, -1, 662, 662, 
	662, -1, -1, 662, 662, -1, 662, 662, 
	662, 662, 662, -1, 662, 662, 662, -1, 
	-1, -1, 662, 662, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 662, 662, 
	-1, -1, 662, -1, 662, 662, -1, 662, 
	-1, -1, -1, -1, 662, -1, 662, 662, 
	662, 662, 662, -1, -1, 663, 663, 663, 
	663, 663, 663, 663, 663, 663, 663, 663, 
	663, 663, 663, 663, 663, 663, 663, 663, 
	663, 663, 663, 663, 663, 663, 663, 663, 
	-1, 663, 663, 663, 663, 663, -1, 663, 
	-1, 663, 663, 663, 663, -1, 663, -1, 
	663, 663, 663, -1, 663, 663, 663, 663, 
	663, 663, 663, 663, 663, 663, 663, 663, 
	663, -1, 663, 663, 663, 663, 663, 663, 
	663, 663, 663, 663, 663, 663, 663, 663, 
	663, -1, 663, -1, -1, -1, -1, 663, 
	663, 663, 663, 663, -1, -1, 663, 663, 
	663, 663, 663, 663, 663, 663, 663, 663, 
	663, 663, 663, 663, 663, 663, -1, 663, 
	663, -1, -1, -1, -1, -1, 663, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 663, 663, 663, 
	663, -1, -1, 663, 663, 663, 663, 663, 
	663, -1, -1, -1, 662, 663, 663, 663, 
	663, 663, 663, 663, 663, -1, -1, -1, 
	-1, 663, -1, -1, -1, -1, 663, 663, 
	-1, -1, 663, 663, 663, 663, -1, 663, 
	663, -1, -1, 663, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 663, 663, 663, 
	663, 663, 663, 663, 663, -1, -1, -1, 
	663, 663, 663, -1, -1, 663, 663, -1, 
	663, 663, 663, 663, 663, -1, 663, 663, 
	663, -1, -1, -1, 663, 663, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	663, 663, -1, -1, 663, -1, 663, 663, 
	-1, 663, -1, -1, -1, -1, 663, -1, 
	663, 663, 663, 663, 663, -1, -1, -1, 
	661, -1, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, 664, 664, -1, 664, 664, 
	664, 664, 664, 662, 664, -1, 664, 664, 
	664, 664, -1, 664, -1, 664, 664, 664, 
	-1, 664, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, 664, 664, 664, -1, 664, 
	664, 664, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, 664, 664, 664, -1, 664, 
	-1, -1, -1, -1, 664, 664, 664, 664, 
	664, -1, -1, 664, 664, 664, 664, 664, 
	664, 664, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, -1, 664, 664, -1, -1, 
	-1, -1, -1, 664, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 664, 664, 664, 664, -1, -1, 
	664, 664, 664, 664, 664, 664, 663, -1, 
	-1, -1, 664, 664, 664, 664, 664, 664, 
	664, 664, -1, -1, -1, -1, 664, -1, 
	-1, -1, -1, 664, 664, -1, -1, 664, 
	664, 664, 664, -1, 664, 664, -1, -1, 
	664, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 664, 664, 664, 664, 664, 664, 
	664, 664, -1, -1, -1, 664, 664, 664, 
	-1, -1, 664, 664, -1, 664, 664, 664, 
	664, 664, -1, 664, 664, 664, -1, -1, 
	-1, 664, 664, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 664, 664, -1, 
	-1, 664, -1, -1, -1, -1, 664, -1, 
	-1, -1, -1, 664, -1, 664, 664, 664, 
	664, 664, 665, 665, 665, 665, 665, 665, 
	665, -1, 665, 665, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 665, 665, 665, 
	665, 665, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 665, 663, -1, -1, 
	665, -1, -1, -1, 665, 665, 665, 665, 
	665, 665, -1, -1, -1, -1, 665, 665, 
	665, -1, -1, -1, -1, 665, 665, 665, 
	665, 665, 665, 665, 665, -1, -1, -1, 
	-1, -1, -1, 665, 667, 667, 667, 667, 
	667, 667, 667, -1, 667, 667, -1, -1, 
	-1, 665, 665, 665, 665, 665, -1, 667, 
	667, 667, 667, 667, -1, -1, -1, -1, 
	-1, -1, 665, -1, -1, -1, 667, -1, 
	-1, -1, 667, -1, -1, -1, 667, 667, 
	667, 667, 667, 667, -1, -1, -1, -1, 
	667, 667, 667, -1, -1, -1, -1, 667, 
	667, -1, 667, 667, 667, 667, -1, -1, 
	-1, -1, -1, -1, -1, 667, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 667, 667, 667, 667, 667, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 664, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 665, 665, 665, 665, 
	665, -1, 665, 665, 665, -1, -1, -1, 
	-1, 665, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 665, 665, -1, -1, 
	665, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 665, 665, 665, 665, 
	665, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 667, 667, 
	667, 667, 667, -1, 667, 667, 667, -1, 
	-1, -1, -1, 667, -1, -1, -1, -1, 
	-1, -1, 664, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 667, 667, 
	667, 667, 667, 690, 690, 690, 690, 690, 
	690, 690, 690, 690, 690, 690, 690, 690, 
	690, 690, 690, 690, 690, 690, 690, 690, 
	690, 690, 690, 690, 690, 690, -1, 690, 
	690, 690, 690, 690, -1, 690, -1, 690, 
	690, 690, 690, -1, 690, -1, 690, 690, 
	690, -1, -1, 690, 690, 690, 690, 690, 
	690, 690, 690, -1, 690, 690, 690, -1, 
	-1, -1, -1, 690, 690, 690, 690, 690, 
	-1, -1, -1, 693, 693, 693, 693, 693, 
	693, 693, 693, 693, -1, 693, 693, -1, 
	690, 693, 693, 693, 693, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 693, 693, 693, -1, 690, 690, 693, 
	-1, -1, -1, -1, 693, -1, -1, -1, 
	-1, -1, 693, 693, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	693, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	693, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 693, 693, -1, 693, 693, 
	-1, -1, -1, 690, 690, 690, 690, -1, 
	-1, 690, 690, -1, 690, 690, 690, -1, 
	-1, -1, -1, 690, 690, 690, -1, 690, 
	690, 690, 690, -1, -1, -1, -1, 690, 
	-1, -1, -1, -1, 690, -1, -1, -1, 
	690, 690, 690, 690, -1, 690, 690, -1, 
	-1, 690, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 690, 690, 690, 690, 690, 
	690, 690, 690, -1, -1, -1, -1, 690, 
	690, -1, -1, 690, 690, -1, -1, -1, 
	-1, -1, -1, -1, -1, 690, 690, -1, 
	-1, -1, -1, 690, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 690, 690, -1, -1, -1, -1, 693, 
	693, -1, -1, -1, -1, -1, -1, 693, 
	-1, -1, -1, -1, 693, 693, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 693, 
	-1, -1, -1, -1, 693, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 693, 693, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 690, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 696, 696, 696, 696, 696, 
	696, 696, -1, 696, 696, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 696, 696, 
	696, 696, 696, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 696, -1, -1, 
	-1, 696, -1, -1, -1, 696, 696, 696, 
	696, 696, 696, -1, -1, -1, -1, 696, 
	696, 696, -1, -1, -1, -1, 696, 696, 
	-1, 696, 696, 696, 696, 696, -1, 667, 
	667, 667, 667, 667, 696, 667, 667, 667, 
	-1, -1, -1, -1, 667, -1, -1, -1, 
	-1, -1, 696, 696, 696, 696, 696, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 696, -1, -1, -1, 667, 
	667, 667, 667, -1, -1, -1, -1, -1, 
	-1, -1, -1, 690, 694, 694, 694, 694, 
	694, 694, 694, 694, 694, 694, 694, 694, 
	694, 694, 694, 694, 694, 694, 694, 694, 
	694, 694, 694, 694, 694, 694, 694, 694, 
	694, 694, 694, 694, 694, -1, 694, -1, 
	694, 694, 694, 694, 694, 694, -1, 694, 
	694, 694, -1, -1, 694, 694, 694, 694, 
	694, 694, 694, 694, -1, 694, 694, 694, 
	694, -1, -1, -1, 694, 694, 694, 694, 
	694, -1, -1, 694, 694, 694, 694, -1, 
	-1, -1, 694, -1, -1, -1, 694, 694, 
	-1, 694, -1, -1, 694, -1, -1, 694, 
	-1, 694, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 694, 694, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 696, 696, 696, 
	696, 696, -1, 696, 696, 696, -1, -1, 
	-1, -1, 696, -1, -1, -1, 694, -1, 
	-1, -1, -1, -1, -1, 696, 696, -1, 
	694, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 696, -1, 696, 696, 696, 
	696, 696, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 694, 694, 694, 694, 
	-1, -1, 694, 694, 694, 694, 694, 694, 
	-1, -1, -1, -1, 694, 694, 694, 694, 
	694, 694, 694, 694, -1, -1, 694, -1, 
	694, -1, -1, -1, -1, 694, 694, -1, 
	694, 694, 694, 694, 694, -1, 694, 694, 
	-1, -1, 694, -1, -1, -1, -1, -1, 
	-1, 694, -1, 694, 694, 694, 694, 694, 
	694, 694, 694, 694, -1, -1, -1, -1, 
	694, 694, -1, 694, 694, 694, -1, -1, 
	-1, -1, -1, -1, -1, -1, 694, 694, 
	-1, -1, 694, -1, 694, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 694, 694, 694, 
	-1, -1, 694, 694, 694, -1, -1, -1, 
	-1, -1, 694, 694, -1, -1, 695, 695, 
	695, 695, 695, 695, 695, 695, 695, 695, 
	695, 695, 695, 695, 695, 695, 695, 695, 
	695, 695, 695, 695, 695, 695, 695, 695, 
	695, 695, 695, 695, 695, 695, 695, -1, 
	695, -1, 695, 695, 695, 695, 695, 695, 
	-1, 695, 695, 695, -1, -1, 695, 695, 
	695, 695, 695, 695, 695, 695, -1, 695, 
	695, 695, 695, -1, -1, -1, 695, 695, 
	695, 695, 695, -1, -1, 695, 695, 695, 
	695, -1, -1, -1, 695, -1, -1, -1, 
	695, 695, -1, 695, -1, -1, 695, -1, 
	-1, 695, -1, 695, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	695, 695, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	695, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 695, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 695, 695, 
	695, 695, -1, -1, 695, 695, 695, 695, 
	695, 695, -1, -1, -1, 694, 695, 695, 
	695, 695, 695, 695, 695, 695, -1, -1, 
	695, -1, 695, -1, -1, -1, -1, 695, 
	695, -1, 695, 695, 695, 695, 695, -1, 
	695, 695, -1, -1, 695, -1, -1, -1, 
	-1, -1, -1, 695, -1, 695, 695, 695, 
	695, 695, 695, 695, 695, 695, -1, -1, 
	-1, -1, 695, 695, -1, 695, 695, 695, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	695, 695, -1, -1, 695, -1, 695, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 695, 
	695, 695, -1, -1, 695, 695, 695, -1, 
	-1, -1, -1, -1, 695, 695, -1, 697, 
	697, 697, 697, 697, 697, 697, -1, 697, 
	697, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 697, 697, 697, 697, 697, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 697, -1, -1, 694, 697, -1, -1, 
	-1, 697, 697, 697, 697, 697, 697, -1, 
	-1, -1, -1, 697, 697, 697, -1, -1, 
	-1, -1, 697, 697, -1, 697, 697, 697, 
	697, 697, -1, -1, -1, -1, -1, -1, 
	697, 698, 698, 698, 698, 698, 698, 698, 
	-1, 698, 698, -1, -1, -1, 697, 697, 
	697, 697, 697, -1, 698, 698, 698, 698, 
	698, -1, -1, -1, -1, -1, -1, 697, 
	-1, -1, -1, 698, -1, -1, -1, 698, 
	-1, -1, -1, 698, 698, 698, 698, 698, 
	698, -1, -1, -1, -1, 698, 698, 698, 
	-1, -1, -1, -1, 698, 698, -1, 698, 
	698, 698, 698, 698, -1, -1, -1, -1, 
	-1, -1, 698, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	698, 698, 698, 698, 698, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 698, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 695, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 697, 697, 697, 697, 697, -1, 697, 
	697, 697, -1, -1, -1, -1, 697, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 697, 697, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 697, 
	-1, 697, 697, 697, 697, 697, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 698, 698, 698, 698, 698, 
	-1, 698, 698, 698, -1, -1, -1, -1, 
	698, -1, -1, -1, -1, -1, 695, -1, 
	-1, -1, -1, 698, 698, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 698, -1, 698, 698, 698, 698, 698, 
	703, 703, 703, 703, 703, 703, 703, 703, 
	703, 703, 703, 703, 703, 703, 703, 703, 
	-1, 703, 703, 703, 703, 703, 703, 703, 
	703, -1, -1, -1, 703, 703, 703, 703, 
	703, -1, 703, -1, 703, 703, 703, 703, 
	-1, 703, -1, 703, 703, 703, -1, -1, 
	703, -1, -1, 703, 703, 703, 703, 703, 
	-1, 703, 703, 703, -1, -1, -1, -1, 
	703, 703, 703, 703, 703, -1, -1, -1, 
	-1, -1, -1, -1, 703, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 703, 703, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	703, 703, 703, 703, -1, -1, 703, 703, 
	703, 703, 703, 703, -1, -1, -1, -1, 
	703, 703, 703, 703, 703, 703, 703, 703, 
	-1, -1, -1, -1, 703, -1, -1, -1, 
	-1, 703, 703, -1, -1, 703, 703, 703, 
	703, -1, 703, 703, -1, -1, 703, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 703, 703, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	703, 703, -1, -1, -1, -1, -1, -1, 
	-1, -1, 703, 703, -1, -1, -1, -1, 
	703, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 703, 703, 
	-1, -1, 704, 704, 704, 704, 704, 704, 
	704, 704, 704, 704, 704, 704, 704, 704, 
	704, 704, -1, 704, 704, 704, 704, 704, 
	704, 704, 704, -1, -1, -1, 704, 704, 
	704, 704, 704, -1, 704, -1, 704, 704, 
	704, 704, -1, 704, -1, 704, 704, 704, 
	-1, -1, 704, -1, -1, 704, 704, 704, 
	704, 704, -1, 704, 704, 704, -1, -1, 
	-1, -1, 704, 704, 704, 704, 704, -1, 
	709, 709, 709, 709, 709, 709, 709, -1, 
	709, 709, -1, -1, -1, -1, 704, -1, 
	-1, -1, -1, 709, 709, 709, 709, 709, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 709, -1, 704, 704, 709, -1, 
	-1, -1, 709, 709, 709, 709, 709, 709, 
	-1, -1, -1, -1, 709, 709, 709, -1, 
	-1, -1, -1, 709, 709, 709, 709, 709, 
	709, 709, -1, -1, -1, -1, -1, -1, 
	-1, 709, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 709, 
	709, 709, 709, 709, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	709, -1, 704, 704, 704, 704, -1, -1, 
	704, 704, 704, 704, 704, 704, -1, -1, 
	-1, 703, 704, 704, 704, 704, 704, 704, 
	704, 704, -1, -1, -1, -1, 704, -1, 
	-1, -1, -1, 704, 704, -1, -1, 704, 
	704, 704, 704, -1, 704, 704, 704, -1, 
	704, -1, -1, -1, -1, -1, -1, 703, 
	-1, -1, -1, -1, -1, 704, 704, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 703, 704, 704, -1, -1, -1, -1, 
	-1, -1, -1, -1, 704, 704, -1, -1, 
	-1, -1, 704, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	704, 704, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 709, 709, 709, 709, 709, -1, 
	709, 709, 709, -1, -1, -1, -1, 709, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	703, -1, 709, 709, -1, -1, 709, 714, 
	714, 714, 714, 714, 714, 714, -1, 714, 
	714, -1, 709, 709, 709, 709, 709, -1, 
	-1, -1, 714, 714, 714, 714, 714, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 714, -1, -1, -1, 714, -1, -1, 
	-1, 714, 714, 714, 714, 714, 714, -1, 
	-1, -1, -1, 714, 714, 714, -1, -1, 
	-1, -1, 714, 714, 714, 714, 714, 714, 
	714, 714, -1, -1, -1, -1, -1, -1, 
	714, -1, -1, -1, 719, 719, 719, 719, 
	719, 719, 719, -1, 719, 719, 714, 714, 
	714, 714, 714, -1, -1, 714, 714, 719, 
	719, 719, 719, 719, -1, -1, -1, 714, 
	-1, -1, -1, -1, -1, -1, 719, -1, 
	-1, -1, 719, -1, -1, -1, 719, 719, 
	719, 719, 719, 719, -1, -1, -1, -1, 
	719, 719, 719, -1, -1, -1, -1, 719, 
	719, -1, 719, 719, 719, 719, -1, -1, 
	-1, -1, -1, 704, -1, 719, 719, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 719, 719, 719, 719, 719, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 714, 714, 714, 714, 714, -1, 714, 
	714, 714, -1, -1, -1, -1, 714, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 714, 714, -1, -1, 714, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 714, 714, 714, 714, 714, -1, -1, 
	-1, -1, 704, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 719, 719, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 719, 719, 
	719, 719, 719, -1, 719, 719, 719, -1, 
	-1, -1, -1, 719, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 719, 719, 
	719, 719, 719, 721, 721, 721, 721, 721, 
	721, 721, 721, 721, 721, 721, 721, 721, 
	721, 721, 721, -1, 721, 721, 721, 721, 
	721, 721, 721, 721, -1, -1, -1, 721, 
	721, 721, 721, 721, -1, 721, -1, 721, 
	721, 721, 721, -1, 721, -1, 721, 721, 
	721, -1, -1, 721, -1, -1, 721, 721, 
	721, 721, 721, -1, 721, 721, 721, -1, 
	-1, -1, -1, 721, 721, 721, 721, 721, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 721, 721, -1, 
	-1, -1, -1, 725, 725, 725, 725, 725, 
	725, 725, 725, 725, 725, 725, 725, -1, 
	-1, 725, 725, 725, 725, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 704, 
	-1, 725, 725, 725, -1, -1, -1, 725, 
	-1, -1, -1, -1, 725, -1, -1, -1, 
	-1, -1, 725, 725, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	725, -1, -1, 721, 721, 721, 721, -1, 
	-1, 721, 721, 721, 721, 721, 721, -1, 
	-1, 725, -1, 721, 721, 721, 721, 721, 
	721, 721, 721, -1, -1, -1, -1, 721, 
	-1, -1, -1, -1, 721, 721, 725, 725, 
	721, 721, 721, 721, -1, 721, 721, -1, 
	-1, 721, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 721, 721, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 721, 721, -1, -1, -1, 
	-1, -1, -1, 709, 709, 721, 721, 709, 
	-1, -1, -1, 721, -1, -1, -1, 723, 
	723, 723, 723, 723, 723, 723, 723, 723, 
	723, 723, 723, 723, 723, 723, 723, -1, 
	723, 723, 723, 723, 723, 723, 723, 723, 
	-1, 721, 721, 723, 723, 723, 723, 723, 
	-1, 723, -1, 723, 723, 723, 723, -1, 
	723, -1, 723, 723, 723, -1, -1, 723, 
	-1, -1, 723, 723, 723, 723, 723, -1, 
	723, 723, 723, -1, -1, -1, -1, 723, 
	723, 723, 723, 723, -1, -1, -1, 725, 
	725, -1, -1, -1, -1, -1, -1, -1, 
	725, 725, 725, -1, 725, 725, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 725, 
	-1, -1, -1, -1, 725, -1, -1, -1, 
	-1, 723, 723, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 725, 725, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 725, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 723, 
	723, 723, 723, -1, -1, 723, 723, 723, 
	723, 723, 723, -1, -1, -1, -1, 723, 
	723, 723, 723, 723, 723, 723, 723, -1, 
	-1, -1, -1, 723, -1, -1, -1, -1, 
	723, 723, -1, -1, 723, 723, 723, 723, 
	-1, 723, 723, -1, 721, 723, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 723, 723, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 723, 
	723, -1, -1, -1, -1, -1, -1, -1, 
	-1, 723, 723, -1, -1, -1, -1, 723, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 723, 723, -1, 
	-1, -1, -1, -1, 719, 719, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 719, 
	719, 719, 719, 719, -1, 719, 719, 719, 
	-1, -1, -1, -1, 719, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 719, 
	719, 719, 719, -1, -1, -1, -1, -1, 
	-1, -1, -1, 721, 724, 724, 724, 724, 
	724, 724, 724, 724, 724, 724, 724, 724, 
	724, 724, 724, 724, -1, 724, 724, 724, 
	724, 724, 724, 724, 724, -1, -1, -1, 
	724, 724, 724, 724, 724, -1, 724, -1, 
	724, 724, 724, 724, -1, 724, -1, 724, 
	724, 724, -1, -1, 724, -1, -1, 724, 
	724, 724, 724, 724, -1, 724, 724, 724, 
	-1, -1, -1, -1, 724, 724, 724, 724, 
	724, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, 724, 724, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	723, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 724, 724, 724, 724, 
	-1, -1, 724, 724, 724, 724, 724, 724, 
	-1, -1, -1, -1, 724, 724, 724, 724, 
	724, 724, 724, 724, -1, -1, -1, -1, 
	724, -1, -1, -1, -1, 724, 724, -1, 
	-1, 724, 724, 724, 724, -1, 724, 724, 
	-1, -1, 724, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 724, 
	724, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 724, 724, -1, -1, 
	-1, -1, -1, -1, -1, -1, 724, 724, 
	-1, -1, -1, -1, 724, -1, -1, 723, 
	731, 731, 731, 731, 731, 731, 731, -1, 
	731, 731, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 731, 731, 731, 731, 731, 
	-1, -1, 724, 724, -1, -1, -1, -1, 
	-1, -1, 731, -1, -1, -1, 731, -1, 
	-1, -1, 731, 731, 731, 731, 731, 731, 
	-1, -1, -1, -1, 731, 731, 731, -1, 
	-1, -1, -1, 731, 731, 731, 731, 731, 
	731, 731, 731, -1, -1, -1, -1, -1, 
	-1, 731, -1, 725, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 731, 
	731, 731, 731, 731, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	731, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 736, 736, 736, 
	736, 736, 736, 736, 736, 736, 736, 736, 
	736, 736, 736, 736, 736, -1, 736, 736, 
	736, 736, 736, 736, 736, 736, 725, -1, 
	-1, 736, 736, 736, 736, 736, -1, 736, 
	-1, 736, 736, 736, 736, -1, 736, -1, 
	736, 736, 736, -1, -1, 736, -1, -1, 
	736, 736, 736, 736, 736, -1, 736, 736, 
	736, -1, -1, -1, -1, 736, 736, 736, 
	736, 736, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 724, -1, 736, 
	736, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 731, 731, 731, 731, 731, -1, 
	731, 731, 731, -1, -1, -1, -1, 731, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 731, 731, -1, -1, 731, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 731, 731, 731, 731, 731, -1, 
	-1, -1, -1, -1, -1, 736, 736, 736, 
	736, -1, -1, 736, 736, 736, 736, 736, 
	736, -1, -1, -1, -1, 736, 736, 736, 
	736, 736, 736, 736, 736, -1, -1, -1, 
	-1, 736, -1, -1, -1, -1, 736, 736, 
	-1, -1, 736, 736, 736, 736, -1, 736, 
	736, -1, -1, 736, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	736, 736, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 724, 736, 736, -1, 
	-1, -1, -1, -1, -1, -1, -1, 736, 
	736, -1, -1, -1, -1, 736, 738, 738, 
	738, 738, 738, 738, 738, -1, 738, 738, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 738, 738, 738, 738, 738, -1, -1, 
	-1, -1, -1, 736, 736, -1, -1, -1, 
	738, -1, -1, -1, 738, -1, -1, -1, 
	738, 738, 738, 738, 738, 738, -1, -1, 
	-1, -1, 738, 738, 738, -1, -1, -1, 
	-1, 738, 738, 738, 738, 738, 738, 738, 
	738, -1, -1, -1, -1, -1, -1, 738, 
	739, 739, 739, 739, 739, 739, 739, -1, 
	739, 739, -1, -1, -1, 738, 738, 738, 
	738, 738, -1, 739, 739, 739, 739, 739, 
	-1, -1, -1, -1, -1, -1, 738, -1, 
	-1, -1, 739, -1, -1, -1, 739, -1, 
	-1, -1, 739, 739, 739, 739, 739, 739, 
	-1, -1, -1, -1, 739, 739, 739, -1, 
	-1, -1, -1, 739, 739, 739, 739, 739, 
	739, 739, 739, -1, -1, -1, -1, -1, 
	-1, 739, 740, 740, 740, 740, 740, 740, 
	740, -1, 740, 740, -1, -1, -1, 739, 
	739, 739, 739, 739, -1, 740, 740, 740, 
	740, 740, -1, -1, -1, -1, -1, -1, 
	739, -1, -1, -1, 740, -1, -1, -1, 
	740, -1, -1, -1, 740, 740, 740, 740, 
	740, 740, -1, -1, -1, -1, 740, 740, 
	740, -1, -1, -1, -1, 740, 740, 740, 
	740, 740, 740, 740, 740, -1, -1, -1, 
	-1, -1, -1, 740, -1, -1, 736, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 740, 740, 740, 740, 740, -1, -1, 
	738, 738, 738, 738, 738, -1, 738, 738, 
	738, -1, 740, -1, -1, 738, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	738, 738, -1, -1, 738, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	738, 738, 738, 738, 738, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 739, 739, 739, 739, 739, -1, 
	739, 739, 739, -1, -1, -1, -1, 739, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 739, 739, -1, -1, 739, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 739, 739, 739, 739, 739, -1, 
	-1, -1, -1, -1, -1, 736, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 740, 740, 740, 740, 
	740, -1, 740, 740, 740, -1, -1, -1, 
	-1, 740, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 740, 740, -1, -1, 
	740, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 740, 740, 740, 740, 
	740, 742, 742, 742, 742, 742, 742, 742, 
	742, 742, 742, 742, 742, 742, 742, 742, 
	742, -1, 742, 742, 742, 742, 742, 742, 
	742, 742, -1, -1, -1, 742, 742, 742, 
	742, 742, -1, 742, -1, 742, 742, 742, 
	742, -1, 742, -1, 742, 742, 742, -1, 
	-1, 742, -1, -1, 742, 742, 742, 742, 
	742, -1, 742, 742, 742, -1, -1, -1, 
	-1, 742, 742, 742, 742, 742, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, 742, 742, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 742, 742, 742, 742, -1, -1, 742, 
	742, 742, 742, 742, 742, -1, -1, -1, 
	-1, 742, 742, 742, 742, 742, 742, 742, 
	742, -1, -1, -1, -1, 742, -1, -1, 
	-1, -1, 742, 742, -1, -1, 742, 742, 
	742, 742, -1, 742, 742, -1, -1, 742, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, 742, 742, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 742, 742, -1, -1, -1, -1, -1, 
	-1, -1, -1, 742, 742, -1, -1, -1, 
	-1, 742, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, 742, 
	742, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, 742, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, 742
};

static int pid_0_parser_keys[] = {
	4, 935, 4, 842, 72, 855, 72, 854, 
	78, 860, 72, 72, 4, 935, 493, 493, 
	4, 923, 531, 531, 72, 72, 80, 541, 
	72, 854, 542, 542, 72, 888, 82, 82, 
	80, 549, 4, 636, 72, 855, 399, 399, 
	4, 923, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 72, 72, 
	64, 831, 64, 206, 72, 850, 72, 72, 
	4, 935, 72, 72, 72, 72, 32, 888, 
	72, 72, 4, 636, 4, 876, 72, 72, 
	13, 923, 72, 923, 13, 923, 86, 92, 
	72, 923, 13, 923, 4, 636, 4, 636, 
	4, 636, 75, 917, 72, 877, 32, 877, 
	88, 88, 72, 888, 72, 72, 76, 76, 
	72, 72, 64, 206, 72, 72, 72, 72, 
	75, 917, 86, 86, 82, 82, 72, 924, 
	32, 890, 32, 890, 32, 890, 72, 72, 
	72, 72, 72, 923, 72, 923, 86, 86, 
	86, 86, 32, 890, 72, 923, 32, 890, 
	75, 292, 75, 292, 72, 263, 72, 263, 
	72, 263, 44, 941, 72, 855, 72, 541, 
	72, 263, 72, 74, 72, 855, 72, 854, 
	79, 79, 78, 858, 44, 941, 4, 923, 
	64, 941, 142, 142, 142, 142, 142, 142, 
	13, 923, 4, 636, 4, 636, 4, 916, 
	114, 948, 119, 936, 122, 897, 13, 949, 
	72, 923, 32, 888, 82, 82, 32, 888, 
	32, 888, 32, 888, 32, 888, 32, 888, 
	75, 903, 75, 917, 75, 917, 4, 940, 
	7, 938, 82, 82, 11, 923, 4, 636, 
	4, 636, 4, 636, 4, 636, 13, 923, 
	13, 923, 13, 923, 13, 923, 13, 923, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 13, 923, 4, 636, 
	31, 31, 96, 96, 96, 96, 4, 636, 
	72, 924, 4, 636, 13, 951, 4, 636, 
	4, 636, 4, 636, 96, 96, 96, 96, 
	96, 96, 96, 96, 96, 96, 4, 921, 
	114, 950, 119, 936, 122, 897, 4, 636, 
	11, 923, 86, 86, 4, 876, 4, 636, 
	32, 888, 32, 888, 11, 942, 4, 876, 
	53, 863, 13, 923, 13, 923, 119, 936, 
	32, 888, 4, 636, 4, 636, 72, 74, 
	72, 72, 72, 72, 4, 937, 4, 831, 
	4, 636, 74, 74, 106, 106, 4, 885, 
	4, 636, 13, 923, 83, 83, 72, 72, 
	13, 923, 13, 923, 44, 877, 72, 854, 
	80, 87, 72, 889, 72, 889, 4, 636, 
	4, 857, 4, 636, 44, 877, 4, 636, 
	64, 877, 4, 636, 124, 932, 124, 932, 
	114, 914, 119, 896, 122, 122, 122, 122, 
	13, 913, 87, 87, 87, 87, 87, 108, 
	4, 636, 95, 95, 32, 263, 75, 891, 
	75, 891, 75, 891, 75, 891, 75, 891, 
	75, 891, 4, 636, 4, 636, 72, 945, 
	4, 902, 114, 944, 119, 936, 122, 897, 
	4, 885, 4, 885, 4, 851, 7, 888, 
	32, 888, 32, 888, 32, 888, 32, 888, 
	32, 888, 32, 888, 32, 888, 32, 888, 
	114, 919, 119, 896, 122, 122, 13, 918, 
	87, 108, 4, 636, 4, 636, 13, 923, 
	4, 636, 4, 636, 4, 636, 4, 868, 
	13, 923, 13, 923, 11, 942, 4, 636, 
	13, 923, 13, 923, 13, 923, 13, 923, 
	13, 923, 13, 923, 13, 923, 13, 923, 
	13, 923, 13, 923, 72, 923, 4, 889, 
	4, 636, 13, 923, 4, 636, 72, 820, 
	4, 636, 4, 636, 86, 86, 89, 89, 
	11, 923, 4, 636, 4, 636, 53, 863, 
	4, 863, 4, 636, 72, 903, 11, 923, 
	87, 87, 87, 87, 119, 896, 4, 636, 
	72, 888, 4, 636, 4, 636, 86, 86, 
	4, 877, 74, 142, 4, 636, 4, 832, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	72, 299, 4, 636, 87, 87, 4, 636, 
	78, 860, 44, 252, 78, 235, 72, 889, 
	72, 542, 4, 636, 4, 636, 4, 636, 
	90, 105, 72, 542, 4, 856, 72, 72, 
	78, 860, 142, 142, 129, 143, 124, 926, 
	88, 307, 88, 307, 124, 932, 88, 307, 
	88, 307, 88, 307, 88, 307, 88, 307, 
	139, 139, 150, 933, 150, 933, 124, 932, 
	88, 307, 142, 142, 129, 143, 4, 636, 
	114, 289, 4, 636, 4, 636, 114, 289, 
	13, 949, 4, 636, 119, 271, 4, 636, 
	4, 636, 4, 636, 4, 636, 13, 299, 
	75, 77, 13, 923, 4, 636, 13, 923, 
	13, 923, 75, 917, 13, 943, 75, 917, 
	75, 917, 75, 917, 75, 917, 75, 912, 
	114, 900, 119, 896, 122, 122, 72, 899, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 32, 263, 4, 636, 
	7, 263, 7, 263, 7, 263, 82, 152, 
	31, 31, 97, 97, 97, 97, 97, 97, 
	95, 95, 95, 95, 97, 97, 97, 97, 
	4, 636, 114, 294, 114, 294, 13, 951, 
	4, 636, 4, 636, 4, 636, 13, 299, 
	75, 77, 13, 923, 4, 636, 4, 636, 
	89, 89, 4, 636, 4, 636, 4, 636, 
	4, 868, 4, 636, 13, 923, 11, 923, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	87, 87, 87, 87, 87, 87, 87, 95, 
	82, 82, 13, 943, 4, 636, 89, 89, 
	11, 299, 11, 942, 72, 923, 11, 923, 
	11, 923, 4, 636, 89, 89, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	72, 820, 4, 636, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 263, 4, 263, 4, 263, 4, 263, 
	4, 636, 64, 64, 72, 72, 72, 72, 
	4, 636, 4, 636, 72, 542, 4, 636, 
	4, 636, 4, 636, 4, 859, 4, 636, 
	4, 636, 124, 932, 129, 143, 88, 307, 
	150, 934, 150, 934, 4, 636, 124, 932, 
	124, 932, 124, 932, 124, 932, 124, 932, 
	124, 932, 124, 932, 124, 932, 124, 307, 
	88, 307, 88, 307, 88, 307, 88, 307, 
	95, 125, 125, 931, 4, 636, 13, 913, 
	114, 948, 119, 936, 122, 897, 13, 299, 
	87, 87, 87, 87, 13, 923, 4, 636, 
	4, 636, 4, 636, 4, 636, 4, 636, 
	4, 636, 4, 636, 13, 947, 4, 911, 
	114, 946, 119, 936, 122, 897, 4, 636, 
	114, 275, 114, 275, 72, 945, 4, 636, 
	4, 636, 4, 636, 72, 274, 72, 898, 
	114, 944, 119, 936, 122, 897, 82, 82, 
	152, 939, 72, 72, 13, 906, 4, 636, 
	4, 636, 4, 636, 32, 888, 32, 888, 
	13, 923, 4, 636, 13, 918, 114, 950, 
	119, 936, 122, 897, 13, 299, 4, 636, 
	11, 923, 4, 636, 4, 636, 4, 636, 
	32, 888, 88, 88, 72, 820, 13, 923, 
	75, 903, 89, 89, 4, 636, 11, 923, 
	4, 636, 4, 636, 87, 87, 4, 636, 
	4, 636, 11, 942, 142, 142, 88, 307, 
	88, 307, 150, 309, 149, 309, 88, 307, 
	124, 926, 124, 926, 124, 926, 124, 926, 
	88, 307, 88, 307, 88, 307, 88, 307, 
	89, 95, 125, 125, 88, 307, 88, 307, 
	88, 307, 88, 307, 114, 289, 114, 914, 
	119, 896, 122, 122, 4, 636, 75, 292, 
	13, 299, 13, 299, 114, 909, 119, 896, 
	122, 122, 13, 908, 4, 636, 72, 899, 
	72, 273, 114, 900, 119, 896, 122, 122, 
	72, 274, 72, 74, 152, 152, 152, 836, 
	11, 923, 72, 923, 72, 72, 13, 923, 
	97, 97, 97, 97, 4, 636, 114, 294, 
	114, 919, 119, 896, 122, 122, 4, 636, 
	87, 95, 87, 95, 96, 96, 11, 942, 
	87, 87, 4, 636, 11, 317, 4, 636, 
	88, 92, 89, 89, 4, 832, 150, 150, 
	89, 89, 88, 307, 89, 125, 13, 299, 
	13, 299, 13, 299, 4, 636, 114, 284, 
	114, 284, 13, 947, 4, 636, 4, 636, 
	4, 636, 13, 299, 72, 888, 13, 923, 
	114, 275, 72, 274, 72, 274, 72, 274, 
	72, 889, 72, 889, 152, 939, 7, 263, 
	152, 211, 152, 211, 152, 211, 152, 211, 
	152, 211, 152, 211, 152, 211, 152, 211, 
	152, 211, 152, 211, 152, 211, 152, 211, 
	152, 211, 152, 939, 4, 636, 86, 86, 
	11, 299, 11, 299, 4, 636, 4, 636, 
	13, 299, 13, 299, 13, 299, 32, 888, 
	89, 89, 11, 942, 72, 72, 4, 636, 
	4, 849, 150, 309, 88, 307, 88, 307, 
	89, 89, 13, 908, 72, 74, 114, 946, 
	119, 936, 122, 897, 13, 299, 72, 274, 
	72, 274, 152, 836, 152, 836, 13, 923, 
	97, 97, 4, 636, 89, 89, 4, 636, 
	4, 636, 11, 942, 88, 307, 114, 284, 
	114, 909, 119, 896, 122, 122, 13, 299, 
	7, 263, 152, 211, 87, 87, 87, 95, 
	4, 636, 89, 89, 13, 299, 13, 299, 
	13, 299, 11, 299, 4, 636, 0, 0
};

static unsigned int pid_0_parser_offsets[] = {
	0, 16, 69, 74, 3, 25, 308, 26, 
	611, 27, 33, 35, 85, 40, 47, 42, 
	46, 942, 89, 50, 1320, 1588, 1856, 2223, 
	2491, 2759, 3027, 3295, 3563, 3831, 4099, 4367, 
	4635, 4903, 5171, 5439, 5707, 5975, 6243, 6511, 
	6779, 7047, 7315, 56, 70, 110, 75, 60, 
	7583, 62, 63, 148, 72, 7891, 8189, 73, 
	8260, 78, 8516, 86, 166, 8592, 8967, 9503, 
	9801, 205, 81, 407, 79, 142, 82, 90, 
	94, 130, 95, 97, 380, 98, 101, 116, 
	441, 452, 545, 102, 104, 234, 243, 105, 
	108, 686, 282, 691, 153, 384, 277, 283, 
	287, 401, 563, 727, 109, 112, 743, 746, 
	113, 129, 941, 10100, 394, 115, 117, 119, 
	10170, 10457, 11090, 11388, 887, 266, 136, 10528, 
	292, 1063, 121, 1169, 1226, 1244, 1278, 1705, 
	838, 550, 1089, 8898, 1943, 122, 11684, 11791, 
	12092, 12426, 12725, 7155, 13021, 13095, 13173, 13429, 
	13540, 14173, 14471, 14770, 15068, 15367, 15663, 15775, 
	124, 125, 127, 16073, 161, 16408, 16706, 17041, 
	17339, 17674, 128, 131, 132, 133, 134, 17972, 
	606, 587, 138, 18271, 14059, 135, 18569, 18904, 
	1710, 1715, 2602, 19202, 712, 18792, 19272, 698, 
	1723, 19562, 19862, 141, 146, 147, 20161, 20257, 
	20525, 157, 159, 20833, 21158, 21228, 162, 163, 
	21484, 21561, 904, 1840, 167, 2723, 2182, 21856, 
	22472, 22770, 1793, 23069, 1181, 23367, 2297, 3637, 
	701, 296, 164, 165, 22123, 168, 169, 181, 
	23666, 170, 1955, 1025, 1274, 1561, 1758, 1811, 
	1477, 23964, 24263, 2170, 24597, 1019, 925, 256, 
	24911, 25233, 25501, 6981, 2323, 2846, 2881, 2909, 
	3125, 3143, 3382, 3393, 1312, 532, 180, 25570, 
	200, 25867, 26175, 25734, 26665, 26963, 27262, 27560, 
	27630, 27887, 4478, 28002, 28267, 28341, 28597, 28866, 
	28940, 29014, 29270, 29344, 29613, 29906, 334, 30332, 
	30641, 30937, 31048, 1082, 31346, 31681, 184, 190, 
	21741, 31979, 32278, 873, 32576, 32875, 1257, 26551, 
	191, 195, 706, 33173, 291, 33472, 33770, 203, 
	33853, 233, 34113, 34576, 34874, 35173, 35471, 35770, 
	348, 36068, 217, 36367, 262, 1081, 302, 3527, 
	2998, 36665, 37012, 37329, 263, 3252, 37628, 223, 
	657, 232, 426, 3788, 7655, 7963, 2639, 8648, 
	8671, 9196, 9227, 9258, 237, 239, 579, 4173, 
	9575, 244, 449, 37926, 1659, 38268, 38582, 1669, 
	29983, 38901, 768, 39215, 39535, 39849, 40168, 34184, 
	273, 40464, 40575, 40840, 40914, 1165, 40989, 2891, 
	2983, 3160, 3215, 842, 2391, 771, 253, 2011, 
	41375, 41873, 42171, 42470, 42553, 42785, 42854, 43075, 
	43144, 43365, 43434, 43655, 43724, 43945, 44014, 44235, 
	44304, 44525, 44594, 44815, 44884, 45105, 2356, 45174, 
	4569, 4837, 5105, 307, 281, 290, 299, 303, 
	311, 324, 335, 341, 45472, 2306, 2351, 45769, 
	45880, 46178, 46477, 46773, 497, 46847, 47134, 47449, 
	354, 47767, 48082, 48400, 48715, 49033, 49107, 49364, 
	49666, 50074, 50372, 50671, 50969, 51268, 51566, 51865, 
	52163, 52462, 52760, 53059, 355, 358, 364, 405, 
	371, 53355, 53470, 403, 3942, 5550, 992, 53736, 
	53785, 54075, 412, 54487, 54785, 55084, 55382, 55681, 
	1273, 55979, 54159, 56062, 56265, 56343, 56564, 56642, 
	56845, 56923, 57126, 57204, 57407, 57485, 57688, 57766, 
	57969, 58047, 58250, 58328, 58560, 416, 423, 424, 
	58858, 59157, 4061, 59457, 59804, 60102, 60401, 60699, 
	61000, 5513, 1070, 9873, 660, 892, 61268, 3905, 
	4874, 5142, 5243, 4606, 5329, 6212, 6466, 4322, 
	10779, 10805, 10838, 11493, 437, 1405, 61536, 61606, 
	2094, 1551, 1034, 61874, 433, 438, 61984, 62277, 
	62586, 62910, 63219, 63543, 63852, 64176, 64472, 64809, 
	2424, 1580, 1060, 65107, 2109, 2464, 3455, 65449, 
	65763, 66083, 3690, 1798, 2717, 1831, 1186, 446, 
	3704, 471, 66379, 66492, 66790, 67125, 3411, 4219, 
	67395, 67526, 67822, 3368, 1937, 1286, 67896, 68186, 
	68452, 68565, 68863, 69162, 5857, 479, 1420, 69458, 
	3461, 480, 69569, 69835, 69948, 70249, 488, 70547, 
	70846, 6622, 503, 12178, 12201, 593, 722, 12833, 
	6584, 6736, 7540, 7656, 13282, 13470, 13800, 13823, 
	510, 511, 13897, 15475, 16160, 16183, 2744, 3672, 
	1104, 513, 71144, 2449, 71214, 71471, 3270, 1545, 
	514, 71548, 71835, 6102, 539, 3519, 2283, 520, 
	3723, 529, 528, 4743, 72131, 1700, 535, 72180, 
	537, 540, 72468, 2382, 3113, 2332, 542, 73101, 
	576, 583, 555, 16899, 558, 73399, 29481, 73698, 
	728, 559, 73996, 562, 564, 16763, 644, 72790, 
	74066, 74334, 74458, 2429, 2960, 74754, 75091, 75389, 
	75690, 75986, 2385, 76060, 2860, 4791, 5061, 5599, 
	6935, 9403, 5025, 5909, 5011, 5279, 5293, 5815, 
	5839, 6054, 6116, 6322, 6351, 6365, 6396, 6888, 
	7387, 7463, 76347, 574, 31419, 76419, 76980, 77278, 
	76859, 77575, 77649, 6075, 581, 61111, 586, 77936, 
	78234, 604, 16787, 16814, 598, 78304, 651, 5372, 
	3087, 1291, 78575, 6671, 7286, 7447, 7725, 78652, 
	636, 78939, 658, 79207, 79572, 79051, 17452, 2965, 
	6340, 2411, 667, 79840, 8329, 7423, 681, 696, 
	79957, 697, 80222, 80296, 80370, 72964, 80657, 0
};

static unsigned int pid_0_parser_targs[] = {
	7, 8, 9, 10, 11, 12, 13, 14, 
	15, 16, 17, 18, 19, 20, 21, 22, 
	23, 24, 25, 26, 27, 28, 29, 30, 
	31, 32, 33, 34, 35, 36, 37, 38, 
	39, 40, 41, 42, 43, 44, 45, 46, 
	47, 48, 49, 50, 51, 52, 53, 54, 
	55, 56, 57, 58, 59, 60, 61, 62, 
	63, 64, 65, 66, 67, 68, 69, 70, 
	71, 72, 73, 74, 75, 76, 77, 78, 
	78, 78, 78, 78, 79, 79, 80, 81, 
	82, 83, 84, 85, 86, 87, 88, 89, 
	90, 91, 92, 93, 94, 95, 96, 97, 
	98, 99, 100, 101, 102, 103, 104, 105, 
	106, 107, 108, 109, 110, 111, 112, 113, 
	114, 115, 116, 116, 117, 117, 118, 118, 
	119, 119, 120, 121, 122, 123, 124, 125, 
	126, 127, 128, 129, 130, 131, 132, 133, 
	134, 135, 136, 137, 138, 139, 140, 141, 
	142, 143, 144, 145, 146, 147, 148, 149, 
	150, 151, 152, 153, 154, 155, 156, 157, 
	158, 159, 160, 161, 162, 163, 164, 165, 
	166, 167, 167, 168, 168, 169, 169, 170, 
	170, 171, 172, 173, 174, 175, 176, 177, 
	178, 179, 180, 181, 182, 183, 184, 185, 
	186, 187, 188, 189, 190, 191, 192, 193, 
	194, 195, 196, 197, 198, 198, 199, 200, 
	201, 202, 203, 204, 205, 206, 207, 208, 
	209, 210, 211, 212, 213, 214, 215, 216, 
	217, 218, 219, 220, 221, 222, 223, 224, 
	225, 226, 227, 228, 229, 230, 231, 232, 
	233, 234, 235, 236, 237, 237, 238, 238, 
	239, 239, 240, 241, 242, 243, 244, 245, 
	246, 247, 248, 249, 250, 251, 252, 253, 
	254, 255, 256, 257, 258, 259, 260, 261, 
	262, 263, 264, 265, 266, 267, 268, 269, 
	270, 271, 272, 273, 274, 275, 276, 277, 
	278, 279, 279, 280, 280, 281, 282, 283, 
	284, 285, 286, 287, 288, 289, 290, 291, 
	292, 292, 293, 293, 294, 294, 295, 295, 
	296, 297, 298, 299, 300, 301, 302, 303, 
	304, 305, 306, 307, 308, 309, 310, 311, 
	312, 313, 314, 315, 316, 317, 318, 319, 
	320, 321, 322, 323, 324, 325, 326, 327, 
	328, 329, 330, 331, 332, 333, 334, 335, 
	336, 337, 338, 339, 340, 341, 342, 343, 
	344, 345, 346, 347, 348, 349, 350, 351, 
	352, 353, 354, 355, 356, 357, 358, 359, 
	360, 361, 362, 363, 364, 365, 366, 367, 
	368, 369, 370, 371, 372, 373, 374, 375, 
	376, 377, 378, 379, 380, 381, 382, 383, 
	384, 385, 386, 387, 388, 389, 390, 391, 
	392, 393, 394, 395, 396, 397, 398, 399, 
	400, 401, 402, 403, 404, 405, 406, 407, 
	408, 409, 410, 411, 412, 413, 414, 415, 
	416, 417, 418, 419, 420, 421, 422, 423, 
	424, 425, 426, 427, 427, 428, 428, 429, 
	429, 430, 431, 432, 433, 434, 435, 436, 
	437, 438, 439, 440, 441, 442, 443, 444, 
	445, 446, 447, 448, 449, 450, 451, 452, 
	453, 454, 455, 456, 457, 458, 459, 459, 
	460, 461, 462, 463, 464, 465, 466, 467, 
	468, 469, 470, 471, 472, 473, 474, 475, 
	476, 477, 478, 479, 480, 481, 482, 483, 
	484, 485, 486, 487, 488, 489, 490, 491, 
	492, 493, 494, 495, 496, 497, 498, 499, 
	500, 501, 502, 503, 504, 505, 506, 507, 
	508, 509, 510, 511, 512, 513, 514, 515, 
	516, 517, 518, 519, 520, 521, 522, 523, 
	524, 525, 526, 527, 528, 529, 530, 531, 
	532, 533, 534, 535, 536, 536, 537, 537, 
	538, 538, 539, 540, 541, 542, 543, 544, 
	545, 546, 547, 548, 549, 550, 551, 552, 
	553, 554, 555, 556, 557, 558, 559, 560, 
	561, 562, 563, 564, 565, 566, 567, 568, 
	569, 570, 570, 571, 572, 573, 574, 575, 
	576, 577, 578, 579, 580, 581, 582, 583, 
	584, 585, 586, 587, 588, 589, 590, 591, 
	592, 593, 594, 595, 596, 597, 598, 599, 
	600, 601, 602, 603, 604, 605, 606, 607, 
	608, 609, 610, 611, 612, 613, 614, 615, 
	616, 617, 618, 619, 620, 621, 622, 623, 
	624, 625, 626, 627, 628, 629, 630, 631, 
	632, 633, 634, 635, 636, 637, 638, 639, 
	640, 641, 642, 643, 644, 645, 646, 647, 
	648, 649, 650, 651, 652, 653, 654, 655, 
	656, 657, 658, 659, 660, 661, 662, 663, 
	664, 665, 666, 667, 668, 669, 670, 671, 
	672, 673, 674, 675, 676, 677, 678, 679, 
	680, 681, 682, 683, 684, 685, 686, 687, 
	688, 689, 690, 691, 692, 693, 694, 695, 
	696, 697, 698, 699, 700, 701, 702, 703, 
	704, 705, 706, 707, 708, 709, 710, 711, 
	712, 713, 714, 715, 716, 717, 718, 719, 
	720, 721, 722, 723, 724, 725, 726, 727, 
	728, 729, 730, 731, 732, 733, 734, 735, 
	736, 737, 738, 739, 740, 741, 742, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743
};

static unsigned int pid_0_parser_actInds[] = {
	0, 2, 4, 6, 8, 10, 12, 14, 
	16, 19, 21, 23, 25, 27, 29, 31, 
	33, 35, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 59, 61, 63, 
	65, 67, 69, 71, 73, 75, 77, 79, 
	81, 83, 85, 87, 89, 91, 93, 95, 
	97, 99, 101, 103, 105, 107, 109, 111, 
	113, 115, 117, 119, 121, 123, 125, 127, 
	129, 131, 133, 135, 137, 139, 141, 143, 
	145, 148, 151, 154, 158, 160, 163, 165, 
	167, 169, 171, 173, 175, 177, 179, 181, 
	183, 185, 187, 189, 191, 193, 195, 197, 
	199, 201, 203, 205, 207, 209, 211, 213, 
	215, 217, 219, 221, 223, 225, 227, 229, 
	231, 233, 235, 237, 240, 242, 245, 247, 
	250, 252, 255, 257, 259, 262, 264, 266, 
	268, 270, 272, 274, 276, 278, 280, 282, 
	284, 286, 288, 290, 292, 294, 296, 298, 
	300, 302, 304, 306, 308, 310, 312, 314, 
	316, 318, 320, 322, 324, 326, 328, 330, 
	332, 334, 336, 338, 340, 342, 344, 346, 
	348, 350, 352, 355, 357, 360, 362, 365, 
	367, 370, 372, 374, 376, 378, 380, 382, 
	384, 386, 388, 390, 392, 394, 396, 398, 
	400, 402, 404, 406, 408, 410, 412, 414, 
	416, 418, 420, 422, 424, 426, 429, 431, 
	433, 435, 437, 439, 441, 443, 445, 447, 
	449, 451, 453, 455, 457, 459, 461, 463, 
	465, 467, 469, 471, 473, 475, 477, 479, 
	481, 483, 485, 487, 489, 491, 493, 495, 
	497, 499, 501, 503, 505, 507, 510, 512, 
	515, 517, 520, 522, 524, 526, 528, 530, 
	532, 534, 536, 538, 540, 542, 544, 546, 
	548, 550, 552, 554, 556, 558, 560, 562, 
	564, 566, 568, 570, 572, 574, 576, 578, 
	580, 582, 584, 586, 588, 590, 592, 594, 
	596, 598, 600, 603, 605, 608, 611, 613, 
	615, 617, 619, 621, 623, 625, 627, 629, 
	631, 633, 636, 638, 641, 643, 646, 648, 
	651, 653, 655, 657, 659, 661, 663, 665, 
	667, 669, 671, 673, 675, 677, 679, 681, 
	683, 685, 687, 689, 691, 693, 695, 697, 
	699, 701, 703, 705, 707, 709, 711, 713, 
	715, 717, 719, 721, 723, 725, 727, 729, 
	731, 733, 735, 737, 739, 741, 743, 745, 
	747, 749, 751, 753, 755, 757, 759, 761, 
	763, 765, 767, 769, 771, 773, 775, 777, 
	779, 781, 783, 785, 787, 789, 791, 793, 
	795, 797, 799, 801, 803, 805, 807, 809, 
	811, 813, 815, 817, 819, 821, 823, 825, 
	827, 829, 831, 833, 835, 837, 839, 841, 
	843, 845, 847, 849, 851, 853, 855, 857, 
	859, 861, 863, 865, 867, 869, 871, 873, 
	875, 877, 879, 881, 883, 885, 887, 889, 
	891, 893, 895, 897, 899, 901, 903, 905, 
	907, 909, 911, 913, 915, 918, 920, 923, 
	925, 928, 931, 934, 936, 938, 940, 942, 
	944, 946, 948, 950, 952, 954, 956, 958, 
	960, 962, 964, 966, 968, 970, 972, 974, 
	976, 978, 980, 982, 984, 986, 988, 990, 
	993, 995, 997, 999, 1001, 1003, 1005, 1007, 
	1009, 1011, 1013, 1015, 1017, 1019, 1021, 1023, 
	1025, 1027, 1029, 1031, 1033, 1035, 1037, 1039, 
	1041, 1043, 1045, 1047, 1049, 1051, 1053, 1055, 
	1057, 1059, 1061, 1063, 1065, 1067, 1069, 1071, 
	1073, 1075, 1077, 1079, 1081, 1083, 1085, 1087, 
	1089, 1091, 1093, 1095, 1097, 1099, 1101, 1103, 
	1105, 1107, 1109, 1111, 1113, 1115, 1117, 1119, 
	1121, 1123, 1125, 1127, 1129, 1131, 1133, 1135, 
	1137, 1139, 1141, 1143, 1145, 1147, 1150, 1152, 
	1155, 1157, 1160, 1162, 1164, 1166, 1168, 1170, 
	1172, 1174, 1176, 1178, 1180, 1182, 1184, 1187, 
	1189, 1191, 1193, 1195, 1197, 1199, 1201, 1203, 
	1205, 1207, 1209, 1211, 1213, 1215, 1217, 1219, 
	1221, 1223, 1225, 1228, 1230, 1232, 1234, 1236, 
	1238, 1240, 1242, 1244, 1246, 1248, 1250, 1252, 
	1254, 1256, 1258, 1260, 1262, 1264, 1266, 1268, 
	1270, 1272, 1274, 1276, 1278, 1280, 1282, 1284, 
	1286, 1288, 1290, 1292, 1294, 1296, 1298, 1300, 
	1302, 1304, 1306, 1308, 1310, 1312, 1314, 1316, 
	1318, 1320, 1322, 1324, 1326, 1328, 1330, 1332, 
	1334, 1336, 1338, 1340, 1342, 1344, 1346, 1348, 
	1350, 1352, 1354, 1356, 1358, 1360, 1362, 1364, 
	1366, 1368, 1370, 1372, 1374, 1376, 1378, 1380, 
	1382, 1384, 1386, 1388, 1390, 1392, 1394, 1396, 
	1398, 1400, 1402, 1404, 1406, 1408, 1410, 1412, 
	1414, 1416, 1418, 1420, 1422, 1424, 1426, 1428, 
	1430, 1432, 1434, 1436, 1438, 1440, 1442, 1444, 
	1446, 1448, 1450, 1452, 1454, 1456, 1458, 1460, 
	1462, 1464, 1466, 1468, 1470, 1472, 1474, 1476, 
	1478, 1480, 1482, 1484, 1486, 1488, 1490, 1492, 
	1494, 1496, 1498, 1500, 1502, 1504, 1506, 1508, 
	1510, 1512, 1514, 1516, 1518, 1520, 1522, 1524, 
	1526, 1528, 1530, 1532, 1534, 1536, 1538, 1540, 
	1542, 1544, 1546, 1548, 1550, 1552, 1554, 1556, 
	1558, 1560, 1562, 1564, 1566, 1568, 1570, 1572, 
	1574, 1576, 1578, 1580, 1582, 1584, 1586, 1588, 
	1590, 1592, 1594, 1596, 1598, 1600, 1602, 1604, 
	1606, 1608, 1610, 1612, 1614, 1616, 1618, 1620, 
	1622, 1624, 1626, 1628, 1630, 1632, 1634, 1636, 
	1638, 1640, 1642, 1644, 1646, 1648, 1650, 1652, 
	1654, 1656, 1658, 1660, 1662, 1664, 1666, 1668, 
	1670, 1672, 1674, 1676, 1678, 1680, 1682, 1684, 
	1686, 1688, 1690, 1692, 1694, 1696, 1698, 1700, 
	1702, 1704, 1706, 1708, 1710, 1712, 1714, 1716, 
	1718, 1720, 1722, 1724, 1726, 1728, 1730, 1732, 
	1734, 1736, 1738, 1740, 1742, 1744, 1746, 1748, 
	1750, 1752, 1754, 1756, 1758, 1760, 1762, 1764, 
	1766, 1768, 1770, 1772, 1774, 1776, 1778, 1780, 
	1782, 1784, 1786, 1788, 1790, 1792, 1794, 1796, 
	1798, 1800, 1802, 1804, 1806, 1808, 1810, 1812, 
	1814, 1816, 1818, 1820, 1822, 1824, 1826, 1828, 
	1830, 1832, 1834, 1836, 1838, 1840, 1842, 1844, 
	1846, 1848, 1850, 1852, 1854, 1856, 1858, 1860, 
	1862, 1864, 1866, 1868, 1870, 1872, 1874, 1876, 
	1878, 1880, 1882, 1884, 1886, 1888, 1890, 1892, 
	1894, 1896, 1898, 1900, 1902, 1904, 1906, 1908, 
	1910, 1912, 1914, 1916, 1918, 1920, 1922, 1924, 
	1926, 1928, 1930, 1932, 1934, 1936, 1938, 1940, 
	1942, 1944, 1946, 1948, 1950, 1952, 1954, 1956, 
	1958, 1960, 1962, 1964, 1966, 1968, 1970, 1972, 
	1974, 1976, 1978, 1980, 1982, 1984, 1986, 1988, 
	1990, 1992, 1994, 1996, 1998, 2000, 2002, 2004, 
	2006, 2008, 2010, 2012, 2014, 2016, 2018, 2020, 
	2022, 2024, 2026, 2028, 2030, 2032, 2034, 2036, 
	2038, 2040, 2042, 2044, 2046, 2048, 2050, 2052, 
	2054, 2056, 2058, 2060, 2062, 2064, 2066, 2068, 
	2070, 2072, 2074, 2076, 2078, 2080, 2082, 2084, 
	2086, 2088, 2090, 2092, 2094, 2096, 2098, 2100, 
	2102, 2104, 2106, 2108, 2110, 2112, 2114, 2116, 
	2118, 2120, 2122, 2124, 2126, 2128, 2130, 2132, 
	2134, 2136, 2138, 2140, 2142, 2144, 2146, 2148, 
	2150, 2152, 2154, 2156, 2158, 2160, 2162, 2164, 
	2166, 2168, 2170, 2172, 2174, 2176, 2178, 2180, 
	2182, 2184, 2186, 2188, 2190, 2192, 2194, 2196, 
	2198, 2200, 2202, 2204, 2206, 2208, 2210, 2212, 
	2214, 2216, 2218, 2220, 2222, 2224, 2226, 2228, 
	2230, 2232, 2234, 2236, 2238, 2240, 2242, 2244, 
	2246, 2248, 2250, 2252, 2254, 2256, 2258, 2260, 
	2262, 2264, 2266, 2268, 2270, 2272, 2274, 2276, 
	2278, 2280, 2282, 2284, 2286, 2288, 2290, 2292, 
	2294, 2296, 2298, 2300, 2302, 2304, 2306, 2308, 
	2310, 2312, 2314, 2316, 2318, 2320, 2322, 2324, 
	2326, 2328, 2330, 2332, 2334, 2336, 2338, 2340, 
	2342, 2344, 2346, 2348, 2350, 2352, 2354, 2356, 
	2358, 2360, 2362, 2364, 2366, 2368, 2370, 2372, 
	2374, 2376, 2378, 2380, 2382, 2384, 2386, 2388, 
	2391, 2394, 2397, 2400
};

static unsigned int pid_0_parser_actions[] = {
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 542, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 242, 0, 1, 982, 0, 238, 
	1, 0, 242, 1, 982, 0, 1, 0, 
	242, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 1286, 0, 
	1, 0, 1, 1286, 0, 1, 0, 1, 
	1286, 0, 1, 0, 1, 1286, 0, 1, 
	0, 1, 0, 1, 1014, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 1334, 0, 1, 0, 1, 1334, 0, 
	1, 0, 1, 1334, 0, 1, 0, 1, 
	1334, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 1358, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 1158, 0, 1, 0, 
	1, 1158, 0, 1, 0, 1, 1158, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 1358, 0, 1, 0, 1334, 1, 0, 
	1, 902, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 614, 0, 1, 0, 614, 1, 
	0, 1, 0, 1, 614, 0, 1, 0, 
	614, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 706, 1, 0, 1, 0, 
	1, 706, 0, 1, 0, 706, 1, 0, 
	1, 706, 0, 1, 706, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 614, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 1230, 0, 1, 0, 
	1, 1230, 0, 1, 0, 1, 1230, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 1082, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 706, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 638, 0, 602, 0, 
	642, 0, 594, 0, 598, 0, 654, 0, 
	658, 0, 606, 0, 634, 0, 662, 0, 
	666, 0, 6, 0, 10, 0, 14, 0, 
	18, 0, 22, 0, 26, 0, 30, 0, 
	34, 0, 38, 0, 42, 0, 46, 0, 
	50, 0, 54, 0, 58, 0, 62, 0, 
	66, 0, 70, 0, 74, 0, 78, 0, 
	82, 0, 86, 0, 134, 0, 138, 0, 
	142, 0, 146, 0, 150, 0, 154, 0, 
	158, 0, 162, 0, 166, 0, 170, 0, 
	174, 0, 178, 0, 182, 0, 186, 0, 
	190, 0, 194, 0, 374, 0, 378, 0, 
	386, 0, 390, 0, 394, 0, 398, 0, 
	402, 0, 406, 0, 410, 0, 414, 0, 
	418, 0, 422, 0, 426, 0, 430, 0, 
	434, 0, 438, 0, 442, 0, 446, 0, 
	450, 0, 630, 0, 670, 0, 674, 0, 
	1, 0, 2, 0, 90, 0, 94, 0, 
	98, 0, 102, 0, 106, 0, 110, 0, 
	114, 0, 118, 0, 122, 0, 126, 0, 
	130, 0, 198, 0, 202, 0, 206, 0, 
	210, 0, 214, 0, 218, 0, 222, 0, 
	226, 0, 230, 0, 234, 0, 238, 0, 
	242, 0, 246, 0, 250, 0, 254, 0, 
	258, 0, 262, 0, 266, 0, 270, 0, 
	274, 0, 278, 0, 282, 0, 286, 0, 
	290, 0, 294, 0, 298, 0, 302, 0, 
	306, 0, 310, 0, 314, 0, 318, 0, 
	322, 0, 326, 0, 330, 0, 334, 0, 
	338, 0, 342, 0, 346, 0, 350, 0, 
	354, 0, 358, 0, 362, 0, 366, 0, 
	370, 0, 382, 0, 458, 0, 462, 0, 
	466, 0, 470, 0, 474, 0, 478, 0, 
	482, 0, 486, 0, 490, 0, 494, 0, 
	498, 0, 502, 0, 506, 0, 510, 0, 
	514, 0, 518, 0, 522, 0, 526, 0, 
	530, 0, 534, 0, 538, 0, 542, 0, 
	546, 0, 550, 0, 554, 0, 558, 0, 
	562, 0, 566, 0, 570, 0, 574, 0, 
	578, 0, 582, 0, 586, 0, 590, 0, 
	610, 0, 614, 0, 618, 0, 622, 0, 
	626, 0, 646, 0, 650, 0, 678, 0, 
	682, 0, 686, 0, 690, 0, 694, 0, 
	698, 0, 702, 0, 706, 0, 710, 0, 
	714, 0, 718, 0, 722, 0, 726, 0, 
	730, 0, 734, 0, 738, 0, 742, 0, 
	746, 0, 750, 0, 754, 0, 758, 0, 
	762, 0, 766, 0, 770, 0, 774, 0, 
	778, 0, 782, 0, 790, 0, 794, 0, 
	798, 0, 802, 0, 806, 0, 810, 0, 
	814, 0, 818, 0, 822, 0, 826, 0, 
	830, 0, 834, 0, 838, 0, 842, 0, 
	846, 0, 850, 0, 854, 0, 858, 0, 
	862, 0, 866, 0, 870, 0, 874, 0, 
	878, 0, 882, 0, 886, 0, 890, 0, 
	894, 0, 898, 0, 902, 0, 906, 0, 
	910, 0, 914, 0, 918, 0, 922, 0, 
	926, 0, 930, 0, 934, 0, 938, 0, 
	942, 0, 946, 0, 950, 0, 954, 0, 
	958, 0, 962, 0, 966, 0, 970, 0, 
	974, 0, 978, 0, 982, 0, 986, 0, 
	990, 0, 994, 0, 998, 0, 1002, 0, 
	1006, 0, 1010, 0, 1014, 0, 1018, 0, 
	1022, 0, 1026, 0, 1030, 0, 1034, 0, 
	1038, 0, 1042, 0, 1046, 0, 1050, 0, 
	1054, 0, 1058, 0, 1062, 0, 1066, 0, 
	1070, 0, 1074, 0, 1078, 0, 1082, 0, 
	1086, 0, 1090, 0, 1094, 0, 1098, 0, 
	1102, 0, 1106, 0, 1110, 0, 1114, 0, 
	1118, 0, 1122, 0, 1126, 0, 1130, 0, 
	1134, 0, 1138, 0, 1142, 0, 1146, 0, 
	1150, 0, 1154, 0, 1158, 0, 1162, 0, 
	1166, 0, 1170, 0, 1174, 0, 1178, 0, 
	1186, 0, 1190, 0, 1194, 0, 1198, 0, 
	1202, 0, 1206, 0, 1210, 0, 1214, 0, 
	1218, 0, 1222, 0, 1226, 0, 1230, 0, 
	1234, 0, 1238, 0, 1242, 0, 1246, 0, 
	1250, 0, 1254, 0, 1258, 0, 1262, 0, 
	1266, 0, 1270, 0, 1274, 0, 1278, 0, 
	1282, 0, 1286, 0, 1290, 0, 1294, 0, 
	1298, 0, 1302, 0, 1306, 0, 1310, 0, 
	1314, 0, 1318, 0, 1322, 0, 1326, 0, 
	1330, 0, 1334, 0, 1338, 0, 1342, 0, 
	1346, 0, 1350, 0, 1354, 0, 1362, 0, 
	1366, 0, 1370, 0, 1374, 0, 1378, 0, 
	1382, 0, 1386, 0, 1390, 0, 1394, 0, 
	1398, 0, 1402, 0, 1406, 0, 1410, 0, 
	1414, 0, 1418, 0, 1422, 0, 1426, 0, 
	1430, 0, 1434, 0, 1438, 0, 1442, 0, 
	1446, 0, 1450, 0, 1454, 0, 1458, 0, 
	1462, 0, 1466, 0, 1470, 0, 1474, 0, 
	1486, 0, 1490, 0, 1494, 0, 1498, 0, 
	1502, 0, 1506, 0, 1510, 0, 1514, 0, 
	1518, 0, 1522, 0, 1526, 0, 1530, 0, 
	1534, 0, 1538, 0, 1542, 0, 1546, 0, 
	1550, 0, 1554, 0, 1558, 0, 1562, 0, 
	1566, 0, 1570, 0, 1574, 0, 1578, 0, 
	1582, 0, 1586, 0, 1590, 0, 1594, 0, 
	1598, 0, 1602, 0, 1606, 0, 1610, 0, 
	1614, 0, 1618, 0, 1622, 0, 1626, 0, 
	1630, 0, 1634, 0, 1638, 0, 1642, 0, 
	1646, 0, 1650, 0, 1170, 1174, 0, 1170, 
	1178, 0, 1478, 1462, 0, 1482, 1466, 0, 
	1170, 1174, 1178, 0
};

static int pid_0_parser_commitLen[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, -7, 
	-4, -4, -3, -3, -3, -3, -2, -2, 
	-2, -2, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, -1, -1, -1, 
	-1, -1, -1, -1, -1, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0
};

static int pid_0_parser_tokenRegionInds[] = {
	1, 3, 5, 7, 9, 11, 13, 15, 
	17, 19, 21, 23, 25, 27, 29, 31, 
	33, 35, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 59, 61, 63, 
	65, 67, 69, 71, 73, 75, 77, 79, 
	81, 83, 85, 87, 89, 91, 93, 96, 
	98, 100, 102, 104, 106, 108, 110, 112, 
	114, 116, 118, 120, 122, 124, 126, 128, 
	130, 132, 134, 136, 138, 140, 142, 144, 
	146, 148, 150, 152, 154, 156, 158, 160, 
	162, 164, 166, 168, 170, 172, 174, 176, 
	178, 180, 182, 184, 186, 188, 190, 192, 
	194, 196, 198, 200, 202, 204, 206, 208, 
	210, 212, 214, 216, 218, 221, 223, 225, 
	227, 229, 231, 234, 237, 239, 241, 243, 
	245, 247, 249, 251, 253, 255, 257, 259, 
	261, 263, 265, 267, 269, 271, 273, 275, 
	278, 281, 284, 287, 289, 291, 293, 295, 
	297, 300, 303, 306, 309, 312, 315, 317, 
	320, 322, 324, 326, 329, 331, 334, 336, 
	340, 344, 348, 350, 352, 354, 356, 358, 
	361, 363, 365, 367, 369, 371, 373, 375, 
	377, 379, 381, 383, 385, 387, 389, 391, 
	393, 395, 397, 399, 401, 403, 405, 407, 
	409, 411, 413, 415, 417, 419, 421, 423, 
	425, 427, 429, 431, 433, 435, 437, 439, 
	441, 443, 445, 447, 449, 452, 454, 456, 
	458, 460, 462, 464, 466, 468, 470, 472, 
	474, 477, 479, 481, 483, 485, 487, 489, 
	491, 493, 496, 499, 501, 504, 506, 508, 
	510, 513, 516, 518, 520, 522, 524, 526, 
	528, 530, 532, 534, 536, 538, 540, 542, 
	544, 546, 549, 552, 554, 557, 560, 563, 
	565, 567, 569, 571, 573, 575, 577, 579, 
	581, 583, 585, 587, 589, 591, 593, 595, 
	599, 602, 604, 606, 608, 610, 612, 614, 
	616, 618, 620, 622, 624, 626, 628, 630, 
	632, 634, 636, 638, 641, 643, 645, 647, 
	649, 651, 654, 656, 658, 660, 663, 666, 
	668, 670, 673, 675, 677, 679, 682, 684, 
	686, 688, 693, 698, 703, 705, 707, 709, 
	711, 713, 715, 717, 719, 722, 725, 727, 
	730, 733, 736, 739, 742, 744, 746, 748, 
	750, 753, 755, 757, 760, 762, 765, 768, 
	770, 773, 776, 778, 781, 784, 787, 790, 
	793, 795, 797, 799, 801, 803, 805, 807, 
	809, 811, 813, 815, 817, 819, 821, 823, 
	825, 828, 831, 834, 836, 838, 840, 842, 
	844, 846, 848, 850, 852, 854, 856, 858, 
	860, 862, 864, 866, 868, 870, 872, 874, 
	876, 878, 880, 882, 885, 887, 889, 891, 
	893, 895, 897, 899, 901, 904, 906, 908, 
	911, 914, 917, 920, 923, 925, 927, 930, 
	933, 935, 938, 941, 943, 945, 947, 949, 
	951, 954, 957, 960, 963, 966, 969, 972, 
	975, 978, 981, 984, 988, 990, 992, 994, 
	996, 998, 1000, 1002, 1004, 1006, 1008, 1010, 
	1012, 1014, 1016, 1018, 1020, 1023, 1026, 1028, 
	1030, 1032, 1034, 1036, 1038, 1040, 1042, 1044, 
	1046, 1048, 1050, 1052, 1054, 1056, 1058, 1060, 
	1062, 1064, 1066, 1068, 1070, 1072, 1074, 1076, 
	1078, 1080, 1082, 1084, 1089, 1094, 1096, 1098, 
	1100, 1102, 1104, 1106, 1109, 1111, 1113, 1115, 
	1117, 1119, 1121, 1123, 1125, 1127, 1129, 1131, 
	1133, 1136, 1139, 1142, 1145, 1148, 1150, 1152, 
	1155, 1157, 1159, 1161, 1164, 1166, 1168, 1170, 
	1173, 1176, 1179, 1182, 1185, 1188, 1191, 1193, 
	1196, 1198, 1200, 1202, 1205, 1207, 1209, 1212, 
	1215, 1218, 1221, 1224, 1226, 1228, 1230, 1232, 
	1234, 1236, 1238, 1240, 1244, 1248, 1252, 1254, 
	1256, 1258, 1261, 1264, 1266, 1268, 1270, 1273, 
	1275, 1277, 1279, 1281, 1284, 1286, 1288, 1290, 
	1292, 1294, 1296, 1298, 1300, 1302, 1304, 1306, 
	1308, 1310, 1312, 1314, 1317, 1320, 1322, 1324, 
	1327, 1329, 1331, 1333, 1335, 1338, 1341, 1344, 
	1347, 1349, 1351, 1354, 1357, 1360, 1363, 1365, 
	1367, 1369, 1371, 1373, 1375, 1377, 1379, 1381, 
	1383, 1385, 1387, 1390, 1393, 1395, 1397, 1399, 
	1401, 1404, 1406, 1408, 1410, 1412, 1414, 1416, 
	1418, 1420, 1422, 1425, 1427, 1429, 1431, 1433, 
	1435, 1437, 1439, 1441, 1443, 1445, 1448, 1450, 
	1452, 1454, 1456, 1458, 1460, 1462, 1465, 1468, 
	1471, 1474, 1477, 1480, 1482, 1484, 1487, 1490, 
	1493, 1496, 1499, 1501, 1503, 1505, 1508, 1511, 
	1514, 1517, 1520, 1522, 1524, 1526, 1528, 1530, 
	1532, 1534, 1536, 1538, 1540, 1542, 1544, 1546, 
	1548, 1550, 1552, 1554, 1556, 1558, 1560, 1564, 
	1568, 1571, 1574, 1577, 1579, 1581, 1583, 1585, 
	1587, 1589, 1591, 1594, 1597, 1599, 1602, 1604, 
	1606, 1608, 1610, 1613, 1616, 1619, 1621, 1623, 
	1625, 1627, 1629, 1631, 1633, 1635, 1637, 1640, 
	1642, 1644, 1646, 1648, 1651, 1653, 1655, 1657, 
	1659, 1661, 1663, 1666, 1669, 1672, 1674, 1676
};

static int pid_0_parser_tokenRegions[] = {
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 0, 
	0, 1, 0, 0, 0, 1, 0, 1, 
	0, 1, 0, 0, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 0, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 17, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 17, 0, 17, 0, 17, 
	0, 17, 0, 1, 0, 1, 0, 1, 
	5, 0, 1, 5, 0, 5, 0, 9, 
	0, 13, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 0, 1, 5, 0, 
	1, 0, 1, 0, 1, 0, 1, 5, 
	0, 1, 0, 1, 5, 0, 1, 0, 
	1, 17, 25, 0, 1, 17, 25, 0, 
	1, 17, 25, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 5, 
	0, 5, 0, 9, 0, 13, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 9, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 17, 0, 1, 0, 17, 0, 
	17, 0, 5, 0, 9, 0, 13, 0, 
	13, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 5, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 5, 0, 
	1, 5, 0, 1, 0, 1, 5, 0, 
	5, 0, 9, 0, 13, 0, 1, 5, 
	0, 1, 5, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	5, 0, 9, 0, 13, 0, 1, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 17, 25, 0, 1, 
	5, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 9, 0, 1, 17, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 17, 0, 1, 0, 
	1, 0, 1, 0, 1, 5, 0, 1, 
	5, 0, 1, 0, 1, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	17, 0, 1, 0, 1, 0, 1, 0, 
	1, 17, 25, 5, 0, 1, 17, 25, 
	5, 0, 1, 17, 25, 5, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 17, 0, 17, 0, 17, 0, 1, 
	17, 0, 1, 17, 0, 17, 0, 1, 
	17, 0, 1, 17, 0, 1, 17, 0, 
	1, 17, 0, 1, 17, 0, 17, 0, 
	21, 0, 21, 0, 17, 0, 17, 1, 
	0, 17, 0, 17, 0, 1, 5, 0, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	9, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 5, 0, 9, 0, 13, 0, 1, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 25, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 5, 0, 
	5, 0, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 0, 1, 0, 1, 
	5, 0, 1, 5, 0, 1, 0, 1, 
	5, 0, 1, 5, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 17, 25, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 5, 0, 1, 
	5, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 17, 25, 5, 
	0, 1, 17, 25, 5, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 17, 0, 
	17, 0, 1, 17, 0, 21, 0, 21, 
	0, 1, 0, 17, 0, 17, 0, 17, 
	0, 17, 0, 17, 0, 17, 0, 17, 
	0, 17, 0, 17, 0, 17, 1, 0, 
	17, 1, 0, 17, 1, 0, 17, 1, 
	0, 17, 1, 0, 17, 0, 1, 0, 
	1, 5, 0, 5, 0, 9, 0, 13, 
	0, 1, 5, 0, 1, 0, 1, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	0, 1, 5, 0, 5, 0, 9, 0, 
	13, 0, 1, 5, 0, 5, 0, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 5, 0, 9, 0, 13, 0, 
	1, 0, 25, 0, 1, 0, 1, 0, 
	1, 17, 25, 0, 1, 17, 25, 0, 
	1, 17, 25, 0, 1, 0, 1, 0, 
	1, 0, 1, 5, 0, 1, 5, 0, 
	5, 0, 9, 0, 13, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 5, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	17, 0, 1, 17, 0, 1, 17, 0, 
	21, 0, 21, 0, 1, 17, 0, 17, 
	0, 17, 0, 17, 0, 17, 0, 17, 
	1, 0, 17, 1, 0, 17, 1, 0, 
	17, 1, 0, 1, 0, 17, 0, 1, 
	17, 0, 1, 17, 0, 1, 17, 0, 
	1, 17, 0, 5, 0, 5, 0, 9, 
	0, 13, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 5, 0, 9, 0, 13, 
	0, 1, 0, 1, 5, 0, 1, 5, 
	0, 1, 0, 5, 0, 9, 0, 13, 
	0, 1, 5, 0, 1, 0, 25, 0, 
	25, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 1, 0, 1, 0, 1, 5, 
	0, 5, 0, 5, 0, 9, 0, 13, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 5, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 0, 21, 0, 1, 0, 1, 17, 
	0, 17, 1, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	5, 0, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 1, 0, 1, 0, 5, 
	0, 1, 5, 0, 1, 5, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	25, 0, 1, 0, 25, 0, 25, 0, 
	25, 0, 25, 0, 25, 0, 25, 0, 
	25, 0, 25, 0, 25, 0, 25, 0, 
	25, 0, 25, 0, 25, 0, 25, 0, 
	1, 0, 1, 0, 1, 0, 1, 0, 
	1, 17, 25, 0, 1, 17, 25, 0, 
	1, 5, 0, 1, 5, 0, 1, 5, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 21, 0, 1, 
	17, 0, 1, 17, 0, 1, 0, 1, 
	5, 0, 1, 0, 5, 0, 9, 0, 
	13, 0, 1, 5, 0, 1, 5, 0, 
	1, 5, 0, 25, 0, 25, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	0, 1, 0, 1, 0, 1, 17, 0, 
	5, 0, 5, 0, 9, 0, 13, 0, 
	1, 5, 0, 1, 0, 25, 0, 1, 
	0, 1, 0, 1, 0, 1, 0, 1, 
	5, 0, 1, 5, 0, 1, 5, 0, 
	1, 0, 1, 0, 0
};

static int pid_0_parser_tokenPreRegions[] = {
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, 3, 
	0, -1, 0, -1, 0, 3, 0, 3, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, 3, 
	0, -1, 0, 3, 0, 3, 3, 0, 
	3, 0, 3, 0, -1, 0, 3, 0, 
	-1, 0, 3, 0, -1, 0, -1, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, -1, 0, -1, 0, 3, 0, 
	3, 0, 3, 0, -1, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 0, -1, 0, 3, 0, 
	-1, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, 3, 3, 0, 3, 0, -1, 
	0, 3, 0, 3, 0, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	0, 3, 0, 3, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, 3, 
	0, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, 3, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	0, -1, -1, 0, 3, 3, 0, -1, 
	-1, 0, 3, 3, 0, 3, 3, 0, 
	3, 3, 0, 3, 0, -1, -1, 0, 
	-1, 0, 3, 0, 3, 0, -1, -1, 
	0, -1, 0, -1, -1, 0, 3, 0, 
	3, 3, 3, 0, 3, 3, 3, 0, 
	3, 3, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, -1, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, -1, 0, -1, 
	0, 3, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	0, 3, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	0, 3, 0, 3, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, 3, 
	0, 3, 0, -1, 0, -1, 0, 3, 
	0, -1, -1, 0, 3, 0, 19, 0, 
	19, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, 0, 3, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, -1, 0, 3, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	3, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, 0, 3, 0, 3, 
	0, 3, 0, -1, 0, 3, 0, 3, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	0, 3, 0, 3, 3, 3, 0, -1, 
	-1, 0, 3, 0, -1, 0, 3, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, 3, 0, 
	-1, 0, -1, 0, 3, 0, 3, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, 3, 0, 3, 0, 3, 0, 3, 
	0, -1, 0, 3, 3, 0, -1, 0, 
	3, 0, -1, 0, 3, 3, 0, 3, 
	3, 0, -1, 0, 3, 0, 3, 3, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	-1, 0, 3, 0, 3, 0, -1, 0, 
	3, 3, 3, 3, 0, 3, 3, 3, 
	3, 0, 3, 3, 3, 3, 0, 3, 
	0, -1, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	-1, 0, -1, -1, 0, 19, 0, -1, 
	-1, 0, 19, 19, 0, 19, 19, 0, 
	19, 19, 0, 19, 19, 0, -1, 0, 
	-1, 0, -1, 0, 19, 0, -1, -1, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, 3, 3, 0, -1, -1, 
	0, -1, 0, -1, 0, 3, 0, 3, 
	0, 3, 0, -1, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, 3, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	3, 0, 3, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, 3, 3, 0, 
	-1, -1, 0, -1, 0, -1, 0, 3, 
	3, 0, -1, -1, 0, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, 3, 0, 3, 0, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	3, 0, -1, 0, 3, 0, -1, 0, 
	-1, 0, -1, 0, 3, 3, 0, 3, 
	3, 0, -1, 0, -1, 0, 3, 0, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	3, 0, 3, 0, 3, 0, 3, 0, 
	-1, 0, -1, 0, 3, 3, 3, 3, 
	0, 3, 3, 3, 3, 0, 3, 0, 
	-1, 0, 3, 0, -1, 0, 19, 0, 
	-1, 0, -1, -1, 0, -1, 0, -1, 
	0, 19, 0, 19, 0, 19, 0, 19, 
	0, 19, 0, -1, 0, 19, 0, 19, 
	0, 19, 0, 19, 0, 19, 19, 0, 
	19, 19, 0, 19, 19, 0, 19, 19, 
	0, 3, 3, 0, 19, 0, 19, 0, 
	-1, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, -1, -1, 0, -1, -1, 0, 3, 
	0, -1, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, 3, 3, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	3, 0, -1, 0, 3, 0, 3, 0, 
	3, 3, 3, 0, 3, 3, 3, 0, 
	3, 3, 3, 0, 3, 0, 3, 0, 
	3, 0, 3, 3, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, 3, 0, -1, 0, -1, 0, -1, 
	0, 3, 3, 0, 3, 0, 3, 0, 
	3, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, 3, 0, 
	-1, 0, 3, 0, -1, 0, 3, 0, 
	-1, 0, 19, 19, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, 19, 0, 3, 0, -1, 
	-1, 0, 19, 19, 0, 19, 19, 0, 
	19, 19, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, 3, 0, 3, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, -1, 0, -1, -1, 
	0, 3, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, 0, 3, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, -1, 
	0, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, 0, -1, 0, -1, 0, 3, 
	0, 3, 0, -1, 0, 3, 3, 0, 
	-1, 0, -1, 0, 3, 0, -1, 0, 
	19, 0, -1, 0, 19, 0, 3, 3, 
	0, 3, 3, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, 0, -1, 0, -1, -1, 0, -1, 
	-1, 0, -1, -1, 0, 3, 3, 0, 
	-1, -1, 0, -1, 0, -1, 0, -1, 
	0, -1, -1, 0, -1, -1, 0, -1, 
	-1, 0, 3, 3, 0, 3, 3, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, 0, 3, 0, -1, 0, 
	3, 3, 3, 0, 3, 3, 3, 0, 
	-1, -1, 0, -1, -1, 0, -1, -1, 
	0, 3, 0, -1, 0, 3, 0, 3, 
	0, 3, 0, -1, 0, -1, 0, 3, 
	3, 0, 3, 3, 0, 19, 0, -1, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	-1, -1, 0, -1, 0, -1, 0, 3, 
	0, -1, 0, 3, 0, -1, 0, 3, 
	0, -1, 0, 3, 0, 3, 3, 0, 
	-1, 0, -1, 0, -1, 0, -1, 0, 
	3, 3, 0, -1, 0, -1, 0, -1, 
	0, 3, 0, 3, 0, -1, 0, -1, 
	-1, 0, -1, -1, 0, -1, -1, 0, 
	3, 0, 3, 0, 0
};

static struct pda_tables pid_0_pdaTables =
{
	pid_0_parser_indices,
	pid_0_parser_owners,
	pid_0_parser_keys,
	pid_0_parser_offsets,
	pid_0_parser_targs,
	pid_0_parser_actInds,
	pid_0_parser_actions,
	pid_0_parser_commitLen,
	pid_0_parser_tokenRegionInds,
	pid_0_parser_tokenRegions,
	pid_0_parser_tokenPreRegions,

	81290,
	1488,
	744,
	1180,
	1180,
	2404,
	1180,
	1677,
	1677
};

static code_t code_0_wv[] = {
	37, 5, 0, 34, 0, 0, 39, 255, 
	255, 22, 80, 0, 37, 5, 0, 215, 
	2, 0, 2, 1, 0, 232, 1, 0, 
	37, 255, 255, 32, 0, 0, 1, 0, 
	141, 0, 0, 21, 0, 2, 0, 0, 
	0, 0, 0, 0, 0, 0, 29, 2, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	29, 120, 233, 1, 0, 212, 35, 1, 
	0, 43, 2, 0, 0, 0, 0, 0, 
	0, 0, 0, 29, 2, 0, 0, 0, 
	0, 0, 0, 0, 0, 29, 21, 51, 
	0, 21, 46, 0, 37, 5, 0, 215, 
	2, 0, 2, 1, 0, 35, 2, 0, 
	43, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 2, 0, 0, 0, 0, 
	0, 0, 0, 0, 29, 2, 0, 0, 
	0, 0, 0, 0, 0, 0, 29, 21, 
	2, 0, 3, 43, 142
};

static code_t code_0_wc[] = {
	37, 5, 0, 34, 0, 0, 39, 255, 
	255, 22, 80, 0, 37, 5, 0, 215, 
	2, 0, 2, 1, 0, 232, 1, 0, 
	37, 255, 255, 32, 0, 0, 1, 0, 
	140, 0, 0, 21, 0, 2, 0, 0, 
	0, 0, 0, 0, 0, 0, 29, 2, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	29, 120, 233, 1, 0, 212, 35, 1, 
	0, 43, 2, 0, 0, 0, 0, 0, 
	0, 0, 0, 29, 2, 0, 0, 0, 
	0, 0, 0, 0, 0, 29, 21, 51, 
	0, 21, 46, 0, 37, 5, 0, 215, 
	2, 0, 2, 1, 0, 35, 2, 0, 
	43, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 2, 0, 0, 0, 0, 
	0, 0, 0, 0, 29, 2, 0, 0, 
	0, 0, 0, 0, 0, 0, 29, 21, 
	2, 0, 3, 43, 142
};

static struct local_info locals_0[] = {
	{ 1, 5 }, { 1, -1 }
};

static code_t code_1_wv[] = {
	99, 5, 0, 65, 240, 255, 0, 0, 
	85, 3, 66, 240, 255, 184, 223, 0, 
	68, 240, 255, 34, 3, 0, 39, 252, 
	255, 39, 253, 255, 39, 254, 255, 22, 
	202, 0, 232, 1, 0, 37, 253, 255, 
	32, 0, 0, 1, 0, 141, 0, 0, 
	34, 0, 2, 0, 0, 0, 0, 0, 
	0, 0, 0, 29, 2, 0, 0, 0, 
	0, 0, 0, 0, 0, 29, 115, 240, 
	255, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 120, 233, 1, 0, 212, 
	39, 251, 255, 37, 251, 255, 85, 147, 
	2, 0, 255, 41, 3, 0, 39, 250, 
	255, 37, 250, 255, 210, 184, 95, 0, 
	241, 1, 0, 0, 0, 2, 1, 0, 
	0, 0, 0, 0, 0, 0, 137, 1, 
	162, 2, 2, 0, 0, 0, 0, 0, 
	0, 0, 85, 147, 3, 0, 85, 255, 
	214, 137, 1, 162, 135, 162, 31, 91, 
	1, 0, 226, 91, 0, 0, 39, 250, 
	255, 85, 147, 3, 0, 1, 1, 0, 
	0, 0, 0, 0, 0, 0, 8, 86, 
	148, 3, 0, 37, 251, 255, 37, 250, 
	255, 85, 147, 2, 0, 90, 255, 38, 
	3, 0, 190, 37, 251, 255, 37, 250, 
	255, 35, 4, 0, 39, 255, 255, 37, 
	252, 255, 37, 250, 255, 37, 254, 255, 
	35, 5, 0, 70, 240, 255, 4, 86, 
	148, 4, 0, 37, 255, 255, 22, 3, 
	0, 21, 3, 0, 21, 27, 255, 71, 
	240, 255, 37, 255, 255, 43, 2, 0, 
	0, 0, 0, 0, 0, 0, 0, 29, 
	21, 0, 0, 142
};

static code_t code_1_wc[] = {
	99, 5, 0, 65, 240, 255, 0, 0, 
	85, 3, 66, 240, 255, 184, 222, 0, 
	68, 240, 255, 34, 3, 0, 39, 252, 
	255, 39, 253, 255, 39, 254, 255, 22, 
	201, 0, 232, 1, 0, 37, 253, 255, 
	32, 0, 0, 1, 0, 140, 0, 0, 
	34, 0, 2, 0, 0, 0, 0, 0, 
	0, 0, 0, 29, 2, 0, 0, 0, 
	0, 0, 0, 0, 0, 29, 115, 240, 
	255, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 120, 233, 1, 0, 212, 
	39, 251, 255, 37, 251, 255, 85, 147, 
	2, 0, 255, 41, 3, 0, 39, 250, 
	255, 37, 250, 255, 210, 184, 94, 0, 
	241, 1, 0, 0, 0, 2, 1, 0, 
	0, 0, 0, 0, 0, 0, 137, 1, 
	162, 2, 2, 0, 0, 0, 0, 0, 
	0, 0, 85, 147, 3, 0, 85, 255, 
	214, 137, 1, 162, 135, 162, 31, 91, 
	1, 0, 226, 91, 0, 0, 39, 250, 
	255, 85, 147, 3, 0, 1, 1, 0, 
	0, 0, 0, 0, 0, 0, 8, 87, 
	149, 3, 0, 37, 251, 255, 37, 250, 
	255, 85, 147, 2, 0, 255, 37, 3, 
	0, 190, 37, 251, 255, 37, 250, 255, 
	35, 4, 0, 39, 255, 255, 37, 252, 
	255, 37, 250, 255, 37, 254, 255, 35, 
	5, 0, 70, 240, 255, 4, 87, 149, 
	4, 0, 37, 255, 255, 22, 3, 0, 
	21, 3, 0, 21, 28, 255, 71, 240, 
	255, 37, 255, 255, 43, 2, 0, 0, 
	0, 0, 0, 0, 0, 0, 29, 21, 
	0, 0, 142
};

static struct local_info locals_1[] = {
	{ 1, -1 }, { 2, -16 }, { 1, -2 }, { 1, -3 }, { 1, -4 }, { 1, -5 }, { 1, -6 }
};

static code_t code_2_wv[] = {
	5, 86, 148, 4, 0, 99, 5, 0, 
	65, 243, 255, 0, 0, 167, 3, 66, 
	243, 255, 184, 116, 0, 68, 243, 255, 
	34, 6, 0, 39, 254, 255, 39, 255, 
	255, 22, 98, 0, 232, 2, 0, 98, 
	254, 255, 32, 0, 0, 2, 0, 141, 
	1, 0, 34, 0, 2, 0, 0, 0, 
	0, 0, 0, 0, 0, 29, 2, 0, 
	0, 0, 0, 0, 0, 0, 0, 29, 
	115, 243, 255, 2, 0, 0, 0, 0, 
	0, 0, 0, 0, 29, 120, 233, 2, 
	0, 212, 39, 253, 255, 37, 253, 255, 
	22, 23, 0, 37, 254, 255, 37, 253, 
	255, 37, 255, 255, 35, 7, 0, 70, 
	243, 255, 4, 86, 148, 4, 0, 21, 
	12, 0, 37, 254, 255, 37, 255, 255, 
	35, 8, 0, 70, 243, 255, 21, 134, 
	255, 71, 243, 255, 85, 147, 4, 0, 
	43, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 21, 0, 0, 142
};

static code_t code_2_wc[] = {
	5, 87, 149, 4, 0, 99, 5, 0, 
	65, 243, 255, 0, 0, 167, 3, 66, 
	243, 255, 184, 116, 0, 68, 243, 255, 
	34, 6, 0, 39, 254, 255, 39, 255, 
	255, 22, 98, 0, 232, 2, 0, 98, 
	254, 255, 32, 0, 0, 2, 0, 140, 
	1, 0, 34, 0, 2, 0, 0, 0, 
	0, 0, 0, 0, 0, 29, 2, 0, 
	0, 0, 0, 0, 0, 0, 0, 29, 
	115, 243, 255, 2, 0, 0, 0, 0, 
	0, 0, 0, 0, 29, 120, 233, 2, 
	0, 212, 39, 253, 255, 37, 253, 255, 
	22, 23, 0, 37, 254, 255, 37, 253, 
	255, 37, 255, 255, 35, 7, 0, 70, 
	243, 255, 4, 87, 149, 4, 0, 21, 
	12, 0, 37, 254, 255, 37, 255, 255, 
	35, 8, 0, 70, 243, 255, 21, 134, 
	255, 71, 243, 255, 85, 147, 4, 0, 
	43, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 21, 0, 0, 142
};

static struct local_info locals_2[] = {
	{ 2, -13 }, { 1, -1 }, { 1, -2 }, { 1, -3 }
};

static struct local_info locals_3[] = {
	{ 1, -1 }, { 1, -3 }
};

static unsigned char copy_0[] = {
	0, 0
};

static unsigned char copy_1[] = {
	0, 0
};

static unsigned char copy_2[] = {
	0, 0
};

static unsigned char copy_3[] = {
	0, 0
};

static unsigned char copy_4[] = {
	0, 0
};

static unsigned char copy_5[] = {
	0, 0
};

static unsigned char copy_6[] = {
	0, 0
};

static unsigned char copy_7[] = {
	0, 0
};

static unsigned char copy_8[] = {
	0, 0
};

static unsigned char copy_9[] = {
	0, 0
};

static unsigned char copy_10[] = {
	0, 0
};

static unsigned char copy_11[] = {
	0, 0
};

static unsigned char copy_12[] = {
	0, 0
};

static unsigned char copy_13[] = {
	0, 0
};

static unsigned char copy_14[] = {
	0, 0
};

static unsigned char copy_15[] = {
	0, 0
};

static unsigned char copy_16[] = {
	0, 0
};

static unsigned char copy_17[] = {
	0, 0
};

static unsigned char copy_18[] = {
	0, 0
};

static unsigned char copy_19[] = {
	0, 0
};

static unsigned char copy_20[] = {
	0, 0
};

static unsigned char copy_21[] = {
	0, 0
};

static unsigned char copy_22[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_23[] = {
	0, 0, 0, 1
};

static unsigned char copy_24[] = {
	0, 0
};

static unsigned char copy_25[] = {
	0, 0
};

static unsigned char copy_26[] = {
	0, 0
};

static unsigned char copy_27[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_28[] = {
	0, 0
};

static unsigned char copy_29[] = {
	0, 0, 0, 1
};

static unsigned char copy_30[] = {
	0, 0, 0, 1
};

static unsigned char copy_31[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_32[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_33[] = {
	0, 0
};

static unsigned char copy_34[] = {
	0, 0
};

static unsigned char copy_35[] = {
	0, 0
};

static unsigned char copy_36[] = {
	0, 0
};

static unsigned char copy_37[] = {
	0, 0
};

static unsigned char copy_38[] = {
	0, 0
};

static unsigned char copy_39[] = {
	0, 0
};

static unsigned char copy_40[] = {
	0, 0
};

static unsigned char copy_41[] = {
	0, 0
};

static unsigned char copy_42[] = {
	0, 0
};

static unsigned char copy_43[] = {
	0, 0
};

static unsigned char copy_44[] = {
	0, 0
};

static unsigned char copy_45[] = {
	0, 0
};

static unsigned char copy_46[] = {
	0, 0
};

static unsigned char copy_47[] = {
	0, 0
};

static unsigned char copy_48[] = {
	0, 0
};

static unsigned char copy_49[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_50[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_51[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7
};

static unsigned char copy_52[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_53[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_54[] = {
	0, 0
};

static unsigned char copy_55[] = {
	0, 0
};

static unsigned char copy_57[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_58[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_59[] = {
	0, 0
};

static unsigned char copy_61[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 
	0, 8
};

static unsigned char copy_62[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7
};

static unsigned char copy_63[] = {
	0, 0
};

static unsigned char copy_64[] = {
	0, 0
};

static unsigned char copy_65[] = {
	0, 0
};

static unsigned char copy_66[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_67[] = {
	0, 0
};

static unsigned char copy_68[] = {
	0, 0
};

static unsigned char copy_69[] = {
	0, 0, 0, 1
};

static unsigned char copy_70[] = {
	0, 0, 0, 1
};

static unsigned char copy_71[] = {
	0, 0
};

static unsigned char copy_72[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_73[] = {
	0, 0, 0, 1
};

static unsigned char copy_75[] = {
	0, 0, 0, 1
};

static unsigned char copy_77[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_78[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_79[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_80[] = {
	0, 0
};

static unsigned char copy_81[] = {
	0, 0
};

static unsigned char copy_82[] = {
	0, 0
};

static unsigned char copy_83[] = {
	0, 0
};

static unsigned char copy_84[] = {
	0, 0
};

static unsigned char copy_85[] = {
	0, 0
};

static unsigned char copy_86[] = {
	0, 0
};

static unsigned char copy_87[] = {
	0, 0
};

static unsigned char copy_88[] = {
	0, 0
};

static unsigned char copy_89[] = {
	0, 0
};

static unsigned char copy_90[] = {
	0, 0
};

static unsigned char copy_91[] = {
	0, 0
};

static unsigned char copy_92[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_93[] = {
	0, 0
};

static unsigned char copy_94[] = {
	0, 0
};

static unsigned char copy_95[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_96[] = {
	0, 0
};

static unsigned char copy_97[] = {
	0, 0
};

static unsigned char copy_98[] = {
	0, 0
};

static unsigned char copy_99[] = {
	0, 0
};

static unsigned char copy_100[] = {
	0, 0
};

static unsigned char copy_101[] = {
	0, 0
};

static unsigned char copy_102[] = {
	0, 0
};

static unsigned char copy_103[] = {
	0, 0
};

static unsigned char copy_104[] = {
	0, 0
};

static unsigned char copy_105[] = {
	0, 0
};

static unsigned char copy_106[] = {
	0, 0
};

static unsigned char copy_107[] = {
	0, 0
};

static unsigned char copy_108[] = {
	0, 0
};

static unsigned char copy_109[] = {
	0, 0
};

static unsigned char copy_110[] = {
	0, 0
};

static unsigned char copy_111[] = {
	0, 0
};

static unsigned char copy_112[] = {
	0, 0
};

static unsigned char copy_114[] = {
	0, 0
};

static unsigned char copy_116[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_117[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_118[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_119[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_120[] = {
	0, 0
};

static unsigned char copy_122[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6, 0, 7, 
	0, 8
};

static unsigned char copy_123[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_124[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_126[] = {
	0, 0
};

static unsigned char copy_128[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_129[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_130[] = {
	0, 0
};

static unsigned char copy_131[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_132[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_133[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_134[] = {
	0, 0, 0, 1
};

static unsigned char copy_136[] = {
	0, 0, 0, 1
};

static unsigned char copy_138[] = {
	0, 0
};

static unsigned char copy_140[] = {
	0, 0, 0, 1
};

static unsigned char copy_142[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_143[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_144[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_146[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_147[] = {
	0, 0
};

static unsigned char copy_148[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_149[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_150[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_151[] = {
	0, 0, 0, 1
};

static unsigned char copy_152[] = {
	0, 0, 0, 1
};

static unsigned char copy_153[] = {
	0, 0
};

static unsigned char copy_154[] = {
	0, 0
};

static unsigned char copy_155[] = {
	0, 0
};

static unsigned char copy_156[] = {
	0, 0
};

static unsigned char copy_157[] = {
	0, 0
};

static unsigned char copy_158[] = {
	0, 0, 0, 1
};

static unsigned char copy_159[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 6
};

static unsigned char copy_160[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_161[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_162[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_163[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_164[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_165[] = {
	0, 0, 0, 1
};

static unsigned char copy_166[] = {
	0, 0, 0, 1
};

static unsigned char copy_167[] = {
	0, 0
};

static unsigned char copy_168[] = {
	0, 0
};

static unsigned char copy_169[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_170[] = {
	0, 0
};

static unsigned char copy_171[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_172[] = {
	0, 0, 0, 1
};

static unsigned char copy_173[] = {
	0, 0
};

static unsigned char copy_174[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_175[] = {
	0, 0, 0, 1
};

static unsigned char copy_177[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_178[] = {
	0, 0
};

static unsigned char copy_179[] = {
	0, 0
};

static unsigned char copy_181[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_182[] = {
	0, 0, 0, 1
};

static unsigned char copy_183[] = {
	0, 0, 0, 1
};

static unsigned char copy_184[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_185[] = {
	0, 0
};

static unsigned char copy_186[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_187[] = {
	0, 0, 0, 1
};

static unsigned char copy_189[] = {
	0, 0, 0, 1
};

static unsigned char copy_190[] = {
	0, 0, 0, 1
};

static unsigned char copy_192[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_193[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_194[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_195[] = {
	0, 0, 0, 1
};

static unsigned char copy_196[] = {
	0, 0
};

static unsigned char copy_197[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_198[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_199[] = {
	0, 0
};

static unsigned char copy_200[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_201[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_202[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_203[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_204[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_205[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_206[] = {
	0, 0
};

static unsigned char copy_207[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_208[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_209[] = {
	0, 0
};

static unsigned char copy_210[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_211[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_212[] = {
	0, 0
};

static unsigned char copy_213[] = {
	0, 0, 0, 1
};

static unsigned char copy_214[] = {
	0, 0, 0, 1
};

static unsigned char copy_215[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_216[] = {
	0, 0, 0, 1
};

static unsigned char copy_217[] = {
	0, 0, 0, 1
};

static unsigned char copy_218[] = {
	0, 0, 0, 1
};

static unsigned char copy_219[] = {
	0, 0
};

static unsigned char copy_220[] = {
	0, 0
};

static unsigned char copy_221[] = {
	0, 0
};

static unsigned char copy_223[] = {
	0, 0
};

static unsigned char copy_224[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_225[] = {
	0, 0
};

static unsigned char copy_226[] = {
	0, 0
};

static unsigned char copy_227[] = {
	0, 0
};

static unsigned char copy_228[] = {
	0, 0
};

static unsigned char copy_229[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_230[] = {
	0, 0
};

static unsigned char copy_231[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_232[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_233[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_234[] = {
	0, 0
};

static unsigned char copy_235[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_236[] = {
	0, 0
};

static unsigned char copy_237[] = {
	0, 0
};

static unsigned char copy_238[] = {
	0, 0
};

static unsigned char copy_239[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_240[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_241[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_242[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_243[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_244[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_246[] = {
	0, 0
};

static unsigned char copy_247[] = {
	0, 0
};

static unsigned char copy_248[] = {
	0, 0
};

static unsigned char copy_249[] = {
	0, 0, 0, 1
};

static unsigned char copy_250[] = {
	0, 0, 0, 1
};

static unsigned char copy_252[] = {
	0, 0, 0, 1
};

static unsigned char copy_254[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_256[] = {
	0, 0
};

static unsigned char copy_257[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_258[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_259[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_260[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_261[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_262[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_263[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_264[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_265[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_266[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_267[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_268[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_269[] = {
	0, 0, 0, 1
};

static unsigned char copy_271[] = {
	0, 0
};

static unsigned char copy_272[] = {
	0, 0
};

static unsigned char copy_273[] = {
	0, 0
};

static unsigned char copy_274[] = {
	0, 0
};

static unsigned char copy_275[] = {
	0, 0
};

static unsigned char copy_277[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_278[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_279[] = {
	0, 0, 0, 1
};

static unsigned char copy_280[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_281[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_282[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_283[] = {
	0, 0
};

static unsigned char copy_284[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_285[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_286[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_287[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_288[] = {
	0, 0, 0, 1
};

static unsigned char copy_289[] = {
	0, 0
};

static unsigned char copy_290[] = {
	0, 0
};

static unsigned char copy_291[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_296[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_297[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_298[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_299[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_300[] = {
	0, 0, 0, 1
};

static unsigned char copy_301[] = {
	0, 0
};

static unsigned char copy_302[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_303[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_304[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_305[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_306[] = {
	0, 0, 0, 1
};

static unsigned char copy_307[] = {
	0, 0
};

static unsigned char copy_308[] = {
	0, 0
};

static unsigned char copy_309[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_310[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_311[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_312[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_313[] = {
	0, 0, 0, 1
};

static unsigned char copy_314[] = {
	0, 0
};

static unsigned char copy_315[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_316[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_317[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_318[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_319[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_320[] = {
	0, 0, 0, 1
};

static unsigned char copy_321[] = {
	0, 0
};

static unsigned char copy_322[] = {
	0, 0
};

static unsigned char copy_323[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_324[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_325[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_326[] = {
	0, 0, 0, 1
};

static unsigned char copy_327[] = {
	0, 0
};

static unsigned char copy_328[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_329[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_330[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_331[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_332[] = {
	0, 0, 0, 1
};

static unsigned char copy_333[] = {
	0, 0
};

static unsigned char copy_334[] = {
	0, 0
};

static unsigned char copy_335[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_336[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_337[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_338[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_340[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_341[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_342[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_343[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_344[] = {
	0, 0
};

static unsigned char copy_345[] = {
	0, 0
};

static unsigned char copy_347[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_348[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_349[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_350[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_351[] = {
	0, 0
};

static unsigned char copy_352[] = {
	0, 0, 0, 1
};

static unsigned char copy_353[] = {
	0, 0, 0, 1
};

static unsigned char copy_354[] = {
	0, 0, 0, 1
};

static unsigned char copy_355[] = {
	0, 0, 0, 1
};

static unsigned char copy_356[] = {
	0, 0, 0, 1, 0, 2, 0, 3
};

static unsigned char copy_357[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_358[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4
};

static unsigned char copy_359[] = {
	0, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5
};

static unsigned char copy_360[] = {
	0, 0
};

static unsigned char copy_361[] = {
	0, 0, 0, 1
};

static unsigned char copy_362[] = {
	0, 0
};

static unsigned char copy_363[] = {
	0, 0
};

static unsigned char copy_364[] = {
	0, 0
};

static unsigned char copy_365[] = {
	0, 0
};

static unsigned char copy_366[] = {
	0, 0
};

static unsigned char copy_367[] = {
	0, 0
};

static unsigned char copy_368[] = {
	0, 0
};

static unsigned char copy_369[] = {
	0, 0
};

static unsigned char copy_370[] = {
	0, 0
};

static unsigned char copy_371[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_372[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_373[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_374[] = {
	0, 0, 0, 1, 0, 2
};

static unsigned char copy_375[] = {
	0, 0, 0, 1
};

static unsigned char copy_377[] = {
	0, 0
};

static unsigned char copy_378[] = {
	0, 0, 0, 1, 0, 2
};

static code_t parser_rootCode[] = {
	255, 8, 7, 0, 255, 7, 6, 0, 
	255, 62, 5, 0, 85, 147, 6, 0, 
	255, 52, 5, 0, 39, 255, 255, 37, 
	255, 255, 2, 3, 0, 0, 0, 0, 
	0, 0, 0, 180, 146, 254, 255, 241, 
	2, 0, 0, 0, 145, 254, 255, 144, 
	162, 135, 162, 31, 91, 1, 0, 226, 
	91, 0, 0, 242, 39, 253, 255, 29, 
	241, 3, 0, 0, 0, 87, 149, 2, 
	0, 1, 1, 0, 0, 0, 0, 0, 
	0, 0, 87, 149, 3, 0, 5, 87, 
	149, 4, 0, 37, 253, 255, 22, 47, 
	0, 232, 2, 0, 98, 253, 255, 32, 
	0, 0, 2, 0, 140, 2, 0, 21, 
	0, 2, 0, 0, 0, 0, 0, 0, 
	0, 0, 29, 2, 0, 0, 0, 0, 
	0, 0, 0, 0, 29, 120, 233, 2, 
	0, 212, 184, 3, 0, 21, 209, 255, 
	37, 253, 255, 87, 251, 0, 0, 85, 
	204, 87, 251, 1, 0, 255, 10
};

static struct lang_el_info parser_lelInfo[] = {
/*    0 */ { "__UNUSED",  "__UNUSED", 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0 },
/*    1 */ { "ptr",  "ptr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*    2 */ { "str",  "str", 0, 0, 0, 0, -1, 302, 0, 0, 0, -1, 0, 0 },
/*    3 */ { "il",  "il", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*    4 */ { "DEF",  "DEF", 0, 0, 0, 0, -1, 5, 0, 0, 0, -1, 0, 0 },
/*    5 */ { "REDEF",  "REDEF", 0, 0, 0, 0, -1, 6, 0, 0, 0, -1, 0, 0 },
/*    6 */ { "LEX",  "LEX", 0, 0, 0, 0, -1, 7, 0, 0, 0, -1, 0, 0 },
/*    7 */ { "END",  "END", 0, 0, 0, 0, -1, 8, 0, 0, 0, -1, 0, 0 },
/*    8 */ { "TOKEN",  "TOKEN", 0, 0, 0, 0, -1, 9, 0, 0, 0, -1, 0, 0 },
/*    9 */ { "RL",  "RL", 0, 0, 0, 0, -1, 10, 0, 0, 0, -1, 0, 0 },
/*   10 */ { "IGNORE",  "IGNORE", 0, 0, 0, 0, -1, 11, 0, 0, 0, -1, 0, 0 },
/*   11 */ { "PRINT",  "PRINT", 0, 0, 0, 0, -1, 12, 0, 0, 0, -1, 0, 0 },
/*   12 */ { "PRINTS",  "PRINTS", 0, 0, 0, 0, -1, 13, 0, 0, 0, -1, 0, 0 },
/*   13 */ { "PARSE",  "PARSE", 0, 0, 0, 0, -1, 14, 0, 0, 0, -1, 0, 0 },
/*   14 */ { "REDUCE",  "REDUCE", 0, 0, 0, 0, -1, 15, 0, 0, 0, -1, 0, 0 },
/*   15 */ { "READ_REDUCE",  "READ_REDUCE", 0, 0, 0, 0, -1, 16, 0, 0, 0, -1, 0, 0 },
/*   16 */ { "PARSE_TREE",  "PARSE_TREE", 0, 0, 0, 0, -1, 17, 0, 0, 0, -1, 0, 0 },
/*   17 */ { "PARSE_STOP",  "PARSE_STOP", 0, 0, 0, 0, -1, 18, 0, 0, 0, -1, 0, 0 },
/*   18 */ { "CONS",  "CONS", 0, 0, 0, 0, -1, 19, 0, 0, 0, -1, 0, 0 },
/*   19 */ { "MATCH",  "MATCH", 0, 0, 0, 0, -1, 20, 0, 0, 0, -1, 0, 0 },
/*   20 */ { "REQUIRE",  "REQUIRE", 0, 0, 0, 0, -1, 21, 0, 0, 0, -1, 0, 0 },
/*   21 */ { "SEND",  "SEND", 0, 0, 0, 0, -1, 22, 0, 0, 0, -1, 0, 0 },
/*   22 */ { "SEND_TREE",  "SEND_TREE", 0, 0, 0, 0, -1, 23, 0, 0, 0, -1, 0, 0 },
/*   23 */ { "NAMESPACE",  "NAMESPACE", 0, 0, 0, 0, -1, 24, 0, 0, 0, -1, 0, 0 },
/*   24 */ { "REDUCTION",  "REDUCTION", 0, 0, 0, 0, -1, 25, 0, 0, 0, -1, 0, 0 },
/*   25 */ { "FOR",  "FOR", 0, 0, 0, 0, -1, 26, 0, 0, 0, -1, 0, 0 },
/*   26 */ { "IF",  "IF", 0, 0, 0, 0, -1, 27, 0, 0, 0, -1, 0, 0 },
/*   27 */ { "YIELD",  "YIELD", 0, 0, 0, 0, -1, 28, 0, 0, 0, -1, 0, 0 },
/*   28 */ { "WHILE",  "WHILE", 0, 0, 0, 0, -1, 29, 0, 0, 0, -1, 0, 0 },
/*   29 */ { "ELSIF",  "ELSIF", 0, 0, 0, 0, -1, 30, 0, 0, 0, -1, 0, 0 },
/*   30 */ { "ELSE",  "ELSE", 0, 0, 0, 0, -1, 31, 0, 0, 0, -1, 0, 0 },
/*   31 */ { "IN",  "IN", 0, 0, 0, 0, -1, 32, 0, 0, 0, -1, 0, 0 },
/*   32 */ { "PARSER",  "PARSER", 0, 0, 0, 0, -1, 33, 0, 0, 0, -1, 0, 0 },
/*   33 */ { "LIST",  "LIST", 0, 0, 0, 0, -1, 34, 0, 0, 0, -1, 0, 0 },
/*   34 */ { "LIST_EL",  "LIST_EL", 0, 0, 0, 0, -1, 35, 0, 0, 0, -1, 0, 0 },
/*   35 */ { "MAP",  "MAP", 0, 0, 0, 0, -1, 36, 0, 0, 0, -1, 0, 0 },
/*   36 */ { "MAP_EL",  "MAP_EL", 0, 0, 0, 0, -1, 37, 0, 0, 0, -1, 0, 0 },
/*   37 */ { "PTR",  "PTR", 0, 0, 0, 0, -1, 38, 0, 0, 0, -1, 0, 0 },
/*   38 */ { "ITER",  "ITER", 0, 0, 0, 0, -1, 39, 0, 0, 0, -1, 0, 0 },
/*   39 */ { "REF",  "REF", 0, 0, 0, 0, -1, 40, 0, 0, 0, -1, 0, 0 },
/*   40 */ { "EXPORT",  "EXPORT", 0, 0, 0, 0, -1, 41, 0, 0, 0, -1, 0, 0 },
/*   41 */ { "RETURN",  "RETURN", 0, 0, 0, 0, -1, 42, 0, 0, 0, -1, 0, 0 },
/*   42 */ { "BREAK",  "BREAK", 0, 0, 0, 0, -1, 43, 0, 0, 0, -1, 0, 0 },
/*   43 */ { "REJECT",  "REJECT", 0, 0, 0, 0, -1, 44, 0, 0, 0, -1, 0, 0 },
/*   44 */ { "REDUCEFIRST",  "REDUCEFIRST", 0, 0, 0, 0, -1, 45, 0, 0, 0, -1, 0, 0 },
/*   45 */ { "ALIAS",  "ALIAS", 0, 0, 0, 0, -1, 46, 0, 0, 0, -1, 0, 0 },
/*   46 */ { "COMMIT",  "COMMIT", 0, 0, 0, 0, -1, 47, 0, 0, 0, -1, 0, 0 },
/*   47 */ { "NEW",  "NEW", 0, 0, 0, 0, -1, 48, 0, 0, 0, -1, 0, 0 },
/*   48 */ { "PREEOF",  "PREEOF", 0, 0, 0, 0, -1, 49, 0, 0, 0, -1, 0, 0 },
/*   49 */ { "GLOBAL",  "GLOBAL", 0, 0, 0, 0, -1, 50, 0, 0, 0, -1, 0, 0 },
/*   50 */ { "EOS",  "EOS", 0, 0, 0, 0, -1, 51, 0, 0, 0, -1, 0, 0 },
/*   51 */ { "CAST",  "CAST", 0, 0, 0, 0, -1, 52, 0, 0, 0, -1, 0, 0 },
/*   52 */ { "SWITCH",  "SWITCH", 0, 0, 0, 0, -1, 53, 0, 0, 0, -1, 0, 0 },
/*   53 */ { "CASE",  "CASE", 0, 0, 0, 0, -1, 54, 0, 0, 0, -1, 0, 0 },
/*   54 */ { "DEFAULT",  "DEFAULT", 0, 0, 0, 0, -1, 55, 0, 0, 0, -1, 0, 0 },
/*   55 */ { "INT",  "INT", 0, 0, 0, 0, -1, 56, 0, 0, 0, -1, 0, 0 },
/*   56 */ { "BOOL",  "BOOL", 0, 0, 0, 0, -1, 57, 0, 0, 0, -1, 0, 0 },
/*   57 */ { "VOID",  "VOID", 0, 0, 0, 0, -1, 58, 0, 0, 0, -1, 0, 0 },
/*   58 */ { "MAKE_TOKEN",  "MAKE_TOKEN", 0, 0, 0, 0, -1, 59, 0, 0, 0, -1, 0, 0 },
/*   59 */ { "MAKE_TREE",  "MAKE_TREE", 0, 0, 0, 0, -1, 60, 0, 0, 0, -1, 0, 0 },
/*   60 */ { "TYPEID",  "TYPEID", 0, 0, 0, 0, -1, 61, 0, 0, 0, -1, 0, 0 },
/*   61 */ { "LITERAL",  "LITERAL", 0, 0, 0, 0, -1, 62, 0, 0, 0, -1, 0, 0 },
/*   62 */ { "CONTEXT",  "CONTEXT", 0, 0, 0, 0, -1, 63, 0, 0, 0, -1, 0, 0 },
/*   63 */ { "STRUCT",  "STRUCT", 0, 0, 0, 0, -1, 64, 0, 0, 0, -1, 0, 0 },
/*   64 */ { "NI",  "NI", 0, 0, 0, 0, -1, 65, 0, 0, 0, -1, 0, 0 },
/*   65 */ { "NIL",  "NIL", 0, 0, 0, 0, -1, 66, 0, 0, 0, -1, 0, 0 },
/*   66 */ { "TRUE",  "TRUE", 0, 0, 0, 0, -1, 67, 0, 0, 0, -1, 0, 0 },
/*   67 */ { "FALSE",  "FALSE", 0, 0, 0, 0, -1, 68, 0, 0, 0, -1, 0, 0 },
/*   68 */ { "LEFT",  "LEFT", 0, 0, 0, 0, -1, 69, 0, 0, 0, -1, 0, 0 },
/*   69 */ { "RIGHT",  "RIGHT", 0, 0, 0, 0, -1, 70, 0, 0, 0, -1, 0, 0 },
/*   70 */ { "NONASSOC",  "NONASSOC", 0, 0, 0, 0, -1, 71, 0, 0, 0, -1, 0, 0 },
/*   71 */ { "INCLUDE",  "INCLUDE", 0, 0, 0, 0, -1, 72, 0, 0, 0, -1, 0, 0 },
/*   72 */ { "id",  "id", 0, 0, 0, 0, -1, 73, 0, 0, 0, -1, 0, 0 },
/*   73 */ { "number",  "number", 0, 0, 0, 0, -1, 74, 0, 0, 0, -1, 0, 0 },
/*   74 */ { "backtick_lit",  "backtick_lit", 0, 0, 0, 0, -1, 75, 0, 0, 0, -1, 0, 0 },
/*   75 */ { "DQ",  "DQ", 0, 0, 0, 0, -1, 76, 0, 0, 0, -1, 0, 0 },
/*   76 */ { "SQ",  "SQ", 0, 0, 0, 0, -1, 77, 0, 0, 0, -1, 0, 0 },
/*   77 */ { "TILDE",  "TILDE", 0, 0, 0, 0, -1, 78, 0, 0, 0, -1, 0, 0 },
/*   78 */ { "SQOPEN",  "SQOPEN", 0, 0, 0, 0, -1, 79, 0, 0, 0, -1, 0, 0 },
/*   79 */ { "SQCLOSE",  "SQCLOSE", 0, 0, 0, 0, -1, 80, 0, 0, 0, -1, 0, 0 },
/*   80 */ { "BAR",  "BAR", 0, 0, 0, 0, -1, 81, 0, 0, 0, -1, 0, 0 },
/*   81 */ { "FSLASH",  "FSLASH", 0, 0, 0, 0, -1, 82, 0, 0, 0, -1, 0, 0 },
/*   82 */ { "COLON",  "COLON", 0, 0, 0, 0, -1, 83, 0, 0, 0, -1, 0, 0 },
/*   83 */ { "DOUBLE_COLON",  "DOUBLE_COLON", 0, 0, 0, 0, -1, 84, 0, 0, 0, -1, 0, 0 },
/*   84 */ { "DOT",  "DOT", 0, 0, 0, 0, -1, 85, 0, 0, 0, -1, 0, 0 },
/*   85 */ { "ARROW",  "ARROW", 0, 0, 0, 0, -1, 86, 0, 0, 0, -1, 0, 0 },
/*   86 */ { "POPEN",  "POPEN", 0, 0, 0, 0, -1, 87, 0, 0, 0, -1, 0, 0 },
/*   87 */ { "PCLOSE",  "PCLOSE", 0, 0, 0, 0, -1, 88, 0, 0, 0, -1, 0, 0 },
/*   88 */ { "COPEN",  "COPEN", 0, 0, 0, 0, -1, 89, 0, 0, 0, -1, 0, 0 },
/*   89 */ { "CCLOSE",  "CCLOSE", 0, 0, 0, 0, -1, 90, 0, 0, 0, -1, 0, 0 },
/*   90 */ { "STAR",  "STAR", 0, 0, 0, 0, -1, 91, 0, 0, 0, -1, 0, 0 },
/*   91 */ { "QUESTION",  "QUESTION", 0, 0, 0, 0, -1, 92, 0, 0, 0, -1, 0, 0 },
/*   92 */ { "EQUALS",  "EQUALS", 0, 0, 0, 0, -1, 93, 0, 0, 0, -1, 0, 0 },
/*   93 */ { "EQ_EQ",  "EQ_EQ", 0, 0, 0, 0, -1, 94, 0, 0, 0, -1, 0, 0 },
/*   94 */ { "BANG_EQ",  "BANG_EQ", 0, 0, 0, 0, -1, 95, 0, 0, 0, -1, 0, 0 },
/*   95 */ { "COMMA",  "COMMA", 0, 0, 0, 0, -1, 96, 0, 0, 0, -1, 0, 0 },
/*   96 */ { "LT",  "LT", 0, 0, 0, 0, -1, 97, 0, 0, 0, -1, 0, 0 },
/*   97 */ { "GT",  "GT", 0, 0, 0, 0, -1, 98, 0, 0, 0, -1, 0, 0 },
/*   98 */ { "LT_EQ",  "LT_EQ", 0, 0, 0, 0, -1, 99, 0, 0, 0, -1, 0, 0 },
/*   99 */ { "GT_EQ",  "GT_EQ", 0, 0, 0, 0, -1, 100, 0, 0, 0, -1, 0, 0 },
/*  100 */ { "BANG",  "BANG", 0, 0, 0, 0, -1, 101, 0, 0, 0, -1, 0, 0 },
/*  101 */ { "DOLLAR",  "DOLLAR", 0, 0, 0, 0, -1, 102, 0, 0, 0, -1, 0, 0 },
/*  102 */ { "CARET",  "CARET", 0, 0, 0, 0, -1, 103, 0, 0, 0, -1, 0, 0 },
/*  103 */ { "AT",  "AT", 0, 0, 0, 0, -1, 104, 0, 0, 0, -1, 0, 0 },
/*  104 */ { "PERCENT",  "PERCENT", 0, 0, 0, 0, -1, 105, 0, 0, 0, -1, 0, 0 },
/*  105 */ { "PLUS",  "PLUS", 0, 0, 0, 0, -1, 106, 0, 0, 0, -1, 0, 0 },
/*  106 */ { "MINUS",  "MINUS", 0, 0, 0, 0, -1, 107, 0, 0, 0, -1, 0, 0 },
/*  107 */ { "AMP_AMP",  "AMP_AMP", 0, 0, 0, 0, -1, 108, 0, 0, 0, -1, 0, 0 },
/*  108 */ { "BAR_BAR",  "BAR_BAR", 0, 0, 0, 0, -1, 109, 0, 0, 0, -1, 0, 0 },
/*  109 */ { "DOT_DOT_DOT",  "DOT_DOT_DOT", 0, 0, 0, 0, -1, 110, 0, 0, 0, -1, 0, 0 },
/*  110 */ { "LT_LT",  "LT_LT", 0, 0, 0, 0, -1, 111, 0, 0, 0, -1, 0, 0 },
/*  111 */ { "LARROW",  "LARROW", 0, 0, 0, 0, -1, 112, 0, 0, 0, -1, 0, 0 },
/*  112 */ { "_ignore_00d9",  "_ignore_00d9", 0, 0, 0, 1, -1, 113, 0, 0, 0, -1, 0, 0 },
/*  113 */ { "_ignore_00db",  "_ignore_00db", 0, 0, 0, 1, -1, 114, 0, 0, 0, -1, 0, 0 },
/*  114 */ { "LIT_DQ",  "LIT_DQ", 0, 0, 0, 0, -1, 115, 0, 0, 0, -1, 0, 0 },
/*  115 */ { "LIT_DQ_NL",  "LIT_DQ_NL", 0, 0, 0, 0, -1, 116, 0, 0, 0, -1, 0, 0 },
/*  116 */ { "LIT_SQOPEN",  "LIT_SQOPEN", 0, 0, 0, 0, -1, 117, 0, 0, 0, -1, 0, 0 },
/*  117 */ { "LIT_SQCLOSE",  "LIT_SQCLOSE", 0, 0, 0, 0, -1, 118, 0, 0, 0, -1, 0, 0 },
/*  118 */ { "lit_dq_data",  "lit_dq_data", 0, 0, 0, 0, -1, 119, 0, 0, 0, -1, 0, 0 },
/*  119 */ { "CONS_SQ",  "CONS_SQ", 0, 0, 0, 0, -1, 120, 0, 0, 0, -1, 0, 0 },
/*  120 */ { "CONS_SQ_NL",  "CONS_SQ_NL", 0, 0, 0, 0, -1, 121, 0, 0, 0, -1, 0, 0 },
/*  121 */ { "sq_cons_data",  "sq_cons_data", 0, 0, 0, 0, -1, 122, 0, 0, 0, -1, 0, 0 },
/*  122 */ { "TILDE_NL",  "TILDE_NL", 0, 0, 0, 0, -1, 123, 0, 0, 0, -1, 0, 0 },
/*  123 */ { "tilde_data",  "tilde_data", 0, 0, 0, 0, -1, 124, 0, 0, 0, -1, 0, 0 },
/*  124 */ { "lex_id",  "lex_id", 0, 0, 0, 0, -1, 125, 0, 0, 0, -1, 0, 0 },
/*  125 */ { "lex_uint",  "lex_uint", 0, 0, 0, 0, -1, 126, 0, 0, 0, -1, 0, 0 },
/*  126 */ { "lex_hex",  "lex_hex", 0, 0, 0, 0, -1, 127, 0, 0, 0, -1, 0, 0 },
/*  127 */ { "lex_lit",  "lex_lit", 0, 0, 0, 0, -1, 128, 0, 0, 0, -1, 0, 0 },
/*  128 */ { "LEX_DOT",  "LEX_DOT", 0, 0, 0, 0, -1, 129, 0, 0, 0, -1, 0, 0 },
/*  129 */ { "LEX_BAR",  "LEX_BAR", 0, 0, 0, 0, -1, 130, 0, 0, 0, -1, 0, 0 },
/*  130 */ { "LEX_AMP",  "LEX_AMP", 0, 0, 0, 0, -1, 131, 0, 0, 0, -1, 0, 0 },
/*  131 */ { "LEX_DASH",  "LEX_DASH", 0, 0, 0, 0, -1, 132, 0, 0, 0, -1, 0, 0 },
/*  132 */ { "LEX_POPEN",  "LEX_POPEN", 0, 0, 0, 0, -1, 133, 0, 0, 0, -1, 0, 0 },
/*  133 */ { "LEX_PCLOSE",  "LEX_PCLOSE", 0, 0, 0, 0, -1, 134, 0, 0, 0, -1, 0, 0 },
/*  134 */ { "LEX_STAR",  "LEX_STAR", 0, 0, 0, 0, -1, 135, 0, 0, 0, -1, 0, 0 },
/*  135 */ { "LEX_STARSTAR",  "LEX_STARSTAR", 0, 0, 0, 0, -1, 136, 0, 0, 0, -1, 0, 0 },
/*  136 */ { "LEX_QUESTION",  "LEX_QUESTION", 0, 0, 0, 0, -1, 137, 0, 0, 0, -1, 0, 0 },
/*  137 */ { "LEX_PLUS",  "LEX_PLUS", 0, 0, 0, 0, -1, 138, 0, 0, 0, -1, 0, 0 },
/*  138 */ { "LEX_CARET",  "LEX_CARET", 0, 0, 0, 0, -1, 139, 0, 0, 0, -1, 0, 0 },
/*  139 */ { "LEX_DOTDOT",  "LEX_DOTDOT", 0, 0, 0, 0, -1, 140, 0, 0, 0, -1, 0, 0 },
/*  140 */ { "LEX_SQOPEN_POS",  "LEX_SQOPEN_POS", 0, 0, 0, 0, -1, 141, 0, 0, 0, -1, 0, 0 },
/*  141 */ { "LEX_SQOPEN_NEG",  "LEX_SQOPEN_NEG", 0, 0, 0, 0, -1, 142, 0, 0, 0, -1, 0, 0 },
/*  142 */ { "LEX_FSLASH",  "LEX_FSLASH", 0, 0, 0, 0, -1, 143, 0, 0, 0, -1, 0, 0 },
/*  143 */ { "LEX_DASHDASH",  "LEX_DASHDASH", 0, 0, 0, 0, -1, 144, 0, 0, 0, -1, 0, 0 },
/*  144 */ { "LEX_COLON_GT",  "LEX_COLON_GT", 0, 0, 0, 0, -1, 145, 0, 0, 0, -1, 0, 0 },
/*  145 */ { "LEX_COLON_GTGT",  "LEX_COLON_GTGT", 0, 0, 0, 0, -1, 146, 0, 0, 0, -1, 0, 0 },
/*  146 */ { "LEX_LT_COLON",  "LEX_LT_COLON", 0, 0, 0, 0, -1, 147, 0, 0, 0, -1, 0, 0 },
/*  147 */ { "_ignore_011f",  "_ignore_011f", 0, 0, 0, 1, -1, 148, 0, 0, 0, -1, 0, 0 },
/*  148 */ { "_ignore_0121",  "_ignore_0121", 0, 0, 0, 1, -1, 149, 0, 0, 0, -1, 0, 0 },
/*  149 */ { "RE_DASH",  "RE_DASH", 0, 0, 0, 0, -1, 150, 0, 0, 0, -1, 0, 0 },
/*  150 */ { "RE_CHAR",  "RE_CHAR", 0, 0, 0, 0, -1, 151, 0, 0, 0, -1, 0, 0 },
/*  151 */ { "RE_SQCLOSE",  "RE_SQCLOSE", 0, 0, 0, 0, -1, 152, 0, 0, 0, -1, 0, 0 },
/*  152 */ { "RED_OPEN",  "RED_OPEN", 0, 0, 0, 0, -1, 183, 0, 0, 0, -1, 0, 0 },
/*  153 */ { "RED_CLOSE",  "RED_CLOSE", 0, 0, 0, 0, -1, 184, 0, 0, 0, -1, 0, 0 },
/*  154 */ { "red_id",  "red_id", 0, 0, 0, 0, -1, 185, 0, 0, 0, -1, 0, 0 },
/*  155 */ { "red_comment",  "red_comment", 0, 0, 0, 0, -1, 186, 0, 0, 0, -1, 0, 0 },
/*  156 */ { "red_ws",  "red_ws", 0, 0, 0, 0, -1, 187, 0, 0, 0, -1, 0, 0 },
/*  157 */ { "red_lit",  "red_lit", 0, 0, 0, 0, -1, 188, 0, 0, 0, -1, 0, 0 },
/*  158 */ { "RED_LHS",  "RED_LHS", 0, 0, 0, 0, -1, 189, 0, 0, 0, -1, 0, 0 },
/*  159 */ { "RED_RHS_REF",  "RED_RHS_REF", 0, 0, 0, 0, -1, 190, 0, 0, 0, -1, 0, 0 },
/*  160 */ { "RED_RHS_LOC",  "RED_RHS_LOC", 0, 0, 0, 0, -1, 191, 0, 0, 0, -1, 0, 0 },
/*  161 */ { "RED_TREE_REF",  "RED_TREE_REF", 0, 0, 0, 0, -1, 192, 0, 0, 0, -1, 0, 0 },
/*  162 */ { "RED_RHS_NREF",  "RED_RHS_NREF", 0, 0, 0, 0, -1, 193, 0, 0, 0, -1, 0, 0 },
/*  163 */ { "RED_RHS_NLOC",  "RED_RHS_NLOC", 0, 0, 0, 0, -1, 194, 0, 0, 0, -1, 0, 0 },
/*  164 */ { "RED_TREE_NREF",  "RED_TREE_NREF", 0, 0, 0, 0, -1, 195, 0, 0, 0, -1, 0, 0 },
/*  165 */ { "red_any",  "red_any", 0, 0, 0, 0, -1, 196, 0, 0, 0, -1, 0, 0 },
/*  166 */ { "_ign_0x557181370fd0",  "_ign_0x557181370fd0", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  167 */ { "_ign_0x557181436040",  "_ign_0x557181436040", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  168 */ { "_ign_0x557181436280",  "_ign_0x557181436280", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  169 */ { "_ign_0x55718143a8b0",  "_ign_0x55718143a8b0", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  170 */ { "_ign_0x55718143b870",  "_ign_0x55718143b870", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  171 */ { "_ign_0x557181448ad0",  "_ign_0x557181448ad0", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  172 */ { "_ign_0x55718146a420",  "_ign_0x55718146a420", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  173 */ { "__0x5571814360e0_DEF_PAT_1",  "__0x5571814360e0_DEF_PAT_1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  174 */ { "__0x557181438c10_DEF_PAT_2",  "__0x557181438c10_DEF_PAT_2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  175 */ { "__0x55718143a950_DEF_PAT_3",  "__0x55718143a950_DEF_PAT_3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  176 */ { "__0x557181448b70_DEF_PAT_4",  "__0x557181448b70_DEF_PAT_4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  177 */ { "__0x55718146a4c0_DEF_PAT_5",  "__0x55718146a4c0_DEF_PAT_5", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  178 */ { "_T_any",  "_T_any", 0, 0, 0, 0, -1, 0, 0, 0, 803, -1, 0, 0 },
/*  179 */ { "_T_start",  "_T_start", 0, 0, 0, 0, -1, 153, 0, 0, 804, -1, 0, 0 },
/*  180 */ { "_T_root_item",  "_T_root_item", 0, 0, 0, 0, -1, 154, 0, 0, 805, -1, 0, 0 },
/*  181 */ { "_T__include",  "_T__include", 0, 0, 0, 0, -1, 155, 0, 0, 806, -1, 0, 0 },
/*  182 */ { "_T_precedence_def",  "_T_precedence_def", 0, 0, 0, 0, -1, 156, 0, 0, 807, -1, 0, 0 },
/*  183 */ { "_T_pred_type",  "_T_pred_type", 0, 0, 0, 0, -1, 157, 0, 0, 808, -1, 0, 0 },
/*  184 */ { "_T_pred_token_list",  "_T_pred_token_list", 0, 0, 0, 0, -1, 158, 0, 0, 809, -1, 0, 0 },
/*  185 */ { "_T_pred_token",  "_T_pred_token", 0, 0, 0, 0, -1, 159, 0, 0, 810, -1, 0, 0 },
/*  186 */ { "_T_pre_eof_def",  "_T_pre_eof_def", 0, 0, 0, 0, -1, 160, 0, 0, 811, -1, 0, 0 },
/*  187 */ { "_T_alias_def",  "_T_alias_def", 0, 0, 0, 0, -1, 161, 0, 0, 812, -1, 0, 0 },
/*  188 */ { "_T_struct_item",  "_T_struct_item", 0, 0, 0, 0, -1, 162, 0, 0, 813, -1, 0, 0 },
/*  189 */ { "_T_export_def",  "_T_export_def", 0, 0, 0, 0, -1, 163, 0, 0, 814, -1, 0, 0 },
/*  190 */ { "_T_global_def",  "_T_global_def", 0, 0, 0, 0, -1, 164, 0, 0, 815, -1, 0, 0 },
/*  191 */ { "_T_iter_def",  "_T_iter_def", 0, 0, 0, 0, -1, 165, 0, 0, 816, -1, 0, 0 },
/*  192 */ { "_T_reference_type_ref",  "_T_reference_type_ref", 0, 0, 0, 0, -1, 166, 0, 0, 817, -1, 0, 0 },
/*  193 */ { "_T_param_var_def_seq",  "_T_param_var_def_seq", 0, 0, 0, 0, -1, 167, 0, 0, 818, -1, 0, 0 },
/*  194 */ { "_T_param_var_def_list",  "_T_param_var_def_list", 0, 0, 0, 0, -1, 168, 0, 0, 819, -1, 0, 0 },
/*  195 */ { "_T_param_var_def",  "_T_param_var_def", 0, 0, 0, 0, -1, 169, 0, 0, 820, -1, 0, 0 },
/*  196 */ { "_T_opt_export",  "_T_opt_export", 0, 0, 0, 0, -1, 170, 0, 0, 821, -1, 0, 0 },
/*  197 */ { "_T_function_def",  "_T_function_def", 0, 0, 0, 0, -1, 171, 0, 0, 822, -1, 0, 0 },
/*  198 */ { "_T_in_host_def",  "_T_in_host_def", 0, 0, 0, 0, -1, 172, 0, 0, 823, -1, 0, 0 },
/*  199 */ { "_T_struct_var_def",  "_T_struct_var_def", 0, 0, 0, 0, -1, 173, 0, 0, 824, -1, 0, 0 },
/*  200 */ { "_T_struct_key",  "_T_struct_key", 0, 0, 0, 0, -1, 174, 0, 0, 825, -1, 0, 0 },
/*  201 */ { "_T_struct_def",  "_T_struct_def", 0, 0, 0, 0, -1, 175, 0, 0, 826, -1, 0, 0 },
/*  202 */ { "_T_literal_keyword",  "_T_literal_keyword", 0, 0, 0, 0, -1, 176, 0, 0, 827, -1, 0, 0 },
/*  203 */ { "_T_literal_def",  "_T_literal_def", 0, 0, 0, 0, -1, 177, 0, 0, 828, -1, 0, 0 },
/*  204 */ { "_T_literal_list",  "_T_literal_list", 0, 0, 0, 0, -1, 178, 0, 0, 829, -1, 0, 0 },
/*  205 */ { "_T_literal_item",  "_T_literal_item", 0, 0, 0, 0, -1, 179, 0, 0, 830, -1, 0, 0 },
/*  206 */ { "_T_no_ignore_left",  "_T_no_ignore_left", 0, 0, 0, 0, -1, 180, 0, 0, 831, -1, 0, 0 },
/*  207 */ { "_T_no_ignore_right",  "_T_no_ignore_right", 0, 0, 0, 0, -1, 181, 0, 0, 832, -1, 0, 0 },
/*  208 */ { "_T_reduction_def",  "_T_reduction_def", 0, 0, 0, 0, -1, 182, 0, 0, 833, -1, 0, 0 },
/*  209 */ { "_T_red_nonterm",  "_T_red_nonterm", 0, 0, 0, 0, -1, 197, 0, 0, 834, -1, 0, 0 },
/*  210 */ { "_T_red_action",  "_T_red_action", 0, 0, 0, 0, -1, 198, 0, 0, 835, -1, 0, 0 },
/*  211 */ { "_T_host_item",  "_T_host_item", 0, 0, 0, 0, -1, 199, 0, 0, 836, -1, 0, 0 },
/*  212 */ { "_T_reduction_item",  "_T_reduction_item", 0, 0, 0, 0, -1, 200, 0, 0, 837, -1, 0, 0 },
/*  213 */ { "_T_namespace_def",  "_T_namespace_def", 0, 0, 0, 0, -1, 201, 0, 0, 838, -1, 0, 0 },
/*  214 */ { "_T_namespace_item",  "_T_namespace_item", 0, 0, 0, 0, -1, 202, 0, 0, 839, -1, 0, 0 },
/*  215 */ { "_T_obj_var_list",  "_T_obj_var_list", 0, 0, 0, 0, -1, 203, 0, 0, 840, -1, 0, 0 },
/*  216 */ { "_T_opt_reduce_first",  "_T_opt_reduce_first", 0, 0, 0, 0, -1, 204, 0, 0, 841, -1, 0, 0 },
/*  217 */ { "_T_cfl_def",  "_T_cfl_def", 0, 0, 0, 0, -1, 205, 0, 0, 842, -1, 0, 0 },
/*  218 */ { "_T_cfl_redef",  "_T_cfl_redef", 0, 0, 0, 0, -1, 206, 0, 0, 843, -1, 0, 0 },
/*  219 */ { "_T_region_def",  "_T_region_def", 0, 0, 0, 0, -1, 207, 0, 0, 844, -1, 0, 0 },
/*  220 */ { "_T_rl_def",  "_T_rl_def", 0, 0, 0, 0, -1, 208, 0, 0, 845, -1, 0, 0 },
/*  221 */ { "_T_opt_lex_expr",  "_T_opt_lex_expr", 0, 0, 0, 0, -1, 209, 0, 0, 846, -1, 0, 0 },
/*  222 */ { "_T_token_def",  "_T_token_def", 0, 0, 0, 0, -1, 210, 0, 0, 847, -1, 0, 0 },
/*  223 */ { "_T_ic_def",  "_T_ic_def", 0, 0, 0, 0, -1, 211, 0, 0, 848, -1, 0, 0 },
/*  224 */ { "_T_opt_translate",  "_T_opt_translate", 0, 0, 0, 0, -1, 212, 0, 0, 849, -1, 0, 0 },
/*  225 */ { "_T_opt_id",  "_T_opt_id", 0, 0, 0, 0, -1, 213, 0, 0, 850, -1, 0, 0 },
/*  226 */ { "_T_ignore_def",  "_T_ignore_def", 0, 0, 0, 0, -1, 214, 0, 0, 851, -1, 0, 0 },
/*  227 */ { "_T_prod_sublist",  "_T_prod_sublist", 0, 0, 0, 0, -1, 215, 0, 0, 852, -1, 0, 0 },
/*  228 */ { "_T_prod_el",  "_T_prod_el", 0, 0, 0, 0, -1, 216, 0, 0, 853, -1, 0, 0 },
/*  229 */ { "_T_opt_prod_el_name",  "_T_opt_prod_el_name", 0, 0, 0, 0, -1, 217, 0, 0, 854, -1, 0, 0 },
/*  230 */ { "_T_prod_el_list",  "_T_prod_el_list", 0, 0, 0, 0, -1, 218, 0, 0, 855, -1, 0, 0 },
/*  231 */ { "_T_opt_commit",  "_T_opt_commit", 0, 0, 0, 0, -1, 219, 0, 0, 856, -1, 0, 0 },
/*  232 */ { "_T_opt_prod_name",  "_T_opt_prod_name", 0, 0, 0, 0, -1, 220, 0, 0, 857, -1, 0, 0 },
/*  233 */ { "_T_prod",  "_T_prod", 0, 0, 0, 0, -1, 221, 0, 0, 858, -1, 0, 0 },
/*  234 */ { "_T_opt_reduce",  "_T_opt_reduce", 0, 0, 0, 0, -1, 222, 0, 0, 859, -1, 0, 0 },
/*  235 */ { "_T_prod_list",  "_T_prod_list", 0, 0, 0, 0, -1, 223, 0, 0, 860, -1, 0, 0 },
/*  236 */ { "_T_case_clause",  "_T_case_clause", 0, 0, 0, 0, -1, 224, 0, 0, 861, -1, 0, 0 },
/*  237 */ { "_T_default_clause",  "_T_default_clause", 0, 0, 0, 0, -1, 225, 0, 0, 862, -1, 0, 0 },
/*  238 */ { "_T_case_clause_list",  "_T_case_clause_list", 0, 0, 0, 0, -1, 226, 0, 0, 863, -1, 0, 0 },
/*  239 */ { "_T_bare_tok",  "_T_bare_tok", 0, 0, 0, 0, -1, 227, 0, 0, 864, -1, 0, 0 },
/*  240 */ { "_T_statement",  "_T_statement", 0, 0, 0, 0, -1, 228, 0, 0, 865, -1, 0, 0 },
/*  241 */ { "_T_elsif_list",  "_T_elsif_list", 0, 0, 0, 0, -1, 229, 0, 0, 866, -1, 0, 0 },
/*  242 */ { "_T_elsif_clause",  "_T_elsif_clause", 0, 0, 0, 0, -1, 230, 0, 0, 867, -1, 0, 0 },
/*  243 */ { "_T_optional_else",  "_T_optional_else", 0, 0, 0, 0, -1, 231, 0, 0, 868, -1, 0, 0 },
/*  244 */ { "_T_call_arg_seq",  "_T_call_arg_seq", 0, 0, 0, 0, -1, 232, 0, 0, 869, -1, 0, 0 },
/*  245 */ { "_T_call_arg_list",  "_T_call_arg_list", 0, 0, 0, 0, -1, 233, 0, 0, 870, -1, 0, 0 },
/*  246 */ { "_T_iter_call",  "_T_iter_call", 0, 0, 0, 0, -1, 234, 0, 0, 871, -1, 0, 0 },
/*  247 */ { "_T_block_or_single",  "_T_block_or_single", 0, 0, 0, 0, -1, 235, 0, 0, 872, -1, 0, 0 },
/*  248 */ { "_T_require_pattern",  "_T_require_pattern", 0, 0, 0, 0, -1, 236, 0, 0, 873, -1, 0, 0 },
/*  249 */ { "_T_opt_require_stmt",  "_T_opt_require_stmt", 0, 0, 0, 0, -1, 237, 0, 0, 874, -1, 0, 0 },
/*  250 */ { "_T_lang_stmt_list",  "_T_lang_stmt_list", 0, 0, 0, 0, -1, 238, 0, 0, 875, -1, 0, 0 },
/*  251 */ { "_T_opt_def_init",  "_T_opt_def_init", 0, 0, 0, 0, -1, 239, 0, 0, 876, -1, 0, 0 },
/*  252 */ { "_T_var_def",  "_T_var_def", 0, 0, 0, 0, -1, 240, 0, 0, 877, -1, 0, 0 },
/*  253 */ { "_T_print_stmt",  "_T_print_stmt", 0, 0, 0, 0, -1, 241, 0, 0, 878, -1, 0, 0 },
/*  254 */ { "_T_expr_stmt",  "_T_expr_stmt", 0, 0, 0, 0, -1, 242, 0, 0, 879, -1, 0, 0 },
/*  255 */ { "_T_code_expr",  "_T_code_expr", 0, 0, 0, 0, -1, 243, 0, 0, 880, -1, 0, 0 },
/*  256 */ { "_T_code_relational",  "_T_code_relational", 0, 0, 0, 0, -1, 244, 0, 0, 881, -1, 0, 0 },
/*  257 */ { "_T_code_additive",  "_T_code_additive", 0, 0, 0, 0, -1, 245, 0, 0, 882, -1, 0, 0 },
/*  258 */ { "_T_code_multiplicitive",  "_T_code_multiplicitive", 0, 0, 0, 0, -1, 246, 0, 0, 883, -1, 0, 0 },
/*  259 */ { "_T_code_unary",  "_T_code_unary", 0, 0, 0, 0, -1, 247, 0, 0, 884, -1, 0, 0 },
/*  260 */ { "_T_opt_eos",  "_T_opt_eos", 0, 0, 0, 0, -1, 248, 0, 0, 885, -1, 0, 0 },
/*  261 */ { "_T_code_factor",  "_T_code_factor", 0, 0, 0, 0, -1, 249, 0, 0, 886, -1, 0, 0 },
/*  262 */ { "_T_type_ref",  "_T_type_ref", 0, 0, 0, 0, -1, 250, 0, 0, 887, -1, 0, 0 },
/*  263 */ { "_T_region_qual",  "_T_region_qual", 0, 0, 0, 0, -1, 251, 0, 0, 888, -1, 0, 0 },
/*  264 */ { "_T_opt_repeat",  "_T_opt_repeat", 0, 0, 0, 0, -1, 252, 0, 0, 889, -1, 0, 0 },
/*  265 */ { "_T_opt_capture",  "_T_opt_capture", 0, 0, 0, 0, -1, 253, 0, 0, 890, -1, 0, 0 },
/*  266 */ { "_T_opt_field_init",  "_T_opt_field_init", 0, 0, 0, 0, -1, 254, 0, 0, 891, -1, 0, 0 },
/*  267 */ { "_T_field_init",  "_T_field_init", 0, 0, 0, 0, -1, 255, 0, 0, 892, -1, 0, 0 },
/*  268 */ { "_T_stmt_or_factor",  "_T_stmt_or_factor", 0, 0, 0, 0, -1, 256, 0, 0, 893, -1, 0, 0 },
/*  269 */ { "_T_opt_label",  "_T_opt_label", 0, 0, 0, 0, -1, 257, 0, 0, 894, -1, 0, 0 },
/*  270 */ { "_T_dq_lit_term",  "_T_dq_lit_term", 0, 0, 0, 0, -1, 258, 0, 0, 895, -1, 0, 0 },
/*  271 */ { "_T_sq_lit_term",  "_T_sq_lit_term", 0, 0, 0, 0, -1, 259, 0, 0, 896, -1, 0, 0 },
/*  272 */ { "_T_opt_tilde_data",  "_T_opt_tilde_data", 0, 0, 0, 0, -1, 260, 0, 0, 897, -1, 0, 0 },
/*  273 */ { "_T_pattern_el_lel",  "_T_pattern_el_lel", 0, 0, 0, 0, -1, 261, 0, 0, 898, -1, 0, 0 },
/*  274 */ { "_T_pattern_el",  "_T_pattern_el", 0, 0, 0, 0, -1, 262, 0, 0, 899, -1, 0, 0 },
/*  275 */ { "_T_litpat_el",  "_T_litpat_el", 0, 0, 0, 0, -1, 263, 0, 0, 900, -1, 0, 0 },
/*  276 */ { "_T_pattern_top_el",  "_T_pattern_top_el", 0, 0, 0, 0, -1, 264, 0, 0, 901, -1, 0, 0 },
/*  277 */ { "_T_pattern_list",  "_T_pattern_list", 0, 0, 0, 0, -1, 265, 0, 0, 902, -1, 0, 0 },
/*  278 */ { "_T_pattern",  "_T_pattern", 0, 0, 0, 0, -1, 266, 0, 0, 903, -1, 0, 0 },
/*  279 */ { "_T_E1",  "_T_E1", 0, 0, 0, 0, -1, 267, 0, 0, 904, -1, 0, 0 },
/*  280 */ { "_T_E2",  "_T_E2", 0, 0, 0, 0, -1, 268, 0, 0, 905, -1, 0, 0 },
/*  281 */ { "_T_E3",  "_T_E3", 0, 0, 0, 0, -1, 269, 0, 0, 906, -1, 0, 0 },
/*  282 */ { "_T_E4",  "_T_E4", 0, 0, 0, 0, -1, 270, 0, 0, 907, -1, 0, 0 },
/*  283 */ { "_T_cons_el",  "_T_cons_el", 0, 0, 0, 0, -1, 271, 0, 0, 908, -1, 0, 0 },
/*  284 */ { "_T_lit_cons_el",  "_T_lit_cons_el", 0, 0, 0, 0, -1, 272, 0, 0, 909, -1, 0, 0 },
/*  285 */ { "_T_cons_top_el",  "_T_cons_top_el", 0, 0, 0, 0, -1, 273, 0, 0, 910, -1, 0, 0 },
/*  286 */ { "_T_cons_list",  "_T_cons_list", 0, 0, 0, 0, -1, 274, 0, 0, 911, -1, 0, 0 },
/*  287 */ { "_T_constructor",  "_T_constructor", 0, 0, 0, 0, -1, 275, 0, 0, 912, -1, 0, 0 },
/*  288 */ { "_T_accum_el",  "_T_accum_el", 0, 0, 0, 0, -1, 276, 0, 0, 913, -1, 0, 0 },
/*  289 */ { "_T_lit_accum_el",  "_T_lit_accum_el", 0, 0, 0, 0, -1, 277, 0, 0, 914, -1, 0, 0 },
/*  290 */ { "_T_accum_top_el",  "_T_accum_top_el", 0, 0, 0, 0, -1, 278, 0, 0, 915, -1, 0, 0 },
/*  291 */ { "_T_accum_list",  "_T_accum_list", 0, 0, 0, 0, -1, 279, 0, 0, 916, -1, 0, 0 },
/*  292 */ { "_T_accumulate",  "_T_accumulate", 0, 0, 0, 0, -1, 280, 0, 0, 917, -1, 0, 0 },
/*  293 */ { "_T_string_el",  "_T_string_el", 0, 0, 0, 0, -1, 281, 0, 0, 918, -1, 0, 0 },
/*  294 */ { "_T_lit_string_el",  "_T_lit_string_el", 0, 0, 0, 0, -1, 282, 0, 0, 919, -1, 0, 0 },
/*  295 */ { "_T_string_top_el",  "_T_string_top_el", 0, 0, 0, 0, -1, 283, 0, 0, 920, -1, 0, 0 },
/*  296 */ { "_T_string_list",  "_T_string_list", 0, 0, 0, 0, -1, 284, 0, 0, 921, -1, 0, 0 },
/*  297 */ { "_T_string",  "_T_string", 0, 0, 0, 0, -1, 285, 0, 0, 922, -1, 0, 0 },
/*  298 */ { "_T_var_ref",  "_T_var_ref", 0, 0, 0, 0, -1, 286, 0, 0, 923, -1, 0, 0 },
/*  299 */ { "_T_qual",  "_T_qual", 0, 0, 0, 0, -1, 287, 0, 0, 924, -1, 0, 0 },
/*  300 */ { "_T_lex_expr",  "_T_lex_expr", 0, 0, 0, 0, -1, 288, 0, 0, 925, -1, 0, 0 },
/*  301 */ { "_T_opt_lex_dot",  "_T_opt_lex_dot", 0, 0, 0, 0, -1, 289, 0, 0, 926, -1, 0, 0 },
/*  302 */ { "_T_lex_term",  "_T_lex_term", 0, 0, 0, 0, -1, 290, 0, 0, 927, -1, 0, 0 },
/*  303 */ { "_T_lex_factor_rep",  "_T_lex_factor_rep", 0, 0, 0, 0, -1, 291, 0, 0, 928, -1, 0, 0 },
/*  304 */ { "_T_lex_factor_neg",  "_T_lex_factor_neg", 0, 0, 0, 0, -1, 292, 0, 0, 929, -1, 0, 0 },
/*  305 */ { "_T_lex_range_lit",  "_T_lex_range_lit", 0, 0, 0, 0, -1, 293, 0, 0, 930, -1, 0, 0 },
/*  306 */ { "_T_lex_num",  "_T_lex_num", 0, 0, 0, 0, -1, 294, 0, 0, 931, -1, 0, 0 },
/*  307 */ { "_T_lex_factor",  "_T_lex_factor", 0, 0, 0, 0, -1, 295, 0, 0, 932, -1, 0, 0 },
/*  308 */ { "_T_reg_or_data",  "_T_reg_or_data", 0, 0, 0, 0, -1, 296, 0, 0, 933, -1, 0, 0 },
/*  309 */ { "_T_reg_or_char",  "_T_reg_or_char", 0, 0, 0, 0, -1, 297, 0, 0, 934, -1, 0, 0 },
/*  310 */ { "_T__lrepeat_root_item",  "_T__lrepeat_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 935, -1, 0, 0 },
/*  311 */ { "_T__lrepeat_sq_cons_data",  "_T__lrepeat_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 936, -1, 0, 0 },
/*  312 */ { "_T__lrepeat_struct_item",  "_T__lrepeat_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 937, -1, 0, 0 },
/*  313 */ { "_T__lrepeat_reduction_item",  "_T__lrepeat_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 938, -1, 0, 0 },
/*  314 */ { "_T__lrepeat_host_item",  "_T__lrepeat_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 939, -1, 0, 0 },
/*  315 */ { "_T__lrepeat_namespace_item",  "_T__lrepeat_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 940, -1, 0, 0 },
/*  316 */ { "_T__lrepeat_var_def",  "_T__lrepeat_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 941, -1, 0, 0 },
/*  317 */ { "_T__lrepeat_statement",  "_T__lrepeat_statement", 0, 0, 0, 0, -1, 0, 0, 0, 942, -1, 0, 0 },
/*  318 */ { "_T__lrepeat_field_init",  "_T__lrepeat_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 943, -1, 0, 0 },
/*  319 */ { "_T__lrepeat_litpat_el",  "_T__lrepeat_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 944, -1, 0, 0 },
/*  320 */ { "_T__lrepeat_pattern_el",  "_T__lrepeat_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 945, -1, 0, 0 },
/*  321 */ { "_T__lrepeat_lit_cons_el",  "_T__lrepeat_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 946, -1, 0, 0 },
/*  322 */ { "_T__lrepeat_cons_el",  "_T__lrepeat_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 947, -1, 0, 0 },
/*  323 */ { "_T__lrepeat_lit_accum_el",  "_T__lrepeat_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 948, -1, 0, 0 },
/*  324 */ { "_T__lrepeat_accum_el",  "_T__lrepeat_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 949, -1, 0, 0 },
/*  325 */ { "_T__lrepeat_lit_string_el",  "_T__lrepeat_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 950, -1, 0, 0 },
/*  326 */ { "_T__lrepeat_string_el",  "_T__lrepeat_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 951, -1, 0, 0 },
/*  327 */ { "_eof_ptr",  "_eof_ptr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  328 */ { "_eof_str",  "_eof_str", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  329 */ { "_eof_il",  "_eof_il", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  330 */ { "_eof_any",  "_eof_any", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  331 */ { "_eof_DEF",  "_eof_DEF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  332 */ { "_eof_REDEF",  "_eof_REDEF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  333 */ { "_eof_LEX",  "_eof_LEX", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  334 */ { "_eof_END",  "_eof_END", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  335 */ { "_eof_TOKEN",  "_eof_TOKEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  336 */ { "_eof_RL",  "_eof_RL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  337 */ { "_eof_IGNORE",  "_eof_IGNORE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  338 */ { "_eof_PRINT",  "_eof_PRINT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  339 */ { "_eof_PRINTS",  "_eof_PRINTS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  340 */ { "_eof_PARSE",  "_eof_PARSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  341 */ { "_eof_REDUCE",  "_eof_REDUCE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  342 */ { "_eof_READ_REDUCE",  "_eof_READ_REDUCE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  343 */ { "_eof_PARSE_TREE",  "_eof_PARSE_TREE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  344 */ { "_eof_PARSE_STOP",  "_eof_PARSE_STOP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  345 */ { "_eof_CONS",  "_eof_CONS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  346 */ { "_eof_MATCH",  "_eof_MATCH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  347 */ { "_eof_REQUIRE",  "_eof_REQUIRE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  348 */ { "_eof_SEND",  "_eof_SEND", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  349 */ { "_eof_SEND_TREE",  "_eof_SEND_TREE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  350 */ { "_eof_NAMESPACE",  "_eof_NAMESPACE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  351 */ { "_eof_REDUCTION",  "_eof_REDUCTION", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  352 */ { "_eof_FOR",  "_eof_FOR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  353 */ { "_eof_IF",  "_eof_IF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  354 */ { "_eof_YIELD",  "_eof_YIELD", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  355 */ { "_eof_WHILE",  "_eof_WHILE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  356 */ { "_eof_ELSIF",  "_eof_ELSIF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  357 */ { "_eof_ELSE",  "_eof_ELSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  358 */ { "_eof_IN",  "_eof_IN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  359 */ { "_eof_PARSER",  "_eof_PARSER", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  360 */ { "_eof_LIST",  "_eof_LIST", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  361 */ { "_eof_LIST_EL",  "_eof_LIST_EL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  362 */ { "_eof_MAP",  "_eof_MAP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  363 */ { "_eof_MAP_EL",  "_eof_MAP_EL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  364 */ { "_eof_PTR",  "_eof_PTR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  365 */ { "_eof_ITER",  "_eof_ITER", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  366 */ { "_eof_REF",  "_eof_REF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  367 */ { "_eof_EXPORT",  "_eof_EXPORT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  368 */ { "_eof_RETURN",  "_eof_RETURN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  369 */ { "_eof_BREAK",  "_eof_BREAK", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  370 */ { "_eof_REJECT",  "_eof_REJECT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  371 */ { "_eof_REDUCEFIRST",  "_eof_REDUCEFIRST", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  372 */ { "_eof_ALIAS",  "_eof_ALIAS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  373 */ { "_eof_COMMIT",  "_eof_COMMIT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  374 */ { "_eof_NEW",  "_eof_NEW", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  375 */ { "_eof_PREEOF",  "_eof_PREEOF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  376 */ { "_eof_GLOBAL",  "_eof_GLOBAL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  377 */ { "_eof_EOS",  "_eof_EOS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  378 */ { "_eof_CAST",  "_eof_CAST", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  379 */ { "_eof_SWITCH",  "_eof_SWITCH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  380 */ { "_eof_CASE",  "_eof_CASE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  381 */ { "_eof_DEFAULT",  "_eof_DEFAULT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  382 */ { "_eof_INT",  "_eof_INT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  383 */ { "_eof_BOOL",  "_eof_BOOL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  384 */ { "_eof_VOID",  "_eof_VOID", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  385 */ { "_eof_MAKE_TOKEN",  "_eof_MAKE_TOKEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  386 */ { "_eof_MAKE_TREE",  "_eof_MAKE_TREE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  387 */ { "_eof_TYPEID",  "_eof_TYPEID", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  388 */ { "_eof_LITERAL",  "_eof_LITERAL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  389 */ { "_eof_CONTEXT",  "_eof_CONTEXT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  390 */ { "_eof_STRUCT",  "_eof_STRUCT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  391 */ { "_eof_NI",  "_eof_NI", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  392 */ { "_eof_NIL",  "_eof_NIL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  393 */ { "_eof_TRUE",  "_eof_TRUE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  394 */ { "_eof_FALSE",  "_eof_FALSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  395 */ { "_eof_LEFT",  "_eof_LEFT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  396 */ { "_eof_RIGHT",  "_eof_RIGHT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  397 */ { "_eof_NONASSOC",  "_eof_NONASSOC", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  398 */ { "_eof_INCLUDE",  "_eof_INCLUDE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  399 */ { "_eof_id",  "_eof_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  400 */ { "_eof_number",  "_eof_number", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  401 */ { "_eof_backtick_lit",  "_eof_backtick_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  402 */ { "_eof_DQ",  "_eof_DQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  403 */ { "_eof_SQ",  "_eof_SQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  404 */ { "_eof_TILDE",  "_eof_TILDE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  405 */ { "_eof_SQOPEN",  "_eof_SQOPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  406 */ { "_eof_SQCLOSE",  "_eof_SQCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  407 */ { "_eof_BAR",  "_eof_BAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  408 */ { "_eof_FSLASH",  "_eof_FSLASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  409 */ { "_eof_COLON",  "_eof_COLON", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  410 */ { "_eof_DOUBLE_COLON",  "_eof_DOUBLE_COLON", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  411 */ { "_eof_DOT",  "_eof_DOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  412 */ { "_eof_ARROW",  "_eof_ARROW", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  413 */ { "_eof_POPEN",  "_eof_POPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  414 */ { "_eof_PCLOSE",  "_eof_PCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  415 */ { "_eof_COPEN",  "_eof_COPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  416 */ { "_eof_CCLOSE",  "_eof_CCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  417 */ { "_eof_STAR",  "_eof_STAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  418 */ { "_eof_QUESTION",  "_eof_QUESTION", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  419 */ { "_eof_EQUALS",  "_eof_EQUALS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  420 */ { "_eof_EQ_EQ",  "_eof_EQ_EQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  421 */ { "_eof_BANG_EQ",  "_eof_BANG_EQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  422 */ { "_eof_COMMA",  "_eof_COMMA", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  423 */ { "_eof_LT",  "_eof_LT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  424 */ { "_eof_GT",  "_eof_GT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  425 */ { "_eof_LT_EQ",  "_eof_LT_EQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  426 */ { "_eof_GT_EQ",  "_eof_GT_EQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  427 */ { "_eof_BANG",  "_eof_BANG", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  428 */ { "_eof_DOLLAR",  "_eof_DOLLAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  429 */ { "_eof_CARET",  "_eof_CARET", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  430 */ { "_eof_AT",  "_eof_AT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  431 */ { "_eof_PERCENT",  "_eof_PERCENT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  432 */ { "_eof_PLUS",  "_eof_PLUS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  433 */ { "_eof_MINUS",  "_eof_MINUS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  434 */ { "_eof_AMP_AMP",  "_eof_AMP_AMP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  435 */ { "_eof_BAR_BAR",  "_eof_BAR_BAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  436 */ { "_eof_DOT_DOT_DOT",  "_eof_DOT_DOT_DOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  437 */ { "_eof_LT_LT",  "_eof_LT_LT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  438 */ { "_eof_LARROW",  "_eof_LARROW", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  439 */ { "_eof__ignore_00d9",  "_eof__ignore_00d9", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  440 */ { "_eof__ignore_00db",  "_eof__ignore_00db", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  441 */ { "_eof_LIT_DQ",  "_eof_LIT_DQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  442 */ { "_eof_LIT_DQ_NL",  "_eof_LIT_DQ_NL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  443 */ { "_eof_LIT_SQOPEN",  "_eof_LIT_SQOPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  444 */ { "_eof_LIT_SQCLOSE",  "_eof_LIT_SQCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  445 */ { "_eof_lit_dq_data",  "_eof_lit_dq_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  446 */ { "_eof_CONS_SQ",  "_eof_CONS_SQ", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  447 */ { "_eof_CONS_SQ_NL",  "_eof_CONS_SQ_NL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  448 */ { "_eof_sq_cons_data",  "_eof_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  449 */ { "_eof_TILDE_NL",  "_eof_TILDE_NL", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  450 */ { "_eof_tilde_data",  "_eof_tilde_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  451 */ { "_eof_lex_id",  "_eof_lex_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  452 */ { "_eof_lex_uint",  "_eof_lex_uint", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  453 */ { "_eof_lex_hex",  "_eof_lex_hex", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  454 */ { "_eof_lex_lit",  "_eof_lex_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  455 */ { "_eof_LEX_DOT",  "_eof_LEX_DOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  456 */ { "_eof_LEX_BAR",  "_eof_LEX_BAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  457 */ { "_eof_LEX_AMP",  "_eof_LEX_AMP", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  458 */ { "_eof_LEX_DASH",  "_eof_LEX_DASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  459 */ { "_eof_LEX_POPEN",  "_eof_LEX_POPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  460 */ { "_eof_LEX_PCLOSE",  "_eof_LEX_PCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  461 */ { "_eof_LEX_STAR",  "_eof_LEX_STAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  462 */ { "_eof_LEX_STARSTAR",  "_eof_LEX_STARSTAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  463 */ { "_eof_LEX_QUESTION",  "_eof_LEX_QUESTION", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  464 */ { "_eof_LEX_PLUS",  "_eof_LEX_PLUS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  465 */ { "_eof_LEX_CARET",  "_eof_LEX_CARET", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  466 */ { "_eof_LEX_DOTDOT",  "_eof_LEX_DOTDOT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  467 */ { "_eof_LEX_SQOPEN_POS",  "_eof_LEX_SQOPEN_POS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  468 */ { "_eof_LEX_SQOPEN_NEG",  "_eof_LEX_SQOPEN_NEG", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  469 */ { "_eof_LEX_FSLASH",  "_eof_LEX_FSLASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  470 */ { "_eof_LEX_DASHDASH",  "_eof_LEX_DASHDASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  471 */ { "_eof_LEX_COLON_GT",  "_eof_LEX_COLON_GT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  472 */ { "_eof_LEX_COLON_GTGT",  "_eof_LEX_COLON_GTGT", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  473 */ { "_eof_LEX_LT_COLON",  "_eof_LEX_LT_COLON", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  474 */ { "_eof__ignore_011f",  "_eof__ignore_011f", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  475 */ { "_eof__ignore_0121",  "_eof__ignore_0121", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  476 */ { "_eof_RE_DASH",  "_eof_RE_DASH", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  477 */ { "_eof_RE_CHAR",  "_eof_RE_CHAR", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  478 */ { "_eof_RE_SQCLOSE",  "_eof_RE_SQCLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  479 */ { "_eof_RED_OPEN",  "_eof_RED_OPEN", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  480 */ { "_eof_RED_CLOSE",  "_eof_RED_CLOSE", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  481 */ { "_eof_red_id",  "_eof_red_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  482 */ { "_eof_red_comment",  "_eof_red_comment", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  483 */ { "_eof_red_ws",  "_eof_red_ws", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  484 */ { "_eof_red_lit",  "_eof_red_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  485 */ { "_eof_RED_LHS",  "_eof_RED_LHS", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  486 */ { "_eof_RED_RHS_REF",  "_eof_RED_RHS_REF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  487 */ { "_eof_RED_RHS_LOC",  "_eof_RED_RHS_LOC", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  488 */ { "_eof_RED_TREE_REF",  "_eof_RED_TREE_REF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  489 */ { "_eof_RED_RHS_NREF",  "_eof_RED_RHS_NREF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  490 */ { "_eof_RED_RHS_NLOC",  "_eof_RED_RHS_NLOC", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  491 */ { "_eof_RED_TREE_NREF",  "_eof_RED_TREE_NREF", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  492 */ { "_eof_red_any",  "_eof_red_any", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  493 */ { "_eof_start",  "_eof_start", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  494 */ { "_eof_root_item",  "_eof_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  495 */ { "_eof__include",  "_eof__include", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  496 */ { "_eof_precedence_def",  "_eof_precedence_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  497 */ { "_eof_pred_type",  "_eof_pred_type", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  498 */ { "_eof_pred_token_list",  "_eof_pred_token_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  499 */ { "_eof_pred_token",  "_eof_pred_token", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  500 */ { "_eof_pre_eof_def",  "_eof_pre_eof_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  501 */ { "_eof_alias_def",  "_eof_alias_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  502 */ { "_eof_struct_item",  "_eof_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  503 */ { "_eof_export_def",  "_eof_export_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  504 */ { "_eof_global_def",  "_eof_global_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  505 */ { "_eof_iter_def",  "_eof_iter_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  506 */ { "_eof_reference_type_ref",  "_eof_reference_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  507 */ { "_eof_param_var_def_seq",  "_eof_param_var_def_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  508 */ { "_eof_param_var_def_list",  "_eof_param_var_def_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  509 */ { "_eof_param_var_def",  "_eof_param_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  510 */ { "_eof_opt_export",  "_eof_opt_export", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  511 */ { "_eof_function_def",  "_eof_function_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  512 */ { "_eof_in_host_def",  "_eof_in_host_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  513 */ { "_eof_struct_var_def",  "_eof_struct_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  514 */ { "_eof_struct_key",  "_eof_struct_key", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  515 */ { "_eof_struct_def",  "_eof_struct_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  516 */ { "_eof_literal_keyword",  "_eof_literal_keyword", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  517 */ { "_eof_literal_def",  "_eof_literal_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  518 */ { "_eof_literal_list",  "_eof_literal_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  519 */ { "_eof_literal_item",  "_eof_literal_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  520 */ { "_eof_no_ignore_left",  "_eof_no_ignore_left", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  521 */ { "_eof_no_ignore_right",  "_eof_no_ignore_right", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  522 */ { "_eof_reduction_def",  "_eof_reduction_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  523 */ { "_eof_red_nonterm",  "_eof_red_nonterm", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  524 */ { "_eof_red_action",  "_eof_red_action", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  525 */ { "_eof_host_item",  "_eof_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  526 */ { "_eof_reduction_item",  "_eof_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  527 */ { "_eof_namespace_def",  "_eof_namespace_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  528 */ { "_eof_namespace_item",  "_eof_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  529 */ { "_eof_obj_var_list",  "_eof_obj_var_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  530 */ { "_eof_opt_reduce_first",  "_eof_opt_reduce_first", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  531 */ { "_eof_cfl_def",  "_eof_cfl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  532 */ { "_eof_cfl_redef",  "_eof_cfl_redef", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  533 */ { "_eof_region_def",  "_eof_region_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  534 */ { "_eof_rl_def",  "_eof_rl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  535 */ { "_eof_opt_lex_expr",  "_eof_opt_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  536 */ { "_eof_token_def",  "_eof_token_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  537 */ { "_eof_ic_def",  "_eof_ic_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  538 */ { "_eof_opt_translate",  "_eof_opt_translate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  539 */ { "_eof_opt_id",  "_eof_opt_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  540 */ { "_eof_ignore_def",  "_eof_ignore_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  541 */ { "_eof_prod_sublist",  "_eof_prod_sublist", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  542 */ { "_eof_prod_el",  "_eof_prod_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  543 */ { "_eof_opt_prod_el_name",  "_eof_opt_prod_el_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  544 */ { "_eof_prod_el_list",  "_eof_prod_el_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  545 */ { "_eof_opt_commit",  "_eof_opt_commit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  546 */ { "_eof_opt_prod_name",  "_eof_opt_prod_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  547 */ { "_eof_prod",  "_eof_prod", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  548 */ { "_eof_opt_reduce",  "_eof_opt_reduce", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  549 */ { "_eof_prod_list",  "_eof_prod_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  550 */ { "_eof_case_clause",  "_eof_case_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  551 */ { "_eof_default_clause",  "_eof_default_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  552 */ { "_eof_case_clause_list",  "_eof_case_clause_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  553 */ { "_eof_bare_tok",  "_eof_bare_tok", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  554 */ { "_eof_statement",  "_eof_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  555 */ { "_eof_elsif_list",  "_eof_elsif_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  556 */ { "_eof_elsif_clause",  "_eof_elsif_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  557 */ { "_eof_optional_else",  "_eof_optional_else", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  558 */ { "_eof_call_arg_seq",  "_eof_call_arg_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  559 */ { "_eof_call_arg_list",  "_eof_call_arg_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  560 */ { "_eof_iter_call",  "_eof_iter_call", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  561 */ { "_eof_block_or_single",  "_eof_block_or_single", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  562 */ { "_eof_require_pattern",  "_eof_require_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  563 */ { "_eof_opt_require_stmt",  "_eof_opt_require_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  564 */ { "_eof_lang_stmt_list",  "_eof_lang_stmt_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  565 */ { "_eof_opt_def_init",  "_eof_opt_def_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  566 */ { "_eof_var_def",  "_eof_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  567 */ { "_eof_print_stmt",  "_eof_print_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  568 */ { "_eof_expr_stmt",  "_eof_expr_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  569 */ { "_eof_code_expr",  "_eof_code_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  570 */ { "_eof_code_relational",  "_eof_code_relational", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  571 */ { "_eof_code_additive",  "_eof_code_additive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  572 */ { "_eof_code_multiplicitive",  "_eof_code_multiplicitive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  573 */ { "_eof_code_unary",  "_eof_code_unary", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  574 */ { "_eof_opt_eos",  "_eof_opt_eos", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  575 */ { "_eof_code_factor",  "_eof_code_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  576 */ { "_eof_type_ref",  "_eof_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  577 */ { "_eof_region_qual",  "_eof_region_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  578 */ { "_eof_opt_repeat",  "_eof_opt_repeat", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  579 */ { "_eof_opt_capture",  "_eof_opt_capture", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  580 */ { "_eof_opt_field_init",  "_eof_opt_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  581 */ { "_eof_field_init",  "_eof_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  582 */ { "_eof_stmt_or_factor",  "_eof_stmt_or_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  583 */ { "_eof_opt_label",  "_eof_opt_label", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  584 */ { "_eof_dq_lit_term",  "_eof_dq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  585 */ { "_eof_sq_lit_term",  "_eof_sq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  586 */ { "_eof_opt_tilde_data",  "_eof_opt_tilde_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  587 */ { "_eof_pattern_el_lel",  "_eof_pattern_el_lel", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  588 */ { "_eof_pattern_el",  "_eof_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  589 */ { "_eof_litpat_el",  "_eof_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  590 */ { "_eof_pattern_top_el",  "_eof_pattern_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  591 */ { "_eof_pattern_list",  "_eof_pattern_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  592 */ { "_eof_pattern",  "_eof_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  593 */ { "_eof_E1",  "_eof_E1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  594 */ { "_eof_E2",  "_eof_E2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  595 */ { "_eof_E3",  "_eof_E3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  596 */ { "_eof_E4",  "_eof_E4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  597 */ { "_eof_cons_el",  "_eof_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  598 */ { "_eof_lit_cons_el",  "_eof_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  599 */ { "_eof_cons_top_el",  "_eof_cons_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  600 */ { "_eof_cons_list",  "_eof_cons_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  601 */ { "_eof_constructor",  "_eof_constructor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  602 */ { "_eof_accum_el",  "_eof_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  603 */ { "_eof_lit_accum_el",  "_eof_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  604 */ { "_eof_accum_top_el",  "_eof_accum_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  605 */ { "_eof_accum_list",  "_eof_accum_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  606 */ { "_eof_accumulate",  "_eof_accumulate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  607 */ { "_eof_string_el",  "_eof_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  608 */ { "_eof_lit_string_el",  "_eof_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  609 */ { "_eof_string_top_el",  "_eof_string_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  610 */ { "_eof_string_list",  "_eof_string_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  611 */ { "_eof_string",  "_eof_string", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  612 */ { "_eof_var_ref",  "_eof_var_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  613 */ { "_eof_qual",  "_eof_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  614 */ { "_eof_lex_expr",  "_eof_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  615 */ { "_eof_opt_lex_dot",  "_eof_opt_lex_dot", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  616 */ { "_eof_lex_term",  "_eof_lex_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  617 */ { "_eof_lex_factor_rep",  "_eof_lex_factor_rep", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  618 */ { "_eof_lex_factor_neg",  "_eof_lex_factor_neg", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  619 */ { "_eof_lex_range_lit",  "_eof_lex_range_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  620 */ { "_eof_lex_num",  "_eof_lex_num", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  621 */ { "_eof_lex_factor",  "_eof_lex_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  622 */ { "_eof_reg_or_data",  "_eof_reg_or_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  623 */ { "_eof_reg_or_char",  "_eof_reg_or_char", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  624 */ { "_eof__ign_0x557181370fd0",  "_eof__ign_0x557181370fd0", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  625 */ { "_eof__ign_0x557181436040",  "_eof__ign_0x557181436040", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  626 */ { "_eof__ign_0x557181436280",  "_eof__ign_0x557181436280", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  627 */ { "_eof__ign_0x55718143a8b0",  "_eof__ign_0x55718143a8b0", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  628 */ { "_eof__ign_0x55718143b870",  "_eof__ign_0x55718143b870", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  629 */ { "_eof__ign_0x557181448ad0",  "_eof__ign_0x557181448ad0", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  630 */ { "_eof__ign_0x55718146a420",  "_eof__ign_0x55718146a420", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  631 */ { "_eof___0x5571814360e0_DEF_PAT_1",  "_eof___0x5571814360e0_DEF_PAT_1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  632 */ { "_eof___0x557181438c10_DEF_PAT_2",  "_eof___0x557181438c10_DEF_PAT_2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  633 */ { "_eof___0x55718143a950_DEF_PAT_3",  "_eof___0x55718143a950_DEF_PAT_3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  634 */ { "_eof___0x557181448b70_DEF_PAT_4",  "_eof___0x557181448b70_DEF_PAT_4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  635 */ { "_eof___0x55718146a4c0_DEF_PAT_5",  "_eof___0x55718146a4c0_DEF_PAT_5", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  636 */ { "_eof__lrepeat_root_item",  "_eof__lrepeat_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  637 */ { "_eof__lrepeat_sq_cons_data",  "_eof__lrepeat_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  638 */ { "_eof__lrepeat_struct_item",  "_eof__lrepeat_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  639 */ { "_eof__lrepeat_reduction_item",  "_eof__lrepeat_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  640 */ { "_eof__lrepeat_host_item",  "_eof__lrepeat_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  641 */ { "_eof__lrepeat_namespace_item",  "_eof__lrepeat_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  642 */ { "_eof__lrepeat_var_def",  "_eof__lrepeat_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  643 */ { "_eof__lrepeat_statement",  "_eof__lrepeat_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  644 */ { "_eof__lrepeat_field_init",  "_eof__lrepeat_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  645 */ { "_eof__lrepeat_litpat_el",  "_eof__lrepeat_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  646 */ { "_eof__lrepeat_pattern_el",  "_eof__lrepeat_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  647 */ { "_eof__lrepeat_lit_cons_el",  "_eof__lrepeat_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  648 */ { "_eof__lrepeat_cons_el",  "_eof__lrepeat_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  649 */ { "_eof__lrepeat_lit_accum_el",  "_eof__lrepeat_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  650 */ { "_eof__lrepeat_accum_el",  "_eof__lrepeat_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  651 */ { "_eof__lrepeat_lit_string_el",  "_eof__lrepeat_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  652 */ { "_eof__lrepeat_string_el",  "_eof__lrepeat_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  653 */ { "_eof__T_any",  "_eof__T_any", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  654 */ { "_eof__T_start",  "_eof__T_start", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  655 */ { "_eof__T_root_item",  "_eof__T_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  656 */ { "_eof__T__include",  "_eof__T__include", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  657 */ { "_eof__T_precedence_def",  "_eof__T_precedence_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  658 */ { "_eof__T_pred_type",  "_eof__T_pred_type", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  659 */ { "_eof__T_pred_token_list",  "_eof__T_pred_token_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  660 */ { "_eof__T_pred_token",  "_eof__T_pred_token", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  661 */ { "_eof__T_pre_eof_def",  "_eof__T_pre_eof_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  662 */ { "_eof__T_alias_def",  "_eof__T_alias_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  663 */ { "_eof__T_struct_item",  "_eof__T_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  664 */ { "_eof__T_export_def",  "_eof__T_export_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  665 */ { "_eof__T_global_def",  "_eof__T_global_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  666 */ { "_eof__T_iter_def",  "_eof__T_iter_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  667 */ { "_eof__T_reference_type_ref",  "_eof__T_reference_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  668 */ { "_eof__T_param_var_def_seq",  "_eof__T_param_var_def_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  669 */ { "_eof__T_param_var_def_list",  "_eof__T_param_var_def_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  670 */ { "_eof__T_param_var_def",  "_eof__T_param_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  671 */ { "_eof__T_opt_export",  "_eof__T_opt_export", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  672 */ { "_eof__T_function_def",  "_eof__T_function_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  673 */ { "_eof__T_in_host_def",  "_eof__T_in_host_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  674 */ { "_eof__T_struct_var_def",  "_eof__T_struct_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  675 */ { "_eof__T_struct_key",  "_eof__T_struct_key", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  676 */ { "_eof__T_struct_def",  "_eof__T_struct_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  677 */ { "_eof__T_literal_keyword",  "_eof__T_literal_keyword", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  678 */ { "_eof__T_literal_def",  "_eof__T_literal_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  679 */ { "_eof__T_literal_list",  "_eof__T_literal_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  680 */ { "_eof__T_literal_item",  "_eof__T_literal_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  681 */ { "_eof__T_no_ignore_left",  "_eof__T_no_ignore_left", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  682 */ { "_eof__T_no_ignore_right",  "_eof__T_no_ignore_right", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  683 */ { "_eof__T_reduction_def",  "_eof__T_reduction_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  684 */ { "_eof__T_red_nonterm",  "_eof__T_red_nonterm", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  685 */ { "_eof__T_red_action",  "_eof__T_red_action", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  686 */ { "_eof__T_host_item",  "_eof__T_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  687 */ { "_eof__T_reduction_item",  "_eof__T_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  688 */ { "_eof__T_namespace_def",  "_eof__T_namespace_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  689 */ { "_eof__T_namespace_item",  "_eof__T_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  690 */ { "_eof__T_obj_var_list",  "_eof__T_obj_var_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  691 */ { "_eof__T_opt_reduce_first",  "_eof__T_opt_reduce_first", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  692 */ { "_eof__T_cfl_def",  "_eof__T_cfl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  693 */ { "_eof__T_cfl_redef",  "_eof__T_cfl_redef", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  694 */ { "_eof__T_region_def",  "_eof__T_region_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  695 */ { "_eof__T_rl_def",  "_eof__T_rl_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  696 */ { "_eof__T_opt_lex_expr",  "_eof__T_opt_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  697 */ { "_eof__T_token_def",  "_eof__T_token_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  698 */ { "_eof__T_ic_def",  "_eof__T_ic_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  699 */ { "_eof__T_opt_translate",  "_eof__T_opt_translate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  700 */ { "_eof__T_opt_id",  "_eof__T_opt_id", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  701 */ { "_eof__T_ignore_def",  "_eof__T_ignore_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  702 */ { "_eof__T_prod_sublist",  "_eof__T_prod_sublist", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  703 */ { "_eof__T_prod_el",  "_eof__T_prod_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  704 */ { "_eof__T_opt_prod_el_name",  "_eof__T_opt_prod_el_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  705 */ { "_eof__T_prod_el_list",  "_eof__T_prod_el_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  706 */ { "_eof__T_opt_commit",  "_eof__T_opt_commit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  707 */ { "_eof__T_opt_prod_name",  "_eof__T_opt_prod_name", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  708 */ { "_eof__T_prod",  "_eof__T_prod", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  709 */ { "_eof__T_opt_reduce",  "_eof__T_opt_reduce", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  710 */ { "_eof__T_prod_list",  "_eof__T_prod_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  711 */ { "_eof__T_case_clause",  "_eof__T_case_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  712 */ { "_eof__T_default_clause",  "_eof__T_default_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  713 */ { "_eof__T_case_clause_list",  "_eof__T_case_clause_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  714 */ { "_eof__T_bare_tok",  "_eof__T_bare_tok", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  715 */ { "_eof__T_statement",  "_eof__T_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  716 */ { "_eof__T_elsif_list",  "_eof__T_elsif_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  717 */ { "_eof__T_elsif_clause",  "_eof__T_elsif_clause", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  718 */ { "_eof__T_optional_else",  "_eof__T_optional_else", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  719 */ { "_eof__T_call_arg_seq",  "_eof__T_call_arg_seq", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  720 */ { "_eof__T_call_arg_list",  "_eof__T_call_arg_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  721 */ { "_eof__T_iter_call",  "_eof__T_iter_call", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  722 */ { "_eof__T_block_or_single",  "_eof__T_block_or_single", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  723 */ { "_eof__T_require_pattern",  "_eof__T_require_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  724 */ { "_eof__T_opt_require_stmt",  "_eof__T_opt_require_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  725 */ { "_eof__T_lang_stmt_list",  "_eof__T_lang_stmt_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  726 */ { "_eof__T_opt_def_init",  "_eof__T_opt_def_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  727 */ { "_eof__T_var_def",  "_eof__T_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  728 */ { "_eof__T_print_stmt",  "_eof__T_print_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  729 */ { "_eof__T_expr_stmt",  "_eof__T_expr_stmt", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  730 */ { "_eof__T_code_expr",  "_eof__T_code_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  731 */ { "_eof__T_code_relational",  "_eof__T_code_relational", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  732 */ { "_eof__T_code_additive",  "_eof__T_code_additive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  733 */ { "_eof__T_code_multiplicitive",  "_eof__T_code_multiplicitive", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  734 */ { "_eof__T_code_unary",  "_eof__T_code_unary", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  735 */ { "_eof__T_opt_eos",  "_eof__T_opt_eos", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  736 */ { "_eof__T_code_factor",  "_eof__T_code_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  737 */ { "_eof__T_type_ref",  "_eof__T_type_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  738 */ { "_eof__T_region_qual",  "_eof__T_region_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  739 */ { "_eof__T_opt_repeat",  "_eof__T_opt_repeat", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  740 */ { "_eof__T_opt_capture",  "_eof__T_opt_capture", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  741 */ { "_eof__T_opt_field_init",  "_eof__T_opt_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  742 */ { "_eof__T_field_init",  "_eof__T_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  743 */ { "_eof__T_stmt_or_factor",  "_eof__T_stmt_or_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  744 */ { "_eof__T_opt_label",  "_eof__T_opt_label", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  745 */ { "_eof__T_dq_lit_term",  "_eof__T_dq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  746 */ { "_eof__T_sq_lit_term",  "_eof__T_sq_lit_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  747 */ { "_eof__T_opt_tilde_data",  "_eof__T_opt_tilde_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  748 */ { "_eof__T_pattern_el_lel",  "_eof__T_pattern_el_lel", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  749 */ { "_eof__T_pattern_el",  "_eof__T_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  750 */ { "_eof__T_litpat_el",  "_eof__T_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  751 */ { "_eof__T_pattern_top_el",  "_eof__T_pattern_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  752 */ { "_eof__T_pattern_list",  "_eof__T_pattern_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  753 */ { "_eof__T_pattern",  "_eof__T_pattern", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  754 */ { "_eof__T_E1",  "_eof__T_E1", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  755 */ { "_eof__T_E2",  "_eof__T_E2", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  756 */ { "_eof__T_E3",  "_eof__T_E3", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  757 */ { "_eof__T_E4",  "_eof__T_E4", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  758 */ { "_eof__T_cons_el",  "_eof__T_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  759 */ { "_eof__T_lit_cons_el",  "_eof__T_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  760 */ { "_eof__T_cons_top_el",  "_eof__T_cons_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  761 */ { "_eof__T_cons_list",  "_eof__T_cons_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  762 */ { "_eof__T_constructor",  "_eof__T_constructor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  763 */ { "_eof__T_accum_el",  "_eof__T_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  764 */ { "_eof__T_lit_accum_el",  "_eof__T_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  765 */ { "_eof__T_accum_top_el",  "_eof__T_accum_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  766 */ { "_eof__T_accum_list",  "_eof__T_accum_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  767 */ { "_eof__T_accumulate",  "_eof__T_accumulate", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  768 */ { "_eof__T_string_el",  "_eof__T_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  769 */ { "_eof__T_lit_string_el",  "_eof__T_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  770 */ { "_eof__T_string_top_el",  "_eof__T_string_top_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  771 */ { "_eof__T_string_list",  "_eof__T_string_list", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  772 */ { "_eof__T_string",  "_eof__T_string", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  773 */ { "_eof__T_var_ref",  "_eof__T_var_ref", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  774 */ { "_eof__T_qual",  "_eof__T_qual", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  775 */ { "_eof__T_lex_expr",  "_eof__T_lex_expr", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  776 */ { "_eof__T_opt_lex_dot",  "_eof__T_opt_lex_dot", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  777 */ { "_eof__T_lex_term",  "_eof__T_lex_term", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  778 */ { "_eof__T_lex_factor_rep",  "_eof__T_lex_factor_rep", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  779 */ { "_eof__T_lex_factor_neg",  "_eof__T_lex_factor_neg", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  780 */ { "_eof__T_lex_range_lit",  "_eof__T_lex_range_lit", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  781 */ { "_eof__T_lex_num",  "_eof__T_lex_num", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  782 */ { "_eof__T_lex_factor",  "_eof__T_lex_factor", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  783 */ { "_eof__T_reg_or_data",  "_eof__T_reg_or_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  784 */ { "_eof__T_reg_or_char",  "_eof__T_reg_or_char", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  785 */ { "_eof__T__lrepeat_root_item",  "_eof__T__lrepeat_root_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  786 */ { "_eof__T__lrepeat_sq_cons_data",  "_eof__T__lrepeat_sq_cons_data", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  787 */ { "_eof__T__lrepeat_struct_item",  "_eof__T__lrepeat_struct_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  788 */ { "_eof__T__lrepeat_reduction_item",  "_eof__T__lrepeat_reduction_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  789 */ { "_eof__T__lrepeat_host_item",  "_eof__T__lrepeat_host_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  790 */ { "_eof__T__lrepeat_namespace_item",  "_eof__T__lrepeat_namespace_item", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  791 */ { "_eof__T__lrepeat_var_def",  "_eof__T__lrepeat_var_def", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  792 */ { "_eof__T__lrepeat_statement",  "_eof__T__lrepeat_statement", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  793 */ { "_eof__T__lrepeat_field_init",  "_eof__T__lrepeat_field_init", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  794 */ { "_eof__T__lrepeat_litpat_el",  "_eof__T__lrepeat_litpat_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  795 */ { "_eof__T__lrepeat_pattern_el",  "_eof__T__lrepeat_pattern_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  796 */ { "_eof__T__lrepeat_lit_cons_el",  "_eof__T__lrepeat_lit_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  797 */ { "_eof__T__lrepeat_cons_el",  "_eof__T__lrepeat_cons_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  798 */ { "_eof__T__lrepeat_lit_accum_el",  "_eof__T__lrepeat_lit_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  799 */ { "_eof__T__lrepeat_accum_el",  "_eof__T__lrepeat_accum_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  800 */ { "_eof__T__lrepeat_lit_string_el",  "_eof__T__lrepeat_lit_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  801 */ { "_eof__T__lrepeat_string_el",  "_eof__T__lrepeat_string_el", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  802 */ { "_notoken",  "_notoken", 0, 0, 0, 1, -1, 0, 0, 0, 0, -1, 0, 0 },
/*  803 */ { "any",  "any", 0, 0, 0, 0, -1, 0, 0, 0, 178, -1, 0, 0 },
/*  804 */ { "start",  "start", 0, 0, 0, 0, -1, 153, 0, 0, 179, -1, 0, 0 },
/*  805 */ { "root_item",  "root_item", 0, 0, 0, 0, -1, 154, 0, 0, 180, -1, 0, 0 },
/*  806 */ { "_include",  "_include", 0, 0, 0, 0, -1, 155, 0, 0, 181, -1, 0, 0 },
/*  807 */ { "precedence_def",  "precedence_def", 0, 0, 0, 0, -1, 156, 0, 0, 182, -1, 0, 0 },
/*  808 */ { "pred_type",  "pred_type", 0, 0, 0, 0, -1, 157, 0, 0, 183, -1, 0, 0 },
/*  809 */ { "pred_token_list",  "pred_token_list", 0, 0, 0, 0, -1, 158, 0, 0, 184, -1, 0, 0 },
/*  810 */ { "pred_token",  "pred_token", 0, 0, 0, 0, -1, 159, 0, 0, 185, -1, 0, 0 },
/*  811 */ { "pre_eof_def",  "pre_eof_def", 0, 0, 0, 0, -1, 160, 0, 0, 186, -1, 0, 0 },
/*  812 */ { "alias_def",  "alias_def", 0, 0, 0, 0, -1, 161, 0, 0, 187, -1, 0, 0 },
/*  813 */ { "struct_item",  "struct_item", 0, 0, 0, 0, -1, 162, 0, 0, 188, -1, 0, 0 },
/*  814 */ { "export_def",  "export_def", 0, 0, 0, 0, -1, 163, 0, 0, 189, -1, 0, 0 },
/*  815 */ { "global_def",  "global_def", 0, 0, 0, 0, -1, 164, 0, 0, 190, -1, 0, 0 },
/*  816 */ { "iter_def",  "iter_def", 0, 0, 0, 0, -1, 165, 0, 0, 191, -1, 0, 0 },
/*  817 */ { "reference_type_ref",  "reference_type_ref", 0, 0, 0, 0, -1, 166, 0, 0, 192, -1, 0, 0 },
/*  818 */ { "param_var_def_seq",  "param_var_def_seq", 0, 0, 0, 0, -1, 167, 0, 0, 193, -1, 0, 0 },
/*  819 */ { "param_var_def_list",  "param_var_def_list", 0, 0, 0, 0, -1, 168, 0, 0, 194, -1, 0, 0 },
/*  820 */ { "param_var_def",  "param_var_def", 0, 0, 0, 0, -1, 169, 0, 0, 195, -1, 0, 0 },
/*  821 */ { "opt_export",  "opt_export", 0, 0, 0, 0, -1, 170, 0, 0, 196, -1, 0, 0 },
/*  822 */ { "function_def",  "function_def", 0, 0, 0, 0, -1, 171, 0, 0, 197, -1, 0, 0 },
/*  823 */ { "in_host_def",  "in_host_def", 0, 0, 0, 0, -1, 172, 0, 0, 198, -1, 0, 0 },
/*  824 */ { "struct_var_def",  "struct_var_def", 0, 0, 0, 0, -1, 173, 0, 0, 199, -1, 0, 0 },
/*  825 */ { "struct_key",  "struct_key", 0, 0, 0, 0, -1, 174, 0, 0, 200, -1, 0, 0 },
/*  826 */ { "struct_def",  "struct_def", 0, 0, 0, 0, -1, 175, 0, 0, 201, -1, 0, 0 },
/*  827 */ { "literal_keyword",  "literal_keyword", 0, 0, 0, 0, -1, 176, 0, 0, 202, -1, 0, 0 },
/*  828 */ { "literal_def",  "literal_def", 0, 0, 0, 0, -1, 177, 0, 0, 203, -1, 0, 0 },
/*  829 */ { "literal_list",  "literal_list", 0, 0, 0, 0, -1, 178, 0, 0, 204, -1, 0, 0 },
/*  830 */ { "literal_item",  "literal_item", 0, 0, 0, 0, -1, 179, 0, 0, 205, -1, 0, 0 },
/*  831 */ { "no_ignore_left",  "no_ignore_left", 0, 0, 0, 0, -1, 180, 0, 0, 206, -1, 0, 0 },
/*  832 */ { "no_ignore_right",  "no_ignore_right", 0, 0, 0, 0, -1, 181, 0, 0, 207, -1, 0, 0 },
/*  833 */ { "reduction_def",  "reduction_def", 0, 0, 0, 0, -1, 182, 0, 0, 208, -1, 0, 0 },
/*  834 */ { "red_nonterm",  "red_nonterm", 0, 0, 0, 0, -1, 197, 0, 0, 209, -1, 0, 0 },
/*  835 */ { "red_action",  "red_action", 0, 0, 0, 0, -1, 198, 0, 0, 210, -1, 0, 0 },
/*  836 */ { "host_item",  "host_item", 0, 0, 0, 0, -1, 199, 0, 0, 211, -1, 0, 0 },
/*  837 */ { "reduction_item",  "reduction_item", 0, 0, 0, 0, -1, 200, 0, 0, 212, -1, 0, 0 },
/*  838 */ { "namespace_def",  "namespace_def", 0, 0, 0, 0, -1, 201, 0, 0, 213, -1, 0, 0 },
/*  839 */ { "namespace_item",  "namespace_item", 0, 0, 0, 0, -1, 202, 0, 0, 214, -1, 0, 0 },
/*  840 */ { "obj_var_list",  "obj_var_list", 0, 0, 0, 0, -1, 203, 0, 0, 215, -1, 0, 0 },
/*  841 */ { "opt_reduce_first",  "opt_reduce_first", 0, 0, 0, 0, -1, 204, 0, 0, 216, -1, 0, 0 },
/*  842 */ { "cfl_def",  "cfl_def", 0, 0, 0, 0, -1, 205, 0, 0, 217, -1, 0, 0 },
/*  843 */ { "cfl_redef",  "cfl_redef", 0, 0, 0, 0, -1, 206, 0, 0, 218, -1, 0, 0 },
/*  844 */ { "region_def",  "region_def", 0, 0, 0, 0, -1, 207, 0, 0, 219, -1, 0, 0 },
/*  845 */ { "rl_def",  "rl_def", 0, 0, 0, 0, -1, 208, 0, 0, 220, -1, 0, 0 },
/*  846 */ { "opt_lex_expr",  "opt_lex_expr", 0, 0, 0, 0, -1, 209, 0, 0, 221, -1, 0, 0 },
/*  847 */ { "token_def",  "token_def", 0, 0, 0, 0, -1, 210, 0, 0, 222, -1, 0, 0 },
/*  848 */ { "ic_def",  "ic_def", 0, 0, 0, 0, -1, 211, 0, 0, 223, -1, 0, 0 },
/*  849 */ { "opt_translate",  "opt_translate", 0, 0, 0, 0, -1, 212, 0, 0, 224, -1, 0, 0 },
/*  850 */ { "opt_id",  "opt_id", 0, 0, 0, 0, -1, 213, 0, 0, 225, -1, 0, 0 },
/*  851 */ { "ignore_def",  "ignore_def", 0, 0, 0, 0, -1, 214, 0, 0, 226, -1, 0, 0 },
/*  852 */ { "prod_sublist",  "prod_sublist", 0, 0, 0, 0, -1, 215, 0, 0, 227, -1, 0, 0 },
/*  853 */ { "prod_el",  "prod_el", 0, 0, 0, 0, -1, 216, 0, 0, 228, -1, 0, 0 },
/*  854 */ { "opt_prod_el_name",  "opt_prod_el_name", 0, 0, 0, 0, -1, 217, 0, 0, 229, -1, 0, 0 },
/*  855 */ { "prod_el_list",  "prod_el_list", 0, 0, 0, 0, -1, 218, 0, 0, 230, -1, 0, 0 },
/*  856 */ { "opt_commit",  "opt_commit", 0, 0, 0, 0, -1, 219, 0, 0, 231, -1, 0, 0 },
/*  857 */ { "opt_prod_name",  "opt_prod_name", 0, 0, 0, 0, -1, 220, 0, 0, 232, -1, 0, 0 },
/*  858 */ { "prod",  "prod", 0, 0, 0, 0, -1, 221, 0, 0, 233, -1, 0, 0 },
/*  859 */ { "opt_reduce",  "opt_reduce", 0, 0, 0, 0, -1, 222, 0, 0, 234, -1, 0, 0 },
/*  860 */ { "prod_list",  "prod_list", 0, 0, 0, 0, -1, 223, 0, 0, 235, -1, 0, 0 },
/*  861 */ { "case_clause",  "case_clause", 0, 0, 0, 0, -1, 224, 0, 0, 236, -1, 0, 0 },
/*  862 */ { "default_clause",  "default_clause", 0, 0, 0, 0, -1, 225, 0, 0, 237, -1, 0, 0 },
/*  863 */ { "case_clause_list",  "case_clause_list", 0, 0, 0, 0, -1, 226, 0, 0, 238, -1, 0, 0 },
/*  864 */ { "bare_tok",  "bare_tok", 0, 0, 0, 0, -1, 227, 0, 0, 239, -1, 0, 0 },
/*  865 */ { "statement",  "statement", 0, 0, 0, 0, -1, 228, 0, 0, 240, -1, 0, 0 },
/*  866 */ { "elsif_list",  "elsif_list", 0, 0, 0, 0, -1, 229, 0, 0, 241, -1, 0, 0 },
/*  867 */ { "elsif_clause",  "elsif_clause", 0, 0, 0, 0, -1, 230, 0, 0, 242, -1, 0, 0 },
/*  868 */ { "optional_else",  "optional_else", 0, 0, 0, 0, -1, 231, 0, 0, 243, -1, 0, 0 },
/*  869 */ { "call_arg_seq",  "call_arg_seq", 0, 0, 0, 0, -1, 232, 0, 0, 244, -1, 0, 0 },
/*  870 */ { "call_arg_list",  "call_arg_list", 0, 0, 0, 0, -1, 233, 0, 0, 245, -1, 0, 0 },
/*  871 */ { "iter_call",  "iter_call", 0, 0, 0, 0, -1, 234, 0, 0, 246, -1, 0, 0 },
/*  872 */ { "block_or_single",  "block_or_single", 0, 0, 0, 0, -1, 235, 0, 0, 247, -1, 0, 0 },
/*  873 */ { "require_pattern",  "require_pattern", 0, 0, 0, 0, -1, 236, 0, 0, 248, -1, 0, 0 },
/*  874 */ { "opt_require_stmt",  "opt_require_stmt", 0, 0, 0, 0, -1, 237, 0, 0, 249, -1, 0, 0 },
/*  875 */ { "lang_stmt_list",  "lang_stmt_list", 0, 0, 0, 0, -1, 238, 0, 0, 250, -1, 0, 0 },
/*  876 */ { "opt_def_init",  "opt_def_init", 0, 0, 0, 0, -1, 239, 0, 0, 251, -1, 0, 0 },
/*  877 */ { "var_def",  "var_def", 0, 0, 0, 0, -1, 240, 0, 0, 252, -1, 0, 0 },
/*  878 */ { "print_stmt",  "print_stmt", 0, 0, 0, 0, -1, 241, 0, 0, 253, -1, 0, 0 },
/*  879 */ { "expr_stmt",  "expr_stmt", 0, 0, 0, 0, -1, 242, 0, 0, 254, -1, 0, 0 },
/*  880 */ { "code_expr",  "code_expr", 0, 0, 0, 0, -1, 243, 0, 0, 255, -1, 0, 0 },
/*  881 */ { "code_relational",  "code_relational", 0, 0, 0, 0, -1, 244, 0, 0, 256, -1, 0, 0 },
/*  882 */ { "code_additive",  "code_additive", 0, 0, 0, 0, -1, 245, 0, 0, 257, -1, 0, 0 },
/*  883 */ { "code_multiplicitive",  "code_multiplicitive", 0, 0, 0, 0, -1, 246, 0, 0, 258, -1, 0, 0 },
/*  884 */ { "code_unary",  "code_unary", 0, 0, 0, 0, -1, 247, 0, 0, 259, -1, 0, 0 },
/*  885 */ { "opt_eos",  "opt_eos", 0, 0, 0, 0, -1, 248, 0, 0, 260, -1, 0, 0 },
/*  886 */ { "code_factor",  "code_factor", 0, 0, 0, 0, -1, 249, 0, 0, 261, -1, 0, 0 },
/*  887 */ { "type_ref",  "type_ref", 0, 0, 0, 0, -1, 250, 0, 0, 262, -1, 0, 0 },
/*  888 */ { "region_qual",  "region_qual", 0, 0, 0, 0, -1, 251, 0, 0, 263, -1, 0, 0 },
/*  889 */ { "opt_repeat",  "opt_repeat", 0, 0, 0, 0, -1, 252, 0, 0, 264, -1, 0, 0 },
/*  890 */ { "opt_capture",  "opt_capture", 0, 0, 0, 0, -1, 253, 0, 0, 265, -1, 0, 0 },
/*  891 */ { "opt_field_init",  "opt_field_init", 0, 0, 0, 0, -1, 254, 0, 0, 266, -1, 0, 0 },
/*  892 */ { "field_init",  "field_init", 0, 0, 0, 0, -1, 255, 0, 0, 267, -1, 0, 0 },
/*  893 */ { "stmt_or_factor",  "stmt_or_factor", 0, 0, 0, 0, -1, 256, 0, 0, 268, -1, 0, 0 },
/*  894 */ { "opt_label",  "opt_label", 0, 0, 0, 0, -1, 257, 0, 0, 269, -1, 0, 0 },
/*  895 */ { "dq_lit_term",  "dq_lit_term", 0, 0, 0, 0, -1, 258, 0, 0, 270, -1, 0, 0 },
/*  896 */ { "sq_lit_term",  "sq_lit_term", 0, 0, 0, 0, -1, 259, 0, 0, 271, -1, 0, 0 },
/*  897 */ { "opt_tilde_data",  "opt_tilde_data", 0, 0, 0, 0, -1, 260, 0, 0, 272, -1, 0, 0 },
/*  898 */ { "pattern_el_lel",  "pattern_el_lel", 0, 0, 0, 0, -1, 261, 0, 0, 273, -1, 0, 0 },
/*  899 */ { "pattern_el",  "pattern_el", 0, 0, 0, 0, -1, 262, 0, 0, 274, -1, 0, 0 },
/*  900 */ { "litpat_el",  "litpat_el", 0, 0, 0, 0, -1, 263, 0, 0, 275, -1, 0, 0 },
/*  901 */ { "pattern_top_el",  "pattern_top_el", 0, 0, 0, 0, -1, 264, 0, 0, 276, -1, 0, 0 },
/*  902 */ { "pattern_list",  "pattern_list", 0, 0, 0, 0, -1, 265, 0, 0, 277, -1, 0, 0 },
/*  903 */ { "pattern",  "pattern", 0, 0, 0, 0, -1, 266, 0, 0, 278, -1, 0, 0 },
/*  904 */ { "E1",  "E1", 0, 0, 0, 0, -1, 267, 0, 0, 279, -1, 0, 0 },
/*  905 */ { "E2",  "E2", 0, 0, 0, 0, -1, 268, 0, 0, 280, -1, 0, 0 },
/*  906 */ { "E3",  "E3", 0, 0, 0, 0, -1, 269, 0, 0, 281, -1, 0, 0 },
/*  907 */ { "E4",  "E4", 0, 0, 0, 0, -1, 270, 0, 0, 282, -1, 0, 0 },
/*  908 */ { "cons_el",  "cons_el", 0, 0, 0, 0, -1, 271, 0, 0, 283, -1, 0, 0 },
/*  909 */ { "lit_cons_el",  "lit_cons_el", 0, 0, 0, 0, -1, 272, 0, 0, 284, -1, 0, 0 },
/*  910 */ { "cons_top_el",  "cons_top_el", 0, 0, 0, 0, -1, 273, 0, 0, 285, -1, 0, 0 },
/*  911 */ { "cons_list",  "cons_list", 0, 0, 0, 0, -1, 274, 0, 0, 286, -1, 0, 0 },
/*  912 */ { "constructor",  "constructor", 0, 0, 0, 0, -1, 275, 0, 0, 287, -1, 0, 0 },
/*  913 */ { "accum_el",  "accum_el", 0, 0, 0, 0, -1, 276, 0, 0, 288, -1, 0, 0 },
/*  914 */ { "lit_accum_el",  "lit_accum_el", 0, 0, 0, 0, -1, 277, 0, 0, 289, -1, 0, 0 },
/*  915 */ { "accum_top_el",  "accum_top_el", 0, 0, 0, 0, -1, 278, 0, 0, 290, -1, 0, 0 },
/*  916 */ { "accum_list",  "accum_list", 0, 0, 0, 0, -1, 279, 0, 0, 291, -1, 0, 0 },
/*  917 */ { "accumulate",  "accumulate", 0, 0, 0, 0, -1, 280, 0, 0, 292, -1, 0, 0 },
/*  918 */ { "string_el",  "string_el", 0, 0, 0, 0, -1, 281, 0, 0, 293, -1, 0, 0 },
/*  919 */ { "lit_string_el",  "lit_string_el", 0, 0, 0, 0, -1, 282, 0, 0, 294, -1, 0, 0 },
/*  920 */ { "string_top_el",  "string_top_el", 0, 0, 0, 0, -1, 283, 0, 0, 295, -1, 0, 0 },
/*  921 */ { "string_list",  "string_list", 0, 0, 0, 0, -1, 284, 0, 0, 296, -1, 0, 0 },
/*  922 */ { "string",  "string", 0, 0, 0, 0, -1, 285, 0, 0, 297, -1, 0, 0 },
/*  923 */ { "var_ref",  "var_ref", 0, 0, 0, 0, -1, 286, 0, 0, 298, -1, 0, 0 },
/*  924 */ { "qual",  "qual", 0, 0, 0, 0, -1, 287, 0, 0, 299, -1, 0, 0 },
/*  925 */ { "lex_expr",  "lex_expr", 0, 0, 0, 0, -1, 288, 0, 0, 300, -1, 0, 0 },
/*  926 */ { "opt_lex_dot",  "opt_lex_dot", 0, 0, 0, 0, -1, 289, 0, 0, 301, -1, 0, 0 },
/*  927 */ { "lex_term",  "lex_term", 0, 0, 0, 0, -1, 290, 0, 0, 302, -1, 0, 0 },
/*  928 */ { "lex_factor_rep",  "lex_factor_rep", 0, 0, 0, 0, -1, 291, 0, 0, 303, -1, 0, 0 },
/*  929 */ { "lex_factor_neg",  "lex_factor_neg", 0, 0, 0, 0, -1, 292, 0, 0, 304, -1, 0, 0 },
/*  930 */ { "lex_range_lit",  "lex_range_lit", 0, 0, 0, 0, -1, 293, 0, 0, 305, -1, 0, 0 },
/*  931 */ { "lex_num",  "lex_num", 0, 0, 0, 0, -1, 294, 0, 0, 306, -1, 0, 0 },
/*  932 */ { "lex_factor",  "lex_factor", 0, 0, 0, 0, -1, 295, 0, 0, 307, -1, 0, 0 },
/*  933 */ { "reg_or_data",  "reg_or_data", 0, 0, 0, 0, -1, 296, 0, 0, 308, -1, 0, 0 },
/*  934 */ { "reg_or_char",  "reg_or_char", 0, 0, 0, 0, -1, 297, 0, 0, 309, -1, 0, 0 },
/*  935 */ { "_lrepeat_root_item",  "_lrepeat_root_item", 1, 0, 0, 0, -1, 0, 0, 0, 310, -1, 0, 0 },
/*  936 */ { "_lrepeat_sq_cons_data",  "_lrepeat_sq_cons_data", 1, 0, 0, 0, -1, 0, 0, 0, 311, -1, 0, 0 },
/*  937 */ { "_lrepeat_struct_item",  "_lrepeat_struct_item", 1, 0, 0, 0, -1, 0, 0, 0, 312, -1, 0, 0 },
/*  938 */ { "_lrepeat_reduction_item",  "_lrepeat_reduction_item", 1, 0, 0, 0, -1, 0, 0, 0, 313, -1, 0, 0 },
/*  939 */ { "_lrepeat_host_item",  "_lrepeat_host_item", 1, 0, 0, 0, -1, 0, 0, 0, 314, -1, 0, 0 },
/*  940 */ { "_lrepeat_namespace_item",  "_lrepeat_namespace_item", 1, 0, 0, 0, -1, 0, 0, 0, 315, -1, 0, 0 },
/*  941 */ { "_lrepeat_var_def",  "_lrepeat_var_def", 1, 0, 0, 0, -1, 0, 0, 0, 316, -1, 0, 0 },
/*  942 */ { "_lrepeat_statement",  "_lrepeat_statement", 1, 0, 0, 0, -1, 0, 0, 0, 317, -1, 0, 0 },
/*  943 */ { "_lrepeat_field_init",  "_lrepeat_field_init", 1, 0, 0, 0, -1, 0, 0, 0, 318, -1, 0, 0 },
/*  944 */ { "_lrepeat_litpat_el",  "_lrepeat_litpat_el", 1, 0, 0, 0, -1, 0, 0, 0, 319, -1, 0, 0 },
/*  945 */ { "_lrepeat_pattern_el",  "_lrepeat_pattern_el", 1, 0, 0, 0, -1, 0, 0, 0, 320, -1, 0, 0 },
/*  946 */ { "_lrepeat_lit_cons_el",  "_lrepeat_lit_cons_el", 1, 0, 0, 0, -1, 0, 0, 0, 321, -1, 0, 0 },
/*  947 */ { "_lrepeat_cons_el",  "_lrepeat_cons_el", 1, 0, 0, 0, -1, 0, 0, 0, 322, -1, 0, 0 },
/*  948 */ { "_lrepeat_lit_accum_el",  "_lrepeat_lit_accum_el", 1, 0, 0, 0, -1, 0, 0, 0, 323, -1, 0, 0 },
/*  949 */ { "_lrepeat_accum_el",  "_lrepeat_accum_el", 1, 0, 0, 0, -1, 0, 0, 0, 324, -1, 0, 0 },
/*  950 */ { "_lrepeat_lit_string_el",  "_lrepeat_lit_string_el", 1, 0, 0, 0, -1, 0, 0, 0, 325, -1, 0, 0 },
/*  951 */ { "_lrepeat_string_el",  "_lrepeat_string_el", 1, 0, 0, 0, -1, 0, 0, 0, 326, -1, 0, 0 },
/*  952 */ { "_root",  "_root", 0, 0, 0, 0, -1, 0, 0, 0, 0, -1, 0, 0 }
};

static short struct_trees_0[] = {
	0, 1, 7, 
};

static short struct_trees_3[] = {
	0, 1, 
};

static short struct_trees_5[] = {
	0, 
};

static struct struct_el_info parser_selInfo[] = {
	{ 8, struct_trees_0, 3,  },
	{ 0, 0, 0,  },
	{ 0, 0, 0,  },
	{ 8, struct_trees_3, 2,  },
	{ 3, 0, 0,  },
	{ 3, struct_trees_5, 1,  },

};

static struct frame_info parser_frameInfo[] = {
	{ "cons_prod", code_0_wv, 141, code_0_wc, 141, locals_0, 2, 1, 1 },
	{ "rewrite_cfl_def", code_1_wv, 260, code_1_wc, 259, locals_1, 7, 2, 16 },
	{ "rewrite", code_2_wv, 159, code_2_wc, 159, locals_2, 4, 2, 13 },
	{ "", 0, 0, 0, 0, locals_3, 2, 0, 3 }
};

static struct prod_info parser_prodInfo[] = {
	{ 804, 0, 1, "start-1", -1, 1, copy_0, 1,  },
	{ 805, 0, 1, "root_item-1", -1, 1, copy_1, 1,  },
	{ 805, 1, 1, "root_item-2", -1, 1, copy_2, 1,  },
	{ 805, 2, 1, "root_item-3", -1, 1, copy_3, 1,  },
	{ 805, 3, 1, "root_item-4", -1, 1, copy_4, 1,  },
	{ 805, 4, 1, "root_item-5", -1, 1, copy_5, 1,  },
	{ 805, 5, 1, "root_item-6", -1, 1, copy_6, 1,  },
	{ 805, 6, 1, "root_item-7", -1, 1, copy_7, 1,  },
	{ 805, 7, 1, "root_item-8", -1, 1, copy_8, 1,  },
	{ 805, 8, 1, "root_item-9", -1, 1, copy_9, 1,  },
	{ 805, 9, 1, "root_item-10", -1, 1, copy_10, 1,  },
	{ 805, 10, 1, "root_item-11", -1, 1, copy_11, 1,  },
	{ 805, 11, 1, "root_item-12", -1, 1, copy_12, 1,  },
	{ 805, 12, 1, "root_item-13", -1, 1, copy_13, 1,  },
	{ 805, 13, 1, "root_item-14", -1, 1, copy_14, 1,  },
	{ 805, 14, 1, "root_item-15", -1, 1, copy_15, 1,  },
	{ 805, 15, 1, "root_item-16", -1, 1, copy_16, 1,  },
	{ 805, 16, 1, "root_item-17", -1, 1, copy_17, 1,  },
	{ 805, 17, 1, "root_item-18", -1, 1, copy_18, 1,  },
	{ 805, 18, 1, "root_item-19", -1, 1, copy_19, 1,  },
	{ 805, 19, 1, "root_item-20", -1, 1, copy_20, 1,  },
	{ 805, 20, 1, "root_item-21", -1, 1, copy_21, 1,  },
	{ 806, 0, 4, "_include-1", -1, 1, copy_22, 4,  },
	{ 807, 0, 2, "precedence_def-1", -1, 1, copy_23, 2,  },
	{ 808, 0, 1, "pred_type-1", -1, 1, copy_24, 1,  },
	{ 808, 1, 1, "pred_type-2", -1, 1, copy_25, 1,  },
	{ 808, 2, 1, "pred_type-3", -1, 1, copy_26, 1,  },
	{ 809, 0, 3, "pred_token_list-1", -1, 1, copy_27, 3,  },
	{ 809, 1, 1, "pred_token_list-2", -1, 1, copy_28, 1,  },
	{ 810, 0, 2, "pred_token-1", -1, 1, copy_29, 2,  },
	{ 810, 1, 2, "pred_token-2", -1, 1, copy_30, 2,  },
	{ 811, 0, 4, "pre_eof_def-1", -1, 1, copy_31, 4,  },
	{ 812, 0, 3, "alias_def-1", -1, 1, copy_32, 3,  },
	{ 813, 0, 1, "struct_item-1", -1, 1, copy_33, 1,  },
	{ 813, 1, 1, "struct_item-2", -1, 1, copy_34, 1,  },
	{ 813, 2, 1, "struct_item-3", -1, 1, copy_35, 1,  },
	{ 813, 3, 1, "struct_item-4", -1, 1, copy_36, 1,  },
	{ 813, 4, 1, "struct_item-5", -1, 1, copy_37, 1,  },
	{ 813, 5, 1, "struct_item-6", -1, 1, copy_38, 1,  },
	{ 813, 6, 1, "struct_item-7", -1, 1, copy_39, 1,  },
	{ 813, 7, 1, "struct_item-8", -1, 1, copy_40, 1,  },
	{ 813, 8, 1, "struct_item-9", -1, 1, copy_41, 1,  },
	{ 813, 9, 1, "struct_item-10", -1, 1, copy_42, 1,  },
	{ 813, 10, 1, "struct_item-11", -1, 1, copy_43, 1,  },
	{ 813, 11, 1, "struct_item-12", -1, 1, copy_44, 1,  },
	{ 813, 12, 1, "struct_item-13", -1, 1, copy_45, 1,  },
	{ 813, 13, 1, "struct_item-14", -1, 1, copy_46, 1,  },
	{ 813, 14, 1, "struct_item-15", -1, 1, copy_47, 1,  },
	{ 813, 15, 1, "struct_item-16", -1, 1, copy_48, 1,  },
	{ 814, 0, 3, "export_def-1", -1, 1, copy_49, 3,  },
	{ 815, 0, 3, "global_def-1", -1, 1, copy_50, 3,  },
	{ 816, 0, 8, "iter_def-1", -1, 1, copy_51, 8,  },
	{ 817, 0, 4, "reference_type_ref-1", -1, 1, copy_52, 4,  },
	{ 818, 0, 3, "param_var_def_seq-1", -1, 1, copy_53, 3,  },
	{ 818, 1, 1, "param_var_def_seq-2", -1, 1, copy_54, 1,  },
	{ 819, 0, 1, "param_var_def_list-1", -1, 1, copy_55, 1,  },
	{ 819, 1, 0, "param_var_def_list-2", -1, 1, 0, 0,  },
	{ 820, 0, 3, "param_var_def-1", -1, 1, copy_57, 3,  },
	{ 820, 1, 3, "param_var_def-2", -1, 1, copy_58, 3,  },
	{ 821, 0, 1, "opt_export-1", -1, 1, copy_59, 1,  },
	{ 821, 1, 0, "opt_export-2", -1, 1, 0, 0,  },
	{ 822, 0, 9, "function_def-1", -1, 1, copy_61, 9,  },
	{ 823, 0, 8, "in_host_def-1", -1, 1, copy_62, 8,  },
	{ 824, 0, 1, "struct_var_def-1", -1, 1, copy_63, 1,  },
	{ 825, 0, 1, "struct_key-1", -1, 1, copy_64, 1,  },
	{ 825, 1, 1, "struct_key-2", -1, 1, copy_65, 1,  },
	{ 826, 0, 4, "struct_def-1", -1, 1, copy_66, 4,  },
	{ 827, 0, 1, "literal_keyword-1", -1, 1, copy_67, 1,  },
	{ 827, 1, 1, "literal_keyword-2", -1, 1, copy_68, 1,  },
	{ 828, 0, 2, "literal_def-1", -1, 1, copy_69, 2,  },
	{ 829, 0, 2, "literal_list-1", -1, 1, copy_70, 2,  },
	{ 829, 1, 1, "literal_list-2", -1, 1, copy_71, 1,  },
	{ 830, 0, 3, "literal_item-1", -1, 1, copy_72, 3,  },
	{ 831, 0, 2, "no_ignore_left-1", -1, 1, copy_73, 2,  },
	{ 831, 1, 0, "no_ignore_left-2", -1, 1, 0, 0,  },
	{ 832, 0, 2, "no_ignore_right-1", -1, 1, copy_75, 2,  },
	{ 832, 1, 0, "no_ignore_right-2", -1, 1, 0, 0,  },
	{ 833, 0, 4, "reduction_def-1", -1, 1, copy_77, 4,  },
	{ 834, 0, 4, "red_nonterm-1", -1, 1, copy_78, 4,  },
	{ 835, 0, 6, "red_action-1", -1, 1, copy_79, 6,  },
	{ 836, 0, 1, "host_item-1", -1, 1, copy_80, 1,  },
	{ 836, 1, 1, "host_item-2", -1, 1, copy_81, 1,  },
	{ 836, 2, 1, "host_item-3", -1, 1, copy_82, 1,  },
	{ 836, 3, 1, "host_item-4", -1, 1, copy_83, 1,  },
	{ 836, 4, 1, "host_item-5", -1, 1, copy_84, 1,  },
	{ 836, 5, 1, "host_item-6", -1, 1, copy_85, 1,  },
	{ 836, 6, 1, "host_item-7", -1, 1, copy_86, 1,  },
	{ 836, 7, 1, "host_item-8", -1, 1, copy_87, 1,  },
	{ 836, 8, 1, "host_item-9", -1, 1, copy_88, 1,  },
	{ 836, 9, 1, "host_item-10", -1, 1, copy_89, 1,  },
	{ 836, 10, 1, "host_item-11", -1, 1, copy_90, 1,  },
	{ 836, 11, 1, "host_item-12", -1, 1, copy_91, 1,  },
	{ 836, 12, 3, "host_item-13", -1, 1, copy_92, 3,  },
	{ 837, 0, 1, "reduction_item-1", -1, 1, copy_93, 1,  },
	{ 837, 1, 1, "reduction_item-2", -1, 1, copy_94, 1,  },
	{ 838, 0, 4, "namespace_def-1", -1, 1, copy_95, 4,  },
	{ 839, 0, 1, "namespace_item-1", -1, 1, copy_96, 1,  },
	{ 839, 1, 1, "namespace_item-2", -1, 1, copy_97, 1,  },
	{ 839, 2, 1, "namespace_item-3", -1, 1, copy_98, 1,  },
	{ 839, 3, 1, "namespace_item-4", -1, 1, copy_99, 1,  },
	{ 839, 4, 1, "namespace_item-5", -1, 1, copy_100, 1,  },
	{ 839, 5, 1, "namespace_item-6", -1, 1, copy_101, 1,  },
	{ 839, 6, 1, "namespace_item-7", -1, 1, copy_102, 1,  },
	{ 839, 7, 1, "namespace_item-8", -1, 1, copy_103, 1,  },
	{ 839, 8, 1, "namespace_item-9", -1, 1, copy_104, 1,  },
	{ 839, 9, 1, "namespace_item-10", -1, 1, copy_105, 1,  },
	{ 839, 10, 1, "namespace_item-11", -1, 1, copy_106, 1,  },
	{ 839, 11, 1, "namespace_item-12", -1, 1, copy_107, 1,  },
	{ 839, 12, 1, "namespace_item-13", -1, 1, copy_108, 1,  },
	{ 839, 13, 1, "namespace_item-14", -1, 1, copy_109, 1,  },
	{ 839, 14, 1, "namespace_item-15", -1, 1, copy_110, 1,  },
	{ 839, 15, 1, "namespace_item-16", -1, 1, copy_111, 1,  },
	{ 839, 16, 1, "namespace_item-17", -1, 1, copy_112, 1,  },
	{ 840, 0, 0, "obj_var_list-1", -1, 1, 0, 0,  },
	{ 841, 0, 1, "opt_reduce_first-1", -1, 1, copy_114, 1,  },
	{ 841, 1, 0, "opt_reduce_first-2", -1, 1, 0, 0,  },
	{ 842, 0, 5, "cfl_def-1", -1, 1, copy_116, 5,  },
	{ 843, 0, 5, "cfl_redef-1", -1, 1, copy_117, 5,  },
	{ 844, 0, 3, "region_def-1", -1, 1, copy_118, 3,  },
	{ 845, 0, 5, "rl_def-1", -1, 1, copy_119, 5,  },
	{ 846, 0, 1, "opt_lex_expr-1", -1, 1, copy_120, 1,  },
	{ 846, 1, 0, "opt_lex_expr-2", -1, 1, 0, 0,  },
	{ 847, 0, 9, "token_def-1", -1, 1, copy_122, 9,  },
	{ 848, 0, 3, "ic_def-1", -1, 1, copy_123, 3,  },
	{ 849, 0, 3, "opt_translate-1", -1, 1, copy_124, 3,  },
	{ 849, 1, 0, "opt_translate-2", -1, 1, 0, 0,  },
	{ 850, 0, 1, "opt_id-1", -1, 1, copy_126, 1,  },
	{ 850, 1, 0, "opt_id-2", -1, 1, 0, 0,  },
	{ 851, 0, 5, "ignore_def-1", -1, 1, copy_128, 5,  },
	{ 852, 0, 3, "prod_sublist-1", -1, 1, copy_129, 3,  },
	{ 852, 1, 1, "prod_sublist-2", -1, 1, copy_130, 1,  },
	{ 853, 0, 4, "prod_el-1", -1, 1, copy_131, 4,  },
	{ 853, 1, 4, "prod_el-2", -1, 1, copy_132, 4,  },
	{ 853, 2, 5, "prod_el-3", -1, 1, copy_133, 5,  },
	{ 854, 0, 2, "opt_prod_el_name-1", -1, 1, copy_134, 2,  },
	{ 854, 1, 0, "opt_prod_el_name-2", -1, 1, 0, 0,  },
	{ 855, 0, 2, "prod_el_list-1", -1, 1, copy_136, 2,  },
	{ 855, 1, 0, "prod_el_list-2", -1, 1, 0, 0,  },
	{ 856, 0, 1, "opt_commit-1", -1, 1, copy_138, 1,  },
	{ 856, 1, 0, "opt_commit-2", -1, 1, 0, 0,  },
	{ 857, 0, 2, "opt_prod_name-1", -1, 1, copy_140, 2,  },
	{ 857, 1, 0, "opt_prod_name-2", -1, 1, 0, 0,  },
	{ 858, 0, 6, "prod-1", -1, 1, copy_142, 6,  },
	{ 858, 1, 3, "prod-2", -1, 1, copy_143, 3,  },
	{ 859, 0, 3, "opt_reduce-1", -1, 1, copy_144, 3,  },
	{ 859, 1, 0, "opt_reduce-2", -1, 1, 0, 0,  },
	{ 860, 0, 3, "prod_list-1", -1, 1, copy_146, 3,  },
	{ 860, 1, 1, "prod_list-2", -1, 1, copy_147, 1,  },
	{ 861, 0, 3, "case_clause-1", -1, 1, copy_148, 3,  },
	{ 861, 1, 3, "case_clause-2", -1, 1, copy_149, 3,  },
	{ 861, 2, 4, "case_clause-3", -1, 1, copy_150, 4,  },
	{ 862, 0, 2, "default_clause-1", -1, 1, copy_151, 2,  },
	{ 863, 0, 2, "case_clause_list-1", -1, 1, copy_152, 2,  },
	{ 863, 1, 1, "case_clause_list-2", -1, 1, copy_153, 1,  },
	{ 863, 2, 1, "case_clause_list-3", -1, 1, copy_154, 1,  },
	{ 864, 0, 1, "bare_tok-1", -1, 1, copy_155, 1,  },
	{ 864, 1, 1, "bare_tok-2", -1, 1, copy_156, 1,  },
	{ 865, 0, 1, "statement-1", -1, 1, copy_157, 1,  },
	{ 865, 1, 2, "statement-2", -1, 1, copy_158, 2,  },
	{ 865, 2, 7, "statement-3", -1, 1, copy_159, 7,  },
	{ 865, 3, 4, "statement-4", -1, 1, copy_160, 4,  },
	{ 865, 4, 3, "statement-5", -1, 1, copy_161, 3,  },
	{ 865, 5, 5, "statement-6", -1, 1, copy_162, 5,  },
	{ 865, 6, 3, "statement-7", -1, 1, copy_163, 3,  },
	{ 865, 7, 3, "statement-8", -1, 1, copy_164, 3,  },
	{ 865, 8, 2, "statement-9", -1, 1, copy_165, 2,  },
	{ 865, 9, 2, "statement-10", -1, 1, copy_166, 2,  },
	{ 865, 10, 1, "statement-11", -1, 1, copy_167, 1,  },
	{ 865, 11, 1, "statement-12", -1, 1, copy_168, 1,  },
	{ 865, 12, 4, "statement-13", -1, 1, copy_169, 4,  },
	{ 865, 13, 1, "statement-14", -1, 1, copy_170, 1,  },
	{ 865, 14, 3, "statement-15", -1, 1, copy_171, 3,  },
	{ 866, 0, 2, "elsif_list-1", -1, 1, copy_172, 2,  },
	{ 866, 1, 1, "elsif_list-2", -1, 1, copy_173, 1,  },
	{ 867, 0, 3, "elsif_clause-1", -1, 1, copy_174, 3,  },
	{ 868, 0, 2, "optional_else-1", -1, 1, copy_175, 2,  },
	{ 868, 1, 0, "optional_else-2", -1, 1, 0, 0,  },
	{ 869, 0, 3, "call_arg_seq-1", -1, 1, copy_177, 3,  },
	{ 869, 1, 1, "call_arg_seq-2", -1, 1, copy_178, 1,  },
	{ 870, 0, 1, "call_arg_list-1", -1, 1, copy_179, 1,  },
	{ 870, 1, 0, "call_arg_list-2", -1, 1, 0, 0,  },
	{ 871, 0, 5, "iter_call-1", -1, 1, copy_181, 5,  },
	{ 871, 1, 2, "iter_call-2", -1, 1, copy_182, 2,  },
	{ 871, 2, 2, "iter_call-3", -1, 1, copy_183, 2,  },
	{ 872, 0, 3, "block_or_single-1", -1, 1, copy_184, 3,  },
	{ 872, 1, 1, "block_or_single-2", -1, 1, copy_185, 1,  },
	{ 873, 0, 3, "require_pattern-1", -1, 1, copy_186, 3,  },
	{ 874, 0, 2, "opt_require_stmt-1", -1, 1, copy_187, 2,  },
	{ 874, 1, 0, "opt_require_stmt-2", -1, 1, 0, 0,  },
	{ 875, 0, 2, "lang_stmt_list-1", -1, 1, copy_189, 2,  },
	{ 876, 0, 2, "opt_def_init-1", -1, 1, copy_190, 2,  },
	{ 876, 1, 0, "opt_def_init-2", -1, 1, 0, 0,  },
	{ 877, 0, 3, "var_def-1", -1, 1, copy_192, 3,  },
	{ 878, 0, 4, "print_stmt-1", -1, 1, copy_193, 4,  },
	{ 878, 1, 6, "print_stmt-2", -1, 1, copy_194, 6,  },
	{ 878, 2, 2, "print_stmt-3", -1, 1, copy_195, 2,  },
	{ 879, 0, 1, "expr_stmt-1", -1, 1, copy_196, 1,  },
	{ 880, 0, 3, "code_expr-1", -1, 1, copy_197, 3,  },
	{ 880, 1, 3, "code_expr-2", -1, 1, copy_198, 3,  },
	{ 880, 2, 1, "code_expr-3", -1, 1, copy_199, 1,  },
	{ 881, 0, 3, "code_relational-1", -1, 1, copy_200, 3,  },
	{ 881, 1, 3, "code_relational-2", -1, 1, copy_201, 3,  },
	{ 881, 2, 3, "code_relational-3", -1, 1, copy_202, 3,  },
	{ 881, 3, 3, "code_relational-4", -1, 1, copy_203, 3,  },
	{ 881, 4, 3, "code_relational-5", -1, 1, copy_204, 3,  },
	{ 881, 5, 3, "code_relational-6", -1, 1, copy_205, 3,  },
	{ 881, 6, 1, "code_relational-7", -1, 1, copy_206, 1,  },
	{ 882, 0, 3, "code_additive-1", -1, 1, copy_207, 3,  },
	{ 882, 1, 3, "code_additive-2", -1, 1, copy_208, 3,  },
	{ 882, 2, 1, "code_additive-3", -1, 1, copy_209, 1,  },
	{ 883, 0, 3, "code_multiplicitive-1", -1, 1, copy_210, 3,  },
	{ 883, 1, 3, "code_multiplicitive-2", -1, 1, copy_211, 3,  },
	{ 883, 2, 1, "code_multiplicitive-3", -1, 1, copy_212, 1,  },
	{ 884, 0, 2, "code_unary-1", -1, 1, copy_213, 2,  },
	{ 884, 1, 2, "code_unary-2", -1, 1, copy_214, 2,  },
	{ 884, 2, 3, "code_unary-3", -1, 1, copy_215, 3,  },
	{ 884, 3, 2, "code_unary-4", -1, 1, copy_216, 2,  },
	{ 884, 4, 2, "code_unary-5", -1, 1, copy_217, 2,  },
	{ 884, 5, 2, "code_unary-6", -1, 1, copy_218, 2,  },
	{ 884, 6, 1, "code_unary-7", -1, 1, copy_219, 1,  },
	{ 885, 0, 1, "opt_eos-1", -1, 1, copy_220, 1,  },
	{ 885, 1, 1, "opt_eos-2", -1, 1, copy_221, 1,  },
	{ 885, 2, 0, "opt_eos-3", -1, 1, 0, 0,  },
	{ 886, 0, 1, "code_factor-1", -1, 1, copy_223, 1,  },
	{ 886, 1, 4, "code_factor-2", -1, 1, copy_224, 4,  },
	{ 886, 2, 1, "code_factor-3", -1, 1, copy_225, 1,  },
	{ 886, 3, 1, "code_factor-4", -1, 1, copy_226, 1,  },
	{ 886, 4, 1, "code_factor-5", -1, 1, copy_227, 1,  },
	{ 886, 5, 1, "code_factor-6", -1, 1, copy_228, 1,  },
	{ 886, 6, 3, "code_factor-7", -1, 1, copy_229, 3,  },
	{ 886, 7, 1, "code_factor-8", -1, 1, copy_230, 1,  },
	{ 886, 8, 3, "code_factor-9", -1, 1, copy_231, 3,  },
	{ 886, 9, 4, "code_factor-10", -1, 1, copy_232, 4,  },
	{ 886, 10, 5, "code_factor-11", -1, 1, copy_233, 5,  },
	{ 886, 11, 1, "code_factor-12", -1, 1, copy_234, 1,  },
	{ 887, 0, 3, "type_ref-1", -1, 1, copy_235, 3,  },
	{ 887, 1, 1, "type_ref-2", -1, 1, copy_236, 1,  },
	{ 887, 2, 1, "type_ref-3", -1, 1, copy_237, 1,  },
	{ 887, 3, 1, "type_ref-4", -1, 1, copy_238, 1,  },
	{ 887, 4, 4, "type_ref-5", -1, 1, copy_239, 4,  },
	{ 887, 5, 4, "type_ref-6", -1, 1, copy_240, 4,  },
	{ 887, 6, 6, "type_ref-7", -1, 1, copy_241, 6,  },
	{ 887, 7, 4, "type_ref-8", -1, 1, copy_242, 4,  },
	{ 887, 8, 6, "type_ref-9", -1, 1, copy_243, 6,  },
	{ 888, 0, 3, "region_qual-1", -1, 1, copy_244, 3,  },
	{ 888, 1, 0, "region_qual-2", -1, 1, 0, 0,  },
	{ 889, 0, 1, "opt_repeat-1", -1, 1, copy_246, 1,  },
	{ 889, 1, 1, "opt_repeat-2", -1, 1, copy_247, 1,  },
	{ 889, 2, 1, "opt_repeat-3", -1, 1, copy_248, 1,  },
	{ 889, 3, 2, "opt_repeat-4", -1, 1, copy_249, 2,  },
	{ 889, 4, 2, "opt_repeat-5", -1, 1, copy_250, 2,  },
	{ 889, 5, 0, "opt_repeat-6", -1, 1, 0, 0,  },
	{ 890, 0, 2, "opt_capture-1", -1, 1, copy_252, 2,  },
	{ 890, 1, 0, "opt_capture-2", -1, 1, 0, 0,  },
	{ 891, 0, 3, "opt_field_init-1", -1, 1, copy_254, 3,  },
	{ 891, 1, 0, "opt_field_init-2", -1, 1, 0, 0,  },
	{ 892, 0, 1, "field_init-1", -1, 1, copy_256, 1,  },
	{ 893, 0, 5, "stmt_or_factor-1", -1, 1, copy_257, 5,  },
	{ 893, 1, 5, "stmt_or_factor-2", -1, 1, copy_258, 5,  },
	{ 893, 2, 5, "stmt_or_factor-3", -1, 1, copy_259, 5,  },
	{ 893, 3, 5, "stmt_or_factor-4", -1, 1, copy_260, 5,  },
	{ 893, 4, 5, "stmt_or_factor-5", -1, 1, copy_261, 5,  },
	{ 893, 5, 4, "stmt_or_factor-6", -1, 1, copy_262, 4,  },
	{ 893, 6, 4, "stmt_or_factor-7", -1, 1, copy_263, 4,  },
	{ 893, 7, 4, "stmt_or_factor-8", -1, 1, copy_264, 4,  },
	{ 893, 8, 4, "stmt_or_factor-9", -1, 1, copy_265, 4,  },
	{ 893, 9, 5, "stmt_or_factor-10", -1, 1, copy_266, 5,  },
	{ 893, 10, 3, "stmt_or_factor-11", -1, 1, copy_267, 3,  },
	{ 893, 11, 6, "stmt_or_factor-12", -1, 1, copy_268, 6,  },
	{ 894, 0, 2, "opt_label-1", -1, 1, copy_269, 2,  },
	{ 894, 1, 0, "opt_label-2", -1, 1, 0, 0,  },
	{ 895, 0, 1, "dq_lit_term-1", -1, 1, copy_271, 1,  },
	{ 895, 1, 1, "dq_lit_term-2", -1, 1, copy_272, 1,  },
	{ 896, 0, 1, "sq_lit_term-1", -1, 1, copy_273, 1,  },
	{ 896, 1, 1, "sq_lit_term-2", -1, 1, copy_274, 1,  },
	{ 897, 0, 1, "opt_tilde_data-1", -1, 1, copy_275, 1,  },
	{ 897, 1, 0, "opt_tilde_data-2", -1, 1, 0, 0,  },
	{ 898, 0, 3, "pattern_el_lel-1", -1, 1, copy_277, 3,  },
	{ 898, 1, 3, "pattern_el_lel-2", -1, 1, copy_278, 3,  },
	{ 899, 0, 2, "pattern_el-1", -1, 1, copy_279, 2,  },
	{ 899, 1, 3, "pattern_el-2", -1, 1, copy_280, 3,  },
	{ 899, 2, 3, "pattern_el-3", -1, 1, copy_281, 3,  },
	{ 899, 3, 3, "pattern_el-4", -1, 1, copy_282, 3,  },
	{ 900, 0, 1, "litpat_el-1", -1, 1, copy_283, 1,  },
	{ 900, 1, 3, "litpat_el-2", -1, 1, copy_284, 3,  },
	{ 901, 0, 3, "pattern_top_el-1", -1, 1, copy_285, 3,  },
	{ 901, 1, 3, "pattern_top_el-2", -1, 1, copy_286, 3,  },
	{ 901, 2, 3, "pattern_top_el-3", -1, 1, copy_287, 3,  },
	{ 902, 0, 2, "pattern_list-1", -1, 1, copy_288, 2,  },
	{ 902, 1, 1, "pattern_list-2", -1, 1, copy_289, 1,  },
	{ 903, 0, 1, "pattern-1", -1, 1, copy_290, 1,  },
	{ 903, 1, 3, "pattern-2", -1, 1, copy_291, 3,  },
	{ 904, 0, 0, "E1-1", -1, 1, 0, 0,  },
	{ 905, 0, 0, "E2-1", -1, 1, 0, 0,  },
	{ 906, 0, 0, "E3-1", -1, 1, 0, 0,  },
	{ 907, 0, 0, "E4-1", -1, 1, 0, 0,  },
	{ 908, 0, 3, "cons_el-1", -1, 1, copy_296, 3,  },
	{ 908, 1, 4, "cons_el-2", -1, 1, copy_297, 4,  },
	{ 908, 2, 4, "cons_el-3", -1, 1, copy_298, 4,  },
	{ 908, 3, 4, "cons_el-4", -1, 1, copy_299, 4,  },
	{ 908, 4, 2, "cons_el-5", -1, 1, copy_300, 2,  },
	{ 909, 0, 1, "lit_cons_el-1", -1, 1, copy_301, 1,  },
	{ 909, 1, 3, "lit_cons_el-2", -1, 1, copy_302, 3,  },
	{ 910, 0, 3, "cons_top_el-1", -1, 1, copy_303, 3,  },
	{ 910, 1, 3, "cons_top_el-2", -1, 1, copy_304, 3,  },
	{ 910, 2, 3, "cons_top_el-3", -1, 1, copy_305, 3,  },
	{ 911, 0, 2, "cons_list-1", -1, 1, copy_306, 2,  },
	{ 911, 1, 1, "cons_list-2", -1, 1, copy_307, 1,  },
	{ 912, 0, 1, "constructor-1", -1, 1, copy_308, 1,  },
	{ 912, 1, 3, "constructor-2", -1, 1, copy_309, 3,  },
	{ 913, 0, 4, "accum_el-1", -1, 1, copy_310, 4,  },
	{ 913, 1, 4, "accum_el-2", -1, 1, copy_311, 4,  },
	{ 913, 2, 4, "accum_el-3", -1, 1, copy_312, 4,  },
	{ 913, 3, 2, "accum_el-4", -1, 1, copy_313, 2,  },
	{ 914, 0, 1, "lit_accum_el-1", -1, 1, copy_314, 1,  },
	{ 914, 1, 3, "lit_accum_el-2", -1, 1, copy_315, 3,  },
	{ 915, 0, 3, "accum_top_el-1", -1, 1, copy_316, 3,  },
	{ 915, 1, 3, "accum_top_el-2", -1, 1, copy_317, 3,  },
	{ 915, 2, 3, "accum_top_el-3", -1, 1, copy_318, 3,  },
	{ 915, 3, 3, "accum_top_el-4", -1, 1, copy_319, 3,  },
	{ 916, 0, 2, "accum_list-1", -1, 1, copy_320, 2,  },
	{ 916, 1, 1, "accum_list-2", -1, 1, copy_321, 1,  },
	{ 917, 0, 1, "accumulate-1", -1, 1, copy_322, 1,  },
	{ 918, 0, 4, "string_el-1", -1, 1, copy_323, 4,  },
	{ 918, 1, 4, "string_el-2", -1, 1, copy_324, 4,  },
	{ 918, 2, 4, "string_el-3", -1, 1, copy_325, 4,  },
	{ 918, 3, 2, "string_el-4", -1, 1, copy_326, 2,  },
	{ 919, 0, 1, "lit_string_el-1", -1, 1, copy_327, 1,  },
	{ 919, 1, 3, "lit_string_el-2", -1, 1, copy_328, 3,  },
	{ 920, 0, 3, "string_top_el-1", -1, 1, copy_329, 3,  },
	{ 920, 1, 3, "string_top_el-2", -1, 1, copy_330, 3,  },
	{ 920, 2, 3, "string_top_el-3", -1, 1, copy_331, 3,  },
	{ 921, 0, 2, "string_list-1", -1, 1, copy_332, 2,  },
	{ 921, 1, 1, "string_list-2", -1, 1, copy_333, 1,  },
	{ 922, 0, 1, "string-1", -1, 1, copy_334, 1,  },
	{ 922, 1, 3, "string-2", -1, 1, copy_335, 3,  },
	{ 923, 0, 3, "var_ref-1", -1, 1, copy_336, 3,  },
	{ 924, 0, 3, "qual-1", -1, 1, copy_337, 3,  },
	{ 924, 1, 3, "qual-2", -1, 1, copy_338, 3,  },
	{ 924, 2, 0, "qual-3", -1, 1, 0, 0,  },
	{ 925, 0, 3, "lex_expr-1", -1, 1, copy_340, 3,  },
	{ 925, 1, 3, "lex_expr-2", -1, 1, copy_341, 3,  },
	{ 925, 2, 3, "lex_expr-3", -1, 1, copy_342, 3,  },
	{ 925, 3, 3, "lex_expr-4", -1, 1, copy_343, 3,  },
	{ 925, 4, 1, "lex_expr-5", -1, 1, copy_344, 1,  },
	{ 926, 0, 1, "opt_lex_dot-1", -1, 1, copy_345, 1,  },
	{ 926, 1, 0, "opt_lex_dot-2", -1, 1, 0, 0,  },
	{ 927, 0, 3, "lex_term-1", -1, 1, copy_347, 3,  },
	{ 927, 1, 3, "lex_term-2", -1, 1, copy_348, 3,  },
	{ 927, 2, 3, "lex_term-3", -1, 1, copy_349, 3,  },
	{ 927, 3, 3, "lex_term-4", -1, 1, copy_350, 3,  },
	{ 927, 4, 1, "lex_term-5", -1, 1, copy_351, 1,  },
	{ 928, 0, 2, "lex_factor_rep-1", -1, 1, copy_352, 2,  },
	{ 928, 1, 2, "lex_factor_rep-2", -1, 1, copy_353, 2,  },
	{ 928, 2, 2, "lex_factor_rep-3", -1, 1, copy_354, 2,  },
	{ 928, 3, 2, "lex_factor_rep-4", -1, 1, copy_355, 2,  },
	{ 928, 4, 4, "lex_factor_rep-5", -1, 1, copy_356, 4,  },
	{ 928, 5, 5, "lex_factor_rep-6", -1, 1, copy_357, 5,  },
	{ 928, 6, 5, "lex_factor_rep-7", -1, 1, copy_358, 5,  },
	{ 928, 7, 6, "lex_factor_rep-8", -1, 1, copy_359, 6,  },
	{ 928, 8, 1, "lex_factor_rep-9", -1, 1, copy_360, 1,  },
	{ 929, 0, 2, "lex_factor_neg-1", -1, 1, copy_361, 2,  },
	{ 929, 1, 1, "lex_factor_neg-2", -1, 1, copy_362, 1,  },
	{ 930, 0, 1, "lex_range_lit-1", -1, 1, copy_363, 1,  },
	{ 930, 1, 1, "lex_range_lit-2", -1, 1, copy_364, 1,  },
	{ 931, 0, 1, "lex_num-1", -1, 1, copy_365, 1,  },
	{ 931, 1, 1, "lex_num-2", -1, 1, copy_366, 1,  },
	{ 932, 0, 1, "lex_factor-1", -1, 1, copy_367, 1,  },
	{ 932, 1, 1, "lex_factor-2", -1, 1, copy_368, 1,  },
	{ 932, 2, 1, "lex_factor-3", -1, 1, copy_369, 1,  },
	{ 932, 3, 1, "lex_factor-4", -1, 1, copy_370, 1,  },
	{ 932, 4, 3, "lex_factor-5", -1, 1, copy_371, 3,  },
	{ 932, 5, 3, "lex_factor-6", -1, 1, copy_372, 3,  },
	{ 932, 6, 3, "lex_factor-7", -1, 1, copy_373, 3,  },
	{ 932, 7, 3, "lex_factor-8", -1, 1, copy_374, 3,  },
	{ 933, 0, 2, "reg_or_data-1", -1, 1, copy_375, 2,  },
	{ 933, 1, 0, "reg_or_data-2", -1, 1, 0, 0,  },
	{ 934, 0, 1, "reg_or_char-1", -1, 1, copy_377, 1,  },
	{ 934, 1, 3, "reg_or_char-2", -1, 1, copy_378, 3,  },
	{ 935, 0, 2, "_lrepeat_root_item-1", -1, 1, 0, 0,  },
	{ 935, 1, 0, "_lrepeat_root_item-2", -1, 1, 0, 0,  },
	{ 936, 0, 2, "_lrepeat_sq_cons_data-1", -1, 1, 0, 0,  },
	{ 936, 1, 0, "_lrepeat_sq_cons_data-2", -1, 1, 0, 0,  },
	{ 937, 0, 2, "_lrepeat_struct_item-1", -1, 1, 0, 0,  },
	{ 937, 1, 0, "_lrepeat_struct_item-2", -1, 1, 0, 0,  },
	{ 938, 0, 2, "_lrepeat_reduction_item-1", -1, 1, 0, 0,  },
	{ 938, 1, 0, "_lrepeat_reduction_item-2", -1, 1, 0, 0,  },
	{ 939, 0, 2, "_lrepeat_host_item-1", -1, 1, 0, 0,  },
	{ 939, 1, 0, "_lrepeat_host_item-2", -1, 1, 0, 0,  },
	{ 940, 0, 2, "_lrepeat_namespace_item-1", -1, 1, 0, 0,  },
	{ 940, 1, 0, "_lrepeat_namespace_item-2", -1, 1, 0, 0,  },
	{ 941, 0, 2, "_lrepeat_var_def-1", -1, 1, 0, 0,  },
	{ 941, 1, 0, "_lrepeat_var_def-2", -1, 1, 0, 0,  },
	{ 942, 0, 2, "_lrepeat_statement-1", -1, 1, 0, 0,  },
	{ 942, 1, 0, "_lrepeat_statement-2", -1, 1, 0, 0,  },
	{ 943, 0, 2, "_lrepeat_field_init-1", -1, 1, 0, 0,  },
	{ 943, 1, 0, "_lrepeat_field_init-2", -1, 1, 0, 0,  },
	{ 944, 0, 2, "_lrepeat_litpat_el-1", -1, 1, 0, 0,  },
	{ 944, 1, 0, "_lrepeat_litpat_el-2", -1, 1, 0, 0,  },
	{ 945, 0, 2, "_lrepeat_pattern_el-1", -1, 1, 0, 0,  },
	{ 945, 1, 0, "_lrepeat_pattern_el-2", -1, 1, 0, 0,  },
	{ 946, 0, 2, "_lrepeat_lit_cons_el-1", -1, 1, 0, 0,  },
	{ 946, 1, 0, "_lrepeat_lit_cons_el-2", -1, 1, 0, 0,  },
	{ 947, 0, 2, "_lrepeat_cons_el-1", -1, 1, 0, 0,  },
	{ 947, 1, 0, "_lrepeat_cons_el-2", -1, 1, 0, 0,  },
	{ 948, 0, 2, "_lrepeat_lit_accum_el-1", -1, 1, 0, 0,  },
	{ 948, 1, 0, "_lrepeat_lit_accum_el-2", -1, 1, 0, 0,  },
	{ 949, 0, 2, "_lrepeat_accum_el-1", -1, 1, 0, 0,  },
	{ 949, 1, 0, "_lrepeat_accum_el-2", -1, 1, 0, 0,  },
	{ 950, 0, 2, "_lrepeat_lit_string_el-1", -1, 1, 0, 0,  },
	{ 950, 1, 0, "_lrepeat_lit_string_el-2", -1, 1, 0, 0,  },
	{ 951, 0, 2, "_lrepeat_string_el-1", -1, 1, 0, 0,  },
	{ 951, 1, 0, "_lrepeat_string_el-2", -1, 1, 0, 0,  },
	{ 952, 0, 1, "_root-1", -1, 1, 0, 0,  },
	{ 952, 1, 1, "_root-2", -1, 1, 0, 0,  },
	{ 952, 2, 1, "_root-3", -1, 1, 0, 0,  },
	{ 952, 3, 1, "_root-4", -1, 1, 0, 0,  },
	{ 952, 4, 1, "_root-5", -1, 1, 0, 0,  },
	{ 952, 5, 1, "_root-6", -1, 1, 0, 0,  },
	{ 952, 6, 1, "_root-7", -1, 1, 0, 0,  },
	{ 952, 7, 1, "_root-8", -1, 1, 0, 0,  },
	{ 952, 8, 1, "_root-9", -1, 1, 0, 0,  },
	{ 952, 9, 1, "_root-10", -1, 1, 0, 0,  },
	{ 952, 10, 1, "_root-11", -1, 1, 0, 0,  },
	{ 952, 11, 1, "_root-12", -1, 1, 0, 0,  },
	{ 952, 12, 1, "_root-13", -1, 1, 0, 0,  },
	{ 952, 13, 1, "_root-14", -1, 1, 0, 0,  },
	{ 952, 14, 1, "_root-15", -1, 1, 0, 0,  },
	{ 952, 15, 1, "_root-16", -1, 1, 0, 0,  },
	{ 952, 16, 1, "_root-17", -1, 1, 0, 0,  },
	{ 952, 17, 1, "_root-18", -1, 1, 0, 0,  },
	{ 952, 18, 1, "_root-19", -1, 1, 0, 0,  },
	{ 952, 19, 1, "_root-20", -1, 1, 0, 0,  },
	{ 952, 20, 1, "_root-21", -1, 1, 0, 0,  },
	{ 952, 21, 1, "_root-22", -1, 1, 0, 0,  },
	{ 952, 22, 1, "_root-23", -1, 1, 0, 0,  },
	{ 952, 23, 1, "_root-24", -1, 1, 0, 0,  },
	{ 952, 24, 1, "_root-25", -1, 1, 0, 0,  },
	{ 952, 25, 1, "_root-26", -1, 1, 0, 0,  },
	{ 952, 26, 1, "_root-27", -1, 1, 0, 0,  },
	{ 952, 27, 1, "_root-28", -1, 1, 0, 0,  },
	{ 952, 28, 1, "_root-29", -1, 1, 0, 0,  },
	{ 952, 29, 1, "_root-30", -1, 1, 0, 0,  },
	{ 952, 30, 1, "_root-31", -1, 1, 0, 0,  },
	{ 952, 31, 1, "_root-32", -1, 1, 0, 0,  },
	{ 952, 32, 1, "_root-33", -1, 1, 0, 0,  },
	{ 952, 33, 1, "_root-34", -1, 1, 0, 0,  },
	{ 952, 34, 1, "_root-35", -1, 1, 0, 0,  },
	{ 952, 35, 1, "_root-36", -1, 1, 0, 0,  },
	{ 952, 36, 1, "_root-37", -1, 1, 0, 0,  },
	{ 952, 37, 1, "_root-38", -1, 1, 0, 0,  },
	{ 952, 38, 1, "_root-39", -1, 1, 0, 0,  },
	{ 952, 39, 1, "_root-40", -1, 1, 0, 0,  },
	{ 952, 40, 1, "_root-41", -1, 1, 0, 0,  },
	{ 952, 41, 1, "_root-42", -1, 1, 0, 0,  },
	{ 952, 42, 1, "_root-43", -1, 1, 0, 0,  },
	{ 952, 43, 1, "_root-44", -1, 1, 0, 0,  },
	{ 952, 44, 1, "_root-45", -1, 1, 0, 0,  },
	{ 952, 45, 1, "_root-46", -1, 1, 0, 0,  },
	{ 952, 46, 1, "_root-47", -1, 1, 0, 0,  },
	{ 952, 47, 1, "_root-48", -1, 1, 0, 0,  },
	{ 952, 48, 1, "_root-49", -1, 1, 0, 0,  },
	{ 952, 49, 1, "_root-50", -1, 1, 0, 0,  },
	{ 952, 50, 1, "_root-51", -1, 1, 0, 0,  },
	{ 952, 51, 1, "_root-52", -1, 1, 0, 0,  },
	{ 952, 52, 1, "_root-53", -1, 1, 0, 0,  },
	{ 952, 53, 1, "_root-54", -1, 1, 0, 0,  },
	{ 952, 54, 1, "_root-55", -1, 1, 0, 0,  },
	{ 952, 55, 1, "_root-56", -1, 1, 0, 0,  },
	{ 952, 56, 1, "_root-57", -1, 1, 0, 0,  },
	{ 952, 57, 1, "_root-58", -1, 1, 0, 0,  },
	{ 952, 58, 1, "_root-59", -1, 1, 0, 0,  },
	{ 952, 59, 1, "_root-60", -1, 1, 0, 0,  },
	{ 952, 60, 1, "_root-61", -1, 1, 0, 0,  },
	{ 952, 61, 1, "_root-62", -1, 1, 0, 0,  },
	{ 952, 62, 1, "_root-63", -1, 1, 0, 0,  },
	{ 952, 63, 1, "_root-64", -1, 1, 0, 0,  },
	{ 952, 64, 1, "_root-65", -1, 1, 0, 0,  },
	{ 952, 65, 1, "_root-66", -1, 1, 0, 0,  },
	{ 952, 66, 1, "_root-67", -1, 1, 0, 0,  },
	{ 952, 67, 1, "_root-68", -1, 1, 0, 0,  },
	{ 952, 68, 1, "_root-69", -1, 1, 0, 0,  },
	{ 952, 69, 1, "_root-70", -1, 1, 0, 0,  },
	{ 952, 70, 1, "_root-71", -1, 1, 0, 0,  },
	{ 952, 71, 1, "_root-72", -1, 1, 0, 0,  },
	{ 952, 72, 1, "_root-73", -1, 1, 0, 0,  },
	{ 952, 73, 1, "_root-74", -1, 1, 0, 0,  },
	{ 952, 74, 1, "_root-75", -1, 1, 0, 0,  },
	{ 952, 75, 1, "_root-76", -1, 1, 0, 0,  },
	{ 952, 76, 1, "_root-77", -1, 1, 0, 0,  },
	{ 952, 77, 1, "_root-78", -1, 1, 0, 0,  },
	{ 952, 78, 1, "_root-79", -1, 1, 0, 0,  },
	{ 952, 79, 1, "_root-80", -1, 1, 0, 0,  },
	{ 952, 80, 1, "_root-81", -1, 1, 0, 0,  },
	{ 952, 81, 1, "_root-82", -1, 1, 0, 0,  },
	{ 952, 82, 1, "_root-83", -1, 1, 0, 0,  },
	{ 952, 83, 1, "_root-84", -1, 1, 0, 0,  },
	{ 952, 84, 1, "_root-85", -1, 1, 0, 0,  },
	{ 952, 85, 1, "_root-86", -1, 1, 0, 0,  },
	{ 952, 86, 1, "_root-87", -1, 1, 0, 0,  },
	{ 952, 87, 1, "_root-88", -1, 1, 0, 0,  },
	{ 952, 88, 1, "_root-89", -1, 1, 0, 0,  },
	{ 952, 89, 1, "_root-90", -1, 1, 0, 0,  },
	{ 952, 90, 1, "_root-91", -1, 1, 0, 0,  },
	{ 952, 91, 1, "_root-92", -1, 1, 0, 0,  },
	{ 952, 92, 1, "_root-93", -1, 1, 0, 0,  },
	{ 952, 93, 1, "_root-94", -1, 1, 0, 0,  },
	{ 952, 94, 1, "_root-95", -1, 1, 0, 0,  },
	{ 952, 95, 1, "_root-96", -1, 1, 0, 0,  },
	{ 952, 96, 1, "_root-97", -1, 1, 0, 0,  },
	{ 952, 97, 1, "_root-98", -1, 1, 0, 0,  },
	{ 952, 98, 1, "_root-99", -1, 1, 0, 0,  },
	{ 952, 99, 1, "_root-100", -1, 1, 0, 0,  },
	{ 952, 100, 1, "_root-101", -1, 1, 0, 0,  },
	{ 952, 101, 1, "_root-102", -1, 1, 0, 0,  },
	{ 952, 102, 1, "_root-103", -1, 1, 0, 0,  },
	{ 952, 103, 1, "_root-104", -1, 1, 0, 0,  },
	{ 952, 104, 1, "_root-105", -1, 1, 0, 0,  },
	{ 952, 105, 1, "_root-106", -1, 1, 0, 0,  },
	{ 952, 106, 1, "_root-107", -1, 1, 0, 0,  },
	{ 952, 107, 1, "_root-108", -1, 1, 0, 0,  },
	{ 952, 108, 1, "_root-109", -1, 1, 0, 0,  },
	{ 952, 109, 1, "_root-110", -1, 1, 0, 0,  },
	{ 952, 110, 1, "_root-111", -1, 1, 0, 0,  },
	{ 952, 111, 1, "_root-112", -1, 1, 0, 0,  },
	{ 952, 112, 1, "_root-113", -1, 1, 0, 0,  },
	{ 952, 113, 1, "_root-114", -1, 1, 0, 0,  },
	{ 952, 114, 1, "_root-115", -1, 1, 0, 0,  },
	{ 952, 115, 1, "_root-116", -1, 1, 0, 0,  },
	{ 952, 116, 1, "_root-117", -1, 1, 0, 0,  },
	{ 952, 117, 1, "_root-118", -1, 1, 0, 0,  },
	{ 952, 118, 1, "_root-119", -1, 1, 0, 0,  },
	{ 952, 119, 1, "_root-120", -1, 1, 0, 0,  },
	{ 952, 120, 1, "_root-121", -1, 1, 0, 0,  },
	{ 952, 121, 1, "_root-122", -1, 1, 0, 0,  },
	{ 952, 122, 1, "_root-123", -1, 1, 0, 0,  },
	{ 952, 123, 1, "_root-124", -1, 1, 0, 0,  },
	{ 952, 124, 1, "_root-125", -1, 1, 0, 0,  },
	{ 952, 125, 1, "_root-126", -1, 1, 0, 0,  },
	{ 952, 126, 1, "_root-127", -1, 1, 0, 0,  },
	{ 952, 127, 1, "_root-128", -1, 1, 0, 0,  },
	{ 952, 128, 1, "_root-129", -1, 1, 0, 0,  },
	{ 952, 129, 1, "_root-130", -1, 1, 0, 0,  },
	{ 952, 130, 1, "_root-131", -1, 1, 0, 0,  },
	{ 952, 131, 1, "_root-132", -1, 1, 0, 0,  },
	{ 952, 132, 1, "_root-133", -1, 1, 0, 0,  },
	{ 952, 133, 1, "_root-134", -1, 1, 0, 0,  },
	{ 952, 134, 1, "_root-135", -1, 1, 0, 0,  },
	{ 952, 135, 1, "_root-136", -1, 1, 0, 0,  },
	{ 952, 136, 1, "_root-137", -1, 1, 0, 0,  },
	{ 952, 137, 1, "_root-138", -1, 1, 0, 0,  },
	{ 952, 138, 1, "_root-139", -1, 1, 0, 0,  },
	{ 952, 139, 1, "_root-140", -1, 1, 0, 0,  },
	{ 952, 140, 1, "_root-141", -1, 1, 0, 0,  },
	{ 952, 141, 1, "_root-142", -1, 1, 0, 0,  },
	{ 952, 142, 1, "_root-143", -1, 1, 0, 0,  },
	{ 952, 143, 1, "_root-144", -1, 1, 0, 0,  },
	{ 952, 144, 1, "_root-145", -1, 1, 0, 0,  },
	{ 952, 145, 1, "_root-146", -1, 1, 0, 0,  },
	{ 952, 146, 1, "_root-147", -1, 1, 0, 0,  },
	{ 952, 147, 1, "_root-148", -1, 1, 0, 0,  },
	{ 952, 148, 1, "_root-149", -1, 1, 0, 0,  },
	{ 952, 149, 1, "_root-150", -1, 1, 0, 0,  },
	{ 952, 150, 1, "_root-151", -1, 1, 0, 0,  },
	{ 952, 151, 1, "_root-152", -1, 1, 0, 0,  },
	{ 952, 152, 1, "_root-153", -1, 1, 0, 0,  },
	{ 952, 153, 1, "_root-154", -1, 1, 0, 0,  },
	{ 952, 154, 1, "_root-155", -1, 1, 0, 0,  },
	{ 952, 155, 1, "_root-156", -1, 1, 0, 0,  },
	{ 952, 156, 1, "_root-157", -1, 1, 0, 0,  },
	{ 952, 157, 1, "_root-158", -1, 1, 0, 0,  },
	{ 952, 158, 1, "_root-159", -1, 1, 0, 0,  },
	{ 952, 159, 1, "_root-160", -1, 1, 0, 0,  },
	{ 952, 160, 1, "_root-161", -1, 1, 0, 0,  },
	{ 952, 161, 1, "_root-162", -1, 1, 0, 0,  },
	{ 952, 162, 1, "_root-163", -1, 1, 0, 0,  },
	{ 952, 163, 1, "_root-164", -1, 1, 0, 0,  },
	{ 952, 164, 1, "_root-165", -1, 1, 0, 0,  },
	{ 952, 165, 1, "_root-166", -1, 1, 0, 0,  },
	{ 952, 166, 1, "_root-167", -1, 1, 0, 0,  },
	{ 952, 167, 1, "_root-168", -1, 1, 0, 0,  },
	{ 952, 168, 1, "_root-169", -1, 1, 0, 0,  },
	{ 952, 169, 1, "_root-170", -1, 1, 0, 0,  },
	{ 952, 170, 1, "_root-171", -1, 1, 0, 0,  },
	{ 952, 171, 1, "_root-172", -1, 1, 0, 0,  },
	{ 952, 172, 1, "_root-173", -1, 1, 0, 0,  },
	{ 952, 173, 1, "_root-174", -1, 1, 0, 0,  },
	{ 952, 174, 1, "_root-175", -1, 1, 0, 0,  },
	{ 952, 175, 1, "_root-176", -1, 1, 0, 0,  },
	{ 952, 176, 1, "_root-177", -1, 1, 0, 0,  },
	{ 952, 177, 1, "_root-178", -1, 1, 0, 0,  },
	{ 952, 178, 1, "_root-179", -1, 1, 0, 0,  },
	{ 952, 179, 1, "_root-180", -1, 1, 0, 0,  },
	{ 952, 180, 1, "_root-181", -1, 1, 0, 0,  },
	{ 952, 181, 1, "_root-182", -1, 1, 0, 0,  },
	{ 952, 182, 1, "_root-183", -1, 1, 0, 0,  },
	{ 952, 183, 1, "_root-184", -1, 1, 0, 0,  },
	{ 952, 184, 1, "_root-185", -1, 1, 0, 0,  },
	{ 952, 185, 1, "_root-186", -1, 1, 0, 0,  },
	{ 952, 186, 1, "_root-187", -1, 1, 0, 0,  },
	{ 952, 187, 1, "_root-188", -1, 1, 0, 0,  },
	{ 952, 188, 1, "_root-189", -1, 1, 0, 0,  },
	{ 952, 189, 1, "_root-190", -1, 1, 0, 0,  },
	{ 952, 190, 1, "_root-191", -1, 1, 0, 0,  },
	{ 952, 191, 1, "_root-192", -1, 1, 0, 0,  },
	{ 952, 192, 1, "_root-193", -1, 1, 0, 0,  },
	{ 952, 193, 1, "_root-194", -1, 1, 0, 0,  },
	{ 952, 194, 1, "_root-195", -1, 1, 0, 0,  },
	{ 952, 195, 1, "_root-196", -1, 1, 0, 0,  },
	{ 952, 196, 1, "_root-197", -1, 1, 0, 0,  },
	{ 952, 197, 1, "_root-198", -1, 1, 0, 0,  },
	{ 952, 198, 1, "_root-199", -1, 1, 0, 0,  },
	{ 952, 199, 1, "_root-200", -1, 1, 0, 0,  },
	{ 952, 200, 1, "_root-201", -1, 1, 0, 0,  },
	{ 952, 201, 1, "_root-202", -1, 1, 0, 0,  },
	{ 952, 202, 1, "_root-203", -1, 1, 0, 0,  },
	{ 952, 203, 1, "_root-204", -1, 1, 0, 0,  },
	{ 952, 204, 1, "_root-205", -1, 1, 0, 0,  },
	{ 952, 205, 1, "_root-206", -1, 1, 0, 0,  },
	{ 952, 206, 1, "_root-207", -1, 1, 0, 0,  },
	{ 952, 207, 1, "_root-208", -1, 1, 0, 0,  },
	{ 952, 208, 1, "_root-209", -1, 1, 0, 0,  },
	{ 952, 209, 1, "_root-210", -1, 1, 0, 0,  },
	{ 952, 210, 1, "_root-211", -1, 1, 0, 0,  },
	{ 952, 211, 1, "_root-212", -1, 1, 0, 0,  },
	{ 952, 212, 1, "_root-213", -1, 1, 0, 0,  },
	{ 952, 213, 1, "_root-214", -1, 1, 0, 0,  },
	{ 952, 214, 1, "_root-215", -1, 1, 0, 0,  },
	{ 952, 215, 1, "_root-216", -1, 1, 0, 0,  },
	{ 952, 216, 1, "_root-217", -1, 1, 0, 0,  },
	{ 952, 217, 1, "_root-218", -1, 1, 0, 0,  },
	{ 952, 218, 1, "_root-219", -1, 1, 0, 0,  },
	{ 952, 219, 1, "_root-220", -1, 1, 0, 0,  },
	{ 952, 220, 1, "_root-221", -1, 1, 0, 0,  },
	{ 952, 221, 1, "_root-222", -1, 1, 0, 0,  },
	{ 952, 222, 1, "_root-223", -1, 1, 0, 0,  },
	{ 952, 223, 1, "_root-224", -1, 1, 0, 0,  },
	{ 952, 224, 1, "_root-225", -1, 1, 0, 0,  },
	{ 952, 225, 1, "_root-226", -1, 1, 0, 0,  },
	{ 952, 226, 1, "_root-227", -1, 1, 0, 0,  },
	{ 952, 227, 1, "_root-228", -1, 1, 0, 0,  },
	{ 952, 228, 1, "_root-229", -1, 1, 0, 0,  },
	{ 952, 229, 1, "_root-230", -1, 1, 0, 0,  },
	{ 952, 230, 1, "_root-231", -1, 1, 0, 0,  },
	{ 952, 231, 1, "_root-232", -1, 1, 0, 0,  },
	{ 952, 232, 1, "_root-233", -1, 1, 0, 0,  },
	{ 952, 233, 1, "_root-234", -1, 1, 0, 0,  },
	{ 952, 234, 1, "_root-235", -1, 1, 0, 0,  },
	{ 952, 235, 1, "_root-236", -1, 1, 0, 0,  },
	{ 952, 236, 1, "_root-237", -1, 1, 0, 0,  },
	{ 952, 237, 1, "_root-238", -1, 1, 0, 0,  },
	{ 952, 238, 1, "_root-239", -1, 1, 0, 0,  },
	{ 952, 239, 1, "_root-240", -1, 1, 0, 0,  },
	{ 952, 240, 1, "_root-241", -1, 1, 0, 0,  },
	{ 952, 241, 1, "_root-242", -1, 1, 0, 0,  },
	{ 952, 242, 1, "_root-243", -1, 1, 0, 0,  },
	{ 952, 243, 1, "_root-244", -1, 1, 0, 0,  },
	{ 952, 244, 1, "_root-245", -1, 1, 0, 0,  },
	{ 952, 245, 1, "_root-246", -1, 1, 0, 0,  },
	{ 952, 246, 1, "_root-247", -1, 1, 0, 0,  },
	{ 952, 247, 1, "_root-248", -1, 1, 0, 0,  },
	{ 952, 248, 1, "_root-249", -1, 1, 0, 0,  },
	{ 952, 249, 1, "_root-250", -1, 1, 0, 0,  },
	{ 952, 250, 1, "_root-251", -1, 1, 0, 0,  },
	{ 952, 251, 1, "_root-252", -1, 1, 0, 0,  },
	{ 952, 252, 1, "_root-253", -1, 1, 0, 0,  },
	{ 952, 253, 1, "_root-254", -1, 1, 0, 0,  },
	{ 952, 254, 1, "_root-255", -1, 1, 0, 0,  },
	{ 952, 255, 1, "_root-256", -1, 1, 0, 0,  },
	{ 952, 256, 1, "_root-257", -1, 1, 0, 0,  },
	{ 952, 257, 1, "_root-258", -1, 1, 0, 0,  },
	{ 952, 258, 1, "_root-259", -1, 1, 0, 0,  },
	{ 952, 259, 1, "_root-260", -1, 1, 0, 0,  },
	{ 952, 260, 1, "_root-261", -1, 1, 0, 0,  },
	{ 952, 261, 1, "_root-262", -1, 1, 0, 0,  },
	{ 952, 262, 1, "_root-263", -1, 1, 0, 0,  },
	{ 952, 263, 1, "_root-264", -1, 1, 0, 0,  },
	{ 952, 264, 1, "_root-265", -1, 1, 0, 0,  },
	{ 952, 265, 1, "_root-266", -1, 1, 0, 0,  },
	{ 952, 266, 1, "_root-267", -1, 1, 0, 0,  },
	{ 952, 267, 1, "_root-268", -1, 1, 0, 0,  },
	{ 952, 268, 1, "_root-269", -1, 1, 0, 0,  },
	{ 952, 269, 1, "_root-270", -1, 1, 0, 0,  },
	{ 952, 270, 1, "_root-271", -1, 1, 0, 0,  },
	{ 952, 271, 1, "_root-272", -1, 1, 0, 0,  },
	{ 952, 272, 1, "_root-273", -1, 1, 0, 0,  },
	{ 952, 273, 1, "_root-274", -1, 1, 0, 0,  },
	{ 952, 274, 1, "_root-275", -1, 1, 0, 0,  },
	{ 952, 275, 1, "_root-276", -1, 1, 0, 0,  },
	{ 952, 276, 1, "_root-277", -1, 1, 0, 0,  },
	{ 952, 277, 1, "_root-278", -1, 1, 0, 0,  },
	{ 952, 278, 1, "_root-279", -1, 1, 0, 0,  },
	{ 952, 279, 1, "_root-280", -1, 1, 0, 0,  },
	{ 952, 280, 1, "_root-281", -1, 1, 0, 0,  },
	{ 952, 281, 1, "_root-282", -1, 1, 0, 0,  },
	{ 952, 282, 1, "_root-283", -1, 1, 0, 0,  },
	{ 952, 283, 1, "_root-284", -1, 1, 0, 0,  },
	{ 952, 284, 1, "_root-285", -1, 1, 0, 0,  },
	{ 952, 285, 1, "_root-286", -1, 1, 0, 0,  },
	{ 952, 286, 1, "_root-287", -1, 1, 0, 0,  },
	{ 952, 287, 1, "_root-288", -1, 1, 0, 0,  },
	{ 952, 288, 1, "_root-289", -1, 1, 0, 0,  },
	{ 952, 289, 1, "_root-290", -1, 1, 0, 0,  },
	{ 952, 290, 1, "_root-291", -1, 1, 0, 0,  },
	{ 952, 291, 1, "_root-292", -1, 1, 0, 0,  },
	{ 952, 292, 1, "_root-293", -1, 1, 0, 0,  },
	{ 952, 293, 1, "_root-294", -1, 1, 0, 0,  },
	{ 952, 294, 1, "_root-295", -1, 1, 0, 0,  },
	{ 952, 295, 1, "_root-296", -1, 1, 0, 0,  },
	{ 952, 296, 1, "_root-297", -1, 1, 0, 0,  },
	{ 952, 297, 1, "_root-298", -1, 1, 0, 0,  },
	{ 952, 298, 1, "_root-299", -1, 1, 0, 0,  },
	{ 952, 299, 1, "_root-300", -1, 1, 0, 0,  },
	{ 952, 300, 1, "_root-301", -1, 1, 0, 0,  },
	{ 952, 301, 1, "_root-302", -1, 1, 0, 0,  },
	{ 952, 302, 1, "_root-303", -1, 1, 0, 0,  },
	{ 952, 303, 1, "_root-304", -1, 1, 0, 0,  },
	{ 952, 304, 1, "_root-305", -1, 1, 0, 0,  },
	{ 952, 305, 1, "_root-306", -1, 1, 0, 0,  },
	{ 952, 306, 1, "_root-307", -1, 1, 0, 0,  },
	{ 952, 307, 1, "_root-308", -1, 1, 0, 0,  },
	{ 952, 308, 1, "_root-309", -1, 1, 0, 0,  },
	{ 952, 309, 1, "_root-310", -1, 1, 0, 0,  },
	{ 952, 310, 1, "_root-311", -1, 1, 0, 0,  },
	{ 952, 311, 1, "_root-312", -1, 1, 0, 0,  },
	{ 952, 312, 1, "_root-313", -1, 1, 0, 0,  },
	{ 952, 313, 1, "_root-314", -1, 1, 0, 0,  },
	{ 952, 314, 1, "_root-315", -1, 1, 0, 0,  },
	{ 952, 315, 1, "_root-316", -1, 1, 0, 0,  },
	{ 952, 316, 1, "_root-317", -1, 1, 0, 0,  },
	{ 952, 317, 1, "_root-318", -1, 1, 0, 0,  },
	{ 952, 318, 1, "_root-319", -1, 1, 0, 0,  },
	{ 952, 319, 1, "_root-320", -1, 1, 0, 0,  },
	{ 952, 320, 1, "_root-321", -1, 1, 0, 0,  },
	{ 952, 321, 1, "_root-322", -1, 1, 0, 0,  },
	{ 952, 322, 1, "_root-323", -1, 1, 0, 0,  },
	{ 952, 323, 1, "_root-324", -1, 1, 0, 0,  },
	{ 952, 324, 1, "_root-325", -1, 1, 0, 0,  },
	{ 952, 325, 1, "_root-326", -1, 1, 0, 0,  },
	{ 952, 326, 1, "_root-327", -1, 1, 0, 0,  },
	{ 952, 327, 1, "_root-328", -1, 1, 0, 0,  },
	{ 952, 328, 1, "_root-329", -1, 1, 0, 0,  },
	{ 952, 329, 1, "_root-330", -1, 1, 0, 0,  },
	{ 952, 330, 1, "_root-331", -1, 1, 0, 0,  },
	{ 952, 331, 1, "_root-332", -1, 1, 0, 0,  },
	{ 952, 332, 1, "_root-333", -1, 1, 0, 0,  },
	{ 952, 333, 1, "_root-334", -1, 1, 0, 0,  },
	{ 952, 334, 1, "_root-335", -1, 1, 0, 0,  },
	{ 952, 335, 1, "_root-336", -1, 1, 0, 0,  },
	{ 952, 336, 1, "_root-337", -1, 1, 0, 0,  },
	{ 952, 337, 1, "_root-338", -1, 1, 0, 0,  },
	{ 952, 338, 1, "_root-339", -1, 1, 0, 0,  },
	{ 952, 339, 1, "_root-340", -1, 1, 0, 0,  },
	{ 952, 340, 1, "_root-341", -1, 1, 0, 0,  },
	{ 952, 341, 1, "_root-342", -1, 1, 0, 0,  },
	{ 952, 342, 1, "_root-343", -1, 1, 0, 0,  },
	{ 952, 343, 1, "_root-344", -1, 1, 0, 0,  },
	{ 952, 344, 1, "_root-345", -1, 1, 0, 0,  },
	{ 952, 345, 1, "_root-346", -1, 1, 0, 0,  },
	{ 952, 346, 1, "_root-347", -1, 1, 0, 0,  },
	{ 952, 347, 1, "_root-348", -1, 1, 0, 0,  },
	{ 952, 348, 1, "_root-349", -1, 1, 0, 0,  },
	{ 952, 349, 1, "_root-350", -1, 1, 0, 0,  },
	{ 952, 350, 1, "_root-351", -1, 1, 0, 0,  },
	{ 952, 351, 1, "_root-352", -1, 1, 0, 0,  },
	{ 952, 352, 1, "_root-353", -1, 1, 0, 0,  },
	{ 952, 353, 1, "_root-354", -1, 1, 0, 0,  },
	{ 952, 354, 1, "_root-355", -1, 1, 0, 0,  },
	{ 952, 355, 1, "_root-356", -1, 1, 0, 0,  },
	{ 952, 356, 1, "_root-357", -1, 1, 0, 0,  },
	{ 952, 357, 1, "_root-358", -1, 1, 0, 0,  },
	{ 952, 358, 1, "_root-359", -1, 1, 0, 0,  },
	{ 952, 359, 1, "_root-360", -1, 1, 0, 0,  },
	{ 952, 360, 1, "_root-361", -1, 1, 0, 0,  },
	{ 952, 361, 1, "_root-362", -1, 1, 0, 0,  },
	{ 952, 362, 1, "_root-363", -1, 1, 0, 0,  },
	{ 952, 363, 1, "_root-364", -1, 1, 0, 0,  },
	{ 952, 364, 1, "_root-365", -1, 1, 0, 0,  },
	{ 952, 365, 1, "_root-366", -1, 1, 0, 0,  },
	{ 952, 366, 1, "_root-367", -1, 1, 0, 0,  },
	{ 952, 367, 1, "_root-368", -1, 1, 0, 0,  },
	{ 952, 368, 1, "_root-369", -1, 1, 0, 0,  },
	{ 952, 369, 1, "_root-370", -1, 1, 0, 0,  },
	{ 952, 370, 1, "_root-371", -1, 1, 0, 0,  },
	{ 952, 371, 1, "_root-372", -1, 1, 0, 0,  },
	{ 952, 372, 1, "_root-373", -1, 1, 0, 0,  },
	{ 952, 373, 1, "_root-374", -1, 1, 0, 0,  },
	{ 952, 374, 1, "_root-375", -1, 1, 0, 0,  },
	{ 952, 375, 1, "_root-376", -1, 1, 0, 0,  },
	{ 952, 376, 1, "_root-377", -1, 1, 0, 0,  },
	{ 952, 377, 1, "_root-378", -1, 1, 0, 0,  },
	{ 952, 378, 1, "_root-379", -1, 1, 0, 0,  },
	{ 952, 379, 1, "_root-380", -1, 1, 0, 0,  },
	{ 952, 380, 1, "_root-381", -1, 1, 0, 0,  },
	{ 952, 381, 1, "_root-382", -1, 1, 0, 0,  },
	{ 952, 382, 1, "_root-383", -1, 1, 0, 0,  },
	{ 952, 383, 1, "_root-384", -1, 1, 0, 0,  },
	{ 952, 384, 1, "_root-385", -1, 1, 0, 0,  },
	{ 952, 385, 1, "_root-386", -1, 1, 0, 0,  },
	{ 952, 386, 1, "_root-387", -1, 1, 0, 0,  },
	{ 952, 387, 1, "_root-388", -1, 1, 0, 0,  },
	{ 952, 388, 1, "_root-389", -1, 1, 0, 0,  },
	{ 952, 389, 1, "_root-390", -1, 1, 0, 0,  },
	{ 952, 390, 1, "_root-391", -1, 1, 0, 0,  },
	{ 952, 391, 1, "_root-392", -1, 1, 0, 0,  },
	{ 952, 392, 1, "_root-393", -1, 1, 0, 0,  },
	{ 952, 393, 1, "_root-394", -1, 1, 0, 0,  },
	{ 952, 394, 1, "_root-395", -1, 1, 0, 0,  },
	{ 952, 395, 1, "_root-396", -1, 1, 0, 0,  },
	{ 952, 396, 1, "_root-397", -1, 1, 0, 0,  },
	{ 952, 397, 1, "_root-398", -1, 1, 0, 0,  },
	{ 952, 398, 1, "_root-399", -1, 1, 0, 0,  },
	{ 952, 399, 1, "_root-400", -1, 1, 0, 0,  },
	{ 952, 400, 1, "_root-401", -1, 1, 0, 0,  },
	{ 952, 401, 1, "_root-402", -1, 1, 0, 0,  },
	{ 952, 402, 1, "_root-403", -1, 1, 0, 0,  },
	{ 952, 403, 1, "_root-404", -1, 1, 0, 0,  },
	{ 952, 404, 1, "_root-405", -1, 1, 0, 0,  },
	{ 952, 405, 1, "_root-406", -1, 1, 0, 0,  },
	{ 952, 406, 1, "_root-407", -1, 1, 0, 0,  },
	{ 952, 407, 1, "_root-408", -1, 1, 0, 0,  },
	{ 952, 408, 1, "_root-409", -1, 1, 0, 0,  },
	{ 952, 409, 1, "_root-410", -1, 1, 0, 0,  },
	{ 952, 410, 1, "_root-411", -1, 1, 0, 0,  },
	{ 952, 411, 1, "_root-412", -1, 1, 0, 0,  },
	{ 952, 412, 1, "_root-413", -1, 1, 0, 0,  },
	{ 952, 413, 1, "_root-414", -1, 1, 0, 0,  },
	{ 952, 414, 1, "_root-415", -1, 1, 0, 0,  },
	{ 952, 415, 1, "_root-416", -1, 1, 0, 0,  },
	{ 952, 416, 1, "_root-417", -1, 1, 0, 0,  },
	{ 952, 417, 1, "_root-418", -1, 1, 0, 0,  },
	{ 952, 418, 1, "_root-419", -1, 1, 0, 0,  },
	{ 952, 419, 1, "_root-420", -1, 1, 0, 0,  },
	{ 952, 420, 1, "_root-421", -1, 1, 0, 0,  },
	{ 952, 421, 1, "_root-422", -1, 1, 0, 0,  },
	{ 952, 422, 1, "_root-423", -1, 1, 0, 0,  },
	{ 952, 423, 1, "_root-424", -1, 1, 0, 0,  },
	{ 952, 424, 1, "_root-425", -1, 1, 0, 0,  },
	{ 952, 425, 1, "_root-426", -1, 1, 0, 0,  },
	{ 952, 426, 1, "_root-427", -1, 1, 0, 0,  },
	{ 952, 427, 1, "_root-428", -1, 1, 0, 0,  },
	{ 952, 428, 1, "_root-429", -1, 1, 0, 0,  },
	{ 952, 429, 1, "_root-430", -1, 1, 0, 0,  },
	{ 952, 430, 1, "_root-431", -1, 1, 0, 0,  },
	{ 952, 431, 1, "_root-432", -1, 1, 0, 0,  },
	{ 952, 432, 1, "_root-433", -1, 1, 0, 0,  },
	{ 952, 433, 1, "_root-434", -1, 1, 0, 0,  },
	{ 952, 434, 1, "_root-435", -1, 1, 0, 0,  },
	{ 952, 435, 1, "_root-436", -1, 1, 0, 0,  },
	{ 952, 436, 1, "_root-437", -1, 1, 0, 0,  },
	{ 952, 437, 1, "_root-438", -1, 1, 0, 0,  },
	{ 952, 438, 1, "_root-439", -1, 1, 0, 0,  },
	{ 952, 439, 1, "_root-440", -1, 1, 0, 0,  },
	{ 952, 440, 1, "_root-441", -1, 1, 0, 0,  },
	{ 952, 441, 1, "_root-442", -1, 1, 0, 0,  },
	{ 952, 442, 1, "_root-443", -1, 1, 0, 0,  },
	{ 952, 443, 1, "_root-444", -1, 1, 0, 0,  },
	{ 952, 444, 1, "_root-445", -1, 1, 0, 0,  },
	{ 952, 445, 1, "_root-446", -1, 1, 0, 0,  },
	{ 952, 446, 1, "_root-447", -1, 1, 0, 0,  },
	{ 952, 447, 1, "_root-448", -1, 1, 0, 0,  },
	{ 952, 448, 1, "_root-449", -1, 1, 0, 0,  },
	{ 952, 449, 1, "_root-450", -1, 1, 0, 0,  },
	{ 952, 450, 1, "_root-451", -1, 1, 0, 0,  },
	{ 952, 451, 1, "_root-452", -1, 1, 0, 0,  },
	{ 952, 452, 1, "_root-453", -1, 1, 0, 0,  },
	{ 952, 453, 1, "_root-454", -1, 1, 0, 0,  },
	{ 952, 454, 1, "_root-455", -1, 1, 0, 0,  },
	{ 952, 455, 1, "_root-456", -1, 1, 0, 0,  },
	{ 952, 456, 1, "_root-457", -1, 1, 0, 0,  },
	{ 952, 457, 1, "_root-458", -1, 1, 0, 0,  },
	{ 952, 458, 1, "_root-459", -1, 1, 0, 0,  },
	{ 952, 459, 1, "_root-460", -1, 1, 0, 0,  },
	{ 952, 460, 1, "_root-461", -1, 1, 0, 0,  },
	{ 952, 461, 1, "_root-462", -1, 1, 0, 0,  },
	{ 952, 462, 1, "_root-463", -1, 1, 0, 0,  },
	{ 952, 463, 1, "_root-464", -1, 1, 0, 0,  },
	{ 952, 464, 1, "_root-465", -1, 1, 0, 0,  },
	{ 952, 465, 1, "_root-466", -1, 1, 0, 0,  },
	{ 952, 466, 1, "_root-467", -1, 1, 0, 0,  },
	{ 952, 467, 1, "_root-468", -1, 1, 0, 0,  },
	{ 952, 468, 1, "_root-469", -1, 1, 0, 0,  },
	{ 952, 469, 1, "_root-470", -1, 1, 0, 0,  },
	{ 952, 470, 1, "_root-471", -1, 1, 0, 0,  },
	{ 952, 471, 1, "_root-472", -1, 1, 0, 0,  },
	{ 952, 472, 1, "_root-473", -1, 1, 0, 0,  },
	{ 952, 473, 1, "_root-474", -1, 1, 0, 0,  },
	{ 952, 474, 1, "_root-475", -1, 1, 0, 0,  },
	{ 952, 475, 1, "_root-476", -1, 1, 0, 0,  },
	{ 952, 476, 1, "_root-477", -1, 1, 0, 0,  },
	{ 952, 477, 1, "_root-478", -1, 1, 0, 0,  },
	{ 952, 478, 1, "_root-479", -1, 1, 0, 0,  },
	{ 952, 479, 1, "_root-480", -1, 1, 0, 0,  },
	{ 952, 480, 1, "_root-481", -1, 1, 0, 0,  },
	{ 952, 481, 1, "_root-482", -1, 1, 0, 0,  },
	{ 952, 482, 1, "_root-483", -1, 1, 0, 0,  },
	{ 952, 483, 1, "_root-484", -1, 1, 0, 0,  },
	{ 952, 484, 1, "_root-485", -1, 1, 0, 0,  },
	{ 952, 485, 1, "_root-486", -1, 1, 0, 0,  },
	{ 952, 486, 1, "_root-487", -1, 1, 0, 0,  },
	{ 952, 487, 1, "_root-488", -1, 1, 0, 0,  },
	{ 952, 488, 1, "_root-489", -1, 1, 0, 0,  },
	{ 952, 489, 1, "_root-490", -1, 1, 0, 0,  },
	{ 952, 490, 1, "_root-491", -1, 1, 0, 0,  },
	{ 952, 491, 1, "_root-492", -1, 1, 0, 0,  },
	{ 952, 492, 1, "_root-493", -1, 1, 0, 0,  },
	{ 952, 493, 1, "_root-494", -1, 1, 0, 0,  },
	{ 952, 494, 1, "_root-495", -1, 1, 0, 0,  },
	{ 952, 495, 1, "_root-496", -1, 1, 0, 0,  },
	{ 952, 496, 1, "_root-497", -1, 1, 0, 0,  },
	{ 952, 497, 1, "_root-498", -1, 1, 0, 0,  },
	{ 952, 498, 1, "_root-499", -1, 1, 0, 0,  },
	{ 952, 499, 1, "_root-500", -1, 1, 0, 0,  },
	{ 952, 500, 1, "_root-501", -1, 1, 0, 0,  },
	{ 952, 501, 1, "_root-502", -1, 1, 0, 0,  },
	{ 952, 502, 1, "_root-503", -1, 1, 0, 0,  },
	{ 952, 503, 1, "_root-504", -1, 1, 0, 0,  },
	{ 952, 504, 1, "_root-505", -1, 1, 0, 0,  },
	{ 952, 505, 1, "_root-506", -1, 1, 0, 0,  },
	{ 952, 506, 1, "_root-507", -1, 1, 0, 0,  },
	{ 952, 507, 1, "_root-508", -1, 1, 0, 0,  },
	{ 952, 508, 1, "_root-509", -1, 1, 0, 0,  },
	{ 952, 509, 1, "_root-510", -1, 1, 0, 0,  },
	{ 952, 510, 1, "_root-511", -1, 1, 0, 0,  },
	{ 952, 511, 1, "_root-512", -1, 1, 0, 0,  },
	{ 952, 512, 1, "_root-513", -1, 1, 0, 0,  },
	{ 952, 513, 1, "_root-514", -1, 1, 0, 0,  },
	{ 952, 514, 1, "_root-515", -1, 1, 0, 0,  },
	{ 952, 515, 1, "_root-516", -1, 1, 0, 0,  },
	{ 952, 516, 1, "_root-517", -1, 1, 0, 0,  },
	{ 952, 517, 1, "_root-518", -1, 1, 0, 0,  },
	{ 952, 518, 1, "_root-519", -1, 1, 0, 0,  },
	{ 952, 519, 1, "_root-520", -1, 1, 0, 0,  },
	{ 952, 520, 1, "_root-521", -1, 1, 0, 0,  },
	{ 952, 521, 1, "_root-522", -1, 1, 0, 0,  },
	{ 952, 522, 1, "_root-523", -1, 1, 0, 0,  },
	{ 952, 523, 1, "_root-524", -1, 1, 0, 0,  },
	{ 952, 524, 1, "_root-525", -1, 1, 0, 0,  },
	{ 952, 525, 1, "_root-526", -1, 1, 0, 0,  },
	{ 952, 526, 1, "_root-527", -1, 1, 0, 0,  },
	{ 952, 527, 1, "_root-528", -1, 1, 0, 0,  },
	{ 952, 528, 1, "_root-529", -1, 1, 0, 0,  },
	{ 952, 529, 1, "_root-530", -1, 1, 0, 0,  },
	{ 952, 530, 1, "_root-531", -1, 1, 0, 0,  },
	{ 952, 531, 1, "_root-532", -1, 1, 0, 0,  },
	{ 952, 532, 1, "_root-533", -1, 1, 0, 0,  },
	{ 952, 533, 1, "_root-534", -1, 1, 0, 0,  },
	{ 952, 534, 1, "_root-535", -1, 1, 0, 0,  },
	{ 952, 535, 1, "_root-536", -1, 1, 0, 0,  },
	{ 952, 536, 1, "_root-537", -1, 1, 0, 0,  },
	{ 952, 537, 1, "_root-538", -1, 1, 0, 0,  },
	{ 952, 538, 1, "_root-539", -1, 1, 0, 0,  },
	{ 952, 539, 1, "_root-540", -1, 1, 0, 0,  },
	{ 952, 540, 1, "_root-541", -1, 1, 0, 0,  },
	{ 952, 541, 1, "_root-542", -1, 1, 0, 0,  },
	{ 952, 542, 1, "_root-543", -1, 1, 0, 0,  },
	{ 952, 543, 1, "_root-544", -1, 1, 0, 0,  },
	{ 952, 544, 1, "_root-545", -1, 1, 0, 0,  },
	{ 952, 545, 1, "_root-546", -1, 1, 0, 0,  },
	{ 952, 546, 1, "_root-547", -1, 1, 0, 0,  },
	{ 952, 547, 1, "_root-548", -1, 1, 0, 0,  },
	{ 952, 548, 1, "_root-549", -1, 1, 0, 0,  },
	{ 952, 549, 1, "_root-550", -1, 1, 0, 0,  },
	{ 952, 550, 1, "_root-551", -1, 1, 0, 0,  },
	{ 952, 551, 1, "_root-552", -1, 1, 0, 0,  },
	{ 952, 552, 1, "_root-553", -1, 1, 0, 0,  },
	{ 952, 553, 1, "_root-554", -1, 1, 0, 0,  },
	{ 952, 554, 1, "_root-555", -1, 1, 0, 0,  },
	{ 952, 555, 1, "_root-556", -1, 1, 0, 0,  },
	{ 952, 556, 1, "_root-557", -1, 1, 0, 0,  },
	{ 952, 557, 1, "_root-558", -1, 1, 0, 0,  },
	{ 952, 558, 1, "_root-559", -1, 1, 0, 0,  },
	{ 952, 559, 1, "_root-560", -1, 1, 0, 0,  },
	{ 952, 560, 1, "_root-561", -1, 1, 0, 0,  },
	{ 952, 561, 1, "_root-562", -1, 1, 0, 0,  },
	{ 952, 562, 1, "_root-563", -1, 1, 0, 0,  },
	{ 952, 563, 1, "_root-564", -1, 1, 0, 0,  },
	{ 952, 564, 1, "_root-565", -1, 1, 0, 0,  },
	{ 952, 565, 1, "_root-566", -1, 1, 0, 0,  },
	{ 952, 566, 1, "_root-567", -1, 1, 0, 0,  },
	{ 952, 567, 1, "_root-568", -1, 1, 0, 0,  },
	{ 952, 568, 1, "_root-569", -1, 1, 0, 0,  },
	{ 952, 569, 1, "_root-570", -1, 1, 0, 0,  },
	{ 952, 570, 1, "_root-571", -1, 1, 0, 0,  },
	{ 952, 571, 1, "_root-572", -1, 1, 0, 0,  },
	{ 952, 572, 1, "_root-573", -1, 1, 0, 0,  },
	{ 952, 573, 1, "_root-574", -1, 1, 0, 0,  },
	{ 952, 574, 1, "_root-575", -1, 1, 0, 0,  },
	{ 952, 575, 1, "_root-576", -1, 1, 0, 0,  },
	{ 952, 576, 1, "_root-577", -1, 1, 0, 0,  },
	{ 952, 577, 1, "_root-578", -1, 1, 0, 0,  },
	{ 952, 578, 1, "_root-579", -1, 1, 0, 0,  },
	{ 952, 579, 1, "_root-580", -1, 1, 0, 0,  },
	{ 952, 580, 1, "_root-581", -1, 1, 0, 0,  },
	{ 952, 581, 1, "_root-582", -1, 1, 0, 0,  },
	{ 952, 582, 1, "_root-583", -1, 1, 0, 0,  },
	{ 952, 583, 1, "_root-584", -1, 1, 0, 0,  },
	{ 952, 584, 1, "_root-585", -1, 1, 0, 0,  },
	{ 952, 585, 1, "_root-586", -1, 1, 0, 0,  },
	{ 952, 586, 1, "_root-587", -1, 1, 0, 0,  },
	{ 952, 587, 1, "_root-588", -1, 1, 0, 0,  },
	{ 952, 588, 1, "_root-589", -1, 1, 0, 0,  },
	{ 952, 589, 1, "_root-590", -1, 1, 0, 0,  },
	{ 952, 590, 1, "_root-591", -1, 1, 0, 0,  },
	{ 952, 591, 1, "_root-592", -1, 1, 0, 0,  },
	{ 952, 592, 1, "_root-593", -1, 1, 0, 0,  },
	{ 952, 593, 1, "_root-594", -1, 1, 0, 0,  },
	{ 952, 594, 1, "_root-595", -1, 1, 0, 0,  },
	{ 952, 595, 1, "_root-596", -1, 1, 0, 0,  },
	{ 952, 596, 1, "_root-597", -1, 1, 0, 0,  },
	{ 952, 597, 1, "_root-598", -1, 1, 0, 0,  },
	{ 952, 598, 1, "_root-599", -1, 1, 0, 0,  },
	{ 952, 599, 1, "_root-600", -1, 1, 0, 0,  },
	{ 952, 600, 1, "_root-601", -1, 1, 0, 0,  },
	{ 952, 601, 1, "_root-602", -1, 1, 0, 0,  },
	{ 952, 602, 1, "_root-603", -1, 1, 0, 0,  },
	{ 952, 603, 1, "_root-604", -1, 1, 0, 0,  },
	{ 952, 604, 1, "_root-605", -1, 1, 0, 0,  },
	{ 952, 605, 1, "_root-606", -1, 1, 0, 0,  },
	{ 952, 606, 1, "_root-607", -1, 1, 0, 0,  },
	{ 952, 607, 1, "_root-608", -1, 1, 0, 0,  },
	{ 952, 608, 1, "_root-609", -1, 1, 0, 0,  },
	{ 952, 609, 1, "_root-610", -1, 1, 0, 0,  },
	{ 952, 610, 1, "_root-611", -1, 1, 0, 0,  },
	{ 952, 611, 1, "_root-612", -1, 1, 0, 0,  },
	{ 952, 612, 1, "_root-613", -1, 1, 0, 0,  },
	{ 952, 613, 1, "_root-614", -1, 1, 0, 0,  },
	{ 952, 614, 1, "_root-615", -1, 1, 0, 0,  },
	{ 952, 615, 1, "_root-616", -1, 1, 0, 0,  },
	{ 952, 616, 1, "_root-617", -1, 1, 0, 0,  },
	{ 952, 617, 1, "_root-618", -1, 1, 0, 0,  },
	{ 952, 618, 1, "_root-619", -1, 1, 0, 0,  },
	{ 952, 619, 1, "_root-620", -1, 1, 0, 0,  },
	{ 952, 620, 1, "_root-621", -1, 1, 0, 0,  },
	{ 952, 621, 1, "_root-622", -1, 1, 0, 0,  },
	{ 952, 622, 1, "_root-623", -1, 1, 0, 0,  },
	{ 952, 623, 1, "_root-624", -1, 1, 0, 0,  },
	{ 952, 624, 1, "_root-625", -1, 1, 0, 0,  },
	{ 952, 625, 1, "_root-626", -1, 1, 0, 0,  },
	{ 952, 626, 1, "_root-627", -1, 1, 0, 0,  },
	{ 952, 627, 1, "_root-628", -1, 1, 0, 0,  },
	{ 952, 628, 1, "_root-629", -1, 1, 0, 0,  },
	{ 952, 629, 1, "_root-630", -1, 1, 0, 0,  },
	{ 952, 630, 1, "_root-631", -1, 1, 0, 0,  },
	{ 952, 631, 1, "_root-632", -1, 1, 0, 0,  },
	{ 952, 632, 1, "_root-633", -1, 1, 0, 0,  },
	{ 952, 633, 1, "_root-634", -1, 1, 0, 0,  },
	{ 952, 634, 1, "_root-635", -1, 1, 0, 0,  },
	{ 952, 635, 1, "_root-636", -1, 1, 0, 0,  },
	{ 952, 636, 1, "_root-637", -1, 1, 0, 0,  },
	{ 952, 637, 1, "_root-638", -1, 1, 0, 0,  },
	{ 952, 638, 1, "_root-639", -1, 1, 0, 0,  },
	{ 952, 639, 1, "_root-640", -1, 1, 0, 0,  },
	{ 952, 640, 1, "_root-641", -1, 1, 0, 0,  },
	{ 952, 641, 1, "_root-642", -1, 1, 0, 0,  },
	{ 952, 642, 1, "_root-643", -1, 1, 0, 0,  },
	{ 952, 643, 1, "_root-644", -1, 1, 0, 0,  },
	{ 952, 644, 1, "_root-645", -1, 1, 0, 0,  },
	{ 952, 645, 1, "_root-646", -1, 1, 0, 0,  },
	{ 952, 646, 1, "_root-647", -1, 1, 0, 0,  },
	{ 952, 647, 1, "_root-648", -1, 1, 0, 0,  },
	{ 952, 648, 1, "_root-649", -1, 1, 0, 0,  },
	{ 952, 649, 1, "_root-650", -1, 1, 0, 0,  },
	{ 952, 650, 1, "_root-651", -1, 1, 0, 0,  },
	{ 952, 651, 1, "_root-652", -1, 1, 0, 0,  },
	{ 952, 652, 1, "_root-653", -1, 1, 0, 0,  },
	{ 952, 653, 1, "_root-654", -1, 1, 0, 0,  },
	{ 952, 654, 1, "_root-655", -1, 1, 0, 0,  },
	{ 952, 655, 1, "_root-656", -1, 1, 0, 0,  },
	{ 952, 656, 1, "_root-657", -1, 1, 0, 0,  },
	{ 952, 657, 1, "_root-658", -1, 1, 0, 0,  },
	{ 952, 658, 1, "_root-659", -1, 1, 0, 0,  },
	{ 952, 659, 1, "_root-660", -1, 1, 0, 0,  },
	{ 952, 660, 1, "_root-661", -1, 1, 0, 0,  },
	{ 952, 661, 1, "_root-662", -1, 1, 0, 0,  },
	{ 952, 662, 1, "_root-663", -1, 1, 0, 0,  },
	{ 952, 663, 1, "_root-664", -1, 1, 0, 0,  },
	{ 952, 664, 1, "_root-665", -1, 1, 0, 0,  },
	{ 952, 665, 1, "_root-666", -1, 1, 0, 0,  },
	{ 952, 666, 1, "_root-667", -1, 1, 0, 0,  },
	{ 952, 667, 1, "_root-668", -1, 1, 0, 0,  },
	{ 952, 668, 1, "_root-669", -1, 1, 0, 0,  },
	{ 952, 669, 1, "_root-670", -1, 1, 0, 0,  },
	{ 952, 670, 1, "_root-671", -1, 1, 0, 0,  },
	{ 952, 671, 1, "_root-672", -1, 1, 0, 0,  },
	{ 952, 672, 1, "_root-673", -1, 1, 0, 0,  },
	{ 952, 673, 1, "_root-674", -1, 1, 0, 0,  },
	{ 952, 674, 1, "_root-675", -1, 1, 0, 0,  },
	{ 952, 675, 1, "_root-676", -1, 1, 0, 0,  },
	{ 952, 676, 1, "_root-677", -1, 1, 0, 0,  },
	{ 952, 677, 1, "_root-678", -1, 1, 0, 0,  },
	{ 952, 678, 1, "_root-679", -1, 1, 0, 0,  },
	{ 952, 679, 1, "_root-680", -1, 1, 0, 0,  },
	{ 952, 680, 1, "_root-681", -1, 1, 0, 0,  },
	{ 952, 681, 1, "_root-682", -1, 1, 0, 0,  },
	{ 952, 682, 1, "_root-683", -1, 1, 0, 0,  },
	{ 952, 683, 1, "_root-684", -1, 1, 0, 0,  },
	{ 952, 684, 1, "_root-685", -1, 1, 0, 0,  },
	{ 952, 685, 1, "_root-686", -1, 1, 0, 0,  },
	{ 952, 686, 1, "_root-687", -1, 1, 0, 0,  },
	{ 952, 687, 1, "_root-688", -1, 1, 0, 0,  },
	{ 952, 688, 1, "_root-689", -1, 1, 0, 0,  },
	{ 952, 689, 1, "_root-690", -1, 1, 0, 0,  },
	{ 952, 690, 1, "_root-691", -1, 1, 0, 0,  },
	{ 952, 691, 1, "_root-692", -1, 1, 0, 0,  },
	{ 952, 692, 1, "_root-693", -1, 1, 0, 0,  },
	{ 952, 693, 1, "_root-694", -1, 1, 0, 0,  },
	{ 952, 694, 1, "_root-695", -1, 1, 0, 0,  },
	{ 952, 695, 1, "_root-696", -1, 1, 0, 0,  },
	{ 952, 696, 1, "_root-697", -1, 1, 0, 0,  },
	{ 952, 697, 1, "_root-698", -1, 1, 0, 0,  },
	{ 952, 698, 1, "_root-699", -1, 1, 0, 0,  },
	{ 952, 699, 1, "_root-700", -1, 1, 0, 0,  },
	{ 952, 700, 1, "_root-701", -1, 1, 0, 0,  },
	{ 952, 701, 1, "_root-702", -1, 1, 0, 0,  },
	{ 952, 702, 1, "_root-703", -1, 1, 0, 0,  },
	{ 952, 703, 1, "_root-704", -1, 1, 0, 0,  },
	{ 952, 704, 1, "_root-705", -1, 1, 0, 0,  },
	{ 952, 705, 1, "_root-706", -1, 1, 0, 0,  },
	{ 952, 706, 1, "_root-707", -1, 1, 0, 0,  },
	{ 952, 707, 1, "_root-708", -1, 1, 0, 0,  },
	{ 952, 708, 1, "_root-709", -1, 1, 0, 0,  },
	{ 952, 709, 1, "_root-710", -1, 1, 0, 0,  },
	{ 952, 710, 1, "_root-711", -1, 1, 0, 0,  },
	{ 952, 711, 1, "_root-712", -1, 1, 0, 0,  },
	{ 952, 712, 1, "_root-713", -1, 1, 0, 0,  },
	{ 952, 713, 1, "_root-714", -1, 1, 0, 0,  },
	{ 952, 714, 1, "_root-715", -1, 1, 0, 0,  },
	{ 952, 715, 1, "_root-716", -1, 1, 0, 0,  },
	{ 952, 716, 1, "_root-717", -1, 1, 0, 0,  },
	{ 952, 717, 1, "_root-718", -1, 1, 0, 0,  },
	{ 952, 718, 1, "_root-719", -1, 1, 0, 0,  },
	{ 952, 719, 1, "_root-720", -1, 1, 0, 0,  },
	{ 952, 720, 1, "_root-721", -1, 1, 0, 0,  },
	{ 952, 721, 1, "_root-722", -1, 1, 0, 0,  },
	{ 952, 722, 1, "_root-723", -1, 1, 0, 0,  },
	{ 952, 723, 1, "_root-724", -1, 1, 0, 0,  },
	{ 952, 724, 1, "_root-725", -1, 1, 0, 0,  },
	{ 952, 725, 1, "_root-726", -1, 1, 0, 0,  },
	{ 952, 726, 1, "_root-727", -1, 1, 0, 0,  },
	{ 952, 727, 1, "_root-728", -1, 1, 0, 0,  },
	{ 952, 728, 1, "_root-729", -1, 1, 0, 0,  },
	{ 952, 729, 1, "_root-730", -1, 1, 0, 0,  },
	{ 952, 730, 1, "_root-731", -1, 1, 0, 0,  },
	{ 952, 731, 1, "_root-732", -1, 1, 0, 0,  },
	{ 952, 732, 1, "_root-733", -1, 1, 0, 0,  },
	{ 952, 733, 1, "_root-734", -1, 1, 0, 0,  },
	{ 952, 734, 1, "_root-735", -1, 1, 0, 0,  },
	{ 952, 735, 1, "_root-736", -1, 1, 0, 0,  },
	{ 952, 736, 1, "_root-737", -1, 1, 0, 0,  },
	{ 952, 737, 1, "_root-738", -1, 1, 0, 0,  },
	{ 952, 738, 1, "_root-739", -1, 1, 0, 0,  },
	{ 952, 739, 1, "_root-740", -1, 1, 0, 0,  },
	{ 952, 740, 1, "_root-741", -1, 1, 0, 0,  },
	{ 952, 741, 1, "_root-742", -1, 1, 0, 0,  },
	{ 952, 742, 1, "_root-743", -1, 1, 0, 0,  },
	{ 952, 743, 1, "_root-744", -1, 1, 0, 0,  },
	{ 952, 744, 1, "_root-745", -1, 1, 0, 0,  },
	{ 952, 745, 1, "_root-746", -1, 1, 0, 0,  },
	{ 952, 746, 1, "_root-747", -1, 1, 0, 0,  },
	{ 952, 747, 1, "_root-748", -1, 1, 0, 0,  },
	{ 952, 748, 1, "_root-749", -1, 1, 0, 0,  },
	{ 952, 749, 1, "_root-750", -1, 1, 0, 0,  },
	{ 952, 750, 1, "_root-751", -1, 1, 0, 0,  },
	{ 952, 751, 1, "_root-752", -1, 1, 0, 0,  },
	{ 952, 752, 1, "_root-753", -1, 1, 0, 0,  },
	{ 952, 753, 1, "_root-754", -1, 1, 0, 0,  },
	{ 952, 754, 1, "_root-755", -1, 1, 0, 0,  },
	{ 952, 755, 1, "_root-756", -1, 1, 0, 0,  },
	{ 952, 756, 1, "_root-757", -1, 1, 0, 0,  },
	{ 952, 757, 1, "_root-758", -1, 1, 0, 0,  },
	{ 952, 758, 1, "_root-759", -1, 1, 0, 0,  },
	{ 952, 759, 1, "_root-760", -1, 1, 0, 0,  },
	{ 952, 760, 1, "_root-761", -1, 1, 0, 0,  },
	{ 952, 761, 1, "_root-762", -1, 1, 0, 0,  },
	{ 952, 762, 1, "_root-763", -1, 1, 0, 0,  },
	{ 952, 763, 1, "_root-764", -1, 1, 0, 0,  },
	{ 952, 764, 1, "_root-765", -1, 1, 0, 0,  },
	{ 952, 765, 1, "_root-766", -1, 1, 0, 0,  },
	{ 952, 766, 1, "_root-767", -1, 1, 0, 0,  },
	{ 952, 767, 1, "_root-768", -1, 1, 0, 0,  },
	{ 952, 768, 1, "_root-769", -1, 1, 0, 0,  },
	{ 952, 769, 1, "_root-770", -1, 1, 0, 0,  },
	{ 952, 770, 1, "_root-771", -1, 1, 0, 0,  },
	{ 952, 771, 1, "_root-772", -1, 1, 0, 0,  },
	{ 952, 772, 1, "_root-773", -1, 1, 0, 0,  },
	{ 952, 773, 1, "_root-774", -1, 1, 0, 0,  },
	{ 952, 774, 1, "_root-775", -1, 1, 0, 0,  },
	{ 952, 775, 1, "_root-776", -1, 1, 0, 0,  },
	{ 952, 776, 1, "_root-777", -1, 1, 0, 0,  },
	{ 952, 777, 1, "_root-778", -1, 1, 0, 0,  },
	{ 952, 778, 1, "_root-779", -1, 1, 0, 0,  },
	{ 952, 779, 1, "_root-780", -1, 1, 0, 0,  },
	{ 952, 780, 1, "_root-781", -1, 1, 0, 0,  },
	{ 952, 781, 1, "_root-782", -1, 1, 0, 0,  },
	{ 952, 782, 1, "_root-783", -1, 1, 0, 0,  },
	{ 952, 783, 1, "_root-784", -1, 1, 0, 0,  },
	{ 952, 784, 1, "_root-785", -1, 1, 0, 0,  },
	{ 952, 785, 1, "_root-786", -1, 1, 0, 0,  },
	{ 952, 786, 1, "_root-787", -1, 1, 0, 0,  },
	{ 952, 787, 1, "_root-788", -1, 1, 0, 0,  },
	{ 952, 788, 1, "_root-789", -1, 1, 0, 0,  },
	{ 952, 789, 1, "_root-790", -1, 1, 0, 0,  },
	{ 952, 790, 1, "_root-791", -1, 1, 0, 0,  },
	{ 952, 791, 1, "_root-792", -1, 1, 0, 0,  },
	{ 952, 792, 1, "_root-793", -1, 1, 0, 0,  },
	{ 952, 793, 1, "_root-794", -1, 1, 0, 0,  },
	{ 952, 794, 1, "_root-795", -1, 1, 0, 0,  },
	{ 952, 795, 1, "_root-796", -1, 1, 0, 0,  },
	{ 952, 796, 1, "_root-797", -1, 1, 0, 0,  },
	{ 952, 797, 1, "_root-798", -1, 1, 0, 0,  },
	{ 952, 798, 1, "_root-799", -1, 1, 0, 0,  },
	{ 952, 799, 1, "_root-800", -1, 1, 0, 0,  },
	{ 952, 800, 1, "_root-801", -1, 1, 0, 0,  },
	{ 952, 801, 1, "_root-802", -1, 1, 0, 0,  },
	{ 952, 802, 1, "_root-803", -1, 1, 0, 0,  },
	{ 952, 803, 1, "_root-804", -1, 1, 0, 0,  },
	{ 952, 804, 1, "_root-805", -1, 1, 0, 0,  },
	{ 952, 805, 1, "_root-806", -1, 1, 0, 0,  },
	{ 952, 806, 1, "_root-807", -1, 1, 0, 0,  },
	{ 952, 807, 1, "_root-808", -1, 1, 0, 0,  },
	{ 952, 808, 1, "_root-809", -1, 1, 0, 0,  },
	{ 952, 809, 1, "_root-810", -1, 1, 0, 0,  },
	{ 952, 810, 1, "_root-811", -1, 1, 0, 0,  },
	{ 952, 811, 1, "_root-812", -1, 1, 0, 0,  },
	{ 952, 812, 1, "_root-813", -1, 1, 0, 0,  },
	{ 952, 813, 1, "_root-814", -1, 1, 0, 0,  },
	{ 952, 814, 1, "_root-815", -1, 1, 0, 0,  },
	{ 952, 815, 1, "_root-816", -1, 1, 0, 0,  },
	{ 952, 816, 1, "_root-817", -1, 1, 0, 0,  },
	{ 952, 817, 1, "_root-818", -1, 1, 0, 0,  },
	{ 952, 818, 1, "_root-819", -1, 1, 0, 0,  },
	{ 952, 819, 1, "_root-820", -1, 1, 0, 0,  },
	{ 952, 820, 1, "_root-821", -1, 1, 0, 0,  },
	{ 952, 821, 1, "_root-822", -1, 1, 0, 0,  },
	{ 952, 822, 1, "_root-823", -1, 1, 0, 0,  },
	{ 952, 823, 1, "_root-824", -1, 1, 0, 0,  },
	{ 952, 824, 1, "_root-825", -1, 1, 0, 0,  },
	{ 952, 825, 1, "_root-826", -1, 1, 0, 0,  },
	{ 952, 826, 1, "_root-827", -1, 1, 0, 0,  },
	{ 952, 827, 1, "_root-828", -1, 1, 0, 0,  },
	{ 952, 828, 1, "_root-829", -1, 1, 0, 0,  },
	{ 952, 829, 1, "_root-830", -1, 1, 0, 0,  },
	{ 952, 830, 1, "_root-831", -1, 1, 0, 0,  },
	{ 952, 831, 1, "_root-832", -1, 1, 0, 0,  },
	{ 952, 832, 1, "_root-833", -1, 1, 0, 0,  },
	{ 952, 833, 1, "_root-834", -1, 1, 0, 0,  },
	{ 952, 834, 1, "_root-835", -1, 1, 0, 0,  },
	{ 952, 835, 1, "_root-836", -1, 1, 0, 0,  },
	{ 952, 836, 1, "_root-837", -1, 1, 0, 0,  },
	{ 952, 837, 1, "_root-838", -1, 1, 0, 0,  },
	{ 952, 838, 1, "_root-839", -1, 1, 0, 0,  },
	{ 952, 839, 1, "_root-840", -1, 1, 0, 0,  },
	{ 952, 840, 1, "_root-841", -1, 1, 0, 0,  },
	{ 952, 841, 1, "_root-842", -1, 1, 0, 0,  },
	{ 952, 842, 1, "_root-843", -1, 1, 0, 0,  },
	{ 952, 843, 1, "_root-844", -1, 1, 0, 0,  },
	{ 952, 844, 1, "_root-845", -1, 1, 0, 0,  },
	{ 952, 845, 1, "_root-846", -1, 1, 0, 0,  },
	{ 952, 846, 1, "_root-847", -1, 1, 0, 0,  },
	{ 952, 847, 1, "_root-848", -1, 1, 0, 0,  },
	{ 952, 848, 1, "_root-849", -1, 1, 0, 0,  },
	{ 952, 849, 1, "_root-850", -1, 1, 0, 0,  },
	{ 952, 850, 1, "_root-851", -1, 1, 0, 0,  },
	{ 952, 851, 1, "_root-852", -1, 1, 0, 0,  },
	{ 952, 852, 1, "_root-853", -1, 1, 0, 0,  },
	{ 952, 853, 1, "_root-854", -1, 1, 0, 0,  },
	{ 952, 854, 1, "_root-855", -1, 1, 0, 0,  },
	{ 952, 855, 1, "_root-856", -1, 1, 0, 0,  },
	{ 952, 856, 1, "_root-857", -1, 1, 0, 0,  },
	{ 952, 857, 1, "_root-858", -1, 1, 0, 0,  },
	{ 952, 858, 1, "_root-859", -1, 1, 0, 0,  },
	{ 952, 859, 1, "_root-860", -1, 1, 0, 0,  },
	{ 952, 860, 1, "_root-861", -1, 1, 0, 0,  },
	{ 952, 861, 1, "_root-862", -1, 1, 0, 0,  },
	{ 952, 862, 1, "_root-863", -1, 1, 0, 0,  },
	{ 952, 863, 1, "_root-864", -1, 1, 0, 0,  },
	{ 952, 864, 1, "_root-865", -1, 1, 0, 0,  },
	{ 952, 865, 1, "_root-866", -1, 1, 0, 0,  },
	{ 952, 866, 1, "_root-867", -1, 1, 0, 0,  },
	{ 952, 867, 1, "_root-868", -1, 1, 0, 0,  },
	{ 952, 868, 1, "_root-869", -1, 1, 0, 0,  },
	{ 952, 869, 1, "_root-870", -1, 1, 0, 0,  },
	{ 952, 870, 1, "_root-871", -1, 1, 0, 0,  },
	{ 952, 871, 1, "_root-872", -1, 1, 0, 0,  },
	{ 952, 872, 1, "_root-873", -1, 1, 0, 0,  },
	{ 952, 873, 1, "_root-874", -1, 1, 0, 0,  },
	{ 952, 874, 1, "_root-875", -1, 1, 0, 0,  },
	{ 952, 875, 1, "_root-876", -1, 1, 0, 0,  },
	{ 952, 876, 1, "_root-877", -1, 1, 0, 0,  },
	{ 952, 877, 1, "_root-878", -1, 1, 0, 0,  },
	{ 952, 878, 1, "_root-879", -1, 1, 0, 0,  },
	{ 952, 879, 1, "_root-880", -1, 1, 0, 0,  },
	{ 952, 880, 1, "_root-881", -1, 1, 0, 0,  },
	{ 952, 881, 1, "_root-882", -1, 1, 0, 0,  },
	{ 952, 882, 1, "_root-883", -1, 1, 0, 0,  },
	{ 952, 883, 1, "_root-884", -1, 1, 0, 0,  },
	{ 952, 884, 1, "_root-885", -1, 1, 0, 0,  },
	{ 952, 885, 1, "_root-886", -1, 1, 0, 0,  },
	{ 952, 886, 1, "_root-887", -1, 1, 0, 0,  },
	{ 952, 887, 1, "_root-888", -1, 1, 0, 0,  },
	{ 952, 888, 1, "_root-889", -1, 1, 0, 0,  },
	{ 952, 889, 1, "_root-890", -1, 1, 0, 0,  },
	{ 952, 890, 1, "_root-891", -1, 1, 0, 0,  },
	{ 952, 891, 1, "_root-892", -1, 1, 0, 0,  },
	{ 952, 892, 1, "_root-893", -1, 1, 0, 0,  },
	{ 952, 893, 1, "_root-894", -1, 1, 0, 0,  },
	{ 952, 894, 1, "_root-895", -1, 1, 0, 0,  },
	{ 952, 895, 1, "_root-896", -1, 1, 0, 0,  },
	{ 952, 896, 1, "_root-897", -1, 1, 0, 0,  },
	{ 952, 897, 1, "_root-898", -1, 1, 0, 0,  },
	{ 952, 898, 1, "_root-899", -1, 1, 0, 0,  },
	{ 952, 899, 1, "_root-900", -1, 1, 0, 0,  },
	{ 952, 900, 1, "_root-901", -1, 1, 0, 0,  },
	{ 952, 901, 1, "_root-902", -1, 1, 0, 0,  },
	{ 952, 902, 1, "_root-903", -1, 1, 0, 0,  },
	{ 952, 903, 1, "_root-904", -1, 1, 0, 0,  },
	{ 952, 904, 1, "_root-905", -1, 1, 0, 0,  },
	{ 952, 905, 1, "_root-906", -1, 1, 0, 0,  },
	{ 952, 906, 1, "_root-907", -1, 1, 0, 0,  },
	{ 952, 907, 1, "_root-908", -1, 1, 0, 0,  },
	{ 952, 908, 1, "_root-909", -1, 1, 0, 0,  },
	{ 952, 909, 1, "_root-910", -1, 1, 0, 0,  },
	{ 952, 910, 1, "_root-911", -1, 1, 0, 0,  },
	{ 952, 911, 1, "_root-912", -1, 1, 0, 0,  },
	{ 952, 912, 1, "_root-913", -1, 1, 0, 0,  },
	{ 952, 913, 1, "_root-914", -1, 1, 0, 0,  },
	{ 952, 914, 1, "_root-915", -1, 1, 0, 0,  },
	{ 952, 915, 1, "_root-916", -1, 1, 0, 0,  },
	{ 952, 916, 1, "_root-917", -1, 1, 0, 0,  },
	{ 952, 917, 1, "_root-918", -1, 1, 0, 0,  },
	{ 952, 918, 1, "_root-919", -1, 1, 0, 0,  },
	{ 952, 919, 1, "_root-920", -1, 1, 0, 0,  },
	{ 952, 920, 1, "_root-921", -1, 1, 0, 0,  },
	{ 952, 921, 1, "_root-922", -1, 1, 0, 0,  },
	{ 952, 922, 1, "_root-923", -1, 1, 0, 0,  },
	{ 952, 923, 1, "_root-924", -1, 1, 0, 0,  },
	{ 952, 924, 1, "_root-925", -1, 1, 0, 0,  },
	{ 952, 925, 1, "_root-926", -1, 1, 0, 0,  },
	{ 952, 926, 1, "_root-927", -1, 1, 0, 0,  },
	{ 952, 927, 1, "_root-928", -1, 1, 0, 0,  },
	{ 952, 928, 1, "_root-929", -1, 1, 0, 0,  },
	{ 952, 929, 1, "_root-930", -1, 1, 0, 0,  },
	{ 952, 930, 1, "_root-931", -1, 1, 0, 0,  },
	{ 952, 931, 1, "_root-932", -1, 1, 0, 0,  },
	{ 952, 932, 1, "_root-933", -1, 1, 0, 0,  },
	{ 952, 933, 1, "_root-934", -1, 1, 0, 0,  },
	{ 952, 934, 1, "_root-935", -1, 1, 0, 0,  },
	{ 952, 935, 1, "_root-936", -1, 1, 0, 0,  },
	{ 952, 936, 1, "_root-937", -1, 1, 0, 0,  },
	{ 952, 937, 1, "_root-938", -1, 1, 0, 0,  },
	{ 952, 938, 1, "_root-939", -1, 1, 0, 0,  },
	{ 952, 939, 1, "_root-940", -1, 1, 0, 0,  },
	{ 952, 940, 1, "_root-941", -1, 1, 0, 0,  },
	{ 952, 941, 1, "_root-942", -1, 1, 0, 0,  },
	{ 952, 942, 1, "_root-943", -1, 1, 0, 0,  },
	{ 952, 943, 1, "_root-944", -1, 1, 0, 0,  },
	{ 952, 944, 1, "_root-945", -1, 1, 0, 0,  },
	{ 952, 945, 1, "_root-946", -1, 1, 0, 0,  },
	{ 952, 946, 1, "_root-947", -1, 1, 0, 0,  },
	{ 952, 947, 1, "_root-948", -1, 1, 0, 0,  },
	{ 952, 948, 1, "_root-949", -1, 1, 0, 0,  },
	{ 952, 949, 1, "_root-950", -1, 1, 0, 0,  },
	{ 952, 950, 1, "_root-951", -1, 1, 0, 0,  },
	{ 952, 951, 1, "_root-952", -1, 1, 0, 0,  }
};

static struct pat_cons_info parser_patReplInfo[] = {
	{ 0, 1 },
	{ 14, 2 },
	{ 29, 1 },
	{ 4, 3 },
	{ 39, 2 },
	{ 47, 3 },
	{ 10, 2 },
	{ 52, 3 },
	{ 60, 2 },
};

static struct pat_cons_node parser_patReplNodes[] = {
	{ 852, 0, -1, 1, 0, 0, 0, -1, -1, 0 },
	{ 852, 0, 2, -1, 1, 0, 0, -1, -1, 1 },
	{ 80, 0, 3, -1, 0, 0, 0, -1, -1, 0 },
	{ 855, 0, -1, -1, 0, 0, 0, -1, -1, 1 },
	{ 853, 2, -1, 5, 0, 0, 0, -1, -1, 0 },
	{ 854, 0, 6, -1, 1, 0, 0, -1, -1, 1 },
	{ 86, 0, 7, -1, 0, 0, 0, -1, -1, 0 },
	{ 852, 0, 8, -1, 2, 0, 0, -1, -1, 1 },
	{ 87, 0, 9, -1, 0, 0, 0, -1, -1, 0 },
	{ 889, 0, -1, -1, 3, 0, 0, -1, -1, 1 },
	{ 935, 0, -1, 11, 0, 0, 0, -1, -1, 0 },
	{ 935, 0, 12, -1, 1, 0, 0, -1, -1, 1 },
	{ 805, 5, -1, 13, 0, 0, 0, -1, -1, 0 },
	{ 842, 0, -1, -1, 2, 0, 0, -1, -1, 1 },
	{ 860, 0, -1, 15, 0, 0, 0, -1, -1, 0 },
	{ 860, 0, 16, -1, 1, 0, 0, -1, -1, 1 },
	{ 80, 0, 19, -1, 0, "|", 1, 17, 18, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 858, 0, -1, 20, 0, 0, 0, -1, -1, 0 },
	{ 78, 0, 22, -1, 0, "[", 1, -1, 21, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 855, 0, 23, -1, 2, 0, 0, -1, -1, 1 },
	{ 79, 0, 26, -1, 0, "]", 1, 24, 25, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 857, 1, 27, -1, 0, 0, 0, -1, -1, 0 },
	{ 856, 1, 28, -1, 0, 0, 0, -1, -1, 0 },
	{ 859, 1, -1, -1, 0, 0, 0, -1, -1, 0 },
	{ 860, 1, -1, 30, 0, 0, 0, -1, -1, 0 },
	{ 858, 0, -1, 31, 0, 0, 0, -1, -1, 0 },
	{ 78, 0, 33, -1, 0, "[", 1, -1, 32, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 855, 0, 34, -1, 1, 0, 0, -1, -1, 1 },
	{ 79, 0, 36, -1, 0, "]", 1, 35, -1, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 857, 1, 37, -1, 0, 0, 0, -1, -1, 0 },
	{ 856, 1, 38, -1, 0, 0, 0, -1, -1, 0 },
	{ 859, 1, -1, -1, 0, 0, 0, -1, -1, 0 },
	{ 842, 0, -1, 40, 0, 0, 0, -1, -1, 0 },
	{ 4, 0, 42, -1, 0, "def", 3, -1, 41, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 72, 0, 44, -1, 1, 0, 0, -1, 43, 0 },
	{ 112, 0, -1, 0, 0, " ", 1, 0, 0, 0 },
	{ 941, 1, 45, -1, 0, 0, 0, -1, -1, 0 },
	{ 841, 1, 46, -1, 0, 0, 0, -1, -1, 0 },
	{ 860, 0, -1, -1, 2, 0, 0, -1, -1, 1 },
	{ 853, 0, -1, 48, 0, 0, 0, -1, -1, 0 },
	{ 854, 0, 49, -1, 1, 0, 0, -1, -1, 1 },
	{ 888, 1, 50, -1, 0, 0, 0, -1, -1, 0 },
	{ 72, 0, 51, -1, 2, 0, 0, -1, -1, 0 },
	{ 889, 0, -1, -1, 3, 0, 0, -1, -1, 1 },
	{ 935, 0, -1, 53, 0, 0, 0, -1, -1, 0 },
	{ 935, 0, 57, 54, 0, 0, 0, -1, -1, 0 },
	{ 935, 0, 55, -1, 1, 0, 0, -1, -1, 1 },
	{ 805, 5, -1, 56, 0, 0, 0, -1, -1, 0 },
	{ 842, 0, -1, -1, 2, 0, 0, -1, -1, 1 },
	{ 805, 5, -1, 58, 0, 0, 0, -1, -1, 0 },
	{ 842, 0, -1, -1, 3, 0, 0, 59, -1, 1 },
	{ 112, 0, -1, 0, 0, "\n\n", 2, 0, 0, 0 },
	{ 935, 0, -1, 61, 0, 0, 0, -1, -1, 0 },
	{ 935, 0, 62, -1, 1, 0, 0, -1, -1, 1 },
	{ 805, 5, -1, 63, 0, 0, 0, -1, -1, 0 },
	{ 842, 0, -1, -1, 2, 0, 0, -1, -1, 1 },
};

static struct function_info parser_functionInfo[] = {
	{ 0, 1, 1 },
	{ 1, 2, 16 },
	{ 2, 2, 13 }
};

static struct region_info parser_regionInfo[] = {
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 166 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 167 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 168 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 169 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 170 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 171 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 0 },
	{ -1, -1, 172 }
};

static struct generic_info parser_genericInfo[] = {
	{ 0, 0, 0, 0, 0, 0, 0, 0 },
	{ 20, -1, -1, 0, 0, 0, 0, 0 },
	{ 20, -1, -1, 0, 0, 0, 0, 1 },
	{ 22, 956, 1, 2, 0, 2, 0, -1 },
	{ 21, 957, 1, 0, 0, 5, 0, -1 },
	{ 21, 958, 1, 0, 0, 2, 0, -1 },
};

static const char *parser_litdata[] = {
	"unwind code\n",
	"_sublist_",
	"%d",
	"r",
};

static long parser_litlen[] = {
	12, 9, 2, 1, };

static head_t *parser_literals[] = {
	0, 0, 0, 0, };

static int startStates[] = {
	5, 0, 2, 3, 6, 4, 1, };

static int eofLelIds[] = {
	399, 493, 541, 542, 636, 549, 531, };

static int parserLelIds[] = {
	72, 804, 852, 853, 935, 860, 842, };

static CaptureAttr captureAttr[] = {
};

tree_t **colm_object_host_call( program_t *prg, long code, tree_t **sp );
void colm_object_commit_reduce_forward( program_t *prg, tree_t **root,
		struct pda_run *pda_run, parse_tree_t *pt );
long colm_object_commit_union_sz( int reducer );
void colm_object_init_need();
int colm_object_reducer_need_tok( program_t *prg, struct pda_run *pda_run, int id );
int colm_object_reducer_need_ign( program_t *prg, struct pda_run *pda_run );
void colm_object_read_reduce( program_t *prg, int reducer, input_t *stream );

static struct export_info parser_exportInfo[] = {
	{ "ColmTree", 0 },
	{ "ColmError", 1 },
};
const int colm_export_ColmTree = 0;
const int colm_export_ColmError = 1;

struct colm_sections colm_object = 
{
	parser_lelInfo,
	953,

	parser_selInfo,
	6,

	parser_prodInfo,
	1365,

	parser_regionInfo,
	29,

	parser_rootCode,
	159,
	3,

	parser_frameInfo,
	4,

	parser_functionInfo,
	3,

	parser_patReplInfo,
	9,

	parser_patReplNodes,
	64,

	parser_genericInfo,
	6,

	parser_exportInfo,
	2,

	5,
	4,

	parser_litdata,
	parser_litlen,
	parser_literals,
	4,

	captureAttr,
	0,

	&fsmTables_start,
	&pid_0_pdaTables,
	startStates, eofLelIds, parserLelIds, 7,

	8,

	803,
	953,
	-1,
	2,
	803,
	0,
	802,
	953,
	958,
	957,
	959,
	959,
	961,
	&fsm_execute,
	&sendNamedLangEl,
	&initBindings,
	&popBinding,
	&colm_object_host_call,
	&colm_object_commit_reduce_forward,
	&colm_object_commit_union_sz,
	&colm_object_init_need,
	&colm_object_reducer_need_tok,
	&colm_object_reducer_need_ign,
	&colm_object_read_reduce,
};

tree_t **colm_object_host_call( program_t *prg, long code, tree_t **sp )
{
	value_t rtn = 0;
	switch ( code ) {
	}
	vm_push_value( rtn );
	return sp;
}
void colm_object_commit_reduce_forward( program_t *prg, tree_t **root,
		struct pda_run *pda_run, parse_tree_t *pt )
{
	commit_clear_parse_tree( prg, root, pda_run, pt->child );
}

long colm_object_commit_union_sz( int reducer ) { return 0; }
void colm_object_init_need() {}
int colm_object_reducer_need_tok( program_t *prg, struct pda_run *pda_run, int id ) { return COLM_RN_BOTH; }
int colm_object_reducer_need_ign( program_t *prg, struct pda_run *pda_run ) { return COLM_RN_BOTH; }

void colm_object_read_reduce( program_t *prg, int reducer, input_t *stream ) {}
